/*
 * @(#)DocBeanInfo.java	1.3 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.util.*;


public class DocBeanInfo {
  String classname;
  String name;
  int beanflags;
  String desc;
  String displayname;
  String propertyeditorclass;
  String customizerclass;
  int numattributes;
  int numenum;
  String[] key;
  String[] value;
  String[] ekey;
  String[] evalue;

  public DocBeanInfo(){}

  public DocBeanInfo(String p, int flags, String d,String displayname, String pec,
		     String cc, int na, String[] key, String[] value, int en, String[] ekey, String[] evalue){
    this.name = p;
    this.beanflags = flags;
    this.desc = d;
    this.displayname = displayname;
    this.propertyeditorclass = pec;
    this.customizerclass = cc;
    this.numattributes = na;
    this.key = key;
    this.value = value;
    this.numenum = en;
    this.ekey = ekey;
    this.evalue = evalue;
    //    key = new String[na]; value = new String[na];
    
  }

  public static DocBeanInfo readData(String s){
    String name = "null";
    int beanflags = -1;
    String desc = "null";
    String displayname = "null";
    String pec = "null";
    String cc = "null";
    int na = 0;
    String[] key = null;
    String[] value = null;
    int en = 0;
    String[] ekey = null;
    String[] evalue = null;

    try {
      StringTokenizer t = new StringTokenizer(s, ":");
      name = t.nextToken().trim();
      beanflags = Integer.parseInt(t.nextToken().trim());
      desc = t.nextToken().trim();
      displayname = t.nextToken().trim();
      pec = t.nextToken().trim();
      cc = t.nextToken().trim();
      na = Integer.parseInt(t.nextToken().trim());
      key = new String[na];
      value = new String[na];
      for (int z = 0; z < na; z++){
	key[z] = t.nextToken().trim();
	value[z] = t.nextToken().trim();
      }
      en = Integer.parseInt(t.nextToken().trim());
      for (int z = 0; z < en; z++){
	ekey[z] = t.nextToken().trim();
	evalue[z] = t.nextToken().trim();
      }	
    }
    catch (Exception e ){
//      System.out.println("ReadData: " + e.toString());
    }
    return new DocBeanInfo(name, beanflags,desc,displayname,pec,cc,na,key,value,en,ekey,evalue);
  }
}
