/*
 * @(#)consts.h	1.7 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * InstallShield constants for JDK/JRE/Plugin products.  The reason these
 * constants are shared across products is that currently they are always
 * released in sync, and it is easy to update just one file for every
 * release.
 *
 * Some #defines contain a special TM character immediately following the
 * word "Java" which might not display properly in some text editors. In
 * order to produce this character on Windows NT or Windows 95 you need to
 * enter the numbers 0153 using the numeric keypad while holding down the
 * Alt key. Also make sure that Num Lock is on when typing the numbers.
 */

#ifndef _CONSTS_H_
#define _CONSTS_H_ 1

#define COMPANY_NAME		"JavaSoft"
#define EXTRA_BLOCKSPACE	1000000
#define STR_DEFTAB		"	     "

/* JDK constants */
#define JDK_TITLE		"Java Development Kit 1.2"
#define JDK_PATH		"jdk1.2beta4"
#define JDK_NAME		"Java Development Kit"
#define JDK_VERSION		"1.2"
#define JDK_MICRO_VERSION	"beta4"
#define JDK_KEY		        "java.exe"
#define JDK_DEINSTALL_KEY	"JDK 1.2"
#define JDK_UNINSTALL_NAME	"Java Development Kit 1.2"

/* Plug-in constants */
#define JAVA_PLUGIN_NAME	"Java Plug-in"
#define JAVA_PLUGIN_VERSION	"1.2"
#define JAVA_PLUGIN_OCX_VERSION "1.1.1.1"
#define JAVA_PLUGIN_PANEL       "Java Plug-in Control Panel"

/* JRE Constants */
#define JRE_TITLE               "Java Runtime Environment 1.2"
#define JRE_RELPATH		"JavaSoft\\JRE\\1.2"
#define JRE_NAME                "Java Runtime Environment"
#define JRE_VERSION             "1.2"
#define JRE_MICRO_VERSION	"beta4"
#define JRE_KEY                 "java.exe"
#define JRE_DEINSTALL_KEY       "JRE 1.2"
#define JRE_UNINSTALL_NAME      "Java Runtime Environment 1.2"
#define JRE_RUNTIMELIB     	"\\bin\\classic\\jvm.dll"

/* Installable components */
#define ITEM_PROGRAMFILES	"Program Files"
#define ITEM_HEADERFILES	"Native Interface Header Files"
#define ITEM_OLDHEADERFILES	"Old Native Interface Header Files"
#define ITEM_DEMOFILES		"Demos"
#define ITEM_SOURCEFILES	"Java Sources"
#define ITEM_DOCFILES		"Tool Docs"

/* Messages */
#define MSG_COPY_OLDHEADERS     "Copying old native interface header files..."
#define MSG_COPY_JNIHEADERS     "Copying Java Native Interface header files..."
#define MSG_COPY_PROGRAMFILES   "Copying program files..."
#define MSG_COPY_RUNTIMEFILES   "Copying runtime files..."
#define MSG_COPY_DEMOFILES      "Copying demo files..."
#define MSG_COPY_SRCFILES       "Copying Java source files..."
#define MSG_COPY_DOCFILES       "Copying documentation files..."

#endif /* _CONSTS_H_ */
