# @(#)classes.mk	1.7 98/10/06 	
#
# Included makefile for building the FileChooser demo


# SRC_FILES and MISC_FILES should probably be moved to a common
# place in mincludes to follow the conventions of other makefiles.

SRCFILES = \
	$(TARGDIR)\FileChooserDemo.java		\
        $(TARGDIR)\ExampleFileFilter.java        	\
	$(TARGDIR)\ExampleFileView.java

MISC_FILES = \
	$(DESTDIR)/images/gifIcon.gif  \
	$(DESTDIR)/images/jpgIcon.jpg

# CLASSPATH = $(CLASSES);$(CLASSDIR);$(DESTDIR)
TARGDIR = $(CLASSDIR)           # Trailing space is significant 

{$(SRCDIR)}.java{$(DESTDIR)}.java :
	cp $? $@

{$(DESTDIR)}.java{$(CLASSDIR)}.class :
!ifdef BUILD_FOR_JDK11
	$(JAVAC_JDK11_CMD) -d $(DESTDIR) -classpath $(JDK11DIR)\classes;$(JDK11DIR)\lib\classes.zip;$(BUILDDIR)\1.1_classes;$(DESTDIR) $?
!else
	$(JAVAC_CMD) -classpath $(CLASSPATH);$(CLASSDIR);$(DESTDIR) -d $(CLASSDIR) $?
!endif

{$(SRCDIR)\images}.gif{$(DESTDIR)\images}.gif :
	-$(DEL) $@
	copy $? $@
{$(SRCDIR)\images}.jpg{$(DESTDIR)\images}.jpg :
	-$(DEL) $@
	copy $? $@

FILES_java = $(SRCFILES)
FILES_class = $(SRCFILES:.java=.class)
FILES_misc = $(MISC_FILES:/=\)

CLASSPATH = $(CLASSBINDIR)

.SUFFIXES: .jpg .gif .txt .html .java .class

clobber :: FORCE
	-$(DELTREE) $(DESTDIR)

FORCE: ;

