# @(#)classes.mk	1.1 97/11/18
#
# Included makefile for building Metalworks demo


# SRC_FILES and MISC_FILES should probably be moved to a common
# place in mincludes to follow the conventions of other makefiles.

SRCFILES = \
	$(TARGDIR)\AquaMetalTheme.java		\
	$(TARGDIR)\BigContrastMetalTheme.java	\
	$(TARGDIR)\DemoMetalTheme.java		\
	$(TARGDIR)\KhakiMetalTheme.java		\
	$(TARGDIR)\PropertiesMetalTheme.java	\
	$(TARGDIR)\ContrastMetalTheme.java		\
	$(TARGDIR)\Metalworks.java			\
	$(TARGDIR)\MetalworksDocumentFrame.java		\
	$(TARGDIR)\MetalworksInBox.java			\
	$(TARGDIR)\MetalworksFrame.java			\
	$(TARGDIR)\MetalworksHelp.java			\
	$(TARGDIR)\MetalworksPrefs.java			\
	$(TARGDIR)\MetalThemeMenu.java			\
	$(TARGDIR)\GreenMetalTheme.java			\
	$(TARGDIR)\UISwitchListener.java		

MISC_FILES = \
	$(DESTDIR)/images/palette_crop.gif \
	$(DESTDIR)/images/palette_draw.gif \
	$(DESTDIR)/images/palette_hand.gif \
	$(DESTDIR)/images/palette_select.gif \
	$(DESTDIR)/images/palette_text.gif \
	$(DESTDIR)/images/palette_zoom.gif \
	$(DESTDIR)/HelpFiles/back.gif \
	$(DESTDIR)/HelpFiles/credits.html \
	$(DESTDIR)/HelpFiles/duke.gif \
	$(DESTDIR)/HelpFiles/metal.html \
	$(DESTDIR)/HelpFiles/metalworks.html \
	$(DESTDIR)/HelpFiles/javalogo.gif \
	$(DESTDIR)/HelpFiles/swing.html \
	$(DESTDIR)/HelpFiles/toc.html \
	$(DESTDIR)/MyTheme.theme \
	$(DESTDIR)/README.txt 

# CLASSPATH = $(CLASSES);$(CLASSDIR);$(DESTDIR)
TARGDIR = $(CLASSDIR)           # Trailing space is significant 

{$(SRCDIR)}.java{$(DESTDIR)}.java :
	cp $? $@

{$(DESTDIR)}.java{$(CLASSDIR)}.class :
!ifdef BUILD_FOR_JDK11
	$(JAVAC_JDK11_CMD) -d $(DESTDIR) -classpath $(JDK11DIR)\classes;$(JDK11DIR)\lib\classes.zip;$(BUILDDIR)\1.1_classes;$(DESTDIR) $?
!else
	$(JAVAC_CMD) -classpath $(CLASSPATH);$(CLASSDIR);$(DESTDIR) -d $(CLASSDIR) $?
!endif

{$(SRCDIR)\images}.gif{$(DESTDIR)\images}.gif :
	-$(DEL) $@
	copy $? $@

{$(SRCDIR)\HelpFiles}.gif{$(DESTDIR)\HelpFiles}.gif :
	-$(DEL) $@
	copy $? $@

{$(SRCDIR)\HelpFiles}.html{$(DESTDIR)\HelpFiles}.html :
	-$(DEL) $@
	copy $? $@

{$(SRCDIR)}.txt{$(DESTDIR)}.txt :
	-$(DEL) $@
	copy $? $@

{$(SRCDIR)}.html{$(DESTDIR)}.html :
	-$(DEL) $@
	copy $? $@

{$(SRCDIR)}.theme{$(DESTDIR)}.theme :
	-$(DEL) $@
	copy $? $@

FILES_java = $(SRCFILES)
FILES_class = $(SRCFILES:.java=.class)
FILES_misc = $(MISC_FILES:/=\)

CLASSPATH = $(CLASSBINDIR)

.SUFFIXES: .gif .txt .html .java .class .theme

clobber :: FORCE
	-$(DELTREE) $(DESTDIR)

FORCE: ;
 
