#
# @(#)Depend.mak	1.11 98/08/17
#
# This makefile must be executed on a system with makedepend, such as Solaris.
# In my copious amount of spare time, I hope to write a Java-based makedepend
# to eliminate this dependency (no pun intended). TB

BUILD_DIR = ../..
TOPDIR   = ../../../..

STUBDIR = WindowsSystemHeaderStubs

WIN32_SRC = $(TOPDIR)/src/win32
SHARE_SRC = $(TOPDIR)/src/share
SRC = $(WIN32_SRC)/native/sun/windows
#COMMON_SRC = $(WIN32_SRC)/native/sun/awt_common
SUN_SRC = $(SHARE_SRC)/native/sun
IMG_SRC = $(SUN_SRC)/awt/image
GIF_SRC = $(IMG_SRC)/gif
LOOP_SRC = $(SUN_SRC)/java2d/loops
PIPE_SRC = $(SUN_SRC)/java2d/pipe
COMP_SRC = $(SUN_SRC)/awt/alphacomposite
MEDIA_SRC = $(SUN_SRC)/awt/medialib

INCLUDES = -I. \
	   -I$(STUBDIR) \
	   -ICClassHeaders \
	   -I$(SHARE_SRC)/javavm/export \
	   -I$(WIN32_SRC)/javavm/export \
	   -I$(SHARE_SRC)/native/common \
	   -I$(WIN32_SRC)/native/common \
	   -I$(SRC) \
	   -I$(IMG_SRC)/cvutils \
	   -I$(IMG_SRC) \
	   -I$(LOOP_SRC) \
	   -I$(COMP_SRC)
#	   -I$(COMMON_SRC)

FILES_cpp = \
	$(SRC)/CmdIDList.cpp \
	$(SRC)/Hashtable.cpp \
	$(SRC)/ObjectList.cpp \
	$(COMP_SRC)/alphaCompst.c \
	$(LOOP_SRC)/IntDiscreteRenderer.c \
	$(LOOP_SRC)/ByteDiscreteRenderer.c \
	$(LOOP_SRC)/ShortDiscreteRenderer.c \
	$(LOOP_SRC)/ARGBcolorloop.c \
	$(LOOP_SRC)/ARGBpaintARGB.c \
	$(LOOP_SRC)/ARGBpaintBitmaskARGB.c \
	$(LOOP_SRC)/ARGBbgpaintARGB.c \
	$(LOOP_SRC)/ARGBbgpaintBitmaskARGB.c \
	$(LOOP_SRC)/XRGBcolorloop.c \
	$(LOOP_SRC)/XRGBpaintARGB.c \
	$(LOOP_SRC)/XRGBpaintBitmaskARGB.c \
	$(LOOP_SRC)/XRGBpaintXRGB.c \
	$(LOOP_SRC)/XRGBbgpaintARGB.c \
	$(LOOP_SRC)/XRGBbgpaintBitmaskARGB.c \
	$(LOOP_SRC)/XRGBbgpaintXRGB.c \
	$(LOOP_SRC)/XBGRcolorloop.c \
	$(LOOP_SRC)/XBGRpaintARGB.c \
	$(LOOP_SRC)/XBGRpaintBitmaskARGB.c \
	$(LOOP_SRC)/XBGRpaintXRGB.c \
	$(LOOP_SRC)/XBGRbgpaintARGB.c \
	$(LOOP_SRC)/XBGRbgpaintBitmaskARGB.c \
	$(LOOP_SRC)/XBGRbgpaintXRGB.c \
	$(PIPE_SRC)/SpanRasterizer.c \
	$(PIPE_SRC)/SpanClipRenderer.c \
	$(SRC)/awt_ActiveEvent.cpp \
	$(SRC)/awt_Brush.cpp \
	$(SRC)/awt_Button.cpp \
	$(SRC)/awt_Canvas.cpp \
	$(SRC)/awt_Checkbox.cpp \
	$(SRC)/awt_Choice.cpp \
	$(SRC)/awt_Clipboard.cpp \
	$(SRC)/awt_Color.cpp \
	$(SRC)/awt_Component.cpp \
	$(SRC)/awt_Cursor.cpp \
	$(SRC)/awt_Dialog.cpp \
	$(SRC)/awt_DrawingSurface.cpp \
	$(SRC)/awt_FileDialog.cpp \
	$(SRC)/awt_Font.cpp \
	$(SRC)/awt_Frame.cpp \
	$(SRC)/awt_Graphics.cpp \
	$(SRC)/awt_Image.cpp \
	$(SRC)/awt_InputMethod.cpp \
	$(SRC)/awt_Label.cpp \
	$(SRC)/awt_List.cpp \
	$(SRC)/awt_Menu.cpp \
	$(SRC)/awt_MenuBar.cpp \
	$(SRC)/awt_MenuItem.cpp \
	$(SRC)/awt_Object.cpp \
	$(SRC)/awt_PopupMenu.cpp \
	$(SRC)/awt_Pen.cpp \
	$(SRC)/awt_PrintJob.cpp \
	$(SRC)/awt_Scrollbar.cpp \
	$(SRC)/awt_ScrollPane.cpp \
	$(SRC)/awt_TextArea.cpp \
	$(SRC)/awt_TextComponent.cpp \
	$(SRC)/awt_TextField.cpp \
	$(SRC)/awt_Toolkit.cpp \
	$(SRC)/awt_Unicode.cpp \
	$(SRC)/awt_Window.cpp \
	$(SRC)/awt_DnDDT.cpp \
	$(SRC)/awt_DnDDS.cpp \
	$(LOOP_SRC)/DefaultComponent.c \
	$(LOOP_SRC)/IndexGrayAccelerators.c \
	$(LOOP_SRC)/ShortCompositing.c \
        $(LOOP_SRC)/IndexedCompositing.c \
        $(LOOP_SRC)/Gray8Blters.c \
        $(LOOP_SRC)/Gray16Blters.c \
	$(LOOP_SRC)/XBGRLoops.c \
        $(LOOP_SRC)/GIFAcceleratorLoops.c \
        $(LOOP_SRC)/ImageData.c \
	$(IMG_SRC)/cvutils/img_globals.c \
	$(GIF_SRC)/gifdecoder.c \
        $(IMG_SRC)/awt_parseImage.c \
        $(IMG_SRC)/awt_ImageRep.c \
        $(MEDIA_SRC)/awt_ImagingLib.c \
        $(SRC)/awt_Mlib.cpp \
        $(MEDIA_SRC)/mlib_ImageCreate.c \
        $(MEDIA_SRC)/mlib_ImageScanPoly.c \
        $(MEDIA_SRC)/mlib_ImageDivTables.c \
        $(MEDIA_SRC)/mlib_ImageAffineEdge.c \
        $(MEDIA_SRC)/mlib_c_ImageBlendTable.c \
        $(MEDIA_SRC)/mlib_c_ImageAffine.c \
        $(MEDIA_SRC)/mlib_c_ImageAffine_BC.c \
        $(MEDIA_SRC)/mlib_c_ImageAffine_BL.c \
        $(MEDIA_SRC)/mlib_c_ImageAffine_NN.c \
        $(MEDIA_SRC)/mlib_c_ImageFilters.c \
        $(MEDIA_SRC)/mlib_sys.c \
        $(MEDIA_SRC)/mlib_c_ImageConvClearEdge.c \
        $(MEDIA_SRC)/mlib_c_ImageConvCopyEdge.c \
        $(MEDIA_SRC)/mlib_c_ImageConv3x3.c \
        $(MEDIA_SRC)/mlib_c_ImageConv5x5.c \
        $(MEDIA_SRC)/mlib_c_ImageConvMxN.c \
        $(MEDIA_SRC)/mlib_c_ImageLookUp.c \
        $(IMG_SRC)/imageInitIDs.c

STUBFILES = \
	$(STUBDIR)/commdlg.h \
	$(STUBDIR)/direct.h \
	$(STUBDIR)/imm.h \
	$(STUBDIR)/ime.h \
	$(STUBDIR)/io.h \
	$(STUBDIR)/Ole2.h \
	$(STUBDIR)/shellapi.h \
	$(STUBDIR)/shlobj.h \
	$(STUBDIR)/tchar.h \
	$(STUBDIR)/winbase.h \
	$(STUBDIR)/windef.h \
	$(STUBDIR)/windows.h \
	$(STUBDIR)/winspool.h \
	$(STUBDIR)/winuser.h \
	$(STUBDIR)/wtypes.h \

default:
	rm -rf make.depend make.tmp make.tmp2 $(STUBDIR)
	touch make.tmp
	mkdir $(STUBDIR)
	touch $(STUBFILES)
	makedepend -DWIN32 -D_X86X -Dx86 -f make.tmp -o.obj $(INCLUDES) \
		$(FILES_cpp)
	fgrep .obj make.tmp | sed -f Depend.sed > make.depend
	rm -rf $(STUBDIR)
