/*
 * @(#)InputMethodManagerResources_ja.java	1.1 98/05/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.resources;

import java.util.Locale;
import sun.awt.im.InputMethodManager;

/**
 * This class defines translated InputMethodManagerResources for Japanese.
 *
 * @see InputMethodManagerResources
 * @version 1.1 05/15/98
 */

public class InputMethodManagerResources_ja extends InputMethodManagerResources
{
    private static Object[][] translationTable = {
	// InputMethodManager
	{ "InputMethodManager.hostAdapterName", "\u30b7\u30b9\u30c6\u30e0\u5165\u529b\u65b9\u5f0f" },
	{ "InputMethodManager.IIIMPName", "\u30cd\u30c3\u30c8\u30ef\u30fc\u30af\u5165\u529b\u65b9\u5f0f" },
	{ "InputMethodManager.switchIMMenu", "\u5165\u529b\u65b9\u5f0f\u306e\u5207\u66ff\u3048" },
	{ "InputMethodManager.error.notFound", "\u304c\u898b\u3064\u304b\u308a\u307e\u305b\u3093" },
	{ "InputMethodManager.error.invokationError", "\u547c\u3073\u51fa\u3057\u30a8\u30e9\u30fc" },

	// CompositionArea
	{ "CompositionArea.inputWindowTitle", "\u5165\u529b\u30a6\u30a3\u30f3\u30c9\u30a6" },

	// localized locale names
	{ Locale.CHINESE, "\u4e2d\u56fd\u8a9e" },
	{ Locale.SIMPLIFIED_CHINESE, "\u4e2d\u56fd\u8a9e\uff08\u7c21\u4f53\u5b57\uff09" },
	{ Locale.TRADITIONAL_CHINESE, "\u4e2d\u56fd\u8a9e\uff08\u7e41\u4f53\u5b57\uff09" },
	{ Locale.KOREAN, "\u97d3\u56fd\u8a9e" },
	{ Locale.JAPANESE, "\u65e5\u672c\u8a9e" }
    };

    protected Object[][] getTable() {
	return translationTable;
    }
}
