/*
 * @(#)ByteToCharCp1143.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)ByteToCharCp1143.java	1.2 98/09/21
 *
 * Copyright 1998 by IBM, Inc.  All rights reserved.
 */

package sun.io;

/**
 * A table to convert Cp1143 to Unicode.  This converter differs from
 * Cp278 is one code point, 0x5A, which changes from \u00A4 to \u20AC.
 * @author  Alan Liu
 * @version >= JDK1.2
 */
public class ByteToCharCp1143 extends ByteToCharCp278 {
    public ByteToCharCp1143() {}

    public String getCharacterEncoding() {
        return "Cp1143";
    }

    protected char getUnicode(int byteIndex) {
        // Change single code point with respect to parent.
        // [Careful -- if the code point in question is >= 0x80, make
        //  sure you do the comparison like this: (byteIndex == (byte)0x??)]
        return (byteIndex == 0x5A) ? '\u20AC' : super.getUnicode(byteIndex);
    }
}

//eof
