/*
 * @(#)ByteToCharMS932.java	1.7 98/08/12
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.io;

/**
 * Tables and data to convert MS932 to Unicode
 *
 * @author Limin Shi
 * @author Mark Son-Bell
 * @version >= JDK1.1.6
 */

public class ByteToCharMS932 extends ByteToCharMS932DB {
    ByteToCharJIS0201 bcJIS0201 = new ByteToCharJIS0201();

    public String getCharacterEncoding() {
        return "MS932";
    }

    protected char convSingleByte(int b) {
        // If the high bits are all off, it's ASCII == Unicode
        if ((b & 0xFF80) == 0) {
	    return (char)b;
        }
	return bcJIS0201.getUnicode(b);
    }

    String prt(int i) {
	return Integer.toString(i,16);
    }
}
