/*
 * @(#)CharToByteX11CNS11643P3.java	1.5 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.motif;
import sun.io.CharToByteEUC_TW;

public class CharToByteX11CNS11643P3 extends CharToByteEUC_TW {
    public String toString(){
	return "X11CNS11643P3";
    }
    
    public boolean canConvert(char ch){
	int cns = getNative(ch);

        if (((0xFF00 & ch) != 0) && (cns & 0xF0000) == 0x30000) {
            return true;
        }
        return false;
    }

    public int convert(char[] input, int inOff, int inEnd,
                       byte[] output, int outOff, int outEnd) {

	for (int i = inOff; i < inEnd; i++) {
            int cns = getNative(input[i]);

            output[outOff++] = (byte) ((cns >> 8) & 0x7f);
            output[outOff++] = (byte) (cns & 0x7f);
	}

        return (inEnd - inOff) * 2;
    }
}

