/*
 * @(#)CharToByteX11JIS0201.java	1.12 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.motif;
import  sun.io.*;

import sun.io.CharToByteISO8859_1;

public class CharToByteX11JIS0201 extends CharToByteISO8859_1 {

    public String toString(){
	return "X11JIS0201";
    }
    
    public boolean canConvert(char ch){
	if ((ch >= 0xff61 && ch <= 0xff9f) 
	    || ch == 0x203e
	    || ch == 0xa5){
	    return true;
	}
	
	return false;
    }

    public int convert(char[] input, int inOff, int inEnd,
		       byte[] output, int outOff, int outEnd)
	throws UnknownCharacterException,
               ConversionBufferFullException
   {
        charOff = inOff;
        byteOff = outOff;

	while (charOff < inEnd && byteOff < outEnd){
	    char ch = input[charOff++]; 
            if (byteOff > outEnd)
	        throw new ConversionBufferFullException();
	    if (ch == 0x203e) {
		output[byteOff++] = (byte)0x7e;
	    } else if (ch == 0xa5) {
		output[byteOff++] = (byte)0x5c;
	    } else if (ch >= 0xff61 && ch <= 0xff9f) {
		output[byteOff++] = (byte)(ch - 0xff61 + 0xa1);
	    } else {
		if (subMode) { 
		    output[byteOff++] = subBytes[0];
		} else {
		    badInputLength = 1;
		    throw new UnknownCharacterException();
		}
	    }
	}
	return byteOff - outOff;
    }
}




