/*
 * @(#)ForwardEvent.java	1.3 98/03/23
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

class ForwardEvent extends IIIMPEvent {
    IIIMPKeyEvent[] event = null;

    /*
     * Currently IIIMP doesn't support utilizing events that are
     * composed by the language engine.  Instead of doing so, when
     * IIIMP receives ForwardEvent events from the language engine,
     * IIIMP simply unmarks the original event as a non-consumed event
     * and returns.  So getEvent() will be commented out for a while.
     *
     * import java.awt.Component;
     * import java.awt.event.KeyEvent;
     * KeyEvent[] getEvent(Component c) {
     *   if (event == null) {
     *      return null;
     *   }
     *   KeyEvent[] tmp = new KeyEvent[event.length];
     *     for (int i = 0; i < event.length; i++) {
     *       tmp[i] = new KeyEvent(c,
     *			  KeyEvent.KEY_PRESSED,
     *			  0,
     *			  event[i].modifier,
     *			  event[i].keycode,
     *			  event[i].keychar);
     *    }
     *    return tmp;
     * }
     */

    public ForwardEvent(InputContext ic, int id, IIIMPKeyEvent[] event) {
	super(ic, id);
	this.event = event;
    }
}
