/*
 * @(#)IIIMPInputLanguage.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import java.util.Locale;

class IIIMPInputLanguage {

    static Locale toLocale(String str) {
	if (str == null || str.length() == 0) {
	    return null;
	}

	// if str is a locale name that is defined in the spec...
	if (str.equals("ja")) {
	    return Locale.JAPANESE;
        } else if (str.equals("ko")) {
	    return Locale.KOREAN;
        } else if (str.equals("zh_TW")) {
	    return Locale.TRADITIONAL_CHINESE;
        } else if (str.equals("zh_CN")) {
	    return Locale.SIMPLIFIED_CHINESE;
        }

	// if str is not in the spec...
	int index = str.indexOf('_');
	if (index > 0) {
	    String language = str.substring(0, index);
	    String tmp = str.substring(index + 1);
	    index = tmp.indexOf('.');
	    String country = "";
	    if (index > 0) {
		country = tmp.substring(0, index);
	    }
	    return new Locale(language, country);
	}

	return new Locale(str, "");
    }

    static String toString(Locale locale) {
	if (locale == null) {
	    return null;
	}

        String loc = locale.getLanguage();
	if (loc.equals("ja")) {
	    return "ja";
        } else if (loc.equals("ko")) {
	    return "ko";
        } else if (loc.equals("zh")) {
            String region = locale.getCountry();
            if (region.equals("TW")) {
		return "zh_TW";
            } else {
		return "zh_CN";
            }
        } 

	return loc;
    }
}
