/*
 * @(#)IIIMPInputMethodChar.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import sun.awt.im.iiimp.InputMethodChar;
import sun.awt.im.iiimp.InputMethodFeedback;

class IIIMPInputMethodChar extends InputMethodChar {

    IIIMPInputMethodChar() {
	c =  (char) 0;
	fd = null;
    }

    void addInputMethodFeedback(int id, int value) {
	if (fd == null) {
	    fd = new InputMethodFeedback[1];
	    fd[0] = new InputMethodFeedback();
	    fd[0].id = id;
	    fd[0].value = value;
	    return;
	} else {
	    InputMethodFeedback tmp = null;
	    for (int i = 0; i < fd.length; i++) {
		if (fd[i].id == id) {
		    tmp = fd[i];
		    break;
		}
	    }

	    if (tmp != null) {
		tmp.value &= value;
		return;
	    }
	}

	int num = fd.length;
	InputMethodFeedback newValue[] = new InputMethodFeedback[num + 1];
	System.arraycopy(fd, 0, newValue, 0, num);
	fd = newValue;
	fd[num] = new InputMethodFeedback();
	fd[num].id = id;
	fd[num].value = value;
    }
}
