/*
 * @(#)IIIMPOutputStream.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import java.io.OutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

class IIIMPOutputStream extends DataOutputStream implements IIIMProtocol {

    IIIMPOutputStream(OutputStream out) {
	super(out);
    }
    
    void writeBasicPacket(int protocol, int len) throws IOException {
	int packet_size = IIIMPInputStream.packetSize();
	if (packet_size == FOURBYTES_PACKET) {
	    int length = ((len / 4) & 0x00FFFFFF);
	    out.write(protocol & 0x7F);
	    out.write((length >>> 16) & 0xFF);
	    out.write((length >>> 8)  & 0xFF);
	    out.write((length >>> 0)  & 0xFF);
	} else if (packet_size == EIGHTBYTES_PACKET) {
	    // not supported
	    throw new IOException("8 byte length of packet");
	}
    }
}
