/*
 * @(#)InputMethodCaret.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

//public 
class InputMethodCaret {

    public final static int CARET_FORWARD_CHAR		= 0;
    public final static int CARET_BACKWARD_CHAR		= 1;
    public final static int CARET_FORWARD_WORD		= 2;
    public final static int CARET_BACKWARD_WORD		= 3;
    public final static int CARET_UP			= 4;
    public final static int CARET_DOWN			= 5;
    public final static int CARET_NEXT_LINE		= 6;
    public final static int CARET_PREVIOUS_LINE		= 7;
    public final static int CARET_LINE_START		= 8;
    public final static int CARET_LINE_END		= 9;
    public final static int CARET_ABSOLUTE_POSITION	= 10;
    public final static int CARET_DONT_CHANGE		= 11;

    public final static int CARET_INVISIBLE		= 100;
    public final static int CARET_PRIMARY		= 101;
    public final static int CARET_SECONDARY		= 102;

    /** The caret position. */
    int position;

    public int getPosition() {
	return position;
    }

    /** The caret move direction. */
    int direction;

    public int getDirection() {
	return direction;
    }

    /* The feedback style of the caret */
    int style;

    public int getStyle() {
	return style;
    }

    public InputMethodCaret(int position, int direction, int style) {
	this.position = position;
	this.direction = direction;
	this.style = style;
    }
}
