/*
 * @(#)InputMethodFeedback.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

/**
 * The InputMethodFeedback class to encapsulate the representation
 * of a feedback value for rendering.
 */
//public 
class InputMethodFeedback {

    /**
     * The pre-defined feedback values for the '0' id.
     */
    public final static int REVERSE		= (1<<0);
    /**
     * The pre-defined feedback values for the '0' id.
     */
    public final static int UNDERLINE		= (1<<1);
    /**
     * The pre-defined feedback values for the '0' id.
     */
    public final static int HIGHLIGHT		= (1<<2);
    /**
     * The pre-defined feedback values for the '0' id.
     */
    public final static int PRIMARY		= (1<<5);
    /**
     * The pre-defined feedback values for the '0' id.
     */
    public final static int SECONDARY		= (1<<6);
    /**
     * The pre-defined feedback values for the '0' id.
     */
    public final static int TERTIARY		= (1<<7);
    
    /**
     * The type of the InputMethodFeedback.
     */
    public int id;

    /**
     * The value of the InputMethodFeedback.
     */
    public int value;
}
