/*
 * @(#)InputMethodLookupDraw.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

//public 
class InputMethodLookupDraw {

    /** The lookup candidates to be displayed. */
    InputMethodLookupText value[];

    public InputMethodLookupText[] getText() {
	return value;
    }

    /** The number of lookup candidates. */
    int count;

    public int getSize() {
	return count;
    }

    /**
     * The first index in the array of lookup candidates pointing
     * the first item to be displayed in a lookup window.
     */
    int first_index;

    public int getFirstIndex() {
	return first_index;
    }

    /**
     * The last index in the array of lookup candidates pointing
     * the last item to be displayed in a window.
     */
    int last_index;

    public int getLastIndex() {
	return last_index;
    }

    /**
     * The current index in the array of lookup candidates pointing
     * the current item to be highlighted in a window.
     */
    int current_index;

    public int getCurrentIndex() {
	return current_index;
    }

    /**
     * The name of a lookup window that displays lookup candidates.
     * This name can be used, for example, as a title of the window or
     * as a footer of the window to show the current state of the lookup.
     */
    InputMethodText title;

    public InputMethodText getTitle() {
	return title;
    }

    public InputMethodLookupDraw(InputMethodLookupText[] value,
				 int count,
				 int first_index,
				 int last_index,
				 int current_index,
				 InputMethodText title) {
	this.value = new InputMethodLookupText[value.length];
	System.arraycopy(value, 0, this.value, 0, value.length);
	this.count = count;
	this.first_index =  first_index;
	this.last_index = last_index;
	this.current_index = current_index;
	// eee???
	this.title = title;
    }
}
