/*
 * @(#)InputMethodLookupProcess.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

//public 
class InputMethodLookupProcess {
    /** The index type. */
    public final static int TYPE_INDEX = 0;
    /** The page type. */
    public final static int TYPE_PAGE = 1;

    /** The type for pointing, index or page. */
    int type;

    public int getType() {
	return type;
    }

    /** The page direction to move the next page. */
    public final static int PAGE_NEXT = 10;
    /** The page direction to move the previous page. */
    public final static int PAGE_PREV = 11;
    /** The page direction to move the first page. */
    public final static int PAGE_FIRST = 12;
    /** The page direction to move the last page. */
    public final static int PAGE_LAST = 13;

    /** The index of the selected item. */
    int index;

    public int getIndex() {
	return index;
    }

    /** The next action by page. */
    int page;

    public int getPage() {
	return page;
    }

    public InputMethodLookupProcess(int type, int index_page) {
	this.type = type;
	if (type == TYPE_INDEX) {
	    this.index = index_page;
	} else if (type == TYPE_PAGE) {
	    this.page = index_page;
	}
    }
}
