/*
 * @(#)InputMethodTextBuffer.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

/**
 * A text buffer implementing a sequence of InputMethodText texts.
 */
//public 
class InputMethodTextBuffer extends InputMethodText {

    /**
     * Constructs a text buffer with no value.
     */
    public InputMethodTextBuffer() {
	this.count = 0;
	this.value = new InputMethodChar[0];
    }

    /**
     * Appends the text to the buffer.
     */
    public void append(InputMethodText imt) {
	InputMethodChar[] newValue =
	    new InputMethodChar[this.count + imt.count];
	System.arraycopy(this.value, 0, newValue, 0, this.count);
	System.arraycopy(imt.value, 0, newValue, this.count, imt.count);
	this.value = newValue;
	this.count += imt.count;
    }

    /**
     * Removes the specified number of the texts from the buffer,
     * starting at the specified index.
     */
    public void remove(int start, int len) {
	System.arraycopy(this.value, start + len,
			 this.value, start, this.count - start - len);
	this.count -= len;
    }
}    
