/*
 * @(#)LookupEvent.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import sun.awt.im.iiimp.InputContext;
import sun.awt.im.iiimp.InputMethodLookupStart;
import sun.awt.im.iiimp.InputMethodLookupDraw;
import sun.awt.im.iiimp.InputMethodLookupProcess;

/**
 * A callback data for start() method of LookupCallback.
 */
//public 
class LookupEvent extends IIIMPEvent {

    public static final int LOOKUP_START = 70;

    public static final int LOOKUP_DRAW = 72;

    public static final int LOOKUP_DONE = 74;

    public static final int LOOKUP_PROCESS = 76;

    InputMethodLookupStart start;

    public InputMethodLookupStart getStart() {
	return start;
    }

    InputMethodLookupDraw draw;

    public InputMethodLookupDraw getDraw() {
	return draw;
    }

    InputMethodLookupProcess process;

    public InputMethodLookupProcess getProcess() {
	return process;
    }

    public LookupEvent(InputContext ic, int id, InputMethodLookupStart start) {
	super(ic, id);
	this.start = start;
    }

    public LookupEvent(InputContext ic, int id, InputMethodLookupDraw draw) {
	super(ic, id);
	this.draw = draw;
    }

    public LookupEvent(InputContext ic,
		       int id,
		       InputMethodLookupProcess process) {
	super(ic, id);
	this.process = process;
    }

    public LookupEvent(InputContext ic, int id) {
	super(ic, id);
    }
}
