/*
 * @(#)PreeditEvent.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import sun.awt.im.iiimp.InputContext;
import sun.awt.im.iiimp.InputMethodCaret;
import sun.awt.im.iiimp.InputMethodPreeditText;

//public 
class PreeditEvent extends IIIMPEvent {

    public static final int PREEDIT_START	= 40;
    public static final int PREEDIT_DRAW	= 42;
    public static final int PREEDIT_CARET	= 44;
    public static final int PREEDIT_DONE	= 46;

    InputMethodCaret caret;

    public InputMethodCaret getCaret() {
	return caret;
    }

    InputMethodPreeditText text;

    public InputMethodPreeditText getPreeditText() {
	return text;
    }

    public PreeditEvent(InputContext ic, int id) {
	super(ic, id);
    }

    public PreeditEvent(InputContext ic, int id, InputMethodPreeditText text) {
	super(ic, id);
	this.text = text;
    }

    public PreeditEvent(InputContext ic, int id, InputMethodCaret caret) {
	super(ic, id);
	this.caret = caret;
    }
}
