/*
 * @(#)PreeditListener.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

/**
 * The callback interface for drawing preedit text.
 */
//public 
interface PreeditListener extends java.util.EventListener {

    /**
     * Invoked when the input method turns preedit on.  This must
     * return the maximum size of the preedit string to be drawn.
     *
     * @return The maximum size of the preedit string to be drawn.
     */
    public int preeditStart(PreeditEvent e);

    /** Invoked when the input method turns preedit off. */
    public void preeditDone(PreeditEvent e);

    /**
     * Invoked when the preedit text has to be drawn and inserted,
     * deleted or replaced.
     */
    public void preeditDraw(PreeditEvent e);

    /**
     * Invoked when the text insertion point during preedit is moved.
     * This must move the insertion point to the new location and
     * return the new value from the initial position.
     *
     * @return  The new value of the insertion point
     * from the initial position.
     */
    public int preeditCaret(PreeditEvent e);
}
