/*
 * @(#)StringData.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import java.io.IOException;

class StringData extends Data {

    StringData(byte b[], int len) {
	super(b, len);
    }

    StringData(String str) throws IOException {
	super();
	writeString(str);
    }

    StringData(Data d) {
	super(d);
    }

    String[] toStringArray() throws IOException {
	final int MAX = 8;

	// reads the length of string to follow
	int len = read2();
	if (len == 0) {
	    return (String[]) null;
	}

	int upto = pos + len;

	int num = 0;
	int num_array = MAX;
	String[] array = new String[num_array];

	for (; pos < upto; num++) {
	    if (num == num_array) {
		num_array += MAX;
		String[] tmp = new String[num_array];
		System.arraycopy(array, 0, tmp, 0, num);
		array = tmp;
	    }
	    array[num] = readString();
	}

	// Shrink array to make the right size
	if (array.length != num) {
	    String tmp[] = new String[num];
	    System.arraycopy(array, 0, tmp, 0, num);
	    array = tmp;
	}

	return array;
    }

    String[] toStringArray2() throws IOException {
	final int MAX = 8;

	// reads the length of string to follow
	int len = read4();
	if (len == 0) {
	    return (String[]) null;
	}

	int upto = pos + len;

	int num = 0;
	int num_array = MAX;
	String[] array = new String[num_array];

	for (; pos < upto; num++) {
	    if (num == num_array) {
		num_array += MAX;
		String[] tmp = new String[num_array];
		System.arraycopy(array, 0, tmp, 0, num);
		array = tmp;
	    }
	    array[num] = readString();
	}

	// Shrink array to make the right size
	if (array.length != num) {
	    String tmp[] = new String[num];
	    System.arraycopy(array, 0, tmp, 0, num);
	    array = tmp;
	}

	return array;
    }
}
