/*
 * @(#)TextEvent.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import sun.awt.im.iiimp.InputContext;
import sun.awt.im.iiimp.InputMethodText;

//public 
abstract class TextEvent extends IIIMPEvent {

    public static final int TEXT_STRING = 0;

    public static final int TEXT_INPUTMETHODTEXT = 1;

    int type;

    String str = null;

    InputMethodText text = null;

    public TextEvent(InputContext ic) {
	super(ic);
    }

    public TextEvent(InputContext ic, int id) {
	super(ic, id);
    }

    public TextEvent(InputContext ic, int id, String str) {
	super(ic, id);
	this.str = str;
	type = TEXT_STRING;
    }

    public TextEvent(InputContext ic, String str) {
	super(ic);
	this.str = str;
	type = TEXT_STRING;
    }

    public TextEvent(InputContext ic, int id, InputMethodText text) {
	super(ic, id);
	this.text = text;
	type = TEXT_INPUTMETHODTEXT;
    }

    public TextEvent(InputContext ic, InputMethodText text) {
	super(ic);
	this.text = text;
	type = TEXT_INPUTMETHODTEXT;
    }

    public int getType() {
	return type;
    }

    public String getString() {
	return str;
    }

    public InputMethodText getText() {
	return text;
    }
}
