/*
 * @(#)Util.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

class Util {

    static boolean localeEquals(java.util.Locale loc1, java.util.Locale loc2) {
	if (loc1 == null || loc2 == null) {
	    return false;
	}

	String lang = loc1.getLanguage();
        if (lang.equals("en") ||
	    lang.equals("fr") ||
	    lang.equals("de") ||
	    lang.equals("it") ||
	    lang.equals("sv") ||
	    lang.equals("es") ||
	    lang.equals("ja") ||
	    lang.equals("ko")) {
	    return lang.equals(loc2.getLanguage());
	}

	if (lang.equals("zh")) {
	    if (lang.equals(loc2.getLanguage())) {
		String region = loc1.getCountry();
		if (region != null && region.length() > 0) {
		    return region.equals(loc2.getCountry());
		}
		return true;
	    }
	    return false;
        }
	
	return lang.equals(loc2.getLanguage());
    }
}
