/*
 * @(#)ClientGIOP.java	1.3 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

/**
 * ClientGIOP contains the client-side GIOP APIs. There can be
 * multiple implementations of this GIOP transport.
 */
public interface ClientGIOP {

    /**
     * Prepare an invocation request.
     */
    public ClientRequest createRequest(IOR ior, String operationName,
				       boolean oneway,
				       ServiceContext[] svc);

    /**
     * Prepare an invocation request with the given requestId.
     */
    public ClientRequest createRequest(IOR ior, String operationName,
				       boolean oneway,
				       ServiceContext[] svc, int id);

    /**
     * Allocate a new request id.
     */
    public int allocateRequestId();


    /**
     * Send a locate request.
     */
    public IOR locate(IOR ior);
}

