/*
 * @(#)ClientRequest.java	1.4 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

/**
 * ClientRequest represents a client-side method invocation request.
 */
public interface ClientRequest extends MarshalOutputStream, Request
{
    /**
     * Process this invocation request.
     */
    public abstract ClientResponse invoke();

    /**
     * Resend the invocation to the IOR in the iorHolder, after a location
     * forward.
     * iorHolder must be an array of size 1.
     * Puts any subsequent forwarded IOR in the iorHolder.
     * Returns the ClientResponse as in invoke() above.
     */
    public abstract ClientResponse reInvoke(IOR[] iorHolder);
}



