/*
 * @(#)ClientSubcontract.java	1.9 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

/**
 * The client subcontract adds quality-of-service behavior on the client-side.
 * It is also the delegate.
 */
public interface ClientSubcontract {

    /**
     * Get the on-the-wire form of the object reference this
     * subcontract serves.
     */
    public IOR marshal();

    /**
     * Unmarshal subcontract specific information from the
     * IOR
     */
    public void unmarshal(IOR ior);

    /**
     * Create a ClientRequest instance.
     * For JavaIDL, this is invoked from the DII layer. For RMI/IIOP,
     * this is invoked from the delegate itself.
     */
    public ClientRequest createRequest(String method, boolean isOneWay);

    /**
     * Make an invocation.
     * For JavaIDL, this is invoked from the DII layer. For RMI/IIOP,
     * this is invoked from the delegate itself.
     */
    public ClientResponse invoke(ClientRequest request);

    /** Release the ClientResponse object after reply arguments have
     *  been unmarshaled. If an exception was unmarshaled, it must be provided.
     *  For JavaIDL, this is invoked from the DII layer. For RMI/IIOP,
     *  this is invoked from the delegate itself.
     */
    public void releaseReply(ClientResponse resp, String method,
                             Exception exception)
        throws org.omg.CORBA.WrongTransaction, org.omg.CORBA.SystemException;

    /**
     * Set the subcontract ID assigned by the ORB for this
     * class.
     */
    void setId(int id);

    /**
     *
     */
    void setOrb(ORB orb);
}
