/*
 * @(#)EndPoint.java	1.4 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

import java.net.InetAddress;

/**
 * EndPoint is an abstraction of a GIOP listening port.
 */
public interface EndPoint
{
    // These are the endpoint types
    public static final int CLEAR_TEXT = 123;
    public static final int SSL = 124;

    /**
     * Get the type of this end point (one of CLEAR_TEXT, SSL, ...)
     */
    public int getType();

    /**
     * Get the port number of this end point.
     */
    public int getPort();

    /**
     * Get the host name of this end point. Subcontracts must use this
     * instead of InetAddress.getHostName() because this would take
     * into account the value of the ORBServerHost property.
     */
    public String getHostName();

    /**
     * Get the InetAddress for this end point.
     */
    public InetAddress getInetAddress();
}
