/*
 * @(#)ORB.java	1.10 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

/**
 *
 */
public abstract class ORB extends org.omg.CORBA.ORB {
    /**
     * Get an instance of the GIOP client implementation.
     */
    public abstract ClientGIOP getClientGIOP();

    /**
     * Get an instance of the GIOP server implementation.
     */
    public abstract ServerGIOP getServerGIOP();

    /**
     * Return the subcontract registry
     */
    public abstract SubcontractRegistry getSubcontractRegistry();

    /**
     * Get a new instance of a GIOP input stream.
     */
    public abstract MarshalInputStream newInputStream();

    /**
     * Get a new instance of a GIOP input stream.
     */
    public abstract MarshalInputStream newInputStream(byte[] buffer, int size);

    /**
     * Get a new instance of a GIOP output stream.
     */
    public abstract MarshalOutputStream newOutputStream();

    /**
     * Get the transient server ID
     */
    public abstract int getTransientServerId();

    /**
     * Return the bootstrap naming port specified in the ORBInitialPort param.
     */
    public abstract int getORBInitialPort();

    /**
     * Return the bootstrap naming host specified in the ORBInitialHost param.
     */
    public abstract String getORBInitialHost();

    /**
     * Get the server host name. Note that this could be set the
     * application programmer using a system property.
     */
    public abstract String getORBServerHost();

    /**
     * Get the server port no. Note that this could be set the
     * application programmer using a system property.
     */
    public abstract int getORBServerPort();


}
