/*
 * @(#)Request.java	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

/**
 * Request represents a method invocation request. There are two types
 * of Request -- one that is used on the client side to invoke into
 * the GIOP layer and one that is used to dispatch up to the
 * subcontract.
 */
public interface Request {

    /**
     * Get the id assigned to this request object. These ids
     * are used by the transaction service hooks.
     */
    public int getRequestId();

    /**
     * Is this request object for a oneway operation?
     */
    public boolean isOneWay();

    /**
     * Get the service context information for this request.
     */
    public ServiceContext[] getServiceContextList();

    /**
     * Get the operation name for this request object.
     */
    public String getOperationName();

    /**
     * Get the object key.
     */
    public byte[] getObjectKey();

}
