/*
 * @(#)Response.java	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

import org.omg.CORBA.SystemException;

/**
 * Response represents a GIOP response received from the server
 * object.
 */
public interface Response {

    /**
     * Is this response a system exception?
     */
    public boolean isSystemException();

    /**
     * Is this response a user exception?
     */
    public boolean isUserException();

    /**
     * Is this a location forward?
     */
    public boolean isLocationForward();

    /**
     * IOR from the forward request
     */
    IOR getForwardedIOR();

    /**
     * Get the request id corresponding to this response.
     */
    public int getRequestId();

    /**
     * Get the service context information for this response.
     */
    public ServiceContext[] getServiceContextList();

    /**
     * Get the SystemException object if this response unmarshalled
     * off the wire was a SystemException.
     */
    public SystemException getSystemException();

}
