/*
 * @(#)ServerRequest.java	1.4 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

import org.omg.CORBA.SystemException;

/**
 * ServerRequest represents the incoming request on the server-side.
 */
public interface ServerRequest extends MarshalInputStream, Request {

    /**
     * Create a normal (invocation return) response for this request.
     */
    public ServerResponse
	createResponse(ServiceContext[] svc);


    /**
     * Create a response that represents an user exception.
     *
     */
    public ServerResponse
	createUserExceptionResponse(ServiceContext[] svc);


    /**
     * Create a response that represents a system exception.
     */
    public ServerResponse
        createSystemExceptionResponse(SystemException ex,
				      ServiceContext[] svc);


    /**
     * Create a response that represents a location forward.
     */
    public ServerResponse
	createLocationForward(IOR ior, ServiceContext[] svc);
}
