/*
 * @(#)ServiceContext.java	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.*;

public
final class ServiceContext {
    private int id;
    private byte[] data;

    public ServiceContext() {
    }

    public ServiceContext(int id, byte[] data) {
	this.id = id;
	this.data = data;
    }

    public int getId() {
	return id;
    }

    public byte[] getContextData() {
	return data;
    }

    public void write(OutputStream s) throws SystemException {
	s.write_long(id);
	s.write_long(data.length);
	s.write_octet_array(data,0,data.length);
    }

    public void read(InputStream s) throws SystemException {
	id = s.read_long();
	int len = s.read_long();
	data = new byte[len];
	s.read_octet_array(data,0,len);
    }
}
