/*
 * @(#)ExceptionListImpl.java	1.15 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.idl;

import java.util.Vector;

import org.omg.CORBA.Bounds;
import org.omg.CORBA.ExceptionList;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.ORB;


public class ExceptionListImpl extends ExceptionList {

  private final int	 INITIAL_CAPACITY	= 2;
  private final int	 CAPACITY_INCREMENT	= 2;

  private Vector _exceptions;

  ExceptionListImpl() {
    _exceptions = new Vector(INITIAL_CAPACITY, CAPACITY_INCREMENT);
  }

  public int count() 
  {
    return _exceptions.size();
  }

  public void add(TypeCode tc)
  {
    _exceptions.addElement(tc);
  }

  public TypeCode item(int index)
    throws Bounds
  {
    try {
      return (TypeCode) _exceptions.elementAt(index);
    } catch (ArrayIndexOutOfBoundsException e) {
      throw new Bounds();
    }
  }

  public void remove(int index)
    throws Bounds
  {
    try {
      _exceptions.removeElementAt(index);
    } catch (ArrayIndexOutOfBoundsException e) {
      throw new Bounds();
    }
  }

}

