/*
 * @(#)CancelRequestMessage.java	1.20 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.iiop;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.*;

final class CancelRequestMessage extends Message {
    CancelRequestMessage() {
    }

    CancelRequestMessage(int requestId)
    {
	super();
	setType(Message.GIOPCancelRequest);
	this.requestId = requestId;
    }

    void
    write(OutputStream s)
    throws SystemException
    {
	super.write(s);
	s.write_long(requestId);
    }

    void
    read(InputStream s)
    throws SystemException
    {
	requestId = s.read_long();
    }
}
