/*
 * @(#)ClientResponseImpl.java	1.8 98/07/09
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.iiop;

import java.io.IOException;

import org.omg.CORBA.SystemException;

import com.sun.CORBA.Response;
import com.sun.CORBA.ClientResponse;
import com.sun.CORBA.IOR;
import com.sun.CORBA.ServiceContext;

class ClientResponseImpl extends IIOPInputStream implements ClientResponse
{
    ClientResponseImpl(Connection conn, byte[] buf, ReplyMessage header)
	throws IOException
    {
	super(conn, buf, header);

        this.reply = header;
    }

    ClientResponseImpl(SystemException ex)
    {
	this.systemException = ex;
    }

    public boolean isSystemException() {
	if ( reply != null )
	    return reply.getReplyStatus() == ReplyMessage.SYSTEM_EXCEPTION;
	else
	    return (systemException != null);	
    }

    public boolean isUserException() {
	if ( reply != null )
	    return reply.getReplyStatus() == ReplyMessage.USER_EXCEPTION;
	else
	    return false;
    }

    public boolean isLocationForward() {
	if ( reply != null )
	    return reply.getReplyStatus() == ReplyMessage.LOCATION_FORWARD;
	else
	    return false;
    }

    public IOR getForwardedIOR() {
	if ( reply != null )
	    return reply.getIOR();
	else
	    return null;
    }

    public int getRequestId() {
	if ( reply != null )
	    return reply.getRequestId();
	else
	    throw new org.omg.CORBA.INTERNAL("Error in getRequestId");
    }

    public ServiceContext[] getServiceContextList() {
	if ( reply != null )
	    return reply.getServiceContextList();
	else
	    return null;
    }

    public SystemException getSystemException() {
	if ( reply != null )
	    return reply.getSystemException();
	else
	    return systemException;
    }

    // XXX To be implemented
    public java.lang.String peekUserExceptionId() {
	throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    private ReplyMessage reply;
    private SystemException systemException;
}
