/*
 * @(#)LocateRequestMessage.java	1.23 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.iiop;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.*;

final class LocateRequestMessage extends Message {
    private byte[] objectKey;

    LocateRequestMessage()
    {
    }

    LocateRequestMessage(int requestId, byte[] objectKey)
    {
	super();
	setType(Message.GIOPLocateRequest);
	this.requestId = requestId;
	this.objectKey = objectKey;
    }

    byte[]
    getObjectKey()
    {
	return objectKey;
    }

    void
    write(OutputStream s)
    throws SystemException
    {
	super.write(s);
	s.write_long(requestId);
        s.write_long(objectKey.length);
	s.write_octet_array(objectKey, 0, objectKey.length);
    }

    void
    read(InputStream s)
    throws SystemException
    {
	requestId = s.read_long();
	objectKey = new byte[s.read_long()];
	s.read_octet_array(objectKey, 0, objectKey.length);
    }
}
