/*
 * @(#)ServerRequestImpl.java	1.35 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.iiop;

import org.omg.CORBA.SystemException;

import com.sun.CORBA.ServerRequest;
import com.sun.CORBA.ServiceContext;
import com.sun.CORBA.ServerResponse;
import com.sun.CORBA.IOR;
import com.sun.CORBA.util.*;

class ServerRequestImpl extends IIOPInputStream implements ServerRequest
{
    ServerRequestImpl(Connection c, byte[] buf, RequestMessage header)
	throws java.io.IOException
    {
	super(c, buf, header);

	this.request = header;
    }

    public int getRequestId() {
	return request.getRequestId();
    }

    public boolean isOneWay() {
	return !request.isResponseExpected();
    }

    public ServiceContext[] getServiceContextList() {
	return request.getServiceContextList();
    }

    public String getOperationName() {
	return request.getOperation();
    }

    public byte[] getObjectKey() {
	return request.getObjectKey();
    }

    public ServerResponse createResponse(ServiceContext[] svc)
    {
	return new ServerResponseImpl(this, svc);
    }

    public ServerResponse createUserExceptionResponse(ServiceContext[] svc)
    {
	return new ServerResponseImpl(this, svc, true);
    }

    public ServerResponse createSystemExceptionResponse(SystemException ex,
				      			ServiceContext[] svc)
    {
	ServerResponseImpl response = new ServerResponseImpl(this, svc, false);
	Utility.writeSystemException(ex, response);
	return response;
    }

    public ServerResponse createLocationForward(IOR ior, ServiceContext[] svc)
    {
	ReplyMessage reply = new ReplyMessage(svc, getRequestId(),
					ReplyMessage.LOCATION_FORWARD);
	ServerResponseImpl response = new ServerResponseImpl(this, reply, ior);
	return response;
    }

    private RequestMessage request;
}
