/*
 * @(#)Condition.java	1.21 98/06/29
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.util;

//
// Traditional Condition variables, unbound to any instance or class.
//							KGH April 95

final public class Condition {

    public Condition() {
    }

    public void wait(Lock lock) {
        synchronized (this) {
	    lock.unlock();
	    boolean ok = false;
	    while (!ok) {
	        try {
		    super.wait();
		    ok = true;
	        } catch (InterruptedException ex) {
		    // Eat it and loop again.  The user doesn't care how
		    // long we wait.
	        }
	    }
	}
	lock.lock();
    }

    public void wait(Lock lock, int timeout)
    throws InterruptedException {
      synchronized (this) {
	lock.unlock();
	super.wait(timeout);
      }
      lock.lock();
    }

    public synchronized void signal() {
	super.notify();
    }

    public synchronized void signalAll() {
	super.notifyAll();
    }
}

