/*
 * @(#)Lock.java	1.9 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.util;

//
// Traditional mutex, unbound to any instance or class.
//							KGH April 95

final public class Lock {

    public synchronized void lock()
    {
	while (busy) {
	    try {
	        wait();
	    } catch (java.lang.InterruptedException ex) {
		// Eat it.
	    }
	}
	busy = true;
    }

    public synchronized void unlock()
    {
	if (!busy) {
	    throw new Error("freeing non-busy lock");
	}
	busy = false;
	notifyAll();
    }

    boolean busy = false;

}
