/*
 * @(#)MinorCodes.java	1.6 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.CORBA.util;


public final class MinorCodes {
// BAD_CONTEXT exception minor codes
// BAD_INV_ORDER exception minor codes
	// from ServerRequestImpl.java
	public static final int DSIMETHOD_NOTCALLED = 1 ;

// BAD_OPERATION exception minor codes
// BAD_PARAM exception minor codes
	public static final int NULL_PARAM = 1 ;

// BAD_TYPECODE exception minor codes
// BOUNDS exception minor codes

// COMM_FAILURE exception minor codes
	// from IIOPConnection.java
	public static final int CONNECT_FAILURE = 1 ;
	public static final int CONN_CLOSE_REBIND = 2 ;
	public static final int WRITE_ERROR_SEND = 3 ;

	// from ORB.java
	public static final int GET_PROPERTIES_ERROR = 4 ;
	public static final int BOOTSTRAP_SERVER_NOT_AVAIL = 5 ;

	// from Generic.java
	/** 
	 * Unable to successfully connect to the server after several
	 * attempts.
	 */
	public static final int INVOKE_ERROR = 6 ;
	
// DATA_CONVERSION exception minor codes
	// from ORB.java

	/** 
	 * Encountered a bad hexadecimal character while doing 
	 * ORB string_to_object operation.
 	 */
	public static final int BAD_HEX_DIGIT = 1 ;

	/** 
	 * The given IOR for string_to_object operation has odd
	 * length. It must be even.
	 */
	public static final int BAD_STRINGIFIED_IOR_LEN = 2 ;

	/** 
	 * The given string does not start with "IOR:" and hence is a
	 * bad stringified IOR.
	 */
	public static final int BAD_STRINGIFIED_IOR = 3 ;

	/** 
	 * Unable to perform ORB resolve_initial_references operation
	 * due to the host or the post being incorrect or unspecified.
	 */
        public static final int BAD_MODIFIER = 4;

// IMP_LIMIT exception minor codes
// INTF_REPOS exception minor codes
// INTERNAL exception minor codes

        // from Generic.java
	/** 
	 * Bad status returned in the IIOP Reply message by the server.
	 */
        public static final int BAD_REPLYSTATUS = 3 ;

	/** 
	 * When unmarshalling, the repository id of the user exception
	 * was found to be of incorrect length.
	 */
	public static final int PEEKSTRING_FAILED = 6 ;

	// from IIOPConnection.java

	/** 
	 * Unable to determine local hostname using the Java APIs 
	 * InetAddress.getLocalHost().getHostName().
	 */
	public static final int GET_LOCAL_HOST_FAILED = 7 ;

	/** 
	 * Unable to create the listener thread on the specific port.
	 * Either the post is taken or there was an error creating the
	 * daemon thread.
	 */
	public static final int CREATE_LISTENER_FAILED = 8 ;

	/**
	 * Bad locate request status found in the IIOP locate reply.
	 */
	public static final int BAD_LOCATE_REQUEST_STATUS = 9 ;

	// from IOR.java
	/** 
	 * Error encountered while stringifying an object reference.
	 */
	public static final int STRINGIFY_WRITE_ERROR = 10 ;

	// from Message.java
	/** 
	 * IIOP message with bad GIOP v1.0 message type found. 
	 */
	public static final int BAD_GIOP_REQUEST_TYPE = 11 ;

	// from Utility.java

	/** 
	 * Error encountered while unmarshalling the user exception.
	 */
	public static final int ERROR_UNMARSHALING_USEREXC = 14 ;

	// from SubcontractRegistry.java
	/** 
	 * The client, or a server subcontract being registered 
	 * will overflow the suncontract registry.
	 */
	public static final int SUBCONTRACTREGISTRY_ERROR = 18 ;

	// from GenericCORBAClientSC.java, RequestImpl.java
	/** 
	 * Error while processing a LocationForward.
	 */
	public static final int LOCATIONFORWARD_ERROR = 19 ;
	

// INV_FLAG exception minor codes
// INV_IDENT exception minor codes
// INV_OBJREF exception minor codes
	// from IOR.java

	/** 
	 * An IOR with no profiles was encountered.
	 */
	public static final int NO_PROFILE_PRESENT = 1 ;

// MARSHAL exception minor codes

	/** 
	 * Error occured while trying to read a marshalled object 
	 * reference and converting into an in memory object reference.
	 */
	public static final int READ_OBJECT_EXCEPTION = 4 ;

	/** 
	 * Marshalling/Unmarshalling unsupported IDL types like wide
	 * characters and wide strings.
	 */
	public static final int UNSUPPORTED_IDLTYPE = 5 ;

	/** 
	 * Character encountered while marshalling or unmarshalling 
	 * that is not ISO Latin-1 (8859.1) compliant. It is not in
	 * the range of 0 to 255.
	 */
	public static final int CHARACTER_OUTOFRANGE = 6 ;

	/**
	 * An exception was thrown while doing the result()
	 * operation on ServerRequest.
	 */
	public static final int DSI_RESULT_EXCEPTION = 7 ;

	/**
	 * IIOPInputStream.grow was called.
	 */
	public static final int IIOPINPUTSTREAM_GROW = 8 ;


// NO_MEMORY exception minor codes
// FREE_MEM exception minor codes
// NO_IMPLEMENT exception minor codes

	/** This is redundant now because DSI is implemented. */
	public static final int DSI_NOT_IMPLEMENTED = 1 ;

	/** 
	 * get_interface is not implemented on server.
	 */
	public static final int GETINTERFACE_NOT_IMPLEMENTED = 2 ;

	/** 
	 * deferred sends are not implemented.
	 */
	public static final int SEND_DEFERRED_NOTIMPLEMENTED = 3 ;

// NO_PERMISSION exception minor codes
// NO_RESOURCES exception minor codes
// NO_RESPONSE exception minor codes
// OBJ_ADAPTER exception minor codes
	// from ORB.java

	/** 
	 * There was no subcontract found that matches the one in 
	 * the object key when dispatching the request on the server
	 * side to the object adapter layer.
	 */
	public static final int NO_SERVER_SC_IN_DISPATCH = 1 ;

	/** 
	 * There was no subcontract found that matches the one in 
	 * the object key when dispatching the locate request on the server
	 * side to the object adapter layer.
	 */ 
	public static final int NO_SERVER_SC_IN_LOOKUP = 2 ;

	/** 
	 * Unable to create the default server-side subcontract while 
	 * connecting a servant to the ORB.
	 */
	public static final int NO_SERVER_SC_IN_CREATE_DEFAULT_SERVER = 3 ;

	/** 
	 * Error occured when trying to connect a servant to the ORB.
	 */
	public static final int ORB_CONNECT_ERROR = 4 ;

// INITIALIZE exception minor codes
// PERSIST_STORE exception minor codes
// TRANSIENT exception minor codes
// UNKNOWN exception minor codes
	// from Utility.java
	/** 
	 * Unknown user exception encountered while unmarshalling.
	 */
	public static final int UNKNOWN_CORBA_EXC = 1 ;

	// from GenericServerSC.java
	/** 
	 * Unknown user exception thrown by the server implementation.
	 */
	public static final int RUNTIMEEXCEPTION  = 3 ;

	// from WorkerThread.java
	/** 
	 * Unknown exception/error thrown by the ORB/application implementation.
	 */
	public static final int UNKNOWN_SERVER_ERROR  = 4 ;

	// from Utility.java
	/**
	 * Error while marshaling SystemException after DSI-based invocation. 
	 */
	public static final int UNKNOWN_DSI_SYSEX  = 5 ;

// OBJECT_NOT_EXIST  exception minor codes
	// from IIOPConnection.java

	/** 
	 * The locate request got the response indicating that the
	 * object is not known to the locator.
	 */
	public static final int LOCATE_UNKNOWN_OBJECT = 1 ; 
	// from GenericServerSC.java

	/** 
	 * The server id of the server that received the request does
	 * not match the server id baked into the object key of the
	 * object reference that was invoked upon.
	 */
	public static final int BAD_SERVER_ID = 2 ; 
	
	/** 
	 * The implementation id baked into the object reference does not 
	 * match any implementation in the server. 
	 */ 
	public static final int BAD_IMPLID = 3 ; 

	/** 
	 * No skeleton was found on the server side that matches the
	 * contents of the object key inside the object reference.
	 */ 
	public static final int BAD_SKELETON = 4 ; 

	public static final int SERVANT_NOT_FOUND = 5 ; 
} ;
