/*
 * @(#)DocErrorReporter.java	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.javadoc;

/**
 * This interface provides error, warning and notice printing.
 *
 * @since JDK1.2
 * @author Robert Field
 */
public interface DocErrorReporter {

    /**
     * Print error message, increment error count.
     *
     * @param msg message to print
     */
    void printError(String msg);

    /**
     * Print warning message, increment warning count.
     *
     * @param msg message to print
     */
    void printWarning(String msg);

    /**
     * Print a message.
     *
     * @param msg message to print
     */
    void printNotice(String msg);
}
