/*
 * @(#)FieldDoc.java	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.javadoc;

/**
 * Represents a field in a java class.
 *
 * @see MemberDoc
 *
 * @since JDK1.2
 * @author Robert Field
 */
public interface FieldDoc extends MemberDoc {

    /**
     * Get type of this field.
     */
    Type type();

    /**
     * Return true if this field is transient
     */
    boolean isTransient();

    /**
     * Return true if this field is volatile
     */
    boolean isVolatile();

    /**
     * Return the serialField tags in this FieldDoc item.
     *
     * @return an array of <tt>SerialFieldTag<\tt> containing all
     *         <code>&#64serialField<\code> tags.
     */
    SerialFieldTag[] serialFieldTags();
}
