/*
 * @(#)Constructor11SubWriter.java	1.6 98/04/17
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.tools.doclets.oneone;

import com.sun.javadoc.*;
import com.sun.tools.doclets.*;

/**
 *
 * @author Robert Field
 */
public class Constructor11SubWriter extends ExecutableMemberSub11Writer {

    Constructor11SubWriter(Class11Writer writer) {
        super(writer);
    }

    public ProgramElementDoc[] members(ClassDoc cd) {
        return cd.constructors();
    }

    protected void printTags(ProgramElementDoc member) {
        ParamTag[] params = ((ConstructorDoc)member).paramTags();
        ThrowsTag[] thrown = ((ConstructorDoc)member).throwsTags();
        SeeTag[] sees = member.seeTags();
        if (params.length + thrown.length + sees.length > 0) {
            writer.dd();
            writer.dl();
            printParamTags(params);
            printThrowsTags(thrown);
            writer.printSeeTags(member);
            writer.dlEnd();
            writer.ddEnd();
        }
    }
                               
    protected void printConstructorBall(ConstructorDoc cons, boolean small) {
        writer.printBall("yellow-ball", "Yellow Ball", small);
    }
 
    public void printSummaryLabel(ClassDoc cd) {
        writer.printBanner("constructor-index", "doclet.Constructor_Index", 275, 38);
    }

    protected void printHeader(ClassDoc cd) {
        writer.anchor("constructors");
        writer.printBanner("constructors", "doclet.Constructors", 151, 38);
    }

    protected void printFooter(ClassDoc cd) {
    }

    protected void printSummaryType(ProgramElementDoc member) {
        printConstructorBall((ConstructorDoc)member, true);
    }

    protected void printSummaryLink(ClassDoc cd, ProgramElementDoc member) {
        ConstructorDoc cons = (ConstructorDoc)member;
        String name = cons.name();
        writer.printHyperLink("#" + name + cons.signature(), name);
        writer.println(cons.flatSignature());
    }

    protected void printMember(ClassDoc cd, ProgramElementDoc member) {
        ConstructorDoc cons = (ConstructorDoc)member;
        String name = cons.name();
        writer.aName(name + cons.signature());
        printConstructorBall(cons, false);
        writer.aEnd();

        writer.bold(name);

        // Get the signature,
        // generate link for each parameter if it is a class.
        printSignature(cons);
        printFullComment(cons);
    }
}  
    
    
