/*
 * @(#)Main.java	1.2 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.tools.extcheck;

import java.io.*;

/** 
 * Main program of extcheck
 */

public final class Main {
    

    /**
     * Terminates with one of the following codes
     *  1 A newer (or same version) jar file is already installed
     *  0 No newer jar file was found
     *  -1 An internal error occurred
     */
    public static void main(String args[]){
	
	if (args.length < 1){
	    System.err.println("Usage: extcheck [-verbose] <jar file>");
	    System.exit(-1);
	}
	int argIndex = 0;
	boolean verboseFlag = false;
	if (args[argIndex].equals("-verbose")){
	    verboseFlag = true;
	    argIndex++;
	}
	String jarName = args[argIndex];
	argIndex++;
	File jarFile = new File(jarName);
	if (!jarFile.exists()){
	    ExtCheck.error("Jarfile " + jarName + " does not exist");
	}
	if (argIndex < args.length) {
	    ExtCheck.error("Extra command line argument :"+args[argIndex]);
	}
	ExtCheck jt = ExtCheck.create(jarFile,verboseFlag);
	boolean result = jt.checkInstalledAgainstTarget();
	if (result) {
	    System.exit(0);
	} else { 
	    System.exit(1);
	}
	    
    }

}

