/*
 * @(#)ConstructorDocImpl.java	1.5 98/07/07
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.tools.javadoc;

import com.sun.javadoc.*;

import sun.tools.java.MemberDefinition;

import java.util.Map;
import java.util.HashMap;

/**
 * Represents a constructor of a java class.
 *
 * @since JDK1.2
 * @author Robert Field
 */
class ConstructorDocImpl extends ExecutableMemberDocImpl
                                implements ConstructorDoc {

    /**
     * map MemberDefinitions to ConstructorDocImpl, for uniqueness.
     */
    private static Map map = new HashMap();

    /**
     * constructor.
     */
    private ConstructorDocImpl(Env env, MemberDefinition f, String lookupKey) {
        super(env, f);
        map.put(lookupKey, this);
    }

    static ConstructorDocImpl getConstructorDocImpl(Env env, MemberDefinition f) {
        String lookupKey = lookupKey(f);
        ConstructorDocImpl m = (ConstructorDocImpl)map.get(lookupKey);
        if (m == null) {
            m = new ConstructorDocImpl(env, f, lookupKey);
        }
        return m;
    }

    /**
     * Get the name.
     *
     * @return the qualified name of the member.
     */
    public String qualifiedName() {
	return containingClass.qualifiedName();
    }

    /**
     * Get the name.
     *
     * @return the unqualified name of the member.
     */
    public String name() {
	return containingClass.name;
    }

    /**
     * Return true if it is a constructor, which it is.
     *
     * @return true
     */
    public boolean isConstructor() {
        return true;
    }
}
