/*
 * @(#)ParameterImpl.java	1.10 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.tools.javadoc;

import com.sun.javadoc.*;

/**
 * ParameterImpl information.
 * This includes a parameter type and parameter name.
 *
 * @author Kaiyang Liu (original)
 * @author Robert Field (rewrite)
 */
public class ParameterImpl implements Parameter {

    /**
     * parameter type information.
     */
    Type type;

    /**
     * paramter local name.
     */
    String name;

    /**
     * constructor of paramter info class.
     */
    ParameterImpl(Type type, String name) {
        this.type = type;
        this.name = name;
    }

    /**
     * Get the type of this parameter.
     */
    public Type type() {
        return type;
    }

    /**
     * Get local name of this parameter.
     * For example if parameter is the short 'index', returns "index".
     */
    public String name() {
	return name;
    }

    /**
     * Get type name of this parameter.
     * For example if parameter is the short 'index', returns "short".
     */
    public String typeName() {
	return type.toString();
    }

    /**
     * Returns a string representation of the class.
     * <p>
     * For example if parameter is the short 'index', returns "short index".
     *
     * @return type name and parameter name of this parameter.
     */
    public String toString() {
	return type.toString() + " " + name;
    }
}


