/*
 * @(#)AppletCopyright.java	1.17 98/06/29
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.applet;

import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * Applet copyright splash screen.
 */
class AppletCopyright extends Frame {
    AppletCopyright() {
        setTitle(amh.getMessage("title"));
	Panel p = new Panel();
	Dimension dims = Toolkit.getDefaultToolkit().getScreenSize();
	TextArea txt = new TextArea((dims.height / 2) / 12, (int) (dims.width / 2) / 7);
	txt.setEditable(false);
	String loadText = (String) java.security.AccessController.doPrivileged(
          new java.security.PrivilegedAction() {
	    public Object run() {
		return (String) load();
	    }
	});

	txt.setText(loadText);
        txt.setFont(new Font("Serif", Font.BOLD, 12));
        p.add(new Button(amh.getMessage("button.accept")));
        p.add(new Button(amh.getMessage("button.reject")));
	add("Center", txt);
	add("South", p);
	pack();
	Dimension d = size();
	Dimension scrn = getToolkit().getScreenSize();
	move((scrn.width - d.width) / 2, (scrn.height - d.height)/ 2);
	show();
    }
    String load() {
	String avHome = System.getProperty("application.home");
	String fileSeparator = System.getProperty("file.separator");
	String copyrightFile = amh.getMessage("copyrightfile");
	String userLanguage = Locale.getDefault().getLanguage();

	// localized COPYRIGHT file may exist in $JAVA_HOME/<language>
	// directory
	File f = new File(avHome + fileSeparator + userLanguage +
			  fileSeparator + copyrightFile);
	if (!f.canRead()) {
	    f = new File(avHome + fileSeparator + copyrightFile);
	}

	try {
	    if (f.canRead()) {
		String copyrightEncoding = amh.getMessage("copyrightencoding");
		InputStreamReader reader =
		    new InputStreamReader(new FileInputStream(f),
					  copyrightEncoding);
		BufferedReader in = new BufferedReader(reader);
		CharArrayWriter out = new CharArrayWriter();
		char buf[] = new char[256];
		int n;

		while ((n = in.read(buf, 0, buf.length)) >= 0) {
		    out.write(buf, 0, n);
		}
		in.close();
		return out.toString();
	    }
	} catch (IOException e) {
	}
        return amh.getMessage("defaultcontent");
    }

    public synchronized boolean action(Event evt, Object arg) {
	if (!(evt.target instanceof Button))
	    return false;

        if (amh.getMessage("button.reject").equals(((Button)evt.target).getLabel())) {

	    System.exit(1);
	    return true;
	}
        else if (amh.getMessage("button.accept").equals(((Button)evt.target).getLabel())) {
	    dispose();
	    notify();
	    final boolean result[] = {false};
	    java.security.AccessController.doPrivileged(
		new java.security.PrivilegedAction() {
		public Object run() {

		    // Get properties, set version
		    Properties props = System.getProperties();
		    props.put("appletviewer.version", AppletViewer.theVersion);

		    // Save properties
		    try {
			FileOutputStream out =
		      new FileOutputStream(AppletViewer.theUserPropertiesFile);
			props.save(out, "AppletViewer");
			out.close();
		    } catch (IOException e) {
		    }
		    result[0] = true;
		    return null;
		}
	    });
	    return result[0];
	}
	return false;
    }

    public synchronized void waitForUser() {
	try {
	    wait();
	} catch (InterruptedException e) {
	}
    }

    private static AppletMessageHandler amh = new AppletMessageHandler("appletcopyright");
}
