/*
 * @(#)AppletEvent.java	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.applet;

import java.util.EventObject;


/**
 * AppletEvent class.
 *
 * @version 1.8, 09/21/98
 * @author  Sunita Mani
 */

public class AppletEvent extends EventObject {

    private Object arg;
    private int id;


    public AppletEvent(Object source, int id, Object argument) {
	super(source);
	this.arg = argument;
	this.id = id;
    }

    public int getID() {
	return id;
    }

    public Object getArgument() {
	return arg;
    }

    public String toString() {
	String str = getClass().getName() + "[source=" + source + " + id="+ id;
	if (arg != null) {
	    str += " + arg=" + arg;
	}
	str += " ]";
	return str;
    }
}
 

