/*
 * @(#)AudioDataStream.java	1.18 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

import java.io.*;

/**
 * An input stream to play AudioData.
 *
 * @see AudioPlayer
 * @see AudioData
 * @author Arthur van Hoff
 * @author Kara Kytle
 * @version 1.18, 98/09/21
 */
public class AudioDataStream extends ByteArrayInputStream {


    AudioContainerInputStream acis;

    /**
     * Constructor
     */
    public AudioDataStream(AudioData data) {
            
        super(data.buffer);

        // we don't need an explicitly typed stream for "real" audio
        // formats, but we *do* for MIDI and RMF, which set the
        // AudioFormat obj to null but require a typed stream to play
        // the song in AudioDevice. 

        try {
           acis = new AudioContainerInputStream(data.format, this);
        } catch (BadAudioHeaderException e) {
            try {
                acis = AudioContainerInputStream.getStream(new ByteArrayInputStream(data.buffer));
            } catch (IOException e2) {
                System.out.println("could not create AudioDataStream from " + data);
            }
        }
    }

}
