/*
 * @(#)BadAudioHeaderException.java	1.10 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;
import java.io.IOException;

class BadAudioHeaderException extends IOException {

    /**
    * Any bytes which were read from the stream and not returned
    * before the exception was thrown.  null if none.
    */

    public byte[] bytes;


   /** BadAudioHeaderException
     *  Construct an BadAudioHeaderException without a message.
     */
    public BadAudioHeaderException() {
	super();
    }
	
    /** BadAudioHeaderException
      * Construct an BadAudioHeaderException with a detail	
      * message. A detail message is a string that describes
      * this particular exception.
      * @param s detail message string
      */
    public BadAudioHeaderException(String s) {
	super(s);
    }

    /**
      * Constructor with a detail message and an array of bytes read
      * from the stream before the exception was thrown.
      * @param s detail message string
      * @param bytes any bytes read from the stream before the exception was thrown
      */
    public BadAudioHeaderException(String s, byte[] bytes) {

	super(s);
	this.bytes = bytes;
    }

}
