/*
 * @(#)HaeDevice.java	1.14 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

import java.io.IOException;
import java.io.FileInputStream;
import sun.audio.BadAudioHeaderException;
import sun.audio.AudioContainerInputStream;
import sun.audio.AudioWavInputStream;
import sun.audio.AudioAiffInputStream;
import sun.audio.AudioAuInputStream;

class HaeDevice {

    private static HaeMixer mixer;
    static {

	try {
	    // Start this off, using native thread.
	    mixer = new HaeMixer();
	} catch (HaeException e) {
	    System.err.println("Can't get a default mixer: " + e);
	    mixer = null;
	}
    }

    /**
     * Get the default mixer
     *
     * @return the default mixer.
     */
    static public HaeMixer getSystemMixer() throws HaeException {
	if (mixer == null) {
	    throw new HaeException("Default mixer not open");
	}

	return mixer;
    }

// BEGIN_SIZE_REDUCTION
//
//    /**
//     * Get a stream for the file name.
//     *
//     * @param fileName to get the stream for.
//     *
//     * @return the stream.
//     */
//    static public HaeAudioStream getAudioStream(String fileName)
//	throws BadAudioHeaderException, IOException, InvalidAudioFormatException, HaeException {
//                                                                                 
//	return getAudioStream(fileName, fileName);
//    }
//
//    /**
//     * Get a WaveFile for the file name.
//     *
//     * @param fileName to get the WaveFile for.
//     *
//     * @return an HaeWaveFile.
//     */
//    static public HaeWaveFile getAudioFile(String fileName)
//	throws HaeException {
//	    
//	HaeWaveFile file = new HaeWaveFile(getSystemMixer());
//
//	// Try a few open methods.
//	try {
//	    file.openAU(fileName);
//	} catch (HaeException auFailed) {
//	    try {
//		file.openWAV(fileName);
//	    } catch (HaeException wavFailed) {
//		file.openAIFF(fileName);
//	    }
//	}
//	return file;
//    }
//
//
//    /**
//     * Get a stream for a file name.<br>
//     * The stream name is for identification purposes only.
//     * 
//     * @param fileName to get the clip for.
//     * @param streamName name of stream.
//     *
//     * @return the stream
//     */
//    static public HaeAudioStream getAudioStream(String fileName,
//						String streamName)
//	throws BadAudioHeaderException, IOException, InvalidAudioFormatException, HaeException {
//	    
//	AudioContainerInputStream audioStream = getAudioContainer(fileName);
//
//	HaeAudioStream clip = new HaeAudioStream(audioStream, streamName);
//	return clip;
//     }
//
//    /**
//     * Get an HeaSound from a file and load it into memory.
//     * 
//     * @param fileName to get the clip fpr.
//     * @param clipName for clip.
//     */
//    static public HaeAudioClip getClipFromFile(String fileName,
//					       String streamName)
//	throws BadAudioHeaderException, IOException, HaeException {
//
//	    // Get an audio container ....
//	    // $$ jdr: This is dependent on size in the container
//	    // working. Which is not guaranteed.
//	    // For .au files you can always run it through audioconvert
//	    // to add the size.
//	    AudioContainerInputStream containerStream =
//		getAudioContainer(fileName);
//	    return new HaeAudioClip(containerStream, streamName);
//    }
//
//
//    /**
//     * Get an HaeMidiSong for a file.
//     */
//    static public HaeMidiSong getSong(String fileName) throws HaeException {
//	
//	HaeMidiSong midiSong = null;
//	if (fileName.endsWith(".rmf")) {
//	    midiSong = new HaeRmfSong(getSystemMixer());
//	    midiSong.open(fileName);
//	} else {
//	    midiSong = new HaeMidiSong(getSystemMixer());
//	    midiSong.open(fileName);
//	}
//	
//	return midiSong;
//    }
//
//
//    /**
//     * Find the right file container for the filename
//     *
//     * @param fileName to create the container from.
//     *
//     * @return a file container for the data in the file.
//     *
//     * @exception BadAudioHeaderException thrown if the file is not a 
//     * recognized audio file.
//     * @exception IOException thrown if the file can't be read.
//     */
//
//    static AudioContainerInputStream getAudioContainer(String fileName)
//	throws BadAudioHeaderException, IOException {
//
//		FileInputStream fis = new FileInputStream(fileName);
//		AudioContainerInputStream acis = AudioContainerInputStream.getStream(fis);
//		return acis;
//    }
// END_SIZE_REDUCTION

}
