/*
 * @(#)HaeMidiNoise.java	1.9 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;


/**
 * HaeMidiNoise:
 * Encapsulates the MIDI-playing capabilities of HAE.  Cannot be instantiated
 * directly.  Make a subclass or use HaeMidiPlayer, HaeMidiSong, or HaeRmfSong.
 */

class HaeMidiNoise extends HaeNoise {

// PUBLIC OPERATIONS:
    public native void      close();
    
    public native void      setVolume(double volume);
    public native void      setPitchOffset(int offset);     // in semitones

    public native void      muteChannel(int channel);
    public native void      unmuteChannel(int channel);
    public native void      soloChannel(int channel);
    public native void      unSoloChannel(int channel);

    public native void      preloadInstrument(byte bank, byte program);
    public native void      preloadPercussionInstrument(byte bank, byte program, byte note);

    public native void      noteOn(int tick, byte channel, byte note, byte velocity);
    public native void      noteOff(int tick, byte channel, byte note, byte velocity);
    public native void      bankPatch(int tick, byte channel, byte bank, byte program);
    public native void      patch(int tick, byte channel, byte program);
    public native void      controller(int tick, byte channel, byte controller, byte value);
    public native void      pitchBend(int tick, byte channel, int value);
    public native void      allNotesOff(int tick);


// PUBLIC DATA:
    public native double    getVolume();
    public native int       getPitchOffset();
    public native byte[]    getChannelMuteStatus();
    public native byte[]    getChannelSoloStatus();

// PUBLIC OPERATIONS:
    public native int       getTick();                      // in microseconds

// PROTECTED DATA:
    protected int m_songData;

// PROTECTED OPERATIONS:
    protected HaeMidiNoise(HaeMixer mixer) {
        super(mixer);
        m_songData = 0;
    }
};
