/*
 * @(#)HaeMidiSong.java	1.10 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;


/**
 * HaeMidiSong:
 * Plays a MIDI-file.
 */

class HaeMidiSong extends HaeMidiNoise implements HaePlayable {
// PUBLIC CONSTRUCTION:
    public HaeMidiSong(HaeMixer mixer) {
        super(mixer);
        m_stringData = 0;
    }

// PUBLIC OPERATIONS:
    public native void open(byte[] midiData) throws HaeException;
//  public native void openFile(String songPath) throws HaeException;
    public native void close();

    // start, don't return until finished
    public void play() throws HaeException {    
		        
        if (!isPlaying()) start();

            // $$ jdr: This needs to be reimplemented with some
            // wait/notify mechanism. Will require some hacking on stop
            // and isPlaying like code.
            while (isPlaying()) {
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                }
        }
    }

    public native void start() throws HaeException; // start, return right away
    public native void stop(boolean withFade);
    public native void pause();
    public native void resume();

    public native void adjustTempo(double tempoFactor); // 1.0 is normal tempo
    public native void setLoopFlag(boolean doLoop);     // to loop entire song

    public native void muteTrack(int track);
    public native void unmuteTrack(int track);
    public native void soloTrack(int track);
    public native void unSoloTrack(int track);

    // in microseconds $$kk: really??  in midi ticks, i think...
    public native void setTickPosition(int ticks) throws HaeException;    

    // in microseconds
    public native void setMicrosecondPosition(int microseconds) throws HaeException;    

// PUBLIC DATA:
    public boolean isDone() { 
        return(!isPlaying()); 
    }

    public native boolean isPlaying();
    public native boolean isPaused();

    public native byte[]  getTrackMuteStatus();         // returns 64 bytes
    public native byte[]  getSoloTrackStatus();         // returns 64 bytes
    public native int     getTickLength();              // in microseconds $$kk: really??
    public native int     getMicrosecondLength();       // in microseconds
    public native int     getTickPosition();            // current song position, 
														// in microseconds.
//  public native String  getInfoTitle()          throws HaeException;
//  public native String  getInfoPerformer()      throws HaeException;
//  public native String  getInfoComposer()       throws HaeException;
//  public native String  getInfoCopyright()      throws HaeException;
//  public native String  getInfoPublisher()      throws HaeException;
//  public native String  getInfoLicenseUse()     throws HaeException;
//  public native String  getInfoLicenseTerm()    throws HaeException;
//  public native String  getInfoLicensedTo()     throws HaeException;
//  public native String  getInfoExpirationDate() throws HaeException;
//  public native String  getInfoComposerNotes()  throws HaeException;
//  public native String  getInfoIndexNumber()    throws HaeException;

// PROTECTED DATA:
    protected int m_stringData;
}
