/*
 * @(#)HaeMixerFrame.java	1.7 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * HaeMixerFrame:
 * Contains waveform data copied from the output stream of an HaeMixer.
 * Used with calls to HaeMixer.GetFrame(). 
 */

class HaeMixerFrame {
// PUBLIC CONSTRUCTION:
    public HaeMixerFrame() {
        m_leftBuffer = new short[1024];
        m_rightBuffer = new short[1024];
        m_validLength = 0;
    }

// PUBLIC DATA:
    public short[]  leftBuffer()        { return m_leftBuffer; }
    public short[]  rightBuffer()       { return m_rightBuffer; }
    public int      validBufferLength() { return m_validLength; }

// PRIVATE DATA:
    protected short m_leftBuffer[];
    protected short m_rightBuffer[];
    protected int   m_validLength;
};
