/*
 * @(#)HaeMixerInfo.java	1.7 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * HaeMixerInfo:
 * Contains data on the current state of an HaeMixer.
 * Used with calls to HaeMixer.GetInfo().
 */

class HaeMixerInfo {
// PUBLIC CONSTRUCTION:
    public HaeMixerInfo() {
        m_internalIndex = new short[HaeMixer.MAX_VOICES];
        m_instrument    = new short[HaeMixer.MAX_VOICES];
        m_midiVolume    = new short[HaeMixer.MAX_VOICES];
        m_scaledVolume  = new short[HaeMixer.MAX_VOICES];
        m_channel       = new short[HaeMixer.MAX_VOICES];
        m_midiNote      = new short[HaeMixer.MAX_VOICES];
    }

// PUBLIC DATA:
    public int GetActiveVoiceCount()        // number of voices active
        { return m_activeVoiceCount; }
    public short GetInternalIndex(int voice)   // index of voice in internal table
        { return m_internalIndex[voice]; }
    public short GetInstrument(int voice)      // current instruments
        { return m_instrument[voice]; }
    public short GetMidiVolume(int voice)      // current volumes
        { return m_midiVolume[voice]; }
    public short GetScaledVolume(int voice)    // current scaled volumes
        { return m_scaledVolume[voice]; }
    public short GetChannel(int voice)         // current channel
        { return m_channel[voice]; }
    public short GetMidiNote(int voice)        // current midi note
        { return m_midiNote[voice]; }

// PRIVATE DATA:
    protected int   m_activeVoiceCount;  // number of voices active
    protected short m_internalIndex[];   // index of voice in internal table
    protected short m_instrument[];      // current instruments
    protected short m_midiVolume[];      // current volumes
    protected short m_scaledVolume[];    // current scaled volumes
    protected short m_channel[];         // current channel
    protected short m_midiNote[];        // current midi note
}
