/*
 * @(#)HaeNoise.java	1.7 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * HaeNoise:
 * The root class for any class that encapsulates a sound made by HAE.
 * Cannot be instantiated directly.  Make a subclass or use HaeMidiPlayer, 
 * HaeMidiSong, HaeRmfSong, HaeWaveMemory, or HaeWaveStream.
 */

abstract class HaeNoise {
// PUBLIC OPERATIONS:
    public abstract void close();    // stops and frees resources

    public abstract void setVolume(double volume);

// PUBLIC DATA:
    public HaeMixer getMixer() { 
        return m_mixer; 
    }

    public abstract double getVolume();

// PROTECTED CONSTRUCTION:
    protected HaeNoise(HaeMixer mixer) {
        m_mixer = mixer;
    }

    protected void finalize() throws Throwable {
        close();
        super.finalize();
    }

// PRIVATE DATA:
    private HaeMixer m_mixer;
}
