/*
 * @(#)HaePlayable.java	1.7 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * HaePlayable:
 * Defines the operations that can be done on an Hae... object that can be 
 * "played", such as:
 *     HaeWaveFile
 *     HaeWaveMemory
 *     HaeWaveStream
 *     HaeMidiSong
 *     HaeRmfSong
 */

interface HaePlayable {
// PUBLIC OPERATIONS:
    public void play()    // start, don't return until finished
                  throws HaeException;
    public void start()    // start, return right away
                  throws HaeException;
    public void stop(boolean withFade);
    public void pause();
    public void resume();

// PUBLIC DATA:
    public boolean isPlaying();
    public boolean isPaused();
}
