/*
 * @(#)HaeWaveDirect.java	1.7 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * HaeWaveDirect{}
 * Plays a sound whose waveform data is in memory or in a file,
 * in a non-streaming fashion.
 */

class HaeWaveDirect extends HaeWaveNoise {
// PUBLIC CONSTRUCTION:
    public HaeWaveDirect(HaeMixer mixer) {
        super(mixer);
        m_gmWaveform = 0;
    }

// PUBLIC OPERATIONS:
    public native void close();

	// $$kk: 01.14.98: added numLoops param
    public native void setLoop(int startFrame,   // zero not allowed
                               int endFrame,	 // one past last frame in loop
							   int numLoops		 // number of loops before continuing to end of sample; <=0 for continuous looping
							   );    
    public void        setNoLoop()
        { setLoop(0, 0, 0); }
    public native void stop(boolean withFade);

    public native void setVolume(double volume);
    public native void setPan(double position);// left=-1.0;center=0.0;right=1.0

// PUBLIC DATA:
    public native boolean isPlaying();

    public native double  getVolume();
    public native double  getPan(); // left=-1.0;center=0.0;right=1.0

// PROTECTED OPERATIONS:
	// $$kk: 01.14.98: added offset param
    protected native void privateStart(double volume,    // 1.0 is normal
                                       double pan, // left=-1.0;center=0.0;right=1.0
                                      boolean reverb,
									  long offset);
    protected native void privateSetSampleRate(double sampleRate);
    protected native void privateSetReverb(boolean useReverb);

// PRIVATE DATA:
    private int m_gmWaveform;    // used as pointer in C code
}
