/*
 * @(#)HaeWaveFile.java	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * HaeWaveFile{}
 * Plays a sound whose waveform data is in a file.
 */

class HaeWaveFile extends HaeWaveDirect {
// PUBLIC CONSTRUCTION:
    public HaeWaveFile(HaeMixer mixer) {
        super(mixer);
    }

// PUBLIC OPERATIONS:
    public native void openAIFF(String path) throws HaeException;
    public native void openWAV(String path)  throws HaeException;
    public native void openAU(String path)   throws HaeException;

// PUBLIC TEST PROGRAM:

    public static void main(String args[])
    {
	String			patchesPath;
	HaeMixer		mixer;
	int				arg;

		if (args.length < 2)
		{
		    System.err.println("Usage: HaeWaveFile <patch file> <wave files>");
		    return;
		}
		patchesPath = args[0];
		System.out.println("Creating mixer using \"" + patchesPath + "\"...");
		try
		{
		    mixer = new HaeMixer(patchesPath);
		}
		catch (HaeException e)
		{
		    System.err.println("Couldn't create a mixer using \"" + patchesPath + "\" : " + e);
		    return;
		}

		arg = 0;
		while (++arg < args.length)
		{
		String			wavePath = args[arg];
		HaeWaveFile		wave;

			System.out.println("Playing wave \"" + wavePath + "\"...");
			wave = null;
			try
			{
				wave = new HaeWaveFile(mixer);
				if (wavePath.endsWith(".au"))
				{
					wave.openAU(wavePath);
				}
				else if (wavePath.endsWith(".wav"))
				{
					wave.openWAV(wavePath);
				}
				else
				{
					wave.openAIFF(wavePath);
				}
			    wave.play();
			}
			catch (HaeException e)
			{
				System.err.println("Couldn't play the wave file, \"" + wavePath + "\" : " + e);
			}
			finally
			{
				if (wave != null)
				{
					wave.close();
				}
			}
		}
		mixer.close();
    }

// PROTECTED OPERATIONS:

// PRIVATE OPERATIONS:

// PRIVATE DATA:    
}
