/*
 * @(#)HaeWaveMemory.java	1.7 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * HaeWaveMemory{}
 * Plays a sound whose waveform data is in memory.
 */

class HaeWaveMemory extends HaeWaveDirect {
// PUBLIC CONSTRUCTION:
    public HaeWaveMemory(HaeMixer mixer) {
        super(mixer);
    }

    public HaeWaveMemory(HaeMixer mixer,
                         byte[] wavedata,
                         int wavedataLength,    // in frames
                         int bitsPerSample,     // bits per sample 8 or 16
                         int channelsPerFrame,  // mono or stereo 1 or 2
                         double sampleRate) {
        super(mixer);
        open(wavedata, wavedataLength, bitsPerSample, 
		     channelsPerFrame, sampleRate);
    }

// PUBLIC OPERATIONS:
    public void open(byte[] wavedata,
                     int wavedataLength,    // in frames
                     int bitsPerSample,     // bits per sample 8 or 16
                     int channelsPerFrame,  // mono or stereo 1 or 2
                     double sampleRate) {
        close();
        setSampleInfo(sampleRate, bitsPerSample, channelsPerFrame);
        nativeOpen(wavedata, wavedataLength,
                   sampleRate, bitsPerSample, channelsPerFrame,
                   getBytesPerFrame());
    }

// PRIVATE OPERATIONS:
    private native void nativeOpen(byte[] wavedata, int wavedataLength,
                                   double sampleRate,
                                   int bitsPerSample, int channelsPerFrame,
                                   int bytesPerFrame);
}
