/*
 * @(#)AWTFinalizer.java	1.6 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt;

import sun.awt.AWTFinalizeable;

public class AWTFinalizer extends Thread {
    static AWTFinalizer theFinalizer;
    static AWTFinalizeable theFinalQueue;

    static {
	java.security.AccessController.doPrivileged(
	    new java.security.PrivilegedAction() {
	    public Object run() {
		theFinalizer = new AWTFinalizer();
		return null;
	    }
	});
	theFinalizer.start();
    }

    private AWTFinalizer() {
	super("AWT-Finalizer");
	setPriority(MAX_PRIORITY - 1);
	setDaemon(true);
    }

    public void run() {
	while (true) {
	    AWTFinalizeable q;
	    synchronized (this) {
		while ((q = theFinalQueue) == null) {
		    try {
			wait();
		    } catch (InterruptedException e) {
		    }
		}
		theFinalQueue = null;
	    }
	    while (q != null) {
		q.doFinalization();
		q = q.getNextFinalizeable();
	    }
	}
    }

    public static void addFinalizeable(AWTFinalizeable o) {
	synchronized (theFinalizer) {
	    o.setNextFinalizeable(theFinalQueue);
	    theFinalQueue = o;
	    theFinalizer.notify();
	}
    }
}
