/*
 * @(#)TAreaDiscretiser.java	1.4 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

class TAreaDiscretiser extends TNurbDiscretiser {
    private TOutlineMakerVertexEngine fVertexEngine;
    private TCAGUnary fNode;

    TAreaDiscretiser(
        TOutlineMakerVertexEngine outputVertexEngine,
        TCAGUnary node,
        TGRect clipBounds,
        double resolution)
    {
        super(clipBounds, resolution);
        fVertexEngine = outputVertexEngine;
        fNode = node;
    }

    void begin(boolean closed) {
        fVertexEngine.SetCAGNode(fNode);
        //fVertexEngine.SetClosed(true);     // true for closed areas
    }
    void endPath() {
        fVertexEngine.End();
    }
    void addPoint(TGPoint vertex) {
        fVertexEngine.AddVertex(vertex);
    }
    void DiscretizeLoop(
        int order,
        TGParametricArray knotsVector,
        TGRPointArray controlPoints,
        boolean closed)
    {
        if (order > 2)
            super.DiscretizeNurb(order, knotsVector, controlPoints, true);
        else
            super.DiscretizeOrderTwo(knotsVector, controlPoints, true);
    }
}
