/*
 * @(#)TArrayOfEdgeTransition.java	1.4 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

class TArrayOfEdgeTransition extends TRawPrimitiveArray {

    private TEdgeTransition[] fValues = null;

    public TArrayOfEdgeTransition() {
        super(0);
    }

    // access protocol...
    public TEdgeTransition getValue(int i) {
        if (i < 0 || i >= fNumberOfValues)
            throw new IndexOutOfBoundsException("RawArray.value(index)");

        return fValues[i];
    }
    public void append(TEdgeTransition p) {
        int numValues = fNumberOfValues;
        resize(numValues + 1); // This changes fNumberOfValues!
        fValues[numValues] = p;
    }
    public TEdgeTransition[] getArray() {
        return fValues;
    }

    void allocateArray(int size) {
        fValues = null;
        if (size > 0)
            fValues = new TEdgeTransition[size];
    }
    void reallocateArray(int newSize) {
        TEdgeTransition oldValues[] = fValues;
        allocateArray(newSize);
        if (newSize > 0)
            System.arraycopy(
                oldValues, 0,
                fValues, 0,
                fArraySize > newSize ? newSize : fArraySize);
    }
}
