/*
 * @(#)TArrayOfPolyYEvent.java	1.4 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

class TArrayOfPolyYEvent extends TRawArray {

    private TPolyYEvent[] fValues = null;

    public TArrayOfPolyYEvent() {
        this(0);
    }
    public TArrayOfPolyYEvent(int size) {
        super(size);
        if (fArraySize > 0) {
            allocateArray(fArraySize);
            newAllocation(0, fArraySize);
        }
    }

    // access protocol...
    public TPolyYEvent getValue(int i) {
        if (i < 0 || i >= fNumberOfValues)
            throw new IndexOutOfBoundsException("RawArray.value(index)");

        return fValues[i];
    }
    public void append(TPolyYEvent p) {
        int numValues = fNumberOfValues;
        resize(numValues + 1); // This changes fNumberOfValues!
        fValues[numValues].copyFrom(p);
    }
    public TPolyYEvent[] getArray() {
        return fValues;
    }

    void allocateArray(int size) {
        fValues = null;
        if (size > 0)
            fValues = new TPolyYEvent[size];
    }
    void reallocateArray(int newSize) {
        TPolyYEvent oldValues[] = fValues;
        allocateArray(newSize);
        if (newSize > 0)
            System.arraycopy(
                oldValues, 0,
                fValues, 0,
                fArraySize > newSize ? newSize : fArraySize);
    }
    void newAllocation(int beginIndex, int count) {
        int end = beginIndex + count;
        for (int i = beginIndex; i < end; ++i)
            fValues[i] = new TPolyYEvent();
    }
}
