/*
 * @(#)TCAGNode.java	1.4 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

// Base class for cAG nodes

abstract class TCAGNode {
    
    // The transition functions for fill & frames
    public abstract void transition(int fill);
    public abstract void transitionLeftFrame(int leftFrame);
    public abstract void transitionRightFrame(int rightFrame);

    // transition type:  fill, left frame, or right frame
    /* enum TransitionType */
    public static final int kFill = 0;
    public static final int kLeftFrame = 1;
    public static final int kRightFrame = 2;
    public int getTransitionType() { // returns TransitionType; defaults to kFill
        return kFill;   // default type is kFill
    }
    
    // cAG node type(for well known cases)
    /* enum CAGType */
    public static final int kUndefined = 0;
    public static final int kEvenOdd = 1;
    public static final int kWindNum = 2;
    public int getType() {  // returns CAGType; defaults to kUndefined
        return kUndefined;
    }

    static int Sign(int x) {  // returns -1, 0, or 1
        if (x > 0)
            return 1;
        else if (x == 0)
            return 0;
        else
            return -1;
    }
}
