/*
 * @(#)TCAGUnary.java	1.4 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

// Base class for cAG nodes that have a single value controlled by a single source
abstract class TCAGUnary extends TCAGNode {

    public abstract void transition(int fill);
    public abstract void transitionLeftFrame(int leftFrame);
    public abstract void transitionRightFrame(int rightFrame);

    public final TCAGLeftFrameLink getLeftFrameLink() {   // link to the left frame transition function
        if (fLeftFrameLink == null)
            fLeftFrameLink = new TCAGLeftFrameLink(this);
        return fLeftFrameLink;
    }
    public final TCAGRightFrameLink getRightFrameLink() {  // link to the right frame transition function
        if (fRightFrameLink == null)
            fRightFrameLink = new TCAGRightFrameLink(this);
        return fRightFrameLink;
    }

    protected TCAGUnary(TCAGNode parent) {
        fParent = parent;
        fLeftFrameLink = null;
        fRightFrameLink = null;
    }

    protected TCAGNode getParent() {
        return fParent;
    }

    private TCAGLeftFrameLink fLeftFrameLink;
    private TCAGRightFrameLink fRightFrameLink;

    // The parent cAG object
    private TCAGNode fParent;
}
