/*
 * @(#)TConicInfo.java	1.5 98/07/06
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;


// internal class to implement conic acceleration support...
class TConicInfo {

/*
    TConicInfo(int kind) {
        this(kind, new TGRect(0.,0.,0.,0.), false); // Look at TGStatics.java
    }
*/
    TConicInfo(int kind, TGRect arcBounds, boolean direction) {
        fIsArc = kind;                     // bbb
        fArcBounds = (TGRect)arcBounds.clone();
        fDirection = direction;
    }
    TConicInfo(TConicInfo src) {
        copyFrom(src);
    }
    TConicInfo copyFrom(TConicInfo src) {
        fIsArc = src.fIsArc;                      // bbb
        fArcBounds = (TGRect)src.fArcBounds.clone();
        fDirection = src.fDirection;
        return this;
    }
    boolean equals(TConicInfo src) {
        return
            fIsArc == src.fIsArc &&
            fArcBounds.equals(src.fArcBounds) &&
            fDirection == src.fDirection;
    }
    boolean transformBy(TGrafMatrix mat) {
        if (!mat.isIdentity()) {
            if (mat.isRectilinear()) {
                fArcBounds = mat.transformBounds(fArcBounds);
                double sx = mat.getElement(AffineTransform.ELEMENT_SCALE_X);
                double sy = mat.getElement(AffineTransform.ELEMENT_SCALE_Y);
                if ((sx > 0. && sy < 0.) || (sx < 0. && sy > 0.)) // sign differs
                    fDirection = !fDirection;   // flip the direction
            }
            else
                return false;
        }
        return true;
    }
    double /*GDegrees*/ calculatePointAngle(TGPoint point) {
        // reverse subtraction components to avoid extra allocation of TGPoint
        TGPoint temp = fArcBounds.getCenter().subtractBy(point);
        // reverse the subtraction above.
        return temp.vectorAngle() - 180.;
    }


    static final int arc_t = 1;
    static final int ellipse_t = 2;
    // static final int pie_t = 3;         // pie is arc in Java ??

    int fIsArc;
    TGRect fArcBounds;
    boolean fDirection;
}
