/*
 * @(#)TPolyYEvent.java	1.4 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

class TPolyYEvent {
    TPolyYEvent() {}
    TPolyYEvent(TPolyEdge edge0, TPolyEdge edge1, TGPoint point) {
        Set(edge0, edge1, point);
    }

    public String toString() {
        return (
            "(fPoint" + fPoint + ") {\n" +
            " fEdge0: " + fEdge0 + "\n" +
            " fEdge1: " + fEdge1 + "}\n");
    }

    void Set(TPolyEdge edge0, TPolyEdge edge1, TGPoint point) {
        fEdge0 = edge0;
        fEdge1 = edge1;
        fPoint.copyFrom(point);
    }

    // For sorting
    final boolean IsLessThan(TPolyYEvent other) {
        if (fPoint.y < other.fPoint.y)
            return true;
        else if (fPoint.y == other.fPoint.y)
            return (fPoint.x < other.fPoint.x);
        return false;
    }
    final void copyFrom(TPolyYEvent that) {
        if (this != that) {
            fEdge0 = that.fEdge0;
            fEdge1 = that.fEdge1;
            fPoint.copyFrom(that.fPoint);
        }
    }
    TPolyEdge fEdge0 = null;        // the two edges that intersect
    TPolyEdge fEdge1 = null;
    TGPoint fPoint = new TGPoint();            // point of intersection
}
