/*
 * @(#)TPolyYEventQSort.java	1.6 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * (C) Copyright Taligent, Inc. 1996 - 1997, All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998, All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by Taligent, Inc., a wholly-owned subsidiary
 * of IBM. These materials are provided under terms of a License
 * Agreement between Taligent and Sun. This technology is protected
 * by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.awt.Albert;

import java.util.Arrays;
import java.util.Comparator;

/*
 * This class was effectively obsoleted by methods on the Arrays class
 * to sort an array of Objects using a Comparator.  It remains in order
 * to provide a class to implement the specific Comparator needed to
 * sort the Y Event objects.
 * REMIND:  The Arrays.sort() methods that sort objects perform a
 * merge sort rather than a quick sort since merge sort is stable.
 * The performance is identical for all practical purposes, but the
 * fact that this class now relies on the method in Arrays to perform
 * its work means that this class now possesses a misleading name.
 */
final class TPolyYEventQSort implements Comparator {
    private static TPolyYEventQSort theComparator = new TPolyYEventQSort();

    private TPolyYEventQSort() {
    }

    public int compare(Object o1, Object o2) {
	TGPoint fPoint1 = ((TPolyYEvent)o1).fPoint;
	TGPoint fPoint2 = ((TPolyYEvent)o2).fPoint;
        if (fPoint1.y < fPoint2.y) {
            return -1;
	}
        if (fPoint1.y > fPoint2.y) {
            return 1;
	}
	if (fPoint1.x < fPoint2.x) {
	    return -1;
	}
	if (fPoint1.x > fPoint2.x) {
	    return 1;
	}
        return 0;
    }

    static void SortYEvents(TPolyYEvent[] yEvents, int numYEvents) {
	Arrays.sort(yEvents, 0, numYEvents, theComparator);
    }
}
