/*
 * @(#)CharsetString.java	1.8 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt;

public class CharsetString {

    static {
        NativeLibLoader.loadLibraries();
        initIDs();
    }

    /**
     * chars for this string.  See also offset, length.
     */
    public char[] charsetChars;

    /**
     * Offset within charsetChars of first character
    **/
    public int offset;
    
    /**
     * Length of the string we represent.
    **/
    public int length;

    /**
     * This string's FontDescriptor.
     */
    public FontDescriptor fontDescriptor;

    /**
     * Creates a new CharsetString
     */
    public CharsetString(char charsetChars[], int offset, int length,
			 FontDescriptor fontDescriptor){

	this.charsetChars = charsetChars;
	this.offset = offset;
	this.length = length;
	this.fontDescriptor = fontDescriptor;
    }

    /**
     * Initialize JNI field and method IDs
     */
    private static native void initIDs();
}
