/*
 * @(#)FontDescriptor.java	1.10 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt;

import sun.io.CharToByteConverter;

public class FontDescriptor implements Cloneable {

    static {
        NativeLibLoader.loadLibraries();
        initIDs();
    }

    String nativeName;
    public CharToByteConverter fontCharset;
    int[] exclusionRanges;

    public FontDescriptor(String nativeName, CharToByteConverter fontCharset,
			  int[] exclusionRanges){

	this.nativeName = nativeName;
	this.fontCharset = fontCharset;
	this.exclusionRanges = exclusionRanges;
    }

    /**
     * Return true if the character is exclusion character.
     */
    public boolean isExcluded(char ch){
	for (int i = 0; i < exclusionRanges.length; i++){

	    int lo = (exclusionRanges[i] >> 16) & 0xffff;
	    int up = (exclusionRanges[i]) & 0xffff ;

	    if (ch >= lo && ch <= up){
		return true;
	    }
	}
	return false;
    }

    public String toString() {
	return super.toString() + " [" + nativeName + "|" + fontCharset + "]";
    }

    /**
     * Initialize JNI field and method IDs
     */
    private static native void initIDs();
}
