/*
 * @(#)PhysicalDrawingSurface.java	1.4 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt;

/**
 * The PhysicalDrawingSurface interface provides a common interface
 * which can be implemented by all of the objects which provide
 * implementation-specific information about the physical surface
 * upon which a DrawingSurface resides.  There are no common methods
 * for all of these objects to implement, thus this interface is
 * empty.  This interface merely exists to provide a common root type
 * for all of the possible objects that can be returned from the
 * DrawingSurfaceInfo.getSurface() method under different implementations.
 * The caller must be able to recognize the specific type of the
 * PhysicalDrawingSurface object in order to render directly to
 * that surface.  Many of the physical handles will be usable only
 * by native code which accesses platform-specific drawing interfaces.
 *
 * @version 	1.4, 09/21/98
 * @author 	Jim Graham
 */
public interface PhysicalDrawingSurface {
}
