/*
 * @(#)Segment.java	1.3 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)Segment.java	1.3 98/09/21
 *
 * (C) Copyright IBM Corp. 1998 - All Rights Reserved
 */

package sun.awt.font;

public class Segment {
  public char[] text;
  public int start;
  public int length;
  public boolean textIsMutable; // true if clients may write into text array

  public Segment() {
  }

  public Segment(char[] text) {
    set(text, 0, text.length, true);
  }
  
  public Segment(char[] text, boolean textIsMutable) {
    set(text, 0, text.length, textIsMutable);
  }

  public Segment(char[] text, int start, int length) {
    set(text, start, length, true);
  }

  public void set(char[] text, int start, int length, boolean textIsMutable) {
    this.text = text;
    this.start = start;
    this.length = length;
    this.textIsMutable = textIsMutable;
  }

  public Segment(Segment rhs) {
    this.text = rhs.text;
    this.start = rhs.start;
    this.length = rhs.length;
    this.textIsMutable = rhs.textIsMutable;
  }

  public String toString() {
    StringBuffer buf = new StringBuffer(super.toString());
    buf.append("[text:");
    if (text == null) {
      buf.append(text);
    } else {
      buf.append("\"");
      for (int i = start, e = start + length; i < e; i++) {
	if (i > start) {
	  buf.append(" ");
	}
	buf.append(Integer.toHexString(text[i]));
      }
      buf.append("\"");
    }
    buf.append(", start:");
    buf.append(start);
    buf.append(", length:");
    buf.append(length);
    buf.append(", textIsMutable:");
    buf.append(textIsMutable);
    buf.append("]");

    return buf.toString();
  }
}
