/*
 * @(#)ByteArrayImageSource.java	1.5 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.image;

import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.BufferedInputStream;

public class ByteArrayImageSource extends InputStreamImageSource {
    byte[] imagedata;
    int imageoffset;
    int imagelength;

    public ByteArrayImageSource(byte[] data) {
	this(data, 0, data.length);
    }

    public ByteArrayImageSource(byte[] data, int offset, int length) {
	imagedata = data;
	imageoffset = offset;
	imagelength = length;
    }

    final boolean checkSecurity(Object context, boolean quiet) {
	// No need to check security.  Applets and downloaded code can
	// only make byte array image once they already have a handle
	// on the image data anyway...
	return true;
    }

    protected ImageDecoder getDecoder() {
	InputStream is =
	    new BufferedInputStream(new ByteArrayInputStream(imagedata,
							     imageoffset,
							     imagelength));
	return getDecoder(is);
    }
}
