/*
 * @(#)BoolEditor.java	1.18 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.beans.editors;

/**
 * Property editor for a java builtin "boolean" type.
 */

import java.beans.*;

public class BoolEditor extends PropertyEditorSupport {


    public String getJavaInitializationString() {
	// This must return locale independnet Java.
	if (((Boolean)getValue()).booleanValue()) {
	    return ("true");
	} else {
	    return ("false");
	}
    }

    public String getAsText() {
	// Should localize this.
	if (((Boolean)getValue()).booleanValue()) {
	    return ("True");
	} else {
	    return ("False");
	}
    }

    public void setAsText(String text) throws java.lang.IllegalArgumentException {
	if (text.toLowerCase().equals("true")) {
	    setValue(Boolean.TRUE);
	} else if (text.toLowerCase().equals("false")) {
	    setValue(Boolean.FALSE);
	} else {
	    throw new java.lang.IllegalArgumentException(text);
	}
    }

    public String[] getTags() {
	String result[] = { "True", "False" };
	return result;
    }

}

