/*
 * @(#)FastPathProducer.java	1.3 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @(#)FastPathProducer.java 3.1 97/11/17
 *
 * ---------------------------------------------------------------------
 *	Copyright (c) 1992-1997 by Ductus, Inc. All Rights Reserved.
 * ---------------------------------------------------------------------
 *
 */

package sun.dc.path;

/**
 * This interface should be supported by path sources capable of
 * producing the path's description on demand, multiple times and
 * fast.
 * @see dc.path.PathConsumer
 */
public interface FastPathProducer {

    /**
     * Returns the path's bounding box.
     * @param box
     *  a 4 element array where the coordinates defining the bounding box
     *  are returned
     * @exception PathError
     *  if invoked with an invalid argument - <tt>null</tt> or too short
     */
    public void getBox(float[] box)	throws PathError;

    /**
     * Describes the path for a path consumer.
     * @param pc
     *  the receiving consumer
     * @exception PathError
     *  if invoked with a <tt>null</tt> parameter
     * @exception PathException
     *  if <tt>pc</tt> throws it
     */
    public void sendTo(PathConsumer pc)	throws PathError, PathException;
}
