/*
 * @(#)ByteToCharDefault.java	1.1 98/06/24
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.io;

import java.io.*;

class ByteToCharDefault extends ByteToCharConverter {

    public String getCharacterEncoding() {
	return "ASCII7";
    }

    public int convert(byte[] input, int inStart, int inEnd,
		       char[] output, int outStart, int outEnd)
	throws ConversionBufferFullException
    {
	int j = outStart;
	for (int i = inStart; i < inEnd; i++, j++) {
	    if (j >= outEnd) {
		byteOff = i;
		charOff = j;
		throw new ConversionBufferFullException();
	    }
	    output[j] = (char) (input[i] & 0x7f);
	}
	byteOff = inEnd;
	charOff = j;
	return j - outStart;
    }

    public int flush(char[] output, int outStart, int outEnd) {
	return 0;
    }

    public void reset() { }

}
