/*
 * @(#)CharToByteDefault.java	1.1 98/08/13
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.io;

import java.io.*;

class CharToByteDefault extends CharToByteConverter {

    public String getCharacterEncoding () {
	return "ASCII7";
    }

    public int convert(char[] input, int inStart, int inEnd,
		       byte[] output, int outStart, int outEnd)
	throws ConversionBufferFullException
    {
	int j = outStart;
	int i = inStart;
	for (; i < inEnd; i++, j++) {
	    if (j >= outEnd)
		throw new ConversionBufferFullException();
	    output[j] = (byte) (input[i] & 0x7f);
	}
	charOff = i;
	byteOff = j;
	return j - outStart;
    }

    public int flush(byte[] output, int outStart, int outEnd) {
	return 0;
    }

    public void reset() { }

    public int getMaxBytesPerChar() {
	return 1;
    }

}
