/*
 * @(#)ColorPaint.java	1.8 98/07/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;
import java.awt.Color;

/**
*   ColorPaint
*   1) blend filled solid color onto destination surface
*   2) must accept [dx, dy]
*      from within the surface description data
*/

public abstract class ColorPaint extends GraphicsPrimitive
{
    private final static String methodSignature =
        "ColorPaint(Lsun/java2d/loops/ImageData;I[BIIFLjava/awt/Color;)V";
                
    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {LOCK_FOR_READ | LOCK_FOR_WRITE};

    protected ColorPaint(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }

    /**
    *   All ColorPaint implementors must have this invoker method
    */
    public abstract void ColorPaint(
        ImageData dstImage,

        int nRule,

        byte [] bAlphaArray, int nAlphaArrayOffset, int nAlphaArraySize,
        float fExtraAlpha,
        Color fgColor
    );
}
