/*
 * @(#)FillPolygons.java	1.8 98/07/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;
import java.awt.Color;
import java.awt.image.ColorModel;
import java.awt.image.Raster;
import sun.java2d.loops.FillPolygonsRasterContext;

/**
*   FillPolygons
*   1) draw solid color polygons onto destination surface
*   2) must accept output area [x, y, dx, dy]
*      from within the surface description data for clip rect
*/

public abstract class FillPolygons extends GraphicsPrimitive
{
    private final static String methodSignature =
        "FillPolygons(Lsun/java2d/loops/ImageData;Ljava/awt/Color;[I[I[IIZ)V";
                
    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {LOCK_FOR_WRITE};

    protected FillPolygons(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }


    /**
    *   All FillPolygon implementors must have this invoker method
    */
    public abstract void FillPolygons(
        ImageData dstImage,
        Color color,
        int xPoints[], int yPoints[], int nPoints[],
        int numPolys, boolean evenOdd
    );

    /*
    *   create cached context for raster drawing
    */
    public FillPolygonsRasterContext createCachedContext(
            Raster raster, ColorModel cm, Color color,
            int clipX, int clipY, int clipW, int clipH) {
        return null;
    }
}
