/*
 * @(#)FillSpans.java	1.2 98/07/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 *
 */

 /*
 * @author Jim Graham
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.pipe.SpanIterator;
import java.awt.Color;
import java.awt.image.ColorModel;
import java.awt.image.Raster;

/**
 * FillSpans
 * 1) draw solid color onto destination surface
 * 2) rectangular areas to fill come from SpanIterator
 */

public abstract class FillSpans extends GraphicsPrimitive
{
    private final static String methodSignature =
        "FillSpans(Lsun/java2d/loops/ImageData;"+
		 "Ljava/awt/Color;"+
		 "Lsun/java2d/pipe/SpanIterator;)V";

    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {LOCK_FOR_WRITE};

    protected FillSpans(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }


    /**
     * All FillSpan implementors must have this invoker method
     */
    public abstract void FillSpans(
        ImageData dstImage,
        Color color,
	SpanIterator sr
    );

    /*
     * create cached context for raster drawing
     */
     /*
    public FillSpanRasterContext createCachedContext(
            Raster raster, ColorModel cm, Color color,
            int clipX, int clipY, int clipW, int clipH) {
        return null;
    }
    */
}
