/*
 * @(#)SimpleRenderPipe.java	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.java2d.pipe;

import sun.java2d.SunGraphics2D;

/**
 * This interface defines the methods used for simple non-antialiased
 * rendering.
 * The set of methods described by the PixelDrawPipe and the ShapeDrawPipe
 * can be converted down into these primitives using a PixelToPolyConverter
 * object.
 */
public interface SimpleRenderPipe {
    public void drawLine(SunGraphics2D sg,
			 int x1, int y1, int x2, int y2);

    public void fillRect(SunGraphics2D sg,
			 int x, int y, int width, int height);

    public void drawPolys(SunGraphics2D sg,
			  int[] xPoints, int[] yPoints, int nPoints[],
			  int numpolys, boolean close);

    public void fillPolys(SunGraphics2D sg,
			  int[] xPoints, int[] yPoints, int nPoints[],
			  int numpolys, boolean evenodd);

    public void fillSpans(SunGraphics2D sg,
			  SpanIterator si);
}
