/*
 * @(#)TextPipe.java	1.5 98/08/10
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.pipe;

import sun.java2d.SunGraphics2D;
import java.awt.font.GlyphVector;
import java.awt.font.TextLayout;

/**
 * This interface defines the set of calls that pipeline objects
 * can use to pass on responsibility for drawing various text
 * representations.
 */
public interface TextPipe {
    public Object drawString(SunGraphics2D g2d, String s,
                                float x, float y, Object cachedState);
    public Object drawGlyphVector(SunGraphics2D g2d, GlyphVector g,
                                float x, float y, Object cachedState);
    public Object drawChars(SunGraphics2D g2d,
                                char data[], int offset, int length,
                                int x, int y, Object cachedState);
    public Object drawBytes(SunGraphics2D g2d,
                                byte data[], int offset, int length,
                                int x, int y, Object cachedState);
};
