/*
 * @(#)JdbcOdbcDriverInterface.java	1.15 98/04/28
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
//----------------------------------------------------------------------------
//
// Module:      JdbcOdbcDriverInterface.java
//
// Description: Definition of the JdbcOdbcDriver interface.  This is
//              necessary to 'forward define' the class to eliminate
//              circular dependencies
//
// Product:     JDBCODBC (Java DataBase Connectivity using
//              Open DataBase Connectivity)
//
// Author:      Karl Moss
//
// Date:        May, 1996
//
// Copyright:   1990-1996 INTERSOLV, Inc.
//              This software contains confidential and proprietary
//              information of INTERSOLV, Inc.
//----------------------------------------------------------------------------

package sun.jdbc.odbc;

import java.sql.*;

public interface JdbcOdbcDriverInterface
	extends		java.sql.Driver
{
	//--------------------------------------------------------------------
	// allocConnection
	// Allocate a connection handle.  Once the handle is allocated, keep
	// it in our list if allocated connection handles.  This list will be
	// used to determine how many connection handles are active.  When
	// closing a connection handle (closeConnection), if the number of
	// handles is zero, the driver can be closed (i.e. the environment
	// handle can be free'ed
	//--------------------------------------------------------------------

	public int allocConnection (
		int env)
		throws SQLException;

	//--------------------------------------------------------------------
	// closeConnection
	// Close the given connection handle, and remove it from our list
	// of connection handles.  If it is the last connection handle in
	// the list, the environment can also be closed
	//--------------------------------------------------------------------

	public void closeConnection (
		int dbc)
		throws SQLException;

	//--------------------------------------------------------------------
	// disconnect
	// Close the given connection handle, disconnect
	//--------------------------------------------------------------------

	public void disconnect (
		int dbc)
		throws SQLException;

}
