/*
 * @(#)JdbcOdbcLimits.java	1.16 98/04/28
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
//----------------------------------------------------------------------------
//
// Module:      JdbcOdbcLimits.java
//
// Description: Maximum limits for various functions
//
// Product:     JDBCODBC (Java DataBase Connectivity using
//              Open DataBase Connectivity)
//
// Author:      Karl Moss
//
// Date:        March, 1996
//
// Copyright:   1990-1996 INTERSOLV, Inc.
//              This software contains confidential and proprietary
//              information of INTERSOLV, Inc.
//----------------------------------------------------------------------------

package sun.jdbc.odbc;


public class JdbcOdbcLimits {

	// Maximum column width for a single getData

	public static int MAX_GET_DATA_LENGTH = 5120;

	// Default buffer size when retrieving options/attributes/errors

	public static int DEFAULT_BUFFER_LENGTH = 300;

	// Default precision when binding parameters
	
	public static int DEFAULT_IN_PRECISION = 2000;

	// Maximum length of native SQL conversion

	public static int DEFAULT_NATIVE_SQL_LENGTH = 1024;

	// Maximum length of PutData buffer

	public static int MAX_PUT_DATA_LENGTH = 2000;

	// Maximum length of attribute strings returned by SQLBrowseConnect

	public static int MAX_BROWSE_RESULT_LENGTH = 2000;

	// Default scale for out parameters

	public static int DEFAULT_OUT_SCALE = 4;
}


