/*
 * @(#)JdbcOdbcSQLWarning.java	1.16 98/04/28
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
//----------------------------------------------------------------------------
//
// Module:      JdbcOdbcSQLWarning.java
//
// Description:	Extension of the SQLWarning class.  Typically, if a warning
//              is issued, there is valid data that needs to be returned
//              to the calling object.  Since the warning is caught as a
//              Java exception, the normal return value cannot be used.  This
//              class exetends the SQLWarning class and provides value 
//              holders in case of a warning.
//
// Product:     JDBCODBC (Java DataBase Connectivity using
//              Open DataBase Connectivity)
//
// Author:      Karl Moss
//
// Date:        March, 1996
//
// Copyright:   1990-1996 INTERSOLV, Inc.
//              This software contains confidential and proprietary
//              information of INTERSOLV, Inc.
//----------------------------------------------------------------------------

package sun.jdbc.odbc;

import java.net.URL;
import java.net.MalformedURLException;
import java.sql.*;

public class JdbcOdbcSQLWarning
	extends		SQLWarning {

	public JdbcOdbcSQLWarning (String reason, String SQLState,
			int vendorCode)
	{
		super (reason, SQLState, vendorCode);
	}

	public JdbcOdbcSQLWarning (String reason, String SQLState)
	{
		super (reason, SQLState);
	}

	public JdbcOdbcSQLWarning (String reason)
	{
		super (reason);
	}

	public JdbcOdbcSQLWarning ()
	{
		super ();
	}

	//====================================================================
	// Data attributes
	//====================================================================

	Object value;				// Generic value object
}
