/*
 * @(#)JdbcOdbcTypeInfo.java	1.15 98/04/28
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
//----------------------------------------------------------------------------
//
// Module:      JdbcOdbcTypeInfo.java
//
// Description: Class for a type info column.  This class is used a place
//              holder for information needed for each SQL type.
//
// Product:     JDBCODBC (Java DataBase Connectivity using
//              Open DataBase Connectivity)
//
// Author:      Karl Moss
//
// Date:        June, 1996
//
// Copyright:   1990-1996 INTERSOLV, Inc.
//              This software contains confidential and proprietary
//              information of INTERSOLV, Inc.
//----------------------------------------------------------------------------

package sun.jdbc.odbc;

import java.sql.*;

public class JdbcOdbcTypeInfo
	extends	JdbcOdbcObject {

	//--------------------------------------------------------------------
	// setName
	// Sets the SQL type name
	//--------------------------------------------------------------------

	public void setName (
		String name)
	{	
		typeName = name;
	}

	//--------------------------------------------------------------------
	// getName
	// Gets the SQL type name
	//--------------------------------------------------------------------

	public String getName ()
	{	
		return typeName;
	}

	//--------------------------------------------------------------------
	// setPrec
	// Sets the precision
	//--------------------------------------------------------------------

	public void setPrec (
		int prec)
	{	
		precision = prec;
	}

	//--------------------------------------------------------------------
	// getPrec
	// Gets the precision
	//--------------------------------------------------------------------

	public int getPrec ()
	{	
		return precision;
	}

	//====================================================================
	// Data attributes
	//====================================================================

	String typeName;			// SQL type name

	int precision;				// Precision
}
