/*
 * @(#)CompoundEnumeration.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.misc;

import java.util.Enumeration;
import java.util.NoSuchElementException;

/*
 * A useful utility class that will enumerate over an array of
 * enumerations.
 */
public class CompoundEnumeration implements Enumeration {
    private Enumeration[] enums;
    private int index = 0;

    public CompoundEnumeration(Enumeration[] enums) {
	this.enums = enums;
    }

    private boolean next() {
	while (index < enums.length) {
	    if (enums[index] != null && enums[index].hasMoreElements()) {
		return true;
	    }
	    index++;
	}
	return false;
    }

    public boolean hasMoreElements() {
	return next();
    }

    public Object nextElement() {
	if (!next()) {
	    throw new NoSuchElementException();
	}
	return enums[index].nextElement();
    }
}
