/*
 * @(#)NewsgroupInfo.java	1.16 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.net.nntp;

import java.io.*;
import java.util.*;

/**
 * This class manages information related to the current status of 
 * newsgroups. 
 * 
 * @version 	1.5, 12 Dec 1994
 * @author	Jonathan Payne, James Gosling
 * @see		NntpClient
 */
public class NewsgroupInfo {
    /** This newsgroup's name in network form (eg rec.pets) */
    public String   name;

    /** Number of the first and last articles in the group */
    public int	    firstArticle;
    public int	    lastArticle;

    public NewsgroupInfo(String name, int start, int end) {
	this.name = name;
	firstArticle = start;
	lastArticle = end;
    }

    /** convert the information to a printable string of the form:
     *  <p>
     *  NewsgroupInfo[name=<i>name</i>[<i>firstArticle</i>,<i>lastArticle</i>]
     */
    public String toString() {
	return "NewsgroupInfo[name=" + name + "[" + firstArticle + ", "
	    + lastArticle + "]";
    }

    /** Reload news in the group using nntp.getGroup(this.name) */
    public void reload(NntpClient nntp) throws IOException {
	NewsgroupInfo newinfo = nntp.getGroup(name);
	this.firstArticle = newinfo.firstArticle;
	this.lastArticle = newinfo.lastArticle;
    }
}
