/*
 * @(#)Win32MimeTable.java	1.10 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.net.www;

import java.io.*;
import java.net.URL;

/** OS dependent class to find mime description files.
  This is currently just a copy of the Solaris Mime table.
  It needs to be modified to work under Windows. */
class Win32MimeTable extends MimeTable {
    Win32MimeTable() {
	InputStream is = null;
	String slist[] = {
	    System.getProperty("user.mailcap"),
	    System.getProperty("user.home") + "/.mailcap",
	    "/etc/mailcap",
	    "/usr/etc/mailcap",
	    "/usr/local/etc/mailcap",
	    System.getProperty("hotjava.home", "/usr/local/hotjava") + "/lib/mailcap"
	};
	for (int i = 0; i < slist.length; i++) {
	    if (slist[i] != null) {
		try {
		    is = new FileInputStream(slist[i]);
		    break;
		} catch(Exception e) {
		}
	    }
	}
	if (is != null) {
	    ParseMailcap(is);
	    try {
		is.close();
	    } catch(IOException e) {}
	}
	add(new MimeEntry ("application/postscript", "imagetool %s; rm %s"));
	add(new MimeEntry ("application/x-dvi", "xdvi %s"));
	add(new MimeEntry ("application/x-troff", "xterm -title troff -e sh -c \"nroff %s | col | more -w ; rm %s\""));
	add(new MimeEntry ("application/x-troff-man", "xterm -title troff -e sh -c \"nroff -man %s | col | more -w ; rm %s\""));
	add(new MimeEntry ("application/x-troff-me", "xterm -title troff -e sh -c \"nroff -me %s | col | more -w ; rm %s\""));
	add(new MimeEntry ("application/x-troff-ms", "xterm -title troff -e sh -c \"nroff -ms %s | col | more -w ; rm %s\""));
	add(new MimeEntry ("video/mpeg", "mpeg_play %s; rm %s"));
	add(new MimeEntry ("application/x-tar", "loadtofile"));
	add(new MimeEntry ("application/x-gtar", "loadtofile"));
	add(new MimeEntry ("application/x-hdf", "loadtofile"));
	add(new MimeEntry ("application/x-netcdf", "loadtofile"));
	add(new MimeEntry ("application/x-shar", "loadtofile"));
	add(new MimeEntry ("application/x-sv4cpio", "loadtofile"));
	add(new MimeEntry ("application/x-sv4crc", "loadtofile"));
	add(new MimeEntry ("application/zip", "loadtofile"));
	add(new MimeEntry ("application/x-bcpio", "loadtofile"));
	add(new MimeEntry ("application/x-cpio", "loadtofile"));
	add(new MimeEntry ("application/octet-stream", "loadtofile"));
	add(new MimeEntry ("application/x-ustar", "loadtofile"));
	add(new MimeEntry ("audio/", "audiotool %s"));
	add(new MimeEntry ("image/", "xv %s; rm %s"));
    }

    String TempTemplate() {
	return "/tmp/%s.wrt";
    }
}
