/*
 * @(#)CachedFile.java	1.6 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.net.www.httpd;
import java.io.*;
import sun.net.www.MessageHeader;

/**
 * A class to represent a file in the RAM cache.
 * @author  James Gosling
 */

class CachedFile {
    private byte body[];
    public MessageHeader mh;
    CachedFile(InputStream src, int size, MessageHeader fmh) {
	body = new byte[size];
	int pos = 0;
	int pending = size;
	while (pending > 0) {
	    int nr = src.read(body, pos, size);
	    if (nr < 0)
		break;
	    pending -= nr;
	    pos += nr;
	}
	if (pending != 0) {
System.out.print("Expected "+size+", missed by "+pending+"\n");
	    throw new IOException();
	}
	mh = fmh;
    }
    void sendto(OutputStream os) {
	os.write(body, 0, body.length);
    }
    void headerto(PrintStream ps) {
	if (mh != null)
	    mh.print(ps);
    }
    int length() {
	return body.length;
    }
}

