/*
 * @(#)DocURLConnection.java	1.7 98/06/06
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)DocURLConnection.java	1.7 98/06/06
 * 
 * Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */
/*
 * 
 * @(#)DocURLConnection.java	1.7 98/06/06  
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/**
 * Open an file input stream given a doc URL.
 * @author	Sunita Mani	
 * @version     1.7, 06/06/98
 */

package sun.net.www.protocol.doc;

import java.net.URL;
import java.io.*;
import sun.net.*;
import sun.net.www.*;
import java.security.Permission;

public class DocURLConnection extends URLConnection {

    InputStream is;
    String filename;
    Permission permission;

    static String installDirectory;

    static {
	installDirectory = (String)java.security.AccessController.doPrivileged(
                new sun.security.action.GetPropertyAction("hotjava.home"));
	if (installDirectory == null) {
	    installDirectory = "/usr/local/hotjava";
	}
    }

    DocURLConnection(URL u) {
	super(u);
    }

    public void connect() throws IOException {

	String fn = installDirectory + url.getFile();
	MessageHeader props = new MessageHeader();

	MimeTable mt = MimeTable.getDefaultTable();
	MimeEntry entry = mt.findByFileName(fn);

	if (entry != null) {
	    props.add("content-type", entry.getType());
	}

	setProperties(props);

	File f = new File(fn);

	if (f.exists()) {
	    props.add("Content-length", String.valueOf(f.length()));
	}
	filename = fn.replace('/', File.separatorChar);
	is = new BufferedInputStream(new FileInputStream(filename));
		     
	connected = true;
    }

    public synchronized InputStream getInputStream()
	throws IOException
    {
	if (!connected) {
	    connect();
	}
	return is;
    }

    public Permission getPermission() throws IOException {
	if (permission == null) {
	    if (File.separatorChar == '/') {
		permission = new FilePermission(url.getFile(), "read");
	    } else {
		permission = new FilePermission(
			url.getFile().replace('/',File.separatorChar), "read");
	    }
	}
	return permission;
    }
}

