/*
 * @(#)Handler.java	1.8 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*-
 * netdoc urls point either into the local filesystem or externally
 * through an http url, with network documents being preferred.  Useful for
 * FAQs & other documents which are likely to be changing over time at the
 * central site, and where the user will want the most recent edition.
 *
 * @author Steven B. Byrne
 */

package sun.net.www.protocol.netdoc;

import java.net.URL;
import java.net.URLConnection;
import java.net.MalformedURLException;
import java.net.URLStreamHandler;
import java.io.InputStream;
import java.io.IOException;

public class Handler extends URLStreamHandler {
    static URL base;

    /*
     * Attempt to find a load the given url using the default (network)
     * documentation location.  If that fails, use the local copy
     */
    public synchronized URLConnection openConnection(URL u)
	throws IOException
    {
	URLConnection uc = null;
	URL ru;

	Boolean tmp = (Boolean) java.security.AccessController.doPrivileged(
                new sun.security.action.GetBooleanAction("newdoc.localonly"));
	boolean localonly = tmp.booleanValue();

	String docurl = (String) java.security.AccessController.doPrivileged(
                new sun.security.action.GetPropertyAction("doc.url"));

	String file = u.getFile();
	if (!localonly) {
	    try {
		if (base == null) {
		    base = new URL(docurl);
		}
		ru = new URL(base, file);
	    } catch (MalformedURLException e) {
		ru = null;
	    }
	    if (ru != null) {
		uc = ru.openConnection();
	    }
	}

	if (uc == null) {
	    try {
		ru = new URL("file", "~", file);

		uc = ru.openConnection();
		InputStream is = uc.getInputStream();	// Check for success.
	    } catch (MalformedURLException e) {
		uc = null;
	    } catch (IOException e) {
		uc = null;
	    }
	}

	if (uc == null) {
	    throw new IOException("Can't find file for URL: "
				  +u.toExternalForm());
	}
	return uc;
    }
}

