/*
 * @(#)Constants.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.rmi.rmic;

import sun.tools.java.Identifier;

public interface Constants extends sun.tools.java.Constants {

    /*
     * identifiers for RMI classes referenced by rmic
     */
    public static final Identifier idRemote =
	Identifier.lookup("java.rmi.Remote");
    public static final Identifier idRemoteException =
	Identifier.lookup("java.rmi.RemoteException");
    public static final Identifier idRemoteObject =
	Identifier.lookup("java.rmi.server.RemoteObject");
    public static final Identifier idRemoteStub =
	Identifier.lookup("java.rmi.server.RemoteStub");
    public static final Identifier idRemoteRef =
	Identifier.lookup("java.rmi.server.RemoteRef");
    public static final Identifier idOperation =
	Identifier.lookup("java.rmi.server.Operation");
    public static final Identifier idSkeleton =
	Identifier.lookup("java.rmi.server.Skeleton");
    public static final Identifier idSkeletonMismatchException =
	Identifier.lookup("java.rmi.server.SkeletonMismatchException");
    public static final Identifier idRemoteCall =
	Identifier.lookup("java.rmi.server.RemoteCall");
    public static final Identifier idMarshalException =
	Identifier.lookup("java.rmi.MarshalException");
    public static final Identifier idUnmarshalException =
	Identifier.lookup("java.rmi.UnmarshalException");
    public static final Identifier idUnexpectedException =
	Identifier.lookup("java.rmi.UnexpectedException");

    /*
     * stub protocol versions
     */
    public static final int STUB_VERSION_1_1 = 1;
    public static final int STUB_VERSION_FAT = 2;
    public static final int STUB_VERSION_1_2 = 3;

    /** serialVersionUID for all stubs that can use 1.2 protocol */
    public static final long STUB_SERIAL_VERSION_UID = 2;

    /** version number used to seed interface hash computation */
    public static final int INTERFACE_HASH_STUB_VERSION = 1;
}
