/*
 * @(#)Connection.java	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.rmi.transport;

import java.io.*;

public interface Connection {
    /**
     * Gets the input stream for this connection.
     */
    public InputStream getInputStream() throws IOException;

    /*
     * Release the input stream for this connection.
     */
    public void releaseInputStream() throws IOException;

    /**
     * Gets the output stream for this connection
     */
    public OutputStream getOutputStream() throws IOException;

    /*
     * Release the output stream for this connection.
     */
    public void releaseOutputStream() throws IOException;

    /**
     * Return true if channel can be used for multiple operations.
     */
    public boolean isReusable();

    /**
     * Close connection.
     */
    public void close() throws IOException;

    /**
     * Returns the channel for this connection.
     */
    public Channel getChannel();
}
