/*
 * @(#)LocateDGC.java	1.9 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.rmi.transport;

import java.rmi.RemoteException;
import java.rmi.dgc.DGC;
import sun.rmi.server.RemoteProxy;
import sun.rmi.server.UnicastRef;

/**
 * This class is used to obtain the remote object collector on a particular
 * host.
 */
final class LocateDGC {
    /**
     * Returns the remote object garbage collector at the specified
     * endpoint.
     */
    static DGC getDGC(Endpoint ep)
	throws RemoteException
    {
	String classname = "sun.rmi.transport.DGCImpl";

	// Create the needed remote reference
	// Then find and initialize the stub
	LiveRef ref = new LiveRef(DGCImpl.getID(), ep, false);
	return (DGC)RemoteProxy.getStub(classname, new UnicastRef(ref));
    }

}
