/*
 * @(#)Notifiable.java	1.5 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.rmi.transport;

/**
 * Objects supporting the Notifiable interface are capable of being
 * called back when an address space (associated with a specific
 * endpoint) becomes inaccessible.  An object registers interest in
 * receiving such a callback via the Notifier.add method.
 */
public interface Notifiable {
    
    /**
     * Informs that the endpoint (ep) has become inaccessible.  The
     * parameter "state" indicates whether the address space is
     * permanently inaccessible (Notifier.Dead) or a transient failure
     * has been detected (Notifier.Failed)
     */
    void notify(Endpoint ep, int state);
}
