/*
 * @(#)Notifier.java	1.5 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.rmi.transport;

interface Notifier {
    
    /** VM is alive */
    final static int Alive = 0;
    /** VM is permanently inaccessible */
    final static int Dead = 1;
    /** indicates Transient  failure */
    final static int Failed = 2;
    
    /**
     * Register interest in receiving a callback when the address
     * space indicated by the endpoint ep goes away.
     */
    public void addNotifiable(Endpoint ep, Notifiable obj);
    
    /**
     * Remove notification request.
     */
    public void removeNotifiable(Endpoint ep, Notifiable obj);
    
}
