/*
 * @(#)Utils.java	1.4 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.rmi.transport;

public abstract class Utils {
    /**
     * Gets the System property indicated by the specified name.
     * If obtaining the property throws an exception (such as
     * a SecurityException), then simply return the value.
     * @param name the name of the system property
     * @param value the default value to use if this property is not set
     */
    public static Long getLong(String name, long value) {
	try {
	    return Long.getLong(name, value);
	} catch (Exception e) {
	    return new Long(value);
	}
    }
    
    /**
     * Gets the System property indicated by the specified key.
     * @param key the name of the system property
     */
    public static String getProperty(String key) {
	try {
	    return System.getProperty(key);
	} catch (Exception e) {
	    return null;
	}
    }
    
    /**
     * Gets a Boolean from the properties.
     * @param name the property name.
     */
    public static boolean getBoolean(String name) {
	try {
	    return Boolean.getBoolean(name);
	} catch (Exception e) {
	    return false;
	}
    }
}

