/*
 * @(#)PermissionImpl.java	1.9 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.security.acl;

import java.security.Principal;
import java.security.acl.*;

/**
 * The PermissionImpl class implements the permission 
 * interface for permissions that are strings.
 * @author Satish Dharmaraj
 */
public class PermissionImpl implements Permission {

    private String permission;

    /**
     * Construct a permission object using a string.
     * @param permission the stringified version of the permission.
     */
    public PermissionImpl(String permission) {
	this.permission = permission;
    }

    /**
     * This function returns true if the object passed matches the permission 
     * represented in this interface.
     * @param another The Permission object to compare with.
     * @return true if the Permission objects are equal, false otherwise
     */
    public boolean equals(Object another) {
	if (another instanceof Permission) {
	    Permission p = (Permission) another;
	    return permission.equals(p.toString());
	} else {
	    return false;
	}
    }
    
    /**
     * Prints a stringified version of the permission.
     * @return the string representation of the Permission.
     */
    public String toString() {
	return permission;
    }
}

