/*
 * @(#)AgentConstants.java	1.35 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.agent;
import sun.tools.java.Constants;

public interface AgentConstants extends Constants {
    final   int AGENT_VERSION		= 3;

    final   int TP_THREADGROUP		= 15;
    final   int TP_CLASS     		= 16;
    final   int TP_OBJECT		= 17;
    final   int TP_STRING		= 18;
    final   int TP_THREAD		= 19;

    final   int CMD_GET_CLASS_INFO	= 20;
    final   int CMD_GET_THREAD_NAME	= 21;
    final   int CMD_GET_CLASS_BY_NAME	= 22;
    final   int CMD_MARK_OBJECTS	= 23;
    final   int CMD_FREE_OBJECTS	= 24;
    final   int CMD_LIST_THREADS	= 25;
    final   int CMD_RUN			= 26;
    final   int CMD_SUSPEND_THREAD	= 27;
    final   int CMD_RESUME_THREAD	= 28;
    final   int CMD_RESUME_LAST_SUSPENDED_THREADS	= 29;
    final   int CMD_SUSPEND_ALL_THREADS	= 30;   // GVH SAS # 4046670
    final   int CMD_GET_THREAD_STATUS   = 31;
    final   int CMD_GET_STACK_TRACE	= 32;
    final   int CMD_WRITE_BYTES		= 33;
    final   int CMD_SYSTEM		= 34;
    final   int CMD_GET_FIELDS		= 35;
    final   int CMD_GET_METHODS		= 36;
    final   int CMD_GET_VALUES		= 37;
    final   int CMD_GET_SLOT_SIGNATURE 	= 38;
    final   int CMD_GET_SLOT_VALUE 	= 39;
    final   int CMD_GET_ELEMENTS	= 40;
    final   int CMD_SET_BRKPT_LINE	= 41;
    final   int CMD_SET_BRKPT_METHOD	= 42;
    final   int CMD_CLEAR_BRKPT		= 43;
    final   int CMD_CLEAR_BRKPT_LINE	= 44;
    final   int CMD_CLEAR_BRKPT_METHOD	= 45;
    final   int CMD_BRKPT_NOTIFY	= 46;
    final   int CMD_LIST_THREADGROUPS	= 47;
    final   int CMD_GET_THREADGROUP_INFO= 48;
    final   int CMD_LIST_CLASSES	= 49;
    final   int CMD_GET_STACK_VALUE	= 50;
    final   int CMD_SET_VERBOSE		= 51;
    final   int CMD_EXCEPTION_NOTIFY	= 52;
    final   int CMD_CATCH_EXCEPTION_CLS = 53;
    final   int CMD_IGNORE_EXCEPTION_CLS= 54;
    final   int CMD_GET_CATCH_LIST	= 55;
    final   int CMD_STOP_THREAD		= 56;
    final   int CMD_STOP_THREAD_GROUP	= 57;
    final   int CMD_QUIT		= 58;
    final   int CMD_GET_SOURCE_FILE	= 59;
    final   int CMD_OBJECT_TO_STRING	= 60;
    final   int CMD_GET_SOURCEPATH	= 61;
    final   int CMD_SET_SOURCEPATH	= 62;
    final   int CMD_STEP_THREAD		= 63;
    final   int CMD_NEXT_STEP_THREAD	= 64;
    final   int CMD_LIST_BREAKPOINTS	= 65;
    final   int CMD_THREADDEATH_NOTIFY	= 66;
    final   int CMD_QUIT_NOTIFY		= 67;
    final   int CMD_SET_SLOT_VALUE	= 68;
    final   int CMD_SET_STACK_VALUE	= 69;
    final   int CMD_OBJECT_FINALIZED	= 70;
    final   int CMD_GET_LINENUMBERS	= 71;
    final   int CMD_GET_METHOD_LINENO	= 72;
    final   int CMD_STEP_OUT_THREAD	= 73;        // GVH SAS step out

    final   int CMD_EXCEPTION		= -2;	// Exception occurred during cmd

    /* Thread statuses */
    final   int THR_STATUS_UNKNOWN	= -1;
    final   int THR_STATUS_ZOMBIE	= 0;
    final   int THR_STATUS_RUNNING	= 1;
    final   int THR_STATUS_SLEEPING	= 2;
    final   int THR_STATUS_MONWAIT	= 3;
    final   int THR_STATUS_CONDWAIT	= 4;
    final   int THR_STATUS_SUSPENDED	= 5;
    final   int THR_STATUS_BREAK	= 6;

    /* System commands */
    final   int SYS_MEMORY_TOTAL	= 1;
    final   int SYS_MEMORY_FREE		= 2;
    final   int SYS_TRACE_METHOD_CALLS	= 3;
    final   int SYS_TRACE_INSTRUCTIONS	= 4;

    /* Valid password characters:
     * [0-9][a-z] minus zero, one, O and L to reduce mistakes.
     */
    String PSWDCHARS = "23456789abcdefghijkmnpqrstuvwxyz";

    // Special object ids
    final   int NULL_OBJECT_ID          = 0;
    final   int INVALID_OBJECT_ID       = -1;
}
