/*
 * @(#)AgentOutputStream.java	1.13 98/08/13
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.agent;

import java.io.*;

class AgentOutputStream extends FilterOutputStream implements AgentConstants {

    private DataOutputStream outAsDataStream;  /* cache to avoid casting */

    AgentOutputStream(DataOutputStream out) {
	super(out);
	outAsDataStream = out;
    }

    public void write(int b) throws IOException {
        synchronized (out) {
            out.write(CMD_WRITE_BYTES);
            outAsDataStream.writeInt(1);
            out.write(b);
        }
    }

    public void write(byte b[]) throws IOException {
	write(b, 0, b.length);
    }

    public void write(byte b[], int off, int len) throws IOException {
        synchronized (out) {
            out.write(CMD_WRITE_BYTES);
            outAsDataStream.writeInt(len);
            out.write(b, off, len);
        }
    }

    public void flush() throws IOException {
        synchronized (out) {
        	out.flush();
        }
    }
}
