/*
 * @(#)Location.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.agent;

/**
 *   Chunk of program location information.
 *   @author Robert Field
 */
public class Location {
    public final CachedMethod method;
    public final int line;
    public final int startBCI;
    public final int endBCI;

    /**
     * Constructor.
     */
    public Location(CachedMethod method, int line, int startBCI, int endBCI) {
	this.method = method;
        this.line = line;
        this.startBCI = startBCI;
        this.endBCI = endBCI;
    }

    public String toString() {
        return method.toString() + ":" + line + "(" + startBCI + "-" + endBCI + ")";
    }

}
