/*
 * @(#)LocalVariable.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.asm;

import sun.tools.java.*;

/**
 * This class is used to assemble the local variables in the local
 * variable table.
 *
 * @author Arthur van Hoff
 * @version 	1.8, 09/21/98
 */
public final
class LocalVariable {
    MemberDefinition field;
    int slot;
    int from;
    int to;

    public LocalVariable(MemberDefinition field, int slot) {
	if (field == null) {
	    new Exception().printStackTrace();
	}
	this.field = field;
	this.slot = slot;
	to = -1;
    }

    LocalVariable(MemberDefinition field, int slot, int from, int to) {
	this.field = field;
	this.slot = slot;
	this.from = from;
	this.to = to;
    }

    public String toString() {
	return field + "/" + slot;
    }
}
