/*
 * @(#)NameAndTypeData.java	1.12 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.asm;

import sun.tools.java.*;

/**
 * An object to represent a name and type constant pool data item.
 */
final
class NameAndTypeData {
    MemberDefinition field;

    /**
     * Constructor
     */
    NameAndTypeData(MemberDefinition field) {
	this.field = field;
    }

    /**
     * Hashcode
     */
    public int hashCode() {
	return field.getName().hashCode() * field.getType().hashCode();
    }

    /**
     * Equality
     */
    public boolean equals(Object obj) {
	if ((obj != null) && (obj instanceof NameAndTypeData)) {
	    NameAndTypeData nt = (NameAndTypeData)obj;
	    return field.getName().equals(nt.field.getName()) &&
		field.getType().equals(nt.field.getType());
	}
	return false;
    }

    /**
     * Convert to string
     */
    public String toString() {
	return "%%" + field.toString() + "%%";
    }
}
