/*
 * @(#)RemoteBoolean.java	1.9 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteBoolean class extends RemoteValue for booleans.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteBoolean extends RemoteValue {
    private boolean value;

    RemoteBoolean(boolean b) {
	super(TC_BOOLEAN);
	value = b;
    }

    /** Return the boolean's value. */
    public boolean get() {
	return value;
    }

    /** Print this RemoteValue's type ("boolean"). */
    public String typeName() {
	return new String("boolean");
    }

    /** Return the boolean's value as a string. */
    public String toString() {
	return (new Boolean(value).toString());
    }
}
