/*
 * @(#)RemoteByte.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteByte class extends RemoteValue for bytes.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteByte extends RemoteValue {
    private byte value;

    RemoteByte(byte b) {
	super(TC_BYTE);
	value = b;
    }
    
    /** Return the byte's value. */
    public byte get() {
	return value;
    }

    /** Print this RemoteValue's type ("byte"). */
    public String typeName() {
	return new String("byte");
    }
    
    /** Return the byte's value as a string. */
    public String toString() {
	return toHex(value);
    }
}
