/*
 * @(#)RemoteChar.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteChar class extends RemoteValue for chars.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteChar extends RemoteValue {
    private char value;

    RemoteChar(char c) {
	super(TC_CHAR);
	value = c;
    }
    
    /** Return the char's value. */
    public char get() {
	return value;
    }

    /** Print this RemoteValue's type ("char"). */
    public String typeName() {
	return new String("char");
    }
    
    /** Return the char's value as a string. */
    public String toString() {
	return (new Character(value).toString());
    }
}
