/*
 * @(#)RemoteDouble.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteDouble class extends RemoteValue for doubles.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteDouble extends RemoteValue {
    private double value;

    RemoteDouble(double d) {
	super(TC_DOUBLE);
	value = d;
    }
    
    /** Return the double's value. */
    public double get() {
	return value;
    }

    /** Print this RemoteValue's type ("double"). */
    public String typeName() {
	return new String("double");
    }
    
    /** Return the double's value as a string. */
    public String toString() {
	return (new Double(value).toString());
    }
}
