/*
 * @(#)RemoteFloat.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteFloat class extends RemoteValue for floats.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteFloat extends RemoteValue {
    private float value;

    RemoteFloat(float f) {
	super(TC_FLOAT);
	value = f;
    }
    
    /** Return the float's value. */
    public float get() {
	return value;
    }

    /** Print this RemoteValue's type ("float"). */
    public String typeName() {
	return new String("float");
    }
    
    /** Return the float's value as a string. */
    public String toString() {
	return (new Float(value).toString());
    }
}
