/*
 * @(#)RemoteInt.java	1.9 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteInt class extends RemoteValue for ints.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteInt extends RemoteValue {
    private int value;

    public RemoteInt(int i) {
	super(TC_INT);
	value = i;
    }
    
    /** Return the int's value. */
    public int get() {
	return value;
    }

    /** Print this RemoteValue's type ("int"). */
    public String typeName() {
	return new String("int");
    }
    
    /** Return the int's value as a string. */
    public String toString() {
	return new Integer(value).toString();
    }
}
