/*
 * @(#)RemoteLong.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteLong class extends RemoteValue for longs.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteLong extends RemoteValue {
    private long value;

    RemoteLong(long l) {
	super(TC_LONG);
	value = l;
    }
    
    /** Return the long's value. */
    public long get() {
	return value;
    }

    /** Print this RemoteValue's type ("long"). */
    public String typeName() {
	return new String("long");
    }
    
    /** Return the long's value as a string. */
    public String toString() {
	return (new Long(value).toString());
    }
}
