/*
 * @(#)RemoteShort.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteShort class extends RemoteValue for shorts.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteShort extends RemoteValue {
    private short value;

    RemoteShort(short s) {
	super(TC_SHORT);
	value = s;
    }
    
    /** Return the short's value. */
    public short get() {
	return value;
    }

    /** Print this RemoteValue's type ("short"). */
    public String typeName() {
	return new String("short");
    }

    /** Return the short's value as a string. */
    public String toString() {
	return toHex(value);
    }
}
