/*
 * @(#)RemoteString.java	1.9 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.debug;

/**
 * The RemoteString class allows access to a string in a remote Java
 * interpreter.  
 *
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteString extends RemoteObject {

    RemoteString(RemoteAgent agent, int id) {
	super(agent, TP_STRING, id, agent.classString);
    }

    /** Print this RemoteValue's type ("String"). */
    public String typeName() {
	return new String("String");
    }
    
    /** Return the string value, or "null" */
    public String description() {
	return toString();
    }

    /** Return the string value, or "null" */
    public String toString() {
	String retStr = agent.objectToString(id);
	return (retStr.length() == 0) ? new String("null") : retStr;
    }
}
