/*
 * @(#)CodeContext.java	1.15 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Label;

class CodeContext extends Context {
    Label breakLabel;
    Label contLabel;

    /**
     * Create a new nested context, for a block statement
     */
    CodeContext(Context ctx, Node node) {
	super(ctx, node);
	switch (node.op) {
	  case DO:
	  case WHILE:
	  case FOR:
	  case FINALLY:
	  case SYNCHRONIZED:
	    this.breakLabel = new Label();
	    this.contLabel = new Label();
	    break;
	  case SWITCH:
	  case TRY:
	  case INLINEMETHOD:
	  case INLINENEWINSTANCE:
	    this.breakLabel = new Label();
	    break;
	  default:
	    if ((node instanceof Statement) && (((Statement)node).labels != null)) {
		this.breakLabel = new Label();
	    }
	}
    }
}
