/*
 * @(#)DivRemExpression.java	1.6 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Assembler;
import java.util.Hashtable;

abstract public
class DivRemExpression extends BinaryArithmeticExpression {
    /**
     * constructor
     */
    public DivRemExpression(int op, long where, Expression left, Expression right) {
	super(op, where, left, right);
    }
  
    /**
     * Inline
     */
    public Expression inline(Environment env, Context ctx) {
        // Do not toss out integer divisions or remainders since they 
        // can cause a division by zero.
        if (type.inMask(TM_INTEGER)) { 
	    right = right.inlineValue(env, ctx);
	    if (right.isConstant() && !right.equals(0)) { 
	        // We know the division can be elided
	        left = left.inline(env, ctx);
		return left;
	    } else { 
	        left = left.inlineValue(env, ctx);
		try {
		    return eval().simplify();
		} catch (ArithmeticException e) {
		    env.error(where, "arithmetic.exception");
		    return this;
		}
	    }
	} else { 
   	    // float & double divisions don't cause arithmetic errors
	    return super.inline(env, ctx);
	}
    }
}
