/*
 * @(#)DivideExpression.java	1.19 98/06/29
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Assembler;
import java.util.Hashtable;

public
class DivideExpression extends DivRemExpression {
    /**
     * constructor
     */
    public DivideExpression(long where, Expression left, Expression right) {
	super(DIV, where, left, right);
    }

    /**
     * Evaluate
     */
    Expression eval(int a, int b) {
	return new IntExpression(where, a / b);
    }
    Expression eval(long a, long b) {
	return new LongExpression(where, a / b);
    }
    Expression eval(float a, float b) {
	return new FloatExpression(where, a / b);
    }
    Expression eval(double a, double b) {
	return new DoubleExpression(where, a / b);
    }

    /**
     * Simplify
     */
    Expression simplify() {
	// This code here was wrong.  What if the expression is a float?
	// In any case, if the expression throws an exception, we
	// should just throw the exception at run-time.  Throwing
	// it at compile-time is not correct.
	// (Fix for 4019300)
	//
	// if (right.equals(0)) {
	//      throw new ArithmeticException("/ by zero");
	// }
	if (right.equals(1)) {
	    return left;
	}
	return this;
    }

    /**
     * Code
     */
    void codeOperation(Environment env, Context ctx, Assembler asm) {
	asm.add(where, opc_idiv + type.getTypeCodeOffset());
    }
}
