/*
 * @(#)DoubleExpression.java	1.16 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Assembler;
import java.io.PrintStream;

public
class DoubleExpression extends ConstantExpression {
    double value;
    
    /**
     * Constructor
     */
    public DoubleExpression(long where, double value) {
	super(DOUBLEVAL, where, Type.tDouble);
	this.value = value;
    }

    /**
     * Get the value
     */
    public Object getValue() {
	return new Double(value);
    }

    /**
     * Check if the expression is equal to a value
     */
    public boolean equals(int i) {
        return value == i;
    }

    /**
     * Check if the expression is equal to its default static value
     */
    public boolean equalsDefault() {
        // don't allow -0.0
        return (Double.doubleToLongBits(value) == 0);
    }

    /**
     * Code
     */
    public void codeValue(Environment env, Context ctx, Assembler asm) {
	asm.add(where, opc_ldc2_w, new Double(value));
    }

    /**
     * Print
     */
    public void print(PrintStream out) {
	out.print(value + "D");
    }
}
