/*
 * @(#)IntExpression.java	1.15 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import java.io.PrintStream;

public
class IntExpression extends IntegerExpression {
    /**
     * Constructor
     */
    public IntExpression(long where, int value) {
	super(INTVAL, where, Type.tInt, value);
    }

    /**
     * Equality, this is needed so that switch statements
     * can put IntExpressions in a hashtable
     */
    public boolean equals(Object obj) {
	if ((obj != null) && (obj instanceof IntExpression)) {
	    return value == ((IntExpression)obj).value;
	}
	return false;
    }

    /**
     * Hashcode, this is needed so that switch statements
     * can put IntExpressions in a hashtable
     */
    public int hashCode() {
	return value;
    }

    /**
     * Print
     */
    public void print(PrintStream out) {
	out.print(value);
    }
}
