/*
 * @(#)LengthExpression.java	1.17 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Assembler;
import java.util.Hashtable;

public
class LengthExpression extends UnaryExpression {
    /**
     * Constructor
     */
    public LengthExpression(long where, Expression right) {
	super(LENGTH, where, Type.tInt, right);
    }
 
    /**
     * Select the type of the expression
     */
    public Vset checkValue(Environment env, Context ctx, Vset vset, Hashtable exp) {
	vset = right.checkValue(env, ctx, vset, exp);
	if (!right.type.isType(TC_ARRAY)) {
	    env.error(where, "invalid.length", right.type);
	}
	return vset;
    }

    /**
     * Code
     */
    public void codeValue(Environment env, Context ctx, Assembler asm) {
	right.codeValue(env, ctx, asm);
	asm.add(where, opc_arraylength);
    }
}
