/*
 * @(#)MultiplyExpression.java	1.14 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Assembler;

public
class MultiplyExpression extends BinaryArithmeticExpression {
    /**
     * constructor
     */
    public MultiplyExpression(long where, Expression left, Expression right) {
	super(MUL, where, left, right);
    }

    /**
     * Evaluate
     */
    Expression eval(int a, int b) {
	return new IntExpression(where, a * b);
    }
    Expression eval(long a, long b) {
	return new LongExpression(where, a * b);
    }
    Expression eval(float a, float b) {
	return new FloatExpression(where, a * b);
    }
    Expression eval(double a, double b) {
	return new DoubleExpression(where, a * b);
    }

    /**
     * Simplify
     */
    Expression simplify() {
	if (left.equals(1)) {
	    return right;
	}
	if (right.equals(1)) {
	    return left;
	}
	return this;
    }

    /**
     * Code
     */
    void codeOperation(Environment env, Context ctx, Assembler asm) {
	asm.add(where, opc_imul + type.getTypeCodeOffset());
    }
}
