/*
 * @(#)StringExpression.java	1.16 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.tools.tree;

import sun.tools.java.*;
import sun.tools.asm.Assembler;
import java.io.PrintStream;

public
class StringExpression extends ConstantExpression {
    String value;
    
    /**
     * Constructor
     */
    public StringExpression(long where, String value) {
	super(STRINGVAL, where, Type.tString);
	this.value = value;
    }

    public boolean equals(String s) {
	return value.equals(s);
    }
    public boolean isNonNull() {
	return true;		// string literal is never null
    }

    /**
     * Code
     */
    public void codeValue(Environment env, Context ctx, Assembler asm) {
	asm.add(where, opc_ldc, this);
    }

    /**
     * Get the value
     */
    public Object getValue() {
	return value;
    }

    /**
     * Hashcode
     */
    public int hashCode() {
	return value.hashCode() ^ 3213;
    }

    /**
     * Equality
     */
    public boolean equals(Object obj) {
	if ((obj != null) && (obj instanceof StringExpression)) {
	    return value.equals(((StringExpression)obj).value);
	}
	return false;
    }

    /**
     * Print
     */
    public void print(PrintStream out) {
	out.print("\"" + value + "\"");
    }
}
