/*
 * @(#)vm_calls.h	1.7 98/09/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef _JAVASOFT_VM_CALLS_H_
#define _JAVASOFT_VM_CALLS_H_

/* This file defines the function table and macros exported from the VM
 * for the implementation of HPI.
 */

extern vm_calls_t *vm_calls;

#define VM_CALLS_READY() vm_calls
#define VM_CALL(f) (vm_calls->f)

#undef sysAssert

#ifdef DEBUG
#define sysAssert(expression) {		\
    if (!(expression)) {		\
	vm_calls->panic \
            ("\"%s\", line %d: assertion failure\n", __FILE__, __LINE__); \
    }					\
}
#else
#define sysAssert(expression) ((void) 0)
#endif

#ifdef LOGGING

#define Log(level, message) {						\
    if (vm_calls && level <= logging_level)			\
	vm_calls->jio_fprintf(stderr, message);				\
}

#define Log1(level, message, x1) {					\
    if (vm_calls && level <= logging_level)			\
	vm_calls->jio_fprintf(stderr, message, (x1));			\
}

#define Log2(level, message, x1, x2) {					\
    if (vm_calls && level <= logging_level)			\
	vm_calls->jio_fprintf(stderr, message, (x1), (x2));		\
}

#define Log3(level, message, x1, x2, x3) {				\
    if (vm_calls && level <= logging_level)			\
	vm_calls->jio_fprintf(stderr, message, (x1), (x2), (x3));	\
}

#define Log4(level, message, x1, x2, x3, x4) {				\
    if (vm_calls && level <= logging_level)			\
	vm_calls->jio_fprintf(stderr, message, (x1), (x2), (x3), (x4)); \
}

#else

#define Log(level, message)			((void) 0)
#define Log1(level, message, x1)		((void) 0)
#define Log2(level, message, x1, x2)		((void) 0)
#define Log3(level, message, x1, x2, x3)	((void) 0)
#define Log4(level, message, x1, x2, x3, x4)	((void) 0)

#endif /* LOGGING */

#endif /* !_JAVASOFT_VM_CALLS_H_ */
