/*
 * @(#)common_exceptions.c	1.19 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "oobj.h"
#include "interpreter.h"
#include "threads.h"
#include "common_exceptions.h"

#include "java_lang_Thread.h"

/* JAVAPKG */

void ThrowArrayIndexOutOfBoundsException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "ArrayIndexOutOfBoundsException", s);
}

void ThrowClassNotFoundException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "ClassNotFoundException", s);
}

void ThrowIllegalAccessError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IllegalAccessError", s);
}

void ThrowIllegalAccessException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IllegalAccessException", s);
}

void ThrowIllegalArgumentException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IllegalArgumentException", s);
}

void ThrowInstantiationException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "InstantiationException", s);
}

void ThrowInternalError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "InternalError", s);
}

void ThrowInterruptedException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "InterruptedException", s);
}

void ThrowNoClassDefFoundError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NoClassDefFoundError", s);
}

void ThrowNoSuchFieldError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NoSuchFieldError", s);
}

void ThrowNoSuchFieldException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NoSuchFieldException", s);
}

void ThrowNoSuchMethodError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NoSuchMethodError", s);
}

void ThrowNoSuchMethodException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NoSuchMethodException", s);
}

void ThrowNullPointerException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NullPointerException", s);
}

void ThrowNumberFormatException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NumberFormatException", s);
}

void ThrowNegativeArraySizeException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "NegativeArraySizeException", s);
}

void ThrowOutOfMemoryError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "OutOfMemoryError", s);
}

void ThrowStringIndexOutOfBoundsException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "StringIndexOutOfBoundsException", s);
}

void ThrowAbstractMethodError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "AbstractMethodError", s);
}

void ThrowVerifyError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "VerifyError", s);
}

void ThrowIncompatibleClassChangeError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IncompatibleClassChangeError", s);
}

void ThrowClassCircularityError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "ClassCircularityError", s);
}

void ThrowClassFormatError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "ClassFormatError", s);
}

void ThrowUnsupportedClassVersionError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "UnsupportedClassVersionError", s);
}

void ThrowUnsatisfiedLinkError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "UnsatisfiedLinkError", s);
}

void ThrowStackOverflowError(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "StackOverflowError", s);
}

void ThrowArrayStoreException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "ArrayStoreException", s);
}

void ThrowIllegalMonitorStateException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IllegalMonitorStateException", s);
}

void ThrowIllegalStateException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IllegalStateException", s);
}

void ThrowCloneNotSupportedException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "CloneNotSupportedException", s);
}

void ThrowIllegalThreadStateException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "IllegalThreadStateException", s);
}

void ThrowClassCastException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAPKG "ClassCastException", s);
}

/* JAVAIOPKG */

void ThrowIOException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAIOPKG "IOException", s);
}

void ThrowInterruptedIOException(ExecEnv *ee, char *s) {
    SignalError(ee, JAVAIOPKG "InterruptedIOException", s);
}

