;
; @(#)executeJava_p5.inc	1.31 98/08/24
;
; Copyright 1996-1998 by Sun Microsystems, Inc.,
; 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
; All rights reserved.
;
; This software is the confidential and proprietary information
; of Sun Microsystems, Inc. ("Confidential Information").  You
; shall not disclose such Confidential Information and shall use
; it only in accordance with the terms of the license agreement
; you entered into with Sun.
;

define(`MOV',`
	ifelse(CPU,`5',	`mov $2, $3',  `movzx $1, $3')
')


define(`NSP',``
	add	esp, eval('$1`*1)'')

define(`finish_return',`

	;################ START FINISH RETURN MACRO #################

	$5
	$6

	mov ecx, DWORD PTR _ee$[esp+$3*4]		;ecx = ee
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = frame

	mov edx, DWORD PTR [ebx + javaframe_monitor]
	test edx,edx					;if (javaframe->monitor)
	jnz Lb($1_monitor)				;There is a monitor ON

Lb($1_back_from_monitor):
	mov edx, _if$[esp+$3*4]
	xor eax, eax
	cmp edx,ebx					;frame = initial_frame?
	je Lb($1_initial_frame)

	mov edx, [CName(jvmpi_event_flags)]
	and edx, JVMPI_EVENT_METHOD_EXIT_ON
	jnz Lb($1_jvmpi_profiling)

Lb($1_back_from_jvmpi_profiling):
	mov ebx, DWORD PTR [ebx + javaframe_prev]	;ebx = javaframe->prev
	mov DWORD PTR [ecx + ee_current_frame], ebx	;current_frame=frame->prev
	mov esi, DWORD PTR [ebx + javaframe_returnpc]	;pc = javaframe->returnpc
	test esi,esi
	jnz Lb($1_nofixupquick)

	; frame->returnpc = frame->lastpc + 3
	mov esi, DWORD PTR [ebx + javaframe_lastpc]
	add esi, 3
	mov DWORD PTR [ebx + javaframe_returnpc], esi
	
	; FixupQuickInvocation(ee, frame) 
	push ebx					; pass frame
	push ecx					; pass ee
	call CName(FixupQuickInvocation)
	add esp, 8

	xor eax, eax
	mov ecx, DWORD PTR _ee$[esp+$3*4]		;ecx = ee
	xor edx, edx

Lb($1_nofixupquick):
	MOV(edx, dl, BYTE PTR [ecx + ee_exceptionKind])		
	mov ecx, DWORD PTR [ebx + javaframe_constant_pool]		
	test edx,edx
	jnz Lb($1_exceptionOccurred)			
							
	mov ebp, DWORD PTR [ebx + javaframe_vars]	;ebp = javaframe->vars
	MOV(eax, al, BYTE PTR [esi])		

	mov _cp$[esp+$3*4], ecx				;javaframe->constant_pool
	mov edi, DWORD PTR [ebx + javaframe_optop]	;CACHE_OPTOP()

	$7
	$8
	Dispatch$2
				  
Lb($1_monitor):						;branch usually !taken
	push ecx
	push ebx					;push ebx safe keeping

ifdef(`FAST_MONITOR',
`	lea  eax, [ecx]					;load ee',
`	lea  eax, [ecx + ee_sys_thr]			;load EE2SysThread'
     )

	push edx
	push eax

ifdef(`FAST_MONITOR',
`	call CName(monitorExit2)				;monitorExit2(ee, javaframe->monitor)',
`	mov  edx, CName(hpi_thread_interface)
	mov  edx, [edx]
	call dword ptr [edx + hpi_thread_monitorexit]	;sysMonitorExit(ee, javaframe->monitor)'
     )
	add esp, 8

	pop ebx
	pop ecx
	xor eax, eax
	xor edx, edx
	jmp Lb($1_back_from_monitor)

Lb($1_jvmpi_profiling):

;	jvmpi_method_exit(ee);
	
	push ecx					; EE
	push ebx
	
	push ecx
	call CName(jvmpi_method_exit)
	add esp, 4

	pop ebx
	pop ecx
	xor eax, eax
	xor edx, edx
	jmp Lb($1_back_from_jvmpi_profiling)

Lb($1_exceptionOccurred):
	mov esi, [ebx + javaframe_lastpc]		;current_javaframe->lastpc

	$7
	$8
	jmp Lb($4_except)

Lb($1_initial_frame):
	$7
	$8
	xor eax,eax
	jmp Lg($exit)

	;################ END FINISH_RETURN MACRO #################
')


define(`finish_call_method',`
	;################ START FINISH_CALL_METHOD MACRO #################
	;## Requirement before calling macro- ecx = ee
	;## NOTE- Will trash all regs & jump to next opcode
	xor eax,eax 
	mov edx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame

	mov _ee$[esp],ecx
	mov esi, DWORD PTR [edx + javaframe_returnpc] 	;esi = javaframe->returnpc

	mov edi, DWORD PTR [edx + javaframe_optop]	;edi = javaframe->optop
	mov ebx, DWORD PTR [edx + javaframe_constant_pool]		

	mov _cp$[esp],ebx
	MOV(eax, al, BYTE PTR [esi])		

	mov ebp,DWORD PTR [edx + javaframe_vars]
	Dispatch0
							
	;################ END FINISH_CALL_METHOD MACRO #################
')				   
				   
define(`invoke_java_method',`   
	;################ START INVOKE_JAVA_METHOD MACRO #################
	;## This macro can only be used in "0" state!
	;## do check for stack overflow first
	;## originally ((a + b) + c) >= d, now (a + b) >= (d - c)
	;## assume ebx = current_frame, ecx = current_frame->javastack, and 
	;## ebx has been pushed
	;## dx= WORD PTR [eax + mb_maxstack], and eax = new mb  (C)

	mov ecx, DWORD PTR [ecx + javastack_end_data] 	;D 
	mov ebx, DWORD PTR [ebx + javaframe_optop]	;A beg of javaframe

	lea edx, [edx *4]				;scale edx (maxstack)
	sub ecx,edx					;(d - c)
	xor edx,edx
	MOV(edx, dx, WORD PTR [eax + mb_nlocals])       ;edx = mb_nlocals
	cmp edx, 2
	jge @F
	mov edx, 2
@@:
	lea edx, [ebx + javaframe_ostack + edx*4]	;(A + B)+ mb_nlocals*4
	cmp edx, ecx
	jge Lb(Stack_Overflow_$1)			;stack overflow!!!
	pop ebx						;back ptr to orig frame

	;* Finish check for overflow
        ;* Survived the setup for the invocation
	;* now time to do the actual invokeJavaMethod
        ;* assumptions, edx = new frame, ebx = old frame, eax = new mb

	sub edx, javaframe_ostack			;ptr to new frame
	mov ebp,edi					;set local vars
	mov ecx, DWORD PTR [ebx + javaframe_javastack]	;old frames javastack
Lb(ijm_back_$1):
	mov esi, DWORD PTR [eax + mb_code]		;edi&esi now mangled 
	mov DWORD PTR [edx + javaframe_returnpc], esi	;frame->returnpc=mb->code
	mov DWORD PTR [edx + javaframe_javastack], ecx	;old_javaframe->javastack	
	mov ecx, DWORD PTR [eax + mb_fb]			
        mov DWORD PTR [edx + javaframe_vars], ebp	;javaframe->vars = optop
        mov DWORD PTR [edx + javaframe_current_method], eax ; current_method = mb
        mov DWORD PTR [edx + javaframe_prev], ebx	;old_javaframe (ebx) 
	mov eax, DWORD PTR [ecx + o_obj]		;unhand(new class)
	mov eax, [eax + ucbConstantPool]	      ;new class->constant_pool 
	mov DWORD PTR [edx + javaframe_monitor], 0    ;javaframe->monitor = 0
	mov _cp$[esp],eax			      ;javaframe->constant_pool
	mov DWORD PTR [edx + javaframe_constant_pool], eax 	
	mov ebx, DWORD PTR _ee$[esp]			;ecx = ee
	lea edi, [edx + javaframe_ostack]		;begining of the stack 
	mov DWORD PTR [edx + javaframe_optop],edi	;optop=javaframe->ostack
	mov DWORD PTR [ebx + ee_current_frame],edx	;set ee->current_frame

	mov eax, [CName(jvmpi_event_flags)]
	and eax, JVMPI_EVENT_METHOD_ENTRY_ON
	jnz Lb(Profiling_jvmpi_$1)

Lb(BackFromProfiling_jvmpi_$1):
	MOV(eax, al, BYTE PTR [esi])		
  	Dispatch0

Lb(Profiling_jvmpi_$1):
;	jvmpi_method_entry(ee);

	push edx
	push ebx
	push ecx
	
	mov eax, [ebp]                                  ; this pointer in *prev->optop
	push eax                                        ; push this pointer
	push ebx					; EE
	call CName(jvmpi_method_entry)
	add esp, 8

	pop ecx
	pop ebx
	pop edx
	jmp Lb(BackFromProfiling_jvmpi_$1)
	
Lb(Stack_Overflow_$1):
	push eax					;push the new mb
	mov ebx, _ee$[esp +8 ]				;+8(mb,current frame)stack

; We need to duplicate frame and mb because the callee may destroy
; them on stack, although we expect to use them later.

	mov eax, [esp+4]
	push eax					; push frame
	mov eax, [esp+4]
	push eax					; push mb

	push ebx					; push ee

	;*** NOTE- routine expects args_size to be at mb->args_size
	call CName(x86_ijm_javastack_overflow)		;(ee, mb, frame)
	add esp, 12
	test eax, eax
	jnz	Lb(ijm_no_error_$1)

	add esp, 8					;clean stack
	xor eax,eax
	jmp Lb(NO_except)				;error, get out

Lb(ijm_no_error_$1):
	mov ebp, eax					;vars= new optop
	pop eax
	xor ebx,ebx
	mov ecx, edx					;ecx = javastack
	MOV(ebx, bx, WORD PTR[eax + mb_nlocals]) 
	cmp ebx, 2
	jge @F
	mov ebx, 2
@@:
	;**** frame =(javastack->data + mlocals * 4)
	lea edx, DWORD PTR[edx + javastack_data + ebx * 4]	
	pop ebx						; get old frame pointer
	jmp	Lb(ijm_back_$1)

	;################ END INVOKE_JAVA_METHOD MACRO #################
')

Csupport(ijm_javastack_overflow)

;***********************************************************************
;* $cs_callmethod  (label callmethod: in original executeJava.c)
;*
;* We goto here from C-support invokers in executeJava_p5.m4.  We call the
;* mb->invoker and then perform the FixupQuickInvocation check (by testing
;* for returnpc==0).  There's no reason to optimize this invoker call
;* since it only happens the first time - as the opcode is being replaced
;* by a _quick version.
;*
;* Assumptions: eax = mb, edx = object
;*
;***********************************************************************

Lb($cs_callmethod):
	Assert(edx,ne,0)				;sysAssert(o != 0)
	mov ecx, DWORD PTR _ee$[esp]
	mov ebx, [ecx+ee_current_frame]	                ;ebx = ee->current_frame
	mov DWORD PTR [ebx + javaframe_lastpc],esi 	;javaframe->lastpc=pc
	push ecx					;save this for later
        ;; mb->invoker(o, mb, args_size, ee)
	push ecx					;pass ee
	xor ecx, ecx
	MOV(ecx, cx, WORD PTR [eax + mb_args_size])
	push ecx					;pass args_size
	push eax					;pass mb
	push edx					;pass o
	call DWORD PTR [eax + mb_invoker]

	add esp, 16
	pop ecx						;get ee back
	push eax					;save invoker result
	mov ebx, [ecx+ee_current_frame]			;ebx = javaframe
	mov esi, DWORD PTR [ebx + javaframe_returnpc]	;pc=javaframe->returnpc
	test esi,esi
	jnz Lb($cs_nofixupquick)

	mov esi, DWORD PTR [ebx + javaframe_lastpc]
	add esi, 3					;pc = lastpc + 3
	push ebx					;pass frame
	push ecx					;pass ee
	call CName(FixupQuickInvocation)
	add esp, 8

Lb($cs_nofixupquick):
	pop eax						;invoker result
	mov edi, DWORD PTR [ebx + javaframe_optop] 	;CACHE_OPTOP()
	test eax,eax
	jnz Lb($cs_noexcept)

	mov esi, DWORD PTR [ebx + javaframe_lastpc]	;pc = javaframe->lastpc
	mov ecx, DWORD PTR _ee$[esp]
	xor edx,edx
	MOV(edx, dl, BYTE PTR [ecx + ee_exceptionKind])
	test edx,edx
	jnz Lb($cs_except)				;exceptionOccurred

Lb($cs_noexcept):
	mov edx, DWORD PTR [ebx + javaframe_constant_pool]		
	mov _cp$[esp],edx				;constant_pool=f->cp
	mov ebp,DWORD PTR [ebx + javaframe_vars]
	xor eax, eax
	MOV(eax,al,BYTE PTR [esi])
	Dispatch0				;process new opcode

Lb($cs_except):
	mov esi, [ebx + javaframe_lastpc]		;current_javaframe->lastpc
	jmp Lb(NO_except)

;***********************************************************************
;* invokestatic_quick
;*
;*	case opc_invokestatic_quick-
;*	    mb = constant_pool[GET_INDEX(pc + 1)].p;
;*	    args_size = mb->args_size;
;*	    optop -= args_size;
;*	    frame->returnpc = pc + 3;
;*	    /* o should be the handle to the method's class */
;*	    o = (JHandle *)(cbHandle(fieldclass(&mb->fb)));
;*	    goto callmethod;
;*
;*
;***********************************************************************

Def210(invokestatic_quick)
	mov ebx, DWORD PTR _cp$[esp]			;get constant pool
	xor ecx, ecx
	mov ch, BYTE PTR [esi+1]			;GET_INDEX() macro
	xor edx,edx					
	mov cl, BYTE PTR [esi+2]			
	mov eax, DWORD PTR [ebx + ecx * 4 ]		;eax = method block
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	cmp DWORD PTR [eax + mb_invoker], CName(invokeJavaMethod)
	jne Lb(isq_not_ijn)					
	
	;*************  START invokeJavaMethod
	MOV(edx, dx, WORD PTR [eax + mb_args_size])
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	lea edx,[edx * 4]				;edx *= 4
	mov ecx, esi					;ecx = PC
	sub edi,edx					;edi -= arg_size * 4
	add ecx, 3					;ecx = pc +3 
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3
	mov DWORD PTR [ebx + javaframe_optop],edi	;DECACHE_OPTOP()
	mov DWORD PTR [ebx + javaframe_lastpc],esi
	mov ecx, DWORD PTR [ebx + javaframe_javastack]
	xor edx,edx
	push ebx
	mov dx, WORD PTR [eax + mb_maxstack]		;C
        invoke_java_method(NO_isq_invoker_error)
	;************* END invokeJavaMethod

Lb(isq_not_ijn):
	MOV(edx, dx, WORD PTR [eax + mb_args_size])			 
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	push ecx					;ee
	push edx					;arg_size
	shl edx,2					;edx*4
	mov ecx, esi					;ecx = esi, pc
	sub edi,edx					;edi -= arg_size*4
	add ecx, 3					;ecx = pc +3 
	mov DWORD PTR [ebx + javaframe_optop],edi	;DECACHE_OPTOP()
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3
	mov DWORD PTR [ebx + javaframe_lastpc],esi
	; o = mb->fb.clazz
	mov ebx, DWORD PTR [eax + mb_fb + fb_clazz]	;ebx = mb->fb.clazz
	push eax					;mb
	push ebx					;ebx = mb->fb.clazz
	call DWORD PTR [eax + mb_invoker]		;invoker(o,mb,args_size,ee)
	
	; pc = ee->current_javaframe->returnpc	
	add esp, 16					;pop 4 dwords 
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
 	test eax,eax					;Was there an error?
	je	Lb(NO_isq_invoker_error)
	finish_call_method				

Lb(NO_isq_invoker_error):
	xor eax, eax		
	jmp	Lb(NO_except)

;***********************************************************************
;* NO_invokenonvirtual_quick
;*
;***********************************************************************
  

Def210(invokenonvirtual_quick)

; Assumptions- esi = pc[0], edi = sp[0]
 
	;;   mb = constant_pool[GET_INDEX(pc+1)] 
	xor ecx, ecx					
	mov ebx, DWORD PTR _cp$[esp]			;Get constant_pool
	mov ch, BYTE PTR [esi+1]			;GET_INDEX() macro
	xor edx,edx		
	mov cl, BYTE PTR [esi+2]
	mov eax, DWORD PTR [ebx + ecx * 4 ]		;eax = method block
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	
	cmp DWORD PTR [eax + mb_invoker], CName(invokeJavaMethod)
	jne Lb(invq_not_ijn)					
				
	;************* invokeJavaMethod
	MOV(edx, dx, WORD PTR [eax + mb_args_size])			 
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	push ebx					;save old frame pointer
	lea ecx, [esi+3]				;ecx = pc + 3
	lea edx,[edx*4]					;edx*4
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;pc+3 (BEFORE COMPARE!)
	sub edi,edx					;-=arg_size (ditto)
	mov ecx, DWORD PTR [ebx + javaframe_javastack]
	
	;; check for a null pointer exception
	Verify(DWORD PTR [edi],ne,0,NullPointer,NSP(4))	
	
	mov DWORD PTR [ebx + javaframe_optop],edi	;DECACHE_OPTOP()
	xor edx,edx
	mov DWORD PTR [ebx + javaframe_lastpc],esi
	MOV(edx, dx, WORD PTR [eax + mb_maxstack])

        invoke_java_method(NO_invq_invoker_error)
	;************* END invokeJavaMethod

Lb(invq_not_ijn):
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	MOV(edx, dx, WORD PTR [eax + mb_args_size])	
	push ecx					;ee
	push edx					;arg_size
	shl edx,2					;edx*4
	mov ecx, esi					;ecx = esi, pc
	sub edi,edx					;edi -= arg_size 
	add ecx, 3					;ecx = pc +3 
	mov edx, [edi]					;edx = S_HANDLE(sp[0])
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3
	Verify(edx,ne,0,NullPointer,NSP(8))		;sp[0]=0 (0 ptr exception)	
	mov DWORD PTR [ebx + javaframe_optop],edi	;equiv to DECACHE_OPTOP()
	mov DWORD PTR [ebx + javaframe_lastpc],esi
	push eax					;mb
	push edx					;ebx = o handle to self
	call DWORD PTR [eax + mb_invoker]		;invoker(o,mb,args_size,ee)
 	add esp, 16					;pop 4 dwords 
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
 	test eax,eax					;Was there an error?
	je	Lb(NO_invq_invoker_error)
	; Requirement before calling macro- ecx = ee
	finish_call_method		

Lb(NO_invq_invoker_error):
	xor eax,eax					;exception occured trap
	jmp	Lb(NO_except)

;***********************************************************************
;* NO_invokevirtual_quick
;*
;***********************************************************************

Def210(invokevirtual_quick)

; Assumptions- esi = pc[0], edi = sp[0]

	xor edx,edx		
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee

	mov dl, BYTE PTR [esi + 2]			;edx = args_size = pc[2]
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	push ecx					;ee
	push edx					;arg_size
	lea edx,[edx * 4]				;edx*4
	sub edi,edx					;edi -= arg_size
	lea ecx, [esi+3]				;ecx = pc + 3
	mov edx, [edi]					;edx=o (handle to myself)
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3
	Verify(edx,ne,0,NullPointer,NSP(8))		;sp[0]=0 (0 ptr exception)	
	mov DWORD PTR [ebx + javaframe_lastpc],esi	;javaframe->lastpc=pc
	mov DWORD PTR [ebx + javaframe_optop],edi	;equiv to DECACHE_OPTOP()
	push ebx				
	xor ebx,ebx				
	mov ecx, [edx +	o_methods]			;ecx = (o)->methods
	MOV(ebx, bl, BYTE PTR [esi + 1]) 		;(o) pc[1]
	mov eax, [ecx + ebx * 4 + methodtable_methods]	;eax = ecx->methods[pc[1]]  
	pop ebx
	mov ecx, DWORD PTR [ebx + javaframe_javastack]
	cmp DWORD PTR [eax + mb_invoker], CName(invokeJavaMethod) ;  = invokeJavaMethod
	jne Lb(ivq_not_ijn)										
							  
	;************* START invokeJavaMethod
	pop edx
	mov WORD PTR [eax + mb_args_size], dx		;mb->args_size=args_size
	add esp,4					;get rid pushed items
 	xor edx,edx
	push ebx					;save it for later keeping
	MOV(edx, dx, WORD PTR [eax + mb_maxstack])		
	invoke_java_method(NO_ivq_invoker_error)
	;************* END invokeJavaMethod

Lb(ivq_not_ijn):
	push eax					;mb
	push edx					;edx = o handle to self
	call DWORD PTR [eax + mb_invoker]		;invoker(o,mb,args_size,ee)
	add esp, 16					;pop 4 dwords 
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
 	test eax,eax					;Was there an error?
	je	Lb(NO_ivq_invoker_error)
	finish_call_method;

Lb(NO_ivq_invoker_error):
	xor	eax, eax				;exception
	jmp	Lb(NO_except)


;***********************************************************************
;* invokeinterface_quick
;*
;*
;***********************************************************************

Def210(invokeinterface_quick)
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	xor edx,edx
	mov dl, BYTE PTR [esi + 3]			;edx = args_size = pc[3]
	xor eax, eax
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	mov ecx, esi
	shl edx, 2					;edx*4
	mov ah, BYTE PTR [esi+1]			;GET_INDEX() macro
	sub edi,edx					;optop -= args_size
	add ecx, 5
	mov al, BYTE PTR [esi+2]			;eax=GET_INDEX(pc+1)
	mov DWORD PTR [ebx + javaframe_returnpc],ecx	;javaframe->returnpc=pc+5
	mov DWORD PTR [ebx + javaframe_optop],edi
	mov ebx, DWORD PTR _cp$[esp]			;Get ptr to constant_pool
	mov edx, [edi]					;edx = o = SHANDLE(0)
	Verify(edx,ne,0,NullPointer)			;sp[0]=0 (0 ptr exception)
	;** DEAD CODE removed here!!!! refer to interpreter.c source TFR 4/2/96
	;** (arrays don't support interface calls) but now executeJava.c
	mov ebx, DWORD PTR [ebx + eax * 4 ]		;imb=constant_pool[eax].mb
	push edx					;push o
	mov ecx, DWORD PTR [ebx + mb_fb + fb_clazz]	;intf=imb->fb.clazz
	mov ebx, DWORD PTR [ebx + mb_fb + fb_offset]	;imb->fb.u.offset
	mov eax, DWORD PTR [edx + o_methods]		;mtable=o->methods
	push ebx					;offset for later retrieval
	mov eax, [eax + methodtable_classdescriptor]	;cb=o->methods->classdesc.
	push eax					;cb for later retrieval
	mov edx, DWORD PTR[eax + o_obj]			;unhand(cb)
 	mov edx, [edx + ucbIntfMethodTable]		;imtable = cbIntfMethodTable(cb)
	mov ebx, [edx + imethodtable_icount]		;imtable->icount
	xor eax,eax
	MOV(eax,al, BYTE PTR [esi + 4])			;guess = pc[4]
	cmp eax, ebx					;guess >= icount ?
	jge Lb(search_loop)
	cmp ecx, [edx + eax*8 + imethodtable_itable]	;imtable->itable[guess].classdescriptor
	je Lb(found_it)
Lb(search_loop):
	mov eax, ebx					;guess = icount
Lb(top_search_loop):
	dec eax						;guess--
	jl Lb(iiq_error)
	cmp ecx, [edx + eax*8 + imethodtable_itable]	;imtable->itable[guess].classdescriptor
	jne Lb(top_search_loop)
	mov BYTE PTR [esi + 4], al			;pc[4] = guess

Lb(found_it):
	mov ebx, DWORD PTR [esp + 4]			;stashed offset
	mov ecx, [edx + eax*8 + imethodtable_itable+4]	;imtable->itable[guess].offsets
	mov eax, DWORD PTR [esp + 8]			;stashed o
	mov ebx, DWORD PTR [ecx + ebx*4]		;mtable slot #
	mov edx, DWORD PTR [eax + o_methods]		;mtable=o->methods
	mov ecx, DWORD PTR _ee$[esp + 12]		;ecx = ee
	mov edx, DWORD PTR [edx + ebx*4 + methodtable_methods] ;mb
	add esp,8
	xor ebx,ebx
	mov eax, DWORD PTR [ecx +  ee_current_frame]	;Get current frame again
	mov bl, BYTE PTR [esi + 3]			;args_size = pc[3]
	mov DWORD PTR [eax + javaframe_lastpc], esi	; set last pc, now
	pop eax						;finally... pop o
	push ecx					;push ee
	push ebx					;arg_size
	push edx					;mb
	push eax					;eax = o handle to self
	call DWORD PTR [edx + mb_invoker]		;invoker(o,mb,args_size,ee)
	add esp, 16					;pop 4 dwords
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	test eax,eax					;Was there an error?
	je	Lb(iiq_invoker_error)
	finish_call_method
Lb(iiq_invoker_error):
	xor	eax, eax				; exception
	jmp	Lb(NO_except)

Lb(iiq_error):
	pop edx						;pop cb
	add esp,8
	mov ebx, _ee$[esp]
	mov eax, [ebx+ee_current_frame]
	push ecx					;pass intf
	push edx					;pass cb
	push esi					;pass pc
	push ebx					;pass ee
	mov [eax+javaframe_optop], edi			;decache sp
	call CName(invokeInterfaceError)
	add esp, 16
	xor	eax, eax				; exception
	jmp	Lb(NO_except)
	
;***********************************************************************
;* NO_invokevirtual_quick_w
;*
;*	case opc_invokevirtual_quick_w-
;*	    mb = constant_pool[GET_INDEX(pc + 1)].p;
;*	    args_size = mb->args_size;
;*	    optop -= args_size;
;*	    frame->returnpc = pc + 3;
;*	    o = S_HANDLE(0);
;*	    if (o == 0) 
;*	        ERROR("NullPointer", 0);
;*	    mb = mt_slot(obj_array_methodtable(o), mb->fb.u.offset);
;*	    goto callmethod;
;*
;***********************************************************************
  

Def210(invokevirtual_quick_w)

; Assumptions- esi = pc[0], edi = sp[0]
;   mb = constant_pool[GET_INDEX(pc+1)]

	xor ecx, ecx
	mov ebx, DWORD PTR _cp$[esp]			; constant_pool
	mov ch, BYTE PTR [esi+1]			;GET_INDEX() macro
	xor edx,edx		
	mov cl, BYTE PTR [esi+2]
	mov eax, DWORD PTR [ebx + ecx * 4 ]		;eax = method block
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	MOV(edx, dx, WORD PTR [eax + mb_args_size])			
	push ecx					;ee
	push edx					;arg_size
	shl edx, 2					;edx*4
	mov ecx, esi					;ecx = esi, pc
	sub edi,edx					;edi -= arg_size
	add ecx, 3					;ecx = pc +3 
	mov edx, [edi]					;edx = S_HANDLE(sp[0])
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3
	Verify(edx,ne,0,NullPointer,NSP(8))		;sp[0]=0 (0 ptr exception)	
	mov ecx, DWORD PTR [edx + o_methods]	
	mov DWORD PTR [ebx + javaframe_optop],edi	; DECACHE_OPTOP()
	and ecx, FJ_FLAG_MASK
	mov DWORD PTR [ebx + javaframe_lastpc],esi	;where ifndef was
	cmp ecx, FJ_T_NORMAL_OBJECT			;if FJ_T_NORMAL_OBJECT 
	jnz Lb(ivqw_not_normal_object)
        ;; normal object
	mov ecx, DWORD PTR [edx + o_methods]		;methodtable

Lb(ivqw_macro_done):					
        ;; ecx contains obj_array_methodtable(o)
        ;; calculate  mb = mt_slot(obj_array_methodtable(o), mb->fb.u.offset);
	mov edx, DWORD PTR [eax + mb_fb + fb_offset]	;mb->fb.u.offset
	mov eax,DWORD PTR [ecx + edx * 4 + methodtable_methods] ; new mb
	mov edx, [edi]					; get object
	cmp DWORD PTR [eax + mb_invoker], CName(invokeJavaMethod)
	jne Lb(ivqw_not_ijn)				

	;************* START invokeJavaMethod
	pop edx
	pop ecx						;get ee back
	mov WORD PTR [eax + mb_args_size], dx		;mb->args_size=args_size
	push ebx					;= orig frame 
	MOV(edx,dx, WORD PTR [eax + mb_maxstack])			
	mov ecx, DWORD PTR [ebx + javaframe_javastack]
	invoke_java_method(NO_ivwq_invoker_error)
	;************* END invokeJavaMethod

Lb(ivqw_not_ijn):
	push eax					;mb
	push edx					;ebx = o handle to self
	call DWORD PTR [eax + mb_invoker]		;invoker(o,mb,args_size,ee)
 	add esp, 16					;pop 4 dwords 
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	test eax,eax					;Was there an error?
	je	Lb(NO_ivqw_invoker_error)
	; Requirement before calling macro- ecx = ee
	finish_call_method

Lb(ivqw_not_normal_object):
        ;; set ecx to be appropriate methodtable, which is
        ;; classJavaLangObject->obj->methodtable
	mov ecx, DWORD PTR [CName(classJavaLangObject)]
	mov ecx, DWORD PTR [ecx + o_obj]
	mov ecx, DWORD PTR [ecx + ucbMethodTable]
	jmp Lb(ivqw_macro_done)			

Lb(NO_ivqw_invoker_error):
	xor eax,eax					; exception
	jmp	Lb(NO_except)

Lb(NO_ivq_native_invoker_error):
	sub esi, 3					; take 3 off of esi
	xor	eax, eax				;exception
	jmp	Lb(NO_except)

;***********************************************************************
;* NO_invokesuper_quick
;* (based almost entirely on invokenonvirtual_quick)
;*
;***********************************************************************
  

Def210(invokesuper_quick)

; Assumptions: esi = pc[0], edi = sp[0]
; ClassClass *currentClass = (&frame->currentmethod->fb)->clazz
; ClassClass *superClass   = cbSuperClass(currentClass)
; mb = ((superClass)->methodTable)->methods[offset]

	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	mov ebx, DWORD PTR [ebx + javaframe_current_method]
	mov ebx, DWORD PTR [ebx + mb_fb + fb_clazz]	;current clazz
	mov ebx, DWORD PTR [ebx + o_obj]		;current class info
	mov ebx, DWORD PTR [ebx + ucbSuperclass]	;super classs
	mov ebx, DWORD PTR [ebx + o_obj]		;super clazz info
	mov ebx, DWORD PTR [ebx + ucbMethodTable]	;method table
	
	xor ecx, ecx
	mov ch, BYTE PTR [esi+1]			;GET_INDEX() macro
	xor edx,edx		
	mov cl, BYTE PTR [esi+2]
	
	mov eax, DWORD PTR [ebx + ecx*4 + methodtable_methods] ;method block
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	cmp DWORD PTR [eax + mb_invoker], CName(invokeJavaMethod)
	jne Lb(invsq_not_ijn)					 

	;************* invokeJavaMethod
	MOV(edx, dx, WORD PTR [eax + mb_args_size])			 
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	push ebx					;save old frame pointer
	lea ecx, [esi+3]				;ecx = pc + 3
	lea edx,[edx*4]					;edx*4
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;pc + 3 (BEFORE COMPARE)
	sub edi,edx					;-arg_size(BEFORE . .)
	mov ecx, DWORD PTR [ebx + javaframe_javastack]	
	
        ;; make sure argument isn't NULL
	Verify(DWORD PTR [edi],ne,0,NullPointer,NSP(4))	
	mov DWORD PTR [ebx + javaframe_optop],edi	; DECACHE_OPTOP()
	xor edx,edx
	mov DWORD PTR [ebx + javaframe_lastpc],esi
	mov dx, WORD PTR [eax + mb_maxstack]		;C
        invoke_java_method(NO_invsq_invoker_error)
	;************* END invokeJavaMethod

Lb(invsq_not_ijn):
	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	MOV(edx,dx, WORD PTR [eax + mb_args_size])
	push ecx					;ee
	push edx					;arg_size
	shl edx,2					;edx*4
	mov ecx, esi					;ecx = esi, pc
	sub edi,edx					;edi -= arg_size 
	add ecx, 3					;ecx = pc +3 
	mov edx, [edi]					;edx = S_HANDLE(sp[0])
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3
	Verify(edx,ne,0,NullPointer,NSP(8))		;sp[0]=0 (0 ptr exception)	
	mov DWORD PTR [ebx + javaframe_optop],edi	;equiv to DECACHE_OPTOP()
	mov DWORD PTR [ebx + javaframe_lastpc],esi
	push eax					;mb
	push edx					;ebx = o handle to self
	call DWORD PTR [eax + mb_invoker]		;invoker(o,mb,args_size,ee)
 	add esp, 16					;pop 4 dwords 
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
 	test eax,eax					;Was there an error?
	je	Lb(NO_invsq_invoker_error)
	; Requirement before calling macro: ecx = ee
	finish_call_method										
Lb(NO_invsq_invoker_error):
	xor eax,eax					;exception occured trap
	jmp	Lb(NO_except)			

	
;***********************************************************************
;* NO_invokevirtualobject_quick
;*
;***********************************************************************
  

Def210(invokevirtualobject_quick)

; Assumptions- esi = pc[0], edi = sp[0]

	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
	xor edx,edx		

	mov ebx, DWORD PTR [ecx + ee_current_frame]	;ebx = ee->current_frame
	mov dl, BYTE PTR [esi + 2]			;edx = mb.args_size
	push ecx					;ee
	push edx					;arg_size
	shl edx,2					;edx*4
	mov ecx, esi					;ecx = esi, pc

	sub edi,edx					;edi -= arg_size
	add ecx, 3					;ecx = pc +3 
	
	mov edx, [edi]					;edx = S_HANDLE(sp[0])
	mov DWORD PTR [ebx + javaframe_returnpc],ecx 	;javaframe->returnpc=pc+3

	Verify(edx,ne,0,NullPointer,NSP(8))		;sp[0]=0 (0 ptr exception)	
	mov DWORD PTR [ebx + javaframe_optop],edi	;equiv to DECACHE_OPTOP()
	mov DWORD PTR [ebx + javaframe_lastpc],esi	;where ifndef was

        ;; mb = mt_slot(obj_array_methodtable(o),mb->fb.u.offset)
        ;; edx = o
	;; can trash ecx, ebx, eax...

	mov ebx, DWORD PTR [edx + o_methods]
	and ebx, FJ_FLAG_MASK
	
	cmp ebx, FJ_T_NORMAL_OBJECT						
	jz Lb(ivow_normal_object)

	mov ebx, DWORD PTR [CName(classJavaLangObject)]	; javaLangObject
	mov ecx, DWORD PTR [ebx + o_obj]		
	mov ecx, [ecx + ucbMethodTable]			; its method table
	jmp Lb(ivow_macro_done)

Lb(ivow_normal_object):
	mov ecx, DWORD PTR [edx + o_methods]

Lb(ivow_macro_done):					
	;; now ecx = correct object methodtable

	xor ebx,ebx
	mov bl, BYTE PTR [esi + 1]
	mov eax, DWORD PTR [ecx + ebx * 4 + methodtable_methods] ;mb = (o)->methods.methods[mb->fb.u.offset]	
							; + 4?
	push eax					;mb
	push edx					;ebx = o handle to self
	call DWORD PTR [eax + mb_invoker]		;mb->invoker(o,mb,args_size,ee)
 
	add esp, 16					;pop 4 dwords 
	mov ecx, DWORD PTR _ee$[esp]			;ecx = ee
 	test eax,eax					;Was there an error?
	je	Lb(NO_ivow_invoker_error)

	; Requirement before calling macro- ecx = ee
	finish_call_method			
	
Lb(NO_ivow_invoker_error):
	xor eax,eax					; exception
	jmp	Lb(NO_except)

;***********************************************************************
;* return
;*
;***********************************************************************

Def210(return)
	mov edx, DWORD PTR _ee$[esp]			; edx=ee
	mov edx, DWORD PTR [edx+ee_current_frame]	; edx=ee->current_frame
	mov DWORD PTR [edx+javaframe_optop],edi

	finish_return(NORETURN,0,0,NO)


;***********************************************************************
;* areturn,freturn,ireturn
;*	Current Frame					Prev Frame
;*  N2 N1 di-1 di-2		 >>   		N2 N1 di-1 di-2
;*	       RV   A	  				   RV   1	
;***********************************************************************

Def210( areturn,freturn,ireturn)
	mov edx, DWORD PTR _ee$[esp]			;edx=ee
	mov edx, DWORD PTR [edx+ee_current_frame]	;edx=ee->current_frame
	mov DWORD PTR [edx+javaframe_optop],edi
	mov ebx, DWORD PTR [edi - 4]
	finish_return(AFINO,1,1,N1,push ebx,,pop ebx,)		
	
;***********************************************************************
;* lreturn,dreturn
;*
;*	Current Frame					Prev Frame
;*  N2 N1 di-1 di-2		   >> 		N2  N1 di-1 di-2
;*	      RV2  RV1   				RV2 RV1	 1	 2
;***********************************************************************

Def210(lreturn, dreturn)
	mov edx, DWORD PTR _ee$[esp]			;edx=ee
	mov edx, DWORD PTR [edx+ee_current_frame]	;edx=ee->current_frame
	mov DWORD PTR [edx+javaframe_optop],edi
	mov ecx, DWORD PTR [edi - 4]			;ecx = RV1, ebx = RV2
	mov ebx, DWORD PTR [edi - 8] 
	finish_return(LDNO,2,2,N2,push ebx,push ecx,pop ecx,pop ebx)

