;
; @(#)executeJava_p5.m4	1.39 98/08/13
;
; Copyright 1996-1998 by Sun Microsystems, Inc.,
; 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
; All rights reserved.
;
; This software is the confidential and proprietary information
; of Sun Microsystems, Inc. ("Confidential Information").  You
; shall not disclose such Confidential Information and shall use
; it only in accordance with the terms of the license agreement
; you entered into with Sun.
;

define(`Lb',`$1'CPU)
define(`L5',`$1'5)
define(`L6',`$1'6)
define(`Lg',`$1')

ifdef(`SOLARIS',
      `define(`__allmul',`__mul64')
       define(`__alldiv',`__div64')
       define(`__allrem',`__rem64')
       define(`CName',$1)
       define(`_drem',`fmod')
       define(`BigLabel',`Lb($1) PROC NEAR')
    ',`define(`CName',_$1)
       define(`BigLabel',`Lb($1):')'
     )

;	Transfer to new opcode and state

define(`Ld_opc',`ifelse(CPU,6,`movzx	eax, BYTE PTR [esi+$1]',`mov	al, BYTE PTR [esi+$1]')')

define(`Dispatch0',`jmp	DWORD PTR Lb(targets_0) [eax*4]')
define(`Dispatch1',`jmp	DWORD PTR Lb(targets_1) [eax*4]')
define(`Dispatch2',`jmp	DWORD PTR Lb(targets_2) [eax*4]')

define(`JumpDispatch0',`
	mov	edx, DWORD PTR _ee$[esp]
	mov	dl, BYTE PTR [edx+ee_exceptionKind]
	test	dl, dl				; ee->exceptionKind ?
	jnz	Lb(NO_except)			; we are toast
	Dispatch0')
define(`JumpDispatch1',`
	mov	edx, DWORD PTR _ee$[esp]
	mov	dl, BYTE PTR [edx+ee_exceptionKind]
	test	dl, dl				; ee->exceptionKind ?
	jnz	Lb(N1_except)			; we are toast
	Dispatch1')
define(`JumpDispatch2',`
	mov	edx, DWORD PTR _ee$[esp]
	mov	dl, BYTE PTR [edx+ee_exceptionKind]
	test	dl, dl				; ee->exceptionKind ?
	jnz	Lb(N2_except)			; we are toast
	Dispatch2')

;	Avoid bswap if processor could be 386
define(`Bswap',`ifelse(CPU,6,`bswap	e$1',`rol	$1,8
	rol	e$1,16
	rol	$1,8')')

;	Offset constants for "C" data structures
include(`fjconst.inc')


;	This hack reflects the obj_length hack in oobj.h
define(`Get_obj_length_word',  `mov	$1, DWORD PTR [$2+o_methods]')
define(`Get_obj_length_field', `shr	$1, METHOD_FLAG_BITS')

; ====== 1 state entry macros ========
define(`Def0',`BigLabel(NO_$1)
ifelse($2,`',`',`Def0(shift($@))')')

define(`Def1',`BigLabel(N1_$1)
ifelse($2,`',`',`Def1(shift($@))')')

define(`Def2',`BigLabel(N2_$1)
ifelse($2,`',`',`Def2(shift($@))')')
; ====================================

; ====== 2 state entry macros ========
define(`Def01',`
Def0($@)
	mov	ebx, DWORD PTR [edi-4]
	sub	edi, 4
Def1($@)')

define(`Def21',`
Def2($@)
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	add	edi, 4
Def1($@)')
; ====================================

; ====== 3 state entry macros ========
define(`Def210',`
Def2($@)
	mov	DWORD PTR [edi], ebx
	add	edi, 4
	mov	ebx, ecx
Def1($@)
	mov	DWORD PTR [edi], ebx
	add	edi, 4
Def0($@)')

define(`Def021',`
Def0($@)
	mov	ebx, DWORD PTR [edi-4]
	sub	edi, 4
	jmp	Lb(N1_$1)
Def2($@)
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	add	edi, 4
Def1($@)')

define(`Def201',`
Def2($@)
	mov	DWORD PTR [edi], ebx
	add	edi, 4
	mov	ebx, ecx
	jmp	Lb(N1_$1)
Def0($@)
	mov	ebx, DWORD PTR [edi-4]
	sub	edi, 4
Def1($@)')

define(`Def012',`
Def0($@)
	mov	ebx, DWORD PTR [edi-4]
	sub	edi, 4
Def1($@)
	mov	ecx, ebx
	mov	ebx, DWORD PTR [edi-4]
	sub	edi, 4
Def2($@)')
; ====================================

define(`SP',``add	edi, eval('$1`*4)'')
define(`Sp',``add	esp, eval('$1`*4)'')
define(`IP',``add	esi, eval('$1`*1)'')
define(`Detail',``mov	ebx, Lg($1)'')


define(`Verify',`
	cmp	$1,$3
	j$2	@F
	mov	ebx, Lg(Empty)
	mov	eax, Lg(`$4')
ifelse(`$5',`',`',`	$5
')dnl
ifelse(`$6',`',`',`	$6
')dnl
ifelse(`$7',`',`',`	$7
')dnl
ifelse(`$8',`',`',`	$8
')dnl
ifelse(`$9',`',`',`	$9
')dnl
	jmp	Lb($error)
@@:')

define(`Cverify',`
ifelse(`$1',`',`',`	j$1	@F
')dnl
	mov	ebx, Lg(Empty)
	mov	eax, Lg(`$2')
ifelse(`$3',`',`',`	$3
')dnl
ifelse(`$4',`',`',`	$4
')dnl
ifelse(`$5',`',`',`	$5
')dnl
ifelse(`$6',`',`',`	$6
')dnl
ifelse(`$7',`',`',`	$7
')dnl
ifelse(`$8',`',`',`	$8
')dnl
ifelse(`$9',`',`',`	$9
')dnl
	jmp	Lb($error)
@@:')

define(`BoundsCheck',`
	cmp	$1,$3
	j$2	@F
	$5
	$6
	mov	ebx, $3
	jmp	Lb($indexOutOfBounds)
@@:')

define(`DEBUG',1)
	
define(`Assert',`ifdef(`DEBUG',`Verify(`$1',`$2',`$3',Internal,Detail(AssertFail),`$4',`$5',`$6',`$7')',`; assert `$1' `$2' `$3'')')

ifelse(CPU,`5',`
TITLE	..\..\..\..\src\share\javavm\runtime\fastjava.asm
.386
.model FLAT

PUBLIC	CName(ExecuteJava)
EXTERN 	CName(classJavaLangObject):DWORD 
EXTERN  CName(jvmpi_event_flags):DWORD			
EXTERN  CName(jvmpi_method_entry):NEAR
EXTERN  CName(jvmpi_method_exit):NEAR
EXTERN	CName(is_instance_of):NEAR
EXTERN	CName(throwArrayIndexOutOfBoundsException):NEAR
EXTERN	CName(throwClassCastException):NEAR
EXTERN	CName(ThrowStackOverflowError):NEAR
EXTERN	CName(allocObject):NEAR
EXTERN	CName(allocArray):NEAR
EXTERN	CName(sizearray):NEAR
EXTERN	CName(SignalError):NEAR
EXTERN  CName(monitorExit2):NEAR
EXTERN  CName(monitorEnter2):NEAR
EXTERN  CName(invokeInterfaceError):NEAR
EXTERN  CName(invokeJavaMethod):NEAR			
EXTERN  CName(invokeNativeMethod):NEAR		
EXTERN  CName(FixupQuickInvocation):NEAR
EXTERN  CName(ResolveClassConstant):NEAR
EXTERN  CName(ProcedureFindThrowTag):NEAR
EXTERN  CName(hpi_thread_interface):NEAR
EXTERN  CName(x86_CPUlevel):NEAR
EXTERN  CName(x86_getfield):NEAR
EXTERN  CName(x86_putfield):NEAR
EXTERN  CName(x86_getstatic):NEAR
EXTERN  CName(x86_putstatic):NEAR
EXTERN  CName(x86_new):NEAR
EXTERN  CName(x86_invokeinterface):NEAR
EXTERN  CName(x86_invokespecial):NEAR
EXTERN  CName(x86_invokestatic):NEAR
EXTERN  CName(x86_invokevirtual):NEAR
EXTERN  CName(x86_multianewarray_quick):NEAR
EXTERN  CName(x86_ijm_javastack_overflow):NEAR


EXTERN	__allmul:NEAR
EXTERN	__alldiv:NEAR
EXTERN	__allrem:NEAR
EXTERN  _drem:NEAR
_TEXT	SEGMENT

;;; Amount of scratch space at the base of the stack
_lsize$ = 12
	
;;; Use of stack space at the base of the stack.  There offsets are incremented
;;; by 16 to make up for the 4 registers pushed above them.
_cp$ = 16	; java current constant pool
_if$ = 20 	; java initial frame
_scratch$ = 24	; temporary space			

;; Originally, these are at 4(esp) and 8(esp).  However, we push _lsize$ bytes
;; of temporary space and 16 bytes of registers.
_ee$ = 24 + _lsize$	; rightmost parm is java exec environment
_pc$ = 20 + _lsize$	; leftmost  parm is java pc


; Permanent register assignments

;   esi is pc (java pc)
;   edi is sp (java tos)
;   ebp is pv (java locals)
;
;   In state 2,
;     ecx is top stack elt
;     ebx is top-1 stack elt
;
;   In state 1,
;     ecx is undefined
;     ebx is top stack elt
;
;   In state 0,
;     ecx is undefined
;     ebx is undefined
;
;   At entry to each opcode/state handler, eax is zero-extended current opcode.
;
;   Many code sequences depend on the eax zero fill, some depend on al
;   containing the opcode byte.

CName(ExecuteJava) PROC NEAR
;	bool_t ExecuteJava(unsigned char *pc, ExecEnv *ee) 
;
;	Execute bytecodes at "pc" in the specified execution environment.
;
;	Returns TRUE if completed OK, FALSE if finished because of some
;	uncaught exception.

	sub	esp, _lsize$
	push	ebx
	push	esi
	push	edi
	push	ebp
	mov	esi, _pc$ [esp]			; pc = java pc
	mov	edx, _ee$[esp]			; ee = java exec environment
	mov	edx, [edx+ee_current_frame]
	mov	[esp+_if$], edx			; if = ee->current_frame
	mov	edi, [edx+javaframe_optop]	; sp = if->optop
	mov	ebp, [edx+javaframe_vars]	; pv = if->vars;
	mov	[edx+javaframe_lastpc], esi	; if->last_pc = pc
	mov	edx, [edx+javaframe_constant_pool]
	mov	[esp+_cp$], edx			; cp = if->constant_pool
	mov	edx, CName(hpi_thread_interface)
	mov     edx, [edx]
	call    dword ptr [edx + hpi_thread_checkstack]	; this is just a stub !

	test	eax, eax
	jz	Lg($stack_err)
	
	push	getCPUtype		; call back routine, if wanted
	call	CName(x86_CPUlevel)
	add	esp,4

	cmp	al, 6
	jge	L6($doit)

L5($doit):
	movzx	eax, BYTE PTR [esi]
	jmp	DWORD PTR [L5(targets_0)+eax*4]

L6($doit):
	movzx	eax, BYTE PTR [esi]
	jmp	DWORD PTR [L6(targets_0)+eax*4]


Lg($stack_err):
        push    0
        push	0
	call    CName(ThrowStackOverflowError)
	add	sp, 8

Lg($exit):
	mov	edx, _ee$[esp]
	xor	eax, eax
	pop	ebp
	pop	edi
	pop	esi
	pop	ebx
	mov	al, BYTE PTR [edx+ee_exceptionKind]
	add	esp, _lsize$
	test	al, al
	setz	al	; return 1 iff no exception

	ret	0
',`.486')

	
define(`Clabel',
  `ifelse(
    $1,-1,iconst_m1,
    $1,0,`iconst_0,aconst_null,fconst_0',
    $1,1.0,fconst_1,
    $1,2.0,fconst_2,
    iconst_$1)')

define(`Cload',
  `ifelse(
    $2,0,`xor	$1, $1',
    $2,1.0,`mov	$1, 1065353216',
    $2,2.0,`mov	$1, 1073741824',
    `mov	$1,$2')')

define(`IFconst_N',`
Def0(Clabel($1))	;r0 = $1
	Ld_opc(1)
	inc	esi
	Cload(ebx,$1)
	Dispatch1
Def1(Clabel($1))	;r1 = $1
	Ld_opc(1)
	inc	esi
	Cload(ecx,$1)
	Dispatch2
Def2(Clabel($1))	;sp[0]=r0; r0=r1; r1=0;  sp+=1
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	Ld_opc(1)
	inc	esi
	add	edi, 4
	Cload(ecx,$1)
	Dispatch2
ifelse($2,`',`',`IFconst_N(shift($@))')')

IFconst_N(-1,0,1,2,3,4,5,1.0,2.0)

Def0(nop)
	Ld_opc(1)
	inc	esi
	Dispatch0
Def1(nop)	
	Ld_opc(1)
	inc	esi
	Dispatch1
Def2(nop)	
	Ld_opc(1)
	inc	esi
	Dispatch2


Def0(bipush)					;r0=(signed char)(pc[1])
	mov	bl, BYTE PTR [esi+1]
	Ld_opc(2)
	shl	ebx, 24
	add	esi, 2
	sar	ebx, 24
	Dispatch1
Def1(bipush)	;r1=(signed char)(pc[1])
	mov	cl, BYTE PTR [esi+1]
	Ld_opc(2)
	shl	ecx, 24
	add	esi, 2
	sar	ecx, 24
	Dispatch2
Def2(bipush)	;sp[0]=r0; r0=r1; r1=(signed char)(pc[1]); sp+=1
	mov	DWORD PTR [edi], ebx
	add	edi, 4
	mov	ebx, ecx
	mov	cl, BYTE PTR [esi+1]
	shl	ecx, 24
	Ld_opc(2)
	sar	ecx, 24
	add	esi, 2
	Dispatch2


Def0(sipush)					;r0=pc2s(pc+1)
	mov	bh, BYTE PTR [esi+1]
	mov	bl, BYTE PTR [esi+2]
	Ld_opc(3)
	shl	ebx, 16
	add	esi, 3
	sar	ebx, 16
	Dispatch1

Def1(sipush)	;r1=pc2s(pc+1)
	mov	ch, BYTE PTR [esi+1]
	mov	cl, BYTE PTR [esi+2]
	Ld_opc(3)
	shl	ecx, 16
	add	esi, 3
	sar	ecx, 16
	Dispatch2

Def2(sipush)	;sp[0]=r0; r0=r1; r1=pc2s(pc+1);  sp+=1
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	add	edi, 4
	mov	ch, BYTE PTR [esi+1]
	mov	cl, BYTE PTR [esi+2]
	Ld_opc(3)
	shl	ecx, 16
	add	esi, 3
	sar	ecx, 16
	Dispatch2


Def210(dload,lload)
;	r0=pv[pc[1]]
;	r1=pv[pc[1]+1]
	Ld_opc(1)
	add	esi, 2
	mov	ebx, DWORD PTR [ebp+eax*4]
	mov	ecx, DWORD PTR [ebp+eax*4+4]
	Ld_opc(0)
	Dispatch2


Def0(aload,iload,fload)			;r0=pv[pc[1]]
	Ld_opc(1)
	add	esi, 2
	mov	ebx, DWORD PTR [ebp+eax*4]
	Ld_opc(0)
	Dispatch1

Def1(aload,iload,fload)			;r1=pv[pc[1]]
	Ld_opc(1)
	add	esi, 2
	mov	ecx, DWORD PTR [ebp+eax*4]
	Ld_opc(0)
	Dispatch2

Def2(aload,iload,fload)	;sp[0]=r0; r0=r1; r1=pv[pc[1]];  sp+=1
	mov	DWORD PTR [edi], ebx
	Ld_opc(1)
	mov	ebx, ecx
	add	edi, 4
	add	esi, 2
	mov	ecx, DWORD PTR [ebp+eax*4]
	Ld_opc(0)
	Dispatch2


Def210(dconst_0,lconst_0)
;	r0=0; r1=0;
	xor	ebx, ebx
	Ld_opc(1)
	xor	ecx, ecx
	inc	esi
	Dispatch2


Def210(lconst_1)
;	r0=1; r1=0;
	xor	ecx, ecx
	Ld_opc(1)
	mov	ebx, 1
	inc	esi
	Dispatch2


Def210(dconst_1)
;	r0=0; r1=0x3ff00000;
	xor	ebx, ebx
	Ld_opc(1)
	mov	ecx, 3ff00000h
	inc	esi
	Dispatch2


Def210(dload_0,dload_1,dload_2,dload_3)
;	r0=(pv[(*pc-opc_dload_0)+0]);
;	r1=(pv[(*pc-opc_dload_0)+1]);
	mov	ebx, [0+ebp+eax*4-(4*opc_dload_0)]
	mov	dl, [esi+1]
	mov	ecx, [4+ebp+eax*4-(4*opc_dload_0)]
	mov	al, dl
	inc	esi
	Dispatch2


Def210(lload_0,lload_1,lload_2,lload_3)
;	r0=(pv[(*pc-opc_lload_0)+0]);
;	r1=(pv[(*pc-opc_lload_0)+1]);
	mov	ebx, [0+ebp+eax*4-(4*opc_lload_0)]
	mov	dl, [esi+1]
	mov	ecx, [4+ebp+eax*4-(4*opc_lload_0)]
	mov	al, dl
	inc	esi
	Dispatch2


Def012(dstore_0,dstore_1,dstore_2,dstore_3)
;	(pv[(*pc-opc_dstore_0)+0])=r0;
;	(pv[(*pc-opc_dstore_0)+1])=r1;
	mov	[0+ebp+eax*4-(4*opc_dstore_0)], ebx
	mov	dl, [esi+1]
	mov	[4+ebp+eax*4-(4*opc_dstore_0)], ecx
	mov	al, dl
	inc	esi
	Dispatch0


Def012(lstore_0,lstore_1,lstore_2,lstore_3)
;	(pv[(*pc-opc_lstore_0)+0])=r0;
;	(pv[(*pc-opc_lstore_0)+1])=r1;
	mov	[0+ebp+eax*4-(4*opc_lstore_0)], ebx
	mov	dl, [esi+1]
	mov	[4+ebp+eax*4-(4*opc_lstore_0)], ecx
	mov	al, dl
	inc	esi
	Dispatch0

define(`AIFload_N',`
Def0(aload_$1,iload_$1,fload_$1)		;r0=pv[$1]
	Ld_opc(1)
	mov	ebx, DWORD PTR [ebp+(4*$1)]
	inc	esi
	Dispatch1
Def1(aload_$1,iload_$1,fload_$1)		;r1=pv[$1]
	Ld_opc(1)
	mov	ecx, DWORD PTR [ebp+(4*$1)]
	inc	esi
	Dispatch2
Def2(aload_$1,iload_$1,fload_$1)	;s[0]=r0;r0=r1;r1=pv[$1];s++
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	Ld_opc(1)
	mov	ecx, DWORD PTR [ebp+(4*$1)]
	add	edi, 4
	inc	esi
	Dispatch2
ifelse($2,`',`',`AIFload_N(shift($@))')')

define(`AIFstore_N',`
Def01(astore_$1,istore_$1,fstore_$1)	;pv[$1]=r0
	Ld_opc(1)
	mov	DWORD PTR [ebp+(4*$1)], ebx
	inc	esi
	Dispatch0
Def2(astore_$1,istore_$1,fstore_$1)	;pv[$1]=r1
	Ld_opc(1)
	mov	DWORD PTR [ebp+(4*$1)], ecx
	inc	esi
	Dispatch1
ifelse($2,`',`',`AIFstore_N(shift($@))')')
	

AIFload_N(0,1,2,3)
AIFstore_N(0,1,2,3)


Def021(nonnull_quick)				;pop, error if null
	Verify(ebx,ne,0,NullPointer,SP(1))
	Ld_opc(1)
	inc	esi
	Dispatch0


Def0(pop)					;sp-=1
	Ld_opc(1)
	inc	esi
	sub	edi, 4
	Dispatch0
	
Def1(pop)
	Ld_opc(1)
	inc	esi
	Dispatch0
	
Def2(pop)
	Ld_opc(1)
	inc	esi
	Dispatch1


Def0(pop2)				;Discard top 2 wds
	Ld_opc(1)
	inc	esi
	sub	edi, 8
	Dispatch0

Def1(pop2)				;Discard top 2 wds
	Ld_opc(1)
	inc	esi
	sub	edi, 4
	Dispatch0

Def2(pop2)				;Discard top 2 wds
	Ld_opc(1)
	inc	esi
	Dispatch0


Def0(dup)					;r0=sp[-1]
	Ld_opc(1)
	inc	esi
	mov	ebx, DWORD PTR [edi-4]
	Dispatch1

Def1(dup)					;r1=r0
	Ld_opc(1)
	inc	esi
	mov	ecx, ebx
	Dispatch2

Def2(dup)					;sp[0]=r0;r0=r1;sp+=1
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	add	edi, 4
	Ld_opc(1)
	inc	esi
	Dispatch2


Def012(dup2)				;Duplicate top 2 wds
	Ld_opc(1)
	inc	esi
	mov	DWORD PTR [edi],   ebx
	mov	DWORD PTR [edi+4], ecx
	add	edi, 8
	Dispatch2


Def012(dup_x1)				;Insert top 2 down
	Ld_opc(1)
	inc	esi
	mov	DWORD PTR [edi],   ecx
	add	edi, 4
	Dispatch2


Def012(dup_x2)				;Insert top 3 down
	Ld_opc(1)
	inc	esi
	mov	edx, DWORD PTR [edi-4]
	mov	DWORD PTR [edi-4], ecx
	mov	DWORD PTR [edi], edx
	add	edi, 4
	Dispatch2


Def012(dup2_x1)				;Insert top (2 wds) 2 down
	Ld_opc(1)
	inc	esi
	mov	edx, DWORD PTR [edi-4]
	mov	DWORD PTR [edi-4], ebx
	mov	DWORD PTR [edi],   ecx
	mov	DWORD PTR [edi+4], edx
	add	edi, 8
	Dispatch2
	

Def012(dup2_x2)				;Insert top (2 wds) 3 down
	Ld_opc(1)
	inc	esi
	mov	edx, DWORD PTR [edi-4]
	mov	DWORD PTR [edi-4], ecx
	mov	DWORD PTR [edi+4], edx
	mov	edx, DWORD PTR [edi-8]
	mov	DWORD PTR [edi-8], ebx
	mov	DWORD PTR [edi], edx
	add	edi, 8
	Dispatch2


Def210(iinc)	;pv[pc[1]]+=((signed char *) pc)[2];
	Ld_opc(1)
	mov	cl, BYTE PTR [esi+2]
	sal	ecx, 24
	add	esi, 3
	sar	ecx, 24
	lea	ebx, DWORD PTR [ebp+eax*4]
	add	ecx, DWORD PTR [ebp+eax*4]
	Ld_opc(0)
	mov	DWORD PTR [ebx], ecx
	Dispatch0


Def210(wide)
	xor	edx, edx
	Ld_opc(1)
	mov	dh, [esi+2]
	push	edi		
	mov	dl, [esi+3]	 
	add	esi, 4
	mov	edi, Lg(wide_opc)
	mov	ecx, Lg(wide_end)-Lg(wide_opc)
	repne	scasb
	pop	edi
	Cverify(e,Internal,Detail(Undefined))
	jmp	[ecx*4+Lb(wide_targets)]
	
	
Lb(wide_aload):
Lb(wide_iload):
Lb(wide_fload):
;	r0=vars[edx]
	mov	ebx, DWORD PTR [ebp+edx*4]
	Ld_opc(0)
	Dispatch1
	
Lb(wide_dload):
Lb(wide_lload):
;	r0=vars[edx]
;	r1=vars[edx+1]
	mov	ebx, DWORD PTR [ebp+edx*4]
	Ld_opc(0)
	mov	ecx, DWORD PTR [ebp+edx*4+4]
	Dispatch2

Lb(wide_astore):
Lb(wide_istore):
Lb(wide_fstore):
;	vars[edx] = sp[-1]
;	sp-=1
	mov	ebx, [edi-4]
	Ld_opc(0)
	mov	DWORD PTR [ebp+edx*4], ebx
	sub	edi, 4
	Dispatch0

Lb(wide_dstore):
Lb(wide_lstore):
;	vars[edx] = sp[-2]
;	vars[edx+1] = sp[-1]
;	sp -= 2
	mov	ebx, [edi-8]
	Ld_opc(0)
	mov	ecx, [edi-4]
	mov	DWORD PTR [ebp+edx*4], ebx
	mov	DWORD PTR [ebp+edx*4+4], ecx
	sub	edi, 8
	Dispatch0

Lb(wide_iinc):
;	offset = (((signed char *)pc)[0] << 8) + pc[1];
;	vars[edx] += offset;
	mov	bh, BYTE PTR [esi]
	mov	bl, BYTE PTR [esi+1]
	sal	ebx, 16
	Ld_opc(2)
	sar	ebx, 16
	add	esi, 2
	add	[ebp+edx*4], ebx
	Dispatch0

Lb(wide_ret):
;	pc = vars[edx];
	mov	esi, [ebp+edx*4]
	Ld_opc(0)
	Dispatch0

define(`Goto_w',`
Def$1(goto_w)	;pc+=pc2l(pc+1)
	mov	dh, BYTE PTR [esi+1]
	mov	dl, BYTE PTR [esi+2]
	shl	edx,16
	mov	dh, BYTE PTR [esi+3]
	mov	dl, BYTE PTR [esi+4]
	Ld_opc(edx)
	add	esi, edx
        JumpDispatch$1')

	
Def21(jsr_w)
	lea	ecx, [esi+5]	; ecx=next addr, fall thru to goto_w(1)
Goto_w(2)

Def0(jsr_w)
	lea	ebx, [esi+5]	; ebx=next addr, fall thru to goto_w(0)
Goto_w(1)

Goto_w(0)

Def0(goto)	;pc+=pc2s(pc+1);
	mov	dh, BYTE PTR [esi+1]
	mov	dl, BYTE PTR [esi+2]
	sal	edx, 16
	sar	edx, 16
	Ld_opc(edx)
	add	esi, edx
	JumpDispatch0
	
Def1(goto)	;pc+=pc2s(pc+1)
	mov	dh, BYTE PTR [esi+1]
	mov	dl, BYTE PTR [esi+2]
	sal	edx, 16
	sar	edx, 16
	Ld_opc(edx)
	add	esi, edx
	JumpDispatch1
	
Def2(goto)	;pc+=pc2s(pc+1)
	mov	dh, BYTE PTR [esi+1]
	mov	dl, BYTE PTR [esi+2]
	sal	edx, 16
	sar	edx, 16
	Ld_opc(edx)
	add	esi, edx
	JumpDispatch2

	
Def210(jsr)	;pc+=pc2s(pc+1);
	lea	ebx, [esi+3]
	mov	dh, BYTE PTR [esi+1]
	mov	dl, BYTE PTR [esi+2]
	sal	edx, 16
	sar	edx, 16
	Ld_opc(edx)
	add	esi, edx
	JumpDispatch1

	
Def210(ret)
	Ld_opc(1)
	mov	esi, DWORD PTR [ebp+eax*4]
	Ld_opc(0)
	Dispatch0

	
Def201(tableswitch)
;	long *lpc=(long *) (pc+1) & 0xfffffffc;
;	int key=ebx
;	int low=SWAP32(lpc[1]);
;	int high=SWAP32(lpc[2]);
;	key -= low;
;	high -= low;
;	pc+= key > high ? SWAP32(lpc[0]) : SWAP32(lpc[key+3]);
	lea	edx, [esi+4]
	and	edx, -4		; aligned pc
	mov	ecx, [edx+4]	; low
	Bswap(cx)
	mov	eax, [edx+8]	; high
	Bswap(ax)
	sub	ebx, ecx	; key -= low
	sub	eax, ecx	; high -= low
	cmp	ebx, eax
	ja	Lb($tdefault)
	lea	edx, [edx+ebx*4+12]
Lb($tdefault):
	mov	edx, [edx]
	xor	eax, eax
	Bswap(dx)
	Ld_opc(edx)
	add	esi, edx
	JumpDispatch0

	
Def201(lookupswitch)
;	long *lpc=(long *) (pc+1) & 0xfffffffc;
;	int key=SWAP32(ebx)
;	int skip=lpc[0]; /* default skip amount */
;	int npairs=SWAP32(lpc[1]);
;	while (--npairs >= 0)
;	{ lpc+=2;
;	  if (key == lpc[0])
;	  { skip=lpc[1];
;	    break;
;	  }
;	}
;	skip=SWAP32(skip);
;	pc+=skip;
	Bswap(bx)		; put selector in BE form
	lea	edx, [esi+12]
	and	edx, -4		; edx pts to first pair
	mov	ecx, [edx-4]
	Bswap(cx)		; ecx has npairs
	test	ecx, ecx
	jz	Lb($lnotfound)
Lb($ltop):
	mov	eax, [edx]
	add	edx, 8
	cmp	eax, ebx
	je	Lb($lfound)
Lb($lcond):
	dec	ecx
	jnz	Lb($ltop)
Lb($lnotfound):	; point edx 4 beyond the default offset
	lea	edx, [esi+8]
	and	edx, -4
Lb($lfound):	; edx pts 4 beyond the correct offset
	mov	edx, [edx-4]
	xor	eax, eax
	Bswap(dx)
	Ld_opc(edx)
	add	esi, edx
	JumpDispatch0

	
Def210(arraylength)	;CHK(!sp[-1]);sp[-1]=obj_length((JHandle*)sp[-1])
	mov	eax, DWORD PTR [edi-4]
	Verify(eax,ne,0,NullPointer)
	Get_obj_length_word(eax,eax)
	inc	esi
	Get_obj_length_field(eax)
	mov	DWORD PTR [edi-4], eax
	xor	eax, eax
	Ld_opc(0)
	Dispatch0

	
Def0(ldc_quick)	;r0=cp[pc[1]]
	mov	edx, DWORD PTR _cp$[esp]
	xor	ecx, ecx
	mov	cl, BYTE PTR [esi+1]
	Ld_opc(2)
	add	esi, 2
	mov	ebx, DWORD PTR [edx+ecx*4]
	Dispatch1
	
Def1(ldc_quick)	;r1=cp[pc[1]]
	xor	ecx, ecx
	mov	edx, DWORD PTR _cp$[esp]
	mov	cl, BYTE PTR [esi+1]
	Ld_opc(2)
	add	esi, 2
	mov	ecx, DWORD PTR [edx+ecx*4]
	Dispatch2
	
Def2(ldc_quick)	;sp[0]=r0; r0=r1; r1=cp[pc[1]];  sp+=1
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	xor	ecx, ecx
	mov	edx, DWORD PTR _cp$[esp]
	mov	cl, BYTE PTR [esi+1]
	Ld_opc(2)
	add	esi, 2
	add	edi, 4
	mov	ecx, DWORD PTR [edx+ecx*4]
	Dispatch2

	
Def210(ldc2_w_quick)
;	r0=cp[pc2u(pc+1)];
;	r1=cp[pc2u(pc+1)+1];
	mov	edx, DWORD PTR _cp$[esp]
	xor	ecx, ecx
	mov	ch, BYTE PTR [esi+1]	; PC2U
	mov	cl, BYTE PTR [esi+2]	; PC2U
	mov	ebx, DWORD PTR [edx+ecx*4]
	Ld_opc(3)
	mov	ecx, DWORD PTR [edx+ecx*4+4]
	add	esi, 3
	Dispatch2

	
Def0(ldc_w_quick)	;r0=cp[pc2u(pc+1)]
	mov	edx, DWORD PTR _cp$[esp]
	xor	ecx, ecx
	mov	ch, BYTE PTR [esi+1]	; PC2U
	mov	cl, BYTE PTR [esi+2]	; PC2U
	Ld_opc(3)
	add	esi, 3
	mov	ebx, DWORD PTR [edx+ecx*4]
	Dispatch1
	
Def1(ldc_w_quick)	;r1=cp[pc2u(pc+1)]
	xor	ecx, ecx
	mov	edx, DWORD PTR _cp$[esp]
	mov	ch, BYTE PTR [esi+1]	; PC2U
	mov	cl, BYTE PTR [esi+2]	; PC2U
	Ld_opc(3)
	add	esi, 3
	mov	ecx, DWORD PTR [edx+ecx*4]
	Dispatch2
	
Def2(ldc_w_quick)	;sp[0]=r0; r0=r1; r1=cp[pc2u(pc+1)];  sp+=1
	mov	DWORD PTR [edi], ebx
	mov	ebx, ecx
	xor	ecx, ecx
	mov	edx, DWORD PTR _cp$[esp]
	mov	ch, BYTE PTR [esi+1]	; PC2U
	mov	cl, BYTE PTR [esi+2]	; PC2U
	Ld_opc(3)
	add	esi, 3
	mov	ecx, DWORD PTR [edx+ecx*4]
	add	edi, 4
	Dispatch2


Def01(i2b)	;r0= (signed char)    r0
	shl	ebx, 24
	Ld_opc(1)
	sar	ebx, 24
	inc	esi
	Dispatch1
	
Def2(i2b)	;r1= (signed char)    r1
	shl	ecx, 24
	Ld_opc(1)
	sar	ecx, 24
	inc	esi
	Dispatch2


Def01(i2c)	;r0= (unsigned short) r0
	shl	ebx, 16
	Ld_opc(1)
	shr	ebx, 16
	inc	esi
	Dispatch1
	
Def2(i2c)	;r1= (unsigned short) r1
	shl	ecx, 16
	Ld_opc(1)
	shr	ecx, 16
	inc	esi
	Dispatch2

	
Def01(i2s)	;r0= (signed short)   r0
	shl	ebx, 16
	Ld_opc(1)
	sar	ebx, 16
	inc	esi
	Dispatch1
	
Def2(i2s)	;r1= (signed short)   r1
	shl	ecx, 16
	Ld_opc(1)
	sar	ecx, 16
	inc	esi
	Dispatch2

	
Def01(ineg)	;r0= -r0
	Ld_opc(1)
	inc	esi
	neg	ebx
	Dispatch1
	
Def2(ineg)	;r1= -r1
	Ld_opc(1)
	inc	esi
	neg	ecx
	Dispatch2

	
Def012(swap)
	;tmp=r0; r0=r1; r1=tmp
	mov	eax, ebx
	mov	ebx, ecx
	mov	ecx, eax
	xor	eax, eax
 	Ld_opc(1)
	inc	esi
	Dispatch2

	
Def012(lsub)
	Ld_opc(1)
	sub	[edi-8], ebx
	sbb	[edi-4], ecx
	inc	esi
	Dispatch0

	
Def012(lneg)
	Ld_opc(1)
	neg	ebx
	adc	ecx,0
	inc	esi
	neg	ecx
	Dispatch2

	
Def012(lcmp)
	mov	edx, [edi-4]
	Ld_opc(1)
	sub	edi, 8
	inc	esi
	cmp	edx, ecx
	jl	Lb($lc_lt)
	mov	edx, [edi]
	jg	Lb($lc_ge)
	cmp	edx, ebx
	jb	Lb($lc_lt)
Lb($lc_ge):
	mov	ebx, 0
	setne	bl
	Dispatch1
Lb($lc_lt):
	mov	ebx, -1
	Dispatch1
	
define(`RealToInteger',`
Def210($1)
	fld     ifelse($2,8,QWORD,DWORD) PTR [edi-$2]
	fstcw   WORD PTR _scratch$[esp]
	ftst				; set the flags, if needed
	mov	dx, WORD PTR _scratch$[esp]
	or	dx, (3 SHL 10)		; set rounding mode to "chop"
	mov 	WORD PTR _scratch$[esp + 2],dx
	fldcw	WORD PTR _scratch$[esp + 2]
	fistp   DWORD PTR [edi - $2]	    
	fldcw	WORD PTR _scratch$[esp]	; reset the floating point point
    	mov     ebx, DWORD PTR [edi - $2]	    
	sub	edi,$2	
	cmp	ebx, 80000000h		; possible error result?
	je	Lb(f2i_unusual)
	Ld_opc(1)			; everything is fine
	inc	esi
	Dispatch1
')
	
define(`RealToLong',`
Def210($1)
	fld     ifelse($2,8,QWORD,DWORD) PTR [edi-$2]
	fstcw   WORD PTR _scratch$[esp]
	ftst				; set the flags, if needed
	mov	dx, WORD PTR _scratch$[esp]
	or	dx, (3 SHL 10)		; set rounding mode to "chop"
	mov 	WORD PTR _scratch$[esp + 2],dx
	fldcw	WORD PTR _scratch$[esp + 2]
	fistp   QWORD PTR [edi - $2]	    
	fldcw	WORD PTR _scratch$[esp]	; reset the floating point point
	mov	ecx, DWORD PTR 4[edi - $2] ; high word of result
	mov	edx,80000000h
	mov	ebx, DWORD PTR [edi - $2] ; low word of result
        ;; check if high word is 80000000h and low word is 0
	xor	edx,ecx	
	sub	edi, $2			; decrement stack
	or	edx,ebx	
	je	Lb(f2l_unusual)
	Ld_opc(1)	
	inc	esi	
	Dispatch2
')


RealToInteger(f2i,4)			
RealToInteger(d2i,8)
RealToLong(f2l,4)
RealToLong(d2l,8)			; 

Lb(f2i_unusual): 
        ;; ebx contains 80000000h
	fnstsw	ax			; get fpu flags in ax	  
	sahf
	jp	Lb(f2i_NaN)		; parity bit indicates NaN
	adc	ebx,-1			; carry bit is set if result was < 0
	xor	eax,eax
	Ld_opc(1)	
	inc	esi
	Dispatch1
Lb(f2i_NaN):	
        ;; return 0
	xor	eax,eax
	xor	ebx,ebx
	Ld_opc(1)	
	inc	esi
	Dispatch1

	
	
	
Lb(f2l_unusual):    
        ;; ecx contains 80000000h, ebx contains 0
	fnstsw	ax			; get fpu flags in ax	  
	sahf				; 
	jp	Lb(f2l_NaN)		; parity bit indicates NaN
	adc	ebx,-1			; carry bit is set if result was < 0
	adc	ecx,-1
	xor	eax,eax
	Ld_opc(1)	
	inc	esi
	Dispatch2
Lb(f2l_NaN):	
	;; return 0L
	xor	eax,eax			; return zeros 
	xor	ecx,ecx
	Ld_opc(1)	
	inc	esi
	Dispatch2

	
Def210(i2f)
	fild	DWORD PTR [edi-4]
	fstp	DWORD PTR [edi-4]
	Ld_opc(1)
	inc	esi
	Dispatch0

	
Def210(l2d)
	fild	QWORD PTR [edi-8]
	fstp	QWORD PTR [edi-8]
	Ld_opc(1)
	inc	esi
	Dispatch0

	
Def210(f2d)
	fld	DWORD PTR [edi-4]
	fstp	QWORD PTR [edi-4]
	add	edi, 4
	Ld_opc(1)
	inc	esi
	Dispatch0

	
Def210(i2d)
	fild	DWORD PTR [edi-4]
	fstp	QWORD PTR [edi-4]
	add	edi, 4
	Ld_opc(1)
	inc	esi
	Dispatch0


Def021(i2l)
	mov	ecx, ebx
	Ld_opc(1)
	sar	ecx, 31
	inc	esi
	Dispatch2

	
Def0(l2i)	; Discard the most significant 4 bytes
	Ld_opc(1)
	inc	esi
	sub	edi, 4
	Dispatch0
Def1(l2i)
	Ld_opc(1)
	inc	esi
	Dispatch0
Def2(l2i)
	Ld_opc(1)
	inc	esi
	Dispatch1

	
Def210(d2f)
	fld	QWORD PTR [edi-8]
	fstp	DWORD PTR [edi-8]
	sub	edi, 4
	Ld_opc(1)
	inc	esi
	Dispatch0

Def210(l2f)
	fild	QWORD PTR [edi-8]
	fstp	DWORD PTR [edi-8]
	sub	edi, 4
	Ld_opc(1)
	inc	esi
	Dispatch0

	
define(`Ladd',`
Def012(l$1)	;r0=l$1 r0,r1;
	mov	edx, [edi-8]
	inc	esi
	$1	ebx, edx
	mov	edx, [edi-4]
	Ld_opc(0)
	ifelse($1,add,adc,$1)	ecx, edx
	sub	edi, 8
	Dispatch2
ifelse($2,`',`',`Ladd(shift($@))')')
Ladd(add,and,or,xor)

	
define(`Iadd',`
Def012(i$1)	;r0=$1 r0,r1
	ifelse($1,mul,imul,$1)	ebx, ecx
	Ld_opc(1)
	inc	esi
	Dispatch1
ifelse($2,`',`',`Iadd(shift($@))')')
Iadd(add,sub,and,or,xor,mul)

	
define(`Lshl',`
Def012(l$1)
        ;; ecx has the shift; ebx has high word.  
        ;; Note that we only care about (ecx && 63).  The x86 shift operators
        ;; automatically only look at the low 5 bits
	test     ecx, 32		; is high bit of shift set?
	jne	Lb(l$1_wide)		; go to special code
	mov	edx, [edi-4]		; get low word
	sub	edi, 4
	Ld_opc(1)
        ;; do the shift
	ifelse($1,ushr,`    shrd    edx,ebx,cl
	                    shr	    ebx,cl')
	ifelse($1,shr,`     shrd    edx,ebx,cl
	                    sar	    ebx,cl')
	ifelse($1,shl,`     shld    ebx,edx,cl
			    sal	    edx,cl')
	mov	ecx,ebx			; ecx gets high word of result
	mov	ebx,edx			; ebx gets low word of result
	inc	esi
	Dispatch2	    
ifelse($2,`',`',`Lshl(shift($@))')')

Lshl(shl,shr,ushr)
	
Lb(lushr_wide):				; lushr of 32 <= shift < 64
	; ecx has the shift, ebx has the high word;		
        shr	ebx,cl			; set low word to high word shifted
	xor	ecx,ecx			; set high word to zero
	Ld_opc(1)
	sub	edi, 4			; pop low word off stack
	inc	esi
	Dispatch2	    
Lb(lshr_wide):				; lshr of 32 <= shift < 64
        ; ecx has the shift, ebx has the high word; 
        sar	ebx,cl			; set low word to high word shifted
	Ld_opc(1)
	mov	ecx,ebx			; set high word to all sign bit
	sar	ecx,31
	sub	edi, 4			; pop low word off stack
	inc	esi
	Dispatch2	    
Lb(lshl_wide):				; lshl of 32 <= shift < 64
        ; ecx has the shift, ebx has the high word;	
	mov	edx, [edi-4]		; get low word
	sub	edi, 4
	Ld_opc(1)
        shl	edx,cl			; shift appropriately
	xor	ebx,ebx			; set low word to 0
	mov	ecx,edx			; set high word to value
	inc	esi
	Dispatch2	    


define(`Ldiv',`
Def012(l$1)	;r0=l$1 (sp[-2]:sp[-1],r0:r1)
	mov	eax, [edi-8]
	push	ecx
	mov	edx, [edi-4]
	push	ebx
	push	edx
	push	eax
	ifelse($1,mul,`',`or	ebx, ecx
	Cverify(nz,Arithmetic,SP(2),Sp(4),Detail(ByZero))')
	call	__all$1
	mov	ebx, eax
	xor	eax, eax
	Ld_opc(1)
	sub	edi, 8
	mov	ecx, edx
	inc	esi
	Dispatch2
ifelse($2,`',`',`Ldiv(shift($@))')')
Ldiv(div,mul,rem)

	
Def210(frem)	; Use _drem from math_md.c
	sub	esp, 16
	fld	DWORD PTR [edi-8]
	fstp	QWORD PTR [esp]
	fld	DWORD PTR [edi-4]
	fstp	QWORD PTR [esp+8]
	call	_drem
	fstp	DWORD PTR [edi-8]
	sub	edi, 4
	jmp	Lb($drem_common)

	
Def012(drem)	; Use _drem from math_md.c
	mov	eax, [edi-8]
	push	ecx
	mov	edx, [edi-4]
	push	ebx
	push	edx
	push	eax
	call	_drem
	fstp	QWORD PTR [edi-8]
Lb($drem_common):
	xor	eax, eax
	add	esp, 16
	Ld_opc(1)
	inc	esi
	Dispatch0

	
define(`Ishl',`
Def012(i$1)	;r0=i$1 r0,r1
	ifelse($1,shr,sar,$1,ushr,shr,shl)	ebx, cl
	Ld_opc(1)
	inc	esi
	Dispatch1
ifelse($2,`',`',`Ishl(shift($@))')')
Ishl(shl,shr,ushr)

	
define(`Idiv',`
Def012(i$1)	;CHK(!r1); r0=$1 r0,r1
	mov	eax, ebx
	inc	esi
	cdq
Lb(__i$1_inst):
	idiv	ecx
Lb($i$1_done):
	mov	ebx, ifelse($1,div,eax,edx)
	xor	eax, eax
	Ld_opc(0)
	Dispatch1
Lb(__i$1_trap):
	Verify(ecx,ne,0,Arithmetic,SP(2),Detail(ByZero))
	mov	eax, 80000000h
	mov	edx, 0
	jmp	Lb($i$1_done)
EXTERNDEF Lb(__i$1_inst):PTR  ;visible to javai exception handler
EXTERNDEF Lb(__i$1_trap):PTR  ; "                          "
ifelse($2,`',`',`Idiv(shift($@))')')

Idiv(div,rem)

	
define(`Dadd',`
Def210(d$1)
	Ld_opc(1)
	inc	esi
	fld	QWORD PTR [edi-16]
	f$1	QWORD PTR [edi-8]
	fstp	QWORD PTR [edi-16]
	sub	edi, 8
	Dispatch0
ifelse($2,`',`',`Dadd(shift($@))')')
Dadd(add,sub,mul,div)

	
define(`Fadd',`
Def210(f$1)
	Ld_opc(1)
	inc	esi
	fld	DWORD PTR [edi-8]
	f$1	DWORD PTR [edi-4]
	fstp	DWORD PTR [edi-8]
	sub	edi, 4
	Dispatch0
ifelse($2,`',`',`Fadd(shift($@))')')
Fadd(add,sub,mul,div)

	
Def210(fcmpl,fcmpg)
	fld	DWORD PTR [edi-8]
	fcomp	DWORD PTR [edi-4]
	sub	edi, 8
	; pretend we had dcmpl/dcmpg
	add	eax, (opc_dcmpl-opc_fcmpl)
	jmp	Lb($dc_flags)

	
Def210(dcmpl,dcmpg)
	fld	QWORD PTR [edi-16]
	fcomp	QWORD PTR [edi-8]
	sub	edi, 16
Lb($dc_flags):
	mov	ebx, eax	; in case we had NaN
	inc	esi
	fnstsw	ax		; get fpu flags in ax
	sahf			; set cpu flags from fp flags
	mov	eax, 0
	Ld_opc(0)
	jnp	Lb($dc_nrml)	; parity flag == NaN
	cmp	bl, opc_dcmpl
	je	Lb($dc_less)
Lb($dc_nrml):
	setne	bl
	jae	Lb($dc_done)
Lb($dc_less):
	mov	ebx, -1
Lb($dc_done):
	Dispatch1

	
Def210(dneg)
	Ld_opc(1)
	inc	esi
	fld	QWORD PTR [edi-8]
	fchs
	fstp	QWORD PTR [edi-8]
	Dispatch0
	

Def210(fneg)
	Ld_opc(1)
	inc	esi
	fld	DWORD PTR [edi-4]
	fchs
	fstp	DWORD PTR [edi-4]
	Dispatch0

	
Def012(dstore,lstore)
;	pv[pc[1]]=r0
;	pv[pc[1]+1]=r1
	Ld_opc(1)
	add	esi, 2
	mov	DWORD PTR [ebp+eax*4], ebx
	mov	DWORD PTR [ebp+eax*4+4], ecx
	Ld_opc(0)
	Dispatch0

	
Def01(astore,istore,fstore)			;pv[pc[1]]=r0
	Ld_opc(1)
	add	esi, 2
	mov	DWORD PTR [ebp+eax*4], ebx
	Ld_opc(0)
	Dispatch0

Def2(astore,istore,fstore)			;pv[pc[1]]=r1
	Ld_opc(1)
	add	esi, 2
	mov	DWORD PTR [ebp+eax*4], ecx
	Ld_opc(0)
	Dispatch1


	
Def01(ifeq,ifnull)				;if(r0==0) goto ttaken
	test	ebx, ebx
	je	SHORT Lb($ttaken_0)
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def01(ifne,ifnonnull)				;if(r0!=0) goto ttaken
	test	ebx, ebx
	jne	SHORT Lb($ttaken_0)
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def01(iflt)					;if(r0 <0) goto ttaken
	test	ebx, ebx
	jl	SHORT Lb($ttaken_0)
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def01(ifge)					;if(r0>=0) goto ttaken
	test	ebx, ebx
	jge	SHORT Lb($ttaken_0)
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def01(ifgt)					;if(r0 >0) goto ttaken
	test	ebx, ebx
	jg	SHORT Lb($ttaken_0)
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Lb($ttaken_0): ; pc+=pc2s(pc+1);
	mov	ah, BYTE PTR [esi+1]	; PC2S
	mov	al, BYTE PTR [esi+2]	; PC2S
	shl	eax, 16
	sar	eax, 16
	add	esi, eax
	xor	eax, eax
	Ld_opc(0)
	JumpDispatch0

Def01(ifle)					;if(r0<=0) goto ttaken
	test	ebx, ebx
	jle	SHORT Lb($ttaken_0)
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def2(ifeq,ifnull)				;if(r1==0) goto ttaken
	test	ecx, ecx
	je	SHORT Lb($ttaken_1)
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Def2(ifne,ifnonnull)				;if(r1!=0) goto N2_ttaken
	test	ecx, ecx
	jne	SHORT Lb($ttaken_1)
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Def2(iflt)					;if(r1 <0) goto N2_ttaken
	test	ecx, ecx
	jl	SHORT Lb($ttaken_1)
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Def2(ifge)					;if(r1>=0) goto N2_ttaken
	test	ecx, ecx
	jge	SHORT Lb($ttaken_1)
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Def2(ifgt)					;if(r1 >0) goto N2_ttaken
	test	ecx, ecx
	jg	SHORT Lb($ttaken_1)
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Def2(ifle)					;if(r1<=0) goto N2_ttaken
	test	ecx, ecx
	jle	SHORT Lb($ttaken_1)
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Lb($ttaken_1): ; pc+=pc2s(pc+1)
	mov	ah, BYTE PTR [esi+1]	; PC2S
	mov	al, BYTE PTR [esi+2]	; PC2S
	shl	eax, 16
	sar	eax, 16
	add	esi, eax
	xor	eax, eax
	Ld_opc(0)
	JumpDispatch1

Def012(if_icmpeq,if_acmpeq)	;if(r0 == r1) goto N2_icmpeq_not_taken;
	cmp	ebx, ecx
	mov	bh, BYTE PTR [esi+1]	; PC2S
	mov	bl, BYTE PTR [esi+2]	; PC2S
	jne	SHORT Lb($N2_icmpeq_not_taken)
	shl	ebx, 16
	sar	ebx, 16
	Ld_opc(ebx)
	add	esi, ebx
	JumpDispatch0
Lb($N2_icmpeq_not_taken): ; pc+=pc2s(pc+1);
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def012(if_icmpne,if_acmpne)	;if(r0 != r1) goto N2_icmpne_not_taken;
	cmp	ebx, ecx
	mov	bh, BYTE PTR [esi+1]	; PC2S
	mov	bl, BYTE PTR [esi+2]	; PC2S
	je	SHORT Lb($N2_icmpne_not_taken)
	shl	ebx, 16
	sar	ebx, 16
	Ld_opc(ebx)
	add	esi, ebx
	JumpDispatch0
Lb($N2_icmpne_not_taken): ; pc+=pc2s(pc+1);
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def012(if_icmplt)	;if(r0 < r1) goto N2_icmplt_not_taken;
	cmp	ebx, ecx
	mov	bh, BYTE PTR [esi+1]	; PC2S
	mov	bl, BYTE PTR [esi+2]	; PC2S
	jge	SHORT Lb($N2_icmplt_not_taken)
	shl	ebx, 16
	sar	ebx, 16
	Ld_opc(ebx)
	add	esi, ebx
	JumpDispatch0
Lb($N2_icmplt_not_taken): ; pc+=pc2s(pc+1);
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def012(if_icmpge)	;if(r0 >= r1) goto N2_icmpge_not_taken;
	cmp	ebx, ecx
	mov	bh, BYTE PTR [esi+1]	; PC2S
	mov	bl, BYTE PTR [esi+2]	; PC2S
	jl	SHORT Lb($N2_icmpge_not_taken)
	shl	ebx, 16
	sar	ebx, 16
	Ld_opc(ebx)
	add	esi, ebx
	JumpDispatch0
Lb($N2_icmpge_not_taken): ; pc+=pc2s(pc+1);
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def012(if_icmpgt)	;if(r0 > r1) goto N2_icmpgt_not_taken;
	cmp	ebx, ecx
	mov	bh, BYTE PTR [esi+1]	; PC2S
	mov	bl, BYTE PTR [esi+2]	; PC2S
	jle	SHORT Lb($N2_icmpgt_not_taken)
	shl	ebx, 16
	sar	ebx, 16
	Ld_opc(ebx)
	add	esi, ebx
	JumpDispatch0
Lb($N2_icmpgt_not_taken): ; pc+=pc2s(pc+1);
	Ld_opc(3)
	add	esi, 3
	Dispatch0

Def012(if_icmple)	;if(r0 <= r1) goto N2_icmple_not_taken;
	cmp	ebx, ecx
	mov	bh, BYTE PTR [esi+1]	; PC2S
	mov	bl, BYTE PTR [esi+2]	; PC2S
	jg	SHORT Lb($N2_icmple_not_taken)
	shl	ebx, 16
	sar	ebx, 16
	Ld_opc(ebx)
	add	esi, ebx
	JumpDispatch0
Lb($N2_icmple_not_taken): ; pc+=pc2s(pc+1);
	Ld_opc(3)
	add	esi, 3
	Dispatch0


Def021(getfield2_quick)
;	t=(((JHandle*)r0)->obj);
;	r0=t[pc[1]];
;	r1=t[pc[1]+1];
	Verify(ebx,ne,0,NullPointer,SP(1))
	mov	edx, DWORD PTR [ebx+o_obj]	; t=(r0->obj)
	Ld_opc(1)
	mov	ebx, DWORD PTR [edx+eax*4]	; r0=t[pc[1]]
	mov	ecx, DWORD PTR [edx+eax*4+4]	; r1=t[pc[1]]
	Ld_opc(3)
	add	esi, 3
	Dispatch2


Def012(putfield_quick_w)
;	fb=(void*) cb[pc2u(pc+1)];
;	char* t=fieldsig(fb)
;	char isig=t[0]
;	offset=fb->u.offset
;	if (isig == SIGNATURE_LONG || isig == SIGNATURE_DOUBLE)
;	{ o=(void*)(s[-1]);
;	  o=o->obj;
;	  o[offset] = r0;
;	  o[offset+1] = r1;
;	else
;	{ r0=r0->obj
;	  r0[offset] = r1;
;	}
	mov	edx, DWORD PTR _cp$[esp]
	mov	ah, BYTE PTR [esi+1]
	mov	al, BYTE PTR [esi+2]
	add	esi, 3
	mov	eax, DWORD PTR [edx+eax*4]		; fb=cp[pc2u(pc+1)]
	mov	edx, DWORD PTR [eax+fb_signature]	; t=fieldsig(fb)
	mov	eax, [eax+fb_offset]			; offset=fb->u.offset
	mov	dl, BYTE PTR [edx]			; isig=*t
	cmp	dl, SIGNATURE_LONG
	je	Lb($pqw_islong)
	cmp	dl, SIGNATURE_DOUBLE
	je	Lb($pqw_islong)
	Verify(ebx,ne,0,NullPointer,SP(2),IP(-3))
	mov	ebx, DWORD PTR [ebx+o_obj]		; r0=(r0->obj)
	mov	[ebx+eax], ecx
	xor	eax, eax
	Ld_opc(0)
	Dispatch0
Lb($pqw_islong):
	mov	edx, [edi-4]
	sub	edi, 4
	Verify(edx,ne,0,NullPointer,SP(3), IP(-3))
	mov	edx, DWORD PTR [edx+o_obj]		; r0=(r0->obj)
	mov	[edx+eax], ebx
	mov	[edx+eax+4], ecx
	xor	eax, eax
	Ld_opc(0)
	Dispatch0

	
Def021(getfield_quick_w)
;	fb=(void*)cb[pc2u(pc+1)]
;	char* t=fieldsig(fb)
;	char isig=t[0]
;	offset=fb->u.offset
;	r0=(((JHandle *)r0)->obj)
;	if (isig == SIGNATURE_LONG || isig == SIGNATURE_DOUBLE)
;	{ r0+=offset
;	  r1=r0[1]
;	  r0=*r0
;	}
;	else
;	  r0=r0[offset]
	Verify(ebx,ne,0,NullPointer,SP(1))
	mov	ebx, DWORD PTR [ebx+o_obj]		; r0=(r0->obj)
	xor	ecx, ecx
	mov	edx, DWORD PTR _cp$[esp]
	mov	ch, BYTE PTR [esi+1]
	mov	cl, BYTE PTR [esi+2]
	add	esi, 3
	mov	ecx, DWORD PTR [edx+ecx*4]		; fb=cp[pc2u(pc+1)]
	mov	edx, DWORD PTR [ecx+fb_signature]	; t=fieldsig(fb)
	Ld_opc(0)
	mov	ecx, [ecx+fb_offset]			; offset=fb->u.offset
	mov	dl, BYTE PTR [edx]			; isig=*t
	cmp	dl, SIGNATURE_LONG
	je	Lb($gqw_islong)
	cmp	dl, SIGNATURE_DOUBLE
	je	Lb($gqw_islong)
	mov	ebx, [ebx+ecx]
	Dispatch1

Lb($gqw_islong):
	add	ebx, ecx
	mov	ecx, [ebx+4]
	mov	ebx, [ebx]
	Dispatch2
	
Def01(getfield_quick)
;	r0=(((JHandle *)r0)->obj)
;	r0=r0[pc[1]]
	Verify(ebx,ne,0,NullPointer,SP(1))
	Ld_opc(1)
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=(r0->obj)
	mov	ebx, DWORD PTR [ebx+eax*4]	; r0=r0[pc[1]]
	Ld_opc(3)
	add	esi, 3
	Dispatch1

Def2(getfield_quick)
;	r1=(((JHandle *)r1)->obj); r1=r1[pc[1]]
	Verify(ecx,ne,0,NullPointer,SP(2))
	Ld_opc(1)
	mov	ecx, DWORD PTR [ecx+o_obj]	; r1=(r1->obj)
	mov	ecx, DWORD PTR [ecx+eax*4]	; r1=r1[pc[1]]
	Ld_opc(3)
	add	esi, 3
	Dispatch2

	
Def012(putfield2_quick)
;	t=(void*)(s[-1])->obj
;	t[pc[1]+0] = r0;
;	t[pc[1]+1] = r1;
;	sp-=1;
	mov	edx, [edi-4]
	sub	edi, 4
	Verify(edx,ne,0,NullPointer,SP(3))
	mov	edx, DWORD PTR [edx+o_obj]	; t=(s[-1]->obj)
	Ld_opc(1)
	mov	DWORD PTR [edx+eax*4], ebx	; t[pc[1]]=r0
	mov	DWORD PTR [edx+eax*4+4], ecx	; t[pc[1]]=r1
	Ld_opc(3)
	add	esi, 3
	Dispatch0

	
Def012(putfield_quick)
;	r0=(((JHandle*)r0)->obj);
;	r0[pc[1]] = r1;
	Verify(ebx,ne,0,NullPointer,SP(2))
	Ld_opc(1)
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=(r0->obj)
	mov	DWORD PTR [ebx+eax*4], ecx	; r0[pc[1]]=r1
	Ld_opc(3)
	add	esi, 3
	Dispatch0

	
Def210(getstatic2_quick)
;	t=cp[pc2u(pc+1)];
;	t=twoword_static_address(t);
;	r0=t[0];
;	r1=t[1];
	mov	edx, _cp$[esp]
	xor	ecx, ecx
	mov	ch, [esi+1]
	mov	cl, [esi+2]
	Ld_opc(3)
	add	esi, 3
	mov	edx, DWORD PTR [edx+ecx*4]	; t=cp[pc2u(pc+1)]
	mov	edx, [edx+fb_static_address]
	mov	ebx, DWORD PTR [edx]		; r0=t[0]
	mov	ecx, DWORD PTR [edx+4]		; r1=t[1]
	Dispatch2

	
Def0(getstatic_quick)
;	fb=(void*) cp[pc2u(pc+1)];
;	r0 = *((int *) (&fb->u.static_value))
	mov	edx, DWORD PTR _cp$[esp]
	xor	ebx, ebx
	mov	bh, BYTE PTR [esi+1]
	Ld_opc(3)
	mov	bl, BYTE PTR [esi+2]
	mov	ebx, DWORD PTR [edx+ebx*4]	; fb=cp[pc2u(pc+1)]
	mov	ebx, DWORD PTR [ebx+fb_static_value]
	add	esi, 3
	Dispatch1

Def21(getstatic_quick)
;	fb=(void*) cp[pc2u(pc+1)];
;	r1 = *((int *) (&fb->u.static_value))
	mov	edx, DWORD PTR _cp$[esp]
	xor	ecx, ecx
	mov	ch, BYTE PTR [esi+1]
	Ld_opc(3)
	mov	cl, BYTE PTR [esi+2]
	mov	ecx, DWORD PTR [edx+ecx*4]	; fb=cp[pc2u(pc+1)]
	mov	ecx, DWORD PTR [ecx+fb_static_value]
	add	esi, 3
	Dispatch2

	
Def012(putstatic2_quick)
;	t=cp[pc2u(pc+1)];
;	t=twoword_static_address(t);
;	t[0]=r0;
;	t[1]=r1;
	mov	edx, _cp$[esp]
	mov	ah, [esi+1]
	mov	al, [esi+2]
	mov	edx, DWORD PTR [edx+eax*4]	; t=cp[pc2u(pc+1)]
	mov	edx, [edx+fb_static_address]
	add	esi, 3
	xor	eax, eax
	mov	DWORD PTR [edx], ebx		; t[0]=r0
	Ld_opc(0)
	mov	DWORD PTR [edx+4], ecx		; t[1]=r1
	Dispatch0

	
Def01(putstatic_quick)
;	fb=(void*) c[pc2u(pc+1)];
;	*((int *)(&fb->u.static_value)) = r0;
	mov	edx, DWORD PTR _cp$[esp]
	xor	ecx, ecx
	mov	ch, BYTE PTR [esi+1]
	Ld_opc(3)
	mov	cl, BYTE PTR [esi+2]
	mov	ecx, DWORD PTR [edx+ecx*4]	; fb=cp[pc2u(pc+1)]
	mov	DWORD PTR [ecx+fb_static_value], ebx
	add	esi, 3
	Dispatch0

Def2(putstatic_quick)
;	fb=(void*) c[pc2u(pc+1)];
;	*((int *)(&fb->u.static_value)) = r1;
	mov	DWORD PTR [edi], ebx
	xor	ebx, ebx
	mov	bh, BYTE PTR [esi+1]
	Ld_opc(3)
	mov	bl, BYTE PTR [esi+2]
	mov	edx, DWORD PTR _cp$[esp]
	mov	ebx, DWORD PTR [edx+ebx*4]	; fb=cp[pc2u(pc+1)]
	add	esi, 3
	mov	DWORD PTR [ebx+fb_static_value], ecx
	mov	ebx, DWORD PTR [edi]
	Dispatch1

	
Def210(invokeignored_quick)
	xor	ecx, ecx
	mov	cl, BYTE PTR [esi+1]		; args_size = pc[1]
	lea	ecx, [ecx*4]
	sub	edi, ecx			; optop -= args_size
	mov	ebx, DWORD PTR [edi]		; o = S_HANDLE(0)
	xor	ecx, ecx
	mov	cl, BYTE PTR [esi+2]		; if pc[2] != 0
	test	ecx, ecx
	jz	Lb($iig_z)
	Verify(ebx,ne,0,NullPointer)		; && o==0 then NullPointer
Lb($iig_z):
	Ld_opc(3)
	add	esi, 3
	Dispatch0


Def210(unimplemented,breakpoint,xxxunusedxxx,software,hardware)
	Cverify(`',Internal,Detail(Undefined))

Lb($indexOutOfBounds):
	mov ecx, _ee$[esp]			; ecx = ee
	mov ecx, [ecx+ee_current_frame]		; ecx = ee->frame
	mov [ecx+javaframe_lastpc], esi		; ee->frame->lastpc = pc
	push	ebx
	call	CName(throwArrayIndexOutOfBoundsException)
	add	esp, 4
	jmp	Lb(NO_except)

Lb($error):	; Only reached via verify macros; java stack is in `0' state
	mov ecx, _ee$[esp]			; ecx = ee
	mov ecx, [ecx+ee_current_frame]		; ecx = ee->frame
	mov [ecx+javaframe_lastpc], esi		; ee->frame->lastpc = pc
	push	ebx
	push	eax
	push	DWORD PTR _ee$[esp+8]
	call	CName(SignalError)
	add	esp, 12
	jmp	Lb(NO_except)

	
Def210(except)	; ee->exceptionKind is non-zero.  If there is a catch block
		; in this method, clear the exception, empty the stack, and
		; branch to the catch ode.  Otherwise, execute a method
		; return, which will restore the calling activation and
		; branch back here so we can try it again.

;	object = ee->exception.exc;
;	new_pc = ProcedureFindThrowTag(frame, object, pc);

	mov	edx, _ee$[esp]
	mov	eax, [edx+ee_current_frame]	; frame = ee->current_frame
	mov	ebx, [edx+ee_exception]		; object = ee->exception.exc
	push	ebx				; save exception object
	push	esi				; pass pc
	push	ebx				; pass object
	push	eax				; pass frame
	push	edx				; pass ee
	mov	[eax+javaframe_optop], edi	; decache sp

	xor	eax, eax
	mov	[edx+ee_exceptionKind], al      ; exceptionClear(ee)

	call	CName(ProcedureFindThrowTag)
	add	esp, 16

	pop	ebx				; recover exception object
	mov	edx, _ee$[esp]

	cmp	BYTE PTR [edx+ee_exceptionKind], 0
	jnz	Lb($except_1)

	mov	BYTE PTR [edx+ee_exceptionKind], 1
	mov	DWORD PTR [edx+ee_exception], ebx
Lb($except_1):

;	if (new_pc == 0)
;	  goto finish_return
	test	eax, eax
	jz	Lb(NO_return)			; return, and throw again
;	ee->exceptionKind = 0
;	frame->optop = sp = &(frame->ostack[0])
	mov	esi, eax
	xor	eax, eax
	mov	edx, _ee$[esp]
	mov	[edx+ee_exceptionKind], al
	Ld_opc(0)
	mov	edx, [edx+ee_current_frame]	; frame = ee->current_frame
	mov	ebp, [edx+javaframe_vars]	; vars = frame->vars
	mov	ecx, [edx+javaframe_constant_pool]
	lea	edi, [edx+javaframe_ostack]	; sp = &(frame->ostack[0])
	mov	_cp$[esp],ecx			; cp = frame->constant_pool
	mov	[edx+javaframe_optop], edi	; frame->optop = sp
	Dispatch1			; Branch to catch block, which
						; handles the exception at tos
						; (which is still in ebx)

Def012(laload,daload)
;	CHK(r0==0);
;	CHK(r1>=obj_length(r0));
;	r0 = (r0->obj)
;	r1 = r0->body+r1
;	r0 = *r1
;	r1 = *(r1+1)
	Verify(ebx,ne,0,NullPointer,SP(2))
	Get_obj_length_word(edx,ebx)
	inc	esi
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=r0->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,ecx,SP(2),IP(-1))
	shl	ecx, 3				; index in bytes
	add	ecx, ebx			; r1 = r0->body+r1
	Ld_opc(0)
	mov	ebx, [ecx]
	mov	ecx, [ecx+4]
	Dispatch2


Def012(iaload,faload,aaload)
;	CHK(r0==0);
;	CHK(r1>=obj_length(r0));
;	r0 = (r0->obj);
;	r0 = r0->body[r1]
	Verify(ebx,ne,0,NullPointer,SP(2))
	Get_obj_length_word(edx,ebx)
	inc	esi
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=r0->obj
	Get_obj_length_field(edx)		; obj_length
	Ld_opc(0)
	BoundsCheck(edx,nbe,ecx,SP(2),IP(-1))
	mov	ebx, DWORD PTR [ebx+ecx*4]
	Dispatch1

	
Def012(saload)
;	HArrayOfShort *r0;
;	CHK(r0==0);
;	CHK(r1>=obj_length(r0));
;	r0 = (r0->obj);
;	r0 = r0->body[r1]
	Verify(ebx,ne,0,NullPointer,SP(2))
	Get_obj_length_word(edx,ebx)
	inc	esi
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=r0->obj
	Get_obj_length_field(edx)		; obj_length
	Ld_opc(0)
	BoundsCheck(edx,nbe,ecx,SP(2),IP(-1))
	movsx	ebx, WORD PTR [ebx+ecx*2]
	Dispatch1

	
Def012(caload)
;	HArrayOfChar *r0;
;	CHK(r0==0);
;	CHK(r1>=obj_length(r0));
;	r0 = (r0->obj);
;	r0 = r0->body[r1]
	Verify(ebx,ne,0,NullPointer,SP(2))
	Get_obj_length_word(edx,ebx)
	inc	esi
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=r0->obj
	Get_obj_length_field(edx)		; obj_length
	Ld_opc(0)
	BoundsCheck(edx,nbe,ecx,SP(2),IP(-1))
	movzx	ebx, WORD PTR [ebx+ecx*2]
	Dispatch1

Def012(baload)
;	HArrayOfByte *r0;
;	CHK(r0==0);
;	CHK(r1>=obj_length(r0));
;	r0 = (r0->obj);
;	r0 = r0->body[r1]
	Verify(ebx,ne,0,NullPointer,SP(2))
	Get_obj_length_word(edx,ebx)
	inc	esi
	mov	ebx, DWORD PTR [ebx+o_obj]	; r0=r0->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,ecx,SP(2),IP(-1))
	Ld_opc(0)
	movsx	ebx, BYTE PTR [ebx+ecx]
	Dispatch1

	
Def012(bastore)
;	HArrayOfByte *a = (void*)s[-1];
;	CHK(a==0);
;	CHK(r0>=obj_length(a));
;	a = (a->obj);
;	a->body[r0] = r1; s-=1
	mov	eax, DWORD PTR [edi-4]
	sub	edi, 4
	Verify(eax,ne,0,NullPointer,SP(3))
	Get_obj_length_word(edx,eax)
	inc	esi
	mov	eax, DWORD PTR [eax+o_obj]	; a=a->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,ebx,SP(3),IP(-1))
	mov	BYTE PTR [eax+ebx], cl
	xor	eax, eax
	Ld_opc(0)
	Dispatch0

	
Def012(lastore,dastore)
;	HArrayOfLong *a = (void*)s[-2];
;	CHK(a==0);
;	CHK(s[-1]>=obj_length(a));
;	a=a->obj
;	a->body[s[-1]] = r0;
;	a->body[s[-1]+1] = r1;
	mov	eax, DWORD PTR [edi-8]
	sub	edi, 8
	Verify(eax,ne,0,NullPointer,SP(4))
	Get_obj_length_word(edx,eax)
	inc	esi
	mov	eax, DWORD PTR [eax+o_obj]	; a=a->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,[edi+4],SP(4),IP(-1))
	mov	edx, [edi+4]
	mov	[eax+edx*8], ebx
	mov	[eax+edx*8+4], ecx
	xor	eax, eax
	Ld_opc(0)
	Dispatch0


Def012(iastore,fastore)
;	HArrayOfInt *a = (void*)s[-1];
;	CHK(a==0);
;	CHK(r0>=obj_length(a));
;	a = (a->obj);
;	a->body[r0] = r1; s-=1
	mov	eax, DWORD PTR [edi-4]
	sub	edi, 4
	Verify(eax,ne,0,NullPointer,SP(3))
	Get_obj_length_word(edx,eax)
	inc	esi
	mov	eax, DWORD PTR [eax+o_obj]	; a=a->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,ebx,SP(3),IP(-1))
	mov	DWORD PTR [eax+ebx*4], ecx
	xor	eax, eax
	Ld_opc(0)
	Dispatch0

	
Def012(aastore)
;	HArrayOfObject *a = (void*)s[-1];
;	CHK(a==0);
;	CHK(r0>=obj_length(a));
;	a = (a->obj);
;	ClassClass *aay_cb = (ClassClass *)(a->body[obj_length(a)]);
;	CHK(!is_instance_of((JHandle*)r1,aay_cb,ee));
;	a->body[r0] = r1; s-=1
	mov	eax, DWORD PTR [edi-4]
	sub	edi, 4
	Verify(eax,ne,0,NullPointer,SP(3))
	Get_obj_length_word(edx,eax)
	inc	esi
	mov	eax, DWORD PTR [eax+o_obj]	; a=a->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,ebx,SP(3),IP(-1))
	push	eax
	push	ecx
	push	DWORD PTR _ee$[esp+8]		; pass ee
	push	DWORD PTR [eax+edx*4]		; pass aay_cb
	push	ecx				; pass N2
	call	CName(is_instance_of)
	add	esp, 12
	pop	ecx
	Verify(eax,ne,0,ArrayStore,Sp(1),SP(3),IP(-1))
	pop	eax
	mov	DWORD PTR [eax+ebx*4], ecx
	xor	eax, eax
	Ld_opc(0)
	Dispatch0


	
Def012(sastore,castore)
;	HArrayOfShort *a = (void*)s[-1];
;	CHK(a==0);
;	CHK(r0>=obj_length(a));
;	a = (a->obj);
;	a->body[r0] = r1; s-=1
	mov	eax, DWORD PTR [edi-4]
	sub	edi, 4
	Verify(eax,ne,0,NullPointer,SP(3))
	Get_obj_length_word(edx,eax)
	inc	esi
	mov	eax, DWORD PTR [eax+o_obj]	; a=a->obj
	Get_obj_length_field(edx)		; obj_length
	BoundsCheck(edx,nbe,ebx,SP(3),IP(-1))
	mov	WORD PTR [eax+ebx*2], cx
	xor	eax, eax
	Ld_opc(0)
	Dispatch0

	
Def021(checkcast_quick)
;	CHK(!is_instance_of(r0,cp[pc2u(pc+1)], ee));
	mov	edx, DWORD PTR _cp$[esp]
	mov	ah, BYTE PTR [esi+1]
	mov	ecx,_ee$[esp]
	mov	al, BYTE PTR [esi+2]
	push	ecx				; pass ee
	mov	ecx, DWORD PTR [edx+eax*4]	; ecx=cp[pc2u(pc+1)]
	push	ecx				; pass cp[pc2u(pc+1)]
	push	ebx				; pass r0
	add	esi, 3
	call	CName(is_instance_of)
	add	esp, 12
	test	eax,eax
	je	@F
	xor	eax, eax
	Ld_opc(0)
	Dispatch1
@@:
	add	esi, -3
	mov     ecx, _ee$[esp]			; ecx = ee
	mov     ecx, [ecx+ee_current_frame]	; ecx = ee->frame
	mov 	[ecx+javaframe_lastpc], esi	; ee->frame->lastpc = pc
	push	ebx
	call	CName(throwClassCastException)
	add	esp, 4
	jmp	Lb(NO_except)

Def021(instanceof_quick)
;	r0 = ((r0 != 0) && is_instance_of(r0,cp[pc2u(pc+1), ee));
;	CHK(ee->exceptionKind != 0);
	test	ebx, ebx
	jz	Lb($iof_zero)
	mov	edx, DWORD PTR _cp$[esp]
	mov	ah, BYTE PTR [esi+1]
	mov	ecx,_ee$[esp]
	mov	al, BYTE PTR [esi+2]
	push	ecx				; pass ee
	mov	ecx, DWORD PTR [edx+eax*4]
	push	ecx				; pass cp[pc2u(pc+1)]
	push	ebx				; pass r0
	mov	ebx, DWORD PTR _ee$[esp+12]
	call	CName(is_instance_of)
	add	esp, 12
	mov	cl, BYTE PTR [ebx+ee_exceptionKind]
	test	cl, cl				; ee->exceptionKind ?
	jnz	Lb(N1_except)			; we are toast
	mov	ebx, eax
	xor	eax, eax
Lb($iof_zero):
	Ld_opc(3)
	add	esi, 3
	Dispatch1

	
Def210(new_quick)
;	ClassClass *cb = (void*) cp[pc2u(pc+1)];
;	r0 = (int) allocObject(ee, cb);
;	CHK(r0==0);
;	memset(r0->obj, 0, cbInstanceSize(cb));
;[Sheng 11/8/96] memset has been moved into allocObject.
	mov	edx, DWORD PTR _cp$[esp]
	mov	ah, BYTE PTR [esi+1]
	mov	al, BYTE PTR [esi+2]
	mov	ebx, DWORD PTR [edx+eax*4]		; cb=cp[pc2u(pc+1)]
	mov	eax, DWORD PTR _ee$[esp]
	push	DWORD PTR ebx
	mov	edx, [eax+ee_current_frame]	; if = ee->current_frame
	push	eax
	mov	[edx+javaframe_lastpc], esi	; if->last_pc = pc
	add	esi, 3
	call	CName(allocObject)
	add	esp, 8
	xor	ecx, ecx
	Verify(eax,ne,0,OutOfMemory,IP(-3))
	mov	ebx, eax				; r0 = allocObject
	xor	eax, eax
	Ld_opc(0)
	Dispatch1

	
Def201(anewarray_quick)
;	sp[0] = t = allocArray(ee, 2,r0);
;	t=t->obj
;	t->body[size] = cp[pc2u(pc+1)];
;	memset(t, 0, sizearray(2,r0));
;	sp+=1;
;[Sheng 11/8/96] memset has been moved into allocArray.
	Verify(ebx,ge,0,NegativeArraySize,SP(1))
	mov	eax, _ee$[esp]
	push	ebx
	push	2
	mov	edx, [eax+ee_current_frame]	; if = ee->current_frame
	push	eax
	mov	[edx+javaframe_lastpc], esi	; if->last_pc = pc
	call	CName(allocArray)
	mov	[edi], eax		; sp[0] = t = allocArray(ee,2,r0)
	add	edi,4			; sp+=1
	Verify(eax,ne,0,OutOfMemory,Sp(3))
	mov	edx, DWORD PTR _cp$[esp+12]
	xor	ecx, ecx
	mov	ch, BYTE PTR [esi+1]
	mov	cl, BYTE PTR [esi+2]
	mov	ecx, DWORD PTR [edx+ecx*4]	; ecx=cp[pc2u(pc+1)]
	mov	edx, DWORD PTR [eax+o_obj]	; t=t->obj
	add	esp, 12
	mov	[edx+array_body+ebx*4], ecx	; t->body[size]=cp[pc2u(pc+1)]
	add	esi, 3
	xor	eax, eax
	Ld_opc(0)
	Dispatch0

	
Def201(newarray)
;	sz=r0
;	r0 = allocArray(ee, pc[1], sz);
;	t=r0->obj
;	memset(t, 0, sizearray(pc[1],sz));
;[Sheng 11/8/96] memset has been moved into allocArray.

	Verify(ebx,ge,0,NegativeArraySize,SP(1))
	Ld_opc(1)			; eax=pc[1]
	mov	edx, _ee$[esp]
	push	ebx				; pass sz
	push	eax				; pass pc[1]
	mov	eax, [edx+ee_current_frame]	; if = ee->current_frame
	push 	edx
	mov	[eax+javaframe_lastpc], esi	; if->last_pc = pc
	add	esi, 2
	call	CName(allocArray)
	mov	ebx, eax			; r0=allocArray(ee,pc[1],sz)
	Verify(eax,ne,0,OutOfMemory,Sp(3),IP(-2))
	add	esp, 12
	xor	eax, eax
	Ld_opc(0)
	Dispatch1


	
; Some opcodes (e.g, many quick translations) are handled entirely
; in C.  Each C routine has a name of the form x86_opcodename, and all of
; the routines have this interface:
;
;     extern __int64 x86_xxx (ExecEnv* ee, unsigned char* pc)

; The caller decaches the java stack ptr into ee before the call;
; the callee may modify the cached value if needed.  The callee returns
; the amount to be added to the cached pc in eax and the amount to be
; subtracted from the cached sp (usually 0) in edx.

define(`Csupport',`
Def210($1)
	mov	edx, CName(x86_$1)
	jmp	Lb($csupport_body)
ifelse($2,`',`',`Csupport(shift($@))')')

Csupport(getfield,putfield,getstatic,putstatic,new,multianewarray_quick)
Csupport(invokeinterface)
Lb($csupport_body):
	mov	ebx, _ee$[esp]
	mov	eax, [ebx+ee_current_frame]
	push	esi				; pass pc
	push	ebx				; pass ee
	mov	[eax+javaframe_optop], edi	; decache sp
	call	edx
	add	esi, eax			; advance pc
	add	esp, 8
	xor	eax, eax
	sub	edi, edx			; update sp
	mov	cl, BYTE PTR [ebx+ee_exceptionKind]
	Ld_opc(0)
	test	cl, cl				; ee->exceptionKind ?
	jnz	Lb(NO_except)			; we are toast
	Dispatch0				; process new opcode

	
; Handle these invokers specially, now that the FixUpQuickInvocation
; optimization hack exists.
define(`CsuppInvok',`
Def210($1)
	mov	edx, CName(x86_$1)
	jmp	Lb($csuppinvok_body)
ifelse($2,`',`',`CsuppInvok(shift($@))')')

CsuppInvok(invokevirtual,invokespecial,invokestatic)

Lb($csuppinvok_body):
	mov	ebx, _ee$[esp]
	mov	eax, [ebx+ee_current_frame]
	push	esi				; pass pc
	push	ebx				; pass ee
	mov	[eax+javaframe_optop], edi	; decache sp
	call	edx
	add	esp, 8
	test	eax, eax			; null for exception or recycle
	jnz	Lb($cs_callmethod)		; nonull is methodblock to call
;                   ($cs_callmethod is in fjmisc.inc with the other invokers)
	mov	cl, BYTE PTR [ebx+ee_exceptionKind]
	Ld_opc(0)
	test	cl, cl				; ee->exceptionKind ?
	jnz	Lb(NO_except)			; we are toast
	Dispatch0				; process new opcode

; Some quick translations involve only a call to ResolveClassConstant.

define(`XlateEasy',`
Def210($1)
	push	`opc_'$1`_quick'
	push	ifelse(`$1',`ldc_w',`WordMask',`$1',`ldc2_w',`LongMask',`ClassMask')
	mov	ah, BYTE PTR [esi+1]
	mov	ecx, _ee$[esp+8]
	mov	al, BYTE PTR [esi+2]
	jmp	Lb($xlate_body)
ifelse($2,`',`',`XlateEasy(shift($@))')')

XlateEasy(instanceof,checkcast,anewarray,multianewarray,ldc_w,ldc2_w)

Def210(ldc)
	push	opc_ldc_quick
	push	WordMask
	mov	ecx, _ee$[esp+8]
	Ld_opc(1)
Lb($xlate_body):
	mov	edx, DWORD PTR _cp$[esp+8]
	push	ecx				; pass ee
	push	eax				; pass cp index
	push	edx				; pass cp
	call	CName(ResolveClassConstant)
	mov	ecx,_ee$[esp+20]		; reload ee
	mov	eax,[esp+16]			; new opcode
	add	esp, 20
	mov	cl, BYTE PTR [ecx+ee_exceptionKind]
	test	cl, cl				; ee->exceptionKind ?
	jnz	Lb(NO_except)			; we are toast
	mov	[esi], al			; rewrite opcode
	Dispatch0				; process new opcode

	
Def021(monitorenter)
	Verify(ebx,ne,0,NullPointer,SP(1))
	mov	ecx, _ee$[esp]
	push	ebx
	push	ecx
	call	CName(monitorEnter2)
	add	esp, 8
	xor	eax, eax
	Ld_opc(1)
	inc	esi
	Dispatch0


Def021(monitorexit)
	Verify(ebx,ne,0,NullPointer,SP(1))
	mov	ecx, _ee$[esp]
	push	ebx
	push 	ecx
	call	CName(monitorExit2)
	add	esp, 8
	test	eax, eax
	jnz     Lb(NO_except)
	Ld_opc(1)
	inc	esi
	Dispatch0

	
Def210(athrow)
	Verify(ebx,ne,0,NullPointer,SP(1))
	mov	edx, DWORD PTR _ee$[esp]
	mov	ebx, DWORD PTR [edi-4]
	mov	BYTE PTR [edx+ee_exceptionKind], 1
	mov	DWORD PTR [edx+ee_exception], ebx
	jmp	Lb(N1_except)

include(`../../../../src/share/javavm/runtime/executeJava_p5.inc')
	
align 4

define(`OPCODE',`DD OFFSET FLAT: Lb(NO_$1)')
Lb(targets_0):	
include(`fjtables.inc')
	
define(`OPCODE',`DD OFFSET FLAT: Lb(N1_$1)')
Lb(targets_1):		
include(`fjtables.inc')

define(`OPCODE',`DD OFFSET FLAT: Lb(N2_$1)')
Lb(targets_2):		
include(`fjtables.inc')

align	4
Lb(wide_targets):
	DWORD	Lb(wide_ret)
	DWORD	Lb(wide_lstore)
	DWORD	Lb(wide_dstore)
	DWORD	Lb(wide_lload)
	DWORD	Lb(wide_dload)
	DWORD	Lb(wide_fstore)
	DWORD	Lb(wide_istore)
	DWORD	Lb(wide_astore)
	DWORD	Lb(wide_fload)
	DWORD	Lb(wide_iload)
	DWORD	Lb(wide_aload)
	DWORD	Lb(wide_iinc)

ifelse(CPU,`6',`	

Lg(wide_opc):
	BYTE	opc_iinc
	BYTE	opc_aload
	BYTE	opc_iload
	BYTE	opc_fload
	BYTE	opc_astore
	BYTE	opc_istore
	BYTE	opc_fstore
	BYTE	opc_dload
	BYTE	opc_lload
	BYTE	opc_dstore
	BYTE	opc_lstore
	BYTE	opc_ret
Lg(wide_end):

define(`Exception',`Lg($1):
	BYTE	"java/lang/$1`Exception'",0')
define(`Error',`Lg($1):
	BYTE	"java/lang/$1`Error'",0')

Error(Internal)
Error(OutOfMemory)

Exception(Arithmetic)
Exception(ArrayStore)
Exception(NegativeArraySize)
Exception(NullPointer)

Lg(Empty):
	BYTE	0

Lg(ByZero):
	BYTE	"/ by zero", 0

Lg(Undefined):
	BYTE	"undefined opcode", 0

Lg(AssertFail):
	BYTE	"assertion failure", 0

CName(ExecuteJava) ENDP
	
.586
    	
getCPUtype PROC NEAR
	pushfd			; save original eflags
	pop	edx		; edx gets original flags
	push	edx		; save original flags on the stack
	
        ;;  if we cannot modify bit 18, then its a 386
	mov	eax,edx		; get current value
	xor	edx, (1 SHL 18)	; flip the value
	push	edx
	popfd
	pushfd
	pop	edx
	cmp	eax,edx
	mov	eax,3		; 386 if they are equal
	je	@F

        ;;  if we cannot modify bit 21, then its a 486
	mov	eax,edx		; get current value
	xor	edx, (1 SHL 21)	; flip the value
	push	edx
	popfd
	pushfd
	pop	edx
	cmp	eax,edx
	mov	eax,4		; 386 if they are equal
	je	@F
	
        ;;  okay.  We can use the cpuid opcode
        mov	eax,1
	cpuid
	shr	eax,8
	and	eax,0fh
@@: 
	popfd	
	ret
getCPUtype ENDP
	
	
END')
