/*
 * @(#)globals.c	1.42 98/08/14
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 *      Some development environments don't support common storage
 *      (i.e. data in multiply included .h files not marked extern).
 *      Here is where we declare everything in .h files marked extern.
 */


#include "oobj.h"
#include "tree.h"
#include "interpreter.h"

ClassClass **binclasses;
int nbinclasses, sizebinclasses;
bool_t verbose = FALSE;
bool_t verbosegc = FALSE;
bool_t verboseclassdep = FALSE;
bool_t classgc = TRUE;
int verifyclasses = VERIFY_REMOTE;
bool_t debugging = FALSE;
char *init_sysclasspath = 0;
char *java_home_dir;
char *java_dll_dir;

bool_t (*pExecuteJava)(unsigned char  *, ExecEnv *ee);

typedef jint (JNICALL *vfprintf_hook_t)(FILE *fp, const char *format, 
					va_list args);
typedef void (JNICALL *exit_hook_t)(jint code);
typedef void (JNICALL *abort_hook_t)(void);

/* initialize all to zero, so that we can tell whether they've been 
   overwritten.
 */
vfprintf_hook_t vfprintf_hook = 0;
exit_hook_t exit_hook = 0;
abort_hook_t abort_hook = 0;

/* Win32 can't export variables to shared-libraries, just functions.
 * These access routines are therefore needed by the debugger.
 */
ClassClass** get_binclasses(void)  { return binclasses; }
int          get_nbinclasses(void) { return nbinclasses; }

#ifdef JCOV
char* cov_file = (char *)NULL;		/* Name of code coverage file */
unsigned int jcov_flags = 0;		/* Flags of code coverage     */
#endif /* JCOV */

