/*
 * @(#)oldnmi.c	1.2 98/08/14
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "oobj.h"
#include "interpreter.h"
#include "monitor.h"
#include "monitor_cache.h"
#include "common_exceptions.h"
#include "java_lang_String.h"

/*
 * This file consists of functions whose sole purpose is to support
 * the old style native method interface.
 */

/*
 * Pointer to the Thread class block.
 */
ClassClass *Thread_classblock;

ClassClass*  get_classClass(void)
{
    return classJavaLangClass;
}

ClassClass*  get_classObject(void)
{
    return classJavaLangObject;
}


/* For compatibility with existing native method interface. */

JHandle *ObjAlloc(ClassClass *cb, int ignored)
{
    return allocObject(EE(), cb);
}

JHandle *ArrayAlloc(int type, int size)
{
    return allocArray(EE(), type, size);
}


unicode *
javaString2unicode(Hjava_lang_String *s, unicode *buf, int len) 
{
    if (s) {
	Classjava_lang_String *str = unhand(s);
	HArrayOfChar *hac = (HArrayOfChar *)str->value;
	unicode *body = unhand(hac)->body;
	memcpy(buf, body+str->offset, len*sizeof(unicode));
	KEEP_POINTER_ALIVE(body);
    } else {
	memset(buf, 0, len * sizeof(unicode));
    }
    return buf;
}


void monitorEnter(uintptr_t key){
    monitorEnter2(EE(), key);
}

void monitorExit(uintptr_t key)
{
    monitorExit2(EE(), key);
}

void monitorWait(uintptr_t key, int64_t millis)
{
    monitorWait2(EE(), key, millis);
}

void monitorNotify(uintptr_t key){
    monitorNotify2(EE(), key);
}

void monitorNotifyAll(uintptr_t key)
{
    monitorNotifyAll2(EE(), key);
}

HObject *
newobject(ClassClass *cb, unsigned char *pc, struct execenv *ee)
{
    HObject *ret;
    if ((ret = allocObject(ee, cb)) == 0) {
	char buf[MSG_BUF_LEN];
	if (ee != NULL && pc != NULL) 
	    ee->current_frame->lastpc = pc;
	ThrowOutOfMemoryError(0, classname2string(cbName(cb), buf,
						  sizeof(buf)));
	return 0;
    }
    return ret;
}
