/*
 * @(#)check_version.c	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "jni.h"
#include "jvm.h"

JNIEXPORT jint JNICALL
JNI_OnLoad(JavaVM *vm, void *reserved)
{
    jint vm_version = JVM_GetInterfaceVersion();
    if (vm_version != JVM_INTERFACE_VERSION) {
        JNIEnv *env;
	char buf[128];
	sprintf(buf, "JVM interface version mismatch: expecting %d, got %d.",
		JVM_INTERFACE_VERSION, vm_version);
	(*vm)->GetEnv(vm, (void **)&env, JNI_VERSION_1_2);
	if (env) {
	    (*env)->FatalError(env, buf);
	}
    }
    return JNI_VERSION_1_2;
}
