/*
 * @(#)ObjectInputStream.c	1.31 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "jni.h"
#include "jvm.h"

#include "java_io_ObjectInputStream.h"

JNIEXPORT jobject JNICALL 
Java_java_io_ObjectInputStream_allocateNewObject (JNIEnv * env, 
						  jclass this, 
						  jclass curClass, 
						  jclass initClass)
{
    return JVM_AllocateNewObject(env, this, curClass, initClass);
}


JNIEXPORT jobject JNICALL 
Java_java_io_ObjectInputStream_allocateNewArray (JNIEnv * env, 
						 jclass this, 
						 jclass class, 
						 jint length)
{
    return JVM_AllocateNewArray(env, this, class, length);  /* test this */
}

/*
 * Find the first class loader up the stack and use its class to call 
   FindClassFromClass to resolve the specified class
 * name.  The code is similar to that of java.lang.currentClassLoader
 */
JNIEXPORT jclass JNICALL 
Java_java_io_ObjectInputStream_loadClass0 (JNIEnv * env, 
					   jobject this, 
					   jclass curClass, 
					   jstring currClassName)
{
    return JVM_LoadClass0(env, this, curClass, currClassName);
}
