/*
 * @(#)Field.c	1.46 98/08/14
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "jni.h"
#include "jvm.h"
#include "java_lang_reflect_Field.h"

/*
 * Native code for java.lang.reflect.Field.
 *
 * TODO: Performance
 */

/*
 * get() and its primitive variants
 */

JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Field_get(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetField(env, field, obj);
}

JNIEXPORT jboolean JNICALL
Java_java_lang_reflect_Field_getBoolean(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_BOOLEAN).z;
}

JNIEXPORT jbyte JNICALL
Java_java_lang_reflect_Field_getByte(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_BYTE).b;
}

JNIEXPORT jchar JNICALL
Java_java_lang_reflect_Field_getChar(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_CHAR).c;
}

JNIEXPORT jshort JNICALL
Java_java_lang_reflect_Field_getShort(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_SHORT).s;
}

JNIEXPORT jint JNICALL
Java_java_lang_reflect_Field_getInt(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_INT).i;
}

JNIEXPORT jlong JNICALL
Java_java_lang_reflect_Field_getLong(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_LONG).j;
}

JNIEXPORT jfloat JNICALL
Java_java_lang_reflect_Field_getFloat(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_FLOAT).f;
}

JNIEXPORT jdouble JNICALL
Java_java_lang_reflect_Field_getDouble(JNIEnv *env, jobject field, jobject obj)
{
    return JVM_GetPrimitiveField(env, field, obj, JVM_T_DOUBLE).d;
}

/*
 * set() and its primitive variants
 */

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_set(JNIEnv *env, jobject field, jobject obj,
				 jobject val)
{
    JVM_SetField(env, field, obj, val);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setBoolean(JNIEnv *env, jobject field,
					jobject obj, jboolean z)
{
    jvalue v;
    v.z = z;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_BOOLEAN);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setByte(JNIEnv *env, jobject field,
				     jobject obj, jbyte b)
{
    jvalue v;
    v.b = b;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_BYTE);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setChar(JNIEnv *env, jobject field,
				     jobject obj, jchar c)
{
    jvalue v;
    v.c = c;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_CHAR);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setShort(JNIEnv *env, jobject field,
				     jobject obj, jshort s)
{
    jvalue v;
    v.s = s;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_SHORT);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setInt(JNIEnv *env, jobject field,
				     jobject obj, jint i)
{
    jvalue v;
    v.i = i;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_INT);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setLong(JNIEnv *env, jobject field,
				     jobject obj, jlong j)
{
    jvalue v;
    v.j = j;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_LONG);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setFloat(JNIEnv *env, jobject field,
				     jobject obj, jfloat f)
{
    jvalue v;
    v.f = f;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_FLOAT);
}

JNIEXPORT void JNICALL
Java_java_lang_reflect_Field_setDouble(JNIEnv *env, jobject field,
				     jobject obj, jdouble d)
{
    jvalue v;
    v.d = d;
    JVM_SetPrimitiveField(env, field, obj, v, JVM_T_DOUBLE);
}
