/*
 * @(#)Method.c	1.48 98/08/14
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "jni.h"
#include "jvm.h"
#include "java_lang_reflect_Method.h"
#include "java_lang_reflect_Constructor.h"

/*
 * Native code for java.lang.reflect.Method and
 * java.lang.reflect.Constructor.
 * 
 * TODO: Performance.
 */

/*
 * Invoke an instance or a static method
 */
JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Method_invoke(JNIEnv *env, jobject method, jobject obj,
				     jobjectArray args)
{
    return JVM_InvokeMethod(env, method, obj, args);
}

/*
 * Use constructor to make a new instance of declaring class
 */
JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Constructor_newInstance(JNIEnv *env, jobject c,
					       jobjectArray args)
{
    return JVM_NewInstanceFromConstructor(env, c, args);
}
