/*
 * @(#)HaeMidiPlayer_Impl.cpp	1.8 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#if HAE_MIDI_PLAYERS


#include "Hae_Impl.h"
#include "sun_audio_HaeMidiNoise.h"
#include "sun_audio_HaeMidiPlayer.h"
#include "HaeMidiPlayer.h"


////////////////////////////////////////////////// VARIABLES:

//KARA7: deleted static class cache allocation


////////////////////////////////////////////////// FORWARDS:



////////////////////////////////////////////////// MEMBER FUNCTIONS:

JNIEXPORT void JNICALL
Java_sun_audio_HaeMidiPlayer_open(JNIEnv* e, jobject thisObj,
                                jboolean loadInstruments)
{
HaeEnv          env(e);
HaeMidiPlayer   thiz(env, thisObj);
jint            id;
GM_Song*        song;
OPErr           opErr;

    Java_sun_audio_HaeMidiNoise_close(e, thisObj);

    id = HaeEnv::GetUniqueId();
    song = GM_CreateLiveSong((short)id);
    if (song)
    {
        song->userReference = id;
        opErr = GM_StartLiveSong(song, (BOOL_FLAG)loadInstruments);
        if (opErr != NO_ERR)
        {
            GM_FreeSong(song);
            env.ThrowOnError(opErr);
            return;
        }
        ::Java_sun_audio_HaeMidiNoise_preloadInstrument(e, thisObj, 0, 0);
    }
    thiz.SetSongData(song);
}

#endif // HAE_MIDI_PLAYERS

