/*
 * @(#)HaePath.cpp	1.5 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#include "Hae_Impl.h"
#include "HaePath.h"


//KARA7: re-arranged functions


////////////////////////////////////////////////// OPERATIONS:

XFILE HaePath::OpenResourceFile()
{
XFILENAME       name;

    if (GetXFilename(&name))    //KARA7: changed to test result
    {
        return ::XFileOpenResource(&name, TRUE);
    }
    return NULL;
}

#if HAE_FILES
// Read a file into memory and return an allocated pointer
XPTR HaePath::ReadFile(long* lengthTarget)
{
XFILENAME       name;
XFILE           ref;

    //KARA7: changed to test result
    if (GetXFilename(&name) && (ref = ::XFileOpenForRead(&name))
    {
    long            length;
    XPTR            data;

        length = ::XFileGetLength(ref);
        data = ::XNewPtr(length);
        if (data)
        {
            ::XFileRead(ref, data, length);
        }
        ::XFileClose(ref);
        *lengthTarget = length;
        return data;
    }
    else
    {
        *lengthTarget = 0;
        return NULL;
    }
}
#endif // HAE_FILES


////////////////////////////////////////////////// DATA:

//KARA7: made this function return whether successful
jboolean HaePath::GetXFilename(XFILENAME* target)
{
char            buffer[1024];

    if (CopyOut(buffer, 0, sizeof(buffer) / sizeof(char)) > 0)	//KARA7: changed this line
    {
        ::XConvertNativeFileToXFILENAME(buffer, target);
        return JNI_TRUE;
    }
    return JNI_FALSE;
}


