/*
 * @(#)HaeWaveFile_Impl.cpp	1.6 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#include "Hae_Impl.h"
#include "sun_audio_HaeWaveDirect.h"
#include "sun_audio_HaeWaveFile.h"
#include "HaePath.h"
#include "HaeWaveFile.h"


#if HAE_FILES


////////////////////////////////////////////////// VARIABLES:

//KARA7: deleted static class cache allocation


////////////////////////////////////////////////// HaeWaveFile OPERATIONS:

void HaeOpenWaveFile(JNIEnv* e, jobject thisObj, jstring pathObj,
                     AudioFileType fileType)
{
HaeEnv          env(e);
HaeWaveFile     thiz(env, thisObj);
HaePath         path(env, pathObj);
XFILENAME       name;
GM_Waveform*    data;

    Java_sun_audio_HaeWaveDirect_close(env, thisObj);

    if (path.GetXFilename(&name))   //KARA7: changed to test result
    {
        data = GM_ReadFileIntoMemory(&name, fileType);
        if (data)
        {
            thiz.SetGmWaveform(data);
        }
        else
        {
            env.ThrowOnError(BAD_FILE);
        }
    }
}

JNIEXPORT void JNICALL
Java_sun_audio_HaeWaveFile_openAIFF(JNIEnv* e, jobject thisObj, jstring pathObj)
{
    HaeOpenWaveFile(env, thisObj, pathObj, FILE_AIFF_TYPE);
}
JNIEXPORT void JNICALL
Java_sun_audio_HaeWaveFile_openWAV(JNIEnv* e, jobject thisObj, jstring pathObj)
{
    HaeOpenWaveFile(env, thisObj, pathObj, FILE_WAVE_TYPE);
}
JNIEXPORT void JNICALL
Java_sun_audio_HaeWaveFile_openAU(JNIEnv* e, jobject thisObj, jstring pathObj)
{
    HaeOpenWaveFile(env, thisObj, pathObj, FILE_AU_TYPE);
}


#endif // HAE_FILES



