/*
 * @(#)HaeWaveMemory_Impl.cpp	1.6 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#include "Hae_Impl.h"
#include "sun_audio_HaeWaveDirect.h"
#include "sun_audio_HaeWaveMemory.h"
#include "HaeWaveMemory.h"
#include "JncByteArray.h"

#if HAE_DIRECT_WAVES


////////////////////////////////////////////////// VARIABLES:

//KARA7: deleted static class cache allocation


////////////////////////////////////////////////// HaeWaveMemory OPERATIONS:

JNIEXPORT void JNICALL
Java_sun_audio_HaeWaveMemory_nativeOpen(JNIEnv* e, jobject thisObj,
                                        jbyteArray wavedataObj, jint wavedataLength,
                                        jdouble sampleRate,
                                        jint bitsPerSample, jint channelsPerFrame,
                                        jint bytesPerFrame)
{
HaeEnv          env(e);
HaeWaveMemory   thiz(env, thisObj);
JncByteArray    wavedata(env, wavedataObj);
long            bytes;
void*           wavedataCopy;

    bytes = wavedataLength * bytesPerFrame;
    wavedataCopy = XNewPtr(bytes);
    if (wavedataCopy)
    {
    GM_Waveform     *data;

        wavedata.CopyOut((jbyte*)wavedataCopy, 0, bytes);
        data = (GM_Waveform*)::XNewPtr(sizeof(GM_Waveform));
        if (data)
        {
            data->waveSize = bytes;
            data->waveFrames = wavedataLength;
            data->startLoop = 0;
            data->endLoop = 0;
            data->baseMidiPitch = 60;
            data->bitSize = (unsigned char)bitsPerSample;
            data->channels = (unsigned char)channelsPerFrame;
            data->sampledRate = DOUBLE_TO_FIXED(sampleRate);

            data->theWaveform = (SBYTE*)wavedataCopy;
            thiz.SetGmWaveform(data);

            return; // successfully
        }
        XDisposePtr(wavedataCopy);
    }
    env.ThrowOnError(MEMORY_ERR);
}


////////////////////////////////////////////////// HaeWaveMemory DATA:

#endif // HAE_DIRECT_WAVES



