/*
 * @(#)HaeWaveStream.h	1.9 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#include "HaeWaveNoise.h"


////////////////////////////////////////////////// CLASSES:

class HaeWaveStream : public HaeWaveNoise   //KARA7: simplified class
{
PUBLIC_EXISTENCE:
    HaeWaveStream(JncEnv& env, jobject obj)
    : HaeWaveNoise(env, obj)
    {}

PUBLIC_OPERATIONS:
    jboolean            CallPrivateGetWavedata(jint frameCount)
    { return CallBooleanMethod("privateGetWavedata", "(I)Z", frameCount); }
    void                CallStreamingFinished()
    { CallVoidMethod("streamingFinished"); }

PUBLIC_DATA:
    jobject             GetBuffer()
    { return GetObjectField("m_buffer", "L"JAVA_PACKAGE_NAME"/HaeWaveStreamBuffer;"); }

    // this field does not exist anymore; we are counting samples in GenAudioStreams.c
    // rather than using a sample offset
    //void              SetSampleOffset(jdouble value)
    //{ SetDoubleField("m_sampleOffset", value); }
};


