/*
 * @(#)IgorMidiInputDevice.h	1.5 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*****************************************************************************/
/*
** "IgorMidiInputDevice.h"
**
**	Generalized Audio Synthesis package presented in an oop fashion
**
**
** Modification History:
**
**	2/9/97		Created
**
*/
/*****************************************************************************/


#ifndef IGOR_AUDIO
	#include "IgorAudio.h"
#endif

enum
{
	IGOR_MIDI_MANAGER_FAILED = 20000,
	IGOR_OMS_FAILED,
	IGOR_MIDI_MANGER_NOT_THERE
};

typedef enum
{
	IGOR_OMS_CONNECT = 0,				// connect with just OMS virtual device
	IGOR_OMS_NAME_CONNECT,				// connect with OMS and the OMS name manager
	IGOR_MIDI_MANAGER_CONNECT			// connect with MIDI Manager
} IgorConnection;

// Midi Device class for direct midi input from external platform devices
class IgorMidiInputDevice : public IgorMidiDirect
{
public:
					IgorMidiInputDevice(IgorAudioMixer *pIgorAudioMixer,
								char *pName = 0L, void * userReference = 0);
					~IgorMidiInputDevice();

	IgorErr			Start(IGOR_BOOL loadInstruments,
								IgorConnection connect,
								long midiReference);
	void			Stop(void);

	long			GetMidiReference(void);
	long			GetTimeBaseOffset(void);
	void			SetTimeBaseOffset(long newTimeBase);

private:
	long			timeBaseOffset;
	long			reference;
	void			*controlVariables;
};

