/*
 * @(#)JncByteArray.cpp	1.6 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncByteArray.c


#include "JncByteArray.h"


////////////////////////////////////////////////// EXISTENCE:


////////////////////////////////////////////////// OPERATIONS:

VIR_I void JncByteArray::GetElements(void* dst, jsize srcIndex, jsize length)
{
    m_env->GetByteArrayRegion(GetJObject(), srcIndex, length, (jbyte*)dst);
    //THROWS: ArrayIndexOutOfBoundsException
}
VIR_I void JncByteArray::SetElements(jsize dstIndex, void const* src, jsize length)
{
    m_env->SetByteArrayRegion(GetJObject(), dstIndex, length, (jbyte*)src);
    //THROWS: ArrayIndexOutOfBoundsException
}
VIR_I void* JncByteArray::OpenElements(jboolean* isCopyTarget)
{
    return m_env->GetByteArrayElements(GetJObject(), isCopyTarget);
    // THROWS: nothing,  ??DAVID: really?
}
VIR_I void JncByteArray::CloseElements(void* openedElements, jint mode)
{
    m_env->ReleaseByteArrayElements(GetJObject(), (jbyte*)openedElements, mode);
    // THROWS: nothing
}

STA_I jbyteArray JncByteArray::New(JncEnv& env, jsize length, jbyte const* src /*= NULL*/)
{
    if (!env.IsPendingException())
    {
    jbyteArray      const array = env->NewByteArray(length);
    // THROWS: nothing,  ??DAVID: really?

        if (array)
        {
            if (src)
            {
                env->SetByteArrayRegion(array, 0, length, (jbyte*)src);
                //THROWS: ArrayIndexOutOfBoundsException, but shouldn't
#if JNC_DEBUG
                env.CheckForPendingException();
#endif
            }
        }
        else
        {
            ERROR1("ERROR: Failure to allocate array of %d bytes\n", (int)length);
            env.CheckForPendingException();
        }
        return array;
    }
    return NULL;
}


////////////////////////////////////////////////// DATA:


