/*
 * @(#)JncClass.h	1.6 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#ifndef JncClass_H
#define JncClass_H  1

#include "JncObject.h"


////////////////////////////////////////////////// CLASSES:

class JncClass : public JncObject
{
PUBLIC_EXISTENCE:
    JncClass(JncEnv& env, jclass clazz)
    : JncObject(env, clazz)
    {}

PUBLIC_OPERATIONS:
    jobject         Call_newInstance();

    jobject         Call_getClassLoader()
    { return CallObjectMethod("getClassLoader", "()Ljava/lang/ClassLoader;"); }
    jobjectArray    Call_getInterfaces()
    { return (jobjectArray)CallObjectMethod("getInterfaces", "()[Ljava/lang/String;"); }
    jstring         Call_getName()
    { return CallStringMethod("getName"); }
    jclass          Call_getSuperclass()
    { return (jclass)CallObjectMethod("getSuperclass", "()Ljava/lang/Class;"); }
    jboolean        Call_isInterface()
    { return CallBooleanMethod("isInterface"); }

PUBLIC_DATA:
    jclass          GetJObject() const
    { return (jclass)JncObject::GetJObject(); }
    jsize           GetName(char* buffer, jsize maxLength);
    jsize           GetSignature(char* buffer, jsize maxLength);

PROTECTED_DATA:

PRIVATE_DATA:
};


#endif
