/*
 * @(#)JncGlobalRef.cpp	1.6 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncGlobalRef.cpp

#include "JncGlobalRef.h"


////////////////////////////////////////////////// EXISTENCE:

JncGlobalRef::JncGlobalRef()
{
    m_jobj = NULL;
}
JncGlobalRef::JncGlobalRef(JncEnv& env, jobject obj)
{
    m_jobj = NULL;
    Set(env, obj);
}


////////////////////////////////////////////////// OPERATIONS:

jobject JncGlobalRef::Set(JncEnv& env, jobject obj)
{
    if (m_jobj)
    {
        ERROR0("ERROR: JncGlobalRef{} not Unset before Set\n");
        Unset(env);
    }
    if (obj)
    {
        m_jobj = env->NewGlobalRef(obj);
        // THROWS: nothing
        if (!m_jobj)
        {
            ERROR0("ERROR: Failure to set a JncGlobalRef{}\n");
        }
    }
    else
    {
        ERROR0("ERROR: JncGlobalRef{}::Set() called with NULL jobject\n");
    }
    return m_jobj;
}
void JncGlobalRef::Unset(JncEnv& env)
{
    if (m_jobj)
    {
        env->DeleteGlobalRef(m_jobj);
        // THROWS: nothing
        m_jobj = NULL;
    }
    else
    {
        ERROR0("ERROR: JncGlobalRef{} Unset but not Set\n");
    }
}


