/*
 * @(#)JncGlobalRef.h	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncGlobalRef.h

#ifndef JncGlobalRef_H
#define JncGlobalRef_H  1

#include "Jnc.h"
#include "JncEnv.h"


////////////////////////////////////////////////// CLASS:

class JncGlobalRef
{
PUBLIC_EXISTENCE:
    JncGlobalRef();
    JncGlobalRef(JncEnv& env, jobject obj);
    ~JncGlobalRef();

PUBLIC_OPERATIONS:
    jobject         Set(JncEnv& env, jobject obj);
    void            Unset(JncEnv& env);

PUBLIC_DATA:
    jboolean        IsSet() const
    { return (m_jobj != NULL); }
    jobject         GetJObject() const
    { return m_jobj; }

PRIVATE_DATA:
    jobject         m_jobj;
};


////////////////////////////////////////////////// INLINE EXISTENCE:

INL JncGlobalRef::~JncGlobalRef()
{
    if (IsSet())
    {
        ERROR0("ERROR: JncGlobalRef{} not Unset before destruction\n");
    }
}


#endif
