/*
 * @(#)JncObjectArray.h	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncObjectArray.h

#ifndef JncObjectArray_H
#define JncObjectArray_H    1

#include "Jnc.h"
#include "JncArray.h"


////////////////////////////////////////////////// CLASS:

class JncObjectArray : public JncArray
{
PUBLIC_EXISTENCE:
    JncObjectArray(JncEnv& env, jobjectArray array)
    : JncArray(env, array)
    {}

PUBLIC_OPERATIONS:
    jsize           CopyOut(jobject* dst, jsize srcIndex, jsize maxLength) const;
    jsize           CopyIn(jsize dstIndex, jobject const* src, jsize maxLength) const;
    void            SetElement(jsize index, jobject value) const;

STA jobjectArray    New(JncEnv& env,
                        jclass elementClass, jsize length,
                        jobject initialElementValue = NULL);

PUBLIC_DATA:
    jobjectArray    GetJObject() const
    { return (jobjectArray)JncArray::GetJObject(); }

    jobject         GetElement(jsize index) const;
    jobject         operator[](jsize index) const
    { return GetElement(index); };
};


#endif
