/*
 * @(#)JncPrimitiveArray.h	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncPrimitiveArray.h

#ifndef JncPrimitiveArray_H
#define JncPrimitiveArray_H 1

#include "JncArray.h"


////////////////////////////////////////////////// CLASS:

class JncPrimitiveArray : public JncArray
{
PUBLIC_OPERATIONS:
    void            CopyBackAccess();
    void            EndAccess();

PUBLIC_DATA:
    jboolean        IsAccessingCopy() const
    { return m_openedElementsIsCopy; }

PROTECTED_EXISTENCE:
    JncPrimitiveArray(JncEnv& env, jarray array);
VIR ~JncPrimitiveArray();

PROTECTED_OPERATIONS:
    jsize           CopyOut(void* dst, jsize srcIndex, jsize maxLength);
    jsize           CopyIn(jsize dstIndex, void const* src, jsize maxLength);

/*
VIR void            GetElements(void* dst, jsize srcIndex, jsize length) = 0;
VIR void            SetElements(jsize dstIndex, void const* src, jsize length) = 0;
VIR void*           OpenElements(jboolean* isCopyTarget) = 0;
VIR void            CloseElements(void* openedElements, jint mode) = 0;
*/

// $$kk: this is a VIRTUAL class, but we get a link error showing _PURE_ERROR_ as an
// unresolved external (defined in libC.so, which we are not linking).

VIR void            GetElements(void* dst, jsize srcIndex, jsize length) {  }
VIR void            SetElements(jsize dstIndex, void const* src, jsize length) {  }
VIR void*           OpenElements(jboolean* isCopyTarget) { return NULL; }
VIR void            CloseElements(void* openedElements, jint mode) {  }


PROTECTED_DATA:
    void*           AccessElements();
    jsize           CheckRange(jsize index);

PRIVATE_DATA:
    void*           m_openedElements;
    jboolean        m_openedElementsIsCopy;
};


#endif
