/*
 * @(#)JncShortArray.cpp	1.6 98/03/18
 *
 * Copyright 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncShortArray.c


#include "JncShortArray.h"


////////////////////////////////////////////////// EXISTENCE:


////////////////////////////////////////////////// OPERATIONS:

VIR_I void JncShortArray::GetElements(void* dst, jsize srcIndex, jsize length)
{
    m_env->GetShortArrayRegion(GetJObject(), srcIndex, length, (jshort*)dst);
    //THROWS: ArrayIndexOutOfBoundsException
}
VIR_I void JncShortArray::SetElements(jsize dstIndex, void const* src, jsize length)
{
    m_env->SetShortArrayRegion(GetJObject(), dstIndex, length, (jshort*)src);
    //THROWS: ArrayIndexOutOfBoundsException
}
VIR_I void* JncShortArray::OpenElements(jboolean* isCopyTarget)
{
    return m_env->GetShortArrayElements(GetJObject(), isCopyTarget);
    // THROWS: nothing,  ??DAVID: really?
}
VIR_I void JncShortArray::CloseElements(void* openedElements, jint mode)
{
    m_env->ReleaseShortArrayElements(GetJObject(), (jshort*)openedElements, mode);
    // THROWS: nothing
}

STA_I jshortArray JncShortArray::New(JncEnv& env, jsize length, jshort const* src /*= NULL*/)
{
    if (!env.IsPendingException())
    {
    jshortArray     const array = env->NewShortArray(length);
    // THROWS: nothing,  ??DAVID: really?

        if (array)
        {
            if (src)
            {
                env->SetShortArrayRegion(array, 0, length, (jshort*)src);
                //THROWS: ArrayIndexOutOfBoundsException, but shouldn't
#if JNC_DEBUG
                env.CheckForPendingException();
#endif
            }
        }
        else
        {
            ERROR1("ERROR: Failure to allocate array of %d shorts\n", (int)length);
            env.CheckForPendingException();
        }
        return array;
    }
    return NULL;
}


////////////////////////////////////////////////// DATA:


