/*
 * @(#)JncShortArray.h	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncShortArray.h

#ifndef JncShortArray_H
#define JncShortArray_H 1

#include "JncPrimitiveArray.h"


////////////////////////////////////////////////// CLASS:

class JncShortArray : public JncPrimitiveArray
{
PUBLIC_EXISTENCE:
    JncShortArray(JncEnv& env, jshortArray array)
    : JncPrimitiveArray(env, array)
    {}

PUBLIC_OPERATIONS:
    jsize           CopyOut(jshort* dst, jsize srcIndex, jsize maxLength)
    { return JncPrimitiveArray::CopyOut(dst, srcIndex, maxLength); }
    jsize           CopyIn(jsize dstIndex, jshort const* src, jsize maxLength)
    { return JncPrimitiveArray::CopyIn(dstIndex, src, maxLength); }

STA jshortArray     New(JncEnv& env, jsize length, jshort const* data = NULL);

PUBLIC_DATA:
    jshortArray     GetJObject() const
    { return (jshortArray)JncPrimitiveArray::GetJObject(); }

    jshort*         AccessElements()
    { return (jshort*)JncPrimitiveArray::AccessElements(); }
    jshort&         operator[](jsize index)
    { return AccessElements()[CheckRange(index)]; }
    operator jshort* ()
    { return AccessElements(); }

PROTECTED_OPERATIONS:
VIR void            GetElements(void* dst, jsize srcIndex, jsize length);
VIR void            SetElements(jsize dstIndex, void const* src, jsize length);
VIR void*           OpenElements(jboolean* isCopyTarget);
VIR void            CloseElements(void* openedElements, jint mode);
};


#endif
