/*
 * @(#)JncString.h	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


// JncString.h

#ifndef JncString_H
#define JncString_H 1

#include "Jnc.h"
#include "JncObject.h"


////////////////////////////////////////////////// CLASS:

class JncString : public JncObject
{
PUBLIC_EXISTENCE:
    JncString(JncEnv& env, jstring string);
VIR ~JncString();

PUBLIC_OPERATIONS:
    jchar const*    AccessUnicode();
    ConStr          AccessUTF();
    void            EndAccess();

    jsize           CopyOut(jchar* dst, jsize srcIndex, jsize maxLength);
    jsize           CopyOut(char* dst, jsize srcIndex, jsize maxLength);

STA jstring         New(JncEnv& env, jsize length, jchar const* unicodeString);
STA jstring         New(JncEnv& env, ConStr utfString);

PUBLIC_DATA:
    jstring         GetJObject() const
    { return (jstring)JncObject::GetJObject(); }
    jsize           GetLength() const;
    jchar           operator[](jsize index);

PRIVATE_DATA:
    jchar const*    m_unicodeAccess;
    ConStr          m_utfAccess;
};


////////////////////////////////////////////////// INLINE OPERATIONS:


#endif
