/*
 * @(#)MOD_memory.c	1.6 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*****************************************************************************/
/*

**
**	History	-
**	12/1/96		Created
**	2/5/97		Fixed bug with mod_realloc that did not free old pointer
**	7/17/97		Added compile time switch
**	11/10/97	Changed some preprocessor tests and flags to explicity test for flags rather
**				than assume
*/
/*****************************************************************************/
#include "X_API.h"

#if USE_MOD_API == TRUE
#include "MOD_mikmod.h"
//
//	mod_memory.c
//
//	Memory-manager interfaces for MOD code.
//

/*
void * mod_malloc(long size)
{
	return XNewPtr(size);
}

void mod_free(void* ptr)
{
	XDisposePtr(ptr);
}

void mod_memset(void *ptr, char c, long size)
{
	XSetMemory(ptr, size, c);
}
*/


void * mod_realloc(void* ptr, long size)
{
	XPTR	p;

	p = NULL;
	if (ptr)
	{
		p = XNewPtr(size);
		if (p)
		{
			XBlockMove(ptr, p, size);
			XDisposePtr(ptr);
		}
	}
	return p;
}

#endif	// USE_MOD_API


