/*
 * @(#)alphaCompst.c	1.9 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


#include <alpha_uti.h>
#include <alphaCompst.h>

unsigned char *
getAlphaInfo(JNIEnv *env, jbyteArray alpha)
{
    jbyte *base;
    if (alpha) {
	base = (*env)->GetPrimitiveArrayCritical(env, alpha, 0);
    } else {
	base = (jbyte *) 0;
    }
    return (unsigned char *) base;
}

void
dropBufs(JNIEnv *env,
	 jbyteArray pathAlpha, unsigned char *pathBase,
	 jarray src, void *srcBase)
{
    if (pathBase) {
	(*env)->ReleasePrimitiveArrayCritical(env, pathAlpha, pathBase, 0);
    }
    if (srcBase) {
        (*env)->ReleasePrimitiveArrayCritical(env, src, srcBase, 0);
    }
}

#define NORM_SCALE 256

JNIEXPORT void JNICALL
Java_sun_java2d_pipe_DuctusClipRenderer_mergeAlphas(JNIEnv *env,
						    jobject DCR,
						    jbyteArray srcA,
						    jbyteArray dstA,
						    jint srcOff,
						    jint dstOff,
						    jint tsize,
						    jint w,
						    jint h,
						    jint bitDepth)
{
    unsigned char *srcBase, *srcData;
    unsigned char *dstBase, *dstData;
    int x, y;
    int tileScanStr = tsize - w;
    unsigned int sA;
    unsigned int dA;

    srcData = srcBase = getAlphaInfo(env, srcA);
    dstData = dstBase = getAlphaInfo(env, dstA);

    if (bitDepth == 8) {
	srcData += srcOff;
	dstData += dstOff;

	for (y = 0; y < h; y++) {
	    for (x = 0; x < w; x++) {
		sA = (unsigned int)*srcData;
		if (sA < 255) {
		    if (sA == 0) {
			*dstData = 0;
		    } else {
			dA = (unsigned int)*dstData;
			if (dA == 255) {
			    *dstData = sA;
			} else if (dA > 0) {
			    if (sA > 127) sA++;
			    *dstData = ( (sA * dA) / 256 );
			}
		    }
		}
		dstData++;
		srcData++;
	    }
	    srcData += tileScanStr;
	    dstData += tileScanStr;
	}
    } else {
	printf("Eek! 1 bit alpha merging not supported yet!\n");
    }
    dropBufs(env, srcA, srcBase, dstA, dstBase);
}

