/*
 * @(#)alphaCompst.h	1.9 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "java_awt_AlphaComposite.h"
#include <img_util_md.h>

#define XOR_MODE        0
#define CLEAR		java_awt_AlphaComposite_CLEAR
#define SRC		java_awt_AlphaComposite_SRC
#define SRC_OVER	java_awt_AlphaComposite_SRC_OVER
#define DST_OVER	java_awt_AlphaComposite_DST_OVER
#define SRC_IN		java_awt_AlphaComposite_SRC_IN
#define DST_IN		java_awt_AlphaComposite_DST_IN
#define SRC_OUT		java_awt_AlphaComposite_SRC_OUT
#define DST_OUT		java_awt_AlphaComposite_DST_OUT

typedef void ColorLoopFunc(JNIEnv *env,
			   void *dstPtr,
			   jint dstScanStr,
			   jint dstPixStr,
			   unsigned char *pathData,
			   jint offset,
			   jint alphaTileScan,
			   jint rule,
			   jfloat extraAlpha,
			   jint width, jint height,
			   jint fgColor, ColorData *cData);

typedef void PaintLoopFunc(JNIEnv *env,
			   void *dstPtr,
			   jint dstScanStr,
			   jint dstPixStr,
			   void *srcPtr,
			   jint srcScanStr,
			   jint srcPixStr,
			   unsigned char *pathData,
			   jint offset,
			   jint alphaTileScan,
			   jint rule,
			   jfloat extraAlpha,
			   jint width, jint height,
			   jboolean srcPre,
                           jint xorColor, ColorData *cData);

typedef void BgPaintLoopFunc(JNIEnv *env,
			     void *dstBase,
			     jint dstScanStr,
			     jint dstPixStr,
			     void *srcBase,
			     jint srcScanStr,
			     jint srcPixStr,
			     unsigned char *pathData,
			     jint offset,
			     jint alphaTileScan,
			     jint rule,
			     jfloat fXtraAlpha,
			     jint width, jint height,
			     jboolean srcPre,
			     jint bgColor,
                             jint xorColor, ColorData *cData);

extern unsigned char *getAlphaInfo(JNIEnv *env, jbyteArray alpha);

extern void dropBufs(JNIEnv *env,
		     jbyteArray pathAlpha, unsigned char *pathBase,
		     jarray src, void *srcBase);
