/*
 * @(#)alphaCompst_DST_IN.h	1.14 98/08/31
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#undef DST_IN_RULE

#ifdef COMPST_TWO_COMPONENTS
#define DST_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_IN_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define DST_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define DST_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_IN_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif
    
#ifdef COMPST_DST16
#define DST_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif
    
#ifdef COMPST_SRCDST16
#define DST_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_IN_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef DST_IN_RULE
#define DST_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define DST_IN_RULE2(rA, cA, xA,					\
                     sA, sR, sG, sB,                			\
                     dA, dR, dG, dB)					\
    do {								\
        cA = NORM_SCALE - rA;                                           \
        if (sA > (NORM_SCALE/2)) sA++;   				\
	if (xA < NORM_SCALE) {                               		\
            sA = (sA * xA) / NORM_SCALE;                        	\
	}								\
        if (rA < NORM_SCALE) {                                          \
            sA = (sA * rA) / NORM_SCALE;                                \
        }                                                               \
        sA += cA;                                                       \
	if (sA <= 0) {                                                  \
            dA = 0;                                                     \
	    dR = 0;                                                     \
        } else if (sA < NORM_SCALE) {                                   \
            dA = (dA * sA) / NORM_SCALE;                                \
            dR = (dR * sA) / NORM_SCALE;                                \
	} else {                                                        \
            skipDst = 1;                                                \
        }                                                               \
    } while (0)

#define DST_IN_RULE4(rA, cA, xA,					\
                     sA, sR, sG, sB,                			\
                     dA, dR, dG, dB)					\
    do {								\
        cA = NORM_SCALE - rA;                                           \
        if (sA > (NORM_SCALE/2)) sA++;    				\
	if (xA < NORM_SCALE) {                               		\
            sA = (sA * xA) / NORM_SCALE;                        	\
	}								\
        if (rA < NORM_SCALE) {                                          \
            sA = (sA * rA) / NORM_SCALE;                                \
        }                                                               \
        sA += cA;                                                       \
	if (sA <= 0) {                                                  \
            dA = 0;                                                     \
	    dR = 0;                                                     \
	    dG = 0;                                                     \
	    dB = 0;                                                     \
        } else if (sA < NORM_SCALE) {                                   \
            dA = (dA * sA) / NORM_SCALE;                                \
            dR = (dR * sA) / NORM_SCALE;                                \
            dG = (dG * sA) / NORM_SCALE;                                \
            dB = (dB * sA) / NORM_SCALE;                                \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
    } while (0)


#define DST_IN_RULE_SRC16(rA, cA, xA,					\
                          sA, sR, sG, sB,              			\
                          dA, dR, dG, dB)				\
    do {								\
        cA = NORM_SCALE - rA;                                           \
	if (xA < NORM_SCALE) {                               		\
            sA = (sA * xA) / NORM_SCALE;                        	\
	}								\
        if (rA < NORM_SCALE) {                                          \
            sA = (sA * rA) / NORM_SCALE;                                \
        }                                                               \
        sA += cA * 256;                                                 \
	if (sA <= 0) {                                                  \
            dA = 0;                                                     \
	    dR = 0;                                                     \
	    dG = 0;                                                     \
	    dB = 0;                                                     \
        } else if (sA < SHORT_NORM_SCALE_1) {                           \
            dA = (dA * sA) / SHORT_NORM_SCALE_1;                        \
            dR = (dR * sA) / SHORT_NORM_SCALE_1;                        \
            dG = (dG * sA) / SHORT_NORM_SCALE_1;                        \
            dB = (dB * sA) / SHORT_NORM_SCALE_1;                        \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
    } while (0)

#define DST_IN_RULE_SRCDST16(rA, cA, xA,				\
                             sA, sR, sG, sB,           			\
                             dA, dR, dG, dB)				\
    do {								\
        cA = NORM_SCALE - rA;                                           \
	if (xA < NORM_SCALE) {                               		\
            sA = (sA * xA) / NORM_SCALE;                        	\
	}								\
        if (rA < NORM_SCALE) {                                          \
            sA = (sA * rA) / NORM_SCALE;                                \
        }                                                               \
        sA += cA * 256;                                                 \
	if (sA <= 0) {                                                  \
            dA = 0;                                                     \
	    dR = 0;                                                     \
	    dG = 0;                                                     \
	    dB = 0;                                                     \
        } else if (sA < SHORT_NORM_SCALE_1) {                           \
            dA = (dA * sA) / SHORT_NORM_SCALE_1;                        \
            dR = (dR * sA) / SHORT_NORM_SCALE_1;                        \
            dG = (dG * sA) / SHORT_NORM_SCALE_1;                        \
            dB = (dB * sA) / SHORT_NORM_SCALE_1;                        \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
    } while (0)


