/*
 * @(#)alphaCompst_DST_OVER.h	1.15 98/08/31
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#undef DST_OVER_RULE

#ifdef COMPST_TWO_COMPONENTS
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPS_SRCDST16
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef DST_OVER_RULE
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define DST_OVER_RULE2(rA, cA, xA,					\
                       sA, sR, sG, sB,           			\
                       dA, dR, dG, dB)					\
do {								        \
        unsigned int a = NORM_SCALE_1 - dA;                             \
        if (a < NORM_SCALE_1) {                                         \
            rA = (rA * a)/NORM_SCALE;                                   \
            if (rA > NORM_SCALE/2) rA++;                                \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / NORM_SCALE;                               \
            dR += (rA * sR) / NORM_SCALE;                               \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE4(rA, cA, xA,					\
                       sA, sR, sG, sB,           			\
                       dA, dR, dG, dB)					\
do {                                            			\
        unsigned int a = NORM_SCALE_1 - dA;                             \
        if (a < NORM_SCALE_1) {                                         \
            rA = (rA * a)/NORM_SCALE;                                   \
            if (rA > NORM_SCALE/2) rA++;                                \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / NORM_SCALE;                               \
            dR += (rA * sR) / NORM_SCALE;                               \
            dG += (rA * sG) / NORM_SCALE;                               \
            dB += (rA * sB) / NORM_SCALE;                               \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE_SRC16(rA, cA, xA,					\
                            sA, sR, sG, sB,           			\
                            dA, dR, dG, dB)				\
do {                                            			\
        unsigned int a = NORM_SCALE_1 - dA;                             \
        if (a < NORM_SCALE_1) {                                         \
            rA = (rA * a)/NORM_SCALE;                                   \
            if (rA > NORM_SCALE/2) rA++;                                \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / SHORT_NORM_SCALE_1;                       \
            dR += (rA * sR) / SHORT_NORM_SCALE_1;                       \
            dG += (rA * sG) / SHORT_NORM_SCALE_1;                       \
            dB += (rA * sB) / SHORT_NORM_SCALE_1;                       \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE_DST16(rA, cA, xA,					\
                            sA, sR, sG, sB,           			\
                            dA, dR, dG, dB)				\
do {                                            			\
        unsigned int a = SHORT_NORM_SCALE_1 - dA;                       \
        if (a < SHORT_NORM_SCALE_1) {                                   \
            if (rA > NORM_SCALE/2) rA++;                                \
            rA = (rA * a)/NORM_SCALE;                                   \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / NORM_SCALE;                               \
            dR += (rA * sR) / NORM_SCALE;                               \
            dG += (rA * sG) / NORM_SCALE;                               \
            dB += (rA * sB) / NORM_SCALE;                               \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE_SRCDST16(rA, cA, xA,				\
                               sA, sR, sG, sB,         			\
                               dA, dR, dG, dB)				\
do {                                            			\
        unsigned int a = SHORT_NORM_SCALE_1 - dA;                       \
        if (a < SHORT_NORM_SCALE_1) {                                   \
            rA = (rA * a)/NORM_SCALE;                                   \
            if (rA > NORM_SCALE/2) rA++;                                \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / SHORT_NORM_SCALE_1;                       \
            dR += (rA * sR) / SHORT_NORM_SCALE_1;                       \
            dG += (rA * sG) / SHORT_NORM_SCALE_1;                       \
            dB += (rA * sB) / SHORT_NORM_SCALE_1;                       \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

