/*
 * @(#)alphaCompst_SRC.h	1.13 98/09/01
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#undef SRC_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_RULE
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif


#define SRC_RULE2(rA, cA, xA,						\
                  sA, sR, sG, sB,					\
                  dA, dR, dG, dB)					\
do {								\
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = (sA * xA) / NORM_SCALE;                                \
	    sR = (sR * xA) / NORM_SCALE;                                \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
	    dA = CLIP_BLEND(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND(rA, cA, sR, dR);				\
	} else {                                                        \
	    dA = sA;                    				\
	    dR = sR;                                            	\
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE4(rA, cA, xA,						\
                  sA, sR, sG, sB,					\
                  dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = (sA * xA) / NORM_SCALE;                                \
	    sR = (sR * xA) / NORM_SCALE;                                \
	    sG = (sG * xA) / NORM_SCALE;                                \
	    sB = (sB * xA) / NORM_SCALE;                                \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
	    dA = CLIP_BLEND(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND(rA, cA, sR, dR);				\
	    dG = CLIP_BLEND(rA, cA, sG, dG);				\
	    dB = CLIP_BLEND(rA, cA, sB, dB);				\
	} else {                                                        \
	    dA = sA;                    				\
	    dR = sR;                                            	\
	    dG = sG;                                                    \
	    dB = sB;                                                    \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE_SRC16(rA, cA, xA,					\
                       sA, sR, sG, sB,					\
                       dA, dR, dG, dB)					\
do {								\
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = (sA * xA) / NORM_SCALE;                                \
	    sR = (sR * xA) / NORM_SCALE;                                \
	    sG = (sG * xA) / NORM_SCALE;                                \
	    sB = (sB * xA) / NORM_SCALE;                                \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
	    dA = ((rA*sA)/SHORT_NORM_SCALE_1)+((cA*dA)/NORM_SCALE);	\
	    dR = ((rA*sR)/SHORT_NORM_SCALE_1)+((cA*dR)/NORM_SCALE);	\
	    dG = ((rA*sG)/SHORT_NORM_SCALE_1)+((cA*dG)/NORM_SCALE);	\
	    dB = ((rA*sB)/SHORT_NORM_SCALE_1)+((cA*dB)/NORM_SCALE);	\
	} else {                                                        \
	    dA = (sA*NORM_SCALE)/SHORT_NORM_SCALE_1;			\
	    dR = (sR*NORM_SCALE)/SHORT_NORM_SCALE_1;                    \
	    dG = (sG*NORM_SCALE)/SHORT_NORM_SCALE_1;                    \
	    dB = (sB*NORM_SCALE)/SHORT_NORM_SCALE_1;                    \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE_DST16(rA, cA, xA,					\
                       sA, sR, sG, sB,					\
                       dA, dR, dG, dB)					\
do {								\
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = (sA * xA) / NORM_SCALE;                                \
	    sR = (sR * xA) / NORM_SCALE;                                \
	    sG = (sG * xA) / NORM_SCALE;                                \
	    sB = (sB * xA) / NORM_SCALE;                                \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
	    dA = (((rA*sA)/NORM_SCALE)<<8)+((cA*dA)/NORM_SCALE);	\
	    dR = (((rA*sR)/NORM_SCALE)<<8)+((cA*dR)/NORM_SCALE);	\
	    dG = (((rA*sG)/NORM_SCALE)<<8)+((cA*dG)/NORM_SCALE);	\
	    dB = (((rA*sB)/NORM_SCALE)<<8)+((cA*dB)/NORM_SCALE);	\
	} else {                                                        \
            dA = sA << 8;                                               \
	    dR = sR << 8;                                            	\
	    dG = sG << 8;                                               \
	    dB = sB << 8;                                               \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
