/*
 * @(#)alphaCompst_SRC_IN.h	1.12 98/09/01
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#undef SRC_IN_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_IN_RULE
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define SRC_IN_RULE2(rA, cA, xA,					\
                     sA, sR, sG, sB,                			\
                     dA, dR, dG, dB)					\
do {								\
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
	if (dA < NORM_SCALE_1) {                             		\
	    rA = (rA * dA) / NORM_SCALE;				\
            if (rA > (NORM_SCALE/2)) rA++;    				\
	}								\
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
        dA = CLIP_BLEND(rA, cA, sA, dA);				\
        dR = CLIP_BLEND(rA, cA, sR, dR);				\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE4(rA, cA, xA,					\
                     sA, sR, sG, sB,                			\
                     dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
	if (dA < NORM_SCALE_1) {                             		\
	    rA = (rA * dA) / NORM_SCALE;				\
            if (rA > (NORM_SCALE/2)) rA++;    				\
	}								\
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
        dA = CLIP_BLEND(rA, cA, sA, dA);				\
        dR = CLIP_BLEND(rA, cA, sR, dR);				\
        dG = CLIP_BLEND(rA, cA, sG, dG);				\
        dB = CLIP_BLEND(rA, cA, sB, dB);				\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE_SRC16(rA, cA, xA,					\
                          sA, sR, sG, sB,              			\
                          dA, dR, dG, dB)				\
do {								\
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
	if (dA < NORM_SCALE_1) {                             		\
	    rA = (rA * dA) / NORM_SCALE;				\
            if (rA > (NORM_SCALE/2)) rA++;    				\
	}								\
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
        dA = ((rA*sA)/SHORT_NORM_SCALE_1)+((cA*dA)/NORM_SCALE);   	\
        dR = ((rA*sR)/SHORT_NORM_SCALE_1)+((cA*dR)/NORM_SCALE);         \
        dG = ((rA*sG)/SHORT_NORM_SCALE_1)+((cA*dG)/NORM_SCALE);         \
        dB = ((rA*sB)/SHORT_NORM_SCALE_1)+((cA*dB)/NORM_SCALE);         \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE_DST16(rA, cA, xA,					\
                          sA, sR, sG, sB,              			\
                          dA, dR, dG, dB)				\
do {								\
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
	if (dA < SHORT_NORM_SCALE_1) {                         		\
	    rA = (rA * dA) / SHORT_NORM_SCALE_1;			\
            if (rA > (NORM_SCALE/2)) rA++;    				\
	}								\
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
        dA = (((rA*sA)/NORM_SCALE)<<8)+((cA*dA)/NORM_SCALE);    	\
        dR = (((rA*sR)/NORM_SCALE)<<8)+((cA*dR)/NORM_SCALE);    	\
        dG = (((rA*sG)/NORM_SCALE)<<8)+((cA*dG)/NORM_SCALE);    	\
        dB = (((rA*sB)/NORM_SCALE)<<8)+((cA*dB)/NORM_SCALE);            \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
