/*
 * @(#)alphaCompst_SRC_OUT.h	1.15 98/09/01
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#undef SRC_OUT_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_OUT_RULE
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define SRC_OUT_RULE2(rA, cA, xA,					\
                      sA, sR, sG, sB,                			\
                      dA, dR, dG, dB)					\
do {								\
    if (rA > 0) {                                                       \
        unsigned int a = NORM_SCALE_1 - dA;                             \
        unsigned int b = NORM_SCALE - rA;                               \
	/* REMIND: workaround for Solaris2.6 iropt crash */		\
	/* Storing the dA result temporarily into a volatile variable	\
	 * fixes an iropt bug on Solaris 2.6 */				\
	volatile int d;							\
        if (a > (NORM_SCALE/2)) a++;				        \
	if (rA < NORM_SCALE) {                             		\
	    a = (a * rA) / NORM_SCALE;                                  \
	}								\
        if (xA < NORM_SCALE) {                                  	\
            a = (a * xA) / NORM_SCALE;                                  \
	}								\
        dA = d = CLIP_BLEND(a, b, sA, dA);                              \
        dR = CLIP_BLEND(a, b, sR, dR);                                  \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OUT_RULE4(rA, cA, xA,					\
                      sA, sR, sG, sB,                			\
                      dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        unsigned int a = NORM_SCALE_1 - dA;                             \
        unsigned int b = NORM_SCALE - rA;                               \
	/* REMIND: workaround for Solaris2.6 iropt crash */		\
	/* Storing the dA result temporarily into a volatile variable	\
	 * fixes an iropt bug on Solaris 2.6 */				\
	volatile int d;							\
        if (a > (NORM_SCALE/2)) a++;				        \
	if (rA < NORM_SCALE) {                             		\
	    a = (a * rA) / NORM_SCALE;                                  \
	}								\
        if (xA < NORM_SCALE) {                                  	\
            a = (a * xA) / NORM_SCALE;                                  \
	}								\
	dA = d = CLIP_BLEND(a, b, sA, dA);				\
	dR = CLIP_BLEND(a, b, sR, dR);					\
	dG = CLIP_BLEND(a, b, sG, dG);					\
	dB = CLIP_BLEND(a, b, sB, dB);					\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
        
#define SRC_OUT_RULE_SRC16(rA, cA, xA,					\
                           sA, sR, sG, sB,             			\
                           dA, dR, dG, dB)				\
do {								\
    if (rA > 0) {                                                       \
        unsigned int a = NORM_SCALE_1 - dA;                             \
        unsigned int b = NORM_SCALE - rA;                               \
	/* REMIND: workaround for Solaris2.6 iropt crash */		\
	/* Storing the dA result temporarily into a volatile variable	\
	 * fixes an iropt bug on Solaris 2.6 */				\
	volatile int d;							\
        if (a > (NORM_SCALE/2)) a++;				        \
	if (rA < NORM_SCALE) {                             		\
	    a = (a * rA) / NORM_SCALE;                                  \
	}								\
        if (xA < NORM_SCALE) {                                  	\
            a = (a * xA) / NORM_SCALE;                                  \
	}								\
        dA = d = ((a*sA)/SHORT_NORM_SCALE_1)+((b*dA)/NORM_SCALE);       \
        dR = ((a*sR)/SHORT_NORM_SCALE_1)+((b*dR)/NORM_SCALE);           \
        dG = ((a*sG)/SHORT_NORM_SCALE_1)+((b*dG)/NORM_SCALE);           \
        dB = ((a*sB)/SHORT_NORM_SCALE_1)+((b*dB)/NORM_SCALE);           \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OUT_RULE_DST16(rA, cA, xA,					\
                           sA, sR, sG, sB,             			\
                           dA, dR, dG, dB)				\
do {								\
    if (rA > 0) {                                                       \
        unsigned int a = SHORT_NORM_SCALE_1 - dA;                       \
        unsigned int b = NORM_SCALE - rA;                               \
	/* REMIND: workaround for Solaris2.6 iropt crash */		\
	/* Storing the dA result temporarily into a volatile variable	\
	 * fixes an iropt bug on Solaris 2.6 */				\
	volatile int d;							\
	if (rA < NORM_SCALE) {                             		\
	    a = (a * rA) / NORM_SCALE;                                  \
	}								\
        if (xA < NORM_SCALE) {                                  	\
            a = (a * xA) / NORM_SCALE;                                  \
	}								\
        dA = d = ((a*sA)/NORM_SCALE)+((b*dA)/NORM_SCALE);               \
        dR = ((a*sR)/NORM_SCALE)+((b*dR)/NORM_SCALE);                   \
        dG = ((a*sG)/NORM_SCALE)+((b*dG)/NORM_SCALE);                   \
        dB = ((a*sB)/NORM_SCALE)+((b*dB)/NORM_SCALE);                   \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OUT_RULE_SRCDST16(rA, cA, xA,				\
                              sA, sR, sG, sB,          			\
                              dA, dR, dG, dB)				\
do {								\
    if (rA > 0) {                                                       \
        unsigned int a = SHORT_NORM_SCALE_1 - dA;                       \
        unsigned int b = NORM_SCALE - rA;                               \
	/* REMIND: workaround for Solaris2.6 iropt crash */		\
	/* Storing the dA result temporarily into a volatile variable	\
	 * fixes an iropt bug on Solaris 2.6 */				\
	volatile int d;							\
	if (rA < NORM_SCALE) {                             		\
	    a = (a * rA) / NORM_SCALE;                                  \
	}								\
        if (xA < NORM_SCALE) {                                  	\
            a = (a * xA) / NORM_SCALE;                                  \
	}								\
        dA = d = ((a*sA)/SHORT_NORM_SCALE_1)+((b*dA)/NORM_SCALE);       \
        dR = ((a*sR)/SHORT_NORM_SCALE_1)+((b*dR)/NORM_SCALE);           \
        dG = ((a*sG)/SHORT_NORM_SCALE_1)+((b*dG)/NORM_SCALE);           \
        dB = ((a*sB)/SHORT_NORM_SCALE_1)+((b*dB)/NORM_SCALE);           \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
