/*
 * @(#)alphaCompst_colorloop.h	1.20 98/07/17
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <alphaCompst_XOR_MODE.h>
#include <alphaCompst_SRC.h>
#include <alphaCompst_SRC_OVER.h>
#include <alphaCompst_DST_OVER.h>
#include <alphaCompst_SRC_IN.h>
#include <alphaCompst_DST_IN.h>
#include <alphaCompst_SRC_OUT.h>
#include <alphaCompst_DST_OUT.h>
#include <alphaCompst_loop_uti.h>

#ifndef PrepColorDst
#define PrepColorDst
#endif

extern ColorLoopFunc   COLOR_BLENDFUNC;

void
COLOR_BLENDFUNC(JNIEnv *env,
		void *dstBase, jint dstScanStr, jint dstPixStr,
		unsigned char *pathData, jint offset,
		jint alphaTileScan, jint rule, jfloat fXtraAlpha,
                jint width, jint height, jint color, ColorData *cData)
{
    int extraAlpha = (int)(fXtraAlpha*(float)NORM_SCALE);
    int row, column;
    int rastAlpha = 256;
    int compAlpha = 0;
    int colorAlpha = (color >> 24) & 0xff;
    int colorRed   = (((color >> 16) & 0xff)*colorAlpha)/255;
    int colorGreen = (((color >>  8) & 0xff)*colorAlpha)/255;
    int colorBlue  = (((color >>  0) & 0xff)*colorAlpha)/255;
    int srcAlpha   = colorAlpha;
    int srcRed     = colorRed;
    int srcGreen   = colorGreen;
    int srcBlue    = colorBlue;
    int dstAlpha;
    int dstRed;
    int dstGreen;
    int dstBlue;
    int pathDataInc = 1;
    int skipDst;
    int skipDither = 0;
    
    DeclareDst
#ifdef DST_XCCC
    PrepColorDst;
#endif

    InitRastAlpha;

    if (rule == SRC_OVER && extraAlpha == NORM_SCALE && colorAlpha == 255) {
        rule = SRC;
    }
    InitDst;

    switch (rule) {

    case XOR_MODE:
        skipDither = 1;
#ifdef FastXORLoop
        FastXORLoop;
#else
        COMPOSITE_COLOR(RASTEROP_XOR(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
#endif
        skipDither = 0;
        break;

    case CLEAR:
        CLEAR_COMP;
        break;

    case SRC:
	{
#define SKIP_READ_DST_PIXEL
            COMPOSITE_COLOR(SRC_RULE(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
#undef SKIP_READ_DST_PIXEL
	}
        break;

    case SRC_OVER:
        COMPOSITE_COLOR(SRC_OVER_RULE(rastAlpha, compAlpha, extraAlpha,
                                      srcAlpha, srcRed, srcGreen, srcBlue,
                                      dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case DST_OVER:
        COMPOSITE_COLOR(DST_OVER_RULE(rastAlpha, compAlpha, extraAlpha,
                                      srcAlpha, srcRed, srcGreen, srcBlue,
                                      dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case SRC_IN:
        COMPOSITE_COLOR(SRC_IN_RULE(rastAlpha, compAlpha, extraAlpha,
                                    srcAlpha, srcRed, srcGreen, srcBlue,
                                    dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case DST_IN:
        COMPOSITE_COLOR(DST_IN_RULE(rastAlpha, compAlpha, extraAlpha,
                                    srcAlpha, srcRed, srcGreen, srcBlue,
                                    dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case SRC_OUT:
        COMPOSITE_COLOR(SRC_OUT_RULE(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case DST_OUT:
        COMPOSITE_COLOR(DST_OUT_RULE(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    }
}
