/*
 * @(#)alphaCompst_loop_uti.h	1.21 98/08/31
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <string.h>
/**
 * Macros used in different variants of the compositing loop.
 */

#ifndef SKIP_READ_DST_PIXEL
#define ReadDst ReadDstPixel(dstAlpha, dstRed, dstGreen, dstBlue)
#else
#define ReadDst
#endif

#define CLIP_BLEND(rA, cA, s1, s2)					\
    ((((rA) * (s1))/NORM_SCALE) + (((cA) * (s2)) / NORM_SCALE))


/* CLEAR Rule is the same for all composite flavors */
#define CLEAR_COMP                                                      \
do {                                                                       \
    /* REMIND */\
    /* variables used to misguide the optimizer, see below */\
    int t[4];                                                           \
    int *p = t;                                                         \
    /*********/\
    if (pathData) {                                                     \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                ReadRastAlpha(rastAlpha);                               \
                if (rastAlpha > 0) {					\
                    int a = NORM_SCALE - rastAlpha;                     \
                    if (a) {                                            \
                         ReadDst;                                       \
                         /* REMIND */\
                        /*There is a bug in the iropt (optimizer) in */\
                        /*the Sparc Compiler 4.2 under Solaris 2.6 that */\
                        /*cause the iropt to die. Therefore the next five */\
                        /*lines with the purpose to misguide the optimizer. */\
                         *p++     = (a*dstAlpha)/NORM_SCALE;            \
                         *p++     = (a*dstRed  )/NORM_SCALE;            \
                         *p++     = (a*dstGreen)/NORM_SCALE;            \
                         *p       = (a*dstBlue )/NORM_SCALE;            \
                         dstBlue = *p--; dstGreen = *p--; dstRed = *p--; dstAlpha = *p;\
                    } else {                                            \
                         dstAlpha = 0;                                  \
                         dstRed   = 0;                                  \
                         dstGreen = 0;                                  \
                         dstBlue  = 0;                                  \
                    }                                                   \
                    WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                }                                                       \
                NextRastAlpha;                                          \
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
            NextRastAlphaRow;                                           \
        }                                                               \
    } else {                                                            \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                int a = NORM_SCALE - rastAlpha;                         \
                if (a) {                                                \
                     ReadDst;                                           \
                     /* REMIND */\
                     /*There is a bug in the iropt (optimizer) in */\
                     /*the Sparc Compiler 4.2 under Solaris 2.6 that */\
                     /*cause the iropt to die. Therefore the next five */\
                     /*lines with the purpose to misguide the optimizer. */\
                     *p++     = (a*dstAlpha)/NORM_SCALE;            \
                     *p++     = (a*dstRed  )/NORM_SCALE;            \
                     *p++     = (a*dstGreen)/NORM_SCALE;            \
                     *p       = (a*dstBlue )/NORM_SCALE;            \
                     dstBlue = *p--; dstGreen = *p--; dstRed = *p--; dstAlpha = *p;\
                } else {                                                \
                     dstAlpha = 0;                                      \
                     dstRed   = 0;                                      \
                     dstGreen = 0;                                      \
                     dstBlue  = 0;                                      \
                }                                                       \
                WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue);     \
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
        }                                                               \
    }                                                                   \
} while (0);

#define INT_FASTCOPYLOOP                                                \
    do {								\
        int bytes_per_row = width*sizeof(int);                          \
        for (row = 0 ; row < height ; row++) {                          \
            memcpy(dstPtr, srcPtr, bytes_per_row);                      \
            dstPtr += dstScanStr + width;                               \
            srcPtr += srcScanStr + width;                               \
        }								\
    } while (0);

#define INT_FASTXORLOOP                                                 \
do {                                                                    \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                *dstPtr++ ^= color;                                     \
            }                                                           \
            dstPtr += dstScanStr;                                       \
        }                                                               \
} while (0); 

#define COMPOSITE_TILE(AssignBG, Rule)                                  \
do {                                                                    \
    if (pathData) {                                                     \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                ReadRastAlpha(rastAlpha);                               \
                if (rastAlpha > 0) {					\
                    ReadSrcPixel(srcAlpha, srcRed, srcGreen, srcBlue);  \
                    ReadDst;                                            \
                    AssignBG;                                           \
                    skipDst = 0;                                        \
                    Rule;                                               \
                    if (!skipDst) {                                     \
                        WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                    }                                                   \
                }                                                       \
                NextRastAlpha;                                          \
                NextSrcPixel;                                           \
                NextDstPixel;                                           \
            }                                                           \
            NextSrcRow;                                                 \
            NextDstRow;                                                 \
            NextRastAlphaRow;                                           \
        }                                                               \
    } else {                                                            \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                rastAlpha = 256;                                        \
                ReadSrcPixel(srcAlpha, srcRed, srcGreen, srcBlue);      \
                ReadDst;                                                \
                AssignBG;                                               \
                skipDst = 0;                                            \
                Rule;                                                   \
                if (!skipDst) {                                         \
                    WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                }                                                       \
                NextSrcPixel;                                           \
                NextDstPixel;                                           \
            }                                                           \
            NextSrcRow;                                                 \
            NextDstRow;                                                 \
        }                                                               \
    }                                                                   \
} while (0);

#define RestoreSrcColor()						\
    do {								\
	srcAlpha = colorAlpha;						\
	srcRed   = colorRed;						\
	srcGreen = colorGreen;						\
	srcBlue  = colorBlue;						\
    } while (0)

#ifdef DST_XCCC

#define COMPOSITE_COLOR(Rule)                                           \
do {                                                                    \
    if (pathData) {                                                     \
      if (rule == SRC &&                                                \
	  extraAlpha == NORM_SCALE &&                                   \
	  colorAlpha == 255) {		                                \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                ReadRastAlpha(rastAlpha);                               \
                if (rastAlpha > 0) {					\
		    if (rastAlpha >= 256) {				\
			CopyColorToDst;					\
		    } else {						\
			ReadDst;                                        \
                        skipDst = 0;                                    \
			Rule;                                           \
                        if (!skipDst) {                                 \
			    WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                        }                                               \
			RestoreSrcColor();				\
		    }							\
                }                                                       \
                NextRastAlpha;                                          \
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
            NextRastAlphaRow;                                           \
        }                                                               \
      } else {								\
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                ReadRastAlpha(rastAlpha);                               \
                if (rastAlpha > 0) {					\
		    ReadDst;						\
                    skipDst = 0;                                        \
		    Rule;						\
                    if (!skipDst) {                                     \
		         WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                    }                                                   \
		    RestoreSrcColor();					\
                }                                                       \
                NextRastAlpha;                                          \
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
            NextRastAlphaRow;                                           \
        }                                                               \
      }									\
    } else {                                                            \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                rastAlpha = 256;                                        \
                ReadDst;                                                \
                skipDst = 0;                                            \
                Rule;                                                   \
                if (!skipDst) {                                         \
                     WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                }                                                       \
		RestoreSrcColor();					\
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
        }                                                               \
    }                                                                   \
} while (0);
#else

#define COMPOSITE_COLOR(Rule)                                           \
do {                                                                    \
    if (pathData) {                                                     \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                ReadRastAlpha(rastAlpha);                               \
                if (rastAlpha > 0) {					\
		    ReadDst;						\
                    skipDst = 0;                                        \
		    Rule;						\
                    if (!skipDst) {                                     \
		        WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                    }                                                   \
		    RestoreSrcColor();					\
                }                                                       \
                NextRastAlpha;                                          \
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
            NextRastAlphaRow;                                           \
        }                                                               \
    } else {                                                            \
        for (row = 0 ; row < height ; row++) {                          \
            for (column = 0 ; column < width ; column++) {              \
                rastAlpha = 256;                                        \
                ReadDst;                                                \
                skipDst = 0;                                            \
                Rule;                                                   \
                if (!skipDst) {                                         \
		    WriteDstPixel(dstAlpha, dstRed, dstGreen, dstBlue); \
                }                                                       \
		RestoreSrcColor();					\
                NextDstPixel;                                           \
            }                                                           \
            NextDstRow;                                                 \
        }                                                               \
    }                                                                   \
} while (0);
#endif

#define EMPTY_STATEMENT

#define ASSIGN_BG(sA, sR, sG, sB, bA, bR, bG, bB)                       \
        if (sA == 0){                                                   \
            sA = bA;                                                    \
            sR = bR;                                                    \
            sG = bG;                                                    \
            sB = bB;                                                    \
         }
