/*
 * @(#)calcxtbl.c	1.5 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * File: calcxtbl.c	1.7 98/02/17
 *
 *	Contains:	based on the FPU flag, chooses which routine
 *			to call at runtime.
 *
 *	Written by:	The Boston White Sox
 *
 **********************************************************************
 *    COPYRIGHT (c) Eastman Kodak Company, 1993-1998
 *    An an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *********************************************************************
 */

/*
 *	General definitions
 */

#include "kcms_sys.h"

#if defined (KPMAC68K)
#include <Gestalt.h>
#else
#define gestaltNoFPU 0
#endif

#include <math.h>
#include "kcmptdef.h"
#include "kcmptlib.h"
#include "kcptmgr.h"
#include "fut.h"
#include "csmatrix.h"

static	KpInt32_t	kcpFPUType = gestaltNoFPU;

#if defined (KPMAC68K)
/************************************************************************/
/* For the macintosh find out if there is a floating point processor.	*/
/*	for everybody else there is not.									*/
/************************************************************************/
void
kcpGetFPU ()
{
	OSErr	myErr;

	myErr = Gestalt(gestaltFPUType, &kcpFPUType);
}
#endif

/************************************************************/
/*	Return gestalt status for whether or not FPU is present */
/************************************************************/
KpInt32_t
	kcpIsFPUpresent ()
{
	return (kcpFPUType);
}

#if !defined (KPMAC68K)
/************************************************************/
/* If this is not a KPMAC68K these functions do not exhist. */
/************************************************************/

PTErr_t
	makeOutputMatrixXformFPU (	KpF15d16_t FAR*	matrix,
							u_int32			gridsize,
							fut_ptr_t FAR*	theFut)
{
	if (matrix) {}
	if (gridsize) {}
	if (theFut) {}

	return (KCP_SYSERR_2);
}

PTErr_t makeProfileXformFPU (FixedXYZColor_p rXYZ,
							FixedXYZColor_p gXYZ,
							FixedXYZColor_p bXYZ,
							ResponseRecord_p rTRC,
							ResponseRecord_p gTRC,
							ResponseRecord_p bTRC,
							u_int32 gridsize,
							KpBool_t invert,
							newMGmode_p newMGmodeP,
							fut_ptr_t FAR* theFut)
{
	if (rXYZ) {}
	if (gXYZ) {}
	if (bXYZ) {}
	if (rTRC) {}
	if (gTRC) {}
	if (bTRC) {}
	if (gridsize) {}
	if (invert) {}
	if (newMGmodeP) {}
	if (theFut) {}

	return (KCP_SYSERR_2);
}

PTErr_t makeForwardXformFromMatrixFPU (LPMATRIXDATA	mdata,
									u_int32			gridsize,
									KpUInt32_t		interpMode,
									fut_ptr_t *		theFut)
{
	if (mdata) {}
	if (gridsize) {}
	if (interpMode) {}
	if (theFut) {}

	return (KCP_SYSERR_2);
}

PTErr_t makeInverseXformFromMatrixFPU (LPMATRIXDATA	mdata,
									u_int32 		gridsize,
									KpUInt32_t		interpMode,
									fut_ptr_t *		theFut)
{
	if (mdata) {}
	if (gridsize) {}
	if (interpMode) {}
	if (theFut) {}

	return (KCP_SYSERR_2);
}

void calcGtbl3FPU (fut_gtbldat_ptr_t *table, int32 *gridSizes,
					double **rows, KpBool_t xrange)
{
	if (table) {}
	if (gridSizes) {}
	if (rows) {}
	if (xrange) {}
}

void calcItbl1FPU (fut_itbldat_ptr_t table, int32 gridSize, double gamma)
{
	if (table) {}
	if (gridSize) {}
	if (gamma) {}
}

void calcItbl256FPU (fut_itbldat_ptr_t table, int32 gridSize, unsigned short lut[])
{
	if (table) {}
	if (gridSize) {}
	if (lut) {}
}

PTErr_t calcItblNFPU (fut_itbldat_ptr_t table, int32 gridSize, ResponseRecord* rrp, KpUInt32_t interpMode)
{
	if (table) {}
	if (gridSize) {}
	if (rrp) {}
	if (interpMode) {}
	return (KCP_SUCCESS);
}

void calcOtbl0FPU (fut_otbldat_ptr_t table)
{
	if (table) {}
}

void calcOtbl1FPU (fut_otbldat_ptr_t table, double fwdgamma)
{
	if (table) {}
	if (fwdgamma) {}
}

PTErr_t calcOtblNFPU (fut_otbldat_ptr_t table, ResponseRecord* rrp, KpUInt32_t interpMode)
{
	if (table) {}
	if (rrp) {}
	if (interpMode) {}
	return (KCP_SUCCESS);
}

double calcInvertTRCFPU (double p, KpUInt16_p data, KpUInt32_t length)
{
	if (p) {}
	if (data) {}
	if (length) {}
	return (0);
}

#endif

