/*
 * @(#)cmmdll.c	1.1 98/05/10
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*

	Contains:	This module contains the required DLL entry points.
			Created by acr, October 94, 1997

	Written by:	The Kodak CMS  Team

 **********************************************************************
 *** COPYRIGHT (c) Eastman Kodak Company, 1997-1998
 *** As an unpublished work pursuant to Title 17 of the United
 *** States Code.  All rights reserved.
 **********************************************************************
 */

#include "kcmsos.h"

void KpMemInit();

/* Global handle to save the DLL's Instance */
HANDLE	SpHInst;

/* Macro for debug strings */
#if defined(_DEBUG)
#define SP_DEBUG_STRING(dbgstr) OutputDebugString (dbgstr)
#else
#define SP_DEBUG_STRING(dbgstr) 
#endif

/****************************************************************************
 * Function: DllMain (HINSTANCE, WORD, LPVOID)
 *
 * Purpose:  Entry point to DLL.
 *
 * Parameters: None
 *          hInstance == Handle to this instance
 *       reasonCalled == Situation when DllMain is called
 *
 * Comments:
 *
 * History:  Date       Author        Reason
 *           8/5/93		P. Tracy      Created
 ****************************************************************************/
INT APIENTRY DllMain (HINSTANCE hInstance, DWORD reasonCalled, LPVOID lpNot)
{
	lpNot = lpNot;
	hInstance = hInstance;

	SP_DEBUG_STRING ("jprofile ");
	switch (reasonCalled) {
	case DLL_PROCESS_ATTACH:
		SP_DEBUG_STRING ("Process Attach");
		KpMemInit();
		SpHInst = hInstance;
		break;

	case DLL_PROCESS_DETACH:
		SP_DEBUG_STRING ("Process Detach");
		SpHInst = NULL;
		break;

	case DLL_THREAD_ATTACH:
		SP_DEBUG_STRING ("Thread Attach");
		break;

	case DLL_THREAD_DETACH:
		SP_DEBUG_STRING ("Thread Detach");
		break;
	}
	SP_DEBUG_STRING ("\n");

    return TRUE;
}
