/*
 * @(#)csmatrix.h	1.5 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * File: csmatrix.h	1.19 98/02/17
 *			This module contains private definitions required
 *			by the color space to transform software
 *			Created by PGT, Nov 1, 1993
 *			From RFP prototype on Sun
 *
 ****************************************************************
 *    COPYRIGHT (c) 1993-1998 Eastman Kodak Company.
 *    As an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *****************************************************************
 */


#if !defined(CSMATRIX_H)
#define CSMATRIX_H

#include <math.h>
#include "matdata.h"


/* Convenient Notations */

#ifndef NULL
#define NULL	(0)
#endif

#define ALLOC(number,size)	(allocBufferPtr((KpInt32_t)((number)*(size))))

#define	DALLOC(ptr)	(freeBufferPtr((KpChar_p)(ptr)),\
				(ptr) = NULL)	/* deallocate memory */

/* Private Function Prototypes */

double f4l ARGS((double x, double xtab[], double ytab[], int n, int* hint));
double f4lFPU ARGS((double x, double xtab[], double ytab[], KpInt32_t n, KpInt32_p hint));
void calcGtbl3 ARGS((fut_gtbldat_ptr_t*, KpInt32_p, double**,KpBool_t));
void calcItbl1 ARGS((fut_itbldat_ptr_t, KpInt32_t, double));
void calcItbl256 ARGS((fut_itbldat_ptr_t, KpInt32_t, KpUInt16_p));
PTErr_t calcItblN ARGS((fut_itbldat_ptr_t table, KpInt32_t gridSize, ResponseRecord* rrp, KpUInt32_t interpMode));
void calcOtbl0 ARGS((fut_otbldat_ptr_t));
void calcOtbl1 ARGS((fut_otbldat_ptr_t, double));
PTErr_t calcOtblN ARGS((fut_otbldat_ptr_t table, ResponseRecord* rrp, KpUInt32_t interpMode));
double calcInvertTRC ARGS((double p, KpUInt16_p data, KpUInt32_t length));
KpInt32_t solvemat ARGS((int, double**, double*));

void calcGtbl3noFPU ARGS((fut_gtbldat_ptr_t*, KpInt32_p, double**,KpBool_t));
void calcItbl1noFPU ARGS((fut_itbldat_ptr_t, KpInt32_t, double));
void calcItbl256noFPU ARGS((fut_itbldat_ptr_t, KpInt32_t, KpUInt16_p));
PTErr_t calcItblNnoFPU ARGS((fut_itbldat_ptr_t table, KpInt32_t gridSize, ResponseRecord* rrp, KpUInt32_t interpMode));
void calcOtbl0noFPU ARGS((fut_otbldat_ptr_t));
void calcOtbl1noFPU ARGS((fut_otbldat_ptr_t, double));
PTErr_t calcOtblNnoFPU ARGS((fut_otbldat_ptr_t table, ResponseRecord* rrp, KpUInt32_t interpMode));
double calcInvertTRCnoFPU ARGS((double p, KpUInt16_p data, KpUInt32_t length));

void calcGtbl3FPU ARGS((fut_gtbldat_ptr_t*, KpInt32_p, double**,KpBool_t));
void calcItbl1FPU ARGS((fut_itbldat_ptr_t, KpInt32_t, double));
void calcItbl256FPU ARGS((fut_itbldat_ptr_t, KpInt32_t, KpUInt16_p));
PTErr_t calcItblNFPU ARGS((fut_itbldat_ptr_t table, KpInt32_t gridSize, ResponseRecord* rrp, KpUInt32_t interpMode));
void calcOtbl0FPU ARGS((fut_otbldat_ptr_t));
void calcOtbl1FPU ARGS((fut_otbldat_ptr_t, double));
PTErr_t calcOtblNFPU ARGS((fut_otbldat_ptr_t table, ResponseRecord* rrp, KpUInt32_t interpMode));
double calcInvertTRCFPU ARGS((double p, KpUInt16_p data, KpUInt32_t length));

#if defined(KCP_FPU)			/* using the FPU? */
_float_eval log10fpu(_float_eval _x);
_float_eval powfpu(_float_eval _x,_float_eval _y);
#endif	/* #if defined(KCP_FPU) */

#endif
