;
; @(#)evalth13.asm	1.4 98/06/29
;
; Copyright 1997, 1998 by Sun Microsystems, Inc.,
; 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
; All rights reserved.
;
; This software is the confidential and proprietary information
; of Sun Microsystems, Inc. ("Confidential Information").  You
; shall not disclose such Confidential Information and shall use
; it only in accordance with the terms of the license agreement
; you entered into with Sun.
;

; File:	evalTh13.asm	@(#)evalth13.asm	1.6	02/25/98
; Created 17-Mar-97	GBP
;
; Copyright (C) 1997-1998 Eastman Kodak Company. All rights reserved.
;
; This file is a replacement for the file evalth13.c for
; Pentium architectures.

	page	60,200

	.586P

	.model	flat, c

	.code


MAX_OUTPUT_CHANS	equ	8	;max number of output channels
MAX_PT_CHAIN_SIZE	equ	20
TH1_4D_PENTAHEDRA	equ	24
KCM_USHORT_12		equ 10
TH1_I3_ICHANS		equ 3

ecm	struct
	bytes	dword	?
	P		dword	?
	H		dword	?
ecm	ends

it	struct
	index	dword	?
	frac	dword	?
it	ends

t4c	struct
	tvert1	dword	?
	tvert2	dword	?
	tvert3	dword	?
	tvert4	dword	?
	d4x		dword	?
	d4y		dword	?
	d4z		dword	?
	d4t		dword	?
t4c	ends

;the PTTable_p structure
ec	struct
	uid				dword ?					;structure identifier */
	refNum			dword ?					;the reference number for the PT */
	hdr				dword ?					;address of the PT header */
	attrBase		dword ?					;address of the PT attributes */
	data			dword ?					;address of the PT data */
	checkInFlag		dword ?					;is this PT checked in? */
	inUseCount		dword ?					;number of links to this PT */
	serialPTflag	dword ?					;is this a serial PT? */
	serialCount		dword ?					;# of PTs in the serial chain */
	serialDef		dword MAX_PT_CHAIN_SIZE dup	(0) 	;list of PTs for serial eval

	futP				dword ?		;locked fut */
	evalIOMask			dword ?		;I/O mask for the evaluation */
	evalDataTypeI		dword ?		;input and output data types */
	evalDataTypeO		dword ?;

	esIOMask			dword ?		;I/O mask of the evaluation assigned to the cache
	esDataTypeI			dword ?		;input and output data sizes
	esDataTypeO			dword ?		;

	inputTableEntries	dword ?		; # of entries in each input table
	inputLuts			ecm	{}		; Input lookup tables of the cached fut for a given evaluation

	gridLuts			ecm	{}		; grid lookup tables for each channel

	outputLuts			ecm	{}		; Output lookup tables of the cached fut for a given evaluation

	gridOffset0			dword ?		; Offset in grid from base of a cell to next entry in each dimension
	gridOffset1			dword ?
	gridOffset2			dword ?
	gridOffset3			dword ?
	gridOffset4			dword ?
	gridOffset5			dword ?
	gridOffset6			dword ?
	gridOffset7			dword ?
	gridOffset8			dword ?
	gridOffset9			dword ?
	gridOffset10		dword ?
	gridOffset11		dword ?
	gridOffset12		dword ?
	gridOffset13		dword ?
	gridOffset14		dword ?
	gridOffset15		dword ?

	esFinder	t4c	TH1_4D_PENTAHEDRA dup	({})	; finder tables for pentahedron data

ec	ends

;All of these functions have the same argument list
;This structure describes the stack frame during
;execution of the function.

	;!!! local variables must not exceed 4k bytes total !!!
	;Otherwise stack guard page will be skipped and page fault will occur

sf	struct
	sebx		dword	?
	sedi		dword	?
	sesi		dword	?
	sebp		dword	?
	prevRes0	word	?
	prevRes1	word	?
	prevRes2	word	?
	prevRes3	word	?
	prevRes4	word	?
	prevRes5	word	?
	prevRes6	word	?
	prevRes7	word	?
	outLut0		dword	?
	inLut0		dword	?
	inLut1		dword	?
	inLut2		dword	?
	gridBase	dword	?
	i			dword	?
	prevColor	dword	?
	prevColor2	dword	?
	dataMask	dword	?
	tvert1		dword	?
	tvert2		dword	?
	tvert3		dword	?
	tvert4		dword	?
	xf			dword	?
	yf			dword	?
	zf			dword	?
	tf			dword	?
	a001		dword	?
	a010		dword	?
	a011		dword	?
	a100		dword	?
	a101		dword	?
	a110		dword	?
	a111		dword	?
	a1000		dword	?
	a1001		dword	?
	a1010		dword	?
	a1011		dword	?
	a1100		dword	?
	a1101		dword	?
	a1110		dword	?
	inp0		dword	?
	inStride0	dword	?
	inp1		dword	?
	inStride1	dword	?
	inp2		dword	?
	inStride2	dword	?
	inp3		dword	?
	inStride3	dword	?
	outp0		dword	?
	outStride0	dword	?
	outp1		dword	?
	outStride1	dword	?
	outp2		dword	?
	outStride2	dword	?
	outp3		dword	?
	outStride3	dword	?
	outp4		dword	?
	outStride4	dword	?
	outp5		dword	?
	outStride5	dword	?
	outp6		dword	?
	outStride6	dword	?
	outp7		dword	?
	outStride7	dword	?
	returnAddress	dword	?
	inp			dword	?
	inStride	dword	?
	outp		dword	?
	outStride	dword	?
	n			dword	?
	th1Cache	dword	?
sf	ends


rData0Xf	equ ebx
rData1Yf	equ ecx
rData2Zf	equ edx
rThisColor	equ edi

rBaseP		equ ebp
rIOLut		equ edi
rTResult	equ ebx
rTVertData	equ ecx
rMulAcc	equ edx


initLocalsI3	macro	nCHANs
	LOCAL	l00, l01

	sub		esp, sf.returnAddress	;set up stack frame

	mov		[esp].sf.sebx, ebx		;save volatile registers
	mov		[esp].sf.sedi, edi
	mov		[esp].sf.sesi, esi
	mov		[esp].sf.sebp, ebp

	mov		ebp, [esp].sf.th1Cache	; th1Cache in ebp

	mov		eax, [esp].sf.inp		;inp0 = inp[0].p8, inp1 = inp[1].p8, inp2 = inp[2].p8;
	mov		ecx, [esp].sf.inStride	;inStride0 = inStride[0], inStride1 = inStride[1], inStride2 = inStride[2]

	theComp = 0
	repeat	TH1_I3_ICHANS
		mov		ebx, [eax+theComp*4]
		mov		[esp].sf.@CatStr(<inp>, %theComp), ebx

		mov		ebx, [ecx+theComp*4]
		mov		[esp].sf.@CatStr(<inStride>, %theComp), ebx

		mov		ebx, [ebp].ec.inputTableEntries
		imul	ebx, theComp
		imul	ebx, 8
		add		ebx, [ebp].ec.inputLuts.P		;inLut0 = (KpUInt8_p)th1Cache->inputLuts.P
		mov		[esp].sf.@CatStr(<inLut>, %theComp), ebx

		theComp = theComp +1

		endm

	mov		eax, [esp].sf.outp		;set up output pointers and strides
	mov		ecx, [esp].sf.outStride	;must be correct number to avoid accessing non-existent data

	theComp = 0
	repeat	&nCHANs
		mov		ebx, [eax+theComp*4]
		mov		[esp].sf.@CatStr(<outp>, %theComp), ebx

		mov		edx, [ecx+theComp*4]
		mov		[esp].sf.@CatStr(<outStride>, %theComp), edx

		theComp = theComp +1

		endm

	mov		ebx, [ebp].ec.gridLuts.P	;gridBase = (KpUInt8_p)th1Cache->gridLuts.P
	mov		[esp].sf.gridBase, ebx

	mov		ebx, [ebp].ec.outputLuts.P	;outLut0 = (KpUInt8_p)th1Cache->outputLuts.P
	mov		[esp].sf.outLut0, ebx

	mov		ebx, [ebp].ec.gridOffset1	; a001 = th1Cache->gridOffsets[1]
	mov		[esp].sf.a001, ebx
	mov		ebx, [ebp].ec.gridOffset2	; a010 = th1Cache->gridOffsets[2]
	mov		[esp].sf.a010, ebx
	mov		ebx, [ebp].ec.gridOffset3	; a011 = th1Cache->gridOffsets[3]
	mov		[esp].sf.a011, ebx
	mov		ebx, [ebp].ec.gridOffset4	; a100 = th1Cache->gridOffsets[4]
	mov		[esp].sf.a100, ebx
	mov		ebx, [ebp].ec.gridOffset5	; a101 = th1Cache->gridOffsets[5]
	mov		[esp].sf.a101, ebx
	mov		ebx, [ebp].ec.gridOffset6	; a110 = th1Cache->gridOffsets[6]
	mov		[esp].sf.a110, ebx
	mov		ebx, [ebp].ec.gridOffset7	; tvert3 = th1Cache->gridOffsets[7]
	mov		[esp].sf.tvert3, ebx

	cmp		[ebp].ec.esDataTypeI, KCM_USHORT_12	; set up data mask to prevent input table memory access violations
	jne		l00

	mov		[esp].sf.dataMask, 0fffh
	jmp		l01

l00:
	mov		[esp].sf.dataMask, 0ffffh

l01:
	mov		[esp].sf.prevColor, 0ffffffffh	;prevColor = 0xffffffff
	mov		[esp].sf.prevColor2, 0ffffffffh	;prevColor2 = 0xffffffff

	mov		eax, [esp].sf.n		; for (i = n; i > 0; i--)
	mov		[esp].sf.i, eax

	jmp		@f

pixloop:
	dec		[esp].sf.i

@@:	cmp		[esp].sf.i, 0
	jbe		getout

endm


getDataI3D8Gen	macro
	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		ebp, [esp].sf.inp0		; get inp0
	mov		bl, byte ptr [ebp]		; data0 = *inp0
	add		ebp, [esp].sf.inStride0
	mov		[esp].sf.inp0, ebp		; update inp0
	mov		rThisColor, rData0Xf
	shl		rThisColor, 10h			; thisColor = data0 << 16

	xor		rData1Yf, rData1Yf
	mov		ebp, [esp].sf.inp1
	mov		cl, byte ptr [ebp]		; data1 = *inp1
	add		ebp, [esp].sf.inStride1
	mov		[esp].sf.inp1, ebp
	mov		esi, rData1Yf
	shl		esi, 8h					; thisColor |= data1 << 8
	or		rThisColor, esi

	xor		rData2Zf, rData2Zf
	mov		ebp, [esp].sf.inp2
	mov		dl, byte ptr [ebp]		; data2 = *inp2
	add		ebp, [esp].sf.inStride2
	mov		[esp].sf.inp2, ebp
	or		rThisColor, rData2Zf	; thisColor |= data2

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	je		storeDataD8

endm


getDataI3D16Gen	macro
	LOCAL	newColor

	mov		ebp, [esp].sf.inp0				; get inp0
	mov		bx, word ptr [ebp]				; data0 = *inp0
	and		rData0Xf, [esp].sf.dataMask
	add		ebp, [esp].sf.inStride0
	mov		[esp].sf.inp0, ebp				; update inp0
	mov		rThisColor, rData0Xf
	shl		rThisColor, 10h					; thisColor = data0 << 16

	mov		ebp, [esp].sf.inp1
	mov		cx, word ptr [ebp]				; data1 = *inp1
	and		rData1Yf, [esp].sf.dataMask
	add		ebp, [esp].sf.inStride1
	mov		[esp].sf.inp1, ebp
	or		rThisColor, rData1Yf			; thisColor |= data1

	mov		ebp, [esp].sf.inp2
	mov		dx, word ptr [ebp]				; data2 = *inp2
	and		rData2Zf, [esp].sf.dataMask
	add		ebp, [esp].sf.inStride2
	mov		[esp].sf.inp2, ebp

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	jne		newColor

	cmp		[esp].sf.prevColor2, rData2Zf	; || (data2 != prevColor2)
	je		storeDataD16

newColor:
	mov		[esp].sf.prevColor2, rData2Zf	; prevColor2 = data2

endm


evalItblI3D8	macro

	mov		rIOLut, [esp].sf.inLut0				; get inLut0

	mov		eax, [rIOLut+rData0Xf*8]			; baseP += inLut0[(0*FUT_INPTBL_ENT) + data0].index
	add		rBaseP, eax
	mov		rData0Xf, [rIOLut+rData0Xf*8+4]		; Xf = inLut0[(0*FUT_INPTBL_ENT) + data0].frac

	mov		eax, [rIOLut+rData1Yf*8+800h]		; baseP += inLut0[(1*FUT_INPTBL_ENT) + data1].index
	add		rBaseP, eax
	mov		rData1Yf, [rIOLut+rData1Yf*8+804h]	; Yf = inLut0[(1*FUT_INPTBL_ENT) + data1].frac

	mov		eax, [rIOLut+rData2Zf*8+1000h]		; baseP += inLut0[(2*FUT_INPTBL_ENT) + data2].index
	add		rBaseP, eax
	mov		rData2Zf, [rIOLut+rData2Zf*8+1004h]	; Zf = inLut0[(2*FUT_INPTBL_ENT) + data2].frac

endm


evalItblI3D16	macro

	mov		rIOLut, [esp].sf.inLut0				; get inLut0
	mov		eax, [rIOLut+rData0Xf*8]			; baseP += inLut0[(0*FUT_INPTBL_ENT) + data0].index
	add		rBaseP, eax
	mov		rData0Xf, [rIOLut+rData0Xf*8+4]		; Xf = inLut0[(0*FUT_INPTBL_ENT) + data0].frac

	mov		rIOLut, [esp].sf.inLut1				; get inLut1
	mov		eax, [rIOLut+rData1Yf*8]			; baseP += inLut0[(1*FUT_INPTBL_ENT) + data1].index
	add		rBaseP, eax
	mov		rData1Yf, [rIOLut+rData1Yf*8+4]		; Yf = inLut0[(1*FUT_INPTBL_ENT) + data1].frac

	mov		rIOLut, [esp].sf.inLut2				; get inLut2
	mov		eax, [rIOLut+rData2Zf*8]			; baseP += inLut0[(2*FUT_INPTBL_ENT) + data2].index
	add		rBaseP, eax
	mov		rData2Zf, [rIOLut+rData2Zf*8+4]		; Zf = inLut0[(2*FUT_INPTBL_ENT) + data2].frac

endm


th1TetraInterp	macro

	mov		esi, [esp].sf.tvert1		; tResult = (KpInt32_t)*(ecGridData_p)(baseP + tvert1)
	xor		rTResult, rTResult
	mov		bx, word ptr [esi+rBaseP]	; tResult in ebx

	mov		esi, [esp].sf.tvert3		; mulacc = zf * ((KpInt32_t)*(ecGridData_p)(baseP + tvert3) - tResult)
	xor		rMulAcc, rMulAcc
	mov		dx, word ptr [esi+rBaseP]
	sub		rMulAcc, rTResult
	imul	rMulAcc, [esp].sf.zf

	mov		esi, [esp].sf.tvert2		; tvertData = (KpInt32_t)*(ecGridData_p)(baseP + tvert2)
	xor		rTVertData, rTVertData
	mov		cx, word ptr [esi+rBaseP]

	sub		rTResult, rTVertData		; mulacc += (yf * (tResult - tvertData))
	imul	rTResult, [esp].sf.yf
	add		rMulAcc, rTResult

	xor		rTResult, rTResult			; tResult = (KpInt32_t)*(ecGridData_p)(baseP + 0)
	mov		bx, word ptr [rBaseP]

	sub		rTVertData, rTResult		; mulacc += (xf * (tvertData - tResult))
	imul	rTVertData, [esp].sf.xf
	add		rMulAcc, rTVertData

	add		rMulAcc, 8000h			;tResult += ((mulacc + (1 << 15)) >> 16)
	sar		rMulAcc, 10h
	add		rTResult, rMulAcc

endm

th1TetraInterpOLutD8	macro theChan

	th1TetraInterp

	mov		al, byte ptr [rIOLut+rTResult+&theChan*1000h]	; prevResX = outLut0[(X*4096)+tResult]
	mov		byte ptr [esp].sf.@CatStr(<prevRes>, &theChan), al

endm


th1TetraInterpOLutD16	macro theChan

	th1TetraInterp

	mov		ax, word ptr [rIOLut+rTResult*2+&theChan*2000h]	; prevResX = outLut0[(X*2*4096)+tResult]
	mov		word ptr [esp].sf.@CatStr(<prevRes>, &theChan), ax

endm


evalTetraI3	macro	nOutputs, dataSize
	LOCAL	ftet0, ftet1, ftet3, ftet4, ftet5, ftet6, ftet7

	mov		[esp].sf.prevColor, rThisColor		; prevColor = thisColor

	mov		rBaseP, [esp].sf.gridBase			; baseP = gridBase

	evalItblI3D&dataSize

	cmp		rData1Yf, rData0Xf		; if (Xf > Yf)
	jnl		ftet3

	cmp		rData2Zf, rData1Yf		; if (Yf > Zf)
	jnl		ftet0

	mov		[esp].sf.xf, rData0Xf	; xf = Xf
	mov		[esp].sf.yf, rData1Yf	; yf = Yf
	mov		[esp].sf.zf, rData2Zf	; zf = Zf
	mov		eax, [esp].sf.a110		; tvert1 = a110
	mov		[esp].sf.tvert1, eax
	mov		eax, [esp].sf.a100		; tvert2 = a100
	mov		[esp].sf.tvert2, eax

	jmp		ftet7

ftet0:
	mov		[esp].sf.zf, rData1Yf	; zf = Yf
	mov		eax, [esp].sf.a101		; tvert1 = a101
	mov		[esp].sf.tvert1, eax

	cmp		rData2Zf, rData0Xf		; if (Xf > Zf)
	jnl		ftet1

	mov		[esp].sf.xf, rData0Xf	; xf = Xf
	mov		[esp].sf.yf, rData2Zf	; yf = Zf
	mov		eax, [esp].sf.a100		; tvert2 = a100
	mov		[esp].sf.tvert2, eax

	jmp		ftet7

ftet1:
	mov		[esp].sf.xf, rData2Zf	; xf = Zf
	mov		[esp].sf.yf, rData0Xf	; yf = Xf
	mov		eax, [esp].sf.a001		; tvert2 = a001
	mov		[esp].sf.tvert2, eax

	jmp		ftet7


ftet3:
	cmp		rData2Zf, rData1Yf		; if (Yf > Zf)
	jnl		ftet6

	mov		[esp].sf.xf, rData1Yf	; xf = Yf
	mov		eax, [esp].sf.a010		; tvert2 = a010
	mov		[esp].sf.tvert2, eax

	cmp		rData2Zf, rData0Xf		; if (Xf > Zf)
	jnl		ftet4

	mov		[esp].sf.yf, rData0Xf	; yf = Xf
	mov		[esp].sf.zf, rData2Zf	; zf = Zf
	mov		eax, [esp].sf.a110		; tvert1 = a110
	mov		[esp].sf.tvert1, eax

	jmp		ftet7

ftet4:
	mov		[esp].sf.yf, rData2Zf	; yf = Zf
	mov		[esp].sf.zf, rData0Xf	; zf = Xf
	mov		eax, [esp].sf.a011		; tvert1 = a011
	mov		[esp].sf.tvert1, eax

	jmp		ftet7

ftet6:
	mov		[esp].sf.xf, rData2Zf	; xf = Zf
	mov		[esp].sf.yf, rData1Yf	; yf = Yf
	mov		[esp].sf.zf, rData0Xf	; zf = Xf
	mov		eax, [esp].sf.a011		; tvert1 = a011
	mov		[esp].sf.tvert1, eax
	mov		eax, [esp].sf.a001		; tvert2 = a001
	mov		[esp].sf.tvert2, eax

ftet7:
	mov		rIOLut, [esp].sf.outLut0	; get outLut0

; tetrahedral interpolation for each channel
	th1TetraInterpOLutD&dataSize	0

	theComp = 1
	while	theComp ne &nOutputs

		add		rBaseP, 2					; baseP += sizeof (ecGridData_t)

		th1TetraInterpOLutD&dataSize	%theComp

		theComp = theComp +1

	endm

endm


exitTetra	macro
	mov		ebp, [esp].sf.sebp		;restore registers
	mov		esi, [esp].sf.sesi
	mov		edi, [esp].sf.sedi
	mov		ebx, [esp].sf.sebx

	add		esp, sf.returnAddress	;remove the stack frame

	ret

	endm


storeDataD8Gen	macro	nOutChans

storeDataD8:
	theComp = 0
	repeat	&nOutChans
		mov		ebp, [esp].sf.@CatStr(<outp>, %theComp)				; get outpX
		mov		al, byte ptr [esp].sf.@CatStr(<prevRes>, %theComp)	; *outpX = prevResX
		mov		byte ptr [ebp], al
		add		ebp, [esp].sf.@CatStr(<outStride>, %theComp)
		mov		[esp].sf.@CatStr(<outp>, %theComp), ebp				; update outpX

		theComp = theComp +1

		endm

	jmp		pixloop


getout:
	exitTetra

endm


storeDataD16Gen	macro	nOutChans

storeDataD16:
	theComp = 0
	repeat	&nOutChans
		mov		ebp, [esp].sf.@CatStr(<outp>, %theComp)				; get outpX
		mov		ax, word ptr [esp].sf.@CatStr(<prevRes>, %theComp)	; *outpX = prevResX
		mov		word ptr [ebp], ax
		add		ebp, [esp].sf.@CatStr(<outStride>, %theComp)
		mov		[esp].sf.@CatStr(<outp>, %theComp), ebp				; update outpX

		theComp = theComp +1

		endm

	jmp		pixloop


getout:
	exitTetra

endm


; 3 input, 1 to 8 outputs, 8 bit data.
; void evalTh1i3o3d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

evalTh1I3d8Proc	macro	nOChans

evalTh1i3o&nOChans&d8	proc	c public

	initLocalsI3	&nOChans

	getDataI3D8Gen

	evalTetraI3	&nOChans, 8

	storeDataD8Gen &nOChans

evalTh1i3o&nOChans&d8	endp

endm


; 3 input, 1 to 8 outputs, 16 bit data.
; void evalTh1i3o3d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

evalTh1I3d16Proc	macro	nOChans

evalTh1i3o&nOChans&d16	proc	c public

	initLocalsI3	&nOChans

	getDataI3D16Gen

	evalTetraI3	&nOChans, 16

	storeDataD16Gen &nOChans

evalTh1i3o&nOChans&d16	endp

endm


; void evalTh1i3o1d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o2d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o3d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o4d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o5d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o6d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o7d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o8d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o1d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o2d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o3d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o4d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o5d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o6d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o7d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
; void evalTh1i3o8d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

; Generate all of the standard 8 and 16 bit data functions
	theNumChans = 1

	repeat	MAX_OUTPUT_CHANS

		evalTh1I3d8Proc		%theNumChans
		evalTh1I3d16Proc	%theNumChans

		theNumChans = theNumChans +1

	endm


; void evalTh1iB24oB24 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

evalTh1iB24oB24	proc	c public

	initLocalsI3	3

	mov		ebp, [esp].sf.inp0		; get inp0

	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		bl, byte ptr [ebp+0]	; data0 = *inp0[0]
	mov		rThisColor, rData0Xf
	shl		rThisColor, 10h			; thisColor = data0 << 16

	xor		rData1Yf, rData1Yf
	mov		cl, byte ptr [ebp+1]	; data1 = *inp0[1]
	mov		esi, rData1Yf
	shl		esi, 8h					; thisColor |= data1 << 8
	or		rThisColor, esi

	xor		rData2Zf, rData2Zf
	mov		dl, byte ptr [ebp+2]	; data2 = *inp0[2]
	or		rThisColor, rData2Zf	; thisColor |= data2

	add		ebp, 3					; next pixel
	mov		[esp].sf.inp0, ebp		; update inp0

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	je		storeData

	evalTetraI3	3, 8

storeData:
	mov		ebp, [esp].sf.outp0		; get outp0

	mov		al, byte ptr [esp].sf.prevRes0	; *outp0[0] = prevRes0
	mov		byte ptr [ebp+0], al

	mov		al, byte ptr [esp].sf.prevRes1	; *outp0[1] = prevRes1
	mov		byte ptr [ebp+1], al

	mov		al, byte ptr [esp].sf.prevRes2	; *outp0[2] = prevRes2
	mov		byte ptr [ebp+2], al

	add		ebp, 3							; next pixel
	mov		[esp].sf.outp0, ebp

	jmp		pixloop


getout:
	exitTetra


evalTh1iB24oB24	endp


; void evalTh1iL24oL24 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

evalTh1iL24oL24	proc	c public

	initLocalsI3	3

	mov		ebp, [esp].sf.inp2		; get inp2

	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		bl, byte ptr [ebp+2]	; data0 = *inp2[2]
	mov		rThisColor, rData0Xf
	shl		rThisColor, 10h			; thisColor = data0 << 16

	xor		rData1Yf, rData1Yf
	mov		cl, byte ptr [ebp+1]	; data1 = *inp2[1]
	mov		esi, rData1Yf
	shl		esi, 8h					; thisColor |= data1 << 8
	or		rThisColor, esi

	xor		rData2Zf, rData2Zf
	mov		dl, byte ptr [ebp+0]	; data2 = *inp2[0]
	or		rThisColor, rData2Zf	; thisColor |= data2

	add		ebp, 3					; next pixel
	mov		[esp].sf.inp2, ebp		; update inp2

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	je		storeData

	evalTetraI3	3, 8

storeData:
	mov		ebp, [esp].sf.outp2		; get outp2

	mov		al, byte ptr [esp].sf.prevRes0	; *outp2[2] = prevRes0
	mov		byte ptr [ebp+2], al

	mov		al, byte ptr [esp].sf.prevRes1	; *outp2[1] = prevRes1
	mov		byte ptr [ebp+1], al

	mov		al, byte ptr [esp].sf.prevRes2	; *outp2[0] = prevRes2
	mov		byte ptr [ebp+0], al

	add		ebp, 3							; next pixel
	mov		[esp].sf.outp2, ebp

	jmp		pixloop


getout:
	exitTetra


evalTh1iL24oL24	endp


	end
