;
; @(#)evalth14.asm	1.4 98/06/29
;
; Copyright 1997, 1998 by Sun Microsystems, Inc.,
; 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
; All rights reserved.
;
; This software is the confidential and proprietary information
; of Sun Microsystems, Inc. ("Confidential Information").  You
; shall not disclose such Confidential Information and shall use
; it only in accordance with the terms of the license agreement
; you entered into with Sun.
;

; File:	evalTh14.asm	@(#)evalth14.asm	1.6	02/25/98
; Created 20-Mar-97	GBP
;
; Copyright (C) 1997-1998 Eastman Kodak Company. All rights reserved.
;
; This file is a replacement for the file evalth14.asm for
; Pentium architectures.

	page	60, 200

	.586P

	.model	flat, c
	public	pentahedron

	.data
pentahedron	dword	24,  0, 23,  0,  0,  0, 12,  0,  0,  0, 22,  0
			dword	 0,  0,  9,  8, 18,  0,  0,  0, 17, 16, 11, 10
			dword	 0,  0,  0,  0,  0,  0,  0,  7, 21,  0,  0,  0
			dword	 0,  0,  0,  0, 20,  6, 19,  3,  0,  0,  0,  2
			dword	15, 14,  0,  0,  0, 13,  0,  0,  0,  5,  0,  0
			dword	 0,  4,  0,  1


	.code

MAX_OUTPUT_CHANS	equ	4	;max number of output channels
MAX_PT_CHAIN_SIZE	equ	20
TH1_4D_PENTAHEDRA	equ	24
KCM_USHORT_12		equ 10
TH1_I4_ICHANS		equ 4
ITBLSIZ				equ 800h

ecm	struct
	bytes	dword	?
	P		dword	?
	H		dword	?
ecm	ends

it	struct
	index	dword	?
	frac	dword	?
it	ends

t4c	struct
	tvert1	dword	?
	tvert2	dword	?
	tvert3	dword	?
	tvert4	dword	?
	d4x		dword	?
	d4y		dword	?
	d4z		dword	?
	d4t		dword	?
t4c	ends

ec	struct
	uid				dword ?					;structure identifier */
	refNum			dword ?					;the reference number for the PT */
	hdr				dword ?					;address of the PT header */
	attrBase		dword ?					;address of the PT attributes */
	data			dword ?					;address of the PT data */
	checkInFlag		dword ?					;is this PT checked in? */
	inUseCount		dword ?					;number of links to this PT */
	serialPTflag	dword ?					;is this a serial PT? */
	serialCount		dword ?					;# of PTs in the serial chain */
	serialDef		dword MAX_PT_CHAIN_SIZE dup	(0) 	;list of PTs for serial eval

	futP				dword ?		;locked fut */
	evalIOMask			dword ?		;I/O mask for the evaluation */
	evalDataTypeI		dword ?		;input and output data types */
	evalDataTypeO		dword ?;

	esIOMask			dword ?		;I/O mask of the evaluation assigned to the cache
	esDataTypeI			dword ?		;input and output data sizes
	esDataTypeO			dword ?		;

	inputTableEntries	dword ?		; # of entries in each input table
	inputLuts			ecm	{}		; Input lookup tables of the cached fut for a given evaluation

	gridLuts			ecm	{}		; grid lookup tables for each channel

	outputLuts			ecm	{}		; Output lookup tables of the cached fut for a given evaluation

	gridOffset0			dword ?		; Offset in grid from base of a cell to next entry in each dimension
	gridOffset1			dword ?
	gridOffset2			dword ?
	gridOffset3			dword ?
	gridOffset4			dword ?
	gridOffset5			dword ?
	gridOffset6			dword ?
	gridOffset7			dword ?
	gridOffset8			dword ?
	gridOffset9			dword ?
	gridOffset10		dword ?
	gridOffset11		dword ?
	gridOffset12		dword ?
	gridOffset13		dword ?
	gridOffset14		dword ?
	gridOffset15		dword ?

	esFinder	t4c	TH1_4D_PENTAHEDRA dup	({})	; finder tables for pentahedron data

ec	ends

;All of these functions have the same argument list
;This structure describes the stack frame during
;execution of the function.

	;!!! local variables must not exceed 4k bytes total !!!
	;Otherwise stack guard page will be skipped and page fault will occur

sf	struct
	sebx		dword	?
	sedi		dword	?
	sesi		dword	?
	sebp		dword	?
	prevRes0	word	?
	prevRes1	word	?
	prevRes2	word	?
	prevRes3	word	?
	prevRes4	word	?
	prevRes5	word	?
	prevRes6	word	?
	prevRes7	word	?
	outLut0		dword	?
	inLut0		dword	?
	inLut1		dword	?
	inLut2		dword	?
	inLut3		dword	?
	gridBase	dword	?
	i			dword	?
	prevColor	dword	?
	prevColor2	dword	?
	dataMask	dword	?
	pentahedronP	dword	?
	esFinderP	dword	?
	thisColor	dword	?
	baseP	dword	?
	Tf	dword	?	; MUST be sequentially t, z, y, x !!
	Zf	dword	?
	Yf	dword	?
	Xf	dword	?
	tvert1		dword	?
	tvert2		dword	?
	tvert3		dword	?
	tvert4		dword	?
	tvert0Data		dword	?
	tvert1Data		dword	?
	tvert2Data		dword	?
	tvert3Data		dword	?
	tvert4Data		dword	?
	tResult		dword	?
	a001		dword	?
	a010		dword	?
	a011		dword	?
	a100		dword	?
	a101		dword	?
	a110		dword	?
	a111		dword	?
	a1000		dword	?
	a1001		dword	?
	a1010		dword	?
	a1011		dword	?
	a1100		dword	?
	a1101		dword	?
	a1110		dword	?
	inp0		dword	?
	inStride0	dword	?
	inp1		dword	?
	inStride1	dword	?
	inp2		dword	?
	inStride2	dword	?
	inp3		dword	?
	inStride3	dword	?
	outp0		dword	?
	outStride0	dword	?
	outp1		dword	?
	outStride1	dword	?
	outp2		dword	?
	outStride2	dword	?
	outp3		dword	?
	outStride3	dword	?
	outp4		dword	?
	outStride4	dword	?
	outp5		dword	?
	outStride5	dword	?
	outp6		dword	?
	outStride6	dword	?
	outp7		dword	?
	outStride7	dword	?
	returnAddress	dword	?
	inp			dword	?
	inStride	dword	?
	outp		dword	?
	outStride	dword	?
	n			dword	?
	th1Cache	dword	?
sf	ends


rData0Xf	equ eax
rData1Yf	equ ebx
rData2Zf	equ ecx
rData3Tf	equ edx
rThisColor	equ edi
rThisColor2	equ esi

rBaseP		equ ebp
rIOLut		equ edi
rTResult	equ ebx
rTVertData	equ ecx
rMulAcc		equ edx


initColorCacheD8	macro

	mov		eax, [esp].sf.inp0			;prevColor = ~(*inp0) << 24
	xor		ecx, ecx
	mov		cl, byte ptr [eax]
	not		ecx
	shl		ecx, 18h
	mov		[esp].sf.prevColor, ecx

endm


initColorCacheD16	macro

	mov		eax, [esp].sf.inp0			;prevColor = ~(*inp0) << 16
	xor		ecx, ecx
	mov		cx, word ptr [eax]
	not		ecx
	shl		ecx, 10h
	mov		[esp].sf.prevColor, ecx

endm


initLocalsI4	macro	nCHANs, dataSize

	sub		esp, sf.returnAddress	;set up stack frame

	mov		[esp].sf.sebx, ebx		;save volatile registers
	mov		[esp].sf.sedi, edi
	mov		[esp].sf.sesi, esi
	mov		[esp].sf.sebp, ebp

	mov		eax, OFFSET pentahedron		;pentahedronP
	mov		[esp].sf.pentahedronP, eax

	mov		ebp, [esp].sf.th1Cache	; th1Cache in ebp

	mov		eax, [esp].sf.inp		;inp0 = inp[0].p8, inp1 = inp[1].p8, inp2 = inp[2].p8;
	mov		ecx, [esp].sf.inStride	;inStride0 = inStride[0], inStride1 = inStride[1], inStride2 = inStride[2]

	theComp = 0
	repeat	TH1_I4_ICHANS
		mov		ebx, [eax+theComp*4]
		mov		[esp].sf.@CatStr(<inp>, %theComp), ebx

		mov		ebx, [ecx+theComp*4]
		mov		[esp].sf.@CatStr(<inStride>, %theComp), ebx

		mov		ebx, [ebp].ec.inputTableEntries
		imul	ebx, theComp
		imul	ebx, 8
		add		ebx, [ebp].ec.inputLuts.P		;inLut0 = (KpUInt8_p)th1Cache->inputLuts.P
		mov		[esp].sf.@CatStr(<inLut>, %theComp), ebx

		theComp = theComp +1

		endm

	mov		eax, [esp].sf.outp		;set up output pointers and strides
	mov		ecx, [esp].sf.outStride	;must be correct number to avoid accessing non-existent data

	theComp = 0
	repeat	&nCHANs
		mov		ebx, [eax+theComp*4]
		mov		[esp].sf.@CatStr(<outp>, %theComp), ebx

		mov		edx, [ecx+theComp*4]
		mov		[esp].sf.@CatStr(<outStride>, %theComp), edx

		theComp = theComp +1

		endm

	mov		ebx, [ebp].ec.gridLuts.P	;gridBase = (KpUInt8_p)th1Cache->gridLuts.P
	mov		[esp].sf.gridBase, ebx

	mov		ebx, [ebp].ec.outputLuts.P	;outLut0 = (KpUInt8_p)th1Cache->outputLuts.P
	mov		[esp].sf.outLut0, ebx

	lea		eax, [ebp+ec.esFinder-t4c]	;finderP = &th1Cache->esFinder[-1]
	mov		[esp].sf.esFinderP, eax

	cmp		[ebp].ec.esDataTypeI, KCM_USHORT_12	; set up data mask to prevent input table memory access violations
	jne		L00

	mov		[esp].sf.dataMask, 0fffh
	jmp		L01

L00:
	mov		[esp].sf.dataMask, 0ffffh

L01:
	initColorCacheD&dataSize

	mov		eax, [esp].sf.n				; for (i = n; i > 0; i--)
	mov		[esp].sf.i, eax

	jmp		@f

pixloop:
	dec		[esp].sf.i

@@:	cmp		[esp].sf.i, 0
	jbe		getout

endm


getDataI4D8Gen	macro

	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		ebp, [esp].sf.inp0		; get inp0
	mov		al, byte ptr [ebp]		; data0 = *inp0
	add		ebp, [esp].sf.inStride0
	mov		[esp].sf.inp0, ebp		; update inp0
	mov		rThisColor, rData0Xf
	shl		rThisColor, 18h			; thisColor = data0 << 24

	xor		rData1Yf, rData1Yf
	mov		ebp, [esp].sf.inp1
	mov		bl, byte ptr [ebp]		; data1 = *inp1
	add		ebp, [esp].sf.inStride1
	mov		[esp].sf.inp1, ebp
	mov		esi, rData1Yf
	shl		esi, 10h				; thisColor |= data1 << 16
	or		rThisColor, esi

	xor		rData2Zf, rData2Zf
	mov		ebp, [esp].sf.inp2
	mov		cl, byte ptr [ebp]		; data2 = *inp2
	add		ebp, [esp].sf.inStride2
	mov		[esp].sf.inp2, ebp
	mov		esi, rData2Zf
	shl		esi, 8h					; thisColor |= data1 << 8
	or		rThisColor, esi

	xor		rData3Tf, rData3Tf
	mov		ebp, [esp].sf.inp3
	mov		dl, byte ptr [ebp]		; data3 = *inp3
	add		ebp, [esp].sf.inStride3
	mov		[esp].sf.inp3, ebp
	or		rThisColor, rData3Tf	; thisColor |= data3

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	je		storeDataD8

endm


getDataI4D16Gen	macro

	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		ebp, [esp].sf.inp0		; get inp0
	mov		ax, word ptr [ebp]		; data0 = *inp0
	add		ebp, [esp].sf.inStride0
	mov		[esp].sf.inp0, ebp		; update inp0
	mov		rThisColor, rData0Xf
	shl		rThisColor, 10h			; thisColor = data0 << 16

	xor		rData1Yf, rData1Yf
	mov		ebp, [esp].sf.inp1
	mov		bx, word ptr [ebp]		; data1 = *inp1
	add		ebp, [esp].sf.inStride1
	mov		[esp].sf.inp1, ebp
	or		rThisColor, rData1Yf	; thisColor |= data1

	xor		rData2Zf, rData2Zf
	mov		ebp, [esp].sf.inp2
	mov		cx, word ptr [ebp]		; data2 = *inp2
	add		ebp, [esp].sf.inStride2
	mov		[esp].sf.inp2, ebp
	mov		rThisColor2, rData2Zf
	shl		rThisColor2, 10h		;thisColor2 = data2 << 16

	xor		rData3Tf, rData3Tf
	mov		ebp, [esp].sf.inp3
	mov		dx, word ptr [ebp]		; data3 = *inp3
	add		ebp, [esp].sf.inStride3
	mov		[esp].sf.inp3, ebp
	or		rThisColor2, rData3Tf	;thisColor2 |= data3

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	jne		newColor

	cmp		[esp].sf.prevColor2, rThisColor2	; || (thisColor2 != prevColor2)
	je		storeDataD16

newColor:
	mov		[esp].sf.prevColor2, rThisColor2	; prevColor2 = thisColor2

endm


evalItblI4D8	macro

	mov		rIOLut, [esp].sf.inLut0						; get inLut0

	mov		esi, [rIOLut+rData0Xf*8+0*ITBLSIZ]			; baseP += inLut0[(0*FUT_INPTBL_ENT) + data0].index
	add		rBaseP, esi
	mov		rData0Xf, [rIOLut+rData0Xf*8+0*ITBLSIZ+4]	; Xf = inLut0[(0*FUT_INPTBL_ENT) + data0].frac

	mov		esi, [rIOLut+rData1Yf*8+1*ITBLSIZ]			; baseP += inLut0[(1*FUT_INPTBL_ENT) + data1].index
	add		rBaseP, esi
	mov		rData1Yf, [rIOLut+rData1Yf*8+1*ITBLSIZ+4]	; Yf = inLut0[(1*FUT_INPTBL_ENT) + data1].frac

	mov		esi, [rIOLut+rData2Zf*8+2*ITBLSIZ]			; baseP += inLut0[(2*FUT_INPTBL_ENT) + data2].index
	add		rBaseP, esi
	mov		rData2Zf, [rIOLut+rData2Zf*8+2*ITBLSIZ+4]	; Zf = inLut0[(2*FUT_INPTBL_ENT) + data2].frac

	mov		esi, [rIOLut+rData3Tf*8+3*ITBLSIZ]			; baseP += inLut0[(3*FUT_INPTBL_ENT) + data3].index
	add		rBaseP, esi
	mov		rData3Tf, [rIOLut+rData3Tf*8+3*ITBLSIZ+4]	; Tf = inLut0[(3*FUT_INPTBL_ENT) + data3].frac

endm


evalItblI4D16	macro

	mov		rIOLut, [esp].sf.inLut0				; get inLut0
	mov		esi, [rIOLut+rData0Xf*8]			; baseP += inLut0[data0].index
	add		rBaseP, esi
	mov		rData0Xf, [rIOLut+rData0Xf*8+4]		; Xf = inLut0[data0].frac

	mov		rIOLut, [esp].sf.inLut1				; get inLut1
	mov		esi, [rIOLut+rData1Yf*8]			; baseP += inLut1[data1].index
	add		rBaseP, esi
	mov		rData1Yf, [rIOLut+rData1Yf*8+4]		; Yf = inLut1[data1].frac

	mov		rIOLut, [esp].sf.inLut2				; get inLut2
	mov		esi, [rIOLut+rData2Zf*8]			; baseP += inLut2[data2].index
	add		rBaseP, esi
	mov		rData2Zf, [rIOLut+rData2Zf*8+4]		; Zf = inLut2[data2].frac

	mov		rIOLut, [esp].sf.inLut3				; get inLut3
	mov		esi, [rIOLut+rData3Tf*8]			; baseP += inLut3[(data3].index
	add		rBaseP, esi
	mov		rData3Tf, [rIOLut+rData3Tf*8+4]		; Zf = inLut3[data3].frac

endm


th1TetraInterp	macro

	mov		esi, [esp].sf.tvert3		;tvertData = *(ecGridData_p)(baseP + tvert3)
	xor		rTVertData, rTVertData
	mov		cx, word ptr [esi+rBaseP]	;tvertData in ecx

	mov		esi, [esp].sf.tvert4		;mulacc = tf * (*(ecGridData_p)(baseP + tvert4) - tvertData)
	xor		rMulAcc, rMulAcc
	mov		dx, word ptr [esi+rBaseP]
	sub		rMulAcc, rTVertData
	imul	rMulAcc, [esp].sf.Tf

	mov		esi, [esp].sf.tvert2		;tResult = *(ecGridData_p)(baseP + tvert2)
	xor		rTResult, rTResult
	mov		bx, word ptr [esi+rBaseP]

	sub		rTVertData, rTResult		;mulacc += (zf * (tvertData - tResult))
	imul	rTVertData, [esp].sf.Zf
	add		rMulAcc, rTVertData

	mov		esi, [esp].sf.tvert1		;tvertData = *(ecGridData_p)(baseP + tvert1)
	xor		rTVertData, rTVertData
	mov		cx, word ptr [esi+rBaseP]

	sub		rTResult, rTVertData		;mulacc += (yf * (tResult - tvertData))
	imul	rTResult, [esp].sf.Yf
	add		rMulAcc, rTResult

	xor		rTResult, rTResult			;tResult = *(ecGridData_p)(baseP + 0)
	mov		bx, word ptr [rBaseP]

	sub		rTVertData, rTResult		;mulacc += (xf * (tvertData - tResult))
	imul	rTVertData, [esp].sf.Xf
	add		rMulAcc, rTVertData

	add		rMulAcc, 8000h				;tResult += ((mulacc + (1 << 15)) >> 16)
	sar		rMulAcc, 10h
	add		rTResult, rMulAcc

endm


th1TetraInterpOLutD8	macro theChan

	th1TetraInterp

	mov		al, byte ptr [rIOLut+rTResult+&theChan*1000h]	; prevResX = outLut0[(X*4096)+tResult]
	mov		byte ptr [esp].sf.@CatStr(<prevRes>, &theChan), al

endm


th1TetraInterpOLutD16	macro theChan

	th1TetraInterp

	mov		ax, word ptr [rIOLut+rTResult*2+&theChan*2000h]	; prevResX = outLut0[(X*2*4096)+tResult]
	mov		word ptr [esp].sf.@CatStr(<prevRes>, &theChan), ax

endm


;find the pentahedron in which the point is located
;this builds a binary number based of the possible comparisons of the 4 interpolants
;then do the interpolation for each channel

evalTetraI4	macro	nOutputs, dataSize

	mov		[esp].sf.prevColor, rThisColor		; prevColor = thisColor
	mov		rBaseP, [esp].sf.gridBase			; baseP = gridBase

	evalItblI4D&dataSize

	mov		esi, 0				;index = 0

	cmp		rData0Xf, rData1Yf	;if (Xf > Yf)
	jle		@f

	add		esi, 20h			;index += (1<<5)

@@:	cmp		rData2Zf, rData3Tf	;if (Zf > Tf)
	jle		@f

	add		esi, 10h			;index += (1<<4)

@@:	cmp		rData2Zf, rData0Xf	;if (Xf > Zf)
	jnl		@f

	add		esi, 8				;index += (1<<3)

@@:	cmp		rData1Yf, rData3Tf	;if (Yf > Tf)
	jle		@f

	add		esi, 4				;index += (1<<2)

@@:	cmp		rData2Zf, rData1Yf	;if (Yf > Zf)
	jnl		@f

	add		esi, 2				;index += (1<<1)

@@:	cmp		rData0Xf, rData3Tf	;if (Xf > Tf)
	jle		@f

	add		esi, 1				;index += (1<<0)

@@:	mov		edi, [esp].sf.pentahedronP	;pentaInfo = esFinderP + pentahedronP[index]
	mov		edi, [edi+esi*4]
	shl		edi, 5
	add		edi, [esp].sf.esFinderP		;edi is pentaInfo

	mov		esi, [edi].t4c.tvert1		;offsets from the base grid point to the pentahedral corners
	mov		[esp].sf.tvert1, esi
	mov		esi, [edi].t4c.tvert2
	mov		[esp].sf.tvert2, esi
	mov		esi, [edi].t4c.tvert3
	mov		[esp].sf.tvert3, esi
	mov		esi, [edi].t4c.tvert4
	mov		[esp].sf.tvert4, esi

	mov		esi, [edi].t4c.d4x			;re-dorder the interpolants
	mov		[esp+esi*4+sf.Tf], rData0Xf
	mov		esi, [edi].t4c.d4y
	mov		[esp+esi*4+sf.Tf], rData1Yf
	mov		esi, [edi].t4c.d4z
	mov		[esp+esi*4+sf.Tf], rData2Zf
	mov		esi, [edi].t4c.d4t
	mov		[esp+esi*4+sf.Tf], rData3Tf

	mov		rIOLut, [esp].sf.outLut0	; get outLut0

;tetrahedral interpolation for each channel

	th1TetraInterpOLutD&dataSize	0

	theComp = 1
	while	theComp ne &nOutputs

		add		rBaseP, 2					;baseP += sizeof (ecGridData_t)

		th1TetraInterpOLutD&dataSize	%theComp

		theComp = theComp +1

	endm

endm


exitTetra	macro
	mov		ebp, [esp].sf.sebp		;restore registers
	mov		esi, [esp].sf.sesi
	mov		edi, [esp].sf.sedi
	mov		ebx, [esp].sf.sebx

	add		esp, sf.returnAddress	;remove the stack frame

	ret

	endm


storeDataD8Gen	macro	nOutChans

storeDataD8:
	theComp = 0
	repeat	&nOutChans
		mov		ebp, [esp].sf.@CatStr(<outp>, %theComp)				; get outpX
		mov		al, byte ptr [esp].sf.@CatStr(<prevRes>, %theComp)	; *outpX = prevResX
		mov		byte ptr [ebp], al
		add		ebp, [esp].sf.@CatStr(<outStride>, %theComp)
		mov		[esp].sf.@CatStr(<outp>, %theComp), ebp				; update outpX

		theComp = theComp +1

		endm

	jmp		pixloop


getout:
	exitTetra

endm


storeDataD16Gen	macro	nOutChans

storeDataD16:
	theComp = 0
	repeat	&nOutChans
		mov		ebp, [esp].sf.@CatStr(<outp>, %theComp)				; get outpX
		mov		ax, word ptr [esp].sf.@CatStr(<prevRes>, %theComp)	; *outpX = prevResX
		mov		word ptr [ebp], ax
		add		ebp, [esp].sf.@CatStr(<outStride>, %theComp)
		mov		[esp].sf.@CatStr(<outp>, %theComp), ebp				; update outpX

		theComp = theComp +1

		endm

	jmp		pixloop


getout:
	exitTetra

endm


;void evalTh1i4o1d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o2d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o3d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o4d8 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o1d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o2d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o3d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);
;void evalTh1i4o4d16 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

; 4 input, 1 to 4 outputs, 8 bit data.

evalTh1I4D8Proc	macro	nOChans

evalTh1i4o&nOChans&d8	proc	c public

	initLocalsI4 &nOChans, 8

	getDataI4D8Gen

	evalTetraI4	&nOChans, 8

	storeDataD8Gen &nOChans

evalTh1i4o&nOChans&d8	endp

endm


; 4 input, 1 to 4 outputs, 16 bit data.

evalTh1I4D16Proc	macro	nOChans

evalTh1i4o&nOChans&d16	proc	c public

	initLocalsI4 &nOChans, 16

	getDataI4D16Gen

	evalTetraI4	&nOChans, 16

	storeDataD16Gen &nOChans

evalTh1i4o&nOChans&d16	endp

endm


; Generate all of the standard 8 bit data functions
	theNumChans = 1

	repeat	MAX_OUTPUT_CHANS

		evalTh1I4D8Proc		%theNumChans
		evalTh1I4D16Proc	%theNumChans

		theNumChans = theNumChans +1

	endm


;void evalTh1iB32oB32 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

evalTh1iB32oB32	proc	c public

	initLocalsI4 4, 8

	mov		ebp, [esp].sf.inp0		; get inp0

	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		al, byte ptr [ebp+0]	; data0 = inp0[0]
	mov		rThisColor, rData0Xf
	shl		rThisColor, 18h			; thisColor = data0 << 24

	xor		rData1Yf, rData1Yf
	mov		bl, byte ptr [ebp+1]	; data1 = inp0[1]
	mov		esi, rData1Yf
	shl		esi, 10h				; thisColor |= data1 << 16
	or		rThisColor, esi

	xor		rData2Zf, rData2Zf
	mov		cl, byte ptr [ebp+2]	; data2 = inp0[2]
	mov		esi, rData2Zf
	shl		esi, 8h					; thisColor |= data1 << 8
	or		rThisColor, esi

	xor		rData3Tf, rData3Tf
	mov		dl, byte ptr [ebp+3]	; data3 = inp0[3]
	or		rThisColor, rData3Tf	; thisColor |= data3

	add		ebp, 4					; next pixel
	mov		[esp].sf.inp0, ebp		; update inp0

	cmp		[esp].sf.prevColor, rThisColor	; if (thisColor != prevColor)
	je		storeData

	evalTetraI4	4, 8

storeData:
	mov		ebp, [esp].sf.outp0		; get outp0

	mov		al, byte ptr [esp].sf.prevRes0	; outp0[0] = prevRes0
	mov		byte ptr [ebp+0], al

	mov		al, byte ptr [esp].sf.prevRes1	; outp0[1] = prevRes1
	mov		byte ptr [ebp+1], al

	mov		al, byte ptr [esp].sf.prevRes2	; outp0[2] = prevRes2
	mov		byte ptr [ebp+2], al

	mov		al, byte ptr [esp].sf.prevRes3	; outp0[3] = prevRes3
	mov		byte ptr [ebp+3], al

	add		ebp, 4							; next pixel
	mov		[esp].sf.outp0, ebp

	jmp		pixloop


getout:
	exitTetra

evalTh1iB32oB32	endp



;void evalTh1iL32oL32 (imagePtr_p, KpInt32_p, imagePtr_p, KpInt32_p, KpInt32_t, th1Cache_p);

evalTh1iL32oL32	proc	c public

	initLocalsI4 4, 8

	mov		ebp, [esp].sf.inp3		; get inp3

	xor		rData0Xf, rData0Xf		; clear upper 3 bytes for byte fetching
	mov		al, byte ptr [ebp+3]	; data0 = inp3[3]
	mov		rThisColor, rData0Xf
	shl		rThisColor, 18h			; thisColor = data0 << 24

	xor		rData1Yf, rData1Yf
	mov		bl, byte ptr [ebp+2]	; data1 = inp3[2]
	mov		esi, rData1Yf
	shl		esi, 10h				; thisColor |= data1 << 16
	or		rThisColor, esi

	xor		rData2Zf, rData2Zf
	mov		cl, byte ptr [ebp+1]	; data2 = inp3[1]
	mov		esi, rData2Zf
	shl		esi, 8h					; thisColor |= data1 << 8
	or		rThisColor, esi

	xor		rData3Tf, rData3Tf
	mov		dl, byte ptr [ebp+0]	; data3 = inp3[0]
	or		rThisColor, rData3Tf	; thisColor |= data3

	add		ebp, 4					; next pixel
	mov		[esp].sf.inp3, ebp		; update inp3

	evalTetraI4	4, 8

storeData:
	mov		ebp, [esp].sf.outp2		; get outp2

	mov		al, byte ptr [esp].sf.prevRes0	; *outp2[3] = prevRes0
	mov		byte ptr [ebp+3], al

	mov		al, byte ptr [esp].sf.prevRes1	; *outp2[2] = prevRes1
	mov		byte ptr [ebp+2], al

	mov		al, byte ptr [esp].sf.prevRes2	; *outp2[1] = prevRes2
	mov		byte ptr [ebp+1], al

	mov		al, byte ptr [esp].sf.prevRes3	; *outp2[0] = prevRes3
	mov		byte ptr [ebp+0], al

	add		ebp, 4							; next pixel
	mov		[esp].sf.outp2, ebp

	jmp		pixloop


getout:
	exitTetra

evalTh1iL32oL32	endp


	end
