/*
 * @(#)kcmptlib.h	1.4 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * File: kcmptlib.h	2.33 98/02/12
 *
 *	Contains:       Header file for KCMS Processor Library
 *
 ****************************************************************
 *    COPYRIGHT (c) 1992-1998 Eastman Kodak Company.
 *    As an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *****************************************************************
 */

#ifndef _KCMSPTLIB_H
#define _KCMSPTLIB_H 1

#include "kcms_sys.h"
#include "kcmptdef.h"

#ifdef KPWIN
typedef PTErr_t (FAR PASCAL *PTProgress_t) (KpInt32_t);
#else
typedef PTErr_t (*PTProgress_t) (KpInt32_t);
#endif


#ifdef __cplusplus
extern "C" {
#endif
PTErr_t PTCheckIn ARGS((PTRefNum_p, PTAddr_t));
PTErr_t PTCheckOut ARGS((PTRefNum_t));
PTErr_t PTActivate ARGS((PTRefNum_t, KpInt32_t, PTAddr_t));
PTErr_t PTDeActivate ARGS((PTRefNum_t));
PTErr_t PTGetPTInfo ARGS((PTRefNum_t, PTAddr_h, PTAddr_h, PTAddr_h));
PTErr_t PTNewPT ARGS((PTAddr_p, PTAddr_p, PTRefNum_p));
PTErr_t PTGetAttribute ARGS((PTRefNum_t, KpInt32_t, KpInt32_p, KpChar_p));
PTErr_t PTSetAttribute ARGS((PTRefNum_t, KpInt32_t, KpChar_p));
PTErr_t PTGetTags ARGS((PTRefNum_t, KpInt32_p, KpInt32_p));
PTErr_t PTGetSize ARGS((PTRefNum_t, KpInt32_p));
PTErr_t PTGetPT ARGS((PTRefNum_t, KpInt32_t, PTAddr_t));
PTErr_t PTGetSizeF ARGS((PTRefNum_t, PTType_t, KpInt32_p));
PTErr_t PTGetPTF ARGS((PTRefNum_t, PTType_t, KpInt32_t, PTAddr_t));
PTErr_t PTEval ARGS((PTRefNum_t, PTEvalPB_p,
					PTEvalTypes_t, KpInt32_t, KpInt32_t, opRefNum_p, PTProgress_t));
PTErr_t PTEvalDT ARGS((PTRefNum_t, PTEvalDTPB_p,
					PTEvalTypes_t, KpInt32_t, KpInt32_t, opRefNum_p, PTProgress_t));
PTErr_t PTEvalRdy ARGS((opRefNum_t, KpInt32_p));
PTErr_t PTEvalCancel ARGS((opRefNum_t));
PTErr_t PTChainValidate ARGS((KpInt32_t, PTRefNum_p, KpInt32_p));
PTErr_t PTChainInit ARGS((KpInt32_t, PTRefNum_p, KpInt32_t, KpInt32_p));
PTErr_t PTChainInitM ARGS((KpInt32_t, PTRefNum_p, KpInt32_t, KpInt32_t));
PTErr_t PTChain ARGS((PTRefNum_t));
PTErr_t PTChainEnd ARGS((PTRefNum_p));
PTErr_t PTCombine ARGS((KpInt32_t, PTRefNum_t, PTRefNum_t, PTRefNum_p));
PTErr_t PTEvaluators ARGS((KpInt32_p, evalList_p));
PTErr_t PTProcessorReset ARGS((void));
PTErr_t PTInitialize ARGS((void));
#if defined (KPWIN)
PTErr_t PTInitializeEx ARGS((PTInitInfo_p InitInfo));
#endif
PTErr_t PTTerminate ARGS((void));
PTErr_t PTInitGlue ARGS((void));
PTErr_t PTTermGlue ARGS((void));
PTErr_t PTNewEmpty ARGS((KpInt32_t, KpInt32_p, KpInt32_t, PTRefNum_p));
PTErr_t PTNewEmptySep ARGS((KpInt32_t, KpInt32_p, PTRefNum_p));
PTErr_t PTGetItbl ARGS((PTRefNum_t, KpInt32_t, KpInt32_t, KpHandle_t FAR*));
PTErr_t PTGetGtbl ARGS((PTRefNum_t, KpInt32_t, KpInt32_p, KpInt32_p, KpHandle_t FAR*));
PTErr_t PTGetOtbl ARGS((PTRefNum_t, KpInt32_t, KpHandle_t FAR*));
PTErr_t PTNewMatGamAIPT ARGS((FixedXYZColor_p, FixedXYZColor_p,
			FixedXYZColor_p, ResponseRecord_p, ResponseRecord_p,
			ResponseRecord_p, KpUInt32_t, bool, newMGmode_p, PTRefNum_p));
PTErr_t PTNewMatGamPT ARGS((FixedXYZColor_p, FixedXYZColor_p,
			FixedXYZColor_p, ResponseRecord_p, ResponseRecord_p,
			ResponseRecord_p, KpUInt32_t, bool, PTRefNum_p));
PTErr_t PTNewMonoPT ARGS((	ResponseRecord_p	grayTRC,
							KpUInt32_t			gridsize,
							bool				invert,
							PTRefNum_p			thePTRefNumP));
PTErr_t PTGetRelToAbsPT ARGS((	KpUInt32_t		RelToAbsMode,
								PTRelToAbs_p	PTRelToAbs,
								PTRefNum_p		PTRefNumPtr));
PTErr_t PTApplInitialize ARGS((KpHandle_t, KpInt32_t));
PTErr_t PTGetFlavor ARGS((KpInt32_p kcpFlavor));
#if defined(KPMAC)
void KCMPTSetComponentInstance ARGS((KpInt32_t theNewCP));
void KCMPTGetComponentInstance ARGS((KpInt32_p theCurCP));
#else
PTErr_t PTInitThread ARGS((void));
PTErr_t PTTermThread ARGS((void));
#endif
#ifdef __cplusplus
}
#endif

#endif
