/*
 * @(#)kcpfchn.h	1.5 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * File: kcpfchn.h	2.27 98/02/17
 *
 *	Contains:	header file for fut chaining in KCM driver
 *
 *********************************************************************
 *    COPYRIGHT (c) 1991-1998 Eastman Kodak Company
 *    As an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *********************************************************************
 */

#ifndef _KCMFCHAIN_H_
#define _KCMFCHAIN_H_ 1

#include "fut.h"
#include "fut_util.h"
#include "fut_io.h"

#if defined (KCP_COMP_2)
	#include "auxpt.h"
#endif

/* constants */
#define MAX_COMP_ATTR_SIZE 4	/* maximum # of characters in compose attribute */
#define RULE_PRE_COMP '+'		/* rule control to indicate Trojan Horse PT */
#define RULE_POST_COMP '_'		/* rule control to indicate Trojan Horse PT */
#define RULE_SERIAL_EVAL 'S'	/* rule control to indicate Serial Evaluation */
#define PT_SERIAL_EVAL -2		/* flags PT for Serial Evaluation */

/* the dimensions of the futs */
#define	TWO_CUBE	2			/* 2 cube min. */
#define SIXTEEN_CUBE	16

/* number of input variables */
#define	THREE_CLR	3			/* 3 input colors */
#define	FOUR_CLR	4			/* 4 input colors */

/* prototypes */
PTErr_t ComposeAttr ARGS((PTRefNum_t, PTRefNum_t, KpInt32_t, PTRefNum_t));
PTErr_t ComposeAttrFut ARGS((PTRefNum_t, PTRefNum_t, PTRefNum_t));
PTErr_t moveAttrList ARGS((PTRefNum_t, PTRefNum_t, KpInt32_p, PTRefNum_t));
PTErr_t chkPropRule07 ARGS((KpInt32_t, PTRefNum_t, PTRefNum_t, KpChar_p));
fut_ptr_t get_lin3d ARGS((KpInt32_t));
fut_ptr_t get_lin4d ARGS((KpInt32_t));
fut_ptr_t get_linlab ARGS((KpInt32_t));
fut_ptr_t get_lab2xyz ARGS((KpInt32_t));
fut_ptr_t get_xyz2lab ARGS((KpInt32_t));
void strcatNMA ARGS((KpChar_p, KpChar_p, KpChar_p));
void makeTempFileName (KpChar_p path, KpChar_p tempName);


/* routines in ptutild.c */
PTErr_t PTLoadD ARGS((KpChar_p PTName, PTRefNum_p PTRefNum_p));
PTErr_t PTStoreD ARGS((PTRefNum_t PTRefNum, KpChar_p PTName));

#if defined (KCP_COMP_2)

/* routines in auxpt.c */
PTErr_t loadAuxPT(const KpChar_p PTName, KpInt32_t invert, KpInt32_t compMode, PTRefNum_p PTRefNum_p);
PTErr_t getAuxBuild (KpInt32_t compMode, KpChar_p PTName, auxPTBuild_p auxBuildPtr);
PTErr_t getAuxName (auxPTBuild_pc auxBuild_Ptr, KpInt32_t compMode, KpChar_p PTName);
PTErr_t copyAuxBuild (auxPTBuild_pc auxBuild1_Ptr, KpInt32_t compMode, auxPTBuild_p auxBuild2_Ptr);
fut_ifunc_t getAuxIFunc (auxBuildFuncs_e func);
fut_gfunc_t getAuxGFunc (auxBuildFuncs_e func);
fut_ofunc_t getAuxOFunc (auxBuildFuncs_e func);

#endif /* KCP_COMP_2 */

#endif	/* _KCMFCHAIN_H_ */
