/*
 * @(#)linear.c	1.1 98/05/10
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 *

	Contains:	Functions used to create the linear auxiliary PTs

 *********************************************************************
 *    COPYRIGHT (c) 1992-1998 Eastman Kodak Company
 *    As an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *********************************************************************
*/

#include <math.h>
#include "fut.h"
#include "makefuts.h"

/*---------------------------------------------------------------------
 *  lin_iFunc -- input mappings
 *  					 all of the input tables are ramps.  They share the
 *						 same generating function.
 *---------------------------------------------------------------------
 */
double 
lin_iFunc (double a, KpGenericPtr_t dataP) 
{ 
	if (dataP) {}

	return a; 
}

/*---------------------------------------------------------------------
 *  lin_gFunc_x, lin_gFunc_y, lin_gFunc_z, lin_gFunc_t grid-table functions (identity)
 *---------------------------------------------------------------------
 */

fut_gtbldat_t
lin_gFunc_x (double_p args, KpGenericPtr_t dataP)
{
double		x;

	if (dataP) {}

	x = args[0];
	return QUANT (x, FUT_GRD_MAXVAL);

}

fut_gtbldat_t
lin_gFunc_y (double_p args, KpGenericPtr_t dataP)
{
double	y;

	if (dataP) {}

	y = args[1];
	return QUANT (y, FUT_GRD_MAXVAL);
}

fut_gtbldat_t
lin_gFunc_z (double_p args, KpGenericPtr_t dataP)
{
double	z;

	if (dataP) {}

	z = args[2];
	return QUANT (z, FUT_GRD_MAXVAL);
}

fut_gtbldat_t
lin_gFunc_t (double_p args, KpGenericPtr_t dataP)
{
double	t;

	if (dataP) {}

	t = args[3];
	return QUANT (t, FUT_GRD_MAXVAL);
}

/*---------------------------------------------------------------------
 *  lin_oFunc -- output mapping
 *---------------------------------------------------------------------
 */
fut_otbldat_t 
lin_oFunc (fut_gtbldat_t q, KpGenericPtr_t dataP) 
{
double s;

	if (dataP) {}

	s = DEQUANT (q, FUT_GRD_MAXVAL); 
	return QUANT (s, FUT_MAX_PEL12); 
}
