/*
 * @(#)monopt.h	1.6 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * File: monopt.h	1.6 98/02/17
 *
 *	Contains: prototypes and defines for the monochrome transforms
 *
 *	Written by:	Color Processor group
 *
 ****************************************************************
 *    COPYRIGHT (c) 1997-1998 Eastman Kodak Company.
 *    As an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *****************************************************************
 */

#ifndef MONOPT_H
#define MONOPT_H

#define RRECORD_DATA_SIZE 65536

/* function prototypes */

PTErr_t calcOtblLSN ARGS((fut_otbldat_ptr_t table, ResponseRecord* rrp));
PTErr_t calcOtblLS1 ARGS((fut_otbldat_ptr_t table, double gamma));
PTErr_t calcOtblLN ARGS((fut_otbldat_ptr_t table, ResponseRecord* rrp));
PTErr_t calcOtblL1 ARGS((fut_otbldat_ptr_t table, double gamma));

PTErr_t makeForwardXformMono ARGS((ResponseRecord FAR*	grayTRC,
									KpUInt32_t			gridsize,
									fut_ptr_t *		theFut));
PTErr_t makeInverseXformMono ARGS((ResponseRecord FAR*	grayTRC,
									KpUInt32_t 		gridsize,
									fut_ptr_t *		theFut));

fut_otbldat_t otblFunc ARGS((fut_gtbldat_t, KpGenericPtr_t));
#endif
