/*
 * @(#)ukcpmgr.c	1.6 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * File: ukcpmgr.c	1.16 98/02/18
 *
 *	Contains:     UNIX only Color Processor management function
 *
 ****************************************************************
 *    COPYRIGHT (c) 1991-1998 Eastman Kodak Company.
 *    As an unpublished work pursuant to Title 17 of the United
 *    States Code.  All rights reserved.
 *****************************************************************
 */


#include "kcms_sys.h"
#include "kcmptlib.h"
#include "kcptmgr.h"

#include <string.h>

#if defined (KPSUN)
#include <dlfcn.h>
#include <unistd.h>
#endif


#if defined (KCP_ACCEL)
#include "ctelib.h"
#endif

int	KcpUsageCount = 0;
static	KpGenericPtr_t	IGPtr = NULL;

#if defined (KPSUN) && defined (KCP_ACCEL)
void	*kcp_cte_hnd;
KcpCteFunc    kcp_cte;
#endif


/*****************************************************/
/* open driver to load it into memory, then close it */
/*****************************************************/
PTErr_t
	PTInitialize (void)
{
KpInt32_t	retErr;

	if (KcpUsageCount == 0) {		/* first process */
		retErr = KCMDsetup (&IGPtr);	/* set up this shared library */
		if (retErr != KCMS_SUCCESS) {
			return KCP_NO_MEMORY;
		}
		KcpUsageCount++;
  	}

	return KCP_SUCCESS;
}

/* Initialize platform specific portions of the instance Globals */
void
KCPInitIGblP(KpGenericPtr_t FAR* theIGPtr, initializedGlobals_p iGP)
{
KpInt32_t	nProcessors;
#if defined(KCP_ACCEL)
	char	tempBuffer[100];
#endif

	if (theIGPtr) {}

	/* setup directory for CPxx files */
#if defined (KPSGI) || defined(KPSGIALL)
	strcpy (iGP->KCPDataDir, "/var/cms/cmscp/");
#elif defined (KPSUN) && defined (SOLARIS_CMM)
	strcpy (iGP->KCPDataDir, "/tmp/");
#elif defined (JAVACMM)
	strcpy(iGP->KCPDataDir, "/tmp/");
#else
	strcpy (iGP->KCPDataDir, "/var/kodak/cmscp/");
#endif

#if defined(KCP_ACCEL)
	/* load shared library */
	kcp_cte_hnd = dlopen ("libkcme1.so.1", RTLD_NOW);
	if (kcp_cte_hnd != NULL){
		kcp_cte = (int (*)())dlsym (kcp_cte_hnd, "cte_proc_send");
		if (kcp_cte == NULL){
			strcpy (tempBuffer, "PTInitialize: ");
			strcat (tempBuffer, dlerror());
			diagWindow(tempBuffer, (int)kcp_cte_hnd);
			dlclose (kcp_cte_hnd);
			kcp_cte_hnd = NULL;
		}
	}
	else{
		strcpy (tempBuffer, "PTInitialize: ");
		strcat (tempBuffer, dlerror());
		diagWindow(tempBuffer, (int)kcp_cte_hnd);
	}
#endif  /* end of KCP_ACCEL */

	nProcessors = sysconf(_SC_NPROCESSORS_ONLN);	/* get # of processors */
#if defined (JAVACMM)
	if (thr_main() == -1) {
		nProcessors = 1;		/* no Java threading, can't use extra processors */
	}
#endif
	iGP->numProcessors = nProcessors;
}


/* Platform specific terminate processing */
PTErr_t
	PTTerminatePlatform (void)
{
	return KCP_SUCCESS;
}
