/*
 * @(#)t2kmem.c	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <malloc.h>
#include <string.h>
#include "HeadSpin.h"

#ifdef __cplusplus
extern "C"
{
#endif

struct sizeBlock {
	size_t	size;
};

typedef struct sizeBlock sizeBlock;

void* t2k_malloc(size_t size)
{
	sizeBlock* block = (sizeBlock*)malloc(size + sizeof(sizeBlock));

	if (block)
	{	block->size = size;
		return block + 1;
	}
	return 0;
}

void t2k_free(void* p)
{
	free((sizeBlock*)p - 1);
}

void* t2k_realloc(void* oldp, size_t newSize)
{
	size_t	oldSize = ((sizeBlock*)oldp - 1)->size;
	void*	newp = malloc(newSize);

	if (newp)
	{	((sizeBlock*)newp - 1)->size = newSize;

		memmove(newp, oldp, hsMinimum(oldSize, newSize));
	
		t2k_free(oldp);
	}
	return newp;
}

#ifdef __cplusplus
}
#endif
