/*
 * @(#)hsConfig.h	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Copyright (C) 1996-1997 all rights reserved by HeadSpin Technology Inc. Chapel Hill, NC USA
 *
 * This software is the property of HeadSpin Technology Inc. and it is furnished
 * under a license and may be used and copied only in accordance with the
 * terms of such license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or otherwise
 * made available to any other person or entity except as allowed under license.
 * No title to and ownership of the software or intellectual property
 * therewithin is hereby transferred.
 *
 * HEADSPIN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * This information in this software is subject to change without notice
*/

#ifndef hsConfigDefined
#define hsConfigDefined

///////////////////////////////////////////////////////////////////////

#define HS_DEBUGGING

//////////////////////////// Define ONLY 1 of these /////////////////////////

//#define HS_BUILD_FOR_REFERENCE		1
//#define HS_BUILD_FOR_MAC68K		1
//#define HS_BUILD_FOR_MACPPC		1
//#define HS_BUILD_FOR_WIN32		1

//////////////////// Change the 1s and 0s //////////////////////

#define HS_CAN_USE_FLOAT			1
#define HS_SCALAR_IS_FLOAT			1

#define HS_PIN_MATH_OVERFLOW		0		// This forces hsWide versions of FixMath routines
#define HS_DEBUG_MATH_OVERFLOW	0		// This calls hsDebugMessage on k[Pos,Neg]Infinity

#define HS_MP_SAFE				1		// this disables some ToolBox calls (may be slower)
										// but is needed to build for multi-processors/threads

//////////////////// This controls building Garnet //////////////////////

#define GARNET_IGNORE_3D

////////////////////  From here down, everything is computed  ///////////////////

#if defined(HS_BUILD_FOR_MAC68K) || defined(HS_BUILD_FOR_MACPPC) 
	#define HS_BUILD_FOR_MAC		1
#endif

#if defined(__INTEL__) && defined(HS_BUILD_FOR_MAC)
	#error Can not have HS_BUILD_FOR_MAC defined
#endif
#if (defined(GENERATING68K) || defined(GENERATINGPOWERPC)) && defined(HS_BUILD_FOR_WIN32)
	#define Can not define HS_BUILD_FOR_WIN32
#endif

#define HS_SCALAR_IS_FIXED			!(HS_SCALAR_IS_FLOAT)
#define HS_NEVER_USE_FLOAT			!(HS_CAN_USE_FLOAT)

#if HS_DEBUG_MATH_OVERFLOW && !(HS_PIN_MATH_OVERFLOW)
	#error Can not debug overflow unless HS_PIN_MATH_OVERFLOW is ON
#endif

///////////////////////////////////////////////////////////////////////

#endif
