/*
 * @(#)hsDescriptor_Internal.h	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef hsDescriptor_Internal_Defined
#define hsDescriptor_Internal_Defined

#include "HeadSpin.h"

struct DescRec {
	UInt32	fTag;
	UInt32	fLength;

	void*		GetData() { return this + 1; }
	const void*	GetConstData() const { return this + 1; }
	DescRec*		Next() { return (DescRec*)((char*)this + sizeof(DescRec) + hsLongAlign(fLength)); }
	const DescRec*	Next() const { return (DescRec*)((char*)this + sizeof(DescRec) + hsLongAlign(fLength)); }
};

struct hsDescriptorHeader {
	UInt32	fLength;
	UInt32	fCheckSum;
	UInt32	fCount;

	DescRec*		GetRec() { return (DescRec*)(this + 1); }
	const DescRec*	GetConstRec() const { return (const DescRec*)(this + 1); }
};

#endif
