/*
 * @(#)hsGGlyphCache.h	1.9 98/08/28
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Copyright (C) 1996-1997 all rights reserved by HeadSpin Technology Inc. Chapel Hill, NC USA
 *
 * This software is the property of HeadSpin Technology Inc. and it is furnished
 * under a license and may be used and copied only in accordance with the
 * terms of such license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or otherwise
 * made available to any other person or entity except as allowed under license.
 * No title to and ownership of the software or intellectual property
 * therewithin is hereby transferred.
 *
 * HEADSPIN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * This information in this software is subject to change without notice
*/

#ifndef hsGGlyphCacheDefined
#define hsGGlyphCacheDefined

#include "fontObject.h"
#include "hsGText.h"
#include "hsDescriptor.h"
#include "hsGeometry.h"

////////////////////////////////////////////////////////////////////////////////

class hsGGlyphStrike : public hsRefCnt {
private:
	class hsGScalerContext*	fScalerContext;		// created by the scaler
	// cached from the scaler context
	UInt32				fGlyphCount;
	hsFixedPoint2			fAscent, fDescent, fBaseline;
        hsFixedPoint2                   fLeading, fMaxAdvance;

	struct hsGGlyphStrikeEntry*	fEntries;
protected:
	hsDescriptor		fDesc;
public:
				hsGGlyphStrike(hsConstDescriptor desc);
	virtual			~hsGGlyphStrike();

	hsConstDescriptor	GetDesc() const { return fDesc; }
	hsPathSpline::Type	GetPathType() const;

	UInt32			CountGlyphs() const { return fGlyphCount; }
	void			GetMetrics(UInt16 index, hsGGlyph* glyph, hsFixedPoint2* advance);
	void			GetMetricsWithImage(UInt16 index, hsGGlyph* glyph, hsFixedPoint2* advance);
	const void*		GetImage(UInt16 index);
	void			GetPath(UInt16 index, struct hsPathSpline* path, hsFixedPoint2* advance);
        void                    GetLineHeight(hsFixedPoint2* ascent,
                                        hsFixedPoint2* descent,
                                        hsFixedPoint2* baseline,
                                        hsFixedPoint2* leading,
                                        hsFixedPoint2* maxAdvance);

        void                    GetItalicAngle(hsFixedPoint2* italicAngle);
        CharToGlyphMapper       *getMapper();

	// Call this to find a strike. Call strike->UnRef() when you are through  with it
	static hsGGlyphStrike*	RefStrike(hsConstDescriptor desc);

	// Call this to clean-up
	static void		KillGlyphCache();

	virtual Boolean isStyleSupported(int);
};

#endif
