/*
 * @(#)hsGScalerContext.h	1.7 98/09/15
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Copyright (C) 1996-1997 all rights reserved by HeadSpin Technology Inc. Chapel Hill, NC USA
 *
 * This software is the property of HeadSpin Technology Inc. and it is furnished
 * under a license and may be used and copied only in accordance with the
 * terms of such license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or otherwise
 * made available to any other person or entity except as allowed under license.
 * No title to and ownership of the software or intellectual property
 * therewithin is hereby transferred.
 *
 * HEADSPIN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * This information in this software is subject to change without notice
*/

#ifndef hsGScalerContextDefined
#define hsGScalerContextDefined

#include "fontObject.h"
#include "hsGText.h"
#include "hsGeometry.h"

class hsGScalerContext {
protected:
	hsPathSpline::Type	fPathType;
public:
	virtual		~hsGScalerContext() {}

	hsPathSpline::Type	GetPathType() const { return fPathType; }

	virtual UInt32	CountGlyphs() = 0;
	virtual void	GenerateMetrics(UInt16 glyphID, hsGGlyph* glyph, hsFixedPoint2* advance) = 0;
	virtual void	GenerateMetricsWithImage(UInt16 glyphID, hsGGlyph* glyph, hsFixedPoint2* advance) = 0;
	virtual void	GenerateImage(UInt16 glyphID, const hsGGlyph* glyph, void* buffer) = 0;
	virtual void	GeneratePath(UInt16 index, hsPathSpline* path, hsFixedPoint2* advance) = 0;
        virtual void	    GetLineHeight(hsFixedPoint2* ascent,
                                        hsFixedPoint2* descent,
                                        hsFixedPoint2* baseline,
                                        hsFixedPoint2* leading,
                                        hsFixedPoint2* maxAdvance) = 0;
        virtual void GetCaretAngle(hsFixedPoint2* caret) = 0;
        virtual CharToGlyphMapper *getMapper() = 0;
	virtual Boolean isStyleSupported(int) = 0;
};

#endif
