/*
 * @(#)hsInput.h	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Copyright (C) 1996-1997 all rights reserved by HeadSpin Technology Inc. Chapel Hill, NC USA
 *
 * This software is the property of HeadSpin Technology Inc. and it is furnished
 * under a license and may be used and copied only in accordance with the
 * terms of such license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or otherwise
 * made available to any other person or entity except as allowed under license.
 * No title to and ownership of the software or intellectual property
 * therewithin is hereby transferred.
 *
 * HEADSPIN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * This information in this software is subject to change without notice
*/

#include "HeadSpin.h"

#if HS_BUILD_FOR_WIN32
	#define WIN32_LEAN_AND_MEAN
	#define WIN32_EXTRA_LEAN
	#include <windows.h>
#endif

//
// hsInput class
//
class hsInput
{

public :
//
// WIN32 Keycodes
// virtual keycodes are in C:\MSDEV\INCLUDE\WINUSER.H
//
#if HS_BUILD_FOR_WIN32
enum hsKeyType
{
	 kSLASH='/',
	 kCONTROL=VK_CONTROL,
	 kALT=VK_MENU,
	 kSHIFT=VK_SHIFT,
	 kLEFT=VK_LEFT,
	 kRIGHT=VK_RIGHT,
	 kUP=VK_UP,
	 kDOWN=VK_DOWN,
	 kSPACE=VK_SPACE,
	 kPAGE_DOWN=VK_NEXT,
	 kPAGE_UP=VK_PRIOR,
	 kDELETE=VK_DELETE,
	 kESCAPE=VK_ESCAPE,
	 kEND=VK_END,
	 kHOME=VK_HOME,
	 kA='A',
	 kB='B',
	 kC='C',
	 kD='D',
	 kE='E',
	 kF='F',
	 kG='G',
	 kH='H',
	 kI='I',
	 kJ='J',
	 kK='K',
	 kL='L',
	 kM='M',
	 kN='N',
	 kO='O',
	 kP='P',
	 kQ='Q',
	 kR='R',
	 kS='S',
	 kT='T',
	 kU='U',
	 kV='V',
	 kW='W',
	 kX='X',
	 kY='Y',
	 kZ='Z',
	 k0='0',
	 k1='1',
	 k2='2',
	 k3='3',
	 k4='4',
	 k5='5',
	 k6='6',
	 k7='7',
	 k8='8',
	 k9='9',
	 kF1=VK_F1,
	 kF2=VK_F2,
	 kF3=VK_F3,
	 kF4=VK_F4,
	 kF5=VK_F5,
	 kF6=VK_F6,
	 kF7=VK_F7,
	 kF8=VK_F8,
	 kF9=VK_F9,
	 kF10=VK_F10,
	 kF11=VK_F11,
	 kF12=VK_F12,
	 kF13=VK_F13,
	 kN0 = VK_NUMPAD0,
	 kN1 = VK_NUMPAD1,
	 kN2 = VK_NUMPAD2,
	 kN3 = VK_NUMPAD3,
	 kN4 = VK_NUMPAD4,
	 kN5 = VK_NUMPAD5,
	 kN6 = VK_NUMPAD6,
	 kN7 = VK_NUMPAD7,
	 kN8 = VK_NUMPAD8,
	 kN9 = VK_NUMPAD9,
	 kPlus = VK_ADD,
	 kMinus = VK_SUBTRACT
};
#endif

//
// MAC keycodes
//
#if HS_BUILD_FOR_MAC
enum hsKeyType
{
	kSLASH=43,
	kCOMMAND=48,
	kBACKSPACE=52,
	kOPTION=61,
	kCONTROL=60,
	kSHIFT=63,
	kLEFT=124,
	kRIGHT=123,
	kUP=121,
	kDOWN=122,
	kSPACE=54,
	kPAGE_DOWN=126,
	kDELETE=114,
	kESCAPE=50,
	kA=7,
	kB=12,
	kC=15,
	kD=5,
	kE=9,
	kF=4,
	kG=2,
	kH=3,
	kI=37,
	kJ=33,
	kK=47,
	kL=34,
	kM=41,
	kN=42,
	kO=24,
	kP=36,
	kQ=11,
	kR=8,
	kS=6,
	kT=22,
	kU=39,
	kV=14,
	kW=10,
	kX=0,
	kY=23,
	kZ=1,
	k0=26,
	k1=21,
	k2=20,
	k3=19,
	k4=18,
	k5=16,
	k6=17,
	k7=29,
	k8=27,
	k9=30
};
#endif

	//
	// Functions
	//
//	Boolean KeyDown(hsKeyType keyType);

};
