/*
 * @(#)swaps.h	1.5 98/08/25
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef swapsDefined
#define swapsDefined

#include "HeadSpin.h"

#if defined(WIN32) || defined(i386)

#ifdef __cplusplus
extern "C"
{
#endif

UInt32 swapLong(UInt32 value);
UInt16 swapWord(UInt16 value);
UInt16 swapWordPtr(UInt16** value);

#ifdef __cplusplus
}
#endif

#define SWAPW(a)		swapWord(a)
#define SWAPL(a)		swapLong(a)
#define SWAPWINC(a)		swapWordPtr((unsigned short**)&a)
#define SWAPLINC(a)		swapLong(*(a)++)
#define DELTASWAPPED(a,d)		(((a) = SWAP_ (a) d), ((a) = SWAP_ (a)))

#define SWAP_(a)	\
(sizeof(a) == 1 ? (a) : \
 sizeof(a) == 2 ? SWAPW(a) : \
 sizeof(a) == 4 ? SWAPL(a) : \
 (a))

#else

#define SWAPW(a)			(a)
#define SWAPWINC(a)		(*(a)++)
#define SWAPLINC(a)		(*(a)++)
#define SWAPL(a)			(a)
#define DELTASWAPPED(a,d)	((a) = (a) d)
#define SWAP_(a)			(a)
#endif

#endif /*swapsDefined*/
