/*
 * @(#)t2kScalerContext.h	1.9 98/09/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "hsGScalerContext.h"
extern "C" 
{
#include "scaler_types.h"
#include "t2k.h"
#include "shapet.h"
}
#include "fontObject.h"
#include "hsGFontScaler.h"

#ifndef t2kScalerContextDefined
#define t2kScalerContextDefined

class t2kScalerContext: public hsGScalerContext {
        fontObject      *fFont;
        CharToGlyphMapper *t1Mapper;
        CharToGlyphMapper *ttMapper;
	hsFixed		fBoldness;
	float		fMatrix[4];
	Boolean		fDoAntiAlias, fDoFractEnable;

	class T2KEntry* fT2KEntry;
	int			fGreyLevel, fT2KFlags;
	
	T2K*		SetupTrans();
public:
    int fNumGlyphs;
    t2kScalerContext(fontObject *font, const float matrix[],
                    Boolean doAntiAlias, Boolean doFractEnable,
                    int style);
    virtual		~t2kScalerContext();
    
    virtual UInt32	CountGlyphs();
    virtual void	GenerateMetrics(UInt16 glyphID, hsGGlyph* glyph,
                                        hsFixedPoint2* advance);
    virtual void	GenerateMetricsWithImage(
                                        UInt16 glyphID, hsGGlyph* glyph,
                                        hsFixedPoint2* advance);
    virtual void	GenerateImage(UInt16 glyphID, const hsGGlyph* glyph,
                                      void* buffer);
    virtual void	GeneratePath(UInt16 index, hsPathSpline* path,
                                     hsFixedPoint2* advance);
    virtual void	    GetLineHeight(hsFixedPoint2* ascent,
                                        hsFixedPoint2* descent,
                                        hsFixedPoint2* baseline,
                                        hsFixedPoint2* leading,
                                        hsFixedPoint2* maxAdvance);
    virtual void GetCaretAngle(hsFixedPoint2* caret);
    virtual CharToGlyphMapper *getMapper();
    virtual Boolean isStyleSupported(int);
};

class t2kFontScaler : public hsGFontScaler {
public:
    virtual hsGScalerContext* CreateContext(hsConstDescriptor desc);
};

#endif
