/*
 * @(#)img_fsutil.h	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * This file contains utility macros used by the Floyd-Steinberg
 * algorithms used in some of the other include files.
 */

#ifndef IMG_FSUTIL_H
#define IMG_FSUTIL_H

#define DitherDist(ep, e1, e2, e3, ec, c)		\
    do {						\
	e3 = (ec << 1);					\
	e1 = e3 + ec;					\
	e2 = e3 + e1;					\
	e3 += e2;					\
							\
	ep[0].c += e1 >>= 4;				\
	ep[1].c += e2 >>= 4;				\
	ep[2].c += e3 >>= 4;				\
	ec -= e1 + e2 + e3;				\
    } while (0)

#endif /* IMG_FSUTIL_H */
