/*
 * @(#)img_output8_32.h	1.9 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * This file contains macro definitions for the Storing category of
 * the macros used by the generic scaleloop function.
 *
 * This implementation can store 8-bit or 32-bit pixels into an array
 * of either bytes or longs such that the pixel for (srcX, srcY) is
 * stored at index (srcOff + srcY * srcScan + srcX) in the array.
 */

#define DeclareOutputVars				\
    pixptr dstP;					\
    int dst32;

#define InitOutput(cvdata, clrdata, dstX, dstY)			\
    do {							\
	switch (clrdata->bitsperpixel) {			\
	case 8: dst32 = 0; break;				\
	case 32: dst32 = 2; break;				\
	default:						\
	    SignalError(0, JAVAPKG "InternalError",		\
			"unsupported screen depth");		\
	    return SCALEFAILURE;				\
	}							\
	img_check((ScanBytes(cvdata) & ((1 << dst32)-1)) == 0);	\
	dstP.vp = cvdata->outbuf;				\
	dstP.bp += dstY * ScanBytes(cvdata) + (dstX << dst32);	\
    } while (0)

#define PutPixelInc(pixel, red, green, blue)			\
    do {							\
	if (dst32) {						\
	    *dstP.ip++ = pixel;					\
	} else {						\
	    *dstP.bp++ = ((unsigned char) pixel);		\
	}							\
    } while (0)

#define EndOutputRow(cvdata, dstY, dstX1, dstX2)		\
    do {							\
	SendRow(cvdata, dstY, dstX1, dstX2);			\
	dstP.bp += (ScanBytes(cvdata)				\
		    - ((dstX2 - dstX1) << dst32));		\
    } while (0)

#define EndOutputRect(cvdata, dstX1, dstY1, dstX2, dstY2)	\
    SendBuffer(cvdata, dstX1, dstY1, dstX2, dstY2)
