/*
 * @(#)mlib_SysMath.h	1.4 98/09/05
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef SOLARIS2
#  define MLIB_NO_LIBSUNMATH
#endif

#ifndef MLIB_SYSMATH_H
#define MLIB_SYSMATH_H

#ifdef __SUNPRO_C
#pragma ident	"@(#)mlib_SysMath.h	1.10	98/06/30 SMI"
#endif /* __SUNPRO_C */

#include <math.h>

#define mlib_sin        sin
#define mlib_cos        cos
#define mlib_sqrt       sqrt
#define mlib_fabs       fabs
#define mlib_ceil       ceil

#ifdef MLIB_LIBCAFEMATH

#define mlib_sinf       sinf
#define mlib_cosf       cosf
static void mlib_sincosf (float x, float *s, float *c)
{
  *s = sinf(x);
  *c = cosf(x);
}
#define mlib_sqrtf       sqrtf
#define mlib_fabsf       fabsf

#else

#ifdef MLIB_NO_LIBSUNMATH

#define mlib_sinf       (float) sin
#define mlib_cosf       (float) cos
static void mlib_sincosf (float x, float *s, float *c)
{
  *s = (float)sin(x);
  *c = (float)cos(x);
}
#define mlib_sqrtf      (float) sqrt
#define mlib_fabsf      (float) fabs

#else

#include <sunmath.h>

#define mlib_sinf       sinf
#define mlib_cosf       cosf
#define mlib_sincosf    sincosf
#define mlib_sqrtf       sqrtf
#define mlib_fabsf       fabsf

#endif  /* MLIB_NO_LIBSUNMATH */

#endif  /* MLIB_LIBCAFEMATH */


  /* internal mathematical functions */

double mlib_sincospi(double x, double *co);
double mlib_atan2i (int y, int x);

#endif /* MLIB_SYSMATH_H */
