/*
 * @(#)mlib_types.h	1.9 98/09/05
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef MLIB_TYPES_H
#define MLIB_TYPES_H

#ifdef __SUNPRO_C
#pragma ident	"@(#)mlib_types.h	1.19	98/06/26 SMI"
#endif /* __SUNPRO_C */

#include <limits.h>

#ifdef  __cplusplus
extern "C" {
#endif

typedef signed char        mlib_s8;
typedef unsigned char      mlib_u8;
typedef short              mlib_s16;
typedef unsigned short     mlib_u16;
typedef int                mlib_s32;
typedef unsigned int       mlib_u32;
typedef float              mlib_f32;
typedef double             mlib_d64;

#if defined(__SUNPRO_C) || defined(__GNUC__)

typedef long long          mlib_s64;
typedef unsigned long long mlib_u64;

#elif defined(_MSC_VER)

typedef __int64            mlib_s64;
typedef unsigned __int64   mlib_u64;

#else

#error	"unknown platform"

#endif

typedef unsigned long      mlib_addr;
typedef void*              mlib_ras;

#define MLIB_S8_MIN        SCHAR_MIN
#define MLIB_S8_MAX        SCHAR_MAX
#define MLIB_U8_MIN        0
#define MLIB_U8_MAX        UCHAR_MAX
#define MLIB_S16_MIN       SHRT_MIN
#define MLIB_S16_MAX       SHRT_MAX
#define MLIB_U16_MIN       0
#define MLIB_U16_MAX       USHRT_MAX
#define MLIB_S32_MIN       INT_MIN
#define MLIB_S32_MAX       INT_MAX
#define MLIB_U32_MIN       0
#define MLIB_U32_MAX       UINT_MAX

#ifdef  __cplusplus
}
#endif

#endif  /* MLIB_TYPES_H */
