/*
 * @(#)dcPathConsumer.h	1.8 98/03/18
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @(#)dcPathConsumer.h 3.1 97/11/17
 *
 * -----------------------------------------------------------------------------
 *	Copyright (c) 1992-1997 by Ductus, Inc. All Rights Reserved.
 * -----------------------------------------------------------------------------
 *
 */

#ifndef _DC_PATH_CONSUMER_H
#define _DC_PATH_CONSUMER_H

#include "doeObject.h"

#ifdef	__cplusplus
extern "C" {
#endif

typedef struct dcPathConsumerFace_**		dcPathConsumer;
typedef struct dcFastPathProducerFace_**	dcFastPathProducer;

typedef struct dcPathConsumerFace_ {
    doeObjectFace	mu;
    void		(*beginPath)	  (doeE, dcPathConsumer);
    void		(*beginSubpath)	  (doeE, dcPathConsumer, f32 x0, f32 y0);
    void		(*appendLine)	  (doeE, dcPathConsumer, f32 x1, f32 y1);
    void		(*appendQuadratic)(doeE, dcPathConsumer, f32 x1, f32 y1,
								  f32 x2, f32 y2);
    void		(*appendCubic)	  (doeE, dcPathConsumer, f32 x1, f32 y1,
								  f32 x2, f32 y2,
								  f32 x3, f32 y3);
    void		(*closedSubpath)  (doeE, dcPathConsumer);
    void		(*endPath)	  (doeE, dcPathConsumer);
    void		(*useProxy)	  (doeE, dcPathConsumer, dcFastPathProducer proxy);
} dcPathConsumerFace;

typedef struct dcFastPathProducerFace_ {
    doeObjectFace	mu;
    void		(*getBox)(doeE, dcFastPathProducer, f32* box);
    void		(*sendTo)(doeE, dcFastPathProducer, dcPathConsumer dest);
} dcFastPathProducerFace;

/* This dcPathConsumer simply ignores the path */
extern	dcPathConsumer	dcPathConsumer_create(doeE);

#ifdef	__cplusplus
}
#endif

#endif  /* _DC_PATH_CONSUMER_H */
