/*
 * @(#)ARGB_DstData.h	1.9 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#define NORM_SCALE   256
#define NORM_SCALE_1 255

#define DeclareDst                                                      \
     unsigned int *dstPtr;

#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width * dstPixStr;                                    \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned int tmp;							\
    tmp = *dstPtr;							\
    dA = (tmp >> 24) & 0xff;   						\
    dR = (tmp >> 16) & 0xff;						\
    dG = (tmp >>  8) & 0xff;						\
    dB = (tmp >>  0) & 0xff;						\
    if (dA < NORM_SCALE_1) {                                            \
        if (dA) {                                                       \
            int a = dA; if (a > NORM_SCALE_1/2) a++;                    \
            dR = (a*dR)/NORM_SCALE;                                     \
            dG = (a*dG)/NORM_SCALE;                                     \
            dB = (a*dB)/NORM_SCALE;                                     \
        } else {                                                        \
            dR = dG = dB = 0;                                           \
        }                                                               \
    }                                                                   \
}while (0);


#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE_1) {                                        \
            dR = (dR * NORM_SCALE_1) / dA;                              \
            dG = (dG * NORM_SCALE_1) / dA;                              \
            dB = (dB * NORM_SCALE_1) / dA;                              \
        }                                                               \
        *dstPtr = (((dA & 0xff) << 24) |                                \
                   ((dR & 0xff) << 16) |				\
                   ((dG & 0xff) <<  8) |				\
                   ((dB & 0xff) <<  0));				\
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
