/*
 * @(#)Gray16Blters.c	1.6 98/08/12
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <jni.h>
#include <jni_util.h>
#include <sun_java2d_loops_Gray16Blters.h>
#include <memory.h>
#include <math.h>
#include <img_globals.h>

#include <stdlib.h>
#include <alpha_uti.h>
#include <alphaCompst.h>
#include <alphaCompst_Ductus.h>

#ifndef _Included_ImageData
#include <ImageData.h>
#endif

#ifndef _Included_BlitMacros
#include <BlitMacros.h>
#endif

#undef DST_XCCC

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <Gray16_DstData.h>

ColorLoopFunc Gray16Colorloop;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    ColorFillAlphaToGray16
 * Signature: (Lsun/java2d/loops/ImageData;I[BIIFI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_ColorFillAlphaToGray16(
    JNIEnv *env, jobject self,
    jobject dstImage,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jint fgColor)
{
    INVOKE_COLOR_LOOP(Gray16Colorloop, Short, short);
}

PaintLoopFunc   Gray16PaintARGB;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    paintARGB_ONTO_Gray16
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_paintARGB_1ONTO_1Gray16(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(Gray16PaintARGB, Int, int, Short, short);
}

PaintLoopFunc   Gray16PaintXRGB;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    paintXRGB_ONTO_Gray16
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_paintXRGB_1ONTO_1Gray16(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(Gray16PaintXRGB, Int, int, Short, short);
}

PaintLoopFunc   Gray16PaintGray16;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    paintGray16_ONTO_Gray16
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_paintGray16_1ONTO_1Gray16(
    JNIEnv *env, jclass joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(Gray16PaintGray16, Short, short, Short, short);
}

PaintLoopFunc   XRGBPaintGray16;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    paintGray16_ONTO_XRGB
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_paintGray16_1ONTO_1XRGB(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XRGBPaintGray16, Short, short, Int, int);
}

PaintLoopFunc   ARGBPaintGray16;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    paintGray16_ONTO_ARGB
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_paintGray16_1ONTO_1ARGB(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(ARGBPaintGray16, Short, short, Int, int);
}

PaintLoopFunc   XBGRPaintGray16;
/*
 * Class:     sun_java2d_loops_Gray16Blters
 * Method:    paintGray16_ONTO_XBGR
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray16Blters_paintGray16_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XBGRPaintGray16, Short, short, Int, int);
}

/************************************* Gray16 composite loops *********************************/

#undef DST_XCCC

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <Gray16_DstData.h>

#undef COLOR_BLENDFUNC
#define COLOR_BLENDFUNC Gray16Colorloop
#define COMPST_DST16
#include <alphaCompst_colorloop.h>
#undef COMPST_DST16

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <ARGB_SrcData.h>
#define TILE_BLENDFUNC Gray16PaintARGB
#define COMPST_DST16
#include <alphaCompst_paintloop.h>
#undef COMPST_DST16

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <XRGB_SrcData.h>
#define TILE_BLENDFUNC Gray16PaintXRGB
#define COMPST_DST16
#include <alphaCompst_paintloop.h>
#undef COMPST_DST16

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <Gray16_SrcData.h>
#define TILE_BLENDFUNC Gray16PaintGray16
#define COMPST_SRCDST16
#include <alphaCompst_paintloop.h>
#undef COMPST_SRCDST16

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <XRGB_DstData.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <Gray16_SrcData.h>

#define TILE_BLENDFUNC XRGBPaintGray16
#define COMPST_SRC16
#include <alphaCompst_paintloop.h>
#undef COMPST_SRC16

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <ARGB_DstData.h>
#undef TILE_BLENDFUNC
#define TILE_BLENDFUNC ARGBPaintGray16
#define COMPST_SRC16
#include <alphaCompst_paintloop.h>
#undef COMPST_SRC16

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <XBGR_DstData.h>
#undef TILE_BLENDFUNC
#define TILE_BLENDFUNC XBGRPaintGray16
#define COMPST_SRC16
#include <alphaCompst_paintloop.h>
#undef COMPST_SRC16
