/*
 * @(#)Gray16_DstData.h	1.4 98/08/24
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#define SHORT_NORM_SCALE     0x10000
#define SHORT_NORM_SCALE_1   0xffff
#define SHORT_NORM_SCALE_1_R 19532
#define SHORT_NORM_SCALE_1_G 38807
#define SHORT_NORM_SCALE_1_B 7196
#define NORM_SCALE     256
#define NORM_SCALE_1   255
#define NORM_SCALE_1_R 76
#define NORM_SCALE_1_G 151
#define NORM_SCALE_1_B 28

#define DeclareDst                                                      \
     unsigned short *dstPtr;
     
#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width;                                                \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    dA = 0xffff;          						\
    dR = dG = dB = *dstPtr;                                             \
}while (0);

#define PrepColorDst							\
   unsigned short colorPrep = *dstPtr;

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)


#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        unsigned int tmp;                                               \
        dR = (dR * SHORT_NORM_SCALE_1_R) / dA;                          \
        dG = (dG * SHORT_NORM_SCALE_1_G) / dA;                          \
        dB = (dB * SHORT_NORM_SCALE_1_B) / dA;                          \
        tmp = (dR&0xffff) + (dG&0xffff) + (dB&0xffff);                  \
        if (tmp > SHORT_NORM_SCALE_1) tmp = SHORT_NORM_SCALE_1;         \
        *dstPtr = tmp;                                                  \
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
