/*
 * @(#)Gray8Blters.c	1.4 98/07/13
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <jni.h>
#include <jni_util.h>
#include <sun_java2d_loops_Gray8Blters.h>
#include <memory.h>
#include <math.h>
#include <img_globals.h>

#include <stdlib.h>
#include <alpha_uti.h>
#include <alphaCompst.h>
#include <alphaCompst_Ductus.h>


#ifndef _Included_ImageData
#include <ImageData.h>
#endif

#ifndef _Included_BlitMacros
#include <BlitMacros.h>
#endif

#undef DST_XCCC

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <Gray8_DstData.h>

ColorLoopFunc Gray8Colorloop;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    ColorFillAlphaToGray8
 * Signature: (Lsun/awt/image/ImageData;I[BIIFI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_ColorFillAlphaToGray8(
    JNIEnv *env, jobject self,
    jobject dstImage,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jint fgColor)
{
    INVOKE_COLOR_LOOP(Gray8Colorloop, Byte, char);
}

PaintLoopFunc   Gray8PaintARGB;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    paintARGB_ONTO_Gray8
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_paintARGB_1ONTO_1Gray8(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(Gray8PaintARGB, Int, int, Byte, char);
}

PaintLoopFunc   Gray8PaintXRGB;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    paintXRGB_ONTO_Gray8
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_paintXRGB_1ONTO_1Gray8(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(Gray8PaintXRGB, Int, int, Byte, char);
}

PaintLoopFunc   Gray8PaintGray8;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    paintGray8_ONTO_Gray8
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_paintGray8_1ONTO_1Gray8(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(Gray8PaintGray8, Byte, char, Byte, char);
}

PaintLoopFunc   XRGBPaintGray8;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    paintGray8_ONTO_XRGB
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_paintGray8_1ONTO_1XRGB(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XRGBPaintGray8, Byte, char, Int, int);
}

PaintLoopFunc   ARGBPaintGray8;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    paintGray8_ONTO_ARGB
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_paintGray8_1ONTO_1ARGB(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(ARGBPaintGray8, Byte, char, Int, int);
}

PaintLoopFunc   XBGRPaintGray8;
/*
 * Class:     sun_java2d_loops_Gray8Blters
 * Method:    paintGray8_ONTO_XBGR
 * Signature: (Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_Gray8Blters_paintGray8_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XBGRPaintGray8, Byte, char, Int, int);
}

/************************************* Gray8 composite loops *********************************/

#undef DST_XCCC

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <Gray8_DstData.h>

#undef COLOR_BLENDFUNC
#define COLOR_BLENDFUNC Gray8Colorloop
#include <alphaCompst_colorloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <ARGB_SrcData.h>
#define TILE_BLENDFUNC Gray8PaintARGB
#include <alphaCompst_paintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <XRGB_SrcData.h>
#define TILE_BLENDFUNC Gray8PaintXRGB
#include <alphaCompst_paintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <Gray8_SrcData.h>
#define TILE_BLENDFUNC Gray8PaintGray8
#include <alphaCompst_paintloop.h>

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <XRGB_DstData.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <Gray8_SrcData.h>

#define TILE_BLENDFUNC XRGBPaintGray8
#include <alphaCompst_paintloop.h>

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <ARGB_DstData.h>
#undef TILE_BLENDFUNC
#define TILE_BLENDFUNC ARGBPaintGray8
#include <alphaCompst_paintloop.h>

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <XBGR_DstData.h>
#undef TILE_BLENDFUNC
#define TILE_BLENDFUNC XBGRPaintGray8
#include <alphaCompst_paintloop.h>
