/*
 * @(#)Gray8_DstData.h	1.4 98/08/21
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#define NORM_SCALE     256
#define NORM_SCALE_1   255
#define NORM_SCALE_1_R 76
#define NORM_SCALE_1_G 150
#define NORM_SCALE_1_B 29

#define DeclareDst                                                      \
     unsigned char *dstPtr;
     
#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width;                                                \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    dA = 0xff;          						\
    dR = dG = dB = *dstPtr;						\
}while (0);

#define PrepColorDst							\
   unsigned char colorPrep = *dstPtr;

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)


#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        unsigned int tmp;                                               \
        dR = (dR * NORM_SCALE_1_R);                                     \
        dG = (dG * NORM_SCALE_1_G);                                     \
        dB = (dB * NORM_SCALE_1_B);                                     \
        tmp = (dR + dG + dB)/dA;                                        \
        if (tmp > NORM_SCALE_1) tmp = NORM_SCALE_1;                     \
        *dstPtr = tmp;                                                  \
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
