/*
 * @(#)ImageData.c	1.44 98/10/01
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

#include <jni.h>
#include <jni_util.h>

#include <sun_java2d_loops_ImageData.h>
#include <sun_java2d_loops_GraphicsPrimitive.h>

#include <img_util_md.h>
#ifndef _Included_ImageData
#include <ImageData.h>
#endif


#include <memory.h>
#include <imageInitIDs.h>
#include <stdlib.h>
ImageDataID gImageData;


/*
 * Class:     sun_java2d_loops_ImageData
 * Method:    initIDs
 * Signature: ()V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ImageData_initIDs(JNIEnv *env, jclass idc)
{
    gImageData.dataID
                    = (*env)->GetFieldID(env, idc, "theDataPointer", "I");
    gImageData.lutDataID
                    = (*env)->GetFieldID(env, idc, "theLutData", "I");
    gImageData.typeID
                    = (*env)->GetFieldID(env, idc, "theType", "I");
    gImageData.lutDataLengthID
                    = (*env)->GetFieldID(env, idc, "theLutDataLength", "I");
    gImageData.pixelStrideID
                    = (*env)->GetFieldID(env, idc, "thePixelStride", "I");
    gImageData.scanlineStrideID
                    = (*env)->GetFieldID(env, idc, "theScanlineStride", "I");
    gImageData.numChannelsID
                    = (*env)->GetFieldID(env, idc, "theNumChannels", "I");
    gImageData.pixelsPerDataUnitID
        = (*env)->GetFieldID(env, idc, "thePixelsPerDataUnit", "I");
    gImageData.bytePerChannelID
                    = (*env)->GetFieldID(env, idc, "theBytePerChannel", "I");

    gImageData.xViewAreaID
                    = (*env)->GetFieldID(env, idc, "theXViewArea", "I");
    gImageData.yViewAreaID
                    = (*env)->GetFieldID(env, idc, "theYViewArea", "I");
    gImageData.dxViewAreaID
                    = (*env)->GetFieldID(env, idc, "theDXViewArea", "I");
    gImageData.dyViewAreaID
                    = (*env)->GetFieldID(env, idc, "theDYViewArea", "I");
    gImageData.xDeviceAreaID
                    = (*env)->GetFieldID(env, idc, "theXDeviceArea", "I");
    gImageData.yDeviceAreaID
                    = (*env)->GetFieldID(env, idc, "theYDeviceArea", "I");
    gImageData.dxDeviceAreaID
                    = (*env)->GetFieldID(env, idc, "theDXDeviceArea", "I");
    gImageData.dyDeviceAreaID
                    = (*env)->GetFieldID(env, idc, "theDYDeviceArea", "I");
    gImageData.xOutputAreaID
                    = (*env)->GetFieldID(env, idc, "theXOutputArea", "I");
    gImageData.yOutputAreaID
                    = (*env)->GetFieldID(env, idc, "theYOutputArea", "I");
    gImageData.dxOutputAreaID
                    = (*env)->GetFieldID(env, idc, "theDXOutputArea", "I");
    gImageData.dyOutputAreaID
                    = (*env)->GetFieldID(env, idc, "theDYOutputArea", "I");

    gImageData.intDataID
                    = (*env)->GetFieldID(env, idc, "naData", "[I");
    gImageData.shortDataID
                    = (*env)->GetFieldID(env, idc, "saData", "[S");
    gImageData.byteDataID
                    = (*env)->GetFieldID(env, idc, "baData", "[B");
    gImageData.lutArrayID
                    = (*env)->GetFieldID(env, idc, "naLutData", "[I");

    gImageData.lockMethodID
                    = (*env)->GetFieldID(env, idc, "theLockMethod", "I");
    gImageData.lockFunctionID
                    = (*env)->GetFieldID(env, idc, "theLockFunction", "I");
    gImageData.platformInfoID
                    = (*env)->GetFieldID(env, idc, "thePlatformInfo", "I");
    gImageData.colorModelID
                    = (*env)->GetFieldID(env, idc, "theColorModel", 
					 "Ljava/awt/image/ColorModel;");

    gImageData.grayInverseLutDataID
                    = (*env)->GetFieldID(env, idc, "theGrayInverseLutData",
                                         "I");

    if( (gImageData.dataID == NULL)
            || (gImageData.lutDataID == NULL)
            || (gImageData.typeID == NULL)
            || (gImageData.lutDataLengthID == NULL)
            || (gImageData.pixelStrideID == NULL)
            || (gImageData.scanlineStrideID == NULL)
            || (gImageData.numChannelsID == NULL)
            || (gImageData.bytePerChannelID == NULL)
            || (gImageData.pixelsPerDataUnitID == NULL)
            || (gImageData.xViewAreaID == NULL)
            || (gImageData.yViewAreaID == NULL)
            || (gImageData.dxViewAreaID == NULL)
            || (gImageData.dyViewAreaID == NULL)
            || (gImageData.xDeviceAreaID == NULL)
            || (gImageData.yDeviceAreaID == NULL)
            || (gImageData.dxDeviceAreaID == NULL)
            || (gImageData.dyDeviceAreaID == NULL)
            || (gImageData.xOutputAreaID == NULL)
            || (gImageData.yOutputAreaID == NULL)
            || (gImageData.dxOutputAreaID == NULL)
            || (gImageData.dyOutputAreaID == NULL)
            || (gImageData.intDataID == NULL)
            || (gImageData.shortDataID == NULL)
            || (gImageData.byteDataID == NULL)
            || (gImageData.lutArrayID == NULL)
            || (gImageData.lockMethodID == NULL)
            || (gImageData.lockFunctionID == NULL)
            || (gImageData.colorModelID == NULL)
            || (gImageData.grayInverseLutDataID == NULL)
            || (gImageData.platformInfoID == NULL)) {
        JNU_ThrowInternalError(env, "NULL ImageData field ID");
    }
}

/*
 * Class:     sun_java2d_loops_ImageData
 * Method:    isAllOpaqueGrayICM
 * Signature: (Ljava/awt/image/IndexColorModel;)Z
 */
JNIEXPORT jboolean JNICALL
Java_sun_java2d_loops_ImageData_isAllOpaqueGrayICM(JNIEnv *env, jclass idc,
                                                   jobject icm) {
    static jfieldID fid = 0;
    jboolean ret = JNI_FALSE;

    if (icm == NULL)
        return ret;

    if (fid == 0) {
        jclass clazz;

        clazz = (*env)->GetObjectClass(env, icm);

        fid = (*env)->GetFieldID(env, clazz, "allgrayopaque", "Z");
        if (fid == 0)
            return ret;
    }

    return (*env)->GetBooleanField(env, icm, fid);
}

/*
 * Class:     sun_java2d_loops_ImageData
 * Method:    freeNativeICMData
 * Signature: (Ljava/awt/image/IndexColorModel;)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ImageData_freeNativeICMData(JNIEnv *env,
                                                  jclass idc,
                                                  jobject icm) {
    jlong pData;
    ColorData *cdata;

    pData = (*env)->GetLongField (env, icm, g_CMpDataID);
    cdata = (ColorData *) pData;
    freeICMColorData(cdata);
}

int
minImageWidths(JNIEnv *env, int width1, jobject img1, jobject img2)
{
    int retval = 0;
    int width2 = 0;
    if (JNU_IsNull(env, img1) || JNU_IsNull(env, img2)) {
        return 0;
    }
    width2 = (*env)->GetIntField(env, img1, gImageData.dxOutputAreaID);
    retval = (width2 > width1)? width1: width2;
    width2 = (*env)->GetIntField(env, img2, gImageData.dxOutputAreaID);
    retval = (width2 > retval)? retval: width2;
    retval = (retval > 0)? retval: 0;
    return retval;
}

int
minImageRows(JNIEnv *env, int rows1, jobject img1, jobject img2)
{
    int retval = 0;
    int rows2 = 0;
    if (JNU_IsNull(env, img1) || JNU_IsNull(env, img2)) {
        return 0;
    }
    rows2 = (*env)->GetIntField(env, img1, gImageData.dyOutputAreaID);
    retval = (rows2 > rows1)? rows1: rows2;
    rows2 = (*env)->GetIntField(env, img2, gImageData.dyOutputAreaID);
    retval = (rows2 > retval)? retval: rows2;
    retval = (retval > 0)? retval: 0;
    return retval;
}

int offsetOfAlphaData(JNIEnv *env, jobject img, int scanStride)
{
    int retval = 0;
    int x1, y1;
    int x2, y2;

    x1 = (*env)->GetIntField(env, img, gImageData.xDeviceAreaID);
    y1 = (*env)->GetIntField(env, img, gImageData.yDeviceAreaID);

    x2 = (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    y2 = (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    retval = (x2 - x1) +  scanStride * (y2 - y1);

    return retval;
}

int getPlatformInfoFromImageData(JNIEnv *env, jobject img)
{
    return (*env)->GetIntField(env, img, gImageData.platformInfoID);
}

JNIEXPORT void JNICALL
getViewOriginFromImageData(JNIEnv *env, jobject img, int *x, int *y)
{
    if (x && y) {
        *x = (*env)->GetIntField(env, img, gImageData.xViewAreaID);
        *y = (*env)->GetIntField(env, img, gImageData.yViewAreaID);
    }
}

JNIEXPORT void JNICALL
getDeviceOriginFromImageData(JNIEnv *env, jobject img, int *x, int *y)
{
    if (x && y) {
        *x = (*env)->GetIntField(env, img, gImageData.xDeviceAreaID);
        *y = (*env)->GetIntField(env, img, gImageData.yDeviceAreaID);
    }
}

JNIEXPORT void JNICALL
getOutputOriginFromImageData(JNIEnv *env, jobject img, int *x, int *y)
{
    if (x && y) {
        *x = (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
        *y = (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    }
}

JNIEXPORT void JNICALL
getTypeFromImageData(JNIEnv *env, jobject img, int *type)
{
    if (type) {
        *type = (*env)->GetIntField(env, img, gImageData.typeID);
    }
}
/*
*   Integer component raster handlers
*/

JNIEXPORT void JNICALL
getIntImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataIntLockInfo *lockInfo)
{
    memset(lockInfo,0,sizeof(ImageDataIntLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned int *)((*env)->GetIntField(env, img, gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned int *)((*env)->GetIntField(env, img,
                                                  gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jintArray)((*env)->GetObjectField(env, img, gImageData.intDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);
    lockInfo->pixelsPerData =
        (*env)->GetIntField(env, img, gImageData.pixelsPerDataUnitID);

    lockInfo->arrayLockedOffset =
            lockInfo->pixelStride * lockInfo->xOutput
            + lockInfo->yOutput * lockInfo->scanStride;
}

JNIEXPORT unsigned int *  JNICALL
lockIntImageData(JNIEnv *env, ImageDataIntLockInfo *lockInfo)
{
    unsigned int *retval = lockInfo->lockedBuffer;
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned int *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (retval && !lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    return retval;
}

JNIEXPORT void JNICALL
unlockIntImageData(JNIEnv *env, ImageDataIntLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
}

/*
*   Short component raster handlers
*/

JNIEXPORT void JNICALL
getShortImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataShortLockInfo *lockInfo) 
{
    memset(lockInfo,0,sizeof(ImageDataShortLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned short *)((*env)->GetIntField(env, img,
                                               gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned short *)((*env)->GetIntField(env, img,
                                                  gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jshortArray)((*env)->GetObjectField(env,img,gImageData.shortDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);
    lockInfo->pixelsPerData =
        (*env)->GetIntField(env, img, gImageData.pixelsPerDataUnitID);

    lockInfo->arrayLockedOffset =
            lockInfo->pixelStride * lockInfo->xOutput
            + lockInfo->yOutput * lockInfo->scanStride;
}

JNIEXPORT unsigned short * JNICALL
lockShortImageData(JNIEnv *env, ImageDataShortLockInfo *lockInfo)
{
    unsigned short *retval = lockInfo->lockedBuffer;
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned short *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (retval && !lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    return retval;
}

JNIEXPORT void JNICALL
unlockShortImageData(JNIEnv *env, ImageDataShortLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
}

/*
*   Byte component raster handlers
*/

JNIEXPORT void JNICALL
getByteImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataByteLockInfo *lockInfo)
{
    memset(lockInfo,0,sizeof(ImageDataByteLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned char *)((*env)->GetIntField(env, img,
                                               gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned char *)((*env)->GetIntField(env, img,
                                                  gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jbyteArray)((*env)->GetObjectField(env, img, gImageData.byteDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);
    lockInfo->pixelsPerData =
        (*env)->GetIntField(env, img, gImageData.pixelsPerDataUnitID);

    lockInfo->arrayLockedOffset =
            lockInfo->pixelStride * lockInfo->xOutput
            + lockInfo->yOutput * lockInfo->scanStride;
}

JNIEXPORT unsigned char * JNICALL
lockByteImageData(JNIEnv *env, ImageDataByteLockInfo *lockInfo)
{
    unsigned char *retval = lockInfo->lockedBuffer;
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned char *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (retval && !lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    return retval;
}

JNIEXPORT void JNICALL
unlockByteImageData(JNIEnv *env, ImageDataByteLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
}

/*
 *  Short Indexed component raster handlers
 */

JNIEXPORT void JNICALL
getShortIndexedImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataShortIndexedLockInfo *lockInfo)
{
    memset(lockInfo,0,sizeof(ImageDataShortIndexedLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned short *)((*env)->GetIntField(env, img,
                                               gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned short *)((*env)->GetIntField(env, img,
                                                  gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jshortArray)((*env)->GetObjectField(env, img, gImageData.shortDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);
    lockInfo->pixelsPerData =
        (*env)->GetIntField(env, img, gImageData.pixelsPerDataUnitID);

    lockInfo->arrayLockedOffset =
            lockInfo->pixelStride * lockInfo->xOutput
            + lockInfo->yOutput * lockInfo->scanStride;

    lockInfo->lockedLut =
        (unsigned int *)((*env)->GetIntField(env, img, gImageData.lutDataID));
    lockInfo->arrayLutSize =
        (*env)->GetIntField(env, img, gImageData.lutDataLengthID);
    lockInfo->arrayToLockLut =
        (jintArray)((*env)->GetObjectField(env, img, gImageData.lutArrayID));
}

JNIEXPORT unsigned short * JNICALL
lockShortIndexedImageData(JNIEnv *env, ImageDataShortIndexedLockInfo *lockInfo)
{
    unsigned short *retval = lockInfo->lockedBuffer;
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned short *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (retval && !lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    if (retval && !lockInfo->lockedLut && lockInfo->arrayToLockLut) {
        lockInfo->arrayLockedLut =
            (unsigned int *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLockLut, NULL));
        lockInfo->lockedLut = lockInfo->arrayLockedLut;
    }
    return retval;
}

JNIEXPORT void JNICALL
unlockShortIndexedImageData(JNIEnv *env, ImageDataShortIndexedLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
    if (lockInfo->arrayLockedLut) {
        if (lockInfo->arrayLockedLut == lockInfo->lockedLut) {
            lockInfo->lockedLut = NULL;
        }
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLockLut,
            lockInfo->arrayLockedLut,
            JNI_ABORT);
        lockInfo->arrayLockedLut = NULL;
    }
}

/*
 *  Byte Indexed component raster handlers
 */

JNIEXPORT void JNICALL
getByteIndexedImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataByteIndexedLockInfo *lockInfo)
{
    jobject icm;

    memset(lockInfo,0,sizeof(ImageDataByteIndexedLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned char *)((*env)->GetIntField(env, img, gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned char *)((*env)->GetIntField(env, img,
                                                  gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jbyteArray)((*env)->GetObjectField(env, img, gImageData.byteDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);
    lockInfo->pixelsPerData =
        (*env)->GetIntField(env, img, gImageData.pixelsPerDataUnitID);
    lockInfo->arrayLockedOffset =
        ((lockInfo->pixelStride * lockInfo->xOutput) /
         lockInfo->pixelsPerData) +
        lockInfo->yOutput * lockInfo->scanStride;

    lockInfo->lockedLut =
        (unsigned int *)((*env)->GetIntField(env, img, gImageData.lutDataID));
    lockInfo->arrayLutSize =
        (*env)->GetIntField(env, img, gImageData.lutDataLengthID);
    lockInfo->arrayToLockLut =
        (jintArray)((*env)->GetObjectField(env, img, gImageData.lutArrayID));
    icm = (*env)->GetObjectField (env, img, gImageData.colorModelID);
    lockInfo->lockedForWrite =
        (*env)->GetIntField(env, img, gImageData.lockMethodID) &
        sun_java2d_loops_GraphicsPrimitive_LOCK_FOR_WRITE;
    lockInfo->inv_cmap = NULL;

    /*
     *  This code initializes the cubemap for destination offscreen 
     *  indexed color model images. 
     *  REMIND:  This could be a lot cleaner
     *  REMIND:  Why is it necessary to do this for sources
     */
    if ((icm != NULL) && (lockInfo->lockedForWrite != 0)) {
	lockInfo->colorData = (ColorData *) ((*env)->GetLongField (env,
					icm, g_CMpDataID));

        if (lockInfo->colorData == NULL) {
            jfieldID rgbID, rgbSizeID;
            int rgb_size;
            jintArray rgb;
            int* pRgb;
            jclass icmClass;

            icmClass = (*env)->GetObjectClass(env, icm);
         
            rgbSizeID = (*env)->GetFieldID(env,  icmClass, "map_size", "I");
            rgb_size = (int)((*env)->GetIntField(env, icm, rgbSizeID));
         
            rgbID = (*env)->GetFieldID(env, icmClass, "rgb", "[I");
            rgb = (jintArray)((*env)->GetObjectField(env, icm, rgbID));

            lockInfo->colorData = (ColorData*)calloc(1, sizeof(ColorData));

            if (lockInfo->colorData != NULL) {
                pRgb = (int *) ((*env)->GetPrimitiveArrayCritical(env, rgb,
                                                                  NULL));
                lockInfo->colorData->img_clr_tbl =
                    initCubemap(pRgb, rgb_size, 32);
                (*env)->ReleasePrimitiveArrayCritical(env, rgb, pRgb,
                                                      JNI_ABORT);

                initDitherTables(lockInfo->colorData);

                (*env)->SetLongField (env, icm, g_CMpDataID,
                                      (jlong) (lockInfo->colorData));
            }
        }
        
        /* 
         * Set the inv_cmap field appropriately.
         * Windows - set to either the screen lut
         *           or the lut from the IndexColorModel
         * Solaris - set to the lut from the IndexColorModel
         */
        color_init();
        SET_CUBEMAPARRAY;
    }
}


JNIEXPORT unsigned char * JNICALL
lockByteIndexedImageData(JNIEnv *env, ImageDataByteIndexedLockInfo *lockInfo)
{
    unsigned char *retval = lockInfo->lockedBuffer;
    if ((lockInfo->lockedForWrite != 0) && (lockInfo->inv_cmap == NULL)) {
        return NULL;
    }
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned char *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (retval && !lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    if (retval && !lockInfo->lockedLut && lockInfo->arrayToLockLut) {
        lockInfo->arrayLockedLut =
            (unsigned int *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLockLut, NULL));
        lockInfo->lockedLut = lockInfo->arrayLockedLut;
    }
    
    if (lockInfo->lockedLut && (lockInfo->arrayLutSize < 256)) {
        memcpy(lockInfo->minLut, lockInfo->lockedLut,
               lockInfo->arrayLutSize*4);
        lockInfo->lockedLut = lockInfo->minLut;
    }

    return retval;
}

JNIEXPORT void JNICALL
unlockByteIndexedImageData(JNIEnv *env, ImageDataByteIndexedLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
    if (lockInfo->arrayLockedLut) {
        if (lockInfo->arrayLockedLut == lockInfo->lockedLut) {
            lockInfo->lockedLut = NULL;
        }
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLockLut,
            lockInfo->arrayLockedLut,
            JNI_ABORT);
        lockInfo->arrayLockedLut = NULL;
    }
}

/*
 *  Index 8 Gray component raster handlers
 */

JNIEXPORT void JNICALL
getIndex8GrayImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataIndex8GrayLockInfo *lockInfo)
{
    jobject icm;

    memset(lockInfo,0,sizeof(ImageDataIndex8GrayLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned char *)((*env)->GetIntField(env, img, gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned char *)((*env)->GetIntField(env, img,
                                                  gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jbyteArray)((*env)->GetObjectField(env, img, gImageData.byteDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);

    lockInfo->arrayLockedOffset =
            lockInfo->pixelStride * lockInfo->xOutput
            + lockInfo->yOutput * lockInfo->scanStride;

    lockInfo->lockedLut =
        (unsigned int *)((*env)->GetIntField(env, img, gImageData.lutDataID));
    lockInfo->arrayLutSize =
        (*env)->GetIntField(env, img, gImageData.lutDataLengthID);
    lockInfo->arrayToLockLut =
        (jintArray)((*env)->GetObjectField(env, img, gImageData.lutArrayID));

    lockInfo->lockedInverseGrayLut = 
        (unsigned int *)((*env)->GetIntField(env, img,
                                             gImageData.grayInverseLutDataID));

    icm = (*env)->GetObjectField (env, img, gImageData.colorModelID);
    lockInfo->lockedForWrite =
        (*env)->GetIntField(env, img, gImageData.lockMethodID) &
        sun_java2d_loops_GraphicsPrimitive_LOCK_FOR_WRITE;
    lockInfo->inv_cmap = NULL;

    /*
     * This code initializes the cubemap and InverseGrayLut for Index8Gray
     * destinations.
     */
    if ((icm != NULL) && (lockInfo->lockedForWrite != 0)) {
        lockInfo->colorData =
            (ColorData *) ((*env)->GetLongField (env, icm, g_CMpDataID));

        if (lockInfo->colorData == NULL) {
            jfieldID rgbID, rgbSizeID;
            int rgb_size;
            jintArray rgb;
            int* pRgb;
            jclass icmClass;

            icmClass = (*env)->GetObjectClass(env, icm);

            rgbSizeID = (*env)->GetFieldID(env,  icmClass, "map_size", "I");
            rgb_size = (int)((*env)->GetIntField(env, icm, rgbSizeID));

            rgbID = (*env)->GetFieldID(env, icmClass, "rgb", "[I");
            rgb = (jintArray)((*env)->GetObjectField(env, icm, rgbID));

            lockInfo->colorData = (ColorData*)calloc(1, sizeof(ColorData));

            if (lockInfo->colorData != NULL) {
                pRgb = (int *) ((*env)->GetPrimitiveArrayCritical(env, rgb,
                                                                  NULL));
                lockInfo->colorData->img_clr_tbl =
                    initCubemap(pRgb, rgb_size, 32);
                (*env)->ReleasePrimitiveArrayCritical(env, rgb, pRgb,
                                                      JNI_ABORT);

                initDitherTables(lockInfo->colorData);

                initInverseGrayLut(pRgb, rgb_size, lockInfo->colorData);

                (*env)->SetLongField (env, icm, g_CMpDataID,
                                      (jlong) (lockInfo->colorData));
            }
        }

        if (!lockInfo->lockedInverseGrayLut) {
            lockInfo->lockedInverseGrayLut =
                (unsigned int *) lockInfo->colorData->pGrayInverseLutData;
        }

        /*
         * Set the inv_cmap field appropriately.
         * Windows - set to either the screen lut
         *           or the lut from the IndexColorModel
         * Solaris - set to the lut from the IndexColorModel
         */
        color_init();
        SET_CUBEMAPARRAY;
    }
}

JNIEXPORT unsigned char * JNICALL
lockIndex8GrayImageData(JNIEnv *env, ImageDataIndex8GrayLockInfo *lockInfo)
{
    unsigned char *retval = lockInfo->lockedBuffer;
    if ((lockInfo->lockedForWrite != 0) && (lockInfo->inv_cmap == NULL)) {
        return NULL;
    }
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned char *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (retval && !lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    if (retval && !lockInfo->lockedLut && lockInfo->arrayToLockLut) {
        lockInfo->arrayLockedLut =
            (unsigned int *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLockLut, NULL));
        lockInfo->lockedLut = lockInfo->arrayLockedLut;
    }
    if (lockInfo->lockedLut && (lockInfo->arrayLutSize < 256)) {
        memcpy(lockInfo->minLut, lockInfo->lockedLut,
               lockInfo->arrayLutSize*4);
        lockInfo->lockedLut = lockInfo->minLut;
    }

       return retval;
}

JNIEXPORT void JNICALL
unlockIndex8GrayImageData(JNIEnv *env, ImageDataIndex8GrayLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
    if (lockInfo->arrayLockedLut) {
        if (lockInfo->arrayLockedLut == lockInfo->lockedLut) {
            lockInfo->lockedLut = NULL;
        }
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLockLut,
            lockInfo->arrayLockedLut,
            JNI_ABORT);
        lockInfo->arrayLockedLut = NULL;
    }   
}

/*
 *  Index 12 Gray component raster handlers
 */

JNIEXPORT void JNICALL
getIndex12GrayImageLockInfo(
    JNIEnv *env, jobject img,
    ImageDataIndex12GrayLockInfo *lockInfo)
{
    jobject icm;

    memset(lockInfo,0,sizeof(ImageDataIndex12GrayLockInfo));

    lockInfo->lockFunction = (deferredLockFunc)
        (*env)->GetIntField(env, img, gImageData.lockFunctionID);

    lockInfo->lockedBuffer =
        (unsigned short *)((*env)->GetIntField(env, img, gImageData.dataID));

    if ( !lockInfo->lockedBuffer && lockInfo->lockFunction) {
        (*lockInfo->lockFunction)(env, img);
        lockInfo->lockedBuffer =
            (unsigned short *)((*env)->GetIntField(env, img,
                                                   gImageData.dataID));
    }

    lockInfo->arrayToLock  =
        (jshortArray)((*env)->GetObjectField(env, img, gImageData.shortDataID));
    lockInfo->xOutput =
        (*env)->GetIntField(env, img, gImageData.xOutputAreaID);
    lockInfo->yOutput =
        (*env)->GetIntField(env, img, gImageData.yOutputAreaID);
    lockInfo->scanStride =
        (*env)->GetIntField(env, img, gImageData.scanlineStrideID);
    lockInfo->bytePerChannel =
        (*env)->GetIntField(env, img, gImageData.bytePerChannelID);
    lockInfo->pixelStride =
        (*env)->GetIntField(env, img, gImageData.pixelStrideID);

    lockInfo->arrayLockedOffset =
            lockInfo->pixelStride * lockInfo->xOutput
            + lockInfo->yOutput * lockInfo->scanStride;

    lockInfo->lockedLut =
        (unsigned int *)((*env)->GetIntField(env, img, gImageData.lutDataID));
    lockInfo->arrayLutSize =
        (*env)->GetIntField(env, img, gImageData.lutDataLengthID);
    lockInfo->arrayToLockLut =
        (jintArray)((*env)->GetObjectField(env, img, gImageData.lutArrayID));

    lockInfo->lockedInverseGrayLut = 
        (unsigned int *)((*env)->GetIntField(env, img,
                                             gImageData.grayInverseLutDataID));

    icm = (*env)->GetObjectField (env, img, gImageData.colorModelID);
    lockInfo->lockedForWrite =
        (*env)->GetIntField(env, img, gImageData.lockMethodID) &
        sun_java2d_loops_GraphicsPrimitive_LOCK_FOR_WRITE;
    lockInfo->inv_cmap = NULL;

    /*
     * This code initializes the cubemap and InverseGrayLut for Index12Gray
     * destinations.
     */
    if ((icm != NULL) && (lockInfo->lockedForWrite != 0)) {
        lockInfo->colorData =
            (ColorData *) ((*env)->GetLongField (env, icm, g_CMpDataID));

        if (lockInfo->colorData == NULL) {
            jfieldID rgbID, rgbSizeID;
            int rgb_size;
            jintArray rgb;
            int* pRgb;
            jclass icmClass;

            icmClass = (*env)->GetObjectClass(env, icm);

            rgbSizeID = (*env)->GetFieldID(env,  icmClass, "map_size", "I");
            rgb_size = (int)((*env)->GetIntField(env, icm, rgbSizeID));

            rgbID = (*env)->GetFieldID(env, icmClass, "rgb", "[I");
            rgb = (jintArray)((*env)->GetObjectField(env, icm, rgbID));

            lockInfo->colorData = (ColorData*)calloc(1, sizeof(ColorData));

            if (lockInfo->colorData != NULL) {
                pRgb = (int *) ((*env)->GetPrimitiveArrayCritical(env, rgb,
                                                                  NULL));
                lockInfo->colorData->img_clr_tbl =
                    initCubemap(pRgb, rgb_size, 32);
                (*env)->ReleasePrimitiveArrayCritical(env, rgb, pRgb,
                                                      JNI_ABORT);

                initDitherTables(lockInfo->colorData);

                initInverseGrayLut(pRgb, rgb_size, lockInfo->colorData);

                (*env)->SetLongField (env, icm, g_CMpDataID,
                                      (jlong) (lockInfo->colorData));
            }
        }

        if (!lockInfo->lockedInverseGrayLut) {
            lockInfo->lockedInverseGrayLut =
                (unsigned int *) lockInfo->colorData->pGrayInverseLutData;
        }

        /*
         * Set the inv_cmap field appropriately.
         * Windows - set to either the screen lut
         *           or the lut from the IndexColorModel
         * Solaris - set to the lut from the IndexColorModel
         */
        color_init();
        SET_CUBEMAPARRAY;
    }
}

JNIEXPORT unsigned short * JNICALL
lockIndex12GrayImageData(JNIEnv *env, ImageDataIndex12GrayLockInfo *lockInfo)
{
    unsigned short *retval = lockInfo->lockedBuffer;
    if ((lockInfo->lockedForWrite != 0) && (lockInfo->inv_cmap == NULL)) {
        return NULL;
    }
    if (!retval && lockInfo->arrayToLock) {
        lockInfo->arrayLockedBuffer =
            (unsigned short *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLock, NULL));
        retval = lockInfo->arrayLockedBuffer;
    }
    if (!lockInfo->lockFunction) {
        retval += lockInfo->arrayLockedOffset;
    }
    if (retval && !lockInfo->lockedLut && lockInfo->arrayToLockLut) {
        lockInfo->arrayLockedLut =
            (unsigned int *)((*env)->GetPrimitiveArrayCritical(
                                        env, lockInfo->arrayToLockLut, NULL));
        lockInfo->lockedLut = lockInfo->arrayLockedLut;
    }
    if (lockInfo->lockedLut && (lockInfo->arrayLutSize < 4096)) {
        lockInfo->minLut = malloc(lockInfo->arrayLutSize*4);
        memcpy(lockInfo->minLut, lockInfo->lockedLut,
               lockInfo->arrayLutSize*4);
        lockInfo->lockedLut = lockInfo->minLut;
    }
       return retval;
}

JNIEXPORT void JNICALL
unlockIndex12GrayImageData(JNIEnv *env, ImageDataIndex12GrayLockInfo *lockInfo)
{
    if (lockInfo->arrayLockedBuffer) {
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLock,
            lockInfo->arrayLockedBuffer,
            JNI_ABORT);
    }
    if (lockInfo->arrayLockedLut) {
        if (lockInfo->arrayLockedLut == lockInfo->lockedLut) {
            lockInfo->lockedLut = NULL;
        }
        else {
            free(lockInfo->minLut);
            lockInfo->lockedLut = NULL;
        }
        (*env)->ReleasePrimitiveArrayCritical(env,
            lockInfo->arrayToLockLut,
            lockInfo->arrayLockedLut,
            JNI_ABORT);
        lockInfo->arrayLockedLut = NULL;
    }   
}


