/*
 * @(#)Indexed_DstData.h	1.13 98/09/08
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

#ifndef __DEFINED_INDEXEDINFO__
#define __DEFINED_INDEXEDINFO__
typedef struct IndexedInfo {
    unsigned char *pixelPtr;
    unsigned int  *colormap;
    ImageDataByteIndexedLockInfo* dstLockInfo;
} IndexedInfo;
#endif

#define NORM_SCALE   256
#define NORM_SCALE_1 255

#define DeclareDst                                                      \
    unsigned char *dstPtr;                                              \
    unsigned int *dstColormap;                                          \
    ImageDataByteIndexedLockInfo dstLockInfo;                          \
    unsigned char colorBlack;


#define InitDst                                                         \
do {                                                                    \
    dstPtr = ((IndexedInfo *)dstBase)->pixelPtr;                        \
    dstColormap = ((IndexedInfo *)dstBase)->colormap;                   \
    dstScanStr -= width * dstPixStr;                                    \
    memcpy(&dstLockInfo, ((IndexedInfo *)dstBase)->dstLockInfo,          \
           sizeof(dstLockInfo));                                        \
    colorBlack = CUBEMAP(0,0,0);                                        \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned int tmp;							\
    tmp = dstColormap[*dstPtr];                                         \
    dA = (tmp >> 24) & 0xff;                                            \
    dB = tmp & 0xff;                                                    \
    dG = (tmp >> 8) & 0xff;                                             \
    dR = (tmp >> 16) & 0xff;                                            \
} while (0);

#define PrepColorDst							\
   unsigned char colorPrep = CUBEMAP(                                   \
                                ((colorRed*extraAlpha)/256) & 0xff,     \
                                ((colorGreen*extraAlpha)/256) & 0xff,   \
                                ((colorBlue*extraAlpha)/256) & 0xff);


#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)

#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE_1) {                                        \
            if (dA > NORM_SCALE_1/2) dA++;                              \
            dR = (dR * NORM_SCALE) / dA;                                \
            dG = (dG * NORM_SCALE) / dA;                                \
            dB = (dB * NORM_SCALE) / dA;                                \
        }                                                               \
        if (!skipDither) {                                              \
            dR += cData->img_oda_red[((row & 7)<<3) + (column & 7)];   \
            dG += cData->img_oda_green[((row & 7)<<3) + (column & 7)];   \
            dB += cData->img_oda_blue[((row & 7)<<3) + (column & 7)];   \
            if (((dR | dG | dB) & (~255)) != 0) {                       \
                if (dR < 0) dR = 0;                                     \
                if (dR > 255) dR = 255;                                 \
                if (dG < 0) dG = 0;                                     \
                if (dG > 255) dG = 255;                                 \
                if (dB < 0) dB = 0;                                     \
                if (dB > 255) dB = 255;                                 \
            }                                                           \
        }                                                               \
        *dstPtr = CUBEMAP(dR, dG, dB);                                  \
    } else {                                                            \
        *dstPtr = colorBlack;                                           \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
