/*
 * @(#)S555_DstData.h	1.7 98/07/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

#define NORM_SCALE   256
#define NORM_SCALE_1 255

#define DeclareDst                                                      \
     unsigned short *dstPtr;                                             

#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width * dstPixStr;                                    \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned short tmp;							\
    tmp = *dstPtr;							\
    dA = 255;		  						\
    dB = ((tmp & 0x001f) <<  3) | ((tmp & 0x001f) >> 2);                \
    dG = ((tmp & 0x03E0) >>  2) | ((tmp & 0x03E0) >> 7);                \
    dR = ((tmp & 0x7C00) >>  7) | ((tmp & 0x7C00) >> 12);               \
}while (0);

#define PrepColorDst							\
   unsigned short colorPrep = (((colorBlue*extraAlpha)/256) >> 3) |     \
                              ((((colorGreen & 0xf8)*extraAlpha)/256) << 2) |\
                              ((((colorRed & 0xf8)*extraAlpha)/256) << 7);

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)

#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE_1) {                                        \
            if (dA > NORM_SCALE_1/2) dA++;                              \
            dR = (dR * NORM_SCALE) / dA;                                \
            dG = (dG * NORM_SCALE) / dA;                                \
            dB = (dB * NORM_SCALE) / dA;                                \
        }                                                               \
        *dstPtr = (((dB >> 3)) |                                        \
                   ((dG & 0xf8) <<  2) |                                \
                   ((dR & 0xf8) <<  7));				\
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
