/*
 * @(#)ShortCompositing.c	1.10 98/07/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * @author Charlton Innovations, Inc.
 */

#include <jni.h>
#include <jni_util.h>
#include <sun_java2d_loops_ShortCompositing.h>
#include <memory.h>
#include <math.h>

#include <stdlib.h>
#include <alpha_uti.h>
#include <alphaCompst.h>
#include <alphaCompst_Ductus.h>


#ifndef _Included_ImageData
#include <ImageData.h>
#endif

#ifndef _Included_BlitMacros
#include <BlitMacros.h>
#endif

ColorLoopFunc S555Colorloop;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    ColorFillAlphaToS555
 * Signature: (Lsun/awt/image/ImageData;I[BIIFI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_ColorFillAlphaToS555(
    JNIEnv *env, jobject self,
    jobject dstImage,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jint fgColor)
{
    INVOKE_COLOR_LOOP(S555Colorloop,Short,short);
}

PaintLoopFunc   S555paintARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_ONTO_S555
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintARGB_1ONTO_1S555(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(S555paintARGB,Int,int,Short,short)
}

PaintLoopFunc   S555paintXRGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintXRGB_ONTO_S555
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintXRGB_1ONTO_1S555(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(S555paintXRGB,Int,int,Short,short);
}

BgPaintLoopFunc   S555bgpaintARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_WITH_BG_CLR_ONTO_S555
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZII)V
 */
JNIEXPORT void JNICALL Java_sun_java2d_loops_ShortCompositing_paintARGB_1WITH_1BG_1CLR_1ONTO_1S555(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint bgColor, jint xorColor
  )
{
    INVOKE_BG_PAINT_LOOP(S555bgpaintARGB,Int,int,Short,short);
}

BgPaintLoopFunc   S555bgpaintBitmaskARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_WITH_BITMASK_AND_BG_CLR_ONTO_S555
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZII)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintARGB_1WITH_1BITMASK_1AND_1BG_1CLR_1ONTO_1S555(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint bgColor, jint xorColor
  )
{
    INVOKE_BG_PAINT_LOOP(S555bgpaintBitmaskARGB,Int,int,Short,short);
}

PaintLoopFunc   S555paintBitmaskARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_WITH_BITMASK_ONTO_S555
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintARGB_1WITH_1BITMASK_1ONTO_1S555(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(S555paintBitmaskARGB,Int,int,Short,short);
}

ColorLoopFunc S565Colorloop;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    ColorFillAlphaToS565
 * Signature: (Lsun/awt/image/ImageData;I[BIIFI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_ColorFillAlphaToS565(
    JNIEnv *env, jobject self,
    jobject dstImage,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jint fgColor)
{
    INVOKE_COLOR_LOOP(S565Colorloop,Short,short);
}

PaintLoopFunc   S565paintARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_ONTO_S565
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintARGB_1ONTO_1S565(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(S565paintARGB,Int,int,Short,short);
}

PaintLoopFunc   S565paintXRGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintXRGB_ONTO_S565
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintXRGB_1ONTO_1S565(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(S565paintXRGB,Int,int,Short,short);
}

BgPaintLoopFunc   S565bgpaintARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_WITH_BG_CLR_ONTO_S565
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZII)V
 */
JNIEXPORT void JNICALL Java_sun_java2d_loops_ShortCompositing_paintARGB_1WITH_1BG_1CLR_1ONTO_1S565(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint bgColor, jint xorColor
  )
{
    INVOKE_BG_PAINT_LOOP(S565bgpaintARGB,Int,int,Short,short);
}

BgPaintLoopFunc   S565bgpaintBitmaskARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_WITH_BITMASK_AND_BG_CLR_ONTO_S565
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZII)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintARGB_1WITH_1BITMASK_1AND_1BG_1CLR_1ONTO_1S565(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint bgColor, jint xorColor
  )
{
    INVOKE_BG_PAINT_LOOP(S565bgpaintBitmaskARGB,Int,int,Short,short);
}

PaintLoopFunc   S565paintBitmaskARGB;
/*
 * Class:     sun_java2d_loops_ShortCompositing
 * Method:    paintARGB_WITH_BITMASK_ONTO_S565
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_ShortCompositing_paintARGB_1WITH_1BITMASK_1ONTO_1S565(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(S565paintBitmaskARGB,Int,int,Short,short);
}

/************************************* 555 composite loops *********************************/

#undef DST_XCCC
#define DST_XCCC

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <S555_DstData.h>

#undef COLOR_BLENDFUNC
#define COLOR_BLENDFUNC S555Colorloop
#include <alphaCompst_colorloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BG_BLENDFUNC
#include <ARGB_SrcData.h>
#define TILE_BG_BLENDFUNC S555bgpaintARGB
#include <alphaCompst_bgpaintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BG_BLENDFUNC
#include <BitmaskARGB_SrcData.h>
#define TILE_BG_BLENDFUNC S555bgpaintBitmaskARGB
#include <alphaCompst_bgpaintloop.h>


#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <BitmaskARGB_SrcData.h>
#define TILE_BLENDFUNC S555paintBitmaskARGB
#include <alphaCompst_paintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <ARGB_SrcData.h>
#define TILE_BLENDFUNC S555paintARGB
#include <alphaCompst_paintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <XRGB_SrcData.h>
#define TILE_BLENDFUNC S555paintXRGB
#include <alphaCompst_paintloop.h>

/************************************* 565 composite loops *********************************/

#undef DST_XCCC
#define DST_XCCC

#undef DeclareDst
#undef InitDst
#undef ReadDstPixel
#undef PrepColorDst
#undef CopyColorToDst
#undef WriteDstPixel
#undef NextDstPixel
#undef NextDstRow
#include <S565_DstData.h>

#undef COLOR_BLENDFUNC
#define COLOR_BLENDFUNC S565Colorloop
#include <alphaCompst_colorloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#include <ARGB_SrcData.h>
#undef TILE_BG_BLENDFUNC
#define TILE_BG_BLENDFUNC S565bgpaintARGB
#include <alphaCompst_bgpaintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BG_BLENDFUNC
#include <BitmaskARGB_SrcData.h>
#define TILE_BG_BLENDFUNC S565bgpaintBitmaskARGB
#include <alphaCompst_bgpaintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <BitmaskARGB_SrcData.h>
#define TILE_BLENDFUNC S565paintBitmaskARGB
#include <alphaCompst_paintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <ARGB_SrcData.h>
#define TILE_BLENDFUNC S565paintARGB
#include <alphaCompst_paintloop.h>

#undef DeclareSrc
#undef InitSrc
#undef ReadSrcPixel
#undef NextSrcPixel
#undef NextSrcRow
#undef TILE_BLENDFUNC
#include <XRGB_SrcData.h>
#define TILE_BLENDFUNC S565paintXRGB
#include <alphaCompst_paintloop.h>
