/*
 * @(#)XBGRLoops.c	1.7 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <jni.h>
#include <jni_util.h>
#include <sun_java2d_loops_XBGRLoops.h>
#include <memory.h>
#include <math.h>

#include <alphaCompst.h>


#ifndef _Included_ImageData
#include <ImageData.h>
#endif

#ifndef _Included_BlitMacros
#include <BlitMacros.h>
#endif

ColorLoopFunc XBGRcolorloop;
/*
 * Class:     sun_java2d_loops_XBGRLoops
 * Method:    ColorFillAlphaToXBGR
 * Signature: (Lsun/awt/image/ImageData;I[BIIFI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_XBGRLoops_ColorFillAlphaToXBGR(
    JNIEnv *env, jobject self,
    jobject dstImage,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jint fgColor)
{
    INVOKE_COLOR_LOOP(XBGRcolorloop,Int,int);
}

PaintLoopFunc   XBGRpaintARGB;
/*
 * Class:     sun_java2d_loops_XBGRLoops
 * Method:    paintARGB_ONTO_XBGR
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_XBGRLoops_paintARGB_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XBGRpaintARGB,Int,int,Int,int);
}

PaintLoopFunc   XBGRpaintXRGB;
/*
 * Class:     sun_java2d_loops_XBGRLoops
 * Method:    paintXRGB_ONTO_XBGR
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_XBGRLoops_paintXRGB_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XBGRpaintXRGB,Int,int,Int,int);
}

BgPaintLoopFunc   XBGRbgpaintARGB;
/*
 * Class:     sun_java2d_loops_XBGRLoops
 * Method:    paintARGB_WITH_BG_CLR_ONTO_XBGR
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZII)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_XBGRLoops_paintARGB_1WITH_1BG_1CLR_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint bgColor, jint xorColor
  )
{
    INVOKE_BG_PAINT_LOOP(XBGRbgpaintARGB,Int,int,Int,int);
}

BgPaintLoopFunc   XBGRbgpaintBitmaskARGB;
/*
 * Class:     sun_java2d_loops_XBGRLoops
 * Method:    paintARGB_WITH_BITMASK_AND_BG_CLR_ONTO_XBGR
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZII)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_XBGRLoops_paintARGB_1WITH_1BITMASK_1AND_1BG_1CLR_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint bgColor, jint xorColor
  )
{
    INVOKE_BG_PAINT_LOOP(XBGRbgpaintBitmaskARGB,Int,int,Int,int);
}

PaintLoopFunc   XBGRpaintBitmaskARGB;
/*
 * Class:     sun_java2d_loops_XBGRLoops
 * Method:    paintARGB_WITH_BITMASK_ONTO_XBGR
 * Signature: (Lsun/awt/image/ImageData;Lsun/awt/image/ImageData;III[BIIFZI)V
 */
JNIEXPORT void JNICALL
Java_sun_java2d_loops_XBGRLoops_paintARGB_1WITH_1BITMASK_1ONTO_1XBGR(
    JNIEnv *env, jobject joSelf,
    jobject srcImage, jobject dstImage, jint width, jint height,

    jint rule,

    jbyteArray alpha, jint alphaOffset, jint alphaScanSize,
    jfloat extraAlpha,
    jboolean srcPreMultiplied,
    jint xorColor
  )
{
    INVOKE_PAINT_LOOP(XBGRpaintBitmaskARGB,Int,int,Int,int);
}
