/*
 * @(#)XBGR_DstData.h	1.12 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#define NORM_SCALE   256
#define NORM_SCALE_1 255

#define DeclareDst                                                      \
     unsigned int *dstPtr;

#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width * dstPixStr;                                    \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned int tmp;							\
    tmp = *dstPtr;							\
    dA = 255;		  						\
    dB = (tmp >> 16) & 0xff;						\
    dG = (tmp >>  8) & 0xff;						\
    dR = (tmp >>  0) & 0xff;						\
}while (0);

#define PrepColorDst							\
unsigned int colorPrep = (((colorBlue*extraAlpha)/256) << 16) |         \
                         (((colorGreen*extraAlpha)/256) << 8) |         \
                         ((colorRed*extraAlpha)/256);

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)

#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE_1) {                                        \
            dR = (dR * NORM_SCALE_1) / dA;                                \
            dG = (dG * NORM_SCALE_1) / dA;                                \
            dB = (dB * NORM_SCALE_1) / dA;                                \
        }                                                               \
        *dstPtr = (((dB & 0xff) << 16) |				\
                   ((dG & 0xff) <<  8) |				\
                   ((dR & 0xff) <<  0));				\
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
