/*
 * @(#)SpanIterator.h	1.2 98/09/08
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * This structure defines the methods used to communicate with a
 * Java SpanIterator at the native level.
 */
typedef struct {
    /**
     * Init and return native data
     */
    void     *(*open)(JNIEnv *env, jobject iterator);

    /**
     * End iteration, dispose data
     */
    void      (*close)(JNIEnv *env, void *clientData);

    /**
     * See PathIterator.getPathBox
     */
    void      (*getPathBox)(JNIEnv *env, void *clientData, jint pathbox[]);

    /**
     * See PathIterator.nextSpan
     */
    jboolean  (*nextSpan)(JNIEnv *env, void *clientData, jint spanbox[]);

    /**
     * See PathIterator.skipDownTo
     */
    void      (*skipDownTo)(JNIEnv *env, void *clientData, jint y);
} SpanIteratorFuncs;
