/*
 * @(#)FocusTest.java	1.8 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.applet.*;

public class FocusTest extends TestApplet {
    TextField	fields[];
    Button	b;
    Panel	fp;

    public void init() {
	setLayout(new BorderLayout());
	fp = new Panel();
	fp.setLayout(new GridLayout(0, 1));
	
	fields = new TextField[3];
	for (int i=0; i < fields.length; i++) {
	    fields[i] = new TextField(15);
	    fp.add(fields[i]);
	}
	add("Center", fp);

	add("South", b=new Button("print"));
    }

    public boolean action(Event evt, Object arg) {
	if (evt.target instanceof TextField) {
	    for (int i=0; i < fields.length; i++) {
		if (fields[i] == evt.target) {
		    if (i < (fields.length - 1)) {
			fields[i+1].requestFocus();
		    } else {
			b.requestFocus();
		    }
		}
	    }
	}
	if (evt.target == b) {
	    print("--values--");
	    for (int i=0; i < fields.length; i++) {
		print(fields[i].getText());
	    }
	    fields[0].requestFocus();
	}

	return true;
    }

    public static void main(String args[]) {
	FocusTest f = new FocusTest();
	
	f.init();
	new FocusFrame(f);
    }
}


class FocusFrame extends Frame {
    public FocusFrame(Applet app) {
	super("FocusTest");
	add("Center", app);
	pack();
	show();
    }

    public boolean handleEvent(Event e) {
	if (e.id == Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
	return super.handleEvent(e);
    }
}
