/*
 * @(#)GetFramesTest.java	1.2 98/03/18
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.awt.*;
import java.io.*;
import java.lang.reflect.*;
import java.net.*;
import java.util.*;
import sun.applet.*;

/**
 * The GetFramesTest verifies the 1.2 Frame.getFrames() API.  Because
 * getFrames() is supposed to return only those frames created within
 * a SecurityContext, the API needs to be tested both as an application
 * and as an applet.  To avoid running the test twice and manually
 * comparing the results, AppletViewer is extended so that both app and
 * applet can be tested at once.  Invoke with GetFramesAppletTest.html
 * as an http URL to test applet-created frames.
 *
 * NOTE:  http URLs must be used to test different SecurityContexts, and
 * if you want to test applets having different SecurityContexts, they
 * need to have different base URLs.  This means that you need to either
 * specify a different web server or put the html file in a different
 * directory.
 */
public class GetFramesTest {

    public static void main(String argv[]) {
        try {
            // Invoke appletviewer with the specified args.
            Class avClass = Class.forName("sun.applet.AppletViewer");
            Class[] signature = new Class[1];
            signature[0] = argv.getClass();
            Method mainMethod = avClass.getMethod("main", signature);
            Object[] args = new Object[1];
            args[0] = argv;
            mainMethod.invoke(null, args);

            // Print out any "system" level frames.
            Frame[] frameList = Frame.getFrames();
            if (frameList.length == 0) {
                System.out.println("no application frames");
            } else {
                System.out.println("Application frames:");
                for (int i = 0; i < frameList.length; i++) {
                    System.out.println("   " + frameList[i]);
                }
            }
        } catch (Exception e) {
            System.err.println(e.toString());
        }
    }
}
