/*
 * @(#)ListStressTest.java	1.5 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.awt.*;
import java.applet.*;
import java.util.Date;



class LTest extends Frame {
  Panel listpanel;

  public LTest() {
    super("ListStressTest");
    listpanel = new ListPanel();
    Dimension d;

    add("Center",listpanel);
    resize(preferredSize());
    show();
  }
}


public class ListStressTest extends TestApplet {
  LTest ltest;

    public void init() {
	setLayout(new GridLayout(0,1));
	add(new Button("start"));
    }

    public void destroy() {
	if (ltest != null) {
	    ltest.dispose();
	}
    }

    public boolean action(Event evt, Object arg) {
	if ("start".equals(arg)) {
	    ltest = new LTest();
	    ((Button)evt.target).setLabel("stop");
	} else if ("stop".equals(arg)) {
	    ltest.dispose();
	    ltest = null;
	    ((Button)evt.target).setLabel("start");
	}
	return true;
    }


  public static void main(String argv[]) {
    Frame f = new Frame("ListStressTest");
    ListStressTest liststresstest = new ListStressTest();
    Dimension d;

    liststresstest.init();
    liststresstest.start();

    f.add("Center", liststresstest);
    f.resize(100, 100);
    f.show();
  }
}


class ListPanel extends Panel {
  StressList stresslist;
  Dimension d;

  public ListPanel() {
    stresslist = new StressList();
    setLayout(new FlowLayout());
    add(stresslist);
  }
}



class StressList extends List {
  List widgetmenu;
  StringBuffer strbuf = new StringBuffer();

  public StressList() {
    addItem("--courier-bold-o-normal--0-0-0-0-m-0-iso8859-1");
    addItem("--courier-bold-r-normal--0-0-0-0-m-0-iso8859-1");
    addItem("--courier-medium-o-normal--0-0-0-0-m-0-iso8859-1");
    addItem("--courier-medium-r-normal--0-0-0-0-m-0-iso8859-1");
    addItem("--symbol-medium-r-normal--0-0-0-0-p-0--symbol");
    addItem("--symbol-medium-r-normal--0-0-0-0-p-0-sun-fontspecific");
    addItem("This is a stress test for the List class. It tests the length of the longest item string as well as the number of such strings in the list. This test is a good stress test for such methods that take a string as an argument.");
    addItem("-adobe-courier-bold-i-normal--0-0-0-0-m-0-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--0-0-100-100-m-0-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--11-80-100-100-m-60-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--14-100-100-100-m-90-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--14-140-75-75-m-90-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--17-120-100-100-m-100-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--18-180-75-75-m-110-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--20-140-100-100-m-110-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--24-240-75-75-m-150-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--25-180-100-100-m-150-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--34-240-100-100-m-200-iso8859-1");
    addItem("-adobe-courier-bold-o-normal--8-80-75-75-m-50-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--0-0-0-0-m-0-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--0-0-100-100-m-0-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--10-100-75-75-m-60-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--11-80-100-100-m-60-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--14-140-75-75-m-90-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--17-120-100-100-m-100-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--18-180-75-75-m-110-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--20-140-100-100-m-110-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--24-240-75-75-m-150-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--25-180-100-100-m-150-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--34-240-100-100-m-200-iso8859-1");
    addItem("-adobe-courier-bold-r-normal--8-80-75-75-m-50-iso8859-1");
    addItem("-adobe-courier-medium-i-normal--0-0-0-0-m-0-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--0-0-100-100-m-0-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--10-100-75-75-m-60-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--11-80-100-100-m-60-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--14-100-100-100-m-90-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--14-140-75-75-m-90-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--17-120-100-100-m-100-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--18-180-75-75-m-110-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--20-140-100-100-m-110-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--24-240-75-75-m-150-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--25-180-100-100-m-150-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--34-240-100-100-m-200-iso8859-1");
    addItem("-adobe-courier-medium-o-normal--8-80-75-75-m-50-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--0-0-0-0-m-0-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--0-0-100-100-m-0-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--0-0-75-75-m-0-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--10-100-75-75-m-60-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--11-80-100-100-m-60-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--12-120-75-75-m-70-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--14-100-100-100-m-90-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--14-140-75-75-m-90-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--17-120-100-100-m-100-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--18-180-75-75-m-110-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--20-140-100-100-m-110-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--24-240-75-75-m-150-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--25-180-100-100-m-150-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--34-240-100-100-m-200-iso8859-1");
    addItem("-adobe-courier-medium-r-normal--8-80-75-75-m-50-iso8859-1");
    addItem("-adobe-helvetica-bold-i-normal--0-0-0-0-p-0-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--0-0-100-100-p-0-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--0-0-75-75-p-0-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--10-100-75-75-p-60-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--11-80-100-100-p-60-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--12-120-75-75-p-69-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--14-100-100-100-p-82-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--17-120-100-100-p-92-iso8859-1");
    addItem("-adobe-helvetica-bold-o-normal--18-180-75-75-p-104-iso8859-1");
    for(int i=0; i <= 1000; i++) {
      strbuf.append("1");
      addItem(strbuf.toString());
    }
    resize(700, 200);
    System.out.println("Number of items in the list: " + countItems());
  }
}
