/*
 * @(#)TestApplet.java	1.11 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.applet.*;
import java.awt.*;

public class TestApplet extends Applet {
    OutputHandler outh = new NullOutput();

    public TestApplet() {
    }

    public void print(String s) {
	if (outh instanceof NullOutput) {
	    try {
		AppletContext appCtxt = getAppletContext();

		if (appCtxt != null) {
		    Applet app = getAppletContext().getApplet("Output");

		    if (app != null && app instanceof OutputHandler) {
			outh = (OutputHandler)app;
			outh.setTitle("*" + getClass().getName() + " Output*");
		    }
		}
	    } catch (NullPointerException e) {
	    }
	}
	outh.print(s);
    }

    public void destroy() {
	if (outh instanceof Applet) {
	    ((Applet)outh).destroy();
	}
    }

    public void paint(Graphics g) {
	Dimension s = size();
	g.setColor(Color.black);
	g.drawRect(0, 0, s.width - 1, s.height - 1);
    }

    public Insets insets() {
	return new Insets(2, 2, 2, 2);
    }
}

class NullOutput implements OutputHandler {
    public void setTitle(String s) {
	System.out.println(s);
    }
    public void print(String s) {
	System.out.println(s);
    }
}
