/*
 * @(#)WindowIconTest.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.awt.*;
import java.applet.*;

import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Shape;

import java.awt.image.BufferedImage;

public class WindowIconTest extends TestApplet 
{
  WindowIconFrame windowf;

  public WindowIconTest() 
  {
    windowf = new WindowIconFrame("WindowFrame");
    windowf.resize(200, 200);
    windowf.show();
  }

}


class WindowIconFrame extends Frame 
{
  static final int   width = 150;
  static final int   height = 150;

  Panel buttonpanel;
  Button prepareIcon;
  Color colorRed;
  Color colorGreen;
  Color colorBlue;
  Color colorBlack;
  Color colorGray;
  Color colorWhite;

  Color savedColor;
  Color colorYellow;

//------------- begin group
//  Draw primitives
  void drawBar(Graphics g,int x,int y,int h, int v,Color c)
  {
    savedColor = g.getColor();

    g.setColor(c);
    
    g.fillRect(x,y,h,v);

    g.setColor(savedColor);
  }
  void drawRect(Graphics g,int x,int y,int h, int v,Color c)
  {
    savedColor = g.getColor();

    g.setColor(c);
    
    g.drawRect(x,y,h,v);

    g.setColor(savedColor);
  }
  void drawRing(Graphics g,int x,int y,int h, int v,Color c)
  {
    savedColor = g.getColor();

    g.setColor(c);
    
    g.drawOval(x,y,h,v);

    g.setColor(savedColor);
  }
  void drawGrid(Graphics g,int x,int y,int h, int v,int d,Color c)
  {
    savedColor = g.getColor();

    g.setColor(c);
    
    {
	    int		i;

	    for(i=y;i<y+v;i+=d)
	    {
		    g.drawLine(x,i,x+h,i);
	    }
	    for(i=x;i<x+v;i+=d)
	    {
		    g.drawLine(i,y,i,y+v);
	    }
    }
    

    g.setColor(savedColor);
  }
  void typeLine(Graphics g,int x,int y,String s,Color c)
  {

    drawBar(g,x,y - 10,150,15,colorWhite);  
  
    savedColor = g.getColor();

    g.setColor(c);
    

    g.drawString(s,x,y);

    g.setColor(savedColor);
  }

  void makeOriginal(Graphics g,int x,int y,int width,int height)
  {


    drawBar(g,x,y,width,height,colorWhite);

    drawBar(g,x,y,40,40,colorRed);
    drawBar(g,x+width-41,y,x+width,40,colorGreen);
    drawBar(g,x+width/2-20,y+height-41,40,40,colorBlue);
    drawBar(g,x+30,y+30,width-61,height-61,colorYellow);
    drawBar(g,x+60,y+60,width-121,height-121,colorGray);


    drawGrid(g,x+30,y+30,width-61,height-61,5,colorBlack);

    drawRing(g,x,y,width-1,height-1,colorBlack);   

  }

//------------- end group

  public WindowIconFrame(String s) 
  {
    super(s);

    prepareIcon     = new Button("prepare icon");
    buttonpanel     = new Panel();
    buttonpanel.add(prepareIcon);

    setLayout(new BorderLayout());
    add("South", buttonpanel);
    pack();

	colorRed		= new Color(0xFF,0x00,0x00);
	colorGreen		= new Color(0x00,0xFF,0x00);
	colorBlue		= new Color(0x00,0x00,0xFF);
	colorWhite		= new Color(0xFF,0xFF,0xFF);
	colorBlack		= new Color(0x00,0x00,0x00);
	colorGray		= new Color(0x77,0x77,0x77);

    colorYellow     = new Color(0xFF,0xFF,0x00);
  }

  public Image prepareImage()
  {
    BufferedImage   img = new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);

    if( null != img )
    {
        Graphics g = img.getGraphics();
        makeOriginal(g,0,0,width,height);
        Graphics g0 = getGraphics();
        if( null != g0 )
        {
            g0.drawImage(img,40,40,null);
        }
    }
    return img;
  }


  public boolean handleEvent(Event evt) 
  {
    if (evt.id == Event.ACTION_EVENT) 
    {
        if( prepareIcon == evt.target )
        {
            Image img = prepareImage();
            if( null != img )
            {
                setIconImage(img);
            }
            return super.handleEvent(evt);
        }
    }
    return super.handleEvent(evt);
  }
}


