/*
 * @(#)Blink.java	1.5 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.util.StringTokenizer;
import java.io.InputStream;
import java.io.*;

/**
 * @author Arthur van Hoff
 * @modified 96/04/24 Jim Hagen : use getBackground
 */
public class Blink extends java.applet.Applet implements Runnable {
    transient Thread blinker;
    String lbl;
    Font font;
    int speed;

    private static String getString(InputStream is) throws IOException {
	byte buffer[] = new byte[256];
	String back=new String();
	int count;
	while ((count = is.read(buffer)) != -1) {
	    back = back.concat(new String(buffer, 0, 0, count));
	}
	return (back);
    }

    private String getMessage() {
	try {
	    InputStream is = this.getClass().getResourceAsStream("BlinkingMessage");
	    lbl = getString(is);
	    return lbl;
	} catch (java.io.IOException ex) {
	    ex.printStackTrace();
	}
	return null;
    }

    public void init() {
	System.err.println("initializing Blink Applet");
	font = new java.awt.Font("TimesRoman", Font.PLAIN, 24);
	String att = getParameter("speed");
	speed = (att == null) ? 400 : (1000 / Integer.valueOf(att).intValue());
	att = getParameter("lbl");
	if (att == null) {
	    lbl = getMessage();
	} else {
	    lbl = att;
	}
    }
    
    public void paint(Graphics g) {
	int x = 0, y = font.getSize(), space;
	int red = (int)(Math.random() * 50);
	int green = (int)(Math.random() * 50);
	int blue = (int)(Math.random() * 256);
	Dimension d = size();

	g.setColor(Color.black);
	g.setFont(font);
	FontMetrics fm = g.getFontMetrics();
	space = fm.stringWidth(" ");
	for (StringTokenizer t = new StringTokenizer(lbl) ; t.hasMoreTokens() ; ) {
	    String word = t.nextToken();
	    int w = fm.stringWidth(word) + space;
	    if (x + w > d.width) {
		x = 0;
		y += font.getSize();
	    }
	    if (Math.random() < 0.5) {
		g.setColor(new java.awt.Color((red + y * 30) % 256, (green + x / 3) % 256, blue));
	    } else {
                g.setColor(getBackground());
	    }
	    g.drawString(word, x, y);
	    x += w;
	}
    }

    public void start() {
	System.err.println("starting Blink applet");
	blinker = new Thread(this);
	blinker.start();
    }
    public void stop() {
	System.err.println("stoping Blink applet");
	blinker.stop();
    }
    public void destroy() {
	System.err.println("destroying Blink applet");
	if (blinker!=null) {
	    blinker.stop();
	    blinker = null;
	}
    }

    public void run() {
	while (true) {
	    try {
		Thread.currentThread().sleep(speed);
	    } catch (InterruptedException e){
	    }
	    repaint();
	}
    }
}
