/*
 * @(#)BlinkWriter.java	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/**
 * Create a Blink instance and serialize it out
 */

import java.applet.*;
import java.io.*;

public class BlinkWriter {
    public static void main(String args[]) {
	if (args.length != 1) {
	    throw new Error("wrong # of args");
	}

	String filename = args[0];
	ClassLoader cl = BlinkWriter.class.getClassLoader();

	try {
	    Applet applet = (Applet) java.beans.Beans.instantiate(cl, "Blink");
	    // instantiate does an init(), but not a start().
	    OutputStream os = new FileOutputStream(filename);
	    ObjectOutputStream oos = new ObjectOutputStream(os);
	    oos.writeObject(applet);
	    oos.close();
	    System.err.println("BlinkWriter: wrote Blink applet");
	    applet.destroy();
	    System.exit(0);
	} catch (Exception e) {
	    System.err.println("caught an exception "+e);
	    e.printStackTrace();
	}
    }
}
