/*
 * @(#)Negative.java	1.8 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package util;

/**
 * Test for Negatives
 *
 * Resources should not be found.
 */

import java.io.*;

public class Negative extends Util implements Test {
    public Negative() {
    }

    private static void usage() {
	print("usage for Negative tests: <golden file>");
    }

    // this is the check to perform
    public void check() throws TestException {
	if (canNotFind(theKlass, theName)) {
	    pass(theName+" not found.");
	} else {
	    fail(theName+" found.");
	}
    }

    // run this test with this arguments
    public void run(Class klass, String args[]) {
	if (args.length != 1) {
	    usage();
	    System.exit(1);
	}
	String fileName = args[0];
	try {
	    BufferedReader r = null;
	    try {
		r = new BufferedReader(new FileReader(fileName));
	    } catch (Exception ex) {
		usage();
		System.exit(1);
	    }
	    String line;
	    // Get and print the test description
	    debug("class: "+klass);
	    debug("ClassLoader: "+klass.getClassLoader());
	    debug("CurrentClassLoader: "+currentClassLoader());
	    while (((line = r.readLine()) != null) &&
		   (line.length() != 0)) {
		print2(line);
	    }
	    // parse the resource names and test them.
	    String name;
	    while ((name = r.readLine()) != null) {
		theKlass = klass;
		theName = name;
		indirect(klass);
	    }
	} catch (Exception ex) {
	    fail("Caught "+ex);
	}
	reportTest();
    }

    // The arguments (this is a closure)
    Class theKlass;		// the class providing the context
    String theName;		// the name of the resource
}
