/*
 * @(#)AffineTransformPipe.java	1.14 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.applet.Applet;
import java.awt.Container;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;

public class AffineTransformPipe extends Pipe {
    AffineTransform at = new AffineTransform();
    public AffineTransformPipe(Pipeline pipeline, Applet applet,
                               BufferedImage bimage) {
        super(pipeline, applet, bimage, false);
        int width = bimage.getWidth();
        int height = bimage.getHeight();
        double angle = Math.PI/4.;
        String rstring = applet.getParameter("rotate");

        if (rstring != null) {
            angle = (Math.PI*Integer.parseInt(rstring))/180.;
        }
        Rectangle r = new Rectangle(0, 0, width, height);
        AffineTransform t = new AffineTransform();
        t.rotate(angle);
        r = t.createTransformedShape(r).getBounds();
        at.translate(width/2.,height/2.);
        at.rotate(angle);
        at.translate(-width/2.,-height/2.);
    }

    public Container addGui() {
        return null;
    }

    public void process() {
        long first, last;
        AffineTransformOp atOp = new AffineTransformOp(at,
                                                       AffineTransformOp.TYPE_BILINEAR);

        // Need to clear the image first
        Graphics2D g2 = outImage.createGraphics();
        g2.clearRect(0, 0, outImage.getWidth(), outImage.getHeight());

        first = System.currentTimeMillis();
        // Try the filter on the image
        outImage = atOp.filter(inImage, outImage);

        last = System.currentTimeMillis();
        System.out.println("elapsed: "+(last-first+1));
        if (outImage == inImage) {
            usedRef = false;
        }
        pipeline.trigger(this);
    }

    public String toString() {
        return ("AffineTransformPipe");
    }
}
