/*
 * @(#)BufImgDraw.java	1.21 98/08/25
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Label;
import java.awt.MediaTracker;
import java.awt.Panel;
import java.awt.Color;
import java.awt.Paint;
import java.awt.Scrollbar;
import java.awt.TextField;
import java.awt.image.ImageObserver;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.awt.image.BufferedImage;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;
import java.awt.image.ColorModel;
import java.awt.image.DirectColorModel;
import java.awt.image.LookupOp;
import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.Rectangle;
import java.awt.geom.Ellipse2D;
import java.awt.Shape;
import java.awt.geom.Area;



public class BufImgDraw extends Applet {

    BICanvas canvas;
    BufferedImage bi;
    BufferedImage bj;
    int width = 512;
    int height = 512;
    int widthj = 300;
    int heightj = 200;
    Shape clip = null;
    Rectangle2D rectClip = new Rectangle2D.Float();
    Shape oldClip = null;
    
    
    public void init() {

        System.out.println("Init");
        
        bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
        bj = new BufferedImage(widthj, heightj, BufferedImage.TYPE_INT_RGB);
        
        canvas = new BICanvas(bi, bj);
        add(canvas);
        setVisible(true);
        canvas.start();
    }

    public class BICanvas extends Canvas implements Runnable {
        BufferedImage bi, bj;
	Image img;
        Thread myThread;
        int width;
        int height;

        public BICanvas(BufferedImage bi, BufferedImage bj) {
            System.out.println("Canvas");
            
            this.bi = bi;
            this.bj = bj;
            width = bi.getWidth();
            height = bi.getHeight();
	    img = getImage(getCodeBase(), "writeonce.gif");

        }

        public void start() {
            if (myThread == null) {
                myThread = new Thread(this);
            }
            myThread.setPriority(Thread.MIN_PRIORITY);
            myThread.start();
        }

        public void stop() {
            if (myThread != null) {
                myThread.stop();
                myThread = null;
            }
        }
    
        public void run() {
            final double OINC[] = {5.0, 3.0};
            final double SINC[] = {5.0, 5.0};
            int bW = bj.getWidth();
            int bH = bj.getHeight();
            double x = Math.random()*bW;
            double y = Math.random()*bH;
            double ix = OINC[0];
            double iy = OINC[1];
            double iw = SINC[0];
            double ih = SINC[1];
            double w = (Math.random()*bW)/2;
            double h = (Math.random()*bH)/2;

//             float pt[] = { 100, 50,
//                            100, 0,
//                            50, 0,
//                            0, 0,
//                            0, 50,
//                            0, 100,
//                            50, 100,
//                            100, 100,
//                            100, 50 };

//             GeneralPath gp = new GeneralPath(9);
//             gp.moveTo(pt[0], pt[1]);
//             gp.quadTo(pt[2], pt[3], pt[4], pt[5]);
//             gp.quadTo(pt[6], pt[7], pt[8], pt[9]);
//             gp.quadTo(pt[10], pt[11], pt[12], pt[13]);
//             gp.quadTo(pt[14], pt[15], pt[16], pt[17]);
//             gp.closePath();

            while(true) {
                x += ix;
                y += iy;
                w += iw;
                h += ih;
                if (w > bW/2) {
                    w = bW/2;
		    iw = Math.random() * -bW/16 - 1;
                }
                if (w < bW/8) {
                    w = bW/8;
		    iw = Math.random() * bW/16 + 1;
                }
                if (h > bH/2) {
                    h = bH/2;
		    ih = Math.random() * -bH/16 - 1;
                }
                if (h < bH/8) {
                    h = bH/8;
		    ih = Math.random() * bH/16 + 1;
                }
                if ((x+w) > bW) {
                    x = (bW - w)-1;
		    ix = Math.random() * -bW/32 - 1;
                }
                if (x < 0) {
                    x = 2;
		    ix = Math.random() * bW/32 + 1;
                }
                if ((y+h) > bH) {
                    y = (bH - h)-2;
		    iy = Math.random() * -bH/32 - 1;
                }
                if (y < 0) {
                    y = 2;
		    iy = Math.random() * bH/32 + 1;
                }
                clip = new Ellipse2D.Float((float)x, (float)y,
                                           (float)w, (float)h);
                rectClip.setRect(x+5, y+5, w-10, h-10);
                
//                 clip = gp;
                
                Graphics g = getGraphics();
                canvas.update(g);
                try {
                    myThread.sleep(1);
                } catch (InterruptedException e) {
                }
            }
        }

        public Dimension getPreferredSize() {
            return new Dimension (width, height);
        }

        public Dimension getMinimumSize() {
            return getPreferredSize();
        }

        void drawStar(Graphics2D g, int width, int height) {
                    
            AlphaComposite composite = AlphaComposite.getInstance(
                                       AlphaComposite.SRC_OVER, .5f);
            GeneralPath p = new GeneralPath(GeneralPath.WIND_NON_ZERO);

            p.moveTo(- width / 2.0f, - height / 8.0f);
            p.lineTo(+ width / 2.0f, - height / 8.0f);
            p.lineTo(- width / 4.0f, + height / 2.0f);
            p.lineTo(+         0.0f, - height / 2.0f);
            p.lineTo(+ width / 4.0f, + height / 2.0f);
            p.closePath();

	    AffineTransform at = g.getTransform();

            g.setPaint(new Color(255, 0, 0));
            g.translate(width*.5f, height*.5f);
            g.setComposite(composite);
            g.setStroke(new BasicStroke(20.0f, BasicStroke.CAP_ROUND,
                                         BasicStroke.JOIN_ROUND));

            g.draw(p);

            g.setPaint(new Color(0, 255, 0));
            g.setTransform(at);
            g.fill(new Ellipse2D.Float(50, 50, 200, 100));

        }

        public void update(Graphics g) {
            paint(g);
        }
        
        public void paint(Graphics g) {
            Graphics2D g2 = (Graphics2D) g;
            long start, end;
            long start1, end1;
            
//             Graphics2D gi = bi.createGraphics();
            Graphics2D gj = bj.createGraphics();

//             gj.setComposite(AlphaComposite.SrcOver);
            gj.setBackground(Color.white);
            if (oldClip != null) {
                Rectangle r = oldClip.getBounds();
                gj.clearRect(r.x, r.y, r.width, r.height);
            } else {
                gj.clearRect(0, 0, bj.getWidth(), bj.getHeight());
            }
            oldClip = clip;
            
            //g2.fillRect(r.x, r.y, r.width, r.height);
            
            if (clip != null) {
//                 g2.setClip(0, 0, bj.getWidth(), bj.getHeight());
//                 g2.setPaint(Color.black);
//                 g2.draw(clip.getBounds2D());
                gj.setClip(clip);
                gj.clip(rectClip);
                gj.setComposite(AlphaComposite.Src);
                gj.drawImage(img, 0, 0, null);
                drawStar(gj, bj.getWidth(), bj.getHeight());
//                 g2.setPaint(Color.red);
//                 g2.fill(new Area(clip));
            }

            
            //gj.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, .5f));
            
            //gj.drawImage(bi, null, 0, 0);


            //gi.setComposite(AlphaComposite.SrcOver);
            //gi.setBackground(Color.pink);
            //gi.clearRect(0, 0, width, height);
//             gi.setComposite(AlphaComposite.Src);
            //gi.setClip(100, 100, 100, 100);
            //start = System.currentTimeMillis();
            //gi.drawImage(bj, null, 0, 0);
            //end = System.currentTimeMillis();
            //System.out.println("elapse: "+ (end-start+1));
            
            g2.setComposite(AlphaComposite.Src);
            g2.drawImage(bj, null, 100, 100);
            //end1= System.currentTimeMillis();
            //System.out.println("elapsed draw time "+(end-start+1)+
            //                 "elapsed blt time "+(end1-start1+1));
        }


    }

}

