/*
 * @(#)CMMTest.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.awt.color.*;
import java.awt.image.*;
import java.io.*;

class CMMTest extends Frame {
    Image img;
    BufferedImage srcImage = null;
    BufferedImage destImage = null;

    CMMTest() {
        img = getToolkit().getImage("brick.jpg");
        WaitImage waiter = new WaitImage(img);
        waiter.waitimg();
        srcImage = new BufferedImage(512, 512, BufferedImage.TYPE_INT_RGB);
        Graphics2D g2d = srcImage.createGraphics();
        g2d.drawImage(img, 0, 0, null);
        destImage = new BufferedImage(512, 512, BufferedImage.TYPE_INT_RGB);
        convertimg();
        new ImgFrame(srcImage);
        new ImgFrame(destImage);

    }

    private void convertimg() {
        ICC_Profile pf1 = ICC_Profile.getInstance ("src.pf");
        ICC_Profile pf2 = ICC_Profile.getInstance ("dest.pf");
        ICC_Profile pfList[] = new ICC_Profile[2];
        pfList[0] = pf1;
        pfList[1] = pf2;
        ColorConvertOp theOp = new ColorConvertOp (pfList, null);
        theOp.filter (srcImage, destImage);
    }

    static public void main(String[] args) {
        new CMMTest();
    }

}


class ImgFrame extends Frame {
    BufferedImage img;

    ImgFrame(BufferedImage bimg) {
        super("CMM Test");
        resize(400, 300);
        img = bimg;
        show();
    }

    public void paint(Graphics g) {
        Graphics2D g2d = (Graphics2D) g;
        g2d.drawImage(img, 0, 0, this);
    }

}


class WaitImage implements ImageObserver {
    Image image;
    int done = 0;

    public WaitImage(Image image) {
        this.image = image;
        image.getHeight(this);
    }

    public boolean imageUpdate(Image img, int flags,
                               int x, int y, int w, int h) {
        if ((flags & ImageObserver.ALLBITS) == ImageObserver.ALLBITS) {
            done = 1;
            return false;
        }
        return true;
    }

    public void waitimg() {
        while (done == 0) {
            try {
                Thread.sleep(100);
            }
            catch (InterruptedException e) {
            }
        }
        return;
    }

}


