/*
 * @(#)FontNames.java	1.5 98/08/28
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.applet.Applet;
import java.awt.Frame;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import java.awt.font.TextLayout;
import java.util.Map;
import java.util.Hashtable;
import java.awt.Color;

public class FontNames extends Applet {
	int position = 10;
    public static void main(String argv[]) {
        Frame f = new Frame();
        f.pack();
        f.show();
    }
    public Dimension getPreferredSize() {
        return new Dimension(600, 600);
    }

    public void paint(Graphics g) {
        Dimension size = getSize();
        int mindim = Math.min(size.width, size.height);
        Graphics2D g2d = (Graphics2D) g;
        doTest(g2d);
    }

    private void showFont(Font theFont, Graphics2D g2d) {
        System.out.println(theFont);
        System.err.println("  Fullname [" + theFont.getFontName() + "]");
		g2d.setFont(theFont);
//		g2d.drawString(theFont.getFontName() + " TEST \u2700\u2701 \u30b0\u30b5\u30b5\u3099 \u0642\u062c", 10, position);
		g2d.drawString(theFont.getFontName() + " TEST \u2700\u2701 \u30b0\u30b5\u30b5\u3099", 10, position);
		position = (position + 12 ) % 1000;
    }

    private void showFontVariations(String logicalName, Graphics2D g2d) {
//        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
//        Map m = new Hashtable();
//        m.put("Name", logicalName);
//        Font f = env.getFont(m);
//        showFont(env.getFont(logicalName));
        showFont(new Font(logicalName, Font.PLAIN, 12), g2d);
        showFont(new Font(logicalName, Font.BOLD, 12), g2d);
        showFont(new Font(logicalName, Font.ITALIC, 12), g2d);
        showFont(new Font(logicalName, Font.ITALIC | Font.BOLD, 12), g2d);
    }

    private void doTest(Graphics2D g2d) {
        // test for compatibility
        g2d.setPaint(Color.blue);
        showFontVariations("Serif", g2d);
        showFontVariations("SansSerif", g2d);
        showFontVariations("Monospaced", g2d);
        showFontVariations("Dialog", g2d);
        showFontVariations("DialogInput", g2d);

        showFontVariations("TimesRoman", g2d);
        showFontVariations("Helvetica", g2d);
        showFontVariations("Courier", g2d);
        showFontVariations("ZapfDingbats", g2d);

        showFontVariations("Default", g2d);
    }
}
