/*
 * @(#)FontTest.java	1.7 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.applet.Applet;
import java.awt.Frame;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
//import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
//import java.awt.geom.AffineTransform;
import java.awt.FontMetrics;
import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import java.awt.font.TextLayout;
//import java.awt.font.GlyphSet;

public class FontTest extends Applet {
    public static void main(String argv[]) {
        Frame f = new Frame();
        f.add(new Tree());
        f.pack();
        f.show();
    }
    public Dimension getPreferredSize() {
        return new Dimension(600, 600);
    }

    public void paint(Graphics g) {
        Dimension size = getSize();
        int mindim = Math.min(size.width, size.height);
        Graphics2D g2d = (Graphics2D) g;
        doTest(g2d);
    }

    private void doTest(Graphics2D g2d) {
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
        int i;
        String [] allFamilies = env.getAvailableFontFamilyNames();
        if (allFamilies != null) {
            for (i = 0; i < allFamilies.length; i++) {
                System.err.println("Family [" + allFamilies[i] + "]");
            }
        } else {
            System.err.println("Null returned for getAvailableFontFamilyNames()");
        }
        Font [] allFonts = env.getAllFonts();
        if (allFonts != null) {
            for (i = 0; i < allFonts.length; i++) {
                System.err.println("Font [" + allFonts[i] + "]");
            }
        } else {
            System.err.println("Null returned for getAllFonts()");
        }
        Font theFont0 = env.getFont("Univers Media");
        Font theFont1 = theFont0.deriveFont(Font.BOLD, 1);
        Font theFont2 = theFont0.deriveFont(Font.BOLD, 12);
        System.out.println(theFont0);
                System.err.println("  Fullname [" + theFont0.getFontName() + "]");
        g2d.setFont(theFont0);
        g2d.drawString("testing 1 2 3", 20, 20);
        System.out.println(theFont1);
                System.err.println("  Fullname [" + theFont1.getFontName() + "]");
        g2d.setFont(theFont1);
        g2d.drawString("testing 4 5 6", 40, 40);
        System.out.println(theFont2);
                System.err.println("  Fullname [" + theFont2.getFontName() + "]");
        g2d.setFont(theFont2);
        g2d.drawString("testing 7 8 9", 60, 60);

        GlyphVector gv = theFont2.createGlyphVector(g2d.getFontRenderContext(), "GlyphVector draw");
        g2d.drawGlyphVector(gv, 60, 80);
        gv = theFont2.createGlyphVector(g2d.getFontRenderContext(), "GlyphVector shape");
        g2d.draw(gv.getOutline(60, 90));

        TextLayout tl = new TextLayout("Simple TextLayout", theFont2);
        tl.draw(g2d, 60, 100);


//REMIND: waiting on Map implementation merge
//public abstract Font[] getFonts (Map attributes);
        FontRenderContext frc = g2d.getFontRenderContext();
        printFontRenderContext(frc);
        FontMetrics fm = g2d.getFontMetrics();
        FontMetrics ffm = g2d.getFont().getFontMetrics(frc);
        printFontMetrics(fm);
        printFontMetrics(ffm);
        FontMetrics fm0 = g2d.getFontMetrics(theFont0);
        printFontMetrics(fm0);
        FontMetrics fm1 = g2d.getFontMetrics(theFont1);
        printFontMetrics(fm1);
        FontMetrics fm2 = g2d.getFontMetrics(theFont2);
        printFontMetrics(fm2);
    }

    void printFontRenderContext(FontRenderContext frc) {
        System.err.println("FRC Transform" + frc.getTransform());
        System.err.println("FRC AA       " + frc.isAntiAliased());
        System.err.println("FRC FracMetr " + frc.usesFractionalMetrics());
    }

    void printFontMetrics(FontMetrics fm) {
        System.err.println("Max Advance [" + fm.getMaxAdvance() + "]");
        System.err.println("Ascent      [" + fm.getAscent() + "]");
        System.err.println("Descent     [" + fm.getDescent() + "]");
        System.err.println("Leading     [" + fm.getLeading() + "]");
        System.err.println("charWidth(W)[" + fm.charWidth('W') + "]");
        System.err.println("charWidth(w)[" + fm.charWidth('w') + "]");
        System.err.println("strWidth(Ww)[" + fm.stringWidth("Ww") + "]");
    }
}
