/*
 * @(#)GlyphTest.java	1.36 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.applet.Applet;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Canvas;
import java.awt.Rectangle;
import java.lang.String;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Shape;
import java.awt.font.TextAttribute;
import java.awt.font.TextLayout;
import java.awt.font.TextHitInfo;
import java.awt.font.GlyphVector;
import java.awt.FontMetrics;
import java.text.AttributedString;


public class GlyphTest extends Frame{
  GlyphCanvas canvas;

  public static void main(String[] args){

    GlyphTest theWindow = new GlyphTest();
    theWindow.pack();
    theWindow.show();
  }

  public GlyphTest(){
    setLayout(new BorderLayout());
    add("Center",canvas = new GlyphCanvas(320,240));
  }
}


class GlyphCanvas extends Canvas {

    public GlyphCanvas(int w, int h) {
    }

    public Dimension getPreferredSize() {
        return new Dimension(400, 250);
    }
    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;

        g2.setColor(Color.black);
        Font newFont = new Font("Times Roman",Font.PLAIN,14);
        Font oldFont = new Font("TimesRoman",Font.PLAIN,14);
        g.setFont(oldFont);
        g.drawString("Times-Roman",(int)10,(int)10);

        AttributedString attrString = new AttributedString("Times-Roman");
        attrString.addAttribute(TextAttribute.FONT, newFont);
//        g2.drawString(attrString.getIterator(),10,150);

        TextLayout tls = new TextLayout("Times-Roman", newFont, g2.getFontRenderContext());

        /*TextHitInfo start = new TextHitInfo(1, TextHitInfo.LEADING);
        TextHitInfo stop  = new TextHitInfo(10, TextHitInfo.TRAILING);

        Shape hilite = tls.getVisualHighlightShape(start, stop);
        AffineTransform t = new AffineTransform();
        t.setToTranslation(10, 250);
        Shape newHilite = ((GeneralPath)hilite).createTransformedShape(t);
        g2.setColor(Color.red);
        g2.fill(newHilite);
        g2.setColor(Color.black);*/
        tls.draw(g2, 10, 250);

        String s1 = "establish this Constitution for the United States of";
        String s2 = "establish ";
        String s3 = "this Constitution for the United States of";
        FontMetrics fm = g2.getFontMetrics(oldFont);

        g2.drawString(s1, 10, 50);
        g2.drawString(s2, 10, 70);
        g2.drawString(s3, 10 + fm.stringWidth(s2), 70);

        GlyphVector gv1 = oldFont.createGlyphVector(g2.getFontRenderContext(), s1);
        GlyphVector gv2 = oldFont.createGlyphVector(g2.getFontRenderContext(), s2);
        GlyphVector gv3 = oldFont.createGlyphVector(g2.getFontRenderContext(), s3);

        dumpGV(gv1,s1);
        dumpGV(gv2,s2);
        dumpGV(gv3,s3);
    }

    void dumpGV(GlyphVector gv, String str) {
        gv.performDefaultLayout();
        float [] positions = gv.getGlyphPositions(0, gv.getNumGlyphs(), null);
        if (positions != null) {
            for (int i=0; i < positions.length; i+=2) {
                System.out.println("[" + str.charAt(i/2) + "] @[" + positions[i] + ", " + positions[i+1] + "]");
            }
        }
        System.out.println("======================");
    }
}
