/*
 * @(#)Bug.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.awt.*;
import java.awt.image.*;
import java.awt.color.ColorSpace;

public class Bug extends Canvas {
  private BufferedImage image;

  public Bug(boolean withAlpha) {
    DirectColorModel cm = new
      DirectColorModel(ColorSpace.getInstance(ColorSpace.CS_sRGB), 
		       withAlpha ? 32 : 24,
		       withAlpha ? 0xFF000000 : 0xFF0000,
		       withAlpha ? 0x00FF0000 : 0x00FF00,
		       withAlpha ? 0x0000FF00 : 0x0000FF,
		       withAlpha ? 0x000000FF : 0,
		       true);
    
 
    WritableRaster myRaster = cm.createCompatibleWritableRaster(103, 67);

    image = new BufferedImage(cm, myRaster, true);
    setSize(image.getWidth(), image.getHeight());
  }
    
  public void paint(Graphics g) {
    if (image != null) {
      g.drawImage(image, 0, 0, null);
    }
  }

  public static void main(String args[]) {
    Bug imageCanvas = new Bug(args.length != 0);

    Frame f = new Frame();

    f.add(imageCanvas);
    f.pack();
    f.validate();
    f.setVisible(true);
  }
    
}
