/*
 * @(#)BugApplet.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)AffineAccuracy.java	1.1 97/10/20
 * 
 * Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */
import java.lang.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.applet.*;

import java.awt.color.ColorSpace;


abstract class AppletProto extends Applet implements Runnable {
  Thread              theThread;
  Graphics2D          theScreen;
  private boolean     theActivityStatus;

  public void start() {
    if (this.theThread == null) {
      this.theThread = new Thread(this);
      if( null != this.theThread ) {
	this.theThread.setPriority(Thread.MAX_PRIORITY);
	this.theThread.start();
	this.theActivityStatus = true;
      } else {
	debugReport("Thread initialization problem");
      } 
    }
  }

  public void stop() {
    if (this.theThread != null) {
      this.theThread.stop();
      this.theThread = null;
      this.theActivityStatus = false;
    }
  }

  public void run() {
    privateStartup();
    if( true == setupInternalData() ) {
      runApplet();
      cleanupInternalData();
    } else {
      debugReport("Error in initialization!");
    }
    privateCleanup();
  }

  private void privateStartup(){
    this.theScreen = (Graphics2D)getGraphics();
  }
  private void privateCleanup(){
    this.theScreen = null;
  }

  public boolean isActive() {
    return this.theActivityStatus;
  }

  public void debugReport(String reportLine){
    System.out.println(">>> "+reportLine);
  }

  abstract boolean setupInternalData();
  abstract public void cleanupInternalData();
  abstract public void runApplet();
  
}


class Bug extends Canvas {
  private BufferedImage image;

  public Bug(boolean withAlpha) {
    DirectColorModel cm = new
      DirectColorModel(ColorSpace.getInstance(ColorSpace.CS_sRGB), 
		       withAlpha ? 32 : 24,
		       withAlpha ? 0xFF000000 : 0xFF0000,
		       withAlpha ? 0x00FF0000 : 0x00FF00,
		       withAlpha ? 0x0000FF00 : 0x0000FF,
		       withAlpha ? 0x000000FF : 0,
		       true);

 
    WritableRaster myRaster = cm.createCompatibleWritableRaster(103, 67);

    image = new BufferedImage(cm, myRaster, true);
    setSize(image.getWidth(), image.getHeight());
  }
    
  public void paint(Graphics g) {
    if (image != null) {
      g.drawImage(image, 0, 0, null);
    }
  }
}

public class BugApplet extends AppletProto {
  //  Frame                 theFrame;
  //  Bug                   theCanvas;

  public boolean setupInternalData(){
    Bug imageCanvas = new Bug(true);

    Frame f = new Frame();

    f.add(imageCanvas);
    f.pack();
    f.validate();
    f.setVisible(true);

    return true;
  }
  public void cleanupInternalData() {
  }
  public void runApplet() {
  }


}



