/*
 * @(#)BugConfig.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.awt.image.*;
import java.awt.color.ColorSpace;

public class BugConfig extends Canvas {
  private BufferedImage image;
  private boolean isAlpha;
  private Frame theFrame;

  public BugConfig(boolean givenIsAlpha) {

    this.image = null;
    this.isAlpha = givenIsAlpha;
    this.theFrame = null;
  }

  public void setupFrame(Frame givenFrame) {
    this.theFrame = givenFrame;
  }

  public void initImage() {
    Graphics2D               theScreen   = null;
    GraphicsConfiguration    devConf     = null;
    ColorModel               devModel    = null;
    WritableRaster           devCMRaster = null;
    BufferedImage            devBImage   = null;

    boolean                  bOK         = false; 

    //1 Obtain color model from GraphicsConfiguration
    theScreen = (Graphics2D)(this.getGraphics());
    if( null != theScreen ) {
      devConf = theScreen.getDeviceConfiguration(); 
      if( null != devConf ) {
	devModel = devConf.getColorModel(Transparency.OPAQUE);
	if( null != devModel ) {
	  devCMRaster = devModel.createCompatibleWritableRaster(103, 67);
	  if( null != devCMRaster ) {
	    devBImage = new BufferedImage(devModel, devCMRaster, true);
	    if( null != devBImage ) {
	      this.setSize(devBImage.getWidth(), devBImage.getHeight());
	      if( null != this.theFrame ){
		this.theFrame.setSize(devBImage.getWidth(), devBImage.getHeight());
	      }
	      this.image = devBImage;
	      bOK = true;
	    }
	  }
	}
      }
    } 

    if( false == bOK ) {
      System.out.println("PROBLEM>>>\n"+
			 "theScreen  " + " [" + theScreen   + "]\n"+
			 "devConf    " + " [" + devConf     + "]\n"+
			 "devModel   " + " [" + devModel    + "]\n"+
			 "devCMRaster" + " [" + devCMRaster + "]\n"+
                         "devBImage  " + " [" + devBImage   + "]\n"+
                         ">>>"); 
			 
    }
 
    
  }
    
  public void paint(Graphics g) {
    if (this.image != null) {
      g.drawImage(this.image, 0, 0, null);
    }
  }

  public static void main(String args[]) {
    BugConfig frameCanvas = new BugConfig(args.length != 0);

    if( null != frameCanvas ) {
      Frame theFrame = new Frame();
      if( null != theFrame ) {
	theFrame.add(frameCanvas);
	theFrame.pack();
	theFrame.validate();
	theFrame.setVisible(true);

	frameCanvas.setupFrame(theFrame);
	frameCanvas.initImage();
      }
    }
  }
    
}
