/*
 * @(#)BugImageFormat.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.awt.image.*;
import java.awt.color.ColorSpace;

public class BugImageFormat extends Canvas {
  private BufferedImage image;
  private boolean isAlpha;
  private Frame theFrame;

  public BugImageFormat(boolean givenIsAlpha) {

    this.image = null;
    this.isAlpha = givenIsAlpha;
    this.theFrame = null;
  }

  public void setupFrame(Frame givenFrame) {
    this.theFrame = givenFrame;
  }

  public void initImage() {
    BufferedImage            testImage   = null;

    boolean                  bOK         = false; 

    if( true == this.isAlpha ) {
      testImage = new BufferedImage(103,67,BufferedImage.TYPE_INT_ARGB);
    } else {
      testImage = new BufferedImage(103,67,BufferedImage.TYPE_INT_RGB);
    }
    if(null != testImage ){
      this.setSize(testImage.getWidth(), testImage.getHeight());
      if( null != this.theFrame ){
	this.theFrame.setSize(testImage.getWidth(), testImage.getHeight());
      }
      this.image = testImage;
      bOK = true;
    }

    if( false == bOK ) {
      System.out.println("PROBLEM>>>\n"+
			 "testImage  " + " [" + testImage   + "]\n"+
                         ">>>"); 
			 
    }
 
    
  }
    
  public void paint(Graphics g) {
    if (this.image != null) {
      g.drawImage(this.image, 0, 0, null);
    }
  }

  public static void main(String args[]) {
    BugImageFormat frameCanvas = new BugImageFormat(args.length != 0);

    if( null != frameCanvas ) {
      Frame theFrame = new Frame();
      if( null != theFrame ) {
	theFrame.add(frameCanvas);
	theFrame.pack();
	theFrame.validate();
	theFrame.setVisible(true);

	frameCanvas.setupFrame(theFrame);
	frameCanvas.initImage();
      }
    }
  }
    
}
