/*
 * @(#)FontTestApplet.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)AffineAccuracy.java	1.1 97/10/20
 * 
 * Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */
import java.lang.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.applet.*;

abstract class AppletProto extends Applet implements Runnable {
  Thread              theThread;
  Graphics2D          theScreen;
  private boolean     theActivityStatus;

  public void start() {
    if (this.theThread == null) {
      this.theThread = new Thread(this);
      if( null != this.theThread ) {
	this.theThread.setPriority(Thread.MAX_PRIORITY);
	this.theThread.start();
	this.theActivityStatus = true;
      } else {
	debugReport("Thread initialization problem");
      } 
    }
  }

  public void stop() {
    if (this.theThread != null) {
      this.theThread.stop();
      this.theThread = null;
      this.theActivityStatus = false;
    }
  }

  public void run() {
    privateStartup();
    if( true == setupInternalData() ) {
      runApplet();
      cleanupInternalData();
    } else {
      debugReport("Error in initialization!");
    }
    privateCleanup();
  }

  private void privateStartup(){
    this.theScreen = (Graphics2D)getGraphics();
  }
  private void privateCleanup(){
    this.theScreen = null;
  }

  public boolean isActive() {
    return this.theActivityStatus;
  }

  public void debugReport(String reportLine){
    System.out.println(">>> "+reportLine);
  }

  abstract boolean setupInternalData();
  abstract public void cleanupInternalData();
  abstract public void runApplet();
  
}

public class FontTestApplet extends AppletProto {
  Frame               testFrame;
  TestCanvas          testCanvas;
  public boolean setupInternalData(){
    boolean           retCode = false;
    if( null != (this.testFrame = new Frame()) ) {
      if( null != (this.testCanvas = new TestCanvas()) ) {
	if( true == this.testCanvas.init() ) {
	  this.testFrame.setSize(300,100);
	  this.testFrame.add(this.testCanvas);
	  this.testFrame.pack();
	  this.testFrame.validate();
	  this.testFrame.setVisible(true);
	  retCode = true;
	}
      }
    }
    return retCode;
  }
  public void cleanupInternalData() {
  }
  public void runApplet() {
  }
}


class TestCanvas extends Canvas {
  Font   theFont;
    public boolean init() {
      setSize(300, 80);
      setBackground(Color.cyan);
      setVisible(true);
      setEnabled(true);

      if( null != (this.theFont = new Font("TimesRoman",Font.PLAIN,10)) ) {
	return true;
      }
      return false;
    }
    
     public void paint(Graphics g) {
	g.drawString("\u00df\u3041\u3042\u00df\u3041\u3042\u00df\u3041abc\u3042\u00dfabc", 5, 15);
    }
    
}

