/*
 * @(#)Lines.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)AffineAccuracy.java	1.1 97/10/20
 * 
 * Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */
import java.lang.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.applet.*;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;



abstract class AppletProto extends Applet implements Runnable {
  Thread              theThread;
  Graphics2D          theScreen;
  private boolean     theActivityStatus;
  private boolean     isInitialized;

  public void start() {
    if (this.theThread == null) {
      this.theThread = new Thread(this);
      if( null != this.theThread ) {
	this.theThread.setPriority(Thread.MAX_PRIORITY);
	this.theThread.start();
	this.theActivityStatus = true;
	this.isInitialized = false;
      } else {
	debugReport("Thread initialization problem");
      } 
    }
  }

  public void stop() {
    if (this.theThread != null) {
      this.theThread.stop();
      this.theThread = null;
      this.theActivityStatus = false;
      this.isInitialized = false;
    }
  }

  public void run() {

    if( false == this.isInitialized ) {
      privateStartup();
      this.isInitialized = setupInternalData(); 
    }
    if( true == this.isInitialized ) {
      runApplet();
      cleanupInternalData();
    } else {
      debugReport("Error in initialization!");
    }
    privateCleanup();
  }

  private void privateStartup(){
    this.theScreen = (Graphics2D)getGraphics();
  }
  private void privateCleanup(){
    this.theScreen = null;
  }

  public boolean isActive() {
    return this.theActivityStatus;
  }

  public void debugReport(String reportLine){
    System.out.println(">>> "+reportLine);
  }

  abstract boolean setupInternalData();
  abstract public void cleanupInternalData();
  abstract public void runApplet();
  
}

public class Lines extends AppletProto {
  LineFrame   theArena;
  public boolean setupInternalData(){
    boolean retCode = false;

    if( null != (this.theArena = new LineFrame()) ) {
      if( true == this.theArena.init() ) {
	retCode = true;
      }
    }
    return retCode;
  }
  public void cleanupInternalData() {
  }
  public void runApplet() {
    //    while(isActive()) { 
    //     System.out.println("I am OK!!!");
    //    }
  }

  public void paint(Graphics givenContext) {
    if( null != givenContext ) {
      Color  tmpC = givenContext.getColor();
      Font   tmpF = givenContext.getFont();
      givenContext.setColor(Color.white);
      givenContext.fillRect(0,0,size().width,size().height);
      givenContext.setColor(tmpC);
      givenContext.setFont(new Font("Serif",Font.BOLD,12));
      //      givenContext.drawString("DRAW LINES",50,15);
      //      givenContext.drawString("This applet is dedicated to provide",10,35);
      //      givenContext.drawString("development and test environment",10,65);
      //      givenContext.drawString("for uniform wide lines",10,95);
      givenContext.setFont(tmpF);
    }
  }

  public static void main(String argv[]) {
    Frame appletFrame = new Frame();
    final Lines applet = new Lines();
    appletFrame.add(applet);
    appletFrame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {System.exit(0);}
      public void windowIconified(WindowEvent e) {applet.stop();}
      public void windowDeiconified(WindowEvent e) {applet.start();}
    });
    appletFrame.setSize(250,150);
    applet.init();
    appletFrame.show();
    applet.start();
  }

}

class LineFrame extends Frame {
  LineCanvas   theCanvas;

  public boolean init() {
    boolean retCode = false;

    if( null != (this.theCanvas = new LineCanvas()) ) {
      if( true == this.theCanvas.init() ) {
	add(this.theCanvas);
	pack();
	show();
	retCode = true;
      }
    }
    return retCode;
  }
  
}


class LineCanvas extends Canvas {
  BasicStroke   theWideStroke;

  public boolean init() {
    boolean   retCode = true;

    if( null != (this.theWideStroke = new BasicStroke((float)5)) ) {
      retCode = true;
    }
    return retCode;
  }

    public void paint(Graphics givenGraphics) {
      Graphics2D    theContext = (Graphics2D)givenGraphics;
      theContext.clearRect(0,0,size().width,size().height);
      //      theContext.setStroke(this.theWideStroke);
      theContext.drawLine(10,10,10,100);
      theContext.drawLine(10,10,100,10);
      theContext.drawLine(10,10,100,100);
      theContext.drawLine(10,10,100,50);
      theContext.drawLine(10,10,50,100);
  }

  public Dimension getPreferredSize() {
    return new Dimension(200,200);
  }
}
