/*
 * @(#)IntersectTest.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)AffineAccuracy.java	1.1 97/10/20
 * 
 * Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */
import java.lang.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.applet.*;
import java.awt.font.*;




public class IntersectTest extends Frame {

  public IntersectTest() {
    setTitle("Intersect Test");
    setSize(400, 400);
    add(new IntersectTestCanvas(), "North");
    show();
    getComponent(0).requestFocus();
  }
  
  public static void main(String argv[]) {
    IntersectTest test = new IntersectTest();
  }
}

class IntersectTestCanvas extends Canvas {
  Rectangle r1,r2;
  GeneralPath	p1,p2;
  
  IntersectTestCanvas() {
    super();
    setSize(300, 300);
    setBackground(Color.black);
    setVisible(true);
    setEnabled(true);
    
    preparePath();
  }
  
  public void paint(Graphics g) {
    Graphics2D  g2 = (Graphics2D)g;

    g2.setColor(new Color(0xFF,0x00,0x00));   
    g2.drawRect(r1.x,r1.y,r1.width,r1.height);
    g2.setColor(new Color(0x00,0x00,0xFF));   
    g2.draw(p1);
    
    g2.setColor(new Color(0x00,0xFF,0x00));
    g2.drawRect(r2.x,r2.y,r2.width,r2.height);
    g2.setColor(new Color(0xFF,0xFF,0x00));
    g2.draw(p2);
    
    
  }
  
  void preparePath(){
    r1 = new Rectangle(10,10,20,20);
    r2 = new Rectangle(20,20,20,20);
    
    p1 = new GeneralPath();
    p1.moveTo(5,15);
    p1.lineTo(35,15);
    p1.lineTo(35,35);
    p1.lineTo(5,35);
    p1.closePath();
    
    p2 = new GeneralPath();
    p2.moveTo(5,15);
    //    p2.moveTo(35,15);
    //    p2.moveTo(35,35);
    p2.lineTo(35,15);
    p2.lineTo(35,35);
    p2.quadTo(5,35,10,40);
    p2.closePath();
    
    // these should all be true
    System.out.println("p1 - r1: "+p1.intersects(r1)); // true
    System.out.println("p1 - r2: "+p1.intersects(r2)); // true
    System.out.println("p2 - r1: "+p2.intersects(r1)); // false (WRONG)
    System.out.println("p2 - r2: "+p2.intersects(r2)); // true
    
  }
  
}


