/*
 * @(#)Test4140011.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;

class Test4140011 extends Frame {
  Scrollbar   vertBar = new Scrollbar(Scrollbar.VERTICAL);
  Scrollbar   horzBar = new Scrollbar(Scrollbar.HORIZONTAL);

  Pane        pane    = new Pane(vertBar,horzBar);


  Test4140011() {
    super("Bug # 4140011 Regression Test");

    add("Center",this.pane);
    add("East",this.vertBar);
    add("South",this.horzBar);

    resize(200,200);

    show();
  }

  public boolean handleEvent(Event givenEvent) {
    if( (givenEvent.target == this.vertBar) || (givenEvent.target == this.horzBar) ) {
      this.pane.sbChanged();
      return true;
    }
    return super.handleEvent(givenEvent);
  }

  static public void main(String[] args) {
    new Test4140011();
  }

}

class Pane extends Canvas {
  int          paneSize  = 1500;
  int          paneCells = 10;
  int          cellSize  = paneSize / paneCells;

  int          originX,originY;

  Scrollbar    vertBar,horzBar;

  Pane(Scrollbar givenVertBar,Scrollbar givenHorzBar) {
    this.vertBar = givenVertBar;
    this.horzBar = givenHorzBar;

    setFont(new Font("Courier", Font.BOLD,36));
  }

  public void sbChanged() {
    this.originY = - this.vertBar.getValue();
    this.originX = - this.horzBar.getValue();
    invalidate();
    repaint();
  }

  public void layout() {
    super.layout();

    int w = size().width;
    int h = size().height;

    this.vertBar.setValues(this.vertBar.getValue(),h,this.vertBar.getMinimum(),this.paneSize);
    this.vertBar.setPageIncrement(Math.min(this.cellSize,h));
    this.vertBar.setLineIncrement(Math.min(this.cellSize,h/5));
    this.horzBar.setValues(this.horzBar.getValue(),w,this.horzBar.getMinimum(),this.paneSize);
    this.horzBar.setPageIncrement(Math.min(this.cellSize,w));
    this.horzBar.setLineIncrement(Math.min(this.cellSize,w/5));

    this.originX = -Math.max(0,Math.min(this.paneSize - w, this.horzBar.getValue()));
    this.originY = -Math.max(0,Math.min(this.paneSize - h, this.vertBar.getValue()));
  }

  public void paint(Graphics givenContext) {
    FontMetrics      metrics = givenContext.getFontMetrics();

    givenContext.translate(this.originX,this.originY);
    givenContext.setColor(Color.red);

    for( int i = 0; i < this.paneCells; i++ ) {
      int   c = i * this.cellSize;

      givenContext.drawLine(c,0,c,this.paneSize);
      givenContext.drawLine(0,c,this.paneSize,c);
    }
    givenContext.drawRect(0,0,this.paneSize - 1,this.paneSize - 1);

    for( int i = 0; i < this.paneSize; i ++ ) {
      for( int j = 0; j < this.paneCells; j++ ) {
	String str = "" + i + "," + j;

	int x = i * this.cellSize;
	int y = j * this.cellSize;

	givenContext.drawString(str, x + (this.cellSize - metrics.stringWidth(str))/2, 
				y + (this.cellSize - metrics.getHeight())/2 + metrics.getAscent());
      }
    }
  }

}
