/*
 * @(#)Test4152512.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;
import java.awt.geom.AffineTransform;
//import J2DCanvas;


/**
 * Simple 45 degree rotate of a rectangle.
 */
public class Test4152512 extends Canvas {

    int w,h;
    Font  font = new Font("Times New Roman",Font.PLAIN,12);

    public Test4152512() {
	setBackground(Color.white);
    }


    public void drawDemo(Graphics2D g2) {

	Rectangle2D r = new Rectangle2D.Float(0,0,w/3,h/5);

	AffineTransform at = new AffineTransform();
	at.translate(w/3, h/3);
	g2.transform(at);

	g2.setColor(Color.black);
// --
//	new TextLayout("Simple 45% Rotate", g2.getFont(), g2.getFontRenderContext()).draw(g2, 0, -14);
        g2.drawString("Simple 45% Rotate",0,-14);
// --
        g2.setColor(Color.cyan);
	g2.fill(r);

	at = new AffineTransform();
	at.rotate((45*java.lang.Math.PI)/180); // radians=degree * pie / 180
	g2.transform(at);
	g2.setColor(Color.black);
	g2.draw(r);
// --
        g2.drawString("Simple 45% Rotate",0,-14);
// --
	g2.setTransform(new AffineTransform());
    }

    public void paint(Graphics g) {
        Dimension dim = getSize();
        w = dim.width;
        h = dim.height;

        BufferedImage offImg = new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);

        Graphics2D g2 = offImg.createGraphics();

        g2.setBackground(getBackground());

        g2.setFont(font);

        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                            RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(RenderingHints.KEY_RENDERING,
                            RenderingHints.VALUE_RENDER_QUALITY);

        g2.clearRect(0,0,w,h);

        drawDemo(g2);

        g2.dispose();

        g.drawImage(offImg,0,0,this);
    }


    public static void main(String s[]) {
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	};
	Frame f = new Frame("Java2D Demo - Rotate");
        Test4152512 t = new Test4152512();
        t.setSize(new Dimension(400,300));

	f.addWindowListener(l);
	f.add("Center", t);
	f.pack();
//	f.setSize(new Dimension(400,300));
	f.show();
    }
}
