/*
 * @(#)Test4157044.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.awt.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.text.*;


public class Test4157044 extends Canvas {

  static String   toDraw;
  static String   familyName;
  static int      method;
  static int      start,end;

    public Test4157044() {
        setBackground(Color.white);
    }

  public Font findSuitableFontSize(Graphics2D g2,Font font,String str,int w,int h) {
    Rectangle         rect = null;
    FontRenderContext frc  = g2.getFontRenderContext();   

    for (float i = font.getSize(); i < 200; i+=2) {
      font = font.deriveFont(i);
      rect = (Rectangle)font.getStringBounds(str,frc);

      if (rect.getHeight() >= h || rect.getWidth() >= w) {
	font = font.deriveFont(i-2);
	break;
      }
    }
    
    return font;
  }

  public void drawString(Graphics2D g2,Font font,String str) {
    Rectangle         rect = null;
    FontRenderContext frc  = g2.getFontRenderContext();

    rect = (Rectangle)font.getStringBounds(str,frc);

    g2.setFont(font);

    g2.setColor(Color.black);
    g2.drawString(str, 0, (int)rect.getHeight());

    g2.setColor(new Color(0x04,0x00,0xAA));
    g2.drawRect((int)(rect.getX()),(int)(rect.getY()),(int)(rect.getWidth()),(int)(rect.getHeight()));
  }

  public void drawSubString(Graphics2D g2,Font font,String str,int start,int end) {
    Rectangle         rect = null;
    FontRenderContext frc  = g2.getFontRenderContext();

    rect = (Rectangle)font.getStringBounds(str,start,end - start,frc);

    g2.setFont(font);

    g2.setColor(Color.black);
    g2.drawString(str.substring(start,end), 0, (int)rect.getHeight());

    g2.setColor(new Color(0x04,0x00,0xAA));
    g2.drawRect((int)(rect.getX()),(int)(rect.getY()),(int)(rect.getWidth()),(int)(rect.getHeight()));
  }
  public void drawIterator(Graphics2D g2,Font font,String str,int start,int end) {
    Rectangle         rect = null;
    FontRenderContext frc  = g2.getFontRenderContext();
    AttributedString  as   = new AttributedString(str);
    CharacterIterator itr  = as.getIterator();

    rect = (Rectangle)font.getStringBounds(itr,start,end - start,frc);

    g2.setFont(font);

    g2.setColor(Color.black);
    g2.drawString(str.substring(start,end), 0, (int)rect.getHeight());

    g2.setColor(new Color(0x04,0x00,0xAA));
    g2.drawRect((int)(rect.getX()),(int)(rect.getY()),(int)(rect.getWidth()),(int)(rect.getHeight()));
  }

    public void paint(Graphics g) {
        int           w          = getSize().width;
        int           h          = getSize().height;
	Font          font       = new Font(familyName,Font.PLAIN,12);
	String        actualLine = toDraw.substring(start,end);
	Graphics2D    g2         = (Graphics2D)g;

	font = findSuitableFontSize(g2,font,actualLine,w,h);

	switch( method ) {
	case 1:
	  drawString(g2,font,actualLine);
	  break;
	case 2:
	  drawSubString(g2,font,toDraw,start,end);
	  break;
	case 3:
	  drawIterator(g2,font,toDraw,start,end);
	  break;
	}
    }

    public static void main(String s[]) {

      if( 5 > s.length ) {
	
      }

      toDraw     = s[0];
      familyName = s[1];
      method     = Integer.parseInt(s[2],10);
      start      = Integer.parseInt(s[3],10);
      end        = Integer.parseInt(s[4],10);

      Frame f = new Frame("Java 2D Demo - test7");
      f.add("Center", new Test4157044());
      f.pack();
      f.setSize(new Dimension(400,400));
      f.show();
    }
}
