/*
 * @(#)ShapeAccuracy.java	1.2 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Shape;

import java.awt.image.BufferedImage;


import java.applet.Applet;
import java.awt.Canvas;
import java.awt.Panel;
import java.awt.Event;
import java.lang.Math;

import java.awt.geom.AffineTransform;


public class AffineAccuracy extends Applet implements Runnable
{
    private static int DRAWSIZE = 300;


    Thread myThread;

    private void ReportHeader() {
        System.out.println(">=================================================");
        System.out.println("SEQUENCE STARTED");
        System.out.println(">=================================================");
    }

    private void ReportFooter() {
        System.out.println(">=================================================");
        System.out.println("SEQUENCE FINISHED");
        System.out.println(">=================================================");
    }

    private void PerformTest(Graphics g,TestObject testObject) {
        boolean ok = true;

        System.out.println(">=================================================");

        try
        {
            System.out.println(testObject.getDescription());
		    testObject.performTest();
        } catch (Exception e)   {
                                    String msg = e.getMessage();
                                    e.printStackTrace();
                                    ok = false;
                                } finally   {
                                                if( true == ok )
                                                {
                                                    System.out.println("passed");
                                                } else  {
                                                            System.out.println("failed");
                                                        }
                                            }
        System.out.println(">=================================================");
    }

    private void DoTests(Graphics g) {
        ReportHeader();

//        PerformTest(g,new TestRotate());
/*
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,1,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,5,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,10,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,15,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,20,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,90,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,180,false));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,360,false));

        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,1,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,5,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,10,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,15,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,20,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,90,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,180,false));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,360,false));

        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,1,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,5,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,10,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,15,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,20,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,90,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,180,false));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,360,false));

        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,1,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,5,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,10,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,15,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,20,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,90,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,180,true));
        PerformTest(g,new TestVectorRotate(g,DRAWSIZE,360,true));

        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,1,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,5,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,10,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,15,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,20,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,90,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,180,true));
        PerformTest(g,new TestDiagonalGridRotate(g,DRAWSIZE,360,true));

        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,1,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,5,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,10,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,15,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,20,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,90,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,180,true));
        PerformTest(g,new TestNormalGridRotate(g,DRAWSIZE,360,true));
*/



        PerformTest(g,new TestHorizontalShear(g,DRAWSIZE,0.07,true));
        PerformTest(g,new TestHorizontalShear(g,DRAWSIZE,-0.07,true));
        PerformTest(g,new TestHorizontalGridShear(g,DRAWSIZE,0.07,true));
        PerformTest(g,new TestHorizontalGridShear(g,DRAWSIZE,-0.07,true));
        PerformTest(g,new TestVerticalShear(g,DRAWSIZE,0.07,true));
        PerformTest(g,new TestVerticalShear(g,DRAWSIZE,-0.07,true));
        PerformTest(g,new TestVerticalGridShear(g,DRAWSIZE,0.07,true));
        PerformTest(g,new TestVerticalGridShear(g,DRAWSIZE,-0.07,true));
        PerformTest(g,new TestSymmetricShear(g,DRAWSIZE,0.07,true));
        PerformTest(g,new TestSymmetricShear(g,DRAWSIZE,-0.07,true));
        PerformTest(g,new TestSymmetricGridShear(g,DRAWSIZE,0.07,true));
        PerformTest(g,new TestSymmetricGridShear(g,DRAWSIZE,-0.07,true));

        PerformTest(g,new TestHorizontalShear(g,DRAWSIZE,0.07,false));
        PerformTest(g,new TestHorizontalShear(g,DRAWSIZE,-0.07,false));
        PerformTest(g,new TestHorizontalGridShear(g,DRAWSIZE,0.07,false));
        PerformTest(g,new TestHorizontalGridShear(g,DRAWSIZE,-0.07,false));
        PerformTest(g,new TestVerticalShear(g,DRAWSIZE,0.07,false));
        PerformTest(g,new TestVerticalShear(g,DRAWSIZE,-0.07,false));
        PerformTest(g,new TestVerticalGridShear(g,DRAWSIZE,0.07,false));
        PerformTest(g,new TestVerticalGridShear(g,DRAWSIZE,-0.07,false));
        PerformTest(g,new TestSymmetricShear(g,DRAWSIZE,0.07,false));
        PerformTest(g,new TestSymmetricShear(g,DRAWSIZE,-0.07,false));
        PerformTest(g,new TestSymmetricGridShear(g,DRAWSIZE,0.07,false));
        PerformTest(g,new TestSymmetricGridShear(g,DRAWSIZE,-0.07,false));

/*
        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.95,false));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.95,false));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.95,false));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.95,false));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.95,false));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.95,false));

        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.75,false));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.75,false));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.75,false));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.75,false));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.75,false));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.75,false));


        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.5,false));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.5,false));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.5,false));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.5,false));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.5,false));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.5,false));

        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.25,false));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.25,false));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.25,false));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.25,false));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.25,false));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.25,false));


        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.95,true));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.95,true));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.95,true));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.95,true));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.95,true));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.95,true));

        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.75,true));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.75,true));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.75,true));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.75,true));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.75,true));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.75,true));


        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.5,true));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.5,true));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.5,true));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.5,true));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.5,true));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.5,true));

        PerformTest(g,new TestSymmetricScale(g,DRAWSIZE,0.25,true));
        PerformTest(g,new TestSymmetricScaleGrid(g,DRAWSIZE,0.25,true));
        PerformTest(g,new TestHorizontalScale(g,DRAWSIZE,0.25,true));
        PerformTest(g,new TestHorizontalScaleGrid(g,DRAWSIZE,0.25,true));
        PerformTest(g,new TestVerticalScale(g,DRAWSIZE,0.25,true));
        PerformTest(g,new TestVerticalScaleGrid(g,DRAWSIZE,0.25,true));
*/

        ReportFooter();
 }



    public void start() {
        if (myThread == null) {
            myThread = new Thread(this);
        }
	myThread.setPriority(Thread.MAX_PRIORITY);
        myThread.start();
    }

    public void stop() {
        if (myThread != null) {
            myThread.stop();
            myThread = null;
        }
    }

    public void run() {
		Graphics graphics = getGraphics();
        DoTests(graphics);
    }
}



abstract class TestObject
{

	Graphics		graphics;
	Rectangle		outputArea;
    AffineTransform theTransform;
    AffineTransform theReverseTransform;
    AffineTransform oldTransform;
    int             theLoopCount;
    int             loopNumber;

	Color			colorRed;
	Color			colorGreen;
	Color			colorBlue;
	Color			colorBlack;
	Color			colorWhite;

	Color			savedColor;
	Color			colorYellow;
//------------- begin group
//  Initializes internal structure
	public void init(Graphics givenGraphics,int drawSize,int loops)
	{
		outputArea		            = new Rectangle(0,0,drawSize,drawSize);

        if( 0 != (loops % 2) ) {
            loops += 1;
        }

		graphics		= givenGraphics;
        theLoopCount    = loops;
        loopNumber      = 0;

		colorRed		= new Color(0xFF,0x00,0x00);
		colorGreen		= new Color(0x00,0xFF,0x00);
		colorBlue		= new Color(0x00,0x00,0xFF);
		colorWhite		= new Color(0xFF,0xFF,0xFF);
		colorBlack		= new Color(0x00,0x00,0x00);

        colorYellow     = new Color(0xFF,0xFF,0x00);

        oldTransform    = ((Graphics2D)givenGraphics).getTransform();

        drawBar(givenGraphics,0,0,drawSize,drawSize+30,colorWhite);
        typeLine(givenGraphics,0,drawSize+20,getDescription(),colorBlack);
	}
    public void free() {
        getScreen().setTransform(oldTransform);
        drawBar(getScreen(),0,0,outputArea.width,outputArea.height,colorWhite);
    }
//------------- end group

    public void waitLoop(int delay)
    {
        long    start = System.currentTimeMillis();

        while( System.currentTimeMillis() - start < delay)
        {
        }
    }

//------------- begin group
//  Draw primitives
    void drawVector(Graphics g,int x0,int y0,int x1,int y1,Color c)
    {
		savedColor = g.getColor();

		g.setColor(c);

        g.drawLine(x0,y0,x1,y1);

		g.setColor(savedColor);
    }
	void drawBar(Graphics g,int x,int y,int h, int v,Color c)
	{
		savedColor = g.getColor();

		g.setColor(c);

		g.fillRect(x,y,h,v);

		g.setColor(savedColor);
	}
	void drawRect(Graphics g,int x,int y,int h, int v,Color c)
	{
		savedColor = g.getColor();

		g.setColor(c);

		g.drawRect(x,y,h,v);

		g.setColor(savedColor);
	}
	void drawRing(Graphics g,int x,int y,int h, int v,Color c)
	{
		savedColor = g.getColor();

		g.setColor(c);

		g.drawOval(x,y,h,v);

		g.setColor(savedColor);
	}
	void drawGrid(Graphics g,int x,int y,int h, int v,int d,Color c)
	{
		savedColor = g.getColor();

		g.setColor(c);

		{
			int		i;

			for(i=y;i<y+v;i+=d)
			{
				g.drawLine(x,i,x+h,i);
			}
			for(i=x;i<x+v;i+=d)
			{
				g.drawLine(i,y,i,y+v);
			}
		}


		g.setColor(savedColor);
	}
	void typeLine(Graphics g,int x,int y,String s,Color c)
	{

        drawBar(g,x,y - 10,150,15,colorWhite);

		savedColor = g.getColor();

		g.setColor(c);


        g.drawString(s,x,y);

		g.setColor(savedColor);
	}
//------------- end group

    abstract void createTransforms();

    abstract void setTransform();

    Graphics2D getScreen() {
        return (Graphics2D)graphics;
    }

    abstract void testAct();
    abstract String getDescription();

    void performTest(){

        loopNumber = 0;
        while( loopNumber < theLoopCount ) {

            testAct();

            loopNumber ++;
        }


        free();
    }
    boolean isLastPass(){
        return (boolean)(loopNumber == theLoopCount-1);
    }
}

class TestVectorRotate extends TestObject {
    int         rotDegree;
    boolean     eraseFactor;
    public TestVectorRotate(Graphics givenGraphics,int sizeFactor,int givenDegree,boolean erase) {
        super.init(givenGraphics,sizeFactor,2*365/givenDegree);
        rotDegree = givenDegree;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);
        drawVector(givenGraphics,92,92,100,100,colorRed);
        drawVector(givenGraphics,-92,-92,-100,-100,colorRed);
        drawVector(givenGraphics,92,-92,100,-100,colorRed);
        drawVector(givenGraphics,-92,92,-100,100,colorRed);

        drawVector(givenGraphics,0,127,0,140,colorRed);
        drawVector(givenGraphics,0,-127,0,-140,colorRed);

        drawVector(givenGraphics,127,0,140,0,colorRed);
        drawVector(givenGraphics,-127,0,-140,0,colorRed);
    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawVector(getScreen(),0,0,80,80,colorBlack);
        drawVector(getScreen(),82,82,85,85,colorBlack);

        waitLoop(100);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),0,0,80,80,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.rotate((this.rotDegree*java.lang.Math.PI)/180); // radians=degree * pie / 180
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.rotate((-1*this.rotDegree*java.lang.Math.PI)/180); // radians=degree * pie / 180
    }

    String getDescription(){
        return "Vector rotate";
    }

}
class TestDiagonalGridRotate extends TestObject {
    int         rotDegree;
    boolean     eraseFactor;
    public TestDiagonalGridRotate(Graphics givenGraphics,int sizeFactor,int givenDegree,boolean erase) {
        super.init(givenGraphics,sizeFactor,2*365/givenDegree);
        rotDegree = givenDegree;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);
        drawVector(givenGraphics,92,92,100,100,colorRed);
        drawVector(givenGraphics,-92,-92,-100,-100,colorRed);
        drawVector(givenGraphics,92,-92,100,-100,colorRed);
        drawVector(givenGraphics,-92,92,-100,100,colorRed);

        drawVector(givenGraphics,0,127,0,140,colorRed);
        drawVector(givenGraphics,0,-127,0,-140,colorRed);

        drawVector(givenGraphics,127,0,140,0,colorRed);
        drawVector(givenGraphics,-127,0,-140,0,colorRed);
    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawGrid(getScreen(),0,1,80,81,8,colorBlack);

        drawVector(getScreen(),82,82,85,85,colorBlack);

        waitLoop(100);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),0,1,80,81,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.rotate((this.rotDegree*java.lang.Math.PI)/180); // radians=degree * pie / 180
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.rotate((-1*this.rotDegree*java.lang.Math.PI)/180); // radians=degree * pie / 180
    }

    String getDescription(){
        return "Diagonal grid rotate";
    }

}


class TestNormalGridRotate extends TestObject {
    int         rotDegree;
    boolean     eraseFactor;
    public TestNormalGridRotate(Graphics givenGraphics,int sizeFactor,int givenDegree,boolean erase) {
        super.init(givenGraphics,sizeFactor,2*365/givenDegree);
        rotDegree = givenDegree;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);
        drawVector(givenGraphics,92,92,100,100,colorRed);
        drawVector(givenGraphics,-92,-92,-100,-100,colorRed);
        drawVector(givenGraphics,92,-92,100,-100,colorRed);
        drawVector(givenGraphics,-92,92,-100,100,colorRed);

        drawVector(givenGraphics,0,127,0,140,colorRed);
        drawVector(givenGraphics,0,-127,0,-140,colorRed);

        drawVector(givenGraphics,127,0,140,0,colorRed);
        drawVector(givenGraphics,-127,0,-140,0,colorRed);
    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawGrid(getScreen(),-80,-81,160,162,8,colorBlack);

        drawVector(getScreen(),82,82,85,85,colorBlack);

        waitLoop(100);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-80,-81,160,162,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.rotate((this.rotDegree*java.lang.Math.PI)/180); // radians=degree * pie / 180
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.rotate((-1*this.rotDegree*java.lang.Math.PI)/180); // radians=degree * pie / 180
    }

    String getDescription(){
        return "Normal grid rotate";
    }

}

class TestHorizontalShear extends TestObject {
    double      shiftFactor;
    boolean     eraseFactor;
    public TestHorizontalShear(Graphics givenGraphics,int sizeFactor,double givenShift,boolean erase) {
        double     shift = givenShift;

        if( shift < 0 ) {
            shift = -1*givenShift;
        }

        super.init(givenGraphics,sizeFactor,(int)(3/shift));
        shiftFactor = givenShift;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawVector(getScreen(),-80,0,80,0,colorBlack);
        drawVector(getScreen(),0,-80,0,80,colorBlack);

        drawVector(getScreen(),0,-82,0,-87,colorBlack);
        drawVector(getScreen(),0,82,0,87,colorBlack);


        waitLoop(200);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),0,-80,0,80,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.shear(shiftFactor,0);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.shear(-1*shiftFactor,0);
    }

    String getDescription(){
        return "Horizontal shear";
    }

}

class TestHorizontalGridShear extends TestObject {
    double      shiftFactor;
    boolean     eraseFactor;
    public TestHorizontalGridShear(Graphics givenGraphics,int sizeFactor,double givenShift,boolean erase) {
        double     shift = givenShift;

        if( shift < 0 ) {
            shift = -1*givenShift;
        }

        super.init(givenGraphics,sizeFactor,(int)(3/shift));
        shiftFactor = givenShift;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawGrid(getScreen(),-80,-80,161,161,8,colorBlack);


        drawVector(getScreen(),0,-82,0,-87,colorBlack);
        drawVector(getScreen(),0,82,0,87,colorBlack);


        waitLoop(200);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-80,-80,161,161,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.shear(shiftFactor,0);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.shear(-1*shiftFactor,0);
    }

    String getDescription(){
        return "Horizontal grid shear";
    }

}

class TestVerticalShear extends TestObject {
    double      shiftFactor;
    boolean     eraseFactor;
    public TestVerticalShear(Graphics givenGraphics,int sizeFactor,double givenShift,boolean erase) {
        double     shift = givenShift;

        if( shift < 0 ) {
            shift = -1*givenShift;
        }

        super.init(givenGraphics,sizeFactor,(int)(3/shift));
        shiftFactor = givenShift;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawVector(getScreen(),-80,0,80,0,colorBlack);
        drawVector(getScreen(),0,-80,0,80,colorBlack);

        drawVector(getScreen(),-82,0,-87,0,colorBlack);
        drawVector(getScreen(),82,0,87,0,colorBlack);


        waitLoop(200);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),-80,0,80,0,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.shear(0,shiftFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.shear(0,-1*shiftFactor);
    }

    String getDescription(){
        return "Vertical shear";
    }

}

class TestVerticalGridShear extends TestObject {
    double      shiftFactor;
    boolean     eraseFactor;
    public TestVerticalGridShear(Graphics givenGraphics,int sizeFactor,double givenShift,boolean erase) {
        double     shift = givenShift;

        if( shift < 0 ) {
            shift = -1*givenShift;
        }

        super.init(givenGraphics,sizeFactor,(int)(3/shift));
        shiftFactor = givenShift;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawGrid(getScreen(),-80,-80,161,161,8,colorBlack);

        drawVector(getScreen(),-82,0,-87,0,colorBlack);
        drawVector(getScreen(),82,0,87,0,colorBlack);


        waitLoop(200);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-80,-80,161,161,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.shear(0,shiftFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.shear(0,-1*shiftFactor);
    }

    String getDescription(){
        return "Vertical grid shear";
    }

}

class TestSymmetricShear extends TestObject {
    double      shiftFactor;
    boolean     eraseFactor;
    public TestSymmetricShear(Graphics givenGraphics,int sizeFactor,double givenShift,boolean erase) {
        double     shift = givenShift;

        if( shift < 0 ) {
            shift = -1*givenShift;
        }

        super.init(givenGraphics,sizeFactor,(int)(2/shift));
        shiftFactor = givenShift;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawVector(getScreen(),-70,0,70,0,colorBlack);
        drawVector(getScreen(),0,-70,0,70,colorBlack);

        drawVector(getScreen(),-72,0,-77,0,colorBlack);
        drawVector(getScreen(),72,0,77,0,colorBlack);

        drawVector(getScreen(),0,-72,0,-77,colorBlack);
        drawVector(getScreen(),0,72,0,77,colorBlack);


        waitLoop(200);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),-70,0,70,0,colorWhite);
            drawVector(getScreen(),0,-70,0,70,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.shear(shiftFactor,shiftFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.shear(-1*shiftFactor,-1*shiftFactor);
    }

    String getDescription(){
        return "Symmetric shear";
    }

}

class TestSymmetricGridShear extends TestObject {
    double      shiftFactor;
    boolean     eraseFactor;
    public TestSymmetricGridShear(Graphics givenGraphics,int sizeFactor,double givenShift,boolean erase) {
        double     shift = givenShift;

        if( shift < 0 ) {
            shift = -1*givenShift;
        }

        super.init(givenGraphics,sizeFactor,(int)(2/shift));
        shiftFactor = givenShift;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){


        drawGrid(getScreen(),-71,-71,140,140,6,colorBlack);

        drawVector(getScreen(),-72,0,-77,0,colorBlack);
        drawVector(getScreen(),72,0,77,0,colorBlack);

        drawVector(getScreen(),0,-72,0,-77,colorBlack);
        drawVector(getScreen(),0,72,0,77,colorBlack);


        waitLoop(200);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-71,-71,140,140,6,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.shear(shiftFactor,shiftFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.shear(-1*shiftFactor,-1*shiftFactor);
    }

    String getDescription(){
        return "Symmetric grid shear";
    }

}



class TestSymmetricScale extends TestObject {
    double      scaleFactor;
    boolean     eraseFactor;
    public TestSymmetricScale(Graphics givenGraphics,int sizeFactor,double givenScale,boolean erase) {
        double     scale = givenScale;

        if( scale < 0 ) {
            scale = -1*givenScale;
        }

        super.init(givenGraphics,sizeFactor,(int)(2/(1-scale)));

        scaleFactor = givenScale;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
            getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawVector(getScreen(),-80,0,80,0,colorBlack);
        drawVector(getScreen(),0,-80,0,80,colorBlack);

        drawVector(getScreen(),-3,-85,3,-85,colorBlack);
        drawVector(getScreen(),-3,85,3,85,colorBlack);
        drawVector(getScreen(),-85,-3,-85,3,colorBlack);
        drawVector(getScreen(),85,-3,85,3,colorBlack);


        waitLoop(300);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),0,-80,0,80,colorWhite);
            drawVector(getScreen(),-80,0,80,0,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.scale(scaleFactor,scaleFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.scale(1/scaleFactor,1/scaleFactor);
    }

    String getDescription(){
        return "Symmetric scale";
    }

}

class TestHorizontalScale extends TestObject {
    double      scaleFactor;
    boolean     eraseFactor;
    public TestHorizontalScale(Graphics givenGraphics,int sizeFactor,double givenScale,boolean erase) {
        double     scale = givenScale;

        if( scale < 0 ) {
            scale = -1*givenScale;
        }

        super.init(givenGraphics,sizeFactor,(int)(2/(1-scale)));

        scaleFactor = givenScale;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
            getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawVector(getScreen(),-80,0,80,0,colorBlack);
        drawVector(getScreen(),0,-80,0,80,colorBlack);

        drawVector(getScreen(),-3,-85,3,-85,colorBlack);
        drawVector(getScreen(),-3,85,3,85,colorBlack);
        drawVector(getScreen(),-85,-3,-85,3,colorBlack);
        drawVector(getScreen(),85,-3,85,3,colorBlack);


        waitLoop(300);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),0,-80,0,80,colorWhite);
            drawVector(getScreen(),-80,0,80,0,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.scale(scaleFactor,1);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.scale(1/scaleFactor,1);
    }

    String getDescription(){
        return "Horizontal scale";
    }

}
class TestVerticalScale extends TestObject {
    double      scaleFactor;
    boolean     eraseFactor;
    public TestVerticalScale(Graphics givenGraphics,int sizeFactor,double givenScale,boolean erase) {
        double     scale = givenScale;

        if( scale < 0 ) {
            scale = -1*givenScale;
        }

        super.init(givenGraphics,sizeFactor,(int)(2/(1-scale)));

        scaleFactor = givenScale;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
            getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawVector(getScreen(),-80,0,80,0,colorBlack);
        drawVector(getScreen(),0,-80,0,80,colorBlack);

        drawVector(getScreen(),-3,-85,3,-85,colorBlack);
        drawVector(getScreen(),-3,85,3,85,colorBlack);
        drawVector(getScreen(),-85,-3,-85,3,colorBlack);
        drawVector(getScreen(),85,-3,85,3,colorBlack);


        waitLoop(300);

        if( eraseFactor && !isLastPass() ) {
            drawVector(getScreen(),0,-80,0,80,colorWhite);
            drawVector(getScreen(),-80,0,80,0,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.scale(1,scaleFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.scale(1,1/scaleFactor);
    }

    String getDescription(){
        return "Vertical scale";
    }

}

class TestSymmetricScaleGrid extends TestObject {
    double      scaleFactor;
    boolean     eraseFactor;
    public TestSymmetricScaleGrid(Graphics givenGraphics,int sizeFactor,double givenScale,boolean erase) {
        double     scale = givenScale;

        if( scale < 0 ) {
            scale = -1*givenScale;
        }


        super.init(givenGraphics,sizeFactor,(int)(2/(1-scale)));

        scaleFactor = givenScale;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawGrid(getScreen(),-80,-80,161,161,8,colorBlack);

        drawVector(getScreen(),-3,-85,3,-85,colorBlack);
        drawVector(getScreen(),-3,85,3,85,colorBlack);
        drawVector(getScreen(),-85,-3,-85,3,colorBlack);
        drawVector(getScreen(),85,-3,85,3,colorBlack);


        waitLoop(300);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-80,-80,161,161,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.scale(scaleFactor,scaleFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.scale(1/scaleFactor,1/scaleFactor);
    }

    String getDescription(){
        return "Symmetric scale grid";
    }

}
class TestHorizontalScaleGrid extends TestObject {
    double      scaleFactor;
    boolean     eraseFactor;
    public TestHorizontalScaleGrid(Graphics givenGraphics,int sizeFactor,double givenScale,boolean erase) {
        double     scale = givenScale;

        if( scale < 0 ) {
            scale = -1*givenScale;
        }


        super.init(givenGraphics,sizeFactor,(int)(2/(1-scale)));

        scaleFactor = givenScale;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawGrid(getScreen(),-80,-80,161,161,8,colorBlack);

        drawVector(getScreen(),-3,-85,3,-85,colorBlack);
        drawVector(getScreen(),-3,85,3,85,colorBlack);
        drawVector(getScreen(),-85,-3,-85,3,colorBlack);
        drawVector(getScreen(),85,-3,85,3,colorBlack);


        waitLoop(300);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-80,-80,161,161,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.scale(scaleFactor,1);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.scale(1/scaleFactor,1);
    }

    String getDescription(){
        return "Horizontal scale grid";
    }

}
class TestVerticalScaleGrid extends TestObject {
    double      scaleFactor;
    boolean     eraseFactor;
    public TestVerticalScaleGrid(Graphics givenGraphics,int sizeFactor,double givenScale,boolean erase) {
        double     scale = givenScale;

        if( scale < 0 ) {
            scale = -1*givenScale;
        }


        super.init(givenGraphics,sizeFactor,(int)(2/(1-scale)));

        scaleFactor = givenScale;
        eraseFactor = erase;
        createTransforms();
        givenGraphics.translate(sizeFactor/2,sizeFactor/2);

        drawVector(givenGraphics,-100,-100,-110,-100,colorRed);
        drawVector(givenGraphics,-100,-100,-100,-110,colorRed);
        drawVector(givenGraphics,100,-100,110,-100,colorRed);
        drawVector(givenGraphics,100,-100,100,-110,colorRed);

        drawVector(givenGraphics,-100,0,-110,0,colorRed);
        drawVector(givenGraphics,100,0,110,0,colorRed);
        drawVector(givenGraphics,0,-100,0,-110,colorRed);
        drawVector(givenGraphics,0,100,0,110,colorRed);

        drawVector(givenGraphics,-100,100,-110,100,colorRed);
        drawVector(givenGraphics,-100,100,-100,110,colorRed);
        drawVector(givenGraphics,100,100,110,100,colorRed);
        drawVector(givenGraphics,100,100,100,110,colorRed);

    }

    void setTransform() {
        if( loopNumber < theLoopCount/2 ) {
            getScreen().transform(theTransform);
        } else {
          getScreen().transform(theReverseTransform);
        }
    }

    public void testAct(){

        drawGrid(getScreen(),-80,-80,161,161,8,colorBlack);

        drawVector(getScreen(),-3,-85,3,-85,colorBlack);
        drawVector(getScreen(),-3,85,3,85,colorBlack);
        drawVector(getScreen(),-85,-3,-85,3,colorBlack);
        drawVector(getScreen(),85,-3,85,3,colorBlack);


        waitLoop(300);

        if( eraseFactor && !isLastPass() ) {
            drawGrid(getScreen(),-80,-80,161,161,8,colorWhite);
        }

        setTransform();
    }


    void createTransforms() {
        this.theTransform = new AffineTransform();
	    this.theTransform.scale(1,scaleFactor);
        this.theReverseTransform = new AffineTransform();
	    this.theReverseTransform.scale(1,1/scaleFactor);
    }

    String getDescription(){
        return "Vertical scale grid";
    }

}
