/*
 * @(#)lists.c	1.1 98/04/10
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * This file maintains the list of all Composite Sets and the list
 * of all Test Value sets for selection on the command line by name.
 */

#include "alphatest.h"

extern CompositeSet RefProxySet;
extern CompositeSet NullSet;
extern CompositeSet IntSet;
extern CompositeSet Int2Set;
extern CompositeSet OptSet;
extern CompositeSet Beta3Set;

CompositeSetEntry CompSetList[] = {
    {
	"Reference",
	"Proxy implementation based on the reference functions",
	&RefProxySet,
    },
    {
	"Null",
	"Null implementation for benchmark overhead checking",
	&NullSet,
    },
    {
	"Integer",
	"Simple integer implementation (no optimization)",
	&IntSet,
    },
    {
	"Short",
	"Simple 12-bit integer implementation (no optimization)",
	&Int2Set,
    },
    {
	"Beta3",
	"Beta3 AlphComposite implementation",
	&Beta3Set,
    },
};

int NumCompSets = (sizeof(CompSetList) / sizeof(CompSetList[0]));
