/*
 * @(#)nullset.c	1.1 98/04/10
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * A NOP CompositeSet for testing the overhead of the benchmark loop.
 * These functions simply store 0, 0 in the results and return.
 */

#include "alphatest.h"

extern CompositeSet NullSet;

static CompositeFunc ClearNull;
static CompositeFunc SrcNull;
static CompositeFunc SrcOverNull;
static CompositeFunc DstOverNull;
static CompositeFunc SrcInNull;
static CompositeFunc DstInNull;
static CompositeFunc SrcOutNull;
static CompositeFunc DstOutNull;

CompositeSet NullSet = {
    ClearNull,
    SrcNull,
    SrcOverNull,
    DstOverNull,
    SrcInNull,
    DstInNull,
    SrcOutNull,
    DstOutNull,
};

static void
ClearNull(unsigned char *srcData, int srcScan, int srcPremul,
	  unsigned char *dstData, int dstScan, int dstPremul,
	  unsigned char *pathData, int pathScan, int extraAlpha256,
	  unsigned char *resData, int width, int height)
{
}

static void
SrcNull(unsigned char *srcData, int srcScan, int srcPremul,
	unsigned char *dstData, int dstScan, int dstPremul,
	unsigned char *pathData, int pathScan, int extraAlpha256,
	unsigned char *resData, int width, int height)
{
}

static void
SrcOverNull(unsigned char *srcData, int srcScan, int srcPremul,
	    unsigned char *dstData, int dstScan, int dstPremul,
	    unsigned char *pathData, int pathScan, int extraAlpha256,
	    unsigned char *resData, int width, int height)
{
}

static void
DstOverNull(unsigned char *srcData, int srcScan, int srcPremul,
	    unsigned char *dstData, int dstScan, int dstPremul,
	    unsigned char *pathData, int pathScan, int extraAlpha256,
	    unsigned char *resData, int width, int height)
{
}

static void
SrcInNull(unsigned char *srcData, int srcScan, int srcPremul,
	  unsigned char *dstData, int dstScan, int dstPremul,
	  unsigned char *pathData, int pathScan, int extraAlpha256,
	  unsigned char *resData, int width, int height)
{
}

static void
DstInNull(unsigned char *srcData, int srcScan, int srcPremul,
	  unsigned char *dstData, int dstScan, int dstPremul,
	  unsigned char *pathData, int pathScan, int extraAlpha256,
	  unsigned char *resData, int width, int height)
{
}

static void
SrcOutNull(unsigned char *srcData, int srcScan, int srcPremul,
	   unsigned char *dstData, int dstScan, int dstPremul,
	   unsigned char *pathData, int pathScan, int extraAlpha256,
	   unsigned char *resData, int width, int height)
{
}

static void
DstOutNull(unsigned char *srcData, int srcScan, int srcPremul,
	   unsigned char *dstData, int dstScan, int dstPremul,
	   unsigned char *pathData, int pathScan, int extraAlpha256,
	   unsigned char *resData, int width, int height)
{
}
