/*
 * @(#)testvals.c	1.1 98/04/10
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Standard sets of test data provided in several levels of intensity.
 */

#include "alphatest.h"

static int hivals255[] = {
    0, 1, 2, 3, 4, 5, 6, 7,
    8, 16, 24, 32, 40, 48, 56, 64,
    72, 80, 88, 96, 104, 112, 120, 128,
    136, 144, 152, 160, 168, 176, 184, 192,
    200, 208, 216, 224, 232, 240, 248,
    249, 250, 251, 252, 253, 254, 255
};

static int hivals256[] = {
    0, 1, 2, 3, 4, 5, 6, 7,
    8, 16, 24, 32, 40, 48, 56, 64,
    72, 80, 88, 96, 104, 112, 120, 128,
    136, 144, 152, 160, 168, 176, 184, 192,
    200, 208, 216, 224, 232, 240, 248,
    249, 250, 251, 252, 253, 254, 255, 256
};

#define NUMHIVALS255 (sizeof(hivals255) / sizeof(hivals255[0]))
#define NUMHIVALS256 (sizeof(hivals256) / sizeof(hivals256[0]))

static TestValues HiValues = {
    NUMHIVALS255,
    hivals255,
    NUMHIVALS256,
    hivals256
};

static int midvals255[] = {
    0, 1, 2, 3,
    8, 16, 24, 32,
    64, 128, 192,
    224, 232, 240, 248,
    253, 254, 255
};

static int midvals256[] = {
    0, 1, 2, 3,
    8, 16, 24, 32,
    64, 128, 192,
    224, 232, 240, 248,
    253, 254, 255, 256
};

#define NUMMIDVALS255 (sizeof(midvals255) / sizeof(midvals255[0]))
#define NUMMIDVALS256 (sizeof(midvals256) / sizeof(midvals256[0]))

static TestValues MidValues = {
    NUMMIDVALS255,
    midvals255,
    NUMMIDVALS256,
    midvals256
};

static int lowvals255[] = {
    0, 8, 16, 32,
    64, 128, 192,
    224, 240, 248, 255
};

static int lowvals256[] = {
    0, 8, 16, 32,
    64, 128, 192,
    224, 240, 248, 256
};

#define NUMLOWVALS255 (sizeof(lowvals255) / sizeof(lowvals255[0]))
#define NUMLOWVALS256 (sizeof(lowvals256) / sizeof(lowvals256[0]))

static TestValues LowValues = {
    NUMLOWVALS255,
    lowvals255,
    NUMLOWVALS256,
    lowvals256
};

static int quickvals255[] = {
    0, 128, 255
};

static int quickvals256[] = {
    0, 128, 256
};

#define NUMQUICKVALS255 (sizeof(quickvals255) / sizeof(quickvals255[0]))
#define NUMQUICKVALS256 (sizeof(quickvals256) / sizeof(quickvals256[0]))

static TestValues QuickValues = {
    NUMQUICKVALS255,
    quickvals255,
    NUMQUICKVALS256,
    quickvals256
};

static int hbenchvals255[] = {
    0, 0, 0, 0, 0, 0,
    32, 64, 128, 192, 224,
    255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255,
};

static int hbenchvals256[] = {
    0, 0, 0, 0, 0, 0,
    32, 64, 128, 192, 224,
    256, 256, 256, 256, 256, 256,
    256, 256, 256, 256, 256, 256,
};

#define NUMHBENCHVALS255 (sizeof(hbenchvals255) / sizeof(hbenchvals255[0]))
#define NUMHBENCHVALS256 (sizeof(hbenchvals256) / sizeof(hbenchvals256[0]))

static TestValues HBenchValues = {
    NUMHBENCHVALS255,
    hbenchvals255,
    NUMHBENCHVALS256,
    hbenchvals256
};

static int mbenchvals255[] = {
    0, 0, 0, 0,
    32, 64, 128, 192, 224,
    255, 255, 255, 255,
    255, 255, 255, 255,
};

static int mbenchvals256[] = {
    0, 0, 0, 0,
    32, 64, 128, 192, 224,
    256, 256, 256, 256,
    256, 256, 256, 256,
};

#define NUMMBENCHVALS255 (sizeof(mbenchvals255) / sizeof(mbenchvals255[0]))
#define NUMMBENCHVALS256 (sizeof(mbenchvals256) / sizeof(mbenchvals256[0]))

static TestValues MBenchValues = {
    NUMMBENCHVALS255,
    mbenchvals255,
    NUMMBENCHVALS256,
    mbenchvals256
};

static int lbenchvals255[] = {
    0, 0, 0, 0,
    64, 128, 192,
    255, 255, 255, 255,
};

static int lbenchvals256[] = {
    0, 0, 0, 0,
    64, 128, 192,
    256, 256, 256, 256,
};

#define NUMLBENCHVALS255 (sizeof(lbenchvals255) / sizeof(lbenchvals255[0]))
#define NUMLBENCHVALS256 (sizeof(lbenchvals256) / sizeof(lbenchvals256[0]))

static TestValues LBenchValues = {
    NUMLBENCHVALS255,
    lbenchvals255,
    NUMLBENCHVALS256,
    lbenchvals256
};

static int bench0vals255[] = {
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
};

static int bench0vals256[] = {
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
};

#define NUMBENCH0VALS255 (sizeof(bench0vals255) / sizeof(bench0vals255[0]))
#define NUMBENCH0VALS256 (sizeof(bench0vals256) / sizeof(bench0vals256[0]))

static TestValues Bench0Values = {
    NUMBENCH0VALS255,
    bench0vals255,
    NUMBENCH0VALS256,
    bench0vals256
};

static int bench1vals255[] = {
    255, 255, 255, 255,
    255, 255, 255, 255,
    255, 255, 255, 255,
    255, 255, 255, 255,
    255, 255, 255, 255,
};

static int bench1vals256[] = {
    256, 256, 256, 256,
    256, 256, 256, 256,
    256, 256, 256, 256,
    256, 256, 256, 256,
    256, 256, 256, 256,
};

#define NUMBENCH1VALS255 (sizeof(bench1vals255) / sizeof(bench1vals255[0]))
#define NUMBENCH1VALS256 (sizeof(bench1vals256) / sizeof(bench1vals256[0]))

static TestValues Bench1Values = {
    NUMBENCH1VALS255,
    bench1vals255,
    NUMBENCH1VALS256,
    bench1vals256
};

TestValueEntry TestValList[] = {
    {
	/*          16,200 test cases (a second) */
	"QuickTest",
	"Tiny list of data for sanity checking (runtime ~1s)",
	&QuickValues,
    },
    {
	/*      33,849,992 test cases (few minutes) */
	"LowTest",
	"Short list of data for testing (runtime ~1m)",
	&LowValues,
    },
    {
	/*     670,388,400 test cases (overnight) */
	"MidTest",
	"Medium list of data for testing (runtime ~1h)",
	&MidValues,
    },
    {
	/* 176,779,112,464 test cases (? a year ?) */
	"HighTest",
	"Long list for exhaustive testing (runtime ?N? days)",
	&HiValues,
    },
    {
	/*       2,402,500 test cases (a minute) */
	"LowBench",
	"Short list for a quick benchmark (runtime < 30s)",
	&LBenchValues,
    },
    {
	/*     451,681,568 test cases (few minutes) */
	"MidBench",
	"Medium list for a decent benchmark (runtime ~1m)",
	&MBenchValues,
    },
    {
	/*   2,742,441,800 test cases (an hour) */
	"HighBench",
	"Long list for an intensive benchmark (runtime ?~1h?)",
	&HBenchValues,
    },
    {
	"BenchOn",
	"All opaque data for a benchmark (runtime < 5m)",
	&Bench0Values,
    },
    {
	"BenchOff",
	"All transparent data for a benchmark (runtime < 5m)",
	&Bench1Values,
    },
};

int NumTestVals = (sizeof(TestValList) / sizeof(TestValList[0]));
