/*
 * @(#)Test.java	1.5 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.applet.Applet;
import java.awt.geom.Area;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.PathIterator;
import java.awt.Shape;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.Canvas;


public class Test extends Applet {
    Shape devClip = new Rectangle2D.Float(0, 0, 100, 100); // Device area
    Shape usrClip = new Ellipse2D.Float(25, 25, 75, 75);   // Ellipse inside
    Shape compClip = shapeIntersection(usrClip, devClip);  // Intersection

            
    
    public Test() {
        
        Shape ellipse = new Ellipse2D.Float(30, 30, 65, 65);

        printShape(compClip, "FIRST Object");
        printShape(ellipse, "SECOND Object");
            
        Shape i = shapeIntersection(compClip, ellipse);
            
        printShape(i, "INTERSECTION");
    }

    Shape shapeIntersection(Shape s1, Shape s2) {
        Area a1 = new Area(s1);
        Area a2 = new Area(s2);

        a1.intersect(a2);

        return a1;
    }

    void printShape(Shape a, String s) {
        if ((a.getBounds()).isEmpty()) {
            System.out.println("The Shape of "+ s +" is EMPTY");
        } else {
            PathIterator pi = a.getPathIterator(null);
            System.out.println("The Shape of "+ s +" is " + a + ", Winding Rule is " + ((pi.getWindingRule() == 0) ? "EVEN_ODD" : "NON_ZERO"));
            float point[]  = new float[6];
            while (!pi.isDone()) {
                int type = pi.currentSegment(point);
                switch (type) {
                case PathIterator.SEG_MOVETO:
                    System.out.println("SEG_MOVETO : " + point[0]+" "+ point[1]);
                    break;
                case PathIterator.SEG_LINETO:
                    System.out.println("SEG_LINETO : " +point[0]+" "+point[1]);
                    break;
                case PathIterator.SEG_QUADTO:
                    System.out.println("SEG_QUADTO : "+point[0]+" "+point[1]+", "+point[2]+" "+point[3]);
                    break;
                case PathIterator.SEG_CUBICTO:
                    System.out.println("SEG_CUBICTO : "+point[0]+" "+point[1]+", "+point[2]+" "+point[3]+", "+point[4]+" "+point[5]);
                    break;
                case PathIterator.SEG_CLOSE:
                    System.out.println("SEG_CLOSE :");
                    break;
                }
                pi.next();
            }
            System.out.println("Done printing " + s +"\n");
        }

    }

}
