/*
 * @(#)RemoteAddrTest.java	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.net.*;
import java.io.*;


public class RemoteAddrTest extends NetTest {

    public /**/ RemoteAddrTest(String[] a) {
	super(a);
    }

    static final int PORT = 9438;

    boolean connector = false;
    public /**/ RemoteAddrTest(String[] a, boolean connector) {
	super(a);
	this.connector = connector;
    }

    public static void main(String[] a) {
	(new RemoteAddrTest(a)).run();
    }

    public void run() {
	if (connector) {
	    connect();
	    exit();
	    return;
	}
	try {
	    ServerSocket ss = new ServerSocket(PORT);
	    (new Thread(new RemoteAddrTest(argv, true), "connector")).start();
	    verbose("made serverSocket: " + ss);
	    assert(ss.getLocalPort() == PORT, "wrong port: " +
		   ss.getLocalPort());
	    Socket s = ss.accept();
	    verbose("accepted socket: " + s);
	    InetAddress addr = s.getInetAddress();
	    assert(addr.equals(InetAddress.getLocalHost()),
		   (addr.getHostAddress() + " != " + 
		    InetAddress.getLocalHost().getHostAddress()));
	    assert(s.getLocalPort() == ss.getLocalPort(),
		   Integer.toHexString(s.getLocalPort()) + " != " +
		   Integer.toHexString(ss.getLocalPort()));
	} catch (Exception e) {
	    pe(e);
	}
	exit();
    }

    void connect() {
	try {
	    Socket s = new Socket(InetAddress.getLocalHost(), PORT);
	    verbose("connected Socket: " + s);
	    s.close();
	} catch (Exception e) {
	    pe(e);
	}
    }
}



