/*
 * @(#)OldNMI.java	1.5 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.lang.reflect.*;

/**
 * A sanity check for the old Native Method Interface.
 *
 * @author Anand Palaniswamy
 * @version 1.5, 06/29/98
 */
public class OldNMI {

    native boolean javaStringLength();
    native boolean makeJavaString();
    native boolean makeCString();
    native boolean allocCString();
    native boolean javaString2unicode();
    native boolean javaString2CString();
    native boolean FindClass();
    native boolean FindStickySystemClass();
    native boolean FindClassFromClass();
    native boolean SignalError();
    native boolean EE();
    native boolean ArrayAlloc();
    native boolean ObjAlloc();
    native boolean do_execute_java_method();
    native boolean execute_java_dynamic_method();
    native boolean execute_java_static_method();
    native boolean execute_java_constructor();
    native boolean is_instance_of();
    native boolean ImplementsInterface();
    native boolean jio_snprintf();
    native boolean jio_printf();
    native boolean jio_fprintf();
    native boolean jio_vfprintf();
    native boolean do_execute_java_method_vararg();
    native boolean newobject();
    native boolean exceptionDescribe();
    native boolean Thread_classblock();
    native boolean classname2string();
    native boolean sizearray();
    native boolean threadSelf();

    native boolean monitorInit();
    native boolean monitorEnter();
    native boolean monitorExit();
    native boolean monitorWait();
    native boolean monitorNotify();
    native boolean monitorNotifyAll();

    public static void main(String[] args) throws Throwable {
	Method[] tests = OldNMI.class.getDeclaredMethods();
	int n = tests.length;
	OldNMI dummy = new OldNMI();

	System.loadLibrary("OldNMI");
	for (int i = 0; i < n; i++) {
	    int m = tests[i].getModifiers();
	    if (!Modifier.isNative(m) ||
		!(tests[i].getReturnType() == Boolean.TYPE)) {
		continue;
	    }
	    try {
		Object result = tests[i].invoke(dummy, null);
		if (((Boolean)result).booleanValue() == false) {
		    throw new Exception("Bad return value from " +
					tests[i].getName());
		}
	    } catch (java.lang.reflect.InvocationTargetException t) {
	        System.err.println("Exception in " + tests[i].getName());
		throw t.getTargetException();
	    } catch (Throwable t) {
	        System.err.println("Error in " + tests[i].getName());
		throw t;
	    }
	}
	/* If you got this far, you probably succeeded! */
	System.out.println("\nOK: OldNMI appears to be breathing.\n");
    }
}
