/*
 * @(#)AppleEvent.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.util.Date;

/**
 * The AppleEvent class is simply an object to be passed back to a
 * remote objct exported by an applet to verify proper object
 * serialization.
 */
public class AppleEvent implements java.io.Serializable {

    public static final int BUY   = 0;
    public static final int EAT   = 1;
    public static final int THROW = 2;

    private int what;

    private java.util.Date when;

    public AppleEvent(int what)
    {
	this.what = what;
	this.when = new Date();
    }

    public String toString()
    {
	String desc = "[";
	switch (what) {
	case BUY:
	    desc += "BUY";
	    break;
	case EAT:
	    desc += "EAT";
	    break;
	case THROW:
	    desc += "THROW";
	    break;
	}
	desc += " @ " + when + "]";
	return desc;
    }
}
