/*
 * @(#)OrangeEchoImpl.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.rmi.*;
import java.rmi.server.*;

import java.awt.*;

/**
 * The OrangeEchoImpl class implements the behavior of the remote "orange
 * echo" objects exported by the server.  The purpose of these objects
 * is simply to recursively call back to their caller.
 */
public class OrangeEchoImpl
    extends UnicastRemoteObject
    implements OrangeEcho
{

    String name;

    public OrangeEchoImpl(String name)
	throws RemoteException
    {
	this.name = name;
    }

    /**
     * Call back on supplied "orange" object (presumably the caller)
     * with the same message data and a decremented recursion level.
     */
    public int[] recurse(Orange orange, int[] message, int level)
	throws RemoteException
    {
	String threadName = Thread.currentThread().getName();
	System.err.println(
	    threadName + ": " + toString() +
	    ".recurse(message[" + message.length + "], " +
	    level + "): BEGIN");

	int[] response = orange.recurse(this, message, level - 1);

	System.err.println(
	    threadName + ": " + toString() +
	    ".recurse(message[" + message.length + "], " +
	    level + "): END\n");

	return response;
    }

    public String toString()
    {
	return name;
    }
}
