/*
 * @(#)LogData.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package benchmarks;

import java.io.*;
import java.util.*;

/**
 * LogData contains all the performance data for all the clients , the log date
 * and the median RMIPerfMark for the day. This is the data that is stored in
 * the log file.
 *
 * @see AttribData
 * @see ClientData
 * @see PerfFigures
 */

public class LogData implements Serializable {

        /**
         * Log Date
         */
        protected Date date;

        /**
         * The median RMIPerfMark for all the clients
         */
        protected float RMIPerfMark;

        /**
         * The Log for all Client Performance data
         *
         */
        protected Hashtable clientLog;

	/**
	 * Server System properties
	 */
	protected Properties serverDesc;

	protected void setDate(Date d) {
		
		date = d;

	}

	protected void setRMIPerfMark (float mark) {

		RMIPerfMark = mark;

	}

	protected void setClientLog (Hashtable log) {

		clientLog = log;

	}

	protected void setServerDesc (Properties props) {

		serverDesc = props;

	}

	public Date getDate() {

		return date;
	
	}

	public float getRMIPerfMark() {

		return RMIPerfMark;

	}

	public Hashtable getClientLog () {

		return clientLog;

	}

	public Properties getServerDesc() {

		return serverDesc;

	}


}


