/*
 * @(#)TestInfo.java	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package visualBenchmarks;

/**
 * A class to encapsulate the test information including wether it uses 
 * arrays, vectors or some such parameters beside the range of iterations
 */

public class TestInfo implements java.io.Serializable{

	private String testName;
	private boolean arraysUsed;
	
  	/**
	 * Constructs a TestInfo object for the test <i>testname</i>
	 * 
	 * @param testName   the unique identifier for the test
	 * @param arraysUsed a boolean value indicating whether a second 
	 *		     parameter is used in this test.
 	 */
	public TestInfo(String testName, boolean arraysUsed) {
	
		this.testName = testName;
		this.arraysUsed = arraysUsed;

	}

	public String getTestName() {
	
		String str = new String(testName);
		return str;

	}

	public boolean areArraysUsed(){

		return (arraysUsed?true:false);

	}
}
