/*
 * @(#)getLocalHostTest.java	1.5 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * File: getLocalHostTest.java
 * Comment: THis file checks the output of InetAddress.getLocalHost() to be
 * 127.0.0.0. This modification was made so as not to reveal the hostname of
 * the machine on which the applet is running.
 *
 * @(#)author:  Vijay Srinivasan
 * @(#)version: 1.5
 * @(#)date:    98/12/01
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class getLocalHostTest extends SecurityTest {
  public void test(Graphics g) {
    String inet, hostname, IPaddress;
    int separatorpt;

    try {
      inet = InetAddress.getLocalHost().toString();
      separatorpt = inet.indexOf('/');
      if (separatorpt == -1) {
	status = FAILED;
	return;
      }

      hostname = inet.substring(0, separatorpt);
      IPaddress = inet.substring(separatorpt+1);

      status = (hostname.equals("localhost")) ? PASSED : FAILED;
      status = (IPaddress.equals("127.0.0.1")) ? status : FAILED;
    } catch (UnknownHostException e) {
      e.printStackTrace();
      status = FAILED;
    }
  }
}
