/*
 * @(#)PKCS8KeyEncodeTest.java	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package crypto;

import test.*;

import java.math.BigInteger;
import sun.security.provider.DSAPrivateKey;

public class PKCS8KeyEncodeTest extends Test {

    String foo;

    public void run() throws TestException {
	try {
	    BigInteger p = BigInteger.valueOf(1);
	    BigInteger q = BigInteger.valueOf(2);
	    BigInteger g = BigInteger.valueOf(3);
	    BigInteger x = BigInteger.valueOf(4);

	    DSAPrivateKey priv = new DSAPrivateKey(p, q, g, x);

	    byte[] encodedKey = priv.getEncoded();
	    System.err.println("encodedKey: " + encodedKey.length);
	
	    DSAPrivateKey decodedKey = new DSAPrivateKey(encodedKey);
	
	    System.err.println("original: " + priv);
	    System.err.println("decoded: " + decodedKey);
	} catch (Exception e) {
	    throw new TestException("error", e);
	}
    }
}
    


