/*
 * @(#)BigIntTest.java	1.2 98/07/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.io.OutputStream;
import java.math.BigInteger;
import sun.security.x509.*;
import sun.security.util.*;
import sun.misc.*;

public class BigIntTest {
    public static void main(String[] args) {
            
            try {
                DerOutputStream dos = new DerOutputStream();
                HexDumpEncoder encoder = new HexDumpEncoder();
                CRLNumberExtension cNum = null;
                BigInteger cBI = null, nBI = null;
                BigInt bI = null;
                byte[] buf = null;
                
                int i = 1;
                while (i < 65000) {
                    cNum = new CRLNumberExtension(i);
                    bI = new BigInt(i);
                    System.out.println("i=" + i + "; " + bI.toInt());

                    cNum.encode((OutputStream)dos);
                    System.out.println(cNum.toString());

                    cBI = (BigInteger)cNum.get(CRLNumberExtension.NUMBER);
                    buf = cBI.toByteArray();
                    System.out.println("int encoded= " +
                                       encoder.encodeBuffer(buf));
                    nBI = new BigInteger(1, buf);
                    i = i * 4;
                    // i++;  -- takes too long
                    if (nBI.equals(cBI))
                        System.out.println(cBI.toString() + ";" + nBI.toString());
                    else
                        System.out.println("BROKEN !!");
               }
            } catch (Exception e) {
                e.printStackTrace();
            }
    } 
}
