/*
 * @(#)CSRParse.java	1.1 98/07/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.io.*;
import sun.security.pkcs.*;
import sun.misc.BASE64Decoder;

/**
 * Usage: CSRParse <fileName>
 */
public class CSRParse {
    public static void main(String[] args) {
            if (args.length != 1) {
                System.out.println("Usage: CSRParse <fileName>");
                System.exit(1);
            }
 
            try {
                // CSR boundaries
                String beginCSR = "-----BEGIN NEW CERTIFICATE REQUEST-----";
                String endCSR = "-----END NEW CERTIFICATE REQUEST-----";
                InputStream inStrm = new FileInputStream(args[0]);
                BufferedReader bufRdr = new BufferedReader(new
                                            InputStreamReader(inStrm));
                StringBuffer strBuf = new StringBuffer();
                String temp;

                while ((temp = bufRdr.readLine()) != null &&
                       !temp.equals(beginCSR))
                    continue;
                if (temp == null) {
                    System.out.println("Missing " + beginCSR + " boundary");
                    System.exit(1);
                }
                while ((temp = bufRdr.readLine()) != null &&
                       !temp.equals(endCSR))
                    strBuf.append(temp);
                if (temp == null) {
                    System.out.println("Missing " + endCSR + " boundary");
                    System.exit(1);
                }

                BASE64Decoder decoder = new BASE64Decoder();
                byte data[];

                data = decoder.decodeBuffer(strBuf.toString());
                FileOutputStream fos = new FileOutputStream("derTestCSR");
                fos.write(data);
                fos.close();

                PKCS10 csr = new PKCS10(data);

                System.out.println("***  Verified CSR ***");
                System.out.println(csr);
                System.out.println("*** End CSR ***");

            } catch (Exception e) {
                e.printStackTrace();
            }
    } 
}
