/*
 * @(#)DateFormatTest.java	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

public class DateFormatTest {
    public static void main(String[] args) {
        try {
            TimeZone tz = TimeZone.getTimeZone("GMT");
            Date firstD = new Date();
	    Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("PST"));
            cal.set(1997, 11, 31, 12, 30, 30);
            Date lastD = cal.getTime();

            System.out.println(firstD.toString() + " & " + lastD.toString());

	    String utc = "yyMMddHHmmss'Z'";
	    String gt = "yyyyMMddHHmmss'Z'";
            SimpleDateFormat sdf = new SimpleDateFormat(utc);
            SimpleDateFormat gsdf = new SimpleDateFormat(gt);
            sdf.setTimeZone(tz);
            gsdf.setTimeZone(tz);
            System.out.println("UTC: " + sdf.format(firstD) +
                               " & " + sdf.format(lastD));
            System.out.println("GT: " + gsdf.format(firstD) +
                               " & " + gsdf.format(lastD));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
