/*
 * @(#)HexStrToX509Cert.java	1.3 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)HexStrToX509Cert.java	1.3 98/09/21
 * 
 * Copyright 1998 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */

import java.io.*;
import java.math.BigInteger;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

import sun.misc.*;

/**
 * Usage: HexStrToX509Cert <fileName>
 * This test was written for interop testing with SunSoft
 * authorization server.
 */
public class HexStrToX509Cert {
    public static void main(String[] args) {
            
            if (args.length != 1) {
                System.out.println("Usage: HexStrToX509Cert <fileName>");
                System.exit(1);
            }
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                BufferedReader br = new BufferedReader(new
                                       InputStreamReader(inStrm));
                String temp;
                StringBuffer strBuf = new StringBuffer();

                // Read the certificate from the file into the buffer
                while ((temp = br.readLine()) != null) {
                   strBuf.append(temp);
                }
                inStrm.close();

                String dataStr = strBuf.toString();
                if ((dataStr.length() & 0x01) == 0x01)
                    dataStr = new String(dataStr+"0");
                BigInteger cI = new BigInteger(dataStr, 16);
                byte[] certData = cI.toByteArray();
                ByteArrayInputStream bais = new ByteArrayInputStream(certData);
                
                CertificateFactory cf = CertificateFactory.getInstance("X509");
                X509Certificate crt = (X509Certificate)
                                      cf.generateCertificate(bais);
                bais.close();
                System.out.println("***  Certificate ***");
                System.out.println(crt);
                System.out.println("*** End Certificate ***");

            } catch (Exception e) {
                e.printStackTrace();
            }
    } 
}
