/*
 * @(#)PKCS7CertPrint.java	1.1 98/07/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import java.util.Collection;
import java.util.Iterator;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

/**
 * Usage: PKCS7CertPrint <fileName>
 */
public class PKCS7CertPrint {
    public static void main(String[] args) {

            if (args.length != 1) {
                System.out.println("Usage: PKCS7CertPrint <fileName>");
                System.exit(1);
            }
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                DataInputStream dis = new DataInputStream(inStrm);
                byte[] data = new byte[dis.available()];
                dis.readFully(data);
                ByteArrayInputStream bais = new ByteArrayInputStream(data);

		CertificateFactory cf = CertificateFactory.getInstance("X509");
                Collection c = cf.generateCertificates(bais);
                bais.close();
                Iterator i = c.iterator();
                while (i.hasNext()) {
                    X509Certificate crt = (X509Certificate)i.next();
                    System.out.println("***  Certificate ***");
                    System.out.println(crt.toString());
                    System.out.println("*** End Certificate ***");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
    }
}
