/*
 * @(#)PKCS7DerPrint.java	1.2 98/09/21
 *
 * Copyright 1998-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
/*
 * @(#)PKCS7DerPrint.java	1.2 98/09/21
 * 
 * Copyright 1998 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */

import java.io.*;
import java.security.Principal;
import java.security.PublicKey;
import java.security.cert.X509Certificate;
import sun.security.pkcs.*;

/**
 * Usage: PKCS7DerPrint <fileName>
 */
public class PKCS7DerPrint {
    public static void main(String[] args) {
            if (args.length != 1) {
                System.out.println("Usage: PKCS7DerPrint <fileName>");
                System.exit(1);
            }
 
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                PKCS7 block = new PKCS7(inStrm);

                System.out.println(block);
                X509Certificate[] certs = block.getCertificates();
                if (certs.length == 1) {
                    Principal subject = certs[0].getSubjectDN();
                    Principal issuer = certs[0].getIssuerDN();
                    if (subject.equals(issuer)) { // self-signed
                        certs[0].verify(certs[0].getPublicKey());
                        System.out.println("verified root cert:");
                        //System.out.println(certs[0]);
                    } else
                        throw new Exception("Cert not self-signed & only one");
                } else if (certs.length == 2) {
                    Principal subject0 = certs[0].getSubjectDN();
                    Principal issuer0 = certs[0].getIssuerDN();
                    Principal subject1 = certs[1].getSubjectDN();
                    Principal issuer1 = certs[1].getIssuerDN();
                    PublicKey IssuerPub;
                    if (subject0.equals(issuer0)) {           
                        IssuerPub = certs[0].getPublicKey();
                        certs[0].verify(IssuerPub);
                        System.out.println("verified root cert:");
                        //System.out.println(certs[0]);
                        if (subject0.equals(issuer1)) {
                            certs[1].verify(IssuerPub);
                            System.out.println("verified child cert:");
                            //System.out.println(certs[1]);
                        } else
                          throw new Exception("Certificate chain incorrect");
                    } 
                    if (subject1.equals(issuer1)) {           
                        IssuerPub = certs[1].getPublicKey();
                        certs[1].verify(IssuerPub);
                        System.out.println("verified root cert:");
                        //System.out.println(certs[1]);
                        if (subject1.equals(issuer0)) {
                            certs[0].verify(IssuerPub);
                            System.out.println("verified child cert:");
                            //System.out.println(certs[0]);
                        } else
                          throw new Exception("Certificate chain incorrect");
                    } 
                } else
                   throw new Exception("Certificate chain of length=" +
                                        certs.length + " not yet supported");
            } catch (Exception e) {
                e.printStackTrace();
            }
    } 
}
