/*
 * @(#)X509CRLPrint.java	1.5 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.io.InputStream;
import java.io.FileInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509CRL;

/**
 * Usage: X509CRLPrint <fileName>
 */
public class X509CRLPrint {
    public static void main(String[] args) {

        if (args.length != 1) {
            System.out.println("Usage: X509CRLPrint <fileName>");
            System.exit(1);
        }
        try {
            InputStream inStrm = new FileInputStream(args[0]);
            CertificateFactory cf = CertificateFactory.getInstance("X509");
            X509CRL crl = (X509CRL)cf.generateCRL(inStrm);

            System.out.println("***  CRL ***");
            System.out.println(crl);
            System.out.println("*** End CRL ***");

            if (crl.hasUnsupportedCriticalExtension())
                System.out.println("Has unsupported critical extension!");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
