/*
 * @(#)X509CertPrint.java	1.8 98/06/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

/**
 * Usage: X509CertPrint <fileName>
 */
public class X509CertPrint {
    public static void main(String[] args) {

            if (args.length != 1) {
                System.out.println("Usage: X509CertPrint <fileName>");
                System.exit(1);
            }
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                DataInputStream dis = new DataInputStream(inStrm);
                byte[] data = new byte[dis.available()];
                dis.readFully(data);
                ByteArrayInputStream bais = new ByteArrayInputStream(data);

		CertificateFactory cf = CertificateFactory.getInstance("X509");
                X509Certificate crt
		    = (X509Certificate)cf.generateCertificate(bais);
                bais.close();
                System.out.println("***  Certificate ***");
                System.out.println(crt.toString());
                System.out.println("*** End Certificate ***");

                if (crt.hasUnsupportedCriticalExtension())
                    System.out.println("Has unsupported critical extension!");

            } catch (Exception e) {
                e.printStackTrace();
            }
    }
}
