/*
 * @(#)TestParsePKCS7.java	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.io.*;
import java.security.*;

import sun.security.pkcs.*;
import sun.security.util.*;

public class TestParsePKCS7 {

    static File file;

    public static void main(String[] args) {
	if (args.length != 1) {
	    System.err.println("usage: java TestPKCSParse <file.pkcs>");
	    System.exit(1);
	}

	file = new File(args[0]);

	if (!file.exists()) {
	    System.err.println("cannot find file: " + file);
	    System.exit(1);
	}

	try {
	    FileInputStream fis = new FileInputStream(file);
	    DataInputStream dis = new DataInputStream(fis);
	    byte[] data = new byte[dis.available()];
	    dis.readFully(data);
	    
	    PKCS7 pkcs = new PKCS7(new DerInputStream(data));
	    
	    System.err.println(pkcs);

	} catch (Exception e) {
	    e.printStackTrace();
	}
    }
}
    
