/*
 * @(#)BinaryTreeTest.java	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
class BinaryTreeTest implements java.io.Serializable {
    public BinaryTreeTest left;
    public BinaryTreeTest right;
    public int id;
    public int level;

    private static int count = 0;
    public BinaryTreeTest(int l) {
	id = count++;
	level = l;
	if (l > 0) {
	    left = new BinaryTreeTest(l-1);
	    right = new BinaryTreeTest(l-1);
	}
    }
    public void print(int levels) {
	for (int i = 0; i < level; i++)
	    System.out.print("  ");
	System.out.println("node " + id);

	if (level <= levels && left != null)
	    left.print(levels);

	if (level <= levels && right != null)
	    right.print(levels);
    }

    public boolean equals(BinaryTreeTest other) {

	if (other == null)
	    return false;

	if (id != other.id)
	    return false;

	if (left != null && !left.equals(other.left))
	    return false;

	if (right != null && !right.equals(other.right))
	    return false;

	return true;
    }
}
