/*
 * @(#)ExceptionOutputStream.java	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import java.io.OutputStream;
import java.io.IOException;


public
class ExceptionOutputStream extends OutputStream {
    /**
     * Writes a byte to the buffer.
     * @param b	the byte
     */
    public void write(int b) throws IOException
    {
	if (currentOffset >= exceptionOffset) {
	    throw new IOException("Debug exception");
	}
	currentOffset++;
    }

    private int exceptionOffset = 0;
    private int currentOffset = 0;
  
    public void setExceptionOffset(int offset)
    {
      exceptionOffset = offset;
      currentOffset = 0;
    }
  
}
