/*
 * @(#)CharToByteX11Dingbats.java	1.12 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.motif;

import sun.io.CharToByteISO8859_1;
import sun.io.UnknownCharacterException;

public class CharToByteX11Dingbats extends CharToByteISO8859_1 {

    private static byte[] table =
	{(byte)0xa1, (byte)0xa2, (byte)0xa3, (byte)0xa4,
	 (byte)0xa5, (byte)0xa6, (byte)0xa7, (byte)0xa8, 
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0xb6, (byte)0xb7,
	 (byte)0xb8, (byte)0xb9, (byte)0xba, (byte)0xbb,
	 (byte)0xbc, (byte)0xbd, (byte)0xbe, (byte)0xbf,
	 (byte)0xc0, (byte)0xc1, (byte)0xc2, (byte)0xc3,
	 (byte)0xc4, (byte)0xc5, (byte)0xc6, (byte)0xc7,
	 (byte)0xc8, (byte)0xc9, (byte)0xca, (byte)0xcb,
	 (byte)0xcc, (byte)0xcd, (byte)0xce, (byte)0xcf, 
	 (byte)0xd0, (byte)0xd1, (byte)0xd2, (byte)0xd3,
	 (byte)0xd4, (byte)0x00, (byte)0x00, (byte)0x00, 
	 (byte)0xd8, (byte)0xd9, (byte)0xda, (byte)0xdb,
	 (byte)0xdc, (byte)0xdd, (byte)0xde, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
	 (byte)0x00, (byte)0x00};


    public String toString() {
	return "X11Dingbats";
    }

    public boolean canConvert(char ch) {
        if (ch >= 0x2701 && ch <= 0x2760) {	// direct map
             return true;
	}
        if (ch >= 0x2761 && ch <= 0x27be) {
             return (table[ch - 0x2761] != 0x00);
	}
        return false;
    }


    public int convert(char[] input, int inOff, int inEnd,
		       byte[] output, int outOff, int outEnd) 
    throws UnknownCharacterException {

	int len = inEnd - inOff;
	for (int i = 0; i < len; i++) {
	    char ch = input[inOff + i];
	    if (!canConvert(ch)) {
		/* this is 1-1 */
		byteOff = outOff + i;
		charOff = inOff + i;
		throw new UnknownCharacterException("can't do: " + (int)ch);
	    }
	    if (ch >= 0x2761){
		    output[outOff + i] = table[ch - 0x2761]; // table lookup
	    } else {
		    output[outOff + i] = (byte)(ch + 0x20 - 0x2700); // direct map
	    }
	}
	return len;
    }
}
