/*
 * @(#)MCheckboxMenuItemPeer.java	1.15 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.motif;


import java.awt.*;
import java.awt.peer.*;
import java.awt.event.ItemEvent;

class MCheckboxMenuItemPeer extends MMenuItemPeer implements CheckboxMenuItemPeer {

    void create(MMenuPeer parent) {
        super.create(parent);
        setState(((CheckboxMenuItem)target).getState());
    }

    MCheckboxMenuItemPeer(CheckboxMenuItem target) {
	this.target = target;
	isCheckbox = true;
	MMenuPeer parent = (MMenuPeer) MToolkit.targetToPeer(getParent_NoClientCode(target));
	create(parent);
    }

    public void setState(boolean t) {
        if (!nativeCreated) {
            return;
        }
        pSetState(t);
    }
    native void pSetState(boolean t);

    // NOTE: This method may be called by privileged threads.
    //       DO NOT INVOKE CLIENT CODE ON THIS THREAD!
    public void action(long when, int modifiers, boolean state) {
	final CheckboxMenuItem cb = (CheckboxMenuItem)target;
	final boolean newState = state;

	MToolkit.executeOnEventHandlerThread(cb, new Runnable() {
	    public void run() {
	        cb.setState(newState);
                postEvent(new ItemEvent(cb, ItemEvent.ITEM_STATE_CHANGED,
                                target.getLabel(), 
                                newState? ItemEvent.SELECTED : ItemEvent.DESELECTED));
	    }
	});
    } // action()
} // class MCheckboxMenuItemPeer
	
