/*
 * @(#)MFontPeer.java	1.10 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.motif;

import sun.io.CharToByteConverter;
import sun.awt.PlatformFont;
import sun.io.CharToByteISO8859_1;

public class MFontPeer extends PlatformFont {

    /*
     * XLFD name for XFontSet.
     */
    private String xfsname;
    /*
     * converter name for this XFontSet encoding.
     */
    private String converter;

    static {
	initIDs();
    }

    /**
     * Initialize JNI field and method IDs for fields that may be
       accessed from C.
     */
    private static native void initIDs();

    public MFontPeer(String name, int style){
	super(name, style);

	if (props != null){
	    xfsname = props.getProperty
		("fontset." + aliasName + "." + styleString);
	}
    }

    public CharToByteConverter
	getFontCharset(String charsetName, String fontName){

	CharToByteConverter fc;
	if (charsetName.equals("default")){
	    fc = (CharToByteConverter)charsetRegistry.get(fontName);
	} else {
	    fc = (CharToByteConverter)charsetRegistry.get(charsetName);
	}
	if (fc instanceof CharToByteConverter){
	    return fc;
	}

	Class fcc;
	
	try {
	    fcc = Class.forName(charsetName);
	} catch(ClassNotFoundException e){
	    try {
		fcc = Class.forName("sun.io." + charsetName);
	    } catch (ClassNotFoundException exx){
		try {
		    fcc = Class.forName("sun.awt.motif." + charsetName);
		} catch(ClassNotFoundException ex){ 
		    return getDefaultFontCharset(fontName);
		}
	    }
	}

	try {
	    fc = (CharToByteConverter)fcc.newInstance();
	} catch(InstantiationException e){
	    return getDefaultFontCharset(fontName);
	} catch(IllegalAccessException e){
	    return getDefaultFontCharset(fontName);
	}

	if (charsetName.equals("default")){
	    charsetRegistry.put(fontName, fc);
	} else {
	    charsetRegistry.put(charsetName, fc);
	}
	return fc;
    }


    private CharToByteConverter getDefaultFontCharset(String fontName){
	return new CharToByteISO8859_1();
    }
}
