/*
 * @(#)PrintControl.java	1.4 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.motif;

import java.awt.*;

/** 
 * An interface for creating a PrintJob object from a given set of
 * print properties.
 *
 * @version 	1.4 09/21/98
 * @author 	Amy Fowler
 */
public interface PrintControl {

    /**
     * Printer destination type. 
     */
    public final static int PRINTER = 0;

    /**
     * File destination type.
     */
    public final static int FILE = 1;

    /**
     * Number of destination types.
     */
    public final static int DEST_N = 2;

    /**
     * Landscape print orientation.
     */
    public final static int LANDSCAPE = 0;

    /**
     * Portrait print orientation.
     */
    public final static int PORTRAIT = 1;

    /**
     * Number of orientation types.
     */
    public final static int ORIENT_N = 2;

    /**
     * Letter paper size.
     */
    public final static int PAPER_LETTER = 0;

    /**
     * Legal paper size.
     */
    public final static int PAPER_LEGAL = 1;

    /**
     * Excecutive paper size.
     */
    public final static int PAPER_EXECUTIVE = 2;

    /**
     * A4 paper size.
     */
    public final static int PAPER_A4 = 3;

    /**
     * Number of paper types.
     */
    public final static int PAPER_N = 4;


    public PrintJob createPrintJob(int destType, String destString, String lpOptions,
                      String bannerStr, int paperSize, int orient, int numCopies); 

}

        
        
