/*
 * @(#)PrintStatusDialog.java	1.5 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.motif;

import java.awt.*;
import java.awt.event.*;


/** 
 * A class for creating a dialog to display print status
 * messages to the user.
 *
 * @version 	1.5 09/21/98
 * @author 	Amy Fowler
 */
public class PrintStatusDialog extends Dialog implements ActionListener {
    Panel buttonPanel;
    String command;

    PrintStatusDialog(Frame f, String title, String msg) {
        super(f, title, true);
        setLayout(new BorderLayout());

        Label l = new Label(msg);
        add("Center", l);

        buttonPanel = new Panel();
        buttonPanel.setLayout(new FlowLayout());
        add("South", buttonPanel);

    }

    public PrintStatusDialog(Frame f, String title, String msg,
                             String command) {
        this(f, title, msg);
        Button b = new Button(command);
        b.setActionCommand(command);
        buttonPanel.add(b);
        b.addActionListener(this);

        pack();
    }

    public PrintStatusDialog(Frame f, String title, String msg,
                             String command1, String command2) {
        this(f, title, msg, command1);
        Button b = new Button(command2);
        b.setActionCommand(command2);
        buttonPanel.add(b);
        b.addActionListener(this);

        pack();
    }

    public void actionPerformed(ActionEvent e) {
        command = e.getActionCommand();
        hide();
    }

    public String getCommand() {
        return command;
    }
}
 

        
        
