/*
 * @(#)X11GIFAcceleratorLoops.java	1.10 98/05/27
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.motif;

import sun.java2d.loops.ImageData;
import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.loops.GraphicsPrimitives;
import sun.java2d.loops.TransparentBlit;
import sun.java2d.loops.TransparentDitheredBlit;
import sun.java2d.loops.GraphicsPrimitiveProxy;

/**
 * X11GIFAcceleratorLoops collection
 * Basically, a collection of components which permit display
 * of 8-bit images on various drawing surfaces, using region
 * masks to prevent exposure of transparent pixels
 */

public final class X11GIFAcceleratorLoops implements GraphicsPrimitives {

    static int[] ST_BYTE_INDEXED_BM__BYTE_INDEXED = { GraphicsPrimitive.TYPE_BYTE_INDEXED_BM, 
					              GraphicsPrimitive.TYPE_BYTE_INDEXED};
    static int[] ST_BYTE_INDEXED_BM__INT_BGR = { GraphicsPrimitive.TYPE_BYTE_INDEXED_BM, 
					         GraphicsPrimitive.TYPE_INT_BGR};

    public final GraphicsPrimitive[] getPrimitives() {
        GraphicsPrimitive[] primitives = {
            new GraphicsPrimitiveProxy(this, "LUTxparToIndexed",
					ST_BYTE_INDEXED_BM__BYTE_INDEXED,
					TransparentBlit.getMethodSignature()),
            new GraphicsPrimitiveProxy(this, "LUTxparToIntBgr",
					ST_BYTE_INDEXED_BM__INT_BGR,
					TransparentBlit.getMethodSignature())
        };
        return primitives;
    }

/**
*   Bitmasked Transparent pixels, Opaque copy over destination
*/
    static native void LUTxparToIndexed(
        ImageData srcImage,
        ImageData dstImage,
        int width, int height
    );

    static native void LUTxparToIntBgr(
        ImageData srcImage,
        ImageData dstImage,
        int width, int height
    );
}
