/*
 * @(#)TinyCanvasPeer.java	1.9 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.tiny;

import java.awt.*;
import java.awt.peer.*;

class TinyCanvasPeer extends TinyComponentPeer implements CanvasPeer {
    TinyCanvasPeer() {
    }

    TinyCanvasPeer(Canvas target) {
	winCreate((TinyComponentPeer)target.getParent().getPeer());
	init(target);
    }

    void paintComponent(Graphics g) {
	g.setColor(target.getBackground());
	g.fillRect(0, 0, width, height);
    }
    public void update(Graphics g) {
	target.update(g);
    }

    public boolean handleWindowEvent(Event evt) {
	switch(evt.id) {
	  case Event.KEY_PRESS:
	  case Event.KEY_RELEASE:
	  case Event.KEY_ACTION:
	  case Event.KEY_ACTION_RELEASE:
	  case Event.GOT_FOCUS:
	  case Event.LOST_FOCUS:
	    // NEW_EVENT_MODEL: already delivered to target
	    return true;
	  case Event.MOUSE_DOWN: 
	    requestFocus();
	    //fall-thru	
	  default:
	    evt.target = target;
	    targetEvent(evt);
	}
	return true;
    }

    public void requestFocus() {
	requestFocus(this);
    }
}




