/*
 * @(#)TinyDialogPeer.java	1.12 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.tiny;

import java.awt.*;
import java.awt.peer.*;

class TinyDialogPeer extends TinyWindowPeer implements DialogPeer {
    TinyDialogPeer() {
    }

    TinyDialogPeer(Dialog target) {
	String str = target.getTitle() == null ? "Dialog" : target.getTitle();

	if (useTinyWindowManager()) {
	    frame = new TinyWindowFrame(this, str, target.getWarningString(), target.isResizable());
	} else {
	    frame = new TinyWinManagerFrame(this, str, target.getWarningString(), target.isResizable());
	}
	init(target);
    }

    public void setTitle(String title) {
	frame.setTitle(title);
    }
    public void setResizable(boolean r) {
	frame.setResizable(r);
    }	
    // Pass this on to the frame and let it deal with it.
    public void dispose() {
	frame.dispose();
    }
}

