/*
 * @(#)TinyFramePeer.java	1.13 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.tiny;

import java.util.Vector;
import java.awt.*;
import java.awt.peer.*;
import java.awt.image.ImageObserver;
import sun.awt.image.ImageRepresentation;

class TinyFramePeer extends TinyWindowPeer implements FramePeer {
    TinyFramePeer(Frame target) {
	if (useTinyWindowManager()) {
	    frame = new TinyWindowFrame(this, target.getTitle(), target.getWarningString(), target.isResizable());
	} else {
	    frame = new TinyWinManagerFrame(this, target.getTitle(), target.getWarningString(), target.isResizable());
	}
	Image icon = target.getIconImage();
	if (icon != null) {
	    setIconImage(icon);
	}
	init(target);
    }

    public void setTitle(String title) {
	frame.setTitle(title);
    }
    public void setResizable(boolean r) {
	frame.setResizable(r);
    }
    public void setIconImage(Image im) {
	frame.setIconImage(im);
    }
    public void setMenuBar(MenuBar mb) {
	frame.setMenuBar((mb == null) ? null : (TinyMenuBarPeer)mb.getPeer());
    }	
    public void setCursor(int cursorType) {
	frame.setCursor(cursorType);
    }
    // Pass this on to the frame and let it deal with it.
    public void dispose() {
	frame.dispose();
    }
}




