/*
 * @(#)TinyImage.java	1.12 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.tiny;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.image.ImageProducer;

import sun.awt.image.ImageRepresentation;

class TinyImage extends sun.awt.image.Image {
    /**
     * Construct an image from an ImageProducer object.
     */
    public TinyImage(ImageProducer producer) {
	super(producer);
    }

    public Graphics getGraphics() {
	Graphics g = new TinyGraphics(this);
	return g;
    }

    protected ImageRepresentation makeImageRep() {
        // REMIND:  might want a different color model/image type
	return new ImageRepresentation(this, ColorModel.getRGBdefault(),
                                       false);
    }

    protected ImageRepresentation getImageRep() {
	return super.getImageRep();
    }
}
