/*
 * @(#)OutputFile.java	1.9 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


/*
 * Associate this class with classes File and InputFile (already part
 * of package demo) into package demo.
 *
 */
package demo;


/**
 * This class defines a simple writeonly file by extending class File.
 *
 */
public
class OutputFile extends File {

    /**
     * Link in the native library that this class depends on.  We
     * bind this class loading to the library loading by making the
     * System.loadLibrary() call part of the static initializer for
     * the class.  That is, if the loadLibary() call fails this class
     * fails to load.
     *
     */
    static {
        System.loadLibrary("file");
    }

    /**
     * Holds the system dependent handle to the file resource.
     *
     */
    protected int fd;

    /**
     * Constructor for the output file object.  Initializes the
     * parent class with the path name.
     *
     */
    public OutputFile(String path) {
	super(path);
    }

    /**
     * Attempts to open the file for writing.  If the file does not
     * exist one is created.  Returns TRUE on success and FALSE on 
     * failure.
     *
     */
    public native boolean open();

    /**
     * Attempts to close the previously opened file.  Has
     * no return value.
     */
    public native void close();

    /**
     * Writes some number of bytes to the opened file.  Returns
     * the number of bytes written.
     *
     */
    public native int write(byte b[], int len);
}
