/*
 * @(#)context_md.h	1.29 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Solaris-dependent API
 */

#ifndef _JAVASOFT_SOLARIS_CONTEXT_MD_H_
#define _JAVASOFT_SOLARIS_CONTEXT_MD_H_

#include <errno.h>
#include <setjmp.h>

/*
 * A solaris2 context.  Everything else is on the stack.
 */

typedef struct {
    unsigned int unix_errno;
    stackp_t current_sp;
    jmp_buf env;
} context_t;

/* Save state of the current content and call rescheduler */

void reschedule(void);


#define	switchContext(contextp) {			\
    errno = (contextp)->unix_errno;			\
    longjmp((contextp)->env, 1);			\
}


#define saveContext(contextp, sp)				\
    ((contextp)->current_sp = sp, setjmp((contextp)->env))

#define yieldContext(contextp)					\
{								\
    unsigned char *dummy;					\
    if (saveContext((contextp), (stackp_t)&dummy) == 0) {	\
	(contextp)->unix_errno = errno;				\
	reschedule();						\
    }								\
}

#endif /* !_JAVASOFT_SOLARIS_CONTEXT_MD_H_ */
