/*
 * @(#)itimer_md.h	1.15 98/09/21
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Machine or host dependent API.
 */

#ifndef _JAVASOFT_SOLARIS_ITIMER_H_
#define _JAVASOFT_SOLARIS_ITIMER_H_

#include <timeval_md.h>

/*
 *	timeval_t currentTime(): return the current time, a 64 bit
 *	    integer, in units of microseconds.
 *	unsigned int hostClockInit(): do any platform specific
 *	    initialization for the clock.  Return a monitor that the async
 *	    notification will be performed upon.
 *	void scheduleAlarm(timeval_t): schedule the alarm to occur
 *	    the indicated number of microseconds in the future.
 *	void cancelAlarm(): cancel the pending alarm (if any).
 */

timeval_t currentTime(void);
unsigned int hostClockInit(void);
void scheduleAlarm(timeval_t);
void cancelAlarm(void);

#endif /* !_JAVASOFT_SOLARIS_ITIMER_H_ */
