/*
 * @(#)mutex_md.h	1.3 98/09/15
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Interface to mutex HPI implementation for Solaris
 */

#ifndef _JAVASOFT_MUTEX_MD_H_
#define _JAVASOFT_MUTEX_MD_H_

#include <synch.h>

/*
 * Generally, we would typedef mutex_t to be whatever the system
 * supplies.  But Solaris gives us mutex_t directly.
 */

#define mutexOwner(m) (*(sys_thread_t **)&((m)->lock.owner64))

#define mutexInit(m) memset(m, 0, sizeof(*m))
#define mutexDestroy(m) ((void) 0)
#define mutexLocked(m) \
	(mutexOwner(m) == greenThreadSelf())

int mutexLock(mutex_t * m);
int mutexUnlock(mutex_t * m);

#endif /* !_JAVASOFT_MUTEX_MD_H_ */
