/*
 * @(#)edi.s	1.4 98/03/18
 *
 * Copyright 1995-1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
	
        .text

//
// Workaround for BUG 4026661/1262991:
// create a private copy (fix) for x86 green threads getcontext
// called green_getcontext to avoid the libc getcontext bug.
// Furthermore, the green_getcontext code differs from the
// libc behavior since it does not call __cerror if the system
// call fails. Reference to __cerror was removed since its no
// longer a global in Solaris 2.6 libc. This change in API should
// be benign to the VM (we don't check for getcontext return code).
//	
//  x86 getcontext bug workaround: local copy here
//
        .globl  green_getcontext
        .type   green_getcontext,@function
        .globl  _green_getcontext
        .type   _green_getcontext,@function
        .align  4
        .align  4
	
green_getcontext:
_green_getcontext:
	/ UC_ALL	0xf
	/ UC_MCONTEXT	0x24
	/ EIP		0xe
	/ EAX		0xb (11)
	/ EBX		0x8
	/ UESP		0x11
	movl	4(%esp),%eax	/ %eax <-- first arg: ucp
	movl    $0xf,(%eax)	/ ucp->uc_flags = UC_ALL
	pushl   %eax		/ push ucp for system call
	call    _green_sys_getcontext	/ call __getcontext: syscall
	addl    $4,%esp		/ pop arg
	andl	%eax,%eax	/ if (error_return_from_syscall)
	jne	.L2		/ 	then return 
	movl    4(%esp),%eax	/ recompute first arg

	/ now fix up %ebx, %esp, and %eip; 
	/ %edi, %esi and %ebp are untouched here since
	/ this is in assembler
 	/ first, cpup = (greg_t *)&ucp->uc_mcontext.gregs;
	
        leal    [0x24](%eax),%edx	/ %edx <-- &ucp->uc_mcontext.gregs
	movl	0(%esp),%eax		/ read return PC from stack
	movl	%eax,0xe\*4(%edx)	/ store ret PC in EIP of env var
	movl    %ebx,0x8\*4(%edx)	/ store caller's %ebx (unchanged)
	leal	4(%esp),%eax		/ get caller's sp at time of call
	movl	%eax,0x11\*4(%edx)	/ store this sp into UESP of env var
	xorl	%eax,%eax		/ return 0
	movl	%eax,0xb\*4(%edx)	/ getcontext returns 0 after setcontext
.L2:
	ret
	
        .globl  _green_sys_getcontext
        .type   _green_sys_getcontext,@function
/       .globl  __cerror
        .align  4
        .align  4

_green_sys_getcontext:
        popl    %edx
        pushl   $0
        pushl   %edx
        jmp     sys

sys:
        movl    $0x64,%eax
        lcall   $0x7,$0
        popl    %edx
        movl    %edx,0(%esp)
/        jae     noerror
/        jmp     __cerror
noerror:
        ret
