/*
 * @(#)porting.h	1.4 98/09/16
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef _JAVASOFT_PORTING_H_
#define _JAVASOFT_PORTING_H_

#ifndef USE_PTHREADS

#include <thread.h>
#include <sys/lwp.h>
#include <synch.h>

#else  /* USE_PTHREADS */

#include <pthread.h>
#undef BOUND_THREADS

#define thread_t		pthread_t

#define mutex_t			pthread_mutex_t
#define mutex_lock		pthread_mutex_lock
#define mutex_trylock		pthread_mutex_trylock
#define mutex_unlock		pthread_mutex_unlock
#define mutex_destroy		pthread_mutex_destroy

#define cond_t			pthread_cond_t
#define cond_destroy		pthread_cond_destroy
#define cond_wait		pthread_cond_wait
#define cond_timedwait		pthread_cond_timedwait
#define cond_signal		pthread_cond_signal
#define cond_broadcast		pthread_cond_broadcast

#define thread_key_t		pthread_key_t
#define thr_setspecific		pthread_setspecific
#define thr_keycreate		pthread_key_create

#define thr_sigsetmask		pthread_sigmask
#define thr_self		pthread_self
#define thr_yield		sched_yield
#define thr_kill		pthread_kill
#define thr_exit		pthread_exit
#endif /* USE_PTHREADS  */

#endif /* !_JAVASOFT_PORTING_H_ */
