/*
 * @(#)mutex_md.c	1.20 98/08/24
 *
 * Copyright 1994-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Mutex HPI implementation for Solaris
 *
 * Mutexes are used both by the system-independent monitor implementation and
 * to implement critical regions elsewhere within the runtime.
 */

#include <errno.h>

#include "hpi_impl.h"

#include "mutex_md.h"
#include "threads_md.h"

/*
 * Return true of the mutex in question is already locked.  note:
 * this does not tell if the mutex is already locked by *this*
 * thread, only that is is locked by *some* thread.
 */
bool_t
mutexLocked(mutex_t *mutex)
{
    if (mutex_trylock(mutex) == 0) {
	mutex_unlock(mutex);
	return FALSE;
    }
    return TRUE;
}
