/*
 * @(#)VDrawingAreaP.h	1.3 98/09/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef _VDrawingAreaP_h_
#define _VDrawingAreaP_h_

#include <Xm/DrawingAP.h>
#include "VDrawingArea.h"


/***************************************************************
 * VDrawingArea Widget Data Structures
 *
 *
 **************************************************************/

/* Define part class structure */
typedef struct _VDrawingAreaClass {
	XtPointer			extension;
} VDrawingAreaClassPart;

/* Define the full class record */
typedef struct _VDrawingAreaClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	XmDrawingAreaClassPart	drawing_area_class;
	VDrawingAreaClassPart	vdrawingarea_class;
} VDrawingAreaClassRec;

/* External definition for class record */
extern VDrawingAreaClassRec vDrawingAreaClassRec;

typedef struct {
	Visual *visual;
} VDrawingAreaPart;

/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _VDrawingAreaRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	XmDrawingAreaPart	drawing_area;
	VDrawingAreaPart	vdrawing_area;
} VDrawingAreaRec;



#endif /* !_VDrawingAreaP_h_ */
