/*
 * @(#)awt_Cursor.c	1.2 98/09/21
 *
 * Copyright 1993-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "java_awt_Cursor.h"
#include "jni_util.h"
#include "awt_Cursor.h"

/* fieldIDs for Cursor fields that may be accessed from C */
struct CursorIDs cursorIDs;


/*
 * Class:     java_awt_Cursor
 * Method:    initIDs
 * Signature: ()V
 */

/* This function gets called from the static initializer for Cursor.java
   to initialize the fieldIDs for fields that may be accessed from C */
JNIEXPORT void JNICALL
Java_java_awt_Cursor_initIDs(JNIEnv *env, jclass cls)
{
    cursorIDs.type = (*env)->GetFieldID(env, cls, "type", "I");
}


/* fieldIDs for X11CustomCursor fields that may be accessed from C */
struct X11CustomCursorIDs x11CustomCursorIDs;


/*
 * Class:     sun_awt_motif_X11CustomCursor
 * Method:    initIDs
 * Signature: ()V
 */

/* This function gets called from the static initializer for
   X11CustomCursor.java
   to initialize the fieldIDs for fields that may be accessed from C */
JNIEXPORT void JNICALL
Java_sun_awt_motif_X11CustomCursor_initIDs(JNIEnv *env, jclass cls)
{
    x11CustomCursorIDs.pData = (*env)->GetFieldID(env, cls, "pData", "J");
}
