/*
 * @(#)awt_MenuBar.c	1.27 98/07/29
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
#include "awt_p.h"
#include "java_awt_MenuBar.h"
#include "sun_awt_motif_MMenuBarPeer.h"
#include "java_awt_Menu.h"
#include "java_awt_Frame.h"
#include "sun_awt_motif_MFramePeer.h"

#include "awt_MenuBar.h"
#include "awt_Component.h"

#include <jni.h>
#include <jni_util.h>

extern struct MComponentPeerIDs mComponentPeerIDs;

struct MMenuBarPeerIDs mMenuBarPeerIDs;

/*
 * Class:     sun_awt_motif_MMenuBarPeer
 * Method:    initIDs
 * Signature: ()V
 */

/* This function gets called from the static initializer for MMenuBarPeer.java
   to initialize the fieldIDs fields that may be accessed from C */
JNIEXPORT void JNICALL 
Java_sun_awt_motif_MMenuBarPeer_initIDs
  (JNIEnv *env, jclass cls)
{
  mMenuBarPeerIDs.pData = (*env)->GetFieldID(env, cls, "pData", "J");
}

/*
 * Class:     sun_awt_motif_MMenuBarPeer
 * Method:    create
 * Signature: (Lsun/awt/motif/MFramePeer;)V
 */
JNIEXPORT void JNICALL Java_sun_awt_motif_MMenuBarPeer_create
  (JNIEnv * env, jobject this, jobject frame)
{
    Arg args[20];
    int argc;
    struct ComponentData *mdata;
    struct FrameData *wdata;
    Pixel bg;
    Pixel fg;

    if (JNU_IsNull(env, frame)) {
        JNU_ThrowNullPointerException(env, "NullPointerException");
        return;
    }
    AWT_LOCK();
    wdata = (struct FrameData *)
      (*env)->GetLongField(env, frame, mComponentPeerIDs.pData);
    mdata = ZALLOC(ComponentData);

    if (wdata == 0 || mdata == 0) {
        JNU_ThrowNullPointerException(env, "NullPointerException");
        AWT_UNLOCK();
        return;
    }
    (*env)->SetLongField(env, this, mMenuBarPeerIDs.pData, (jlong) mdata);
    XtVaGetValues(wdata->winData.comp.widget,
                  XmNbackground, &bg,
                  XmNforeground, &fg,
                  NULL);

    argc = 0;
    XtSetArg(args[argc], XmNbackground, bg);
    argc++;
    XtSetArg(args[argc], XmNforeground, fg);
    argc++;
    mdata->widget = XmCreateMenuBar(wdata->mainWindow, "menu_bar", args, argc);
    XtSetMappedWhenManaged(mdata->widget, False);
    XtManageChild(mdata->widget);
    AWT_UNLOCK();
}

/*
 * Class:     sun_awt_motif_MMenuBarPeer
 * Method:    dispose
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_sun_awt_motif_MMenuBarPeer_pDispose
  (JNIEnv * env, jobject this)
{
    struct ComponentData *mdata;

    AWT_LOCK();

    /*hania LOOK HERE does this make sense? look at original code */
    mdata = (struct ComponentData *)
      (*env)->GetLongField(env, this, mMenuBarPeerIDs.pData);
    if (mdata == 0) {
        AWT_UNLOCK();
        return;
    }
    XtUnmanageChild(mdata->widget);
    awt_util_consumeAllXEvents(mdata->widget);
    XtDestroyWidget(mdata->widget);
    free((void *) mdata);
    (*env)->SetLongField(env, this, mMenuBarPeerIDs.pData, 0);
    AWT_UNLOCK();
}

