/* 
 * @(#)fontObject_md.h	1.5 98/09/21
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A. 
 * All rights reserved. 
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You 
 * shall not disclose such Confidential Information and shall use 
 * it only in accordance with the terms of the license agreement 
 * you entered into with Sun. 
 */
 
/* 
 * @author Joe Warzecha
 */ 

#ifndef _FONTOBJECT_MD_H_
#define _FONTOBJECT_MD_H_

#include "fontObject.h"
#include <jlong_md.h>
#include "font.h"

#define USE_NATIVE_RASTERIZER 
/* #undef USE_NATIVE_RASTERIZER */

class X11CharToGlyphMapper : public CharToGlyphMapper {
private:
    UInt16 *convertedGlyphs;
    int convertedCount;
    UInt16 *reverseMap;
    int reverseCount;
    short nBytes;
    char *psEncoding;
public:
    X11CharToGlyphMapper (char* javaclass, short numBytes, char *psEnc,
			  UInt16 maxUnicode, UInt16 minUnicode);
    virtual ~X11CharToGlyphMapper ();
    virtual void CharsToGlyphs (int count, const Unicode unicodes [],	
			  UInt32 glyphs []) const;
    virtual Boolean canDisplay (Unicode ch) const;
    char *GetPSEncoding () { return psEncoding ; }
    void AddAsciiChars () ;
    const Unicode GlyphToUnicode (UInt16 glyphID);
};

class X11FontObject : public fileFontObject {
 private:
    char *familyName;
    char *slant;
    char *style;
    char *fontName;
    char *PSfontName;
 public: 
    X11FontObject () : fontName (0), PSfontName (0), familyName (0),
				slant (0), style (0) { } ; 
    ~X11FontObject ();
    char *GetPSName () { return PSfontName; }
    char *GetX11Name () { return fontName; }
    char *GetFamilyName () { return familyName; }
    char *GetSlant () { return slant; }
    char *GetStyle () { return style; }
    void SetPSName (char *psfontname) { 
	PSfontName = strdup (psfontname);
    }
    virtual int GetName(UInt16& platformID, UInt16& scriptID,
                        UInt16& languageID, UInt16& nameID, UInt16 *name);
    virtual const Unicode *GetFontName(int& nameLen);
    virtual Boolean MatchName(int nameID, const UInt16 *name, int nameLen);
    virtual enum FontFormats getScalerID (FontTransform& tx,
				jboolean isAntiAliased,
				jboolean usesFractionalMetrics)
	{ return kNRFontFormat; }
private:
    void MakeFontName ();
};

#endif
