/*
 * @(#)mlib_v_ImageLookUp.c	1.3 98/08/21
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#pragma ident	"@(#)mlib_v_ImageLookUp.c	1.4	98/07/28 SMI"

/*
 * $RCSfile: mlib_v_ImageLookUp.c,v $
 * $Revision: 4.1 $
 * $Date: 1996/12/11 20:43:36 $
 * $Author: liang $
 */

/*
 * FUNCTION
 *      mlib_ImageLookUp - table lookup
 *
 * SYNOPSIS
 *      mlib_status mlib_ImageLookUp(mlib_image *dst,
 *                                   mlib_image *src,
 *                                   void **table);
 *
 * ARGUMENT
 *      dst     printer to output image
 *      src     printer to input image
 *      table   lookup table
 *
 * DESCRIPTION
 *      dst = table[src]
 */




#include <stdlib.h>
#include "mlib_image.h"

/***************************************************************/

void mlib_v_ImageLookUp_U8_U8_1(mlib_u8  *sa, mlib_s32 slb,
                                mlib_u8  *da, mlib_s32 dlb,
                                mlib_s32 xsize, mlib_s32 ysize,
                                mlib_u8  **table);
void mlib_v_ImageLookUp_U8_U8_2(mlib_u8  *sa, mlib_s32 slb,
                                mlib_u8  *da, mlib_s32 dlb,
                                mlib_s32 xsize, mlib_s32 ysize,
                                mlib_u8  **table);
void mlib_v_ImageLookUp_U8_U8_3(mlib_u8  *sa, mlib_s32 slb,
                                mlib_u8  *da, mlib_s32 dlb,
                                mlib_s32 xsize, mlib_s32 ysize,
                                mlib_u8  **table);
void mlib_v_ImageLookUp_U8_U8_4(mlib_u8  *sa, mlib_s32 slb,
                                mlib_u8  *da, mlib_s32 dlb,
                                mlib_s32 xsize, mlib_s32 ysize,
                                mlib_u8  **table);

void mlib_v_ImageLookUp_S16_U8_1(mlib_s16 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);
void mlib_v_ImageLookUp_S16_U8_2(mlib_s16 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);
void mlib_v_ImageLookUp_S16_U8_3(mlib_s16 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);
void mlib_v_ImageLookUp_S16_U8_4(mlib_s16 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);

void mlib_v_ImageLookUp_S32_U8_1(mlib_s32 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);
void mlib_v_ImageLookUp_S32_U8_2(mlib_s32 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);
void mlib_v_ImageLookUp_S32_U8_3(mlib_s32 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);
void mlib_v_ImageLookUp_S32_U8_4(mlib_s32 *sa, mlib_s32 slb,
                                 mlib_u8  *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table);

void mlib_v_ImageLookUp_U8_S16_1(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s16 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s16 **table);
void mlib_v_ImageLookUp_U8_S16_2(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s16 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s16 **table);
void mlib_v_ImageLookUp_U8_S16_3(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s16 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s16 **table);
void mlib_v_ImageLookUp_U8_S16_4(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s16 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s16 **table);

void mlib_v_ImageLookUp_S16_S16_1(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);
void mlib_v_ImageLookUp_S16_S16_2(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);
void mlib_v_ImageLookUp_S16_S16_3(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);
void mlib_v_ImageLookUp_S16_S16_4(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);

void mlib_v_ImageLookUp_S32_S16_1(mlib_s32 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);
void mlib_v_ImageLookUp_S32_S16_2(mlib_s32 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);
void mlib_v_ImageLookUp_S32_S16_3(mlib_s32 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);
void mlib_v_ImageLookUp_S32_S16_4(mlib_s32 *sa, mlib_s32 slb,
                                  mlib_s16 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table);

void mlib_v_ImageLookUp_U8_S32_1(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s32 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s32 **table);
void mlib_v_ImageLookUp_U8_S32_2(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s32 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s32 **table);
void mlib_v_ImageLookUp_U8_S32_3(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s32 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s32 **table);
void mlib_v_ImageLookUp_U8_S32_4(mlib_u8  *sa, mlib_s32 slb,
                                 mlib_s32 *da, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_s32 **table);

void mlib_v_ImageLookUp_S16_S32_1(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s32 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s32 **table);
void mlib_v_ImageLookUp_S16_S32_2(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s32 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s32 **table);
void mlib_v_ImageLookUp_S16_S32_3(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s32 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s32 **table);
void mlib_v_ImageLookUp_S16_S32_4(mlib_s16 *sa, mlib_s32 slb,
                                  mlib_s32 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s32 **table);

void mlib_v_ImageLookUp_S32_S32(mlib_s32 *sa, mlib_s32 slb,
                                mlib_s32 *da, mlib_s32 dlb,
                                mlib_s32 xsize, mlib_s32 ysize,
                                mlib_s32 **table, mlib_s32 csize);

/***************************************************************/

void mlib_v_ImageLookUpSI_U8_U8_2(mlib_u8  *sa, mlib_s32 slb,
                                  mlib_u8  *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_u8  **table);
void mlib_v_ImageLookUpSI_U8_U8_3(mlib_u8  *sa, mlib_s32 slb,
                                  mlib_u8  *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_u8  **table);
void mlib_v_ImageLookUpSI_U8_U8_4(mlib_u8  *sa, mlib_s32 slb,
                                  mlib_u8  *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_u8  **table);

void mlib_v_ImageLookUpSI_S16_U8_2(mlib_s16 *sa, mlib_s32 slb,
                                   mlib_u8  *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_u8  **table);
void mlib_v_ImageLookUpSI_S16_U8_3(mlib_s16 *sa, mlib_s32 slb,
                                   mlib_u8  *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_u8  **table);
void mlib_v_ImageLookUpSI_S16_U8_4(mlib_s16 *sa, mlib_s32 slb,
                                   mlib_u8  *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_u8  **table);

void mlib_v_ImageLookUpSI_S32_U8_2(mlib_s32 *sa, mlib_s32 slb,
                                   mlib_u8  *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_u8  **table);
void mlib_v_ImageLookUpSI_S32_U8_3(mlib_s32 *sa, mlib_s32 slb,
                                   mlib_u8  *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_u8  **table);
void mlib_v_ImageLookUpSI_S32_U8_4(mlib_s32 *sa, mlib_s32 slb,
                                   mlib_u8  *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_u8  **table);

void mlib_v_ImageLookUpSI_U8_S16_2(mlib_u8  *sa, mlib_s32 slb,
                                   mlib_s16 *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_s16 **table);
void mlib_v_ImageLookUpSI_U8_S16_3(mlib_u8  *sa, mlib_s32 slb,
                                   mlib_s16 *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_s16 **table);
void mlib_v_ImageLookUpSI_U8_S16_4(mlib_u8  *sa, mlib_s32 slb,
                                   mlib_s16 *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_s16 **table);

void mlib_v_ImageLookUpSI_S16_S16_2(mlib_s16 *sa, mlib_s32 slb,
                                    mlib_s16 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s16 **table);
void mlib_v_ImageLookUpSI_S16_S16_3(mlib_s16 *sa, mlib_s32 slb,
                                    mlib_s16 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s16 **table);
void mlib_v_ImageLookUpSI_S16_S16_4(mlib_s16 *sa, mlib_s32 slb,
                                    mlib_s16 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s16 **table);

void mlib_v_ImageLookUpSI_S32_S16_2(mlib_s32 *sa, mlib_s32 slb,
                                    mlib_s16 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s16 **table);
void mlib_v_ImageLookUpSI_S32_S16_3(mlib_s32 *sa, mlib_s32 slb,
                                    mlib_s16 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s16 **table);
void mlib_v_ImageLookUpSI_S32_S16_4(mlib_s32 *sa, mlib_s32 slb,
                                    mlib_s16 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s16 **table);

void mlib_v_ImageLookUpSI_U8_S32_2(mlib_u8  *sa, mlib_s32 slb,
                                   mlib_s32 *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_s32 **table);
void mlib_v_ImageLookUpSI_U8_S32_3(mlib_u8  *sa, mlib_s32 slb,
                                   mlib_s32 *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_s32 **table);
void mlib_v_ImageLookUpSI_U8_S32_4(mlib_u8  *sa, mlib_s32 slb,
                                   mlib_s32 *da, mlib_s32 dlb,
                                   mlib_s32 xsize, mlib_s32 ysize,
                                   mlib_s32 **table);

void mlib_v_ImageLookUpSI_S16_S32_2(mlib_s16 *sa, mlib_s32 slb,
                                    mlib_s32 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s32 **table);
void mlib_v_ImageLookUpSI_S16_S32_3(mlib_s16 *sa, mlib_s32 slb,
                                    mlib_s32 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s32 **table);
void mlib_v_ImageLookUpSI_S16_S32_4(mlib_s16 *sa, mlib_s32 slb,
                                    mlib_s32 *da, mlib_s32 dlb,
                                    mlib_s32 xsize, mlib_s32 ysize,
                                    mlib_s32 **table);

void mlib_v_ImageLookUpSI_S32_S32(mlib_s32 *sa, mlib_s32 slb,
                                  mlib_s32 *da, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s32 **table, mlib_s32 csize);

/***************************************************************/

#ifdef MLIB_TEST

mlib_status mlib_v_ImageLookUp(mlib_image *dst,
                               mlib_image *src,
                               void **table)
#else

mlib_status mlib_ImageLookUp(mlib_image *dst,
                             mlib_image *src,
                             void **table)
#endif

{
  mlib_s32   slb, dlb, xsize, ysize, nchan, ichan;
  mlib_type  stype, dtype;
  void       *sa, *da;

#ifdef MLIB_DEBUG
  if (mlib_ImageGetType(src) == MLIB_BIT) {
    return MLIB_FAILURE;
  }

  if (mlib_ImageGetType(dst) == MLIB_BIT) {
    return MLIB_FAILURE;
  }

  if (mlib_ImageGetChannels(src) != 1) {
    if (mlib_ImageGetChannels(src) != mlib_ImageGetChannels(dst)) {
      return MLIB_FAILURE;
    }
  }

  if (mlib_ImageGetWidth(src) != mlib_ImageGetWidth(dst)) {
    return MLIB_FAILURE;
  }

  if (mlib_ImageGetHeight(src) != mlib_ImageGetHeight(dst)) {
    return MLIB_FAILURE;
  }
#endif

  stype = mlib_ImageGetType(src);
  dtype = mlib_ImageGetType(dst);
  ichan = mlib_ImageGetChannels(src);
  nchan = mlib_ImageGetChannels(dst);
  xsize = mlib_ImageGetWidth(src);
  ysize = mlib_ImageGetHeight(src);
  slb   = mlib_ImageGetStride(src);
  dlb   = mlib_ImageGetStride(dst);
  sa    = mlib_ImageGetData(src);
  da    = mlib_ImageGetData(dst);

  if (ichan == nchan) {

    if (dtype == MLIB_BYTE) {

      if (stype == MLIB_BYTE) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_U8_1()\n");
#endif
          mlib_v_ImageLookUp_U8_U8_1(sa, slb,
                                     da, dlb,
                                     xsize, ysize,
                                     (mlib_u8 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_U8_2()\n");
#endif
          mlib_v_ImageLookUp_U8_U8_2(sa, slb,
                                     da, dlb,
                                     xsize, ysize,
                                     (mlib_u8 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_U8_3()\n");
#endif
          mlib_v_ImageLookUp_U8_U8_3(sa, slb,
                                     da, dlb,
                                     xsize, ysize,
                                     (mlib_u8 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_U8_4()\n");
#endif
          mlib_v_ImageLookUp_U8_U8_4(sa, slb,
                                     da, dlb,
                                     xsize, ysize,
                                     (mlib_u8 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_SHORT) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_U8_1()\n");
#endif
          mlib_v_ImageLookUp_S16_U8_1(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_U8_2()\n");
#endif
          mlib_v_ImageLookUp_S16_U8_2(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_U8_3()\n");
#endif
          mlib_v_ImageLookUp_S16_U8_3(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_U8_4()\n");
#endif
          mlib_v_ImageLookUp_S16_U8_4(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_INT) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_U8_1()\n");
#endif
          mlib_v_ImageLookUp_S32_U8_1(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_U8_2()\n");
#endif
          mlib_v_ImageLookUp_S32_U8_2(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_U8_3()\n");
#endif
          mlib_v_ImageLookUp_S32_U8_3(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_U8_4()\n");
#endif
          mlib_v_ImageLookUp_S32_U8_4(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_u8 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;
      }

    } else if (dtype == MLIB_SHORT) {

      if (stype == MLIB_BYTE) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S16_1()\n");
#endif
          mlib_v_ImageLookUp_U8_S16_1(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s16 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S16_2()\n");
#endif
          mlib_v_ImageLookUp_U8_S16_2(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s16 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S16_3()\n");
#endif
          mlib_v_ImageLookUp_U8_S16_3(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s16 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S16_4()\n");
#endif
          mlib_v_ImageLookUp_U8_S16_4(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s16 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_SHORT) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S16_1()\n");
#endif
          mlib_v_ImageLookUp_S16_S16_1(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S16_2()\n");
#endif
          mlib_v_ImageLookUp_S16_S16_2(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S16_3()\n");
#endif
          mlib_v_ImageLookUp_S16_S16_3(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S16_4()\n");
#endif
          mlib_v_ImageLookUp_S16_S16_4(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_INT) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_S16_1()\n");
#endif
          mlib_v_ImageLookUp_S32_S16_1(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_S16_2()\n");
#endif
          mlib_v_ImageLookUp_S32_S16_2(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_S16_3()\n");
#endif
          mlib_v_ImageLookUp_S32_S16_3(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_S16_4()\n");
#endif
          mlib_v_ImageLookUp_S32_S16_4(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s16 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;
      }
    } else if (dtype == MLIB_INT) {

      if (stype == MLIB_BYTE) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S32_1()\n");
#endif
          mlib_v_ImageLookUp_U8_S32_1(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s32 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S32_2()\n");
#endif
          mlib_v_ImageLookUp_U8_S32_2(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s32 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S32_3()\n");
#endif
          mlib_v_ImageLookUp_U8_S32_3(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s32 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_U8_S32_4()\n");
#endif
          mlib_v_ImageLookUp_U8_S32_4(sa, slb,
                                      da, dlb,
                                      xsize, ysize,
                                      (mlib_s32 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_SHORT) {

      switch (nchan) {
        case 1:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S32_1()\n");
#endif
          mlib_v_ImageLookUp_S16_S32_1(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s32 **) table);
          break;
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S32_2()\n");
#endif
          mlib_v_ImageLookUp_S16_S32_2(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s32 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S32_3()\n");
#endif
          mlib_v_ImageLookUp_S16_S32_3(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s32 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S16_S32_4()\n");
#endif
          mlib_v_ImageLookUp_S16_S32_4(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s32 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_INT) {
        if ((nchan >= 1) && (nchan <= 4)) {

#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUp_S32_S32()\n");
#endif
          mlib_v_ImageLookUp_S32_S32(sa, slb,
                                     da, dlb,
                                     xsize, ysize,
                                     (mlib_s32 **) table, nchan);
          return MLIB_SUCCESS;
        } else {
          return MLIB_FAILURE;
        }
      }
    }

  } else if (ichan == 1) {

    if (dtype == MLIB_BYTE) {

      if (stype == MLIB_BYTE) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_U8_2()\n");
#endif
          mlib_v_ImageLookUpSI_U8_U8_2(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_u8 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_U8_3()\n");
#endif
          mlib_v_ImageLookUpSI_U8_U8_3(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_u8 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_U8_4()\n");
#endif
          mlib_v_ImageLookUpSI_U8_U8_4(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_u8 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_SHORT) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_U8_2()\n");
#endif
          mlib_v_ImageLookUpSI_S16_U8_2(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_u8 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_U8_3()\n");
#endif
          mlib_v_ImageLookUpSI_S16_U8_3(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_u8 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_U8_4()\n");
#endif
          mlib_v_ImageLookUpSI_S16_U8_4(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_u8 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;
      } else if (stype == MLIB_INT) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_U8_2()\n");
#endif
          mlib_v_ImageLookUpSI_S32_U8_2(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_u8 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_U8_3()\n");
#endif
          mlib_v_ImageLookUpSI_S32_U8_3(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_u8 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_U8_4()\n");
#endif
          mlib_v_ImageLookUpSI_S32_U8_4(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_u8 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;
      }

    } else if (dtype == MLIB_SHORT) {

      if (stype == MLIB_BYTE) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_S16_2()\n");
#endif
          mlib_v_ImageLookUpSI_U8_S16_2(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_s16 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_S16_3()\n");
#endif
          mlib_v_ImageLookUpSI_U8_S16_3(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_s16 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_S16_4()\n");
#endif
          mlib_v_ImageLookUpSI_U8_S16_4(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_s16 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_SHORT) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_S16_2()\n");
#endif
          mlib_v_ImageLookUpSI_S16_S16_2(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s16 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_S16_3()\n");
#endif
          mlib_v_ImageLookUpSI_S16_S16_3(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s16 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_S16_4()\n");
#endif
          mlib_v_ImageLookUpSI_S16_S16_4(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s16 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_INT) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_S16_2()\n");
#endif
          mlib_v_ImageLookUpSI_S32_S16_2(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s16 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_S16_3()\n");
#endif
          mlib_v_ImageLookUpSI_S32_S16_3(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s16 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_S16_4()\n");
#endif
          mlib_v_ImageLookUpSI_S32_S16_4(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s16 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;
      }
    } else if (dtype == MLIB_INT) {

      if (stype == MLIB_BYTE) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_S32_2()\n");
#endif
          mlib_v_ImageLookUpSI_U8_S32_2(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_s32 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_S32_3()\n");
#endif
          mlib_v_ImageLookUpSI_U8_S32_3(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_s32 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_U8_S32_4()\n");
#endif
          mlib_v_ImageLookUpSI_U8_S32_4(sa, slb,
                                        da, dlb,
                                        xsize, ysize,
                                        (mlib_s32 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_SHORT) {

      switch (nchan) {
        case 2:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_S32_2()\n");
#endif
          mlib_v_ImageLookUpSI_S16_S32_2(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s32 **) table);
          break;
        case 3:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_S32_3()\n");
#endif
          mlib_v_ImageLookUpSI_S16_S32_3(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s32 **) table);
          break;
        case 4:
#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S16_S32_4()\n");
#endif
          mlib_v_ImageLookUpSI_S16_S32_4(sa, slb,
                                         da, dlb,
                                         xsize, ysize,
                                         (mlib_s32 **) table);
          break;
        default:
          return MLIB_FAILURE;
        }
        return MLIB_SUCCESS;

      } else if (stype == MLIB_INT) {

        if ((nchan >= 1) && (nchan <= 4)) {

#ifdef MLIB_DIAG
          printf("DIAG    mlib_v_ImageLookUpSI_S32_S32()\n");
#endif
          mlib_v_ImageLookUpSI_S32_S32(sa, slb,
                                       da, dlb,
                                       xsize, ysize,
                                       (mlib_s32 **) table, nchan);
          return MLIB_SUCCESS;
        } else {
          return MLIB_FAILURE;
        }
      }
    }
  }

  return MLIB_FAILURE;
}

/***************************************************************/
