/*
 * @(#)mlib_v_ImageLookUpS32S16Func.c	1.1 98/08/21
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#pragma ident	"@(#)mlib_v_ImageLookUpS32S16Func.c	1.1	98/07/28 SMI"

/*
 * $RCSfile: mlib_v_ImageLookUpS32S16Func.c,v $
 * $Revision: 4.1 $
 * $Date: 1996/12/11 20:43:57 $
 * $Author: liang $
 */




#include <stdlib.h>
#include "vis_proto.h"
#include "mlib_image.h"

/***************************************************************/

void mlib_v_ImageLookUp_S32_S16_124_D1(mlib_s32 *src,
                                       mlib_s16 *dst,
                                       mlib_s32 xsize,
                                       mlib_s16 *table0,
                                       mlib_s16 *table1,
                                       mlib_s16 *table2,
                                       mlib_s16 *table3)
{
  mlib_s32 *sp;            /* pointer to source data */
  mlib_s32 s0, s1, s2, s3; /* source data */
  mlib_s16 *dl;            /* pointer to start of destination */
  mlib_s16 *dend;          /* pointer to end of destination */
  mlib_d64 *dp;            /* aligned pointer to destination */
  mlib_d64 t0, t1, t2;     /* destination data */
  mlib_d64 t3, acc0;       /* destination data */
  mlib_s32 emask;          /* edge mask */
  mlib_s32 i, num;         /* loop variable */

  dl   = dst;
  sp   = src;
  dp   = (mlib_d64 *) dl;
  dend = dl + xsize - 1;

  vis_alignaddr((void *) 0, 6);

  if (xsize >= 4) {

    s0 = sp[0];
    s1 = sp[1];
    s2 = sp[2];
    s3 = sp[3];
    sp += 4;

#pragma pipeloop(0)
    for(i = 0; i <= xsize - 8; i+=4, sp += 4) {
      t3 = vis_ld_u16_i(table3, 2*s3);
      t2 = vis_ld_u16_i(table2, 2*s2);
      t1 = vis_ld_u16_i(table1, 2*s1);
      t0 = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t3, acc0);
      acc0 = vis_faligndata(t2, acc0);
      acc0 = vis_faligndata(t1, acc0);
      acc0 = vis_faligndata(t0, acc0);
      s0 = sp[0];
      s1 = sp[1];
      s2 = sp[2];
      s3 = sp[3];
      *dp++ = acc0;
    }
    t3 = vis_ld_u16_i(table3, 2*s3);
    t2 = vis_ld_u16_i(table2, 2*s2);
    t1 = vis_ld_u16_i(table1, 2*s1);
    t0 = vis_ld_u16_i(table0, 2*s0);
    acc0 = vis_faligndata(t3, acc0);
    acc0 = vis_faligndata(t2, acc0);
    acc0 = vis_faligndata(t1, acc0);
    acc0 = vis_faligndata(t0, acc0);
    *dp++ = acc0;
  }

  if ((mlib_addr) dp <= (mlib_addr) dend) {

    num = (mlib_s32)((mlib_s16*) dend - (mlib_s16*) dp);
    sp  += num;
    num ++;
    if (num == 1) {
      s0 = *sp;

      t0  = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t0, acc0);
    } else if (num  == 2) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u16_i(table1, 2*s0);
      acc0 = vis_faligndata(t0, acc0);

      s0 = *sp;

      t0  = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t0, acc0);
    } else if (num == 3) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u16_i(table2, 2*s0);
      acc0 = vis_faligndata(t0, acc0);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u16_i(table1, 2*s0);
      acc0 = vis_faligndata(t0, acc0);

      s0 = *sp;

      t0  = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t0, acc0);
    }
    emask = vis_edge16(dp, dend);
    vis_pst_16(acc0, dp, emask);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_S16_1(mlib_s32 *src, mlib_s32 slb,
                                  mlib_s16 *dst, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table)
{
  mlib_s32 *sl;
  mlib_s16 *dl;
  mlib_s16 *tab = &table[0][2147483648];
  mlib_s32 j, i;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32 *sp = sl;
    mlib_s16 *dp = dl;
    mlib_s32 off, size = xsize;

    off = (mlib_s32)(((8 - ((mlib_addr)dp & 7)) & 7) >> 1);

    off = (off < size) ? off : size;

    for (i = 0; i < off; i++, sp++) {
      *dp++ = tab[sp[0]];
      size--;
    }

    if (size > 0) {
      mlib_v_ImageLookUp_S32_S16_124_D1(sp, dp, size, tab, tab, tab, tab);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_s16 *) ((mlib_u8 *) dl + dlb);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_S16_2(mlib_s32 *src, mlib_s32 slb,
                                  mlib_s16 *dst, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table)
{
  mlib_s32  *sl;
  mlib_s16  *dl;
  mlib_s16  *tab;
  mlib_s32  j, i;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32  *sp = sl;
    mlib_s16  *dp = dl;
    mlib_s32  off, size = xsize * 2;
    mlib_s16 *tab0 = &table[0][2147483648];
    mlib_s16 *tab1 = &table[1][2147483648];

    off = (mlib_s32)(((8 - ((mlib_addr)dp & 7)) & 7) >> 1);

    off = (off < size) ? off : size;

    for (i = 0; i < off - 1; i+=2, sp += 2) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      size-=2;
    }

    if ((off & 1) != 0) {
      *dp++ = tab0[sp[0]];
      size--; sp++;
      tab = tab0; tab0 = tab1; tab1 = tab;
    }

    if (size > 0) {
      mlib_v_ImageLookUp_S32_S16_124_D1(sp, dp, size, tab0, tab1, tab0, tab1);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_s16 *) ((mlib_u8 *) dl + dlb);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_S16_4(mlib_s32 *src, mlib_s32 slb,
                                  mlib_s16 *dst, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table)
{
  mlib_s32  *sl;
  mlib_s16  *dl;
  mlib_s16  *tab;
  mlib_s32  j;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32  *sp = sl;
    mlib_s16  *dp = dl;
    mlib_s16 *tab0 = &table[0][2147483648];
    mlib_s16 *tab1 = &table[1][2147483648];
    mlib_s16 *tab2 = &table[2][2147483648];
    mlib_s16 *tab3 = &table[3][2147483648];
    mlib_s32  off, size = xsize * 4;

    off = (mlib_s32)(((8 - ((mlib_addr)dp & 7)) & 7) >> 1);

    off = (off < size) ? off : size;

    if (off >= 4) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      *dp++ = tab2[sp[2]];
      *dp++ = tab3[sp[3]];
      size-=4; off-=4; sp += 4;
    }

    if (off == 1) {
      *dp++ = tab0[sp[0]];
      tab = tab0; tab0 = tab1;
      tab1 = tab2; tab2 = tab3; tab3 = tab;
      size--; sp++;
    } else if (off == 2) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      tab = tab0; tab0 = tab2; tab2 = tab;
      tab = tab1; tab1 = tab3; tab3 = tab;
      size-=2; sp += 2;
    } else if (off == 3) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      *dp++ = tab2[sp[2]];
      tab = tab3; tab3 = tab2;
      tab2 = tab1; tab1 = tab0; tab0 = tab;
      size-=3; sp += 3;
    }


    if (size > 0) {
      mlib_v_ImageLookUp_S32_S16_124_D1(sp, dp, size, tab0, tab1, tab2, tab3);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_s16 *) ((mlib_u8 *) dl + dlb);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_S16_3_D1(mlib_s32 *src,
                                     mlib_s16 *dst,
                                     mlib_s32 xsize,
                                     mlib_s16 *table0,
                                     mlib_s16 *table1,
                                     mlib_s16 *table2)
{
  mlib_s32 *sp;              /* pointer to source data */
  mlib_s32 s0, s1, s2, s3;   /* source data */
  mlib_s16 *dl;              /* pointer to start of destination */
  mlib_s16 *dend;            /* pointer to end of destination */
  mlib_d64 *dp;              /* aligned pointer to destination */
  mlib_d64 t0, t1, t2, t3;   /* destination data */
  mlib_d64 acc0;             /* destination data */
  mlib_s32 emask;            /* edge mask */
  mlib_s32 i, num;           /* loop variable */
  mlib_s16 *table;

  dl   = dst;
  sp   = src;
  dp   = (mlib_d64 *) dl;
  dend = dl + xsize - 1;

  vis_alignaddr((void *) 0, 6);

  if (xsize >= 4) {

    s0 = sp[0];
    s1 = sp[1];
    s2 = sp[2];
    s3 = sp[3];
    sp += 4;

#pragma pipeloop(0)
    for(i = 0; i <= xsize - 8; i+=4, sp += 4) {
      t3 = vis_ld_u16_i(table0, 2*s3);
      t2 = vis_ld_u16_i(table2, 2*s2);
      t1 = vis_ld_u16_i(table1, 2*s1);
      t0 = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t3, acc0);
      acc0 = vis_faligndata(t2, acc0);
      acc0 = vis_faligndata(t1, acc0);
      acc0 = vis_faligndata(t0, acc0);
      s0 = sp[0];
      s1 = sp[1];
      s2 = sp[2];
      s3 = sp[3];
      *dp++ = acc0;
      table = table0; table0 = table1;
      table1 = table2; table2 = table;
    }
    t3 = vis_ld_u16_i(table0, 2*s3);
    t2 = vis_ld_u16_i(table2, 2*s2);
    t1 = vis_ld_u16_i(table1, 2*s1);
    t0 = vis_ld_u16_i(table0, 2*s0);
    acc0 = vis_faligndata(t3, acc0);
    acc0 = vis_faligndata(t2, acc0);
    acc0 = vis_faligndata(t1, acc0);
    acc0 = vis_faligndata(t0, acc0);
    *dp++ = acc0;
    table = table0; table0 = table1;
    table1 = table2; table2 = table;
  }

  if ((mlib_addr) dp <= (mlib_addr) dend) {

    num = (mlib_s32)((mlib_s16*) dend - (mlib_s16*) dp);
    sp  += num;
    num ++;
    if (num == 1) {
      s0 = *sp;

      t0  = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t0, acc0);
    } else if (num  == 2) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u16_i(table1, 2*s0);
      acc0 = vis_faligndata(t0, acc0);

      s0 = *sp;

      t0  = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t0, acc0);
    } else if (num == 3) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u16_i(table2, 2*s0);
      acc0 = vis_faligndata(t0, acc0);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u16_i(table1, 2*s0);
      acc0 = vis_faligndata(t0, acc0);

      s0 = *sp;

      t0  = vis_ld_u16_i(table0, 2*s0);
      acc0 = vis_faligndata(t0, acc0);
    }
    emask = vis_edge16(dp, dend);
    vis_pst_16(acc0, dp, emask);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_S16_3(mlib_s32 *src, mlib_s32 slb,
                                  mlib_s16 *dst, mlib_s32 dlb,
                                  mlib_s32 xsize, mlib_s32 ysize,
                                  mlib_s16 **table)
{
  mlib_s32 *sl;
  mlib_s16 *dl;
  mlib_s16 *tab;
  mlib_s32 j, i;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32  *sp = sl;
    mlib_s16  *dp = dl;
    mlib_s16 *tab0 = &table[0][2147483648];
    mlib_s16 *tab1 = &table[1][2147483648];
    mlib_s16 *tab2 = &table[2][2147483648];
    mlib_s32  off, size = xsize * 3;

    off = (mlib_s32)(((8 - ((mlib_addr)dp & 7)) & 7) >> 1);

    off = (off < size) ? off : size;

    for (i = 0; i < off - 2; i += 3, sp += 3) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      *dp++ = tab2[sp[2]];
      size-=3;
    }

    off -= i;

    if (off == 1) {
      *dp++ = tab0[sp[0]];
      tab = tab0; tab0 = tab1;
      tab1 = tab2; tab2 = tab;
      size--; sp++;
    } else if (off == 2) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      tab = tab2; tab2 = tab1;
      tab1 = tab0; tab0 = tab;
      size-=2; sp += 2;
    }


    if (size > 0) {
      mlib_v_ImageLookUp_S32_S16_3_D1(sp, dp, size, tab0, tab1, tab2);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_s16 *) ((mlib_u8 *) dl + dlb);
  }
}
