/*
 * @(#)mlib_v_ImageLookUpS32U8Func.c	1.1 98/08/21
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#pragma ident	"@(#)mlib_v_ImageLookUpS32U8Func.c	1.1	98/07/28 SMI"

/*
 * $RCSfile: mlib_v_ImageLookUpS32U8Func.c,v $
 * $Revision: 4.1 $
 * $Date: 1996/12/11 20:44:03 $
 * $Author: liang $
 */



#include <stdlib.h>
#include "vis_proto.h"
#include "mlib_image.h"

/***************************************************************/

void mlib_v_ImageLookUp_S32_U8_124_D1(mlib_s32 *src,
                                      mlib_u8  *dst,
                                      mlib_s32 xsize,
                                      mlib_u8 *table0,
                                      mlib_u8 *table1,
                                      mlib_u8 *table2,
                                      mlib_u8 *table3)
{
  mlib_s32 *sp;            /* pointer to source data */
  mlib_s32 s0, s1, s2, s3; /* source data */
  mlib_s32 s4, s5, s6, s7; /* source data */
  mlib_u8  *dl;            /* pointer to start of destination */
  mlib_u8  *dend;          /* pointer to end of destination */
  mlib_d64 *dp;            /* aligned pointer to destination */
  mlib_d64 t0, t1, t2;     /* destination data */
  mlib_d64 t3, t4, t5;     /* destination data */
  mlib_d64 t6, t7, acc;    /* destination data */
  mlib_s32 emask;          /* edge mask */
  mlib_s32 i, num;         /* loop variable */

  dl   = dst;
  dp   = (mlib_d64 *) dl;
  dend = dl + xsize - 1;
  sp   = src;

  vis_alignaddr((void *) 0, 7);

  if (xsize >= 8) {

    s0 = sp[0];
    s1 = sp[1];
    s2 = sp[2];
    s3 = sp[3];
    s4 = sp[4];
    s5 = sp[5];
    s6 = sp[6];
    s7 = sp[7];
    sp += 8;

#pragma pipeloop(0)
    for(i = 0; i <= xsize - 16; i+=8, sp += 8) {
      t7 = vis_ld_u8_i(table3, s7);
      t6 = vis_ld_u8_i(table2, s6);
      t5 = vis_ld_u8_i(table1, s5);
      t4 = vis_ld_u8_i(table0, s4);
      t3 = vis_ld_u8_i(table3, s3);
      t2 = vis_ld_u8_i(table2, s2);
      t1 = vis_ld_u8_i(table1, s1);
      t0 = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t7, acc);
      acc = vis_faligndata(t6, acc);
      acc = vis_faligndata(t5, acc);
      acc = vis_faligndata(t4, acc);
      acc = vis_faligndata(t3, acc);
      acc = vis_faligndata(t2, acc);
      acc = vis_faligndata(t1, acc);
      acc = vis_faligndata(t0, acc);
      s0 = sp[0];
      s1 = sp[1];
      s2 = sp[2];
      s3 = sp[3];
      s4 = sp[4];
      s5 = sp[5];
      s6 = sp[6];
      s7 = sp[7];
      *dp++ = acc;
    }
    t7 = vis_ld_u8_i(table3, s7);
    t6 = vis_ld_u8_i(table2, s6);
    t5 = vis_ld_u8_i(table1, s5);
    t4 = vis_ld_u8_i(table0, s4);
    t3 = vis_ld_u8_i(table3, s3);
    t2 = vis_ld_u8_i(table2, s2);
    t1 = vis_ld_u8_i(table1, s1);
    t0 = vis_ld_u8_i(table0, s0);
    acc = vis_faligndata(t7, acc);
    acc = vis_faligndata(t6, acc);
    acc = vis_faligndata(t5, acc);
    acc = vis_faligndata(t4, acc);
    acc = vis_faligndata(t3, acc);
    acc = vis_faligndata(t2, acc);
    acc = vis_faligndata(t1, acc);
    acc = vis_faligndata(t0, acc);
    *dp++ = acc;
  }

  if ((mlib_addr) dp <= (mlib_addr) dend) {

    num = (mlib_s32)((mlib_addr) dend - (mlib_addr) dp);
    sp  += num;
    num ++;
    if ((num & 3) == 1) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
      num--;
    } else if ((num & 3) == 2) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table1, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
      num-=2;
    } else if ((num & 3) == 3) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table2, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table1, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
      num-=3;
    }

    if (num != 0) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table3, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table2, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table1, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
    }
    emask = vis_edge8(dp, dend);
    vis_pst_8(acc, dp, emask);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_U8_1(mlib_s32 *src, mlib_s32 slb,
                                 mlib_u8  *dst, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table)
{
  mlib_s32 *sl;
  mlib_u8  *dl;
  mlib_u8  *tab = &table[0][2147483648];
  mlib_s32 j, i;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32 *sp = sl;
    mlib_u8  *dp = dl;
    mlib_s32 off, size = xsize;

    off = (mlib_s32)((8 - ((mlib_addr)dp & 7)) & 7);

    off = (off < size) ? off : size;

    for (i = 0; i < off; i++, sp++) {
      *dp++ = tab[sp[0]];
      size--;
    }

    if (size > 0) {
      mlib_v_ImageLookUp_S32_U8_124_D1(sp, dp, size, tab, tab, tab, tab);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_u8 *) ((mlib_u8 *) dl + dlb);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_U8_2(mlib_s32 *src, mlib_s32 slb,
                                 mlib_u8  *dst, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table)
{
  mlib_s32 *sl;
  mlib_u8  *dl;
  mlib_u8  *tab;
  mlib_s32 j, i;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32 *sp = sl;
    mlib_u8  *dp = dl;
    mlib_s32 off, size = xsize * 2;
    mlib_u8  *tab0 = &table[0][2147483648];
    mlib_u8  *tab1 = &table[1][2147483648];

    off = (mlib_s32)((8 - ((mlib_addr)dp & 7)) & 7);

    off = (off < size) ? off : size;

    for (i = 0; i < off - 1; i+=2, sp += 2) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      size-=2;
    }

    if ((off & 1) != 0) {
      *dp++ = tab0[sp[0]];
      size--; sp++;
      tab = tab0; tab0 = tab1; tab1 = tab;
    }

    if (size > 0) {
      mlib_v_ImageLookUp_S32_U8_124_D1(sp, dp, size, tab0, tab1, tab0, tab1);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_u8 *) ((mlib_u8 *) dl + dlb);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_U8_4(mlib_s32 *src, mlib_s32 slb,
                                 mlib_u8  *dst, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table)
{
  mlib_s32 *sl;
  mlib_u8  *dl;
  mlib_u8  *tab;
  mlib_s32 j;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32 *sp = sl;
    mlib_u8  *dp = dl;
    mlib_u8  *tab0 = &table[0][2147483648];
    mlib_u8  *tab1 = &table[1][2147483648];
    mlib_u8  *tab2 = &table[2][2147483648];
    mlib_u8  *tab3 = &table[3][2147483648];
    mlib_s32 off, size = xsize * 4;

    off = (mlib_s32)((8 - ((mlib_addr)dp & 7)) & 7);

    off = (off < size) ? off : size;

    if (off >= 4) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      *dp++ = tab2[sp[2]];
      *dp++ = tab3[sp[3]];
      size-=4; off-=4; sp += 4;
    }

    if (off == 1) {
      *dp++ = tab0[sp[0]];
      tab = tab0; tab0 = tab1;
      tab1 = tab2; tab2 = tab3; tab3 = tab;
      size--; sp++;
    } else if (off == 2) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      tab = tab0; tab0 = tab2; tab2 = tab;
      tab = tab1; tab1 = tab3; tab3 = tab;
      size-=2; sp += 2;
    } else if (off == 3) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      *dp++ = tab2[sp[2]];
      tab = tab3; tab3 = tab2;
      tab2 = tab1; tab1 = tab0; tab0 = tab;
      size-=3; sp += 3;
    }


    if (size > 0) {
      mlib_v_ImageLookUp_S32_U8_124_D1(sp, dp, size, tab0, tab1, tab2, tab3);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_u8 *) ((mlib_u8 *) dl + dlb);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_U8_3_D1(mlib_s32 *src,
                                    mlib_u8  *dst,
                                    mlib_s32 xsize,
                                    mlib_u8 *table0,
                                    mlib_u8 *table1,
                                    mlib_u8 *table2)
{
  mlib_s32 *sp;            /* pointer to source data */
  mlib_s32 s0, s1, s2, s3; /* source data */
  mlib_s32 s4, s5, s6, s7; /* source data */
  mlib_u8  *dl;            /* pointer to start of destination */
  mlib_u8  *dend;          /* pointer to end of destination */
  mlib_d64 *dp;            /* aligned pointer to destination */
  mlib_d64 t0, t1, t2;     /* destination data */
  mlib_d64 t3, t4, t5;     /* destination data */
  mlib_d64 t6, t7, acc;    /* destination data */
  mlib_s32 emask;          /* edge mask */
  mlib_s32 i, num;         /* loop variable */
  mlib_u8  *table;

  dl   = dst;
  sp   = src;
  dp   = (mlib_d64 *) dl;
  dend = dl + xsize - 1;

  vis_alignaddr((void *) 0, 7);

  if (xsize >= 8) {

    s0 = sp[0];
    s1 = sp[1];
    s2 = sp[2];
    s3 = sp[3];
    s4 = sp[4];
    s5 = sp[5];
    s6 = sp[6];
    s7 = sp[7];
    sp += 8;

#pragma pipeloop(0)
    for(i = 0; i <= xsize - 16; i+=8, sp += 8) {
      t7 = vis_ld_u8_i(table1, s7);
      t6 = vis_ld_u8_i(table0, s6);
      t5 = vis_ld_u8_i(table2, s5);
      t4 = vis_ld_u8_i(table1, s4);
      t3 = vis_ld_u8_i(table0, s3);
      t2 = vis_ld_u8_i(table2, s2);
      t1 = vis_ld_u8_i(table1, s1);
      t0 = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t7, acc);
      acc = vis_faligndata(t6, acc);
      acc = vis_faligndata(t5, acc);
      acc = vis_faligndata(t4, acc);
      acc = vis_faligndata(t3, acc);
      acc = vis_faligndata(t2, acc);
      acc = vis_faligndata(t1, acc);
      acc = vis_faligndata(t0, acc);
      table = table0; table0 = table2;
      table2 = table1; table1 = table;
      s0 = sp[0];
      s1 = sp[1];
      s2 = sp[2];
      s3 = sp[3];
      s4 = sp[4];
      s5 = sp[5];
      s6 = sp[6];
      s7 = sp[7];
      *dp++ = acc;
    }
    t7 = vis_ld_u8_i(table1, s7);
    t6 = vis_ld_u8_i(table0, s6);
    t5 = vis_ld_u8_i(table2, s5);
    t4 = vis_ld_u8_i(table1, s4);
    t3 = vis_ld_u8_i(table0, s3);
    t2 = vis_ld_u8_i(table2, s2);
    t1 = vis_ld_u8_i(table1, s1);
    t0 = vis_ld_u8_i(table0, s0);
    acc = vis_faligndata(t7, acc);
    acc = vis_faligndata(t6, acc);
    acc = vis_faligndata(t5, acc);
    acc = vis_faligndata(t4, acc);
    acc = vis_faligndata(t3, acc);
    acc = vis_faligndata(t2, acc);
    acc = vis_faligndata(t1, acc);
    acc = vis_faligndata(t0, acc);
    table = table0; table0 = table2;
    table2 = table1; table1 = table;
    *dp++ = acc;
  }

  if ((mlib_addr) dp <= (mlib_addr) dend) {

    num = (mlib_s32)((mlib_addr) dend - (mlib_addr) dp);
    sp  += num;
    num ++;
    i = num - 3*(num/3);
    if (i == 2) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table1, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
      num-=2;
    } else if (i == 1) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
      num--;
    }

#pragma pipeloop(0)
    for (i = 0; i < num; i += 3) {
      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table2, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table1, s0);
      acc = vis_faligndata(t0, acc);

      s0 = *sp;
      sp --;

      t0  = vis_ld_u8_i(table0, s0);
      acc = vis_faligndata(t0, acc);
    }

    emask = vis_edge8(dp, dend);
    vis_pst_8(acc, dp, emask);
  }
}

/***************************************************************/

void mlib_v_ImageLookUp_S32_U8_3(mlib_s32 *src, mlib_s32 slb,
                                 mlib_u8  *dst, mlib_s32 dlb,
                                 mlib_s32 xsize, mlib_s32 ysize,
                                 mlib_u8  **table)
{
  mlib_s32 *sl;
  mlib_u8  *dl;
  mlib_u8  *tab;
  mlib_s32 j, i;

  sl = src;
  dl = dst;

  /* row loop */
  for (j = 0; j < ysize; j ++) {
    mlib_s32 *sp = sl;
    mlib_u8  *dp = dl;
    mlib_u8  *tab0 = &table[0][2147483648];
    mlib_u8  *tab1 = &table[1][2147483648];
    mlib_u8  *tab2 = &table[2][2147483648];
    mlib_s32 off, size = xsize * 3;

    off = (mlib_s32)((8 - ((mlib_addr)dp & 7)) & 7);

    off = (off < size) ? off : size;

    for (i = 0; i < off - 2; i += 3, sp += 3) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      *dp++ = tab2[sp[2]];
      size-=3;
    }

    off -= i;

    if (off == 1) {
      *dp++ = tab0[sp[0]];
      tab = tab0; tab0 = tab1;
      tab1 = tab2; tab2 = tab;
      size--; sp++;
    } else if (off == 2) {
      *dp++ = tab0[sp[0]];
      *dp++ = tab1[sp[1]];
      tab = tab2; tab2 = tab1;
      tab1 = tab0; tab0 = tab;
      size-=2; sp += 2;
    }


    if (size > 0) {
      mlib_v_ImageLookUp_S32_U8_3_D1(sp, dp, size, tab0, tab1, tab2);
    }

    sl = (mlib_s32 *) ((mlib_u8 *) sl + slb);
    dl = (mlib_u8 *) ((mlib_u8 *) dl + dlb);
  }
}
