/*
 * @(#)MCheckboxPeer.java	1.10 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;

public class MCheckboxPeer extends MComponentPeer implements CheckboxPeer {
    native void create(MComponentPeer parent);
    public native void setLabel(String label);

    void initialize() {
	Checkbox t = (Checkbox)target;

	setState(t.getState());
	setCheckboxGroup(t.getCheckboxGroup());
	super.initialize();
    }

    public MCheckboxPeer(Checkbox target) {
	super(target);
    }

    public native void setState(boolean state);
    public native void setCheckboxGroup(CheckboxGroup g);

    public Dimension getMinimumSize() {
	String lbl = ((Checkbox)target).getLabel();
	if (lbl != null) {
	    FontMetrics fm = getFontMetrics(target.getFont());
	    return new Dimension(30 + fm.stringWidth(lbl), 
				 Math.max(fm.getHeight() + 8, 15));
	}
	return new Dimension(20, 15);
    }

    void action(boolean state) {
	Checkbox target = (Checkbox)this.target;
	target.setState(state);
	target.postEvent(new Event(target, Event.ACTION_EVENT, new Boolean(state)));
    }

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	    return getMinimumSize();
    }

}
