/*
 * @(#)MChoicePeer.java	1.16 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;

class MChoicePeer extends MComponentPeer implements ChoicePeer {
    native void create(MComponentPeer parent);
    public native void select(int index);

    void initialize() {
	Choice opt = (Choice)target;
	int itemCount = opt.countItems();
	for (int i=0; i < itemCount; i++) {
	    add(opt.getItem(i), i);
	}
	if (itemCount > 0 && opt.getSelectedIndex() >= 0) {
	    select(opt.getSelectedIndex());
	}
	super.initialize();
    }

    public MChoicePeer(Choice target) {
	super(target);
    }

    public Dimension getMinimumSize() {
	FontMetrics fm = getFontMetrics(target.getFont());
	Choice c = (Choice)target;
	int w = 0;
	for (int i = c.countItems() ; i-- > 0 ;) {
	    w = Math.max(fm.stringWidth(c.getItem(i)), w);
	}
	return new Dimension(28 + w, Math.max(fm.getHeight() + 8, 15) + 3);
    }

    public void add(String item, int index) {
      	addItem(item, index);
    }

    public void removeAll() {
      	System.out.println("Method removeAll() not implemented yet.");
    }

    /**
     * DEPRECATED, but for now, called by add(String, int).
     */
    public native void addItem(String item, int index);

    public native void remove(int index);

    void action(int index) {
	Choice c = (Choice)target;
	c.select(index);
	target.postEvent(new Event(target, Event.ACTION_EVENT, c.getItem(index)));
    }

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	    return getMinimumSize();
    }

}
