/*
 * @(#)MFileDialogPeer.java	1.20 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;
import java.io.FilenameFilter;

public class MFileDialogPeer extends MDialogPeer implements FileDialogPeer {
    native void pCreate(MComponentPeer parent,
	int mode, String title, String file);

    void create(MComponentPeer parent) {
        FileDialog target = (FileDialog)this.target;

        pCreate(parent, target.getMode(), target.getTitle(), target.getFile());
    }

    public MFileDialogPeer(FileDialog target) {
	super(target);

	FileDialog	fdialog = (FileDialog)target;
	String		dir = fdialog.getDirectory();

	if (dir != null) {
	    setDirectory(dir);
	}
    }
    native void		pShow();
    native void		pHide();
    public void		handleSelected(String file) {
	int	index = file.lastIndexOf('\\');

	String dir;
	if (index == -1) {
	    dir = ".\\";
	    ((FileDialog)target).setFile(file);
	} else {
	    dir = file.substring(0, index+1);
	    ((FileDialog)target).setFile(file.substring(index+1));
	}
	((FileDialog)target).setDirectory(dir);
    }
    public void		handleCancel() {
	((FileDialog)target).setFile(null);
    }
    public void		handleQuit() {
	handleCancel();
	hide();
    }
    public native void	setDirectory(String dir);
    public native void	setFile(String file);
    public void		setFilenameFilter(FilenameFilter filter) {
        // Not implemented for 1.0
    }
    public void pReshape(int x, int y, int width, int height) {
        // Not implemented for 1.0
    }
    public void pSetTitle(String title) {
        // Not implemented for 1.0
    }
    public void setResizable(boolean resizable) {
        // Not implemented for 1.0
    }

    public void setInsets(Insets i) {
        insets = i;
    }

    // avoid MDialogPeer's modality support.
    public void show() {
        pShow();
    }
}
