/*
 * @(#)MLabelPeer.java	1.12 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;

class MLabelPeer extends MComponentPeer implements LabelPeer {
    native void create(MComponentPeer parent);
    //public native void setFont(Font f);

    public void initialize() {
	Label	l = (Label)target;
	String  txt;
	int	align;

	if ((txt = l.getText()) != null) {
	    setText(l.getText());
	}
	if ((align = l.getAlignment()) != Label.LEFT) {
	    setAlignment(align);
	}
	super.initialize();
    }

    MLabelPeer(Label target) {
	super(target);
    }

    public Dimension getMinimumSize() {
	FontMetrics fm = getFontMetrics(target.getFont());
	String label = ((Label)target).getText();
	if (label == null) label = "";
	return new Dimension(fm.stringWidth(label) + 14, 
			     fm.getHeight() + 8);
    }

    public native void setText(String label);
    public native void setAlignment(int alignment);

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	    return getMinimumSize();
    }

}
