/*
 * @(#)MMenuItemPeer.java	1.11 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;

class MMenuItemPeer implements MenuItemPeer {
    int		pData;
    boolean	isCheckbox = false;
    MenuItem	target;

    native void create(Menu parent);
    native void pEnable(boolean enable);
    public native void dispose();

    protected MMenuItemPeer() {
    }

    MMenuItemPeer(MenuItem target) {
	this.target = target;
	create((Menu)target.getParent());
    }

    public void setEnabled(boolean b) {
	pEnable(b);
    }

    /**
     * DEPRECATED:  Replaced by setEnabled(boolean).
     */
    public void enable() {
        setEnabled(true);
    }

    /**
     * DEPRECATED:  Replaced by setEnabled(boolean).
     */
    public void disable() {
        setEnabled(false);
    }

    public void setLabel(String label) {
    }

    public void action() {
	target.postEvent(new Event(target, Event.ACTION_EVENT, target.getLabel()));
    }
}
