/*
 * @(#)MScrollbarPeer.java	1.13 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;

class MScrollbarPeer extends MComponentPeer implements ScrollbarPeer {
    native void pCreate(MComponentPeer parent);
    public native void setValue(int value);    
    public native void setValues(int value, int visible, int minimum, int maximum);    
    
    MScrollbarPeer(Scrollbar target) {
	super(target);
    }

    void create(MComponentPeer parent) {
	Scrollbar sb = (Scrollbar)target;
        pCreate(parent);
        setValues(sb.getValue(), sb.getVisibleAmount(), 
                  sb.getMinimum(), sb.getMaximum());
    }

    public Dimension getMinimumSize() {
	if (((Scrollbar)target).getOrientation() == Scrollbar.VERTICAL) {
	    return new Dimension(15, 50);
	} else {
	    return new Dimension(50, 15);
	}
    }

    public void lineUp(int value) {
	Scrollbar sb = (Scrollbar)target;
	sb.setValue(value);
	target.postEvent(new Event(target, Event.SCROLL_LINE_UP, new Integer(value)));
    }

    public void lineDown(int value) {
	Scrollbar sb = (Scrollbar)target;
	sb.setValue(value);
	target.postEvent(new Event(target, Event.SCROLL_LINE_DOWN, new Integer(value)));
    }

    public void pageUp(int value) {
	Scrollbar sb = (Scrollbar)target;
	sb.setValue(value);
	target.postEvent(new Event(target, Event.SCROLL_PAGE_UP, new Integer(value)));
    }

    public void pageDown(int value) {
	Scrollbar sb = (Scrollbar)target;
	sb.setValue(value);
	target.postEvent(new Event(target, Event.SCROLL_PAGE_DOWN, new Integer(value)));
    }

    public void dragAbsolute(int value) {
	Scrollbar sb = (Scrollbar)target;
	sb.setValue(value);
	target.postEvent(new Event(target, Event.SCROLL_ABSOLUTE, new Integer(value)));
    }

    //XXX: NOT IMPLEMENTED
    public void setLineIncrement(int l) {
    }
    //XXX: NOT IMPLEMENTED
    public void setPageIncrement(int l) {
    }

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	    return getMinimumSize();
    }

}
