/*
 * @(#)MTextFieldPeer.java	1.16 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.win32;

import java.awt.*;
import java.awt.peer.*;

public class MTextFieldPeer extends MComponentPeer implements TextFieldPeer {
    native void create(MComponentPeer parent);

    void initialize() {
	TextField txt = (TextField)target;

	setText(txt.getText());
	if (txt.echoCharIsSet()) {
	    setEchoChar(txt.getEchoChar());
	}
	select(txt.getSelectionStart(), txt.getSelectionEnd());
	setEditable(txt.isEditable());
	super.initialize();
    }

    public MTextFieldPeer(TextField target) {
	super(target);
    }

    public void setEditable(boolean editable) {
	pSetEditable(editable);
	setBackground(target.getBackground());
    }
    public void setBackground(Color c) {
	TextField t = (TextField)target;
	if (t.isEditable()) {
	    c = c.brighter();
	}
	super.setBackground(c);
    }
    public native void pSetEditable(boolean editable);
    public native void select(int selStart, int selEnd);
    public native int getSelectionStart();
    public native int getSelectionEnd();
    public native void setText(String l);
    public native void dispose();
    public native String getText();

    /* This should eventually be a direct native method. */
    public void setEchoChar(char c) {
      	setEchoCharacter(c);
    }

    public Dimension getMinimumSize() {
	FontMetrics fm = getFontMetrics(target.getFont());
	return new Dimension(fm.stringWidth(((TextField)target).getText()) + 20, 
				    fm.getHeight() + 8);
    }

    public Dimension getPreferredSize(int cols) {
	return getMinimumSize(cols);
    }

    public Dimension getMinimumSize(int cols) {
	FontMetrics fm = getFontMetrics(target.getFont());
	return new Dimension(fm.charWidth('0') * cols + 20,fm.getHeight() + 8);
    }

    public boolean isFocusTraversable() {
	return true;
    }

    public void action() {
	target.postEvent(new Event(target, Event.ACTION_EVENT, ((TextField)target).getText()));
    }

    /**
     * DEPRECATED but, for now, called by setEchoChar(char).
     */
    public native void setEchoCharacter(char c);

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	return getMinimumSize();
    }

    /**
     * DEPRECATED
     */
    public Dimension minimumSize(int cols) {
	return getMinimumSize(cols);
    }

    /**
     * DEPRECATED
     */
    public Dimension preferredSize(int cols) {
	return getPreferredSize(cols);
    }

}
