/*
 * @(#)Win32Image.java	1.13 98/09/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.win32;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.image.ImageProducer;

class Win32Image extends sun.awt.image.Image {
    /**
     * Construct an image for offscreen rendering to be used with a
     * given Component.
     */
    public Win32Image(Component c, int w, int h) {
	super(c, w, h);
    }

    /**
     * Construct an image from an ImageProducer object.
     */
    public Win32Image(ImageProducer producer) {
	super(producer);
    }

    public Graphics getGraphics() {
	Graphics g = new Win32Graphics(this);
	initGraphics(g);
	return g;
    }

    protected sun.awt.image.ImageRepresentation getImageRep(int w, int h) {
	return super.getImageRep(w, h);
    }
}
