/*
 * @(#)Win32PrintJob.java	1.10 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.win32;

import java.awt.*;
import java.io.*;

/** 
 * A class which initiates and executes a Win32 print job.
 *
 * @version 1.0 24 Jan 1996
 * @author Erik Gilbert
 */
public class Win32PrintJob extends PrintJob {
    String  	 title;
    Dimension 	 pageDimension;
    int		 pageResolution;
    boolean 	 lastFirst = false;
    int		 pageCount = 0;
    int 	 printerDC = 0;

    public Win32PrintJob(String title) throws IOException {
	this.title = title;
	pageDimension = new Dimension((96 * 17)/2, 11 * 96); //for now
	pageResolution = 96; //for now
    }

    /**
     * Gets a Graphics object that will draw to the next page.
     * The page is flushed to the printer when the graphics 
     * object is disposed.
     */
    public Graphics getGraphics() {
	
	pageCount++;
	return new Win32PrintGraphics(this);
    }

    /**
     * Returns the dimensions of the page in pixels.
     */
    public Dimension getPageDimension() {
	return pageDimension;
    }

    /**
     * Returns the resolution of the page in pixels per inch.
     */
    public int getPageResolution() {
	return pageResolution;
    }

    /**
     * Returns true if the last page should be printed first.
     */
    public boolean lastPageFirst() {
	return lastFirst;
    }

    /**
     * Ends the print job and does cleanup.
     */
    public native void end();
}
