/*
 * @(#)WActiveEvent.java	1.4 98/09/13
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.windows;

import java.awt.*;

class WActiveEvent extends AWTEvent implements ActiveEvent {
    private WObjectPeer peer;
    private long pData;

    public WActiveEvent(Object target, WObjectPeer peer, long pData) {
        // The 'target' reference we pass here identifies the
        // event as associated with a particular instance. That
        // way the event can be removed by a call to removeSourceEvents.
        super(target, 0);
	this.peer = peer;
        this.pData = pData;
    }

    private native void dispatchImpl(long pData);
    private native void finalizeImpl(long pData);

    public void dispatch() {
        /* Only dispatch if the native component still exists */

        if (!peer.isDisposed()) {
	    synchronized (peer) {
	        if (!peer.isDisposed()) {
		    dispatchImpl(pData);
		}
	    }
	}
    }

    protected void finalize() throws Throwable {
	finalizeImpl(pData);
        super.finalize();
    }
}
