/*
 * @(#)WCanvasPeer.java	1.12 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import sun.awt.DrawingSurface;
import sun.awt.DrawingSurfaceInfo;

class WCanvasPeer extends WComponentPeer
    implements CanvasPeer, DrawingSurface
{

    // Toolkit & peer internals

    WCanvasPeer(Component target) {
	super(target);
    }

    native void create(WComponentPeer parent);

    void initialize() {
        super.initialize();
	Color bg = ((Component)target).getBackground();
	if (bg != null) {
	    setBackground(bg);
	}
    }

    public void print(Graphics g) {
	Dimension d = ((Component)target).getSize();
	g.setColor(((Component)target).getBackground());
	g.fillRect(0, 0, d.width, d.height);
	g.setColor(((Component)target).getForeground());
	g.setFont(((Component)target).getFont());
	super.print(g);
    }

    public DrawingSurfaceInfo getDrawingSurfaceInfo() {
	return new WDrawingSurfaceInfo(this);
    }
}
