/*
 * @(#)WCheckboxMenuItemPeer.java	1.11 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import java.awt.event.ItemEvent;

class WCheckboxMenuItemPeer extends WMenuItemPeer implements CheckboxMenuItemPeer {

    // CheckboxMenuItemPeer implementation

    public native void setState(boolean t);

    // Toolkit & peer internals

    WCheckboxMenuItemPeer(CheckboxMenuItem target) {
	this.target = target;
	isCheckbox = true;
	WMenuPeer parent = (WMenuPeer) WToolkit.targetToPeer(target.getParent());
	create(parent);
        setState(target.getState());
    }

    // native callbacks

    public void handleAction(final boolean state, final int modifiers) {
	final CheckboxMenuItem target = (CheckboxMenuItem)this.target;
	WToolkit.executeOnEventHandlerThread(target, new Runnable() {
	    public void run() {
		target.setState(state);
		postEvent(
		    new ItemEvent(target, ItemEvent.ITEM_STATE_CHANGED, target.getLabel(), 
                          state? ItemEvent.SELECTED : ItemEvent.DESELECTED));
	    }
	});
    }
}
