/*
 * @(#)WEmbeddedFrame.java	1.10 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.windows;

import sun.awt.EmbeddedFrame;
import java.awt.Toolkit;
import java.awt.Graphics;
import java.awt.peer.ComponentPeer;

public class WEmbeddedFrame extends EmbeddedFrame {

    static {
        initIDs();
    }

    private int handle = 0;

    native void setThisPeer(Object lp);

    public WEmbeddedFrame() {
        this(0);
    }

    public WEmbeddedFrame(int handle) {
        this.handle = handle;
        WToolkit toolkit = (WToolkit)Toolkit.getDefaultToolkit();
        setThisPeer(toolkit.createEmbeddedFrame(this));
        show();
    }

    /*
     * Print the embedded frame and its children using the specified HDC.
     */
    void print(int hdc) {
        WGraphics g = new WEmbeddedGraphics(hdc);
        printComponents(g);
        g.dispose();
    }

    /**
     * Initialize JNI field IDs
     */
    private static native void initIDs();
}
