/*
 * @(#)WFileDialogPeer.java	1.13 98/10/02
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import sun.awt.ScreenUpdater;
import java.io.FilenameFilter;

public class WFileDialogPeer extends WWindowPeer implements FileDialogPeer {

    static {
        initIDs();
    }

    private WComponentPeer parent;

    public void setDirectory(String dir) {}
    public void setFile(String file) {}
    public void setTitle(String title) {}

    public void	setFilenameFilter(FilenameFilter filter) {
        // We can set the filter, but can't do anything with it yet.
        System.err.println("setFilenameFilter not implemented\n");
    }

    // Toolkit & peer internals
    WFileDialogPeer(FileDialog target) {
	super(target);
    }

    void create(WComponentPeer parent) {
        this.parent = parent;
    }

    void initialize() {}

    protected void disposeImpl() {
        ScreenUpdater.updater.removeClient(this);
	WToolkit.targetDisposedPeer(target, this);
    }

    public native void show();

    // We don't actually have to invoke the NoClientCode versions of
    // these functions, but doing so is consistent with the Solaris impl.
    private native void targetSetDirectory_NoClientCode(FileDialog target,
							String dir);
    private native void targetSetFile_NoClientCode(FileDialog target,
						   String file);

    // native callbacks
    // We do not have to use WToolkit.executeOnEventHandlerThread because these
    // functions are never called from the Windows thread.
    void handleSelected(String file) {
        FileDialog fileDialog = (FileDialog) target;

        int index = file.lastIndexOf('\\');
	String dir;

	if (index == -1) {
	    dir = ".\\";
	    targetSetFile_NoClientCode(fileDialog, file);
	}
	else {
	    dir = file.substring(0, index + 1);
	    targetSetFile_NoClientCode(fileDialog, file.substring(index + 1));
	}
	targetSetDirectory_NoClientCode(fileDialog, dir);
	fileDialog.setVisible(false);
    }

    void handleCancel() {
        FileDialog fileDialog = (FileDialog) target;

	targetSetFile_NoClientCode(fileDialog, null);
	fileDialog.setVisible(false);
    }

    // unused methods.
    public void toFront() {}
    public void toBack() {}
    public void setResizable(boolean resizable) {}
    public void hide() {}
    public void enable() {}
    public void disable() {}
    public void reshape(int x, int y, int width, int height) {}
    public boolean handleEvent(Event e) { return false; }
    public void setForeground(Color c) {}
    public void setBackground(Color c) {}
    public void setFont(Font f) {}
    public void requestFocus() {}
    public void nextFocus() {}
    public void setCursor(int cursorType) {}
    void start() {}
    void invalidate(int x, int y, int width, int height) {}

    /**
     * Initialize JNI field and method ids
     */
    private static native void initIDs();
}
