/*
 * @(#)WFontPeer.java	1.9 98/03/18
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import sun.io.CharToByteConverter;
import sun.awt.PlatformFont;

public class WFontPeer extends PlatformFont {

    /*
     * Name for Windows FontSet.
     */
    private String wfsname;

    public WFontPeer(String name, int style){
	super(name, style);

	if (props != null){
	    wfsname = props.getProperty
		("fontset." + aliasName + "." + styleString);
	}
    }

    public CharToByteConverter
	getFontCharset(String charsetName, String fontName){

	CharToByteConverter fc;
	if (charsetName.equals("default")){
	    fc = (CharToByteConverter)charsetRegistry.get(fontName);
	} else {
	    fc = (CharToByteConverter)charsetRegistry.get(charsetName);
	}
	if (fc instanceof CharToByteConverter){
	    return fc;
	}

	Class fcc = null;

	try {
	    fcc = Class.forName(charsetName);
	} catch(ClassNotFoundException e) {
	    try {
		fcc = Class.forName("sun.io." + charsetName);
	    } catch (ClassNotFoundException exx) {
		try {
		    fcc = Class.forName("sun.awt.windows." + charsetName);
		} catch(ClassNotFoundException ex) {
		    fc = getDefaultFontCharset(fontName);
		}
	    }
	}

	if (fc == null) {
	    try {
	        fc = (CharToByteConverter)fcc.newInstance();
	    } catch(InstantiationException e) {
	        return getDefaultFontCharset(fontName);
	    } catch(IllegalAccessException e) {
	        return getDefaultFontCharset(fontName);
	    }
	}

	if (charsetName.equals("default")){
	    charsetRegistry.put(fontName, fc);
	} else {
	    charsetRegistry.put(charsetName, fc);
	}
	return fc;
    }


    private CharToByteConverter getDefaultFontCharset(String fontName){
	return new WDefaultFontCharset(fontName);
    }
} 

