/*
 * @(#)WLabelPeer.java	1.9 98/06/29
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;

class WLabelPeer extends WComponentPeer implements LabelPeer {

    // ComponentPeer overrides

    public Dimension getMinimumSize() {
	FontMetrics fm = getFontMetrics(((Label)target).getFont());
	String label = ((Label)target).getText();
	if (label == null)
            label = "";
	return new Dimension(fm.stringWidth(label) + 14, fm.getHeight() + 8);
    }

    // LabelPeer implementation

    public native void setText(String label);
    public native void setAlignment(int alignment);

    // Toolkit & peer internals

    WLabelPeer(Label target) {
	super(target);
    }

    native void create(WComponentPeer parent);

    void initialize() {
	Label	l = (Label)target;

        String  txt = l.getText();
	if (txt != null) {
	    setText(txt);
	}

        int align = l.getAlignment();
	if (align != Label.LEFT) {
	    setAlignment(align);
	}

	Color bg = ((Component)target).getBackground();
	if (bg != null) {
	    setBackground(bg);
	}

	super.initialize();
    }

    void clearRectBeforePaint(Graphics g, Rectangle r) {
        // Overload to do nothing for native components
    }

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	    return getMinimumSize();
    }

}
