/*
 * @(#)CmdIDList.h	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef CMDIDLIST_H
#define CMDIDLIST_H

#include "awt.h"
#include "awt_Object.h"

// A vector of UINTS, used to map CmdIDs -- it's purposely not generic, 
// so no whining. <grin>
class AwtCmdIDList {
public:
    AwtCmdIDList();
    ~AwtCmdIDList();

    UINT Add(AwtObject* obj);
    AwtObject* Lookup(UINT id);
    void Remove(UINT id);

    CriticalSection    m_lock;

private:
    AwtObject** m_array;  // the vector's contents
    UINT m_size;	  // the number of elements
    UINT m_capacity;	  // the maximum number of elements (before growing)
};


#endif // CMDIDLIST_H
