/*
 * @(#)awt_Brush.cpp	1.3 98/03/18
 *
 * Copyright 1996 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "awt_Brush.h"

Hashtable AwtBrush::cache("Brush cache", DeleteAwtBrush);

AwtBrush::AwtBrush(COLORREF color) {
    SetColor(color);
    HBRUSH brush = ::CreateSolidBrush(color);
    ASSERT(brush != NULL);
    SetHandle(brush);
}

AwtBrush* AwtBrush::Get(COLORREF color) {
    AwtBrush* obj = (AwtBrush*)cache.get((void*)color);
    if (obj == NULL) {
        obj = new AwtBrush(color);
        obj->IncrRefCount();
        VERIFY(cache.put((void*)color, obj) == NULL);
    }
    return obj;
}

void AwtBrush::RemoveFromCache() {
    VERIFY(cache.remove((void*)GetColor()) != NULL); 
}

void AwtBrush::DeleteAwtBrush(void* pBrush) {
    delete (AwtBrush*)pBrush;
}
