/*
 * @(#)awt_Dialog.h	1.14 98/07/17
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_DIALOG_H
#define AWT_DIALOG_H

#include "awt_Frame.h"

#include "java_awt_Dialog.h"
#include "sun_awt_windows_WDialogPeer.h"
#include <awt_image.h>


/************************************************************************
 * AwtDialog class
 */

class AwtDialog : public AwtFrame {
public:

    /* java.awt.Dialog field ids */
    static jfieldID titleID;

    AwtDialog();
    virtual ~AwtDialog();

    virtual const char* GetClassName();
    virtual void RegisterClass();
    virtual void SetResizable(BOOL isResizable);

    void ShowModal();
    void EndModal();
    static BOOL CALLBACK CountHWnds(HWND hWnd, AwtDialog* obj);
    static BOOL CALLBACK DisableHWnds(HWND hWnd, AwtDialog* obj);

    /* Create a new AwtDialog.  This must be run on the main thread. */
    static AwtDialog* Create(jobject peer, jobject hParent);
    virtual MsgRouting WmShowModal();
    virtual MsgRouting WmEndModal();
    virtual MsgRouting WmStyleChanged(WORD wStyleType, LPSTYLESTRUCT lpss);
    virtual MsgRouting WmSize(int type, int w, int h);
    virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

    // utility functions for application-modal dialogs
    static void ModalDisable(HWND hwndDlg);
    static void ModalEnable(HWND hwndDlg);
    static void ModalNextWindowToFront(HWND hwndDlg);

private:
    static int GetDisabledLevel(HWND hwnd);
    static void IncrementDisabledLevel(HWND hwnd, int increment);
    static void ResetDisabledLevel(HWND hwnd);
    static BOOL CALLBACK DisableTopLevelsCallback(HWND hWnd, LPARAM lParam);
    static BOOL CALLBACK EnableTopLevelsCallback(HWND hWnd, LPARAM lParam);
    static BOOL CALLBACK NextWindowToFrontCallback(HWND hWnd, LPARAM lParam);

    void UpdateSystemMenu();
    void UpdateDialogIcon();

    HWND  m_modalWnd;
};

#endif /* AWT_DIALOG_H */



