/*
 * @(#)awt_DnDDS.cpp	1.13 98/08/25
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "awt_DnDDS.h"
#include "awt_Toolkit.h"

#include "java_awt_event_InputEvent.h"
#include "java_awt_event_KeyEvent.h"
#include "java_awt_event_MouseEvent.h"

#include "java_awt_dnd_DnDConstants.h"

#include "java_awt_Cursor.h"

// #include "sun_awt_windows_WDragSourceContextPeer.h"

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include <shlobj.h>

#include "awt_Component.h"

extern "C" {
DWORD __cdecl convertActionsToDROPEFFECT(jint actions);
jint  __cdecl convertDROPEFFECTToActions(DWORD effects);

DWORD __cdecl mapModsToDROPEFFECT(DWORD, DWORD);

extern const char *const PredefinedClipboardNames[];

extern JNIEXPORT void JNICALL Java_sun_awt_windows_WCustomCursor_initIDs(JNIEnv *env, jclass cls);

}

/*
 * static initialization
 */

jclass AwtDragSource::dSCClazz    = (jclass)NULL; // the DragSourceContext
jclass AwtDragSource::awtCClazz   = (jclass)NULL; // the Cursor
jclass AwtDragSource::awtIEClazz  = (jclass)NULL; // InputEvent
jclass AwtDragSource::wdscpBClazz = (jclass)NULL; // WDragSourceContextPeerBuffer

jmethodID AwtDragSource::dSCdragenter  = (jmethodID)NULL;
jmethodID AwtDragSource::dSCdragmotion = (jmethodID)NULL;
jmethodID AwtDragSource::dSCopschanged = (jmethodID)NULL;
jmethodID AwtDragSource::dSCdragexit   = (jmethodID)NULL;
jmethodID AwtDragSource::dSCddfinish   = (jmethodID)NULL;

jmethodID AwtDragSource::dSCgetdxh     = (jmethodID)NULL;
jmethodID AwtDragSource::dSCgetdyh     = (jmethodID)NULL;
jmethodID AwtDragSource::dSCgetdiwcr   = (jmethodID)NULL;

jmethodID AwtDragSource::dSCconvertdata  = (jmethodID)NULL;
jmethodID AwtDragSource::dSCconvertfiles = (jmethodID)NULL;

jmethodID AwtDragSource::wdscpBgetbuffer = (jmethodID)NULL;
jmethodID AwtDragSource::wdscpBsize      = (jmethodID)NULL;

jfieldID AwtDragSource::awtCtype  = (jfieldID)NULL;
jfieldID AwtDragSource::awtCpdata = (jfieldID)NULL;
jfieldID AwtDragSource::awtIEmods = (jfieldID)NULL;

/**
 * static initialization
 */

void AwtDragSource::InitAwtDragSource() {
    JNIEnv* env = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    // first load the class ...

    dSCClazz = env->FindClass("sun/awt/windows/WDragSourceContextPeer");

    if (JNU_IsNull(env, dSCClazz)) return;

    dSCClazz = (jclass)env->NewGlobalRef(dSCClazz); // never freed

    // now resolve upcalls ...

    dSCdragenter = env->GetMethodID(dSCClazz, "dragEnter", "(III)V");

    if (JNU_IsNull(env, dSCdragenter)) return;

    dSCdragmotion = env->GetMethodID(dSCClazz, "dragMotion", "(III)V");

    if (JNU_IsNull(env, dSCdragmotion)) return;

    dSCopschanged = env->GetMethodID(dSCClazz, "operationChanged", "(III)V");

    if (JNU_IsNull(env, dSCopschanged)) return;

    dSCdragexit = env->GetMethodID(dSCClazz, "dragExit", "(I)V");

    if (JNU_IsNull(env, dSCdragexit)) return;

    dSCddfinish = env->GetMethodID(dSCClazz, "dragDropFinished", "(ZIIIZ)V");

    if (JNU_IsNull(env, dSCddfinish)) return;

    dSCgetdxh = env->GetMethodID(dSCClazz, "getDropXHint", "()I");

    if (JNU_IsNull(env, dSCgetdxh)) return;

    dSCgetdyh = env->GetMethodID(dSCClazz, "getDropYHint", "()I");

    if (JNU_IsNull(env, dSCgetdyh)) return;

    dSCgetdiwcr = env->GetMethodID(dSCClazz, "getDroppedInWindowCR", "()Z");

    if (JNU_IsNull(env, dSCgetdiwcr)) return;

    dSCconvertdata = env->GetMethodID(dSCClazz, "convertData", "(Ljava/lang/String;)Lsun/awt/windows/WDragSourceContextPeerBuffer;");

    if (JNU_IsNull(env, dSCconvertdata)) return;


    dSCconvertfiles = env->GetMethodID(dSCClazz, "convertFileList", "(Ljava/lang/String;)[Ljava/lang/String;");

    if (JNU_IsNull(env, dSCconvertfiles)) return;

    wdscpBClazz = env->FindClass("sun/awt/windows/WDragSourceContextPeerBuffer");
    if (JNU_IsNull(env, wdscpBClazz)) return;

    wdscpBClazz = (jclass)env->NewGlobalRef(wdscpBClazz); // never freed

    wdscpBgetbuffer = env->GetMethodID(wdscpBClazz, "getBuffer", "()[B");

    if (JNU_IsNull(env, wdscpBgetbuffer)) return;

    wdscpBsize = env->GetMethodID(wdscpBClazz, "size", "()I");

    if (JNU_IsNull(env, wdscpBsize)) return;

    awtCClazz = env->FindClass("sun/awt/windows/WCustomCursor");

    if (JNU_IsNull(env, awtCClazz)) {
	env->ExceptionDescribe();
	return;
    }

    awtCClazz = (jclass)env->NewGlobalRef(awtCClazz);

    if (JNU_IsNull(env, awtCClazz)) return;

    awtCtype = env->GetFieldID(awtCClazz, "type",  "I");

    if (JNU_IsNull(env, awtCtype)) return;

    awtCpdata = env->GetFieldID(awtCClazz, "pData", "I");

    if (JNU_IsNull(env, awtCpdata)) return;

    awtIEClazz = (jclass)env->FindClass("java/awt/event/InputEvent");

    if (JNU_IsNull(env, awtIEClazz)) return;

    awtIEClazz = (jclass)env->NewGlobalRef(awtIEClazz);

    awtIEmods = env->GetFieldID(awtIEClazz, "modifiers", "I");

    if (JNU_IsNull(env, awtIEmods)) return;
}

/**
 * StartDrag
 */

void AwtDragSource::StartDrag(AwtDragSource* self, jobject cursor) {
    JNIEnv* 		   env   	 = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);
    HCURSOR		   initialCursor = self->SetCursor(cursor);

    AwtToolkit::GetInstance().WaitForSingleObject(self->m_mutex);

    AwtToolkit::GetInstance().InvokeFunctionLater((void (*)(void *))&AwtDragSource::_DoDragDrop, (void *)self);

    self->WaitUntilSignalled(FALSE);

    if (initialCursor != NULL) ::SetCursor(initialCursor);
}

/**
 * DoDragDrop - called from message pump thread
 */

void AwtDragSource::_DoDragDrop(void* param) {
    AwtDragSource* dragSource   = (AwtDragSource*)param;
    DWORD          effects      = DROPEFFECT_NONE;
    JNIEnv*        env          = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);
    jobject        peer         = env->NewLocalRef(dragSource->GetPeer());
    POINT          client       = { 0, 0 };
    POINT          drop         = { 0, 0 };
    jboolean       dropInClient = JNI_FALSE;

    HRESULT        res;

    // StartDrag has caused dragSource->m_mutex to be held by our thread now

    res = ::DoDragDrop(dragSource,
		       dragSource,
		       dragSource->m_effects = convertActionsToDROPEFFECT(dragSource->m_actions),
		       &effects
	  );

    // for later HDROP processing ... probably wrong ... but a good guess
    // the x,y and dropInClient boolean are used to fill in the DROPFILES
    // structs later ...

    if (res == DRAGDROP_S_DROP && effects != DROPEFFECT_NONE) {

	::GetCursorPos(&drop);

	HWND win = ::WindowFromPoint(client = drop);

	if (win != (HWND)NULL || win != ::GetDesktopWindow()) {
	    ::ScreenToClient(win, &client);

	    RECT rect;

	    ::GetClientRect(win, &rect);

	    dropInClient = (client.x < rect.left  ||
	  		    client.x > rect.right ||
	     		    client.y < rect.top   ||
	     		    client.y > rect.bottom) ? JNI_FALSE : JNI_TRUE;
	}
    }

    env->CallVoidMethod(peer,
			dSCddfinish,
			res     == DRAGDROP_S_DROP &&
			effects != DROPEFFECT_NONE,
			convertDROPEFFECTToActions(effects),
			(jint)client.x,
			(jint)client.y,
			dropInClient ? JNI_TRUE : JNI_FALSE
		);

    env->DeleteLocalRef(peer);

    dragSource->Signal();
}

/**
 * constructor
 */

AwtDragSource::AwtDragSource(JNIEnv* env, jobject peer, jobject trigger, jint actions, jobjectArray types) {
    m_peer	= env->NewGlobalRef(peer);

    m_refs	= 0;

    m_actions   = actions;

    m_ntypes    = 0;

    m_trigger   = env->NewGlobalRef(trigger);
    m_initmods	= env->GetIntField(trigger, awtIEmods);
    m_lastmods	= m_initmods;

    m_cancel    = JNI_FALSE;

    m_startCond  = JNI_FALSE;

    m_droptarget   = NULL;
    m_enterpending = FALSE;

    m_cursortype = java_awt_Cursor_DEFAULT_CURSOR;
    m_cursor     = NULL;

    m_mutex      = ::CreateMutex(NULL, FALSE, NULL);

    LoadCache(types);

    AddRef();

}

/**
 * destructor
 */

AwtDragSource::~AwtDragSource() {
    JNIEnv* env = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    env->DeleteGlobalRef(m_peer);
    env->DeleteGlobalRef(m_trigger);

    ::CloseHandle(m_mutex);

    UnloadCache();
}

/**
 * _compar
 *
 * compare format's then tymed's .... only one tymed bit may be set
 * at any time in a FORMATETC in the cache.
 */

int AwtDragSource::_compar(const void* first, const void* second) {
    CachePtr fp = *((CachePtr*)first);
    CachePtr sp = *((CachePtr*)second);
    int      r  = fp->m_formatEtc.cfFormat - sp->m_formatEtc.cfFormat;

    return r != 0 ? r : fp->m_formatEtc.tymed - sp->m_formatEtc.tymed;
}

/**
 * LoadCache
 */

void AwtDragSource::LoadCache(jobjectArray types) {
    JNIEnv*      env = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);
    unsigned int items;

    if (m_types != (CachePtr*)NULL) UnloadCache();

    items = m_ntypes = env->GetArrayLength(types);

    if (m_ntypes == 0) return;

    // we allocate twice the number of actual types in order to represent
    // them both as FORMATETC's for HGLOBAL's and ISTREAM TYMED's ...

    m_types = (CachePtr*)calloc(sizeof(CachePtr), m_ntypes *= 2);

    if (m_types == (CachePtr*)NULL) {
	m_ntypes == 0;

	JNU_ThrowOutOfMemoryError(env, "OutOfMemoryError");
	return;
    }

    for (unsigned int i = 0; i < items; i++) {
	unsigned int idx = i * 2;
	unsigned int fmt;
        jstring	     jstr = (jstring)env->GetObjectArrayElement(types, (jsize)i);
        jboolean     isCopy;
	const  char* str  = env->GetStringUTFChars(jstr, &isCopy);

	for (fmt = 1; fmt < CF_MAX; fmt++) 
	    if (strcmp(str, PredefinedClipboardNames[fmt]) == 0) break;

	if (fmt == CF_MAX) fmt = ::RegisterClipboardFormat(str);

	m_types[idx] = (CachePtr)calloc(sizeof(CacheRec), 1);

	if (m_types[idx] == (CachePtr)NULL) {
	   env->ReleaseStringUTFChars(jstr, str);

	   m_ntypes = idx + 1; 
	   
	   UnloadCache(); // cleanup

	   JNU_ThrowOutOfMemoryError(env, "OutOfMemoryError");
	   return;
	}

	m_types[idx]->m_formatEtc.cfFormat = fmt;
	m_types[idx]->m_formatEtc.dwAspect = DVASPECT_CONTENT;
	m_types[idx]->m_formatEtc.lindex   = -1;
	m_types[idx]->m_formatEtc.tymed    = TYMED_HGLOBAL; // for now ...

	m_types[idx]->m_atomName	   = env->NewGlobalRef(jstr);

	// now make a copy, but with a TYMED of ISTREAM

	idx++;

	m_types[idx] = (CachePtr)calloc(sizeof(CacheRec), 1);

	if (m_types[idx] == (CachePtr)NULL) {
	   env->ReleaseStringUTFChars(jstr, str);

	   m_ntypes = idx + 1; 
	   
	   UnloadCache(); // cleanup

	   JNU_ThrowOutOfMemoryError(env, "OutOfMemoryError");
	   return;
	}

	m_types[idx]->m_formatEtc 	= m_types[idx - 1]->m_formatEtc;
	m_types[idx]->m_formatEtc.tymed = TYMED_ISTREAM;
	m_types[idx]->m_atomName        = env->NewGlobalRef(jstr);

	env->ReleaseStringUTFChars(jstr, str);
    }

    // sort them in ascending order of format

    qsort((void *)m_types, (size_t)m_ntypes, (size_t)sizeof(CachePtr), _compar);
}

/**
 * UnloadCache
 */

void AwtDragSource::UnloadCache() {
    JNIEnv* env = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    if (m_ntypes == 0) return;

    for (unsigned int i = 0; i < m_ntypes; i++) {
	env->DeleteGlobalRef(m_types[i]->m_atomName);

	free((void*)m_types[i]);
    }

    free((void*)m_types);

    m_ntypes = 0;
    m_types  = (CachePtr*)NULL;
}

/**
 * SetCursor
 */

HCURSOR AwtDragSource::SetCursor(jobject cursor) {
    JNIEnv* env = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    if (JNU_IsNull(env, cursor)) return ::GetCursor();

    m_cursortype = env->GetIntField(cursor, awtCtype);

    if (m_cursortype == java_awt_Cursor_CUSTOM_CURSOR) {
	m_cursor = (HCURSOR)env->GetIntField(cursor, awtCpdata);
    } else {
        LPCTSTR winCursor;

        switch (m_cursortype) {
          case java_awt_Cursor_DEFAULT_CURSOR:
          default:
              winCursor = IDC_ARROW;
              break;
          case java_awt_Cursor_CROSSHAIR_CURSOR:
              winCursor = IDC_CROSS;
              break;
          case java_awt_Cursor_TEXT_CURSOR:
              winCursor = IDC_IBEAM;
              break;
          case java_awt_Cursor_WAIT_CURSOR:
              winCursor = IDC_WAIT;
              break;
          case java_awt_Cursor_NE_RESIZE_CURSOR:
          case java_awt_Cursor_SW_RESIZE_CURSOR:
              winCursor = IDC_SIZENESW;
              break;
          case java_awt_Cursor_SE_RESIZE_CURSOR:
          case java_awt_Cursor_NW_RESIZE_CURSOR:
              winCursor = IDC_SIZENWSE;
              break;
          case java_awt_Cursor_N_RESIZE_CURSOR:
          case java_awt_Cursor_S_RESIZE_CURSOR:
              winCursor = IDC_SIZENS;
              break;
          case java_awt_Cursor_W_RESIZE_CURSOR:
          case java_awt_Cursor_E_RESIZE_CURSOR:
              winCursor = IDC_SIZEWE;
              break;
          case java_awt_Cursor_HAND_CURSOR:
              winCursor = "HAND_CURSOR";
              break;
          case java_awt_Cursor_MOVE_CURSOR:
              winCursor = IDC_SIZEALL;
              break;
        }

        m_cursor = ::LoadCursor(NULL, winCursor);

        if (m_cursor == NULL) { /* Not a system cursor, check for resource. */

            m_cursor = ::LoadCursor(AwtToolkit::GetInstance().GetModuleHandle(), winCursor);
        }
    }

    if (m_cursor == NULL) {
        /* Not found anywhere, use default. */
        m_cursor     = ::LoadCursor(NULL, IDC_ARROW);
	m_cursortype = java_awt_Cursor_DEFAULT_CURSOR;
    }

    HCURSOR oldCursor = NULL;

    if (m_cursor != NULL) {
	oldCursor = ::SetCursor(m_cursor);
    }

    return oldCursor;
}

/**
 * MatchFormatEtc
 */

HRESULT __stdcall  AwtDragSource::MatchFormatEtc(FORMATETC __RPC_FAR *pFormatEtcIn, CachePtr* cacheEnt) {

    if ((pFormatEtcIn->tymed & (TYMED_HGLOBAL | TYMED_ISTREAM)) == 0)
	return DV_E_TYMED;

    if (pFormatEtcIn->lindex != -1) return DV_E_LINDEX;

    if (pFormatEtcIn->dwAspect != DVASPECT_CONTENT) return DV_E_DVASPECT;

    FORMATETC  fetc  = *pFormatEtcIn;
    FORMATETC* fetcp = &fetc;
    CachePtr*  centp = (CachePtr*)NULL;

    if ((pFormatEtcIn->tymed & TYMED_HGLOBAL) != 0) {
    	fetc.tymed = TYMED_HGLOBAL;

    	centp = (CachePtr*)bsearch((const void *)&fetcp,
				   (const void *)m_types,
				   (size_t)      m_ntypes,
				   (size_t)      sizeof(CachePtr),
				  	         _compar
			  );

	if (centp != (CachePtr*)NULL) {
	    if (cacheEnt != (CachePtr*)NULL) *cacheEnt = *centp;
	    return S_OK;
        }
    }

    if ((pFormatEtcIn->tymed & TYMED_ISTREAM) != 0) {
    	fetc.tymed = TYMED_ISTREAM;

    	centp = (CachePtr*)bsearch((const void *)&fetcp,
				   (const void *)m_types,
				   (size_t)      m_ntypes,
				   (size_t)      sizeof(CachePtr),
				  	        _compar
			  );

	if (centp != (CachePtr*)NULL) {
	    if (cacheEnt != (CachePtr*)NULL) *cacheEnt = *centp;
	    return S_OK;
        }
    }

    return DV_E_FORMATETC;
}

/**
 * QueryInterface
 */

HRESULT __stdcall AwtDragSource::QueryInterface(REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject) {
    if (riid == IID_IUnknown) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IUnknown*)(IDropSource*)this;
	AddRef();
	return S_OK;
    } else if (riid == IID_IDropSource) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IDropSource*)this;
	AddRef();
	return S_OK;
    } else if (riid == IID_IDataObject) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IDataObject*)this;
	AddRef();
	return S_OK;
    } else {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)NULL;
	return E_NOINTERFACE;
    }
}

/**
 * AddRef
 */

ULONG __stdcall AwtDragSource::AddRef() {
    return (ULONG)++m_refs;
}

/**
 * Release
 */

ULONG __stdcall AwtDragSource::Release() {
    int refs;

    if ((refs = --m_refs) == 0) delete this;

    return (ULONG)refs;
}

/**
 * QueryContinueDrag
 */

HRESULT __stdcall  AwtDragSource::QueryContinueDrag(BOOL fEscapeKeyPressed, DWORD grfKeyState) {
    JNIEnv* env       = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);
    jint    mb        = 0;
    jint    initialmb = m_initmods & (java_awt_event_InputEvent_BUTTON1_MASK |
				      java_awt_event_InputEvent_SHIFT_MASK   |
				      java_awt_event_InputEvent_CTRL_MASK    |
				      java_awt_event_InputEvent_ALT_MASK     |
				      java_awt_event_InputEvent_META_MASK
				     );

    if (m_cancel || fEscapeKeyPressed)
	return DRAGDROP_S_CANCEL;

    if ((grfKeyState & MK_LBUTTON) || (::GetAsyncKeyState(VK_LBUTTON) & 0xff00))
	mb    = LEFT_BUTTON;
    else if ((grfKeyState & MK_MBUTTON) || (::GetAsyncKeyState(VK_MBUTTON) & 0xff00))
	mb = MIDDLE_BUTTON;
    else if ((grfKeyState & MK_RBUTTON) || (::GetAsyncKeyState(VK_RBUTTON) & 0xff00))
	mb = RIGHT_BUTTON;

    jint modifiers = AwtComponent::GetJavaModifiers(0, mb);

    if (!m_startCond)
	m_startCond = (modifiers & initialmb) == initialmb;
    else if ((modifiers & initialmb) != initialmb) {
	return DRAGDROP_S_DROP;
    } else if (m_lastmods != (modifiers = AwtComponent::GetJavaModifiers(grfKeyState, mb))) {
	env->CallVoidMethod(m_peer, dSCopschanged, convertDROPEFFECTToActions(mapModsToDROPEFFECT(m_effects, grfKeyState)), m_actions, modifiers);
    }

    m_lastmods = modifiers;

   if (m_cancel)
	return DRAGDROP_S_CANCEL;
   else {
	::SetCursor(m_cursor);

	return S_OK;
   }
}

/**
 * GiveFeedback
 */

HRESULT __stdcall  AwtDragSource::GiveFeedback(DWORD dwEffect) {
    JNIEnv* env       = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);
    jint    modifiers = 0;
    int	    mb;
    SHORT   mods      = 0;


    m_actions = convertDROPEFFECTToActions(dwEffect);

    if (::GetAsyncKeyState(VK_LBUTTON) & 0xff00) {
	mb    = LEFT_BUTTON;
	mods |= MK_LBUTTON;
    } else if (::GetAsyncKeyState(VK_MBUTTON) & 0xff00) {
	mb    = MIDDLE_BUTTON;
	mods |= MK_MBUTTON;
    } else if (::GetAsyncKeyState(VK_RBUTTON) & 0xff00) {
	mb    = RIGHT_BUTTON;
	mods |= MK_RBUTTON;
    }

    if (::GetAsyncKeyState(VK_SHIFT)   & 0xff00)
	mods |= MK_SHIFT;
    if (::GetAsyncKeyState(VK_CONTROL) & 0xff00)
	mods |= MK_CONTROL;
    if (::GetAsyncKeyState(VK_MENU) & 0xff00)
	mods |= MK_ALT;
	
    modifiers = AwtComponent::GetJavaModifiers(mods, mb);

    POINT curs;

    ::GetCursorPos(&curs);

    HWND win = ::WindowFromPoint(curs);

    int invalid = (dwEffect == DROPEFFECT_NONE);

    if (m_droptarget != NULL) {
	if (!invalid) {
	    env->CallVoidMethod(m_peer,
				m_enterpending ? dSCdragenter : dSCdragmotion,
				m_effects = convertDROPEFFECTToActions(mapModsToDROPEFFECT(dwEffect, mods)),
				m_actions,
				modifiers
	    );

	    m_droptarget   = win;
            m_enterpending = FALSE;
	} else {
	    if (!m_enterpending)
	        env->CallVoidMethod(m_peer, dSCdragexit, modifiers);

	    m_droptarget = (HWND)NULL;
	}

        m_enterpending = FALSE;
    } else if (!invalid) {
	m_droptarget   = win;
	m_enterpending = TRUE;
    }
 
    ::SetCursor(m_cursor);

    if (m_cursortype == java_awt_Cursor_CUSTOM_CURSOR) {
	return S_OK; 
    } else {
	return DRAGDROP_S_USEDEFAULTCURSORS;
    }
}


/**
 * GetData
 */

HRESULT __stdcall  AwtDragSource::GetData(FORMATETC __RPC_FAR *pFormatEtc, STGMEDIUM __RPC_FAR *pmedium) {
    CachePtr  cp;
    HRESULT   res = MatchFormatEtc(pFormatEtc, &cp);

    if (res != S_OK) return res;

    JNIEnv* env    = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    if (pFormatEtc->cfFormat != CF_HDROP) {
        jobject buffer = env->CallObjectMethod(m_peer, dSCconvertdata, cp->m_atomName);
        if (JNU_IsNull(env, buffer)) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

        jbyteArray bytes = (jbyteArray)env->CallObjectMethod(buffer, wdscpBgetbuffer);
    
        if (JNU_IsNull(env, bytes)) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

        jint len = env->CallIntMethod(buffer, wdscpBsize);

        if (!JNU_IsNull(env, env->ExceptionOccurred()) || len == 0) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

    
        if ((pFormatEtc->tymed & TYMED_ISTREAM) != 0) {
	    ADSIStreamProxy* istream = new ADSIStreamProxy(this, bytes, len);

	    if (!JNU_IsNull(env, env->ExceptionOccurred())) return E_UNEXPECTED;

            pmedium->tymed          = TYMED_ISTREAM;
            pmedium->pstm           = istream;
            pmedium->pUnkForRelease = (IUnknown*)istream;

	    return S_OK;
	} else if ((pFormatEtc->tymed & TYMED_HGLOBAL) != 0) {
            HGLOBAL copy = ::GlobalAlloc(GMEM_MOVEABLE, len);

            if (copy == NULL) return E_OUTOFMEMORY;
    
            LPVOID addr = ::GlobalLock(copy);
    
            env->GetByteArrayRegion(bytes, 0, len, (jbyte*)addr);

    	    if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

	        ::GlobalFree(copy);

	        return E_UNEXPECTED;
            }

            pmedium->tymed          = TYMED_HGLOBAL;
            pmedium->hGlobal        = copy; // GlobalFree'd by requestor later
            pmedium->pUnkForRelease = (IUnknown*)NULL;

	    return S_OK;
	}
    } else if ((pFormatEtc->tymed & TYMED_HGLOBAL) != 0) { // CF_HDROP
	jobjectArray files = (jobjectArray)env->CallObjectMethod(m_peer, dSCconvertfiles, cp->m_atomName);

        if (JNU_IsNull(env, files)) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

	jint nfiles = (env)->GetArrayLength(files);

	if (nfiles == 0) return E_UNEXPECTED;

	int blen = 1; // trailing NULL byte

	static jobject buf[16];
	static jsize   slb[sizeof(buf)/sizeof(buf[0])];

	jobject* bp;
	jsize*   bslp;

	if (nfiles > sizeof(buf)/sizeof(buf[0])) {
	    bp   = (jobject*)calloc(sizeof(jobject), nfiles);
	    bslp = (jsize*)calloc(sizeof(jsize), nfiles);
	} else {
	    bp   = buf;
	    bslp = slb;
	}

	for (int i = 0; i < nfiles; i++) {
	    bp[i] = env->GetObjectArrayElement(files, (jsize)i);

	    if (JNU_IsNull(env, bp[i])) {
		if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
		}

	        return E_UNEXPECTED;
	    }

	    if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

		if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
		}

	        return E_UNEXPECTED;
	    }


	    bslp[i] = env->GetStringUTFLength((jstring)bp[i]);

	    if (bslp[i] == 0 || !JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

		if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
		}

	        return E_UNEXPECTED;
	    }

	    blen += bslp[i] + 1; // trailing null byte
	}

	// blen now equals the length of the buffer we need ...

	HGLOBAL buffer = ::GlobalAlloc(GMEM_MOVEABLE, sizeof(DROPFILES) + blen);

        if (buffer == NULL) {
	    if (bp != buf) {
		free((void *)bp);
		free((void *)bslp);
	    }

	    return E_OUTOFMEMORY;
	}
    
        LPVOID       addr     = ::GlobalLock(buffer);
	LPDROPFILES dropFiles = (LPDROPFILES)addr;

	char* caddr = (char *)addr + sizeof(DROPFILES);
	
	dropFiles->pFiles  = sizeof(DROPFILES);

	dropFiles->pt.x = (LONG)env->CallIntMethod(m_peer, dSCgetdxh);
	dropFiles->pt.y = (LONG)env->CallIntMethod(m_peer, dSCgetdyh);

	dropFiles->fNC   = env->CallBooleanMethod(m_peer, dSCgetdiwcr);
	dropFiles->fWide = FALSE; // good guess!

	for (i = 0; i < nfiles; i++) { // pass 2 ... lets do the copy
	    jboolean    isCopy;
	    const char* utf = env->GetStringUTFChars((jstring)bp[i], &isCopy);

	    if (utf == (const char*)NULL || !JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

	        if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
	        }

		::GlobalFree(buffer);

	        return E_UNEXPECTED;
	    }

	    memcpy((void *)caddr, (void *)utf ,bslp[i]); // copy it

	    env->ReleaseStringUTFChars((jstring)bp[i], utf);

	    caddr += bslp[i]; // move pointer to end of utf string

	    *caddr++ = '\0'; // terminate with null byte
	}

	*caddr = '\0'; // terminate with null byte

	if (bp != buf) {
	    free((void *)bp);
	    free((void *)bslp);
	}

        pmedium->tymed          = TYMED_HGLOBAL;
        pmedium->hGlobal        = buffer; // GlobalFree'd by requestor later
        pmedium->pUnkForRelease = (IUnknown*)NULL;

	return S_OK;
    }

    return DV_E_TYMED;
}

/**
 * GetDataHere
 */

HRESULT __stdcall  AwtDragSource::GetDataHere(FORMATETC __RPC_FAR *pFormatEtc, STGMEDIUM __RPC_FAR *pmedium) {
    if (pmedium->pUnkForRelease != (IUnknown*)NULL) return E_INVALIDARG;

    CachePtr  cp;
    HRESULT   res = MatchFormatEtc(pFormatEtc, &cp);

    if (res != S_OK) return res;

    JNIEnv* env    = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    if (pFormatEtc->cfFormat != CF_HDROP) {
        jobject buffer = env->CallObjectMethod(m_peer, dSCconvertdata, cp->m_atomName);
        if (JNU_IsNull(env, buffer)) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

        jbyteArray bytes = (jbyteArray)env->CallObjectMethod(buffer, wdscpBgetbuffer);
    
        if (JNU_IsNull(env, bytes)) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();
    
	    return E_UNEXPECTED;
        }

        jint blen = env->CallIntMethod(buffer, wdscpBsize);
    
        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

        if (blen == 0) return E_UNEXPECTED;

        switch (pmedium->tymed) {
	    case TYMED_HGLOBAL: {
	        int mlen = ::GlobalSize(pmedium->hGlobal);

    	        if (blen > mlen) return STG_E_MEDIUMFULL;

	        LPVOID addr = ::GlobalLock(pmedium->hGlobal);

                env->GetByteArrayRegion(bytes, 0, blen, (jbyte*)addr);

    	        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	     	    env->ExceptionDescribe();
	    	    env->ExceptionClear();

	    	    return E_UNEXPECTED;
                }

                ::GlobalUnlock(pmedium->hGlobal);

	        return S_OK;
	    }

	    case TYMED_ISTREAM: {
	        jbyte*  addr = (jbyte*)calloc(sizeof(jbyte), blen);

	        if (addr == NULL) {
		    JNU_ThrowOutOfMemoryError(env, "OutOfMemoryError");
		    return E_OUTOFMEMORY;
	        }

                env->GetByteArrayRegion(bytes, 0, blen, addr);
    
    	        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	      	    env->ExceptionDescribe();
	    	    env->ExceptionClear();

	    	    return E_UNEXPECTED;
                }

	        ULONG   act;
	        HRESULT res = pmedium->pstm->Write((const void *)addr, (ULONG)blen, &act);
	        free((void *)addr);

	        return res;
            }

	    default:
	        return DV_E_TYMED;
        }
    } else if (pmedium->tymed == TYMED_HGLOBAL) { // CF_HDROP to buffer ...
	jobjectArray files = (jobjectArray)env->CallObjectMethod(m_peer, dSCconvertfiles, cp->m_atomName);

        if (JNU_IsNull(env, files)) return E_UNEXPECTED;

        if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	    env->ExceptionDescribe();
	    env->ExceptionClear();

	    return E_UNEXPECTED;
        }

	jint nfiles = (env)->GetArrayLength(files);

	if (nfiles == 0) return E_UNEXPECTED;

	int blen = 1; // trailing NULL byte

	static jobject buf[16];
	static jsize   slb[sizeof(buf)/sizeof(buf[0])];

	jobject* bp;
	jsize*   bslp;

	if (nfiles > sizeof(buf)/sizeof(buf[0])) {
	    bp   = (jobject*)calloc(sizeof(jobject), nfiles);
	    bslp = (jsize*)calloc(sizeof(jsize), nfiles);
	} else {
	    bp   = buf;
	    bslp = slb;
	}

	for (int i = 0; i < nfiles; i++) {
	    bp[i] = env->GetObjectArrayElement(files, (jsize)i);

	    if (JNU_IsNull(env, bp[i])) {
		if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
		}

	        return E_UNEXPECTED;
	    }

	    if (!JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

		if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
		}

	        return E_UNEXPECTED;
	    }


	    bslp[i] = env->GetStringUTFLength((jstring)bp[i]);

	    if (bslp[i] == 0 || !JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

		if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
		}

	        return E_UNEXPECTED;
	    }

	    blen += bslp[i] + 1; // trailing null byte
	}

	// blen now equals the length of the buffer we need ...

	int mlen = ::GlobalSize(pmedium->hGlobal);

	if (mlen < blen) { // oops its too small ...
	    if (bp != buf) {
		free((void *)bp);
		free((void *)bslp);
	    }

	    return E_OUTOFMEMORY;
	}

	LPVOID      addr      = ::GlobalLock(pmedium->hGlobal);
	LPDROPFILES dropFiles = (LPDROPFILES)addr;

	char* caddr = (char *)addr + sizeof(DROPFILES);
	
	dropFiles->pFiles  = sizeof(DROPFILES);

	dropFiles->pt.x = (LONG)env->CallIntMethod(m_peer, dSCgetdxh);
	dropFiles->pt.y = (LONG)env->CallIntMethod(m_peer, dSCgetdyh);

	dropFiles->fNC   = env->CallBooleanMethod(m_peer, dSCgetdiwcr);
	dropFiles->fWide = FALSE; // good guess!

	for (i = 0; i < nfiles; i++) { // pass 2 ... lets do the copy
	    jboolean    isCopy;
	    const char* utf = env->GetStringUTFChars((jstring)bp[i], &isCopy);

	    if (utf == (const char*)NULL || !JNU_IsNull(env, env->ExceptionOccurred())) {
	        env->ExceptionDescribe();
	        env->ExceptionClear();

	        if (bp != buf) {
		    free((void *)bp);
		    free((void *)bslp);
	        }

		::GlobalUnlock(pmedium->hGlobal);

	        return E_UNEXPECTED;
	    }

	    memcpy((void *)caddr, (void *)utf ,bslp[i]); // copy it

	    env->ReleaseStringUTFChars((jstring)bp[i], utf);

	    caddr += bslp[i]; // move pointer to end of utf string

	    *caddr++ = '\0'; // terminate with null byte
	}

	*caddr = '\0'; // terminate with null byte

	if (bp != buf) {
	    free((void *)bp);
	    free((void *)bslp);
	}

	::GlobalUnlock(pmedium->hGlobal);
    }
    
    return E_UNEXPECTED;
}

/**
 * QueryGetData
 */

HRESULT __stdcall  AwtDragSource::QueryGetData(FORMATETC __RPC_FAR *pFormatEtc) {
    return MatchFormatEtc(pFormatEtc, (CachePtr*)NULL);
}


/**
 * GetCanonicalFormatEtc
 */

HRESULT __stdcall  AwtDragSource::GetCanonicalFormatEtc(FORMATETC __RPC_FAR *pFormatEtcIn, FORMATETC __RPC_FAR *pFormatEtcOut) {
    HRESULT   res = MatchFormatEtc(pFormatEtcIn, (CachePtr*)NULL);

    if (res != S_OK) return res;

    *pFormatEtcOut = *pFormatEtcIn;

    pFormatEtcOut->ptd = NULL;

    return DATA_S_SAMEFORMATETC;
}

/**
 * SetData
 */

HRESULT __stdcall AwtDragSource::SetData(FORMATETC __RPC_FAR *pFormatEtc, STGMEDIUM __RPC_FAR *pmedium, BOOL fRelease) {
    return E_NOTIMPL;
}

/**
 * EnumFormatEtc
 */

HRESULT __stdcall  AwtDragSource::EnumFormatEtc(DWORD dwDirection, IEnumFORMATETC *__RPC_FAR *ppenumFormatEtc) {
    *ppenumFormatEtc = new ADSIEnumFormatEtc(this);
    return S_OK;
}

/**
 * DAdvise
 */

HRESULT __stdcall  AwtDragSource::DAdvise(FORMATETC __RPC_FAR *pFormatEtc, DWORD advf, IAdviseSink __RPC_FAR *pAdvSink, DWORD __RPC_FAR *pdwConnection) {
    return E_NOTIMPL;
}

/**
 * DUnadvise
 */

HRESULT __stdcall  AwtDragSource::DUnadvise(DWORD dwConnection) {
    return OLE_E_ADVISENOTSUPPORTED;
}

/**
 * EnumAdvise
 */

HRESULT __stdcall  AwtDragSource::EnumDAdvise(IEnumSTATDATA __RPC_FAR *__RPC_FAR *ppenumAdvise) {
    return OLE_E_ADVISENOTSUPPORTED;
}

/**
 * Constructor
 */

AwtDragSource::ADSIEnumFormatEtc::ADSIEnumFormatEtc(AwtDragSource* parent) {
    m_parent = parent;
    m_idx    = 0;

    m_parent->AddRef();

    AddRef();
}

/**
 * Destructor
 */

AwtDragSource::ADSIEnumFormatEtc::~ADSIEnumFormatEtc() {
    m_parent->Release();
}

/**
 * QueryInterface
 */

HRESULT __stdcall  AwtDragSource::ADSIEnumFormatEtc::QueryInterface(REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject) {
    if (riid == IID_IUnknown) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IUnknown*)this;
	AddRef();
	return S_OK;
    } else if (riid == IID_IEnumFORMATETC) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IUnknown*)this;
	AddRef();
	return S_OK;
    } else {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)NULL;
	return E_NOINTERFACE;
    }
}

/**
 * AddRef
 */

ULONG __stdcall  AwtDragSource::ADSIEnumFormatEtc::AddRef(void) {
    return (ULONG)++m_refs;
}

/**
 * Release
 */

ULONG __stdcall  AwtDragSource::ADSIEnumFormatEtc::Release(void) {
    int refs;

    if ((refs = --m_refs) == 0) delete this;

    return (ULONG)refs;
}

/**
 * Next
 */

HRESULT _stdcall AwtDragSource::ADSIEnumFormatEtc::Next(ULONG celt, FORMATETC __RPC_FAR *rgelt, ULONG __RPC_FAR *pceltFetched) {
    unsigned int len = m_parent->getNTypes();
    unsigned int i;

    for (i = 0; i < celt && m_idx < len; i++, m_idx++) {
	FORMATETC fetc = m_parent->getType(m_idx);
	rgelt[i] = fetc;
    }

    if (pceltFetched != NULL) *pceltFetched = i;

    return i == celt ? S_OK : S_FALSE;
}

/**
 * Skip
 */

HRESULT __stdcall  AwtDragSource::ADSIEnumFormatEtc::Skip(ULONG celt) {
    unsigned int len = m_parent->getNTypes();
    unsigned int tmp = m_idx + celt;

    if (tmp < len) {
	m_idx = tmp;

        return S_OK;
    } else {
	m_idx = len;

        return S_FALSE;
    }
}

/**
 * Reset
 */

HRESULT __stdcall  AwtDragSource::ADSIEnumFormatEtc::Reset(void) {
    m_idx = 0;

    return S_OK;
}

/**
 * Clone
 */

HRESULT __stdcall  AwtDragSource::ADSIEnumFormatEtc::Clone(IEnumFORMATETC  __RPC_FAR *__RPC_FAR *ppenum) {
    *ppenum = new ADSIEnumFormatEtc(m_parent);

    (*ppenum)->Skip(m_idx);

    return S_OK;
}

/**
 * constructor
 */

AwtDragSource::ADSIStreamProxy::ADSIStreamProxy(AwtDragSource* parent, jbyteArray buffer, jint blen) {
    JNIEnv* env = (JNIEnv *)JNU_GetEnv(jvm, JNI_VERSION_1_2);

    m_parent = parent;

    m_buffer = (signed char *)calloc(sizeof(signed char), m_blen = blen);

    if (m_buffer == (signed char *)NULL) {
	JNU_ThrowOutOfMemoryError(env, "OutOfMemoryError");
	return;
    }

    env->GetByteArrayRegion(buffer, 0, blen, m_buffer);

    if (!JNU_IsNull(env, env->ExceptionOccurred())) return;

    m_off     = 0;

    m_cloneof = (ADSIStreamProxy*)NULL;
    
    m_refs    = 0;

    FILETIME now;

    ::CoFileTimeNow(&now);

    m_statstg.pwcsName		= (LPWSTR)NULL;
    m_statstg.type		= STGTY_STREAM;
    m_statstg.cbSize.HighPart 	= 0;
    m_statstg.cbSize.LowPart  	= m_blen;
    m_statstg.mtime		= now;
    m_statstg.ctime 		= now;
    m_statstg.atime 		= now;
    m_statstg.grfMode 		= STGM_READ;
    m_statstg.grfLocksSupported = FALSE;
    m_statstg.clsid 	 	= CLSID_NULL;
    m_statstg.grfStateBits 	= 0;
    m_statstg.reserved 	 	= 0;

    m_parent->AddRef();

    AddRef();
}

/**
 * constructor (clone)
 */

AwtDragSource::ADSIStreamProxy::ADSIStreamProxy(ADSIStreamProxy* cloneof) {
    m_cloneof = cloneof;

    m_parent  = cloneof->m_parent;

    m_buffer  = cloneof->m_buffer;
    m_blen    = cloneof->m_blen;
    m_off     = cloneof->m_off;

    m_statstg = cloneof->m_statstg;

    m_refs    = 0;

    m_parent->AddRef();
    m_cloneof->AddRef();
}

/**
 * destructor
 */

AwtDragSource::ADSIStreamProxy::~ADSIStreamProxy() {
    if (m_cloneof == (ADSIStreamProxy*)NULL)
	free((void *)m_buffer);
    else
	m_cloneof->Release();

    m_parent->Release();
}

/**
 * QueryInterface
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::QueryInterface(REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject) {
    if (riid == IID_IUnknown) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IUnknown*)this;
	AddRef();
	return S_OK;
    } else if (riid == IID_IStream) {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)(IUnknown*)this;
	AddRef();
	return S_OK;
    } else {
	*ppvObject = (void __RPC_FAR *__RPC_FAR)NULL;
	return E_NOINTERFACE;
    }
}

/**
 * AddRef
 */

ULONG __stdcall  AwtDragSource::ADSIStreamProxy::AddRef(void) {
    return (ULONG)++m_refs;
}

/**
 * Release
 */

ULONG __stdcall  AwtDragSource::ADSIStreamProxy::Release(void) {
    int refs;

    if ((refs = --m_refs) == 0) delete this;

    return (ULONG)refs;
}

/**
 * Read
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Read(void __RPC_FAR *pv, ULONG cb, ULONG __RPC_FAR *pcbRead) {
    unsigned int rem  = m_blen - m_off;
    int          read = cb > rem ? rem : cb;
    
    if (read > 0) memmove(pv, (void *)(m_buffer + m_off), read);

    m_off += read;

    if (pcbRead != (ULONG __RPC_FAR *)NULL) {
	*pcbRead = read;
    }

    FILETIME now; ::CoFileTimeNow(&now); m_statstg.atime = now;

    return S_OK;
}

/**
 * Write
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Write(const void __RPC_FAR *pv, ULONG cb, ULONG __RPC_FAR *pcbWritten) {
    if (pcbWritten != (ULONG __RPC_FAR *)NULL) {
	*pcbWritten = 0;
    }

    FILETIME now; ::CoFileTimeNow(&now); m_statstg.atime = now;

    return STG_E_CANTSAVE; // dont support writing
}

/**
 * Seek
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Seek(LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER __RPC_FAR *plibNewPosition) {
    if (dlibMove.HighPart != 0) return STG_E_INVALIDPOINTER;

    if (plibNewPosition != (ULARGE_INTEGER __RPC_FAR *)NULL) {
	plibNewPosition->HighPart = 0;
	plibNewPosition->LowPart  = 0;
    }

    switch (dwOrigin) {
	case STREAM_SEEK_SET: {
	    if (dlibMove.HighPart != 0 || dlibMove.LowPart >= m_blen) return STG_E_INVALIDPOINTER;

	    m_off = dlibMove.LowPart;
	}
	break;

	case STREAM_SEEK_CUR:
	case STREAM_SEEK_END: {
	    if (dlibMove.HighPart > 0) return STG_E_INVALIDPOINTER;

	    long newoff = (dwOrigin == STREAM_SEEK_END ? m_blen : m_off) + dlibMove.LowPart;

	    if (newoff < 0 || newoff >= (long)m_blen)
		return STG_E_INVALIDPOINTER;
	    else
		m_off = newoff;
	}
	break;

	default: return STG_E_INVALIDFUNCTION;
    }

    if (plibNewPosition != (ULARGE_INTEGER __RPC_FAR *)NULL)
	plibNewPosition->LowPart = m_off;

    FILETIME now; ::CoFileTimeNow(&now); m_statstg.atime = now;

    return S_OK;
}

/**
 * SetSize
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::SetSize(ULARGE_INTEGER libNewSize) {
    return STG_E_INVALIDFUNCTION;
}

/**
 * CopyTo
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::CopyTo(IStream __RPC_FAR *pstm, ULARGE_INTEGER cb, ULARGE_INTEGER __RPC_FAR *pcbRead, ULARGE_INTEGER __RPC_FAR *pcbWritten) {
    ULONG written = 0;

    pcbWritten->HighPart = (ULONG)0;
    pcbWritten->LowPart  = (ULONG)0;

    pcbRead->HighPart     = (ULONG)0;

    unsigned int rem     = m_blen - m_off;
    int          ovrflow = cb.LowPart >= rem;


    if (cb.HighPart != 0) return STG_E_INVALIDPOINTER;

    ULONG nbytes = pcbRead->LowPart = (ULONG)(ovrflow ? rem : cb.LowPart);

    HRESULT res = pstm->Write((const void *)(m_buffer + m_off), nbytes, &written);

    pcbWritten->LowPart = written;

    FILETIME now; ::CoFileTimeNow(&now); m_statstg.atime = now;

    return res;
}

/**
 * Commit
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Commit(DWORD grfCommitFlags) {
    return S_OK;
}

/**
 * Revert
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Revert() {
    return S_OK;
}

/**
 * LockRegion
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::LockRegion(ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType) {
    return STG_E_INVALIDFUNCTION;
}

/**
 * UnlockRegion
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::UnlockRegion(ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType) {
    return STG_E_INVALIDFUNCTION;
}

/**
 * Stat
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Stat(STATSTG __RPC_FAR *pstatstg, DWORD grfStatFlag) {
    *pstatstg = m_statstg;

    FILETIME now; ::CoFileTimeNow(&now); m_statstg.atime = now;

    return S_OK;
}

/**
 * Clone
 */

HRESULT __stdcall  AwtDragSource::ADSIStreamProxy::Clone(IStream __RPC_FAR *__RPC_FAR *ppstm) {
    *ppstm = new ADSIStreamProxy(this);
    return S_OK;
}

/*****************************************************************************/

extern "C" {

/**
 * Initialize
 */

JNIEXPORT void JNICALL Java_sun_awt_windows_WDragSourceContextPeer_Initialize(JNIEnv* env, jclass cls) {
    AwtDragSource::InitAwtDragSource();
}

/**
 * createDragSource
 */

JNIEXPORT jint JNICALL Java_sun_awt_windows_WDragSourceContextPeer_createDragSource(JNIEnv* env, jobject self, jobject trigger, jint actions, jobjectArray types) {
    AwtDragSource* ds = new AwtDragSource(env, self, trigger, actions, types);

    if (ds == (AwtDragSource*)NULL)
	JNU_ThrowOutOfMemoryError(env, "OutOfMemoryError");

    ::CoLockObjectExternal((IDropSource*)ds, TRUE, FALSE);

    return (jint)ds;
}

/**
 * doDragDrop
 */

JNIEXPORT void JNICALL Java_sun_awt_windows_WDragSourceContextPeer_doDragDrop(JNIEnv* env, jobject self, jint nativeCtxt, jobject cursor) {
   AwtDragSource::StartDrag((AwtDragSource*)nativeCtxt, cursor);
}

/**
 * setNativeCursor
 */

JNIEXPORT void JNICALL Java_sun_awt_windows_WDragSourceContextPeer_setNativeCursor(JNIEnv* env, jobject self, jint nativeCtxt, jobject cursor) {
	((AwtDragSource*)nativeCtxt)->SetCursor(cursor);
}

/**
 * Release
 */

JNIEXPORT void JNICALL Java_sun_awt_windows_WDragSourceContextPeer_release(JNIEnv* env, jobject self, jint nativeCtxt) { 
    AwtDragSource* dragSource = (AwtDragSource*)nativeCtxt;
    
    ::CoLockObjectExternal((IDropSource*)dragSource, FALSE, FALSE);

    dragSource->Release();
}

} /* extern "C" */
