/*
 * @(#)awt_Pen.cpp	1.3 98/03/18
 *
 * Copyright 1996 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "awt_Pen.h"

Hashtable AwtPen::cache("Pen cache", DeleteAwtPen);

AwtPen::AwtPen(COLORREF color) {
    SetColor(color);
    HPEN pen = ::CreatePen(PS_SOLID, 1, color);
    ASSERT(pen != NULL);
    SetHandle(pen);
}

AwtPen* AwtPen::Get(COLORREF color) {
    AwtPen* obj = (AwtPen*)cache.get((void*)color);
    if (obj == NULL) {
        obj = new AwtPen(color);
        obj->IncrRefCount();
        VERIFY(cache.put((void*)color, obj) == NULL);
    }
    return obj;
}

void AwtPen::RemoveFromCache() {
    VERIFY(cache.remove((void*)GetColor()) != NULL); 
}

void AwtPen::DeleteAwtPen(void* pPen) {
    delete (AwtPen*)pPen;
}
