/*
 * @(#)awt_Pen.h	1.6 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_PEN_H
#define AWT_PEN_H

#include "awt_GDIObject.h"
#include "Hashtable.h"

/*
 * An AwtPen is a cached Windows pen.
 */
class AwtPen : public AwtGDIObject {
public:
    /*
     * Get a GDI object from its respective cache.  If it doesn't exist
     * it gets created, otherwise its reference count gets bumped.
     */
    static AwtPen* Get(COLORREF color);

    // Delete an AwtPen, called by Hashtable.clear().
    static void DeleteAwtPen(void* pPen);

protected:
    virtual void RemoveFromCache();

private:
    AwtPen(COLORREF color);
    ~AwtPen() {}

    static Hashtable cache;
};

#endif // AWT_PEN_H
