/*
 * @(#)awt_PopupMenu.h	1.8 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_POPUPMENU_H
#define AWT_POPUPMENU_H

#include "awt_Menu.h"

#include <java_awt_MenuItem.h>
#include <sun_awt_windows_WMenuItemPeer.h>
#include <java_awt_PopupMenu.h>
#include <sun_awt_windows_WPopupMenuPeer.h>


/************************************************************************
 * AwtPopupMenu class
 */

class AwtPopupMenu : public AwtMenu {
public:
    AwtPopupMenu();
    virtual ~AwtPopupMenu();
    virtual const char* GetClassName();

    /* Create a new AwtPopupMenu.  This must be run on the main thread. */
    static AwtPopupMenu* Create(jobject self, AwtComponent* parent);

    /* Display the popup modally. */
    void Show(JNIEnv *env, jobject event);

    virtual AwtMenuBar* GetMenuBar() { return NULL; }
    INLINE AwtMenu* GetParent() { return NULL; }
    INLINE void SetParentMenu(AwtMenu* parent) { ASSERT(FALSE); }
    INLINE void SetParent(AwtComponent* parent) { m_parent = parent; }
    virtual HWND GetOwnerHWnd() { 
        return (m_parent == NULL) ? NULL : m_parent->GetHWnd(); 
    }

protected:
    AwtComponent* m_parent;
};

#endif /* AWT_POPUPMENU_H */
