/*
 * @(#)awt_Unicode.cpp	1.4 98/03/18
 *
 * Copyright 1996, 1997 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "awt.h"
#include "awt_Unicode.h"

LPWSTR J2WHelper1(LPWSTR lpw, LPWSTR lpj, int offset, int nChars) {
    memcpy(lpw, lpj + offset, nChars*2);
    lpw[nChars] = '\0';
    return lpw;
}

LPWSTR JNI_J2WHelper1(JNIEnv *env, LPWSTR lpwstr, jstring jstr) {

    int len = env->GetStringLength(jstr);

    env->GetStringRegion(jstr, 0, len, lpwstr);
    lpwstr[len] = '\0';

    return lpwstr;
}

LPWSTR J2WHelper(LPWSTR lpw, LPWSTR lpj,  int nChars) {
    return J2WHelper1(lpw, lpj, 0, nChars);
}

// Translate an ANSI string into a Unicode one.
LPWSTR A2WHelper(LPWSTR lpw, LPCSTR lpa, int nChars) {
    lpw[0] = '\0';
    VERIFY(::MultiByteToWideChar(CP_ACP, 0, lpa, -1, lpw, nChars));
    return lpw;
}

// Translate a Unicode string into an ANSI one.
LPSTR W2AHelper(LPSTR lpa, LPCWSTR lpw, int nChars) {
    lpa[0] = '\0';
    VERIFY(::WideCharToMultiByte(CP_ACP, 0, lpw, -1, lpa, nChars, NULL, NULL));
    return lpa;
}
