/*
 * @(#)awt_Unicode.h	1.8 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Unicode to ANSI string conversion macros, based on a slide from a
 * presentation by Asmus Freytag.  These must be macros, since the 
 * alloca() has to be in the caller's stack space.
 */

#ifndef AWT_UNICODE_H
#define AWT_UNICODE_H

#include <malloc.h>

// Get a Unicode string copy of a Java String object (Java String aren't
// null-terminated).
extern LPWSTR J2WHelper(LPWSTR lpw, LPWSTR lpj, int nChars);
extern LPWSTR J2WHelper1(LPWSTR lpw, LPWSTR lpj, int offset, int nChars);

extern LPWSTR JNI_J2WHelper1(JNIEnv *env, LPWSTR lpw, jstring jstr);

#define TO_WSTRING(jstr) \
   ((jstr == NULL) ? NULL : \
     (JNI_J2WHelper1(env, (LPWSTR) alloca((env->GetStringLength(jstr)+1)*2), \
		     jstr) \
    ))

// Translate an ANSI string into a Unicode one.
extern LPWSTR A2WHelper(LPWSTR lpw, LPCSTR lpa, int nChars);
#define A2W(lpa) \
    ((NULL == lpa) ? NULL : \
     (A2WHelper((LPWSTR) alloca((strlen(lpa)+1)*2), lpa, strlen(lpa)+1)))

// Translate a Unicode string into an ANSI one.
extern LPSTR W2AHelper(LPSTR lpa, LPCWSTR lpw, int nChars);
#define W2A(lpw) \
    ((NULL == (LPCWSTR)lpw) ? NULL : \
     (W2AHelper((LPSTR) alloca((wcslen(lpw)+1)*2), lpw, (wcslen(lpw)+1)*2)))

#endif // AWT_UNICODE_H
