/*
 * @(#)Win32DrawSurfaceTest.java	1.5 98/09/21
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.awt.Frame;
import sun.awt.DrawingSurfaceInfo;
import sun.awt.Win32DrawingSurface;

public class Win32DrawSurfaceTest extends DrawSurfaceTest {
    public static void main(String argv[]) {
	Frame f = new Frame();

	Win32DrawSurfaceTest dst = new Win32DrawSurfaceTest();
	f.add(dst);

	f.pack();
	f.show();

	dst.start();
    }

    public DrawSurfaceTracker getTracker(DrawingSurfaceInfo dsi) {
	return new Win32DrawSurfaceTracker(dsi);
    }
}

class Win32DrawSurfaceTracker extends DrawSurfaceTracker {
    static {
	try {
	    System.loadLibrary("dst");
	} catch (Throwable t) {
	    t.printStackTrace();
	}
    }

    public Win32DrawSurfaceTracker(DrawingSurfaceInfo dsi) {
	super(dsi);
    }

    private native void draw(int hWnd, int hBitmap, int hDC,
			     float ctrlpts[],
			     float red, float green, float blue);

    public void drawBezier(DrawingSurfaceInfo dsi, int state,
			   float ctrlpts[],
			   float red, float green, float blue) {
	Win32DrawingSurface winds = (Win32DrawingSurface) dsi.getSurface();
	if (winds.getHWnd() == 0) {
	    if (winds.getHBitmap() == 0) {
		System.out.println("null hWnd and hBitmap!");
	    }
	}
	draw(winds.getHWnd(), winds.getHBitmap(), winds.getHDC(),
	     ctrlpts, red, green, blue);
    }
}
