/*
 * @(#)mlib_v_ImageFilters.c	1.4 98/08/21
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#pragma ident  "@(#)mlib_v_ImageFilters.c	1.6  98/04/24 SMI"

/*  Table mlib_filters_u8_bl
 *
 *  DESCRIPTION
 *
 *    mlib_filters_u8_bl[i].s[0] = mlib_filters_u8_bl[i + 256].s[0] = (511 - 2*i) << SHIFT;
 *    mlib_filters_u8_bl[i].s[2] = mlib_filters_u8_bl[i + 256].s[1] = (511 - 2*i) << SHIFT;
 *    mlib_filters_u8_bl[i].s[1] = mlib_filters_u8_bl[i + 256].s[2] = (2*i + 1) << SHIFT;
 *    mlib_filters_u8_bl[i].s[3] = mlib_filters_u8_bl[i + 256].s[3] = (2*i + 1) << SHIFT;
 *
 *  Where
 *    SHIFT = 5;
 *    i = 0, 1, ..., 255;
 *
 *  Table mlib_filters_u8_bc
 *
 *  DESCRIPTION
 *
 *    mlib_filters_u8_bc[i].s[0] = (mlib_s16) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC - 0.5);
 *    mlib_filters_u8_bc[i].s[1] = (mlib_s16) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC + 0.5);
 *    mlib_filters_u8_bc[i].s[2] = (mlib_s16) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC + 0.5);
 *    mlib_filters_u8_bc[i].s[3] = (mlib_s16) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC - 0.5);
 *
 *  Where
 *    PREC = ((double) (1 << 14));
 *    dx = (double)i/256 + 1./512.; i = 0, 1, ..., 255;
 *
 *  Table mlib_filters_u8_bc_3
 *
 *  DESCRIPTION
 *
 *    mlib_filters_u8_bc_3[3*i].s[0]   = mlib_filters_u8_bc_3[3*i].s[1] =
 *    mlib_filters_u8_bc_3[3*i].s[2]   = (mlib_s16) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC - 0.5);
 *    mlib_filters_u8_bc_3[3*i].s[3]   = mlib_filters_u8_bc_3[3*i+1].s[0] =
 *    mlib_filters_u8_bc_3[3*i+1].s[1] = (mlib_s16) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC + 0.5);
 *    mlib_filters_u8_bc_3[3*i+1].s[2] = mlib_filters_u8_bc_3[3*i+1].s[3] =
 *    mlib_filters_u8_bc_3[3*i+2].s[0] = (mlib_s16) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC + 0.5);
 *    mlib_filters_u8_bc_3[3*i+2].s[1] = mlib_filters_u8_bc_3[3*i+2].s[2] =
 *    mlib_filters_u8_bc_3[3*i+2].s[3] = (mlib_s16) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC - 0.5);
 *
 *  Where
 *    PREC = ((double) (1 << 14));
 *    dx = (double)i/256 + 1./512.; i = 0, 1, ..., 255;
 *
 *  Table mlib_filters_u8_bc_4
 *
 *  DESCRIPTION
 *
 *    mlib_filters_u8_bc_4[4*i].s[0]   = mlib_filters_u8_bc_4[4*i].s[1] =
 *    mlib_filters_u8_bc_4[4*i].s[2]   = mlib_filters_u8_bc_4[4*i].s[3] =
 *                                    (mlib_s16) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC - 0.5);
 *    mlib_filters_u8_bc_4[4*i+1].s[0] = mlib_filters_u8_bc_4[4*i+1].s[1] =
 *    mlib_filters_u8_bc_4[4*i+1].s[2] = mlib_filters_u8_bc_4[4*i+1].s[3] =
 *                                    (mlib_s16) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC + 0.5);
 *    mlib_filters_u8_bc_4[4*i+2].s[0] = mlib_filters_u8_bc_4[4*i+2].s[1] =
 *    mlib_filters_u8_bc_4[4*i+2].s[2] = mlib_filters_u8_bc_4[4*i+2].s[3] =
 *                                    (mlib_s16) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC + 0.5);
 *    mlib_filters_u8_bc_4[4*i+3].s[0] = mlib_filters_u8_bc_4[4*i+3].s[0] =
 *    mlib_filters_u8_bc_4[4*i+3].s[0] = mlib_filters_u8_bc_4[4*i+3].s[0] =
 *                                    (mlib_s16) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC - 0.5);
 *
 *  Where
 *    PREC = ((double) (1 << 14));
 *    dx = (double)i/256 + 1./512.; i = 0, 1, ..., 255;
 *
 *  Table mlib_filters_s16_bc
 *
 *  DESCRIPTION
 *
 *    mlib_filters_s16_bc[i].s[0] = (mlib_s16) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC - 0.5);
 *    mlib_filters_s16_bc[i].s[1] = (mlib_s16) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC + 0.5);
 *    mlib_filters_s16_bc[i].s[2] = (mlib_s16) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC + 0.5);
 *    mlib_filters_s16_bc[i].s[3] = (mlib_s16) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC - 0.5);
 *
 *  Where
 *    PREC = ((double) (1 << 15));
 *    dx = (double)i/512 + 1./1024.; i = 0, 1, ..., 511;
 *    All 32768 are replace to 32767
 *
 *  Table mlib_filters_s16_bc_3
 *
 *  DESCRIPTION
 *
 *    mlib_filters_s16_bc_3[3*i].s[0]   = mlib_filters_s16_bc_3[3*i].s[1] =
 *    mlib_filters_s16_bc_3[3*i].s[2]   = (mlib_s16) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC - 0.5);
 *    mlib_filters_s16_bc_3[3*i].s[3]   = mlib_filters_s16_bc_3[3*i+1].s[0] =
 *    mlib_filters_s16_bc_3[3*i+1].s[1] = (mlib_s16) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC + 0.5);
 *    mlib_filters_s16_bc_3[3*i+1].s[2] = mlib_filters_s16_bc_3[3*i+1].s[3] =
 *    mlib_filters_s16_bc_3[3*i+2].s[0] = (mlib_s16) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC + 0.5);
 *    mlib_filters_s16_bc_3[3*i+2].s[1] = mlib_filters_s16_bc_3[3*i+2].s[2] =
 *    mlib_filters_s16_bc_3[3*i+2].s[3] = (mlib_s16) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC - 0.5);
 *
 *  Where
 *    PREC = ((double) (1 << 15));
 *    dx = (double)i/512 + 1./1024.; i = 0, 1, ..., 511;
 *    All 32768 are replace to 32767
 *
 *  Table mlib_filters_s16_bc_4
 *
 *  DESCRIPTION
 *
 *    mlib_filters_s16_bc_4[4*i].s[0]   = mlib_filters_s16_bc_4[4*i].s[1] =
 *    mlib_filters_s16_bc_4[4*i].s[2]   = mlib_filters_s16_bc_4[4*i].s[3] =
 *                                    (mlib_s16) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC - 0.5);
 *    mlib_filters_s16_bc_4[4*i+1].s[0] = mlib_filters_s16_bc_4[4*i+1].s[1] =
 *    mlib_filters_s16_bc_4[4*i+1].s[2] = mlib_filters_s16_bc_4[4*i+1].s[3] =
 *                                    (mlib_s16) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC + 0.5);
 *    mlib_filters_s16_bc_4[4*i+2].s[0] = mlib_filters_s16_bc_4[4*i+2].s[1] =
 *    mlib_filters_s16_bc_4[4*i+2].s[2] = mlib_filters_s16_bc_4[4*i+2].s[3] =
 *                                    (mlib_s16) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC + 0.5);
 *    mlib_filters_s16_bc_4[4*i+3].s[0] = mlib_filters_s16_bc_4[4*i+3].s[0] =
 *    mlib_filters_s16_bc_4[4*i+3].s[0] = mlib_filters_s16_bc_4[4*i+3].s[0] =
 *                                    (mlib_s16) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC - 0.5);
 *
 *  Where
 *    PREC = ((double) (1 << 15));
 *    dx = (double)i/512 + 1./1024.; i = 0, 1, ..., 511;
 *    All 32768 are replace to 32767
 *
 *  Table mlib_filters_u8f_bc
 *
 *  DESCRIPTION
 *
 *    mlib_filters_u8f_bc[4*i+0] = (mlib_f32) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC);
 *    mlib_filters_u8f_bc[4*i+1] = (mlib_f32) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC);
 *    mlib_filters_u8f_bc[4*i+2] = (mlib_f32) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC);
 *    mlib_filters_u8f_bc[4*i+3] = (mlib_f32) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC);
 *
 *  Where
 *    PREC = ((double)(1 << 12))
 *    dx = (double)i/256 + 1./512.; i = 0, 1, ..., 255;
 *
 *  Table mlib_filters_s16f_bc
 *
 *  DESCRIPTION
 *
 *    mlib_filters_s16f_bc[4*i+0] = (mlib_f32) ((-0.5*dx*dx*dx + dx*dx - 0.5*dx)*PREC);
 *    mlib_filters_s16f_bc[4*i+1] = (mlib_f32) (( 1.5*dx*dx*dx - 2.5*dx*dx + 1.0)*PREC);
 *    mlib_filters_s16f_bc[4*i+2] = (mlib_f32) ((-1.5*dx*dx*dx + 2.0*dx*dx + 0.5*dx)*PREC);
 *    mlib_filters_s16f_bc[4*i+3] = (mlib_f32) (( 0.5*dx*dx*dx - 0.5*dx*dx)*PREC);
 *
 *  Where
 *    PREC = ((double)(1 << 8))
 *    dx = (double)i/512 + 1./1024.; i = 0, 1, ..., 511;
 *
 *  COMMENTS
 *
 *    These tables are used by VIS versions of the
 *    mlib_ImageRotate and mlib_ImageAffine functions.
 *
 */

#include "mlib_image.h"
#include "mlib_v_ImageFilters.h"

const union table mlib_filters_u8_bl[] = {
 16352,     32,  16352,     32,
 16288,     96,  16288,     96,
 16224,    160,  16224,    160,
 16160,    224,  16160,    224,
 16096,    288,  16096,    288,
 16032,    352,  16032,    352,
 15968,    416,  15968,    416,
 15904,    480,  15904,    480,
 15840,    544,  15840,    544,
 15776,    608,  15776,    608,
 15712,    672,  15712,    672,
 15648,    736,  15648,    736,
 15584,    800,  15584,    800,
 15520,    864,  15520,    864,
 15456,    928,  15456,    928,
 15392,    992,  15392,    992,
 15328,   1056,  15328,   1056,
 15264,   1120,  15264,   1120,
 15200,   1184,  15200,   1184,
 15136,   1248,  15136,   1248,
 15072,   1312,  15072,   1312,
 15008,   1376,  15008,   1376,
 14944,   1440,  14944,   1440,
 14880,   1504,  14880,   1504,
 14816,   1568,  14816,   1568,
 14752,   1632,  14752,   1632,
 14688,   1696,  14688,   1696,
 14624,   1760,  14624,   1760,
 14560,   1824,  14560,   1824,
 14496,   1888,  14496,   1888,
 14432,   1952,  14432,   1952,
 14368,   2016,  14368,   2016,
 14304,   2080,  14304,   2080,
 14240,   2144,  14240,   2144,
 14176,   2208,  14176,   2208,
 14112,   2272,  14112,   2272,
 14048,   2336,  14048,   2336,
 13984,   2400,  13984,   2400,
 13920,   2464,  13920,   2464,
 13856,   2528,  13856,   2528,
 13792,   2592,  13792,   2592,
 13728,   2656,  13728,   2656,
 13664,   2720,  13664,   2720,
 13600,   2784,  13600,   2784,
 13536,   2848,  13536,   2848,
 13472,   2912,  13472,   2912,
 13408,   2976,  13408,   2976,
 13344,   3040,  13344,   3040,
 13280,   3104,  13280,   3104,
 13216,   3168,  13216,   3168,
 13152,   3232,  13152,   3232,
 13088,   3296,  13088,   3296,
 13024,   3360,  13024,   3360,
 12960,   3424,  12960,   3424,
 12896,   3488,  12896,   3488,
 12832,   3552,  12832,   3552,
 12768,   3616,  12768,   3616,
 12704,   3680,  12704,   3680,
 12640,   3744,  12640,   3744,
 12576,   3808,  12576,   3808,
 12512,   3872,  12512,   3872,
 12448,   3936,  12448,   3936,
 12384,   4000,  12384,   4000,
 12320,   4064,  12320,   4064,
 12256,   4128,  12256,   4128,
 12192,   4192,  12192,   4192,
 12128,   4256,  12128,   4256,
 12064,   4320,  12064,   4320,
 12000,   4384,  12000,   4384,
 11936,   4448,  11936,   4448,
 11872,   4512,  11872,   4512,
 11808,   4576,  11808,   4576,
 11744,   4640,  11744,   4640,
 11680,   4704,  11680,   4704,
 11616,   4768,  11616,   4768,
 11552,   4832,  11552,   4832,
 11488,   4896,  11488,   4896,
 11424,   4960,  11424,   4960,
 11360,   5024,  11360,   5024,
 11296,   5088,  11296,   5088,
 11232,   5152,  11232,   5152,
 11168,   5216,  11168,   5216,
 11104,   5280,  11104,   5280,
 11040,   5344,  11040,   5344,
 10976,   5408,  10976,   5408,
 10912,   5472,  10912,   5472,
 10848,   5536,  10848,   5536,
 10784,   5600,  10784,   5600,
 10720,   5664,  10720,   5664,
 10656,   5728,  10656,   5728,
 10592,   5792,  10592,   5792,
 10528,   5856,  10528,   5856,
 10464,   5920,  10464,   5920,
 10400,   5984,  10400,   5984,
 10336,   6048,  10336,   6048,
 10272,   6112,  10272,   6112,
 10208,   6176,  10208,   6176,
 10144,   6240,  10144,   6240,
 10080,   6304,  10080,   6304,
 10016,   6368,  10016,   6368,
  9952,   6432,   9952,   6432,
  9888,   6496,   9888,   6496,
  9824,   6560,   9824,   6560,
  9760,   6624,   9760,   6624,
  9696,   6688,   9696,   6688,
  9632,   6752,   9632,   6752,
  9568,   6816,   9568,   6816,
  9504,   6880,   9504,   6880,
  9440,   6944,   9440,   6944,
  9376,   7008,   9376,   7008,
  9312,   7072,   9312,   7072,
  9248,   7136,   9248,   7136,
  9184,   7200,   9184,   7200,
  9120,   7264,   9120,   7264,
  9056,   7328,   9056,   7328,
  8992,   7392,   8992,   7392,
  8928,   7456,   8928,   7456,
  8864,   7520,   8864,   7520,
  8800,   7584,   8800,   7584,
  8736,   7648,   8736,   7648,
  8672,   7712,   8672,   7712,
  8608,   7776,   8608,   7776,
  8544,   7840,   8544,   7840,
  8480,   7904,   8480,   7904,
  8416,   7968,   8416,   7968,
  8352,   8032,   8352,   8032,
  8288,   8096,   8288,   8096,
  8224,   8160,   8224,   8160,
  8160,   8224,   8160,   8224,
  8096,   8288,   8096,   8288,
  8032,   8352,   8032,   8352,
  7968,   8416,   7968,   8416,
  7904,   8480,   7904,   8480,
  7840,   8544,   7840,   8544,
  7776,   8608,   7776,   8608,
  7712,   8672,   7712,   8672,
  7648,   8736,   7648,   8736,
  7584,   8800,   7584,   8800,
  7520,   8864,   7520,   8864,
  7456,   8928,   7456,   8928,
  7392,   8992,   7392,   8992,
  7328,   9056,   7328,   9056,
  7264,   9120,   7264,   9120,
  7200,   9184,   7200,   9184,
  7136,   9248,   7136,   9248,
  7072,   9312,   7072,   9312,
  7008,   9376,   7008,   9376,
  6944,   9440,   6944,   9440,
  6880,   9504,   6880,   9504,
  6816,   9568,   6816,   9568,
  6752,   9632,   6752,   9632,
  6688,   9696,   6688,   9696,
  6624,   9760,   6624,   9760,
  6560,   9824,   6560,   9824,
  6496,   9888,   6496,   9888,
  6432,   9952,   6432,   9952,
  6368,  10016,   6368,  10016,
  6304,  10080,   6304,  10080,
  6240,  10144,   6240,  10144,
  6176,  10208,   6176,  10208,
  6112,  10272,   6112,  10272,
  6048,  10336,   6048,  10336,
  5984,  10400,   5984,  10400,
  5920,  10464,   5920,  10464,
  5856,  10528,   5856,  10528,
  5792,  10592,   5792,  10592,
  5728,  10656,   5728,  10656,
  5664,  10720,   5664,  10720,
  5600,  10784,   5600,  10784,
  5536,  10848,   5536,  10848,
  5472,  10912,   5472,  10912,
  5408,  10976,   5408,  10976,
  5344,  11040,   5344,  11040,
  5280,  11104,   5280,  11104,
  5216,  11168,   5216,  11168,
  5152,  11232,   5152,  11232,
  5088,  11296,   5088,  11296,
  5024,  11360,   5024,  11360,
  4960,  11424,   4960,  11424,
  4896,  11488,   4896,  11488,
  4832,  11552,   4832,  11552,
  4768,  11616,   4768,  11616,
  4704,  11680,   4704,  11680,
  4640,  11744,   4640,  11744,
  4576,  11808,   4576,  11808,
  4512,  11872,   4512,  11872,
  4448,  11936,   4448,  11936,
  4384,  12000,   4384,  12000,
  4320,  12064,   4320,  12064,
  4256,  12128,   4256,  12128,
  4192,  12192,   4192,  12192,
  4128,  12256,   4128,  12256,
  4064,  12320,   4064,  12320,
  4000,  12384,   4000,  12384,
  3936,  12448,   3936,  12448,
  3872,  12512,   3872,  12512,
  3808,  12576,   3808,  12576,
  3744,  12640,   3744,  12640,
  3680,  12704,   3680,  12704,
  3616,  12768,   3616,  12768,
  3552,  12832,   3552,  12832,
  3488,  12896,   3488,  12896,
  3424,  12960,   3424,  12960,
  3360,  13024,   3360,  13024,
  3296,  13088,   3296,  13088,
  3232,  13152,   3232,  13152,
  3168,  13216,   3168,  13216,
  3104,  13280,   3104,  13280,
  3040,  13344,   3040,  13344,
  2976,  13408,   2976,  13408,
  2912,  13472,   2912,  13472,
  2848,  13536,   2848,  13536,
  2784,  13600,   2784,  13600,
  2720,  13664,   2720,  13664,
  2656,  13728,   2656,  13728,
  2592,  13792,   2592,  13792,
  2528,  13856,   2528,  13856,
  2464,  13920,   2464,  13920,
  2400,  13984,   2400,  13984,
  2336,  14048,   2336,  14048,
  2272,  14112,   2272,  14112,
  2208,  14176,   2208,  14176,
  2144,  14240,   2144,  14240,
  2080,  14304,   2080,  14304,
  2016,  14368,   2016,  14368,
  1952,  14432,   1952,  14432,
  1888,  14496,   1888,  14496,
  1824,  14560,   1824,  14560,
  1760,  14624,   1760,  14624,
  1696,  14688,   1696,  14688,
  1632,  14752,   1632,  14752,
  1568,  14816,   1568,  14816,
  1504,  14880,   1504,  14880,
  1440,  14944,   1440,  14944,
  1376,  15008,   1376,  15008,
  1312,  15072,   1312,  15072,
  1248,  15136,   1248,  15136,
  1184,  15200,   1184,  15200,
  1120,  15264,   1120,  15264,
  1056,  15328,   1056,  15328,
   992,  15392,    992,  15392,
   928,  15456,    928,  15456,
   864,  15520,    864,  15520,
   800,  15584,    800,  15584,
   736,  15648,    736,  15648,
   672,  15712,    672,  15712,
   608,  15776,    608,  15776,
   544,  15840,    544,  15840,
   480,  15904,    480,  15904,
   416,  15968,    416,  15968,
   352,  16032,    352,  16032,
   288,  16096,    288,  16096,
   224,  16160,    224,  16160,
   160,  16224,    160,  16224,
    96,  16288,     96,  16288,
    32,  16352,     32,  16352,
 16352,  16352,     32,     32,
 16288,  16288,     96,     96,
 16224,  16224,    160,    160,
 16160,  16160,    224,    224,
 16096,  16096,    288,    288,
 16032,  16032,    352,    352,
 15968,  15968,    416,    416,
 15904,  15904,    480,    480,
 15840,  15840,    544,    544,
 15776,  15776,    608,    608,
 15712,  15712,    672,    672,
 15648,  15648,    736,    736,
 15584,  15584,    800,    800,
 15520,  15520,    864,    864,
 15456,  15456,    928,    928,
 15392,  15392,    992,    992,
 15328,  15328,   1056,   1056,
 15264,  15264,   1120,   1120,
 15200,  15200,   1184,   1184,
 15136,  15136,   1248,   1248,
 15072,  15072,   1312,   1312,
 15008,  15008,   1376,   1376,
 14944,  14944,   1440,   1440,
 14880,  14880,   1504,   1504,
 14816,  14816,   1568,   1568,
 14752,  14752,   1632,   1632,
 14688,  14688,   1696,   1696,
 14624,  14624,   1760,   1760,
 14560,  14560,   1824,   1824,
 14496,  14496,   1888,   1888,
 14432,  14432,   1952,   1952,
 14368,  14368,   2016,   2016,
 14304,  14304,   2080,   2080,
 14240,  14240,   2144,   2144,
 14176,  14176,   2208,   2208,
 14112,  14112,   2272,   2272,
 14048,  14048,   2336,   2336,
 13984,  13984,   2400,   2400,
 13920,  13920,   2464,   2464,
 13856,  13856,   2528,   2528,
 13792,  13792,   2592,   2592,
 13728,  13728,   2656,   2656,
 13664,  13664,   2720,   2720,
 13600,  13600,   2784,   2784,
 13536,  13536,   2848,   2848,
 13472,  13472,   2912,   2912,
 13408,  13408,   2976,   2976,
 13344,  13344,   3040,   3040,
 13280,  13280,   3104,   3104,
 13216,  13216,   3168,   3168,
 13152,  13152,   3232,   3232,
 13088,  13088,   3296,   3296,
 13024,  13024,   3360,   3360,
 12960,  12960,   3424,   3424,
 12896,  12896,   3488,   3488,
 12832,  12832,   3552,   3552,
 12768,  12768,   3616,   3616,
 12704,  12704,   3680,   3680,
 12640,  12640,   3744,   3744,
 12576,  12576,   3808,   3808,
 12512,  12512,   3872,   3872,
 12448,  12448,   3936,   3936,
 12384,  12384,   4000,   4000,
 12320,  12320,   4064,   4064,
 12256,  12256,   4128,   4128,
 12192,  12192,   4192,   4192,
 12128,  12128,   4256,   4256,
 12064,  12064,   4320,   4320,
 12000,  12000,   4384,   4384,
 11936,  11936,   4448,   4448,
 11872,  11872,   4512,   4512,
 11808,  11808,   4576,   4576,
 11744,  11744,   4640,   4640,
 11680,  11680,   4704,   4704,
 11616,  11616,   4768,   4768,
 11552,  11552,   4832,   4832,
 11488,  11488,   4896,   4896,
 11424,  11424,   4960,   4960,
 11360,  11360,   5024,   5024,
 11296,  11296,   5088,   5088,
 11232,  11232,   5152,   5152,
 11168,  11168,   5216,   5216,
 11104,  11104,   5280,   5280,
 11040,  11040,   5344,   5344,
 10976,  10976,   5408,   5408,
 10912,  10912,   5472,   5472,
 10848,  10848,   5536,   5536,
 10784,  10784,   5600,   5600,
 10720,  10720,   5664,   5664,
 10656,  10656,   5728,   5728,
 10592,  10592,   5792,   5792,
 10528,  10528,   5856,   5856,
 10464,  10464,   5920,   5920,
 10400,  10400,   5984,   5984,
 10336,  10336,   6048,   6048,
 10272,  10272,   6112,   6112,
 10208,  10208,   6176,   6176,
 10144,  10144,   6240,   6240,
 10080,  10080,   6304,   6304,
 10016,  10016,   6368,   6368,
  9952,   9952,   6432,   6432,
  9888,   9888,   6496,   6496,
  9824,   9824,   6560,   6560,
  9760,   9760,   6624,   6624,
  9696,   9696,   6688,   6688,
  9632,   9632,   6752,   6752,
  9568,   9568,   6816,   6816,
  9504,   9504,   6880,   6880,
  9440,   9440,   6944,   6944,
  9376,   9376,   7008,   7008,
  9312,   9312,   7072,   7072,
  9248,   9248,   7136,   7136,
  9184,   9184,   7200,   7200,
  9120,   9120,   7264,   7264,
  9056,   9056,   7328,   7328,
  8992,   8992,   7392,   7392,
  8928,   8928,   7456,   7456,
  8864,   8864,   7520,   7520,
  8800,   8800,   7584,   7584,
  8736,   8736,   7648,   7648,
  8672,   8672,   7712,   7712,
  8608,   8608,   7776,   7776,
  8544,   8544,   7840,   7840,
  8480,   8480,   7904,   7904,
  8416,   8416,   7968,   7968,
  8352,   8352,   8032,   8032,
  8288,   8288,   8096,   8096,
  8224,   8224,   8160,   8160,
  8160,   8160,   8224,   8224,
  8096,   8096,   8288,   8288,
  8032,   8032,   8352,   8352,
  7968,   7968,   8416,   8416,
  7904,   7904,   8480,   8480,
  7840,   7840,   8544,   8544,
  7776,   7776,   8608,   8608,
  7712,   7712,   8672,   8672,
  7648,   7648,   8736,   8736,
  7584,   7584,   8800,   8800,
  7520,   7520,   8864,   8864,
  7456,   7456,   8928,   8928,
  7392,   7392,   8992,   8992,
  7328,   7328,   9056,   9056,
  7264,   7264,   9120,   9120,
  7200,   7200,   9184,   9184,
  7136,   7136,   9248,   9248,
  7072,   7072,   9312,   9312,
  7008,   7008,   9376,   9376,
  6944,   6944,   9440,   9440,
  6880,   6880,   9504,   9504,
  6816,   6816,   9568,   9568,
  6752,   6752,   9632,   9632,
  6688,   6688,   9696,   9696,
  6624,   6624,   9760,   9760,
  6560,   6560,   9824,   9824,
  6496,   6496,   9888,   9888,
  6432,   6432,   9952,   9952,
  6368,   6368,  10016,  10016,
  6304,   6304,  10080,  10080,
  6240,   6240,  10144,  10144,
  6176,   6176,  10208,  10208,
  6112,   6112,  10272,  10272,
  6048,   6048,  10336,  10336,
  5984,   5984,  10400,  10400,
  5920,   5920,  10464,  10464,
  5856,   5856,  10528,  10528,
  5792,   5792,  10592,  10592,
  5728,   5728,  10656,  10656,
  5664,   5664,  10720,  10720,
  5600,   5600,  10784,  10784,
  5536,   5536,  10848,  10848,
  5472,   5472,  10912,  10912,
  5408,   5408,  10976,  10976,
  5344,   5344,  11040,  11040,
  5280,   5280,  11104,  11104,
  5216,   5216,  11168,  11168,
  5152,   5152,  11232,  11232,
  5088,   5088,  11296,  11296,
  5024,   5024,  11360,  11360,
  4960,   4960,  11424,  11424,
  4896,   4896,  11488,  11488,
  4832,   4832,  11552,  11552,
  4768,   4768,  11616,  11616,
  4704,   4704,  11680,  11680,
  4640,   4640,  11744,  11744,
  4576,   4576,  11808,  11808,
  4512,   4512,  11872,  11872,
  4448,   4448,  11936,  11936,
  4384,   4384,  12000,  12000,
  4320,   4320,  12064,  12064,
  4256,   4256,  12128,  12128,
  4192,   4192,  12192,  12192,
  4128,   4128,  12256,  12256,
  4064,   4064,  12320,  12320,
  4000,   4000,  12384,  12384,
  3936,   3936,  12448,  12448,
  3872,   3872,  12512,  12512,
  3808,   3808,  12576,  12576,
  3744,   3744,  12640,  12640,
  3680,   3680,  12704,  12704,
  3616,   3616,  12768,  12768,
  3552,   3552,  12832,  12832,
  3488,   3488,  12896,  12896,
  3424,   3424,  12960,  12960,
  3360,   3360,  13024,  13024,
  3296,   3296,  13088,  13088,
  3232,   3232,  13152,  13152,
  3168,   3168,  13216,  13216,
  3104,   3104,  13280,  13280,
  3040,   3040,  13344,  13344,
  2976,   2976,  13408,  13408,
  2912,   2912,  13472,  13472,
  2848,   2848,  13536,  13536,
  2784,   2784,  13600,  13600,
  2720,   2720,  13664,  13664,
  2656,   2656,  13728,  13728,
  2592,   2592,  13792,  13792,
  2528,   2528,  13856,  13856,
  2464,   2464,  13920,  13920,
  2400,   2400,  13984,  13984,
  2336,   2336,  14048,  14048,
  2272,   2272,  14112,  14112,
  2208,   2208,  14176,  14176,
  2144,   2144,  14240,  14240,
  2080,   2080,  14304,  14304,
  2016,   2016,  14368,  14368,
  1952,   1952,  14432,  14432,
  1888,   1888,  14496,  14496,
  1824,   1824,  14560,  14560,
  1760,   1760,  14624,  14624,
  1696,   1696,  14688,  14688,
  1632,   1632,  14752,  14752,
  1568,   1568,  14816,  14816,
  1504,   1504,  14880,  14880,
  1440,   1440,  14944,  14944,
  1376,   1376,  15008,  15008,
  1312,   1312,  15072,  15072,
  1248,   1248,  15136,  15136,
  1184,   1184,  15200,  15200,
  1120,   1120,  15264,  15264,
  1056,   1056,  15328,  15328,
   992,    992,  15392,  15392,
   928,    928,  15456,  15456,
   864,    864,  15520,  15520,
   800,    800,  15584,  15584,
   736,    736,  15648,  15648,
   672,    672,  15712,  15712,
   608,    608,  15776,  15776,
   544,    544,  15840,  15840,
   480,    480,  15904,  15904,
   416,    416,  15968,  15968,
   352,    352,  16032,  16032,
   288,    288,  16096,  16096,
   224,    224,  16160,  16160,
   160,    160,  16224,  16224,
    96,     96,  16288,  16288,
    32,     32,  16352,  16352,
};

const union table mlib_filters_u8_bc[] = {
   -16,  16384,     16,      0,
   -47,  16383,     49,      0,
   -78,  16380,     83,     -1,
  -109,  16376,    118,     -2,
  -139,  16371,    154,     -2,
  -169,  16365,    191,     -4,
  -198,  16358,    229,     -5,
  -226,  16349,    268,     -7,
  -254,  16340,    307,     -9,
  -282,  16329,    348,    -11,
  -309,  16317,    389,    -13,
  -336,  16304,    432,    -16,
  -362,  16289,    475,    -19,
  -388,  16274,    520,    -22,
  -413,  16257,    565,    -25,
  -438,  16239,    611,    -28,
  -462,  16220,    658,    -32,
  -486,  16200,    705,    -36,
  -510,  16179,    754,    -40,
  -533,  16157,    803,    -44,
  -555,  16134,    854,    -48,
  -577,  16110,    905,    -53,
  -599,  16084,    956,    -58,
  -620,  16058,   1009,    -63,
  -641,  16030,   1063,    -68,
  -662,  16002,   1117,    -73,
  -682,  15972,   1172,    -79,
  -701,  15942,   1228,    -84,
  -720,  15910,   1284,    -90,
  -739,  15878,   1342,    -96,
  -757,  15844,   1400,   -102,
  -775,  15810,   1458,   -109,
  -793,  15774,   1518,   -115,
  -810,  15738,   1578,   -122,
  -826,  15700,   1639,   -129,
  -843,  15662,   1701,   -136,
  -859,  15623,   1763,   -143,
  -874,  15582,   1826,   -150,
  -889,  15541,   1890,   -157,
  -904,  15499,   1954,   -165,
  -918,  15456,   2019,   -173,
  -932,  15412,   2084,   -180,
  -946,  15368,   2151,   -188,
  -959,  15322,   2218,   -196,
  -972,  15275,   2285,   -205,
  -984,  15228,   2353,   -213,
  -997,  15180,   2422,   -221,
 -1008,  15131,   2491,   -230,
 -1020,  15081,   2561,   -238,
 -1031,  15030,   2631,   -247,
 -1041,  14979,   2702,   -256,
 -1052,  14926,   2774,   -265,
 -1062,  14873,   2846,   -274,
 -1071,  14819,   2919,   -283,
 -1080,  14765,   2992,   -292,
 -1089,  14709,   3066,   -302,
 -1098,  14653,   3140,   -311,
 -1106,  14596,   3215,   -320,
 -1114,  14538,   3290,   -330,
 -1122,  14480,   3366,   -340,
 -1129,  14421,   3442,   -349,
 -1136,  14361,   3518,   -359,
 -1143,  14300,   3595,   -369,
 -1149,  14239,   3673,   -379,
 -1155,  14177,   3751,   -389,
 -1161,  14114,   3829,   -399,
 -1166,  14051,   3908,   -409,
 -1171,  13987,   3988,   -419,
 -1176,  13922,   4067,   -430,
 -1180,  13857,   4147,   -440,
 -1185,  13791,   4228,   -450,
 -1188,  13724,   4309,   -461,
 -1192,  13657,   4390,   -471,
 -1195,  13589,   4471,   -481,
 -1198,  13521,   4553,   -492,
 -1201,  13452,   4636,   -502,
 -1204,  13382,   4718,   -513,
 -1206,  13312,   4801,   -523,
 -1208,  13241,   4885,   -534,
 -1209,  13170,   4968,   -545,
 -1211,  13098,   5052,   -555,
 -1212,  13026,   5136,   -566,
 -1213,  12953,   5221,   -577,
 -1213,  12879,   5305,   -587,
 -1214,  12805,   5390,   -598,
 -1214,  12731,   5476,   -609,
 -1213,  12656,   5561,   -619,
 -1213,  12580,   5647,   -630,
 -1212,  12504,   5733,   -641,
 -1211,  12428,   5819,   -651,
 -1210,  12351,   5905,   -662,
 -1209,  12274,   5992,   -672,
 -1207,  12196,   6079,   -683,
 -1206,  12117,   6166,   -694,
 -1204,  12039,   6253,   -704,
 -1201,  11960,   6340,   -715,
 -1199,  11880,   6428,   -725,
 -1196,  11800,   6515,   -736,
 -1193,  11720,   6603,   -746,
 -1190,  11639,   6691,   -757,
 -1187,  11558,   6779,   -767,
 -1183,  11477,   6867,   -777,
 -1179,  11395,   6956,   -787,
 -1175,  11313,   7044,   -798,
 -1171,  11230,   7132,   -808,
 -1167,  11148,   7221,   -818,
 -1162,  11065,   7310,   -828,
 -1158,  10981,   7398,   -838,
 -1153,  10897,   7487,   -848,
 -1148,  10813,   7576,   -858,
 -1142,  10729,   7665,   -867,
 -1137,  10644,   7754,   -877,
 -1131,  10560,   7842,   -887,
 -1125,  10474,   7931,   -896,
 -1119,  10389,   8020,   -906,
 -1113,  10303,   8109,   -915,
 -1107,  10218,   8198,   -924,
 -1101,  10131,   8287,   -934,
 -1094,  10045,   8376,   -943,
 -1087,   9959,   8464,   -952,
 -1080,   9872,   8553,   -961,
 -1073,   9785,   8642,   -969,
 -1066,   9698,   8730,   -978,
 -1059,   9611,   8819,   -987,
 -1051,   9523,   8907,   -995,
 -1044,   9436,   8996,  -1004,
 -1036,   9348,   9084,  -1012,
 -1028,   9260,   9172,  -1020,
 -1020,   9172,   9260,  -1028,
 -1012,   9084,   9348,  -1036,
 -1004,   8996,   9436,  -1044,
  -995,   8907,   9523,  -1051,
  -987,   8819,   9611,  -1059,
  -978,   8730,   9698,  -1066,
  -969,   8642,   9785,  -1073,
  -961,   8553,   9872,  -1080,
  -952,   8464,   9959,  -1087,
  -943,   8376,  10045,  -1094,
  -934,   8287,  10131,  -1101,
  -924,   8198,  10218,  -1107,
  -915,   8109,  10303,  -1113,
  -906,   8020,  10389,  -1119,
  -896,   7931,  10474,  -1125,
  -887,   7842,  10560,  -1131,
  -877,   7754,  10644,  -1137,
  -867,   7665,  10729,  -1142,
  -858,   7576,  10813,  -1148,
  -848,   7487,  10897,  -1153,
  -838,   7398,  10981,  -1158,
  -828,   7310,  11065,  -1162,
  -818,   7221,  11148,  -1167,
  -808,   7132,  11230,  -1171,
  -798,   7044,  11313,  -1175,
  -787,   6956,  11395,  -1179,
  -777,   6867,  11477,  -1183,
  -767,   6779,  11558,  -1187,
  -757,   6691,  11639,  -1190,
  -746,   6603,  11720,  -1193,
  -736,   6515,  11800,  -1196,
  -725,   6428,  11880,  -1199,
  -715,   6340,  11960,  -1201,
  -704,   6253,  12039,  -1204,
  -694,   6166,  12117,  -1206,
  -683,   6079,  12196,  -1207,
  -672,   5992,  12274,  -1209,
  -662,   5905,  12351,  -1210,
  -651,   5819,  12428,  -1211,
  -641,   5733,  12504,  -1212,
  -630,   5647,  12580,  -1213,
  -619,   5561,  12656,  -1213,
  -609,   5476,  12731,  -1214,
  -598,   5390,  12805,  -1214,
  -587,   5305,  12879,  -1213,
  -577,   5221,  12953,  -1213,
  -566,   5136,  13026,  -1212,
  -555,   5052,  13098,  -1211,
  -545,   4968,  13170,  -1209,
  -534,   4885,  13241,  -1208,
  -523,   4801,  13312,  -1206,
  -513,   4718,  13382,  -1204,
  -502,   4636,  13452,  -1201,
  -492,   4553,  13521,  -1198,
  -481,   4471,  13589,  -1195,
  -471,   4390,  13657,  -1192,
  -461,   4309,  13724,  -1188,
  -450,   4228,  13791,  -1185,
  -440,   4147,  13857,  -1180,
  -430,   4067,  13922,  -1176,
  -419,   3988,  13987,  -1171,
  -409,   3908,  14051,  -1166,
  -399,   3829,  14114,  -1161,
  -389,   3751,  14177,  -1155,
  -379,   3673,  14239,  -1149,
  -369,   3595,  14300,  -1143,
  -359,   3518,  14361,  -1136,
  -349,   3442,  14421,  -1129,
  -340,   3366,  14480,  -1122,
  -330,   3290,  14538,  -1114,
  -320,   3215,  14596,  -1106,
  -311,   3140,  14653,  -1098,
  -302,   3066,  14709,  -1089,
  -292,   2992,  14765,  -1080,
  -283,   2919,  14819,  -1071,
  -274,   2846,  14873,  -1062,
  -265,   2774,  14926,  -1052,
  -256,   2702,  14979,  -1041,
  -247,   2631,  15030,  -1031,
  -238,   2561,  15081,  -1020,
  -230,   2491,  15131,  -1008,
  -221,   2422,  15180,   -997,
  -213,   2353,  15228,   -984,
  -205,   2285,  15275,   -972,
  -196,   2218,  15322,   -959,
  -188,   2151,  15368,   -946,
  -180,   2084,  15412,   -932,
  -173,   2019,  15456,   -918,
  -165,   1954,  15499,   -904,
  -157,   1890,  15541,   -889,
  -150,   1826,  15582,   -874,
  -143,   1763,  15623,   -859,
  -136,   1701,  15662,   -843,
  -129,   1639,  15700,   -826,
  -122,   1578,  15738,   -810,
  -115,   1518,  15774,   -793,
  -109,   1458,  15810,   -775,
  -102,   1400,  15844,   -757,
   -96,   1342,  15878,   -739,
   -90,   1284,  15910,   -720,
   -84,   1228,  15942,   -701,
   -79,   1172,  15972,   -682,
   -73,   1117,  16002,   -662,
   -68,   1063,  16030,   -641,
   -63,   1009,  16058,   -620,
   -58,    956,  16084,   -599,
   -53,    905,  16110,   -577,
   -48,    854,  16134,   -555,
   -44,    803,  16157,   -533,
   -40,    754,  16179,   -510,
   -36,    705,  16200,   -486,
   -32,    658,  16220,   -462,
   -28,    611,  16239,   -438,
   -25,    565,  16257,   -413,
   -22,    520,  16274,   -388,
   -19,    475,  16289,   -362,
   -16,    432,  16304,   -336,
   -13,    389,  16317,   -309,
   -11,    348,  16329,   -282,
    -9,    307,  16340,   -254,
    -7,    268,  16349,   -226,
    -5,    229,  16358,   -198,
    -4,    191,  16365,   -169,
    -2,    154,  16371,   -139,
    -2,    118,  16376,   -109,
    -1,     83,  16380,    -78,
     0,     49,  16383,    -47,
     0,     16,  16384,    -16,
};

const union table mlib_filters_u8_bc_3[] = {
   -16,    -16,    -16,
 16384,  16384,  16384,
    16,     16,     16,
     0,      0,      0,
   -47,    -47,    -47,
 16383,  16383,  16383,
    49,     49,     49,
     0,      0,      0,
   -78,    -78,    -78,
 16380,  16380,  16380,
    83,     83,     83,
    -1,     -1,     -1,
  -109,   -109,   -109,
 16376,  16376,  16376,
   118,    118,    118,
    -2,     -2,     -2,
  -139,   -139,   -139,
 16371,  16371,  16371,
   154,    154,    154,
    -2,     -2,     -2,
  -169,   -169,   -169,
 16365,  16365,  16365,
   191,    191,    191,
    -4,     -4,     -4,
  -198,   -198,   -198,
 16358,  16358,  16358,
   229,    229,    229,
    -5,     -5,     -5,
  -226,   -226,   -226,
 16349,  16349,  16349,
   268,    268,    268,
    -7,     -7,     -7,
  -254,   -254,   -254,
 16340,  16340,  16340,
   307,    307,    307,
    -9,     -9,     -9,
  -282,   -282,   -282,
 16329,  16329,  16329,
   348,    348,    348,
   -11,    -11,    -11,
  -309,   -309,   -309,
 16317,  16317,  16317,
   389,    389,    389,
   -13,    -13,    -13,
  -336,   -336,   -336,
 16304,  16304,  16304,
   432,    432,    432,
   -16,    -16,    -16,
  -362,   -362,   -362,
 16289,  16289,  16289,
   475,    475,    475,
   -19,    -19,    -19,
  -388,   -388,   -388,
 16274,  16274,  16274,
   520,    520,    520,
   -22,    -22,    -22,
  -413,   -413,   -413,
 16257,  16257,  16257,
   565,    565,    565,
   -25,    -25,    -25,
  -438,   -438,   -438,
 16239,  16239,  16239,
   611,    611,    611,
   -28,    -28,    -28,
  -462,   -462,   -462,
 16220,  16220,  16220,
   658,    658,    658,
   -32,    -32,    -32,
  -486,   -486,   -486,
 16200,  16200,  16200,
   705,    705,    705,
   -36,    -36,    -36,
  -510,   -510,   -510,
 16179,  16179,  16179,
   754,    754,    754,
   -40,    -40,    -40,
  -533,   -533,   -533,
 16157,  16157,  16157,
   803,    803,    803,
   -44,    -44,    -44,
  -555,   -555,   -555,
 16134,  16134,  16134,
   854,    854,    854,
   -48,    -48,    -48,
  -577,   -577,   -577,
 16110,  16110,  16110,
   905,    905,    905,
   -53,    -53,    -53,
  -599,   -599,   -599,
 16084,  16084,  16084,
   956,    956,    956,
   -58,    -58,    -58,
  -620,   -620,   -620,
 16058,  16058,  16058,
  1009,   1009,   1009,
   -63,    -63,    -63,
  -641,   -641,   -641,
 16030,  16030,  16030,
  1063,   1063,   1063,
   -68,    -68,    -68,
  -662,   -662,   -662,
 16002,  16002,  16002,
  1117,   1117,   1117,
   -73,    -73,    -73,
  -682,   -682,   -682,
 15972,  15972,  15972,
  1172,   1172,   1172,
   -79,    -79,    -79,
  -701,   -701,   -701,
 15942,  15942,  15942,
  1228,   1228,   1228,
   -84,    -84,    -84,
  -720,   -720,   -720,
 15910,  15910,  15910,
  1284,   1284,   1284,
   -90,    -90,    -90,
  -739,   -739,   -739,
 15878,  15878,  15878,
  1342,   1342,   1342,
   -96,    -96,    -96,
  -757,   -757,   -757,
 15844,  15844,  15844,
  1400,   1400,   1400,
  -102,   -102,   -102,
  -775,   -775,   -775,
 15810,  15810,  15810,
  1458,   1458,   1458,
  -109,   -109,   -109,
  -793,   -793,   -793,
 15774,  15774,  15774,
  1518,   1518,   1518,
  -115,   -115,   -115,
  -810,   -810,   -810,
 15738,  15738,  15738,
  1578,   1578,   1578,
  -122,   -122,   -122,
  -826,   -826,   -826,
 15700,  15700,  15700,
  1639,   1639,   1639,
  -129,   -129,   -129,
  -843,   -843,   -843,
 15662,  15662,  15662,
  1701,   1701,   1701,
  -136,   -136,   -136,
  -859,   -859,   -859,
 15623,  15623,  15623,
  1763,   1763,   1763,
  -143,   -143,   -143,
  -874,   -874,   -874,
 15582,  15582,  15582,
  1826,   1826,   1826,
  -150,   -150,   -150,
  -889,   -889,   -889,
 15541,  15541,  15541,
  1890,   1890,   1890,
  -157,   -157,   -157,
  -904,   -904,   -904,
 15499,  15499,  15499,
  1954,   1954,   1954,
  -165,   -165,   -165,
  -918,   -918,   -918,
 15456,  15456,  15456,
  2019,   2019,   2019,
  -173,   -173,   -173,
  -932,   -932,   -932,
 15412,  15412,  15412,
  2084,   2084,   2084,
  -180,   -180,   -180,
  -946,   -946,   -946,
 15368,  15368,  15368,
  2151,   2151,   2151,
  -188,   -188,   -188,
  -959,   -959,   -959,
 15322,  15322,  15322,
  2218,   2218,   2218,
  -196,   -196,   -196,
  -972,   -972,   -972,
 15275,  15275,  15275,
  2285,   2285,   2285,
  -205,   -205,   -205,
  -984,   -984,   -984,
 15228,  15228,  15228,
  2353,   2353,   2353,
  -213,   -213,   -213,
  -997,   -997,   -997,
 15180,  15180,  15180,
  2422,   2422,   2422,
  -221,   -221,   -221,
 -1008,  -1008,  -1008,
 15131,  15131,  15131,
  2491,   2491,   2491,
  -230,   -230,   -230,
 -1020,  -1020,  -1020,
 15081,  15081,  15081,
  2561,   2561,   2561,
  -238,   -238,   -238,
 -1031,  -1031,  -1031,
 15030,  15030,  15030,
  2631,   2631,   2631,
  -247,   -247,   -247,
 -1041,  -1041,  -1041,
 14979,  14979,  14979,
  2702,   2702,   2702,
  -256,   -256,   -256,
 -1052,  -1052,  -1052,
 14926,  14926,  14926,
  2774,   2774,   2774,
  -265,   -265,   -265,
 -1062,  -1062,  -1062,
 14873,  14873,  14873,
  2846,   2846,   2846,
  -274,   -274,   -274,
 -1071,  -1071,  -1071,
 14819,  14819,  14819,
  2919,   2919,   2919,
  -283,   -283,   -283,
 -1080,  -1080,  -1080,
 14765,  14765,  14765,
  2992,   2992,   2992,
  -292,   -292,   -292,
 -1089,  -1089,  -1089,
 14709,  14709,  14709,
  3066,   3066,   3066,
  -302,   -302,   -302,
 -1098,  -1098,  -1098,
 14653,  14653,  14653,
  3140,   3140,   3140,
  -311,   -311,   -311,
 -1106,  -1106,  -1106,
 14596,  14596,  14596,
  3215,   3215,   3215,
  -320,   -320,   -320,
 -1114,  -1114,  -1114,
 14538,  14538,  14538,
  3290,   3290,   3290,
  -330,   -330,   -330,
 -1122,  -1122,  -1122,
 14480,  14480,  14480,
  3366,   3366,   3366,
  -340,   -340,   -340,
 -1129,  -1129,  -1129,
 14421,  14421,  14421,
  3442,   3442,   3442,
  -349,   -349,   -349,
 -1136,  -1136,  -1136,
 14361,  14361,  14361,
  3518,   3518,   3518,
  -359,   -359,   -359,
 -1143,  -1143,  -1143,
 14300,  14300,  14300,
  3595,   3595,   3595,
  -369,   -369,   -369,
 -1149,  -1149,  -1149,
 14239,  14239,  14239,
  3673,   3673,   3673,
  -379,   -379,   -379,
 -1155,  -1155,  -1155,
 14177,  14177,  14177,
  3751,   3751,   3751,
  -389,   -389,   -389,
 -1161,  -1161,  -1161,
 14114,  14114,  14114,
  3829,   3829,   3829,
  -399,   -399,   -399,
 -1166,  -1166,  -1166,
 14051,  14051,  14051,
  3908,   3908,   3908,
  -409,   -409,   -409,
 -1171,  -1171,  -1171,
 13987,  13987,  13987,
  3988,   3988,   3988,
  -419,   -419,   -419,
 -1176,  -1176,  -1176,
 13922,  13922,  13922,
  4067,   4067,   4067,
  -430,   -430,   -430,
 -1180,  -1180,  -1180,
 13857,  13857,  13857,
  4147,   4147,   4147,
  -440,   -440,   -440,
 -1185,  -1185,  -1185,
 13791,  13791,  13791,
  4228,   4228,   4228,
  -450,   -450,   -450,
 -1188,  -1188,  -1188,
 13724,  13724,  13724,
  4309,   4309,   4309,
  -461,   -461,   -461,
 -1192,  -1192,  -1192,
 13657,  13657,  13657,
  4390,   4390,   4390,
  -471,   -471,   -471,
 -1195,  -1195,  -1195,
 13589,  13589,  13589,
  4471,   4471,   4471,
  -481,   -481,   -481,
 -1198,  -1198,  -1198,
 13521,  13521,  13521,
  4553,   4553,   4553,
  -492,   -492,   -492,
 -1201,  -1201,  -1201,
 13452,  13452,  13452,
  4636,   4636,   4636,
  -502,   -502,   -502,
 -1204,  -1204,  -1204,
 13382,  13382,  13382,
  4718,   4718,   4718,
  -513,   -513,   -513,
 -1206,  -1206,  -1206,
 13312,  13312,  13312,
  4801,   4801,   4801,
  -523,   -523,   -523,
 -1208,  -1208,  -1208,
 13241,  13241,  13241,
  4885,   4885,   4885,
  -534,   -534,   -534,
 -1209,  -1209,  -1209,
 13170,  13170,  13170,
  4968,   4968,   4968,
  -545,   -545,   -545,
 -1211,  -1211,  -1211,
 13098,  13098,  13098,
  5052,   5052,   5052,
  -555,   -555,   -555,
 -1212,  -1212,  -1212,
 13026,  13026,  13026,
  5136,   5136,   5136,
  -566,   -566,   -566,
 -1213,  -1213,  -1213,
 12953,  12953,  12953,
  5221,   5221,   5221,
  -577,   -577,   -577,
 -1213,  -1213,  -1213,
 12879,  12879,  12879,
  5305,   5305,   5305,
  -587,   -587,   -587,
 -1214,  -1214,  -1214,
 12805,  12805,  12805,
  5390,   5390,   5390,
  -598,   -598,   -598,
 -1214,  -1214,  -1214,
 12731,  12731,  12731,
  5476,   5476,   5476,
  -609,   -609,   -609,
 -1213,  -1213,  -1213,
 12656,  12656,  12656,
  5561,   5561,   5561,
  -619,   -619,   -619,
 -1213,  -1213,  -1213,
 12580,  12580,  12580,
  5647,   5647,   5647,
  -630,   -630,   -630,
 -1212,  -1212,  -1212,
 12504,  12504,  12504,
  5733,   5733,   5733,
  -641,   -641,   -641,
 -1211,  -1211,  -1211,
 12428,  12428,  12428,
  5819,   5819,   5819,
  -651,   -651,   -651,
 -1210,  -1210,  -1210,
 12351,  12351,  12351,
  5905,   5905,   5905,
  -662,   -662,   -662,
 -1209,  -1209,  -1209,
 12274,  12274,  12274,
  5992,   5992,   5992,
  -672,   -672,   -672,
 -1207,  -1207,  -1207,
 12196,  12196,  12196,
  6079,   6079,   6079,
  -683,   -683,   -683,
 -1206,  -1206,  -1206,
 12117,  12117,  12117,
  6166,   6166,   6166,
  -694,   -694,   -694,
 -1204,  -1204,  -1204,
 12039,  12039,  12039,
  6253,   6253,   6253,
  -704,   -704,   -704,
 -1201,  -1201,  -1201,
 11960,  11960,  11960,
  6340,   6340,   6340,
  -715,   -715,   -715,
 -1199,  -1199,  -1199,
 11880,  11880,  11880,
  6428,   6428,   6428,
  -725,   -725,   -725,
 -1196,  -1196,  -1196,
 11800,  11800,  11800,
  6515,   6515,   6515,
  -736,   -736,   -736,
 -1193,  -1193,  -1193,
 11720,  11720,  11720,
  6603,   6603,   6603,
  -746,   -746,   -746,
 -1190,  -1190,  -1190,
 11639,  11639,  11639,
  6691,   6691,   6691,
  -757,   -757,   -757,
 -1187,  -1187,  -1187,
 11558,  11558,  11558,
  6779,   6779,   6779,
  -767,   -767,   -767,
 -1183,  -1183,  -1183,
 11477,  11477,  11477,
  6867,   6867,   6867,
  -777,   -777,   -777,
 -1179,  -1179,  -1179,
 11395,  11395,  11395,
  6956,   6956,   6956,
  -787,   -787,   -787,
 -1175,  -1175,  -1175,
 11313,  11313,  11313,
  7044,   7044,   7044,
  -798,   -798,   -798,
 -1171,  -1171,  -1171,
 11230,  11230,  11230,
  7132,   7132,   7132,
  -808,   -808,   -808,
 -1167,  -1167,  -1167,
 11148,  11148,  11148,
  7221,   7221,   7221,
  -818,   -818,   -818,
 -1162,  -1162,  -1162,
 11065,  11065,  11065,
  7310,   7310,   7310,
  -828,   -828,   -828,
 -1158,  -1158,  -1158,
 10981,  10981,  10981,
  7398,   7398,   7398,
  -838,   -838,   -838,
 -1153,  -1153,  -1153,
 10897,  10897,  10897,
  7487,   7487,   7487,
  -848,   -848,   -848,
 -1148,  -1148,  -1148,
 10813,  10813,  10813,
  7576,   7576,   7576,
  -858,   -858,   -858,
 -1142,  -1142,  -1142,
 10729,  10729,  10729,
  7665,   7665,   7665,
  -867,   -867,   -867,
 -1137,  -1137,  -1137,
 10644,  10644,  10644,
  7754,   7754,   7754,
  -877,   -877,   -877,
 -1131,  -1131,  -1131,
 10560,  10560,  10560,
  7842,   7842,   7842,
  -887,   -887,   -887,
 -1125,  -1125,  -1125,
 10474,  10474,  10474,
  7931,   7931,   7931,
  -896,   -896,   -896,
 -1119,  -1119,  -1119,
 10389,  10389,  10389,
  8020,   8020,   8020,
  -906,   -906,   -906,
 -1113,  -1113,  -1113,
 10303,  10303,  10303,
  8109,   8109,   8109,
  -915,   -915,   -915,
 -1107,  -1107,  -1107,
 10218,  10218,  10218,
  8198,   8198,   8198,
  -924,   -924,   -924,
 -1101,  -1101,  -1101,
 10131,  10131,  10131,
  8287,   8287,   8287,
  -934,   -934,   -934,
 -1094,  -1094,  -1094,
 10045,  10045,  10045,
  8376,   8376,   8376,
  -943,   -943,   -943,
 -1087,  -1087,  -1087,
  9959,   9959,   9959,
  8464,   8464,   8464,
  -952,   -952,   -952,
 -1080,  -1080,  -1080,
  9872,   9872,   9872,
  8553,   8553,   8553,
  -961,   -961,   -961,
 -1073,  -1073,  -1073,
  9785,   9785,   9785,
  8642,   8642,   8642,
  -969,   -969,   -969,
 -1066,  -1066,  -1066,
  9698,   9698,   9698,
  8730,   8730,   8730,
  -978,   -978,   -978,
 -1059,  -1059,  -1059,
  9611,   9611,   9611,
  8819,   8819,   8819,
  -987,   -987,   -987,
 -1051,  -1051,  -1051,
  9523,   9523,   9523,
  8907,   8907,   8907,
  -995,   -995,   -995,
 -1044,  -1044,  -1044,
  9436,   9436,   9436,
  8996,   8996,   8996,
 -1004,  -1004,  -1004,
 -1036,  -1036,  -1036,
  9348,   9348,   9348,
  9084,   9084,   9084,
 -1012,  -1012,  -1012,
 -1028,  -1028,  -1028,
  9260,   9260,   9260,
  9172,   9172,   9172,
 -1020,  -1020,  -1020,
 -1020,  -1020,  -1020,
  9172,   9172,   9172,
  9260,   9260,   9260,
 -1028,  -1028,  -1028,
 -1012,  -1012,  -1012,
  9084,   9084,   9084,
  9348,   9348,   9348,
 -1036,  -1036,  -1036,
 -1004,  -1004,  -1004,
  8996,   8996,   8996,
  9436,   9436,   9436,
 -1044,  -1044,  -1044,
  -995,   -995,   -995,
  8907,   8907,   8907,
  9523,   9523,   9523,
 -1051,  -1051,  -1051,
  -987,   -987,   -987,
  8819,   8819,   8819,
  9611,   9611,   9611,
 -1059,  -1059,  -1059,
  -978,   -978,   -978,
  8730,   8730,   8730,
  9698,   9698,   9698,
 -1066,  -1066,  -1066,
  -969,   -969,   -969,
  8642,   8642,   8642,
  9785,   9785,   9785,
 -1073,  -1073,  -1073,
  -961,   -961,   -961,
  8553,   8553,   8553,
  9872,   9872,   9872,
 -1080,  -1080,  -1080,
  -952,   -952,   -952,
  8464,   8464,   8464,
  9959,   9959,   9959,
 -1087,  -1087,  -1087,
  -943,   -943,   -943,
  8376,   8376,   8376,
 10045,  10045,  10045,
 -1094,  -1094,  -1094,
  -934,   -934,   -934,
  8287,   8287,   8287,
 10131,  10131,  10131,
 -1101,  -1101,  -1101,
  -924,   -924,   -924,
  8198,   8198,   8198,
 10218,  10218,  10218,
 -1107,  -1107,  -1107,
  -915,   -915,   -915,
  8109,   8109,   8109,
 10303,  10303,  10303,
 -1113,  -1113,  -1113,
  -906,   -906,   -906,
  8020,   8020,   8020,
 10389,  10389,  10389,
 -1119,  -1119,  -1119,
  -896,   -896,   -896,
  7931,   7931,   7931,
 10474,  10474,  10474,
 -1125,  -1125,  -1125,
  -887,   -887,   -887,
  7842,   7842,   7842,
 10560,  10560,  10560,
 -1131,  -1131,  -1131,
  -877,   -877,   -877,
  7754,   7754,   7754,
 10644,  10644,  10644,
 -1137,  -1137,  -1137,
  -867,   -867,   -867,
  7665,   7665,   7665,
 10729,  10729,  10729,
 -1142,  -1142,  -1142,
  -858,   -858,   -858,
  7576,   7576,   7576,
 10813,  10813,  10813,
 -1148,  -1148,  -1148,
  -848,   -848,   -848,
  7487,   7487,   7487,
 10897,  10897,  10897,
 -1153,  -1153,  -1153,
  -838,   -838,   -838,
  7398,   7398,   7398,
 10981,  10981,  10981,
 -1158,  -1158,  -1158,
  -828,   -828,   -828,
  7310,   7310,   7310,
 11065,  11065,  11065,
 -1162,  -1162,  -1162,
  -818,   -818,   -818,
  7221,   7221,   7221,
 11148,  11148,  11148,
 -1167,  -1167,  -1167,
  -808,   -808,   -808,
  7132,   7132,   7132,
 11230,  11230,  11230,
 -1171,  -1171,  -1171,
  -798,   -798,   -798,
  7044,   7044,   7044,
 11313,  11313,  11313,
 -1175,  -1175,  -1175,
  -787,   -787,   -787,
  6956,   6956,   6956,
 11395,  11395,  11395,
 -1179,  -1179,  -1179,
  -777,   -777,   -777,
  6867,   6867,   6867,
 11477,  11477,  11477,
 -1183,  -1183,  -1183,
  -767,   -767,   -767,
  6779,   6779,   6779,
 11558,  11558,  11558,
 -1187,  -1187,  -1187,
  -757,   -757,   -757,
  6691,   6691,   6691,
 11639,  11639,  11639,
 -1190,  -1190,  -1190,
  -746,   -746,   -746,
  6603,   6603,   6603,
 11720,  11720,  11720,
 -1193,  -1193,  -1193,
  -736,   -736,   -736,
  6515,   6515,   6515,
 11800,  11800,  11800,
 -1196,  -1196,  -1196,
  -725,   -725,   -725,
  6428,   6428,   6428,
 11880,  11880,  11880,
 -1199,  -1199,  -1199,
  -715,   -715,   -715,
  6340,   6340,   6340,
 11960,  11960,  11960,
 -1201,  -1201,  -1201,
  -704,   -704,   -704,
  6253,   6253,   6253,
 12039,  12039,  12039,
 -1204,  -1204,  -1204,
  -694,   -694,   -694,
  6166,   6166,   6166,
 12117,  12117,  12117,
 -1206,  -1206,  -1206,
  -683,   -683,   -683,
  6079,   6079,   6079,
 12196,  12196,  12196,
 -1207,  -1207,  -1207,
  -672,   -672,   -672,
  5992,   5992,   5992,
 12274,  12274,  12274,
 -1209,  -1209,  -1209,
  -662,   -662,   -662,
  5905,   5905,   5905,
 12351,  12351,  12351,
 -1210,  -1210,  -1210,
  -651,   -651,   -651,
  5819,   5819,   5819,
 12428,  12428,  12428,
 -1211,  -1211,  -1211,
  -641,   -641,   -641,
  5733,   5733,   5733,
 12504,  12504,  12504,
 -1212,  -1212,  -1212,
  -630,   -630,   -630,
  5647,   5647,   5647,
 12580,  12580,  12580,
 -1213,  -1213,  -1213,
  -619,   -619,   -619,
  5561,   5561,   5561,
 12656,  12656,  12656,
 -1213,  -1213,  -1213,
  -609,   -609,   -609,
  5476,   5476,   5476,
 12731,  12731,  12731,
 -1214,  -1214,  -1214,
  -598,   -598,   -598,
  5390,   5390,   5390,
 12805,  12805,  12805,
 -1214,  -1214,  -1214,
  -587,   -587,   -587,
  5305,   5305,   5305,
 12879,  12879,  12879,
 -1213,  -1213,  -1213,
  -577,   -577,   -577,
  5221,   5221,   5221,
 12953,  12953,  12953,
 -1213,  -1213,  -1213,
  -566,   -566,   -566,
  5136,   5136,   5136,
 13026,  13026,  13026,
 -1212,  -1212,  -1212,
  -555,   -555,   -555,
  5052,   5052,   5052,
 13098,  13098,  13098,
 -1211,  -1211,  -1211,
  -545,   -545,   -545,
  4968,   4968,   4968,
 13170,  13170,  13170,
 -1209,  -1209,  -1209,
  -534,   -534,   -534,
  4885,   4885,   4885,
 13241,  13241,  13241,
 -1208,  -1208,  -1208,
  -523,   -523,   -523,
  4801,   4801,   4801,
 13312,  13312,  13312,
 -1206,  -1206,  -1206,
  -513,   -513,   -513,
  4718,   4718,   4718,
 13382,  13382,  13382,
 -1204,  -1204,  -1204,
  -502,   -502,   -502,
  4636,   4636,   4636,
 13452,  13452,  13452,
 -1201,  -1201,  -1201,
  -492,   -492,   -492,
  4553,   4553,   4553,
 13521,  13521,  13521,
 -1198,  -1198,  -1198,
  -481,   -481,   -481,
  4471,   4471,   4471,
 13589,  13589,  13589,
 -1195,  -1195,  -1195,
  -471,   -471,   -471,
  4390,   4390,   4390,
 13657,  13657,  13657,
 -1192,  -1192,  -1192,
  -461,   -461,   -461,
  4309,   4309,   4309,
 13724,  13724,  13724,
 -1188,  -1188,  -1188,
  -450,   -450,   -450,
  4228,   4228,   4228,
 13791,  13791,  13791,
 -1185,  -1185,  -1185,
  -440,   -440,   -440,
  4147,   4147,   4147,
 13857,  13857,  13857,
 -1180,  -1180,  -1180,
  -430,   -430,   -430,
  4067,   4067,   4067,
 13922,  13922,  13922,
 -1176,  -1176,  -1176,
  -419,   -419,   -419,
  3988,   3988,   3988,
 13987,  13987,  13987,
 -1171,  -1171,  -1171,
  -409,   -409,   -409,
  3908,   3908,   3908,
 14051,  14051,  14051,
 -1166,  -1166,  -1166,
  -399,   -399,   -399,
  3829,   3829,   3829,
 14114,  14114,  14114,
 -1161,  -1161,  -1161,
  -389,   -389,   -389,
  3751,   3751,   3751,
 14177,  14177,  14177,
 -1155,  -1155,  -1155,
  -379,   -379,   -379,
  3673,   3673,   3673,
 14239,  14239,  14239,
 -1149,  -1149,  -1149,
  -369,   -369,   -369,
  3595,   3595,   3595,
 14300,  14300,  14300,
 -1143,  -1143,  -1143,
  -359,   -359,   -359,
  3518,   3518,   3518,
 14361,  14361,  14361,
 -1136,  -1136,  -1136,
  -349,   -349,   -349,
  3442,   3442,   3442,
 14421,  14421,  14421,
 -1129,  -1129,  -1129,
  -340,   -340,   -340,
  3366,   3366,   3366,
 14480,  14480,  14480,
 -1122,  -1122,  -1122,
  -330,   -330,   -330,
  3290,   3290,   3290,
 14538,  14538,  14538,
 -1114,  -1114,  -1114,
  -320,   -320,   -320,
  3215,   3215,   3215,
 14596,  14596,  14596,
 -1106,  -1106,  -1106,
  -311,   -311,   -311,
  3140,   3140,   3140,
 14653,  14653,  14653,
 -1098,  -1098,  -1098,
  -302,   -302,   -302,
  3066,   3066,   3066,
 14709,  14709,  14709,
 -1089,  -1089,  -1089,
  -292,   -292,   -292,
  2992,   2992,   2992,
 14765,  14765,  14765,
 -1080,  -1080,  -1080,
  -283,   -283,   -283,
  2919,   2919,   2919,
 14819,  14819,  14819,
 -1071,  -1071,  -1071,
  -274,   -274,   -274,
  2846,   2846,   2846,
 14873,  14873,  14873,
 -1062,  -1062,  -1062,
  -265,   -265,   -265,
  2774,   2774,   2774,
 14926,  14926,  14926,
 -1052,  -1052,  -1052,
  -256,   -256,   -256,
  2702,   2702,   2702,
 14979,  14979,  14979,
 -1041,  -1041,  -1041,
  -247,   -247,   -247,
  2631,   2631,   2631,
 15030,  15030,  15030,
 -1031,  -1031,  -1031,
  -238,   -238,   -238,
  2561,   2561,   2561,
 15081,  15081,  15081,
 -1020,  -1020,  -1020,
  -230,   -230,   -230,
  2491,   2491,   2491,
 15131,  15131,  15131,
 -1008,  -1008,  -1008,
  -221,   -221,   -221,
  2422,   2422,   2422,
 15180,  15180,  15180,
  -997,   -997,   -997,
  -213,   -213,   -213,
  2353,   2353,   2353,
 15228,  15228,  15228,
  -984,   -984,   -984,
  -205,   -205,   -205,
  2285,   2285,   2285,
 15275,  15275,  15275,
  -972,   -972,   -972,
  -196,   -196,   -196,
  2218,   2218,   2218,
 15322,  15322,  15322,
  -959,   -959,   -959,
  -188,   -188,   -188,
  2151,   2151,   2151,
 15368,  15368,  15368,
  -946,   -946,   -946,
  -180,   -180,   -180,
  2084,   2084,   2084,
 15412,  15412,  15412,
  -932,   -932,   -932,
  -173,   -173,   -173,
  2019,   2019,   2019,
 15456,  15456,  15456,
  -918,   -918,   -918,
  -165,   -165,   -165,
  1954,   1954,   1954,
 15499,  15499,  15499,
  -904,   -904,   -904,
  -157,   -157,   -157,
  1890,   1890,   1890,
 15541,  15541,  15541,
  -889,   -889,   -889,
  -150,   -150,   -150,
  1826,   1826,   1826,
 15582,  15582,  15582,
  -874,   -874,   -874,
  -143,   -143,   -143,
  1763,   1763,   1763,
 15623,  15623,  15623,
  -859,   -859,   -859,
  -136,   -136,   -136,
  1701,   1701,   1701,
 15662,  15662,  15662,
  -843,   -843,   -843,
  -129,   -129,   -129,
  1639,   1639,   1639,
 15700,  15700,  15700,
  -826,   -826,   -826,
  -122,   -122,   -122,
  1578,   1578,   1578,
 15738,  15738,  15738,
  -810,   -810,   -810,
  -115,   -115,   -115,
  1518,   1518,   1518,
 15774,  15774,  15774,
  -793,   -793,   -793,
  -109,   -109,   -109,
  1458,   1458,   1458,
 15810,  15810,  15810,
  -775,   -775,   -775,
  -102,   -102,   -102,
  1400,   1400,   1400,
 15844,  15844,  15844,
  -757,   -757,   -757,
   -96,    -96,    -96,
  1342,   1342,   1342,
 15878,  15878,  15878,
  -739,   -739,   -739,
   -90,    -90,    -90,
  1284,   1284,   1284,
 15910,  15910,  15910,
  -720,   -720,   -720,
   -84,    -84,    -84,
  1228,   1228,   1228,
 15942,  15942,  15942,
  -701,   -701,   -701,
   -79,    -79,    -79,
  1172,   1172,   1172,
 15972,  15972,  15972,
  -682,   -682,   -682,
   -73,    -73,    -73,
  1117,   1117,   1117,
 16002,  16002,  16002,
  -662,   -662,   -662,
   -68,    -68,    -68,
  1063,   1063,   1063,
 16030,  16030,  16030,
  -641,   -641,   -641,
   -63,    -63,    -63,
  1009,   1009,   1009,
 16058,  16058,  16058,
  -620,   -620,   -620,
   -58,    -58,    -58,
   956,    956,    956,
 16084,  16084,  16084,
  -599,   -599,   -599,
   -53,    -53,    -53,
   905,    905,    905,
 16110,  16110,  16110,
  -577,   -577,   -577,
   -48,    -48,    -48,
   854,    854,    854,
 16134,  16134,  16134,
  -555,   -555,   -555,
   -44,    -44,    -44,
   803,    803,    803,
 16157,  16157,  16157,
  -533,   -533,   -533,
   -40,    -40,    -40,
   754,    754,    754,
 16179,  16179,  16179,
  -510,   -510,   -510,
   -36,    -36,    -36,
   705,    705,    705,
 16200,  16200,  16200,
  -486,   -486,   -486,
   -32,    -32,    -32,
   658,    658,    658,
 16220,  16220,  16220,
  -462,   -462,   -462,
   -28,    -28,    -28,
   611,    611,    611,
 16239,  16239,  16239,
  -438,   -438,   -438,
   -25,    -25,    -25,
   565,    565,    565,
 16257,  16257,  16257,
  -413,   -413,   -413,
   -22,    -22,    -22,
   520,    520,    520,
 16274,  16274,  16274,
  -388,   -388,   -388,
   -19,    -19,    -19,
   475,    475,    475,
 16289,  16289,  16289,
  -362,   -362,   -362,
   -16,    -16,    -16,
   432,    432,    432,
 16304,  16304,  16304,
  -336,   -336,   -336,
   -13,    -13,    -13,
   389,    389,    389,
 16317,  16317,  16317,
  -309,   -309,   -309,
   -11,    -11,    -11,
   348,    348,    348,
 16329,  16329,  16329,
  -282,   -282,   -282,
    -9,     -9,     -9,
   307,    307,    307,
 16340,  16340,  16340,
  -254,   -254,   -254,
    -7,     -7,     -7,
   268,    268,    268,
 16349,  16349,  16349,
  -226,   -226,   -226,
    -5,     -5,     -5,
   229,    229,    229,
 16358,  16358,  16358,
  -198,   -198,   -198,
    -4,     -4,     -4,
   191,    191,    191,
 16365,  16365,  16365,
  -169,   -169,   -169,
    -2,     -2,     -2,
   154,    154,    154,
 16371,  16371,  16371,
  -139,   -139,   -139,
    -2,     -2,     -2,
   118,    118,    118,
 16376,  16376,  16376,
  -109,   -109,   -109,
    -1,     -1,     -1,
    83,     83,     83,
 16380,  16380,  16380,
   -78,    -78,    -78,
     0,      0,      0,
    49,     49,     49,
 16383,  16383,  16383,
   -47,    -47,    -47,
     0,      0,      0,
    16,     16,     16,
 16384,  16384,  16384,
   -16,    -16,    -16,
};

const union table mlib_filters_u8_bc_4[] = {
   -16,    -16,    -16,    -16,
 16384,  16384,  16384,  16384,
    16,     16,     16,     16,
     0,      0,      0,      0,
   -47,    -47,    -47,    -47,
 16383,  16383,  16383,  16383,
    49,     49,     49,     49,
     0,      0,      0,      0,
   -78,    -78,    -78,    -78,
 16380,  16380,  16380,  16380,
    83,     83,     83,     83,
    -1,     -1,     -1,     -1,
  -109,   -109,   -109,   -109,
 16376,  16376,  16376,  16376,
   118,    118,    118,    118,
    -2,     -2,     -2,     -2,
  -139,   -139,   -139,   -139,
 16371,  16371,  16371,  16371,
   154,    154,    154,    154,
    -2,     -2,     -2,     -2,
  -169,   -169,   -169,   -169,
 16365,  16365,  16365,  16365,
   191,    191,    191,    191,
    -4,     -4,     -4,     -4,
  -198,   -198,   -198,   -198,
 16358,  16358,  16358,  16358,
   229,    229,    229,    229,
    -5,     -5,     -5,     -5,
  -226,   -226,   -226,   -226,
 16349,  16349,  16349,  16349,
   268,    268,    268,    268,
    -7,     -7,     -7,     -7,
  -254,   -254,   -254,   -254,
 16340,  16340,  16340,  16340,
   307,    307,    307,    307,
    -9,     -9,     -9,     -9,
  -282,   -282,   -282,   -282,
 16329,  16329,  16329,  16329,
   348,    348,    348,    348,
   -11,    -11,    -11,    -11,
  -309,   -309,   -309,   -309,
 16317,  16317,  16317,  16317,
   389,    389,    389,    389,
   -13,    -13,    -13,    -13,
  -336,   -336,   -336,   -336,
 16304,  16304,  16304,  16304,
   432,    432,    432,    432,
   -16,    -16,    -16,    -16,
  -362,   -362,   -362,   -362,
 16289,  16289,  16289,  16289,
   475,    475,    475,    475,
   -19,    -19,    -19,    -19,
  -388,   -388,   -388,   -388,
 16274,  16274,  16274,  16274,
   520,    520,    520,    520,
   -22,    -22,    -22,    -22,
  -413,   -413,   -413,   -413,
 16257,  16257,  16257,  16257,
   565,    565,    565,    565,
   -25,    -25,    -25,    -25,
  -438,   -438,   -438,   -438,
 16239,  16239,  16239,  16239,
   611,    611,    611,    611,
   -28,    -28,    -28,    -28,
  -462,   -462,   -462,   -462,
 16220,  16220,  16220,  16220,
   658,    658,    658,    658,
   -32,    -32,    -32,    -32,
  -486,   -486,   -486,   -486,
 16200,  16200,  16200,  16200,
   705,    705,    705,    705,
   -36,    -36,    -36,    -36,
  -510,   -510,   -510,   -510,
 16179,  16179,  16179,  16179,
   754,    754,    754,    754,
   -40,    -40,    -40,    -40,
  -533,   -533,   -533,   -533,
 16157,  16157,  16157,  16157,
   803,    803,    803,    803,
   -44,    -44,    -44,    -44,
  -555,   -555,   -555,   -555,
 16134,  16134,  16134,  16134,
   854,    854,    854,    854,
   -48,    -48,    -48,    -48,
  -577,   -577,   -577,   -577,
 16110,  16110,  16110,  16110,
   905,    905,    905,    905,
   -53,    -53,    -53,    -53,
  -599,   -599,   -599,   -599,
 16084,  16084,  16084,  16084,
   956,    956,    956,    956,
   -58,    -58,    -58,    -58,
  -620,   -620,   -620,   -620,
 16058,  16058,  16058,  16058,
  1009,   1009,   1009,   1009,
   -63,    -63,    -63,    -63,
  -641,   -641,   -641,   -641,
 16030,  16030,  16030,  16030,
  1063,   1063,   1063,   1063,
   -68,    -68,    -68,    -68,
  -662,   -662,   -662,   -662,
 16002,  16002,  16002,  16002,
  1117,   1117,   1117,   1117,
   -73,    -73,    -73,    -73,
  -682,   -682,   -682,   -682,
 15972,  15972,  15972,  15972,
  1172,   1172,   1172,   1172,
   -79,    -79,    -79,    -79,
  -701,   -701,   -701,   -701,
 15942,  15942,  15942,  15942,
  1228,   1228,   1228,   1228,
   -84,    -84,    -84,    -84,
  -720,   -720,   -720,   -720,
 15910,  15910,  15910,  15910,
  1284,   1284,   1284,   1284,
   -90,    -90,    -90,    -90,
  -739,   -739,   -739,   -739,
 15878,  15878,  15878,  15878,
  1342,   1342,   1342,   1342,
   -96,    -96,    -96,    -96,
  -757,   -757,   -757,   -757,
 15844,  15844,  15844,  15844,
  1400,   1400,   1400,   1400,
  -102,   -102,   -102,   -102,
  -775,   -775,   -775,   -775,
 15810,  15810,  15810,  15810,
  1458,   1458,   1458,   1458,
  -109,   -109,   -109,   -109,
  -793,   -793,   -793,   -793,
 15774,  15774,  15774,  15774,
  1518,   1518,   1518,   1518,
  -115,   -115,   -115,   -115,
  -810,   -810,   -810,   -810,
 15738,  15738,  15738,  15738,
  1578,   1578,   1578,   1578,
  -122,   -122,   -122,   -122,
  -826,   -826,   -826,   -826,
 15700,  15700,  15700,  15700,
  1639,   1639,   1639,   1639,
  -129,   -129,   -129,   -129,
  -843,   -843,   -843,   -843,
 15662,  15662,  15662,  15662,
  1701,   1701,   1701,   1701,
  -136,   -136,   -136,   -136,
  -859,   -859,   -859,   -859,
 15623,  15623,  15623,  15623,
  1763,   1763,   1763,   1763,
  -143,   -143,   -143,   -143,
  -874,   -874,   -874,   -874,
 15582,  15582,  15582,  15582,
  1826,   1826,   1826,   1826,
  -150,   -150,   -150,   -150,
  -889,   -889,   -889,   -889,
 15541,  15541,  15541,  15541,
  1890,   1890,   1890,   1890,
  -157,   -157,   -157,   -157,
  -904,   -904,   -904,   -904,
 15499,  15499,  15499,  15499,
  1954,   1954,   1954,   1954,
  -165,   -165,   -165,   -165,
  -918,   -918,   -918,   -918,
 15456,  15456,  15456,  15456,
  2019,   2019,   2019,   2019,
  -173,   -173,   -173,   -173,
  -932,   -932,   -932,   -932,
 15412,  15412,  15412,  15412,
  2084,   2084,   2084,   2084,
  -180,   -180,   -180,   -180,
  -946,   -946,   -946,   -946,
 15368,  15368,  15368,  15368,
  2151,   2151,   2151,   2151,
  -188,   -188,   -188,   -188,
  -959,   -959,   -959,   -959,
 15322,  15322,  15322,  15322,
  2218,   2218,   2218,   2218,
  -196,   -196,   -196,   -196,
  -972,   -972,   -972,   -972,
 15275,  15275,  15275,  15275,
  2285,   2285,   2285,   2285,
  -205,   -205,   -205,   -205,
  -984,   -984,   -984,   -984,
 15228,  15228,  15228,  15228,
  2353,   2353,   2353,   2353,
  -213,   -213,   -213,   -213,
  -997,   -997,   -997,   -997,
 15180,  15180,  15180,  15180,
  2422,   2422,   2422,   2422,
  -221,   -221,   -221,   -221,
 -1008,  -1008,  -1008,  -1008,
 15131,  15131,  15131,  15131,
  2491,   2491,   2491,   2491,
  -230,   -230,   -230,   -230,
 -1020,  -1020,  -1020,  -1020,
 15081,  15081,  15081,  15081,
  2561,   2561,   2561,   2561,
  -238,   -238,   -238,   -238,
 -1031,  -1031,  -1031,  -1031,
 15030,  15030,  15030,  15030,
  2631,   2631,   2631,   2631,
  -247,   -247,   -247,   -247,
 -1041,  -1041,  -1041,  -1041,
 14979,  14979,  14979,  14979,
  2702,   2702,   2702,   2702,
  -256,   -256,   -256,   -256,
 -1052,  -1052,  -1052,  -1052,
 14926,  14926,  14926,  14926,
  2774,   2774,   2774,   2774,
  -265,   -265,   -265,   -265,
 -1062,  -1062,  -1062,  -1062,
 14873,  14873,  14873,  14873,
  2846,   2846,   2846,   2846,
  -274,   -274,   -274,   -274,
 -1071,  -1071,  -1071,  -1071,
 14819,  14819,  14819,  14819,
  2919,   2919,   2919,   2919,
  -283,   -283,   -283,   -283,
 -1080,  -1080,  -1080,  -1080,
 14765,  14765,  14765,  14765,
  2992,   2992,   2992,   2992,
  -292,   -292,   -292,   -292,
 -1089,  -1089,  -1089,  -1089,
 14709,  14709,  14709,  14709,
  3066,   3066,   3066,   3066,
  -302,   -302,   -302,   -302,
 -1098,  -1098,  -1098,  -1098,
 14653,  14653,  14653,  14653,
  3140,   3140,   3140,   3140,
  -311,   -311,   -311,   -311,
 -1106,  -1106,  -1106,  -1106,
 14596,  14596,  14596,  14596,
  3215,   3215,   3215,   3215,
  -320,   -320,   -320,   -320,
 -1114,  -1114,  -1114,  -1114,
 14538,  14538,  14538,  14538,
  3290,   3290,   3290,   3290,
  -330,   -330,   -330,   -330,
 -1122,  -1122,  -1122,  -1122,
 14480,  14480,  14480,  14480,
  3366,   3366,   3366,   3366,
  -340,   -340,   -340,   -340,
 -1129,  -1129,  -1129,  -1129,
 14421,  14421,  14421,  14421,
  3442,   3442,   3442,   3442,
  -349,   -349,   -349,   -349,
 -1136,  -1136,  -1136,  -1136,
 14361,  14361,  14361,  14361,
  3518,   3518,   3518,   3518,
  -359,   -359,   -359,   -359,
 -1143,  -1143,  -1143,  -1143,
 14300,  14300,  14300,  14300,
  3595,   3595,   3595,   3595,
  -369,   -369,   -369,   -369,
 -1149,  -1149,  -1149,  -1149,
 14239,  14239,  14239,  14239,
  3673,   3673,   3673,   3673,
  -379,   -379,   -379,   -379,
 -1155,  -1155,  -1155,  -1155,
 14177,  14177,  14177,  14177,
  3751,   3751,   3751,   3751,
  -389,   -389,   -389,   -389,
 -1161,  -1161,  -1161,  -1161,
 14114,  14114,  14114,  14114,
  3829,   3829,   3829,   3829,
  -399,   -399,   -399,   -399,
 -1166,  -1166,  -1166,  -1166,
 14051,  14051,  14051,  14051,
  3908,   3908,   3908,   3908,
  -409,   -409,   -409,   -409,
 -1171,  -1171,  -1171,  -1171,
 13987,  13987,  13987,  13987,
  3988,   3988,   3988,   3988,
  -419,   -419,   -419,   -419,
 -1176,  -1176,  -1176,  -1176,
 13922,  13922,  13922,  13922,
  4067,   4067,   4067,   4067,
  -430,   -430,   -430,   -430,
 -1180,  -1180,  -1180,  -1180,
 13857,  13857,  13857,  13857,
  4147,   4147,   4147,   4147,
  -440,   -440,   -440,   -440,
 -1185,  -1185,  -1185,  -1185,
 13791,  13791,  13791,  13791,
  4228,   4228,   4228,   4228,
  -450,   -450,   -450,   -450,
 -1188,  -1188,  -1188,  -1188,
 13724,  13724,  13724,  13724,
  4309,   4309,   4309,   4309,
  -461,   -461,   -461,   -461,
 -1192,  -1192,  -1192,  -1192,
 13657,  13657,  13657,  13657,
  4390,   4390,   4390,   4390,
  -471,   -471,   -471,   -471,
 -1195,  -1195,  -1195,  -1195,
 13589,  13589,  13589,  13589,
  4471,   4471,   4471,   4471,
  -481,   -481,   -481,   -481,
 -1198,  -1198,  -1198,  -1198,
 13521,  13521,  13521,  13521,
  4553,   4553,   4553,   4553,
  -492,   -492,   -492,   -492,
 -1201,  -1201,  -1201,  -1201,
 13452,  13452,  13452,  13452,
  4636,   4636,   4636,   4636,
  -502,   -502,   -502,   -502,
 -1204,  -1204,  -1204,  -1204,
 13382,  13382,  13382,  13382,
  4718,   4718,   4718,   4718,
  -513,   -513,   -513,   -513,
 -1206,  -1206,  -1206,  -1206,
 13312,  13312,  13312,  13312,
  4801,   4801,   4801,   4801,
  -523,   -523,   -523,   -523,
 -1208,  -1208,  -1208,  -1208,
 13241,  13241,  13241,  13241,
  4885,   4885,   4885,   4885,
  -534,   -534,   -534,   -534,
 -1209,  -1209,  -1209,  -1209,
 13170,  13170,  13170,  13170,
  4968,   4968,   4968,   4968,
  -545,   -545,   -545,   -545,
 -1211,  -1211,  -1211,  -1211,
 13098,  13098,  13098,  13098,
  5052,   5052,   5052,   5052,
  -555,   -555,   -555,   -555,
 -1212,  -1212,  -1212,  -1212,
 13026,  13026,  13026,  13026,
  5136,   5136,   5136,   5136,
  -566,   -566,   -566,   -566,
 -1213,  -1213,  -1213,  -1213,
 12953,  12953,  12953,  12953,
  5221,   5221,   5221,   5221,
  -577,   -577,   -577,   -577,
 -1213,  -1213,  -1213,  -1213,
 12879,  12879,  12879,  12879,
  5305,   5305,   5305,   5305,
  -587,   -587,   -587,   -587,
 -1214,  -1214,  -1214,  -1214,
 12805,  12805,  12805,  12805,
  5390,   5390,   5390,   5390,
  -598,   -598,   -598,   -598,
 -1214,  -1214,  -1214,  -1214,
 12731,  12731,  12731,  12731,
  5476,   5476,   5476,   5476,
  -609,   -609,   -609,   -609,
 -1213,  -1213,  -1213,  -1213,
 12656,  12656,  12656,  12656,
  5561,   5561,   5561,   5561,
  -619,   -619,   -619,   -619,
 -1213,  -1213,  -1213,  -1213,
 12580,  12580,  12580,  12580,
  5647,   5647,   5647,   5647,
  -630,   -630,   -630,   -630,
 -1212,  -1212,  -1212,  -1212,
 12504,  12504,  12504,  12504,
  5733,   5733,   5733,   5733,
  -641,   -641,   -641,   -641,
 -1211,  -1211,  -1211,  -1211,
 12428,  12428,  12428,  12428,
  5819,   5819,   5819,   5819,
  -651,   -651,   -651,   -651,
 -1210,  -1210,  -1210,  -1210,
 12351,  12351,  12351,  12351,
  5905,   5905,   5905,   5905,
  -662,   -662,   -662,   -662,
 -1209,  -1209,  -1209,  -1209,
 12274,  12274,  12274,  12274,
  5992,   5992,   5992,   5992,
  -672,   -672,   -672,   -672,
 -1207,  -1207,  -1207,  -1207,
 12196,  12196,  12196,  12196,
  6079,   6079,   6079,   6079,
  -683,   -683,   -683,   -683,
 -1206,  -1206,  -1206,  -1206,
 12117,  12117,  12117,  12117,
  6166,   6166,   6166,   6166,
  -694,   -694,   -694,   -694,
 -1204,  -1204,  -1204,  -1204,
 12039,  12039,  12039,  12039,
  6253,   6253,   6253,   6253,
  -704,   -704,   -704,   -704,
 -1201,  -1201,  -1201,  -1201,
 11960,  11960,  11960,  11960,
  6340,   6340,   6340,   6340,
  -715,   -715,   -715,   -715,
 -1199,  -1199,  -1199,  -1199,
 11880,  11880,  11880,  11880,
  6428,   6428,   6428,   6428,
  -725,   -725,   -725,   -725,
 -1196,  -1196,  -1196,  -1196,
 11800,  11800,  11800,  11800,
  6515,   6515,   6515,   6515,
  -736,   -736,   -736,   -736,
 -1193,  -1193,  -1193,  -1193,
 11720,  11720,  11720,  11720,
  6603,   6603,   6603,   6603,
  -746,   -746,   -746,   -746,
 -1190,  -1190,  -1190,  -1190,
 11639,  11639,  11639,  11639,
  6691,   6691,   6691,   6691,
  -757,   -757,   -757,   -757,
 -1187,  -1187,  -1187,  -1187,
 11558,  11558,  11558,  11558,
  6779,   6779,   6779,   6779,
  -767,   -767,   -767,   -767,
 -1183,  -1183,  -1183,  -1183,
 11477,  11477,  11477,  11477,
  6867,   6867,   6867,   6867,
  -777,   -777,   -777,   -777,
 -1179,  -1179,  -1179,  -1179,
 11395,  11395,  11395,  11395,
  6956,   6956,   6956,   6956,
  -787,   -787,   -787,   -787,
 -1175,  -1175,  -1175,  -1175,
 11313,  11313,  11313,  11313,
  7044,   7044,   7044,   7044,
  -798,   -798,   -798,   -798,
 -1171,  -1171,  -1171,  -1171,
 11230,  11230,  11230,  11230,
  7132,   7132,   7132,   7132,
  -808,   -808,   -808,   -808,
 -1167,  -1167,  -1167,  -1167,
 11148,  11148,  11148,  11148,
  7221,   7221,   7221,   7221,
  -818,   -818,   -818,   -818,
 -1162,  -1162,  -1162,  -1162,
 11065,  11065,  11065,  11065,
  7310,   7310,   7310,   7310,
  -828,   -828,   -828,   -828,
 -1158,  -1158,  -1158,  -1158,
 10981,  10981,  10981,  10981,
  7398,   7398,   7398,   7398,
  -838,   -838,   -838,   -838,
 -1153,  -1153,  -1153,  -1153,
 10897,  10897,  10897,  10897,
  7487,   7487,   7487,   7487,
  -848,   -848,   -848,   -848,
 -1148,  -1148,  -1148,  -1148,
 10813,  10813,  10813,  10813,
  7576,   7576,   7576,   7576,
  -858,   -858,   -858,   -858,
 -1142,  -1142,  -1142,  -1142,
 10729,  10729,  10729,  10729,
  7665,   7665,   7665,   7665,
  -867,   -867,   -867,   -867,
 -1137,  -1137,  -1137,  -1137,
 10644,  10644,  10644,  10644,
  7754,   7754,   7754,   7754,
  -877,   -877,   -877,   -877,
 -1131,  -1131,  -1131,  -1131,
 10560,  10560,  10560,  10560,
  7842,   7842,   7842,   7842,
  -887,   -887,   -887,   -887,
 -1125,  -1125,  -1125,  -1125,
 10474,  10474,  10474,  10474,
  7931,   7931,   7931,   7931,
  -896,   -896,   -896,   -896,
 -1119,  -1119,  -1119,  -1119,
 10389,  10389,  10389,  10389,
  8020,   8020,   8020,   8020,
  -906,   -906,   -906,   -906,
 -1113,  -1113,  -1113,  -1113,
 10303,  10303,  10303,  10303,
  8109,   8109,   8109,   8109,
  -915,   -915,   -915,   -915,
 -1107,  -1107,  -1107,  -1107,
 10218,  10218,  10218,  10218,
  8198,   8198,   8198,   8198,
  -924,   -924,   -924,   -924,
 -1101,  -1101,  -1101,  -1101,
 10131,  10131,  10131,  10131,
  8287,   8287,   8287,   8287,
  -934,   -934,   -934,   -934,
 -1094,  -1094,  -1094,  -1094,
 10045,  10045,  10045,  10045,
  8376,   8376,   8376,   8376,
  -943,   -943,   -943,   -943,
 -1087,  -1087,  -1087,  -1087,
  9959,   9959,   9959,   9959,
  8464,   8464,   8464,   8464,
  -952,   -952,   -952,   -952,
 -1080,  -1080,  -1080,  -1080,
  9872,   9872,   9872,   9872,
  8553,   8553,   8553,   8553,
  -961,   -961,   -961,   -961,
 -1073,  -1073,  -1073,  -1073,
  9785,   9785,   9785,   9785,
  8642,   8642,   8642,   8642,
  -969,   -969,   -969,   -969,
 -1066,  -1066,  -1066,  -1066,
  9698,   9698,   9698,   9698,
  8730,   8730,   8730,   8730,
  -978,   -978,   -978,   -978,
 -1059,  -1059,  -1059,  -1059,
  9611,   9611,   9611,   9611,
  8819,   8819,   8819,   8819,
  -987,   -987,   -987,   -987,
 -1051,  -1051,  -1051,  -1051,
  9523,   9523,   9523,   9523,
  8907,   8907,   8907,   8907,
  -995,   -995,   -995,   -995,
 -1044,  -1044,  -1044,  -1044,
  9436,   9436,   9436,   9436,
  8996,   8996,   8996,   8996,
 -1004,  -1004,  -1004,  -1004,
 -1036,  -1036,  -1036,  -1036,
  9348,   9348,   9348,   9348,
  9084,   9084,   9084,   9084,
 -1012,  -1012,  -1012,  -1012,
 -1028,  -1028,  -1028,  -1028,
  9260,   9260,   9260,   9260,
  9172,   9172,   9172,   9172,
 -1020,  -1020,  -1020,  -1020,
 -1020,  -1020,  -1020,  -1020,
  9172,   9172,   9172,   9172,
  9260,   9260,   9260,   9260,
 -1028,  -1028,  -1028,  -1028,
 -1012,  -1012,  -1012,  -1012,
  9084,   9084,   9084,   9084,
  9348,   9348,   9348,   9348,
 -1036,  -1036,  -1036,  -1036,
 -1004,  -1004,  -1004,  -1004,
  8996,   8996,   8996,   8996,
  9436,   9436,   9436,   9436,
 -1044,  -1044,  -1044,  -1044,
  -995,   -995,   -995,   -995,
  8907,   8907,   8907,   8907,
  9523,   9523,   9523,   9523,
 -1051,  -1051,  -1051,  -1051,
  -987,   -987,   -987,   -987,
  8819,   8819,   8819,   8819,
  9611,   9611,   9611,   9611,
 -1059,  -1059,  -1059,  -1059,
  -978,   -978,   -978,   -978,
  8730,   8730,   8730,   8730,
  9698,   9698,   9698,   9698,
 -1066,  -1066,  -1066,  -1066,
  -969,   -969,   -969,   -969,
  8642,   8642,   8642,   8642,
  9785,   9785,   9785,   9785,
 -1073,  -1073,  -1073,  -1073,
  -961,   -961,   -961,   -961,
  8553,   8553,   8553,   8553,
  9872,   9872,   9872,   9872,
 -1080,  -1080,  -1080,  -1080,
  -952,   -952,   -952,   -952,
  8464,   8464,   8464,   8464,
  9959,   9959,   9959,   9959,
 -1087,  -1087,  -1087,  -1087,
  -943,   -943,   -943,   -943,
  8376,   8376,   8376,   8376,
 10045,  10045,  10045,  10045,
 -1094,  -1094,  -1094,  -1094,
  -934,   -934,   -934,   -934,
  8287,   8287,   8287,   8287,
 10131,  10131,  10131,  10131,
 -1101,  -1101,  -1101,  -1101,
  -924,   -924,   -924,   -924,
  8198,   8198,   8198,   8198,
 10218,  10218,  10218,  10218,
 -1107,  -1107,  -1107,  -1107,
  -915,   -915,   -915,   -915,
  8109,   8109,   8109,   8109,
 10303,  10303,  10303,  10303,
 -1113,  -1113,  -1113,  -1113,
  -906,   -906,   -906,   -906,
  8020,   8020,   8020,   8020,
 10389,  10389,  10389,  10389,
 -1119,  -1119,  -1119,  -1119,
  -896,   -896,   -896,   -896,
  7931,   7931,   7931,   7931,
 10474,  10474,  10474,  10474,
 -1125,  -1125,  -1125,  -1125,
  -887,   -887,   -887,   -887,
  7842,   7842,   7842,   7842,
 10560,  10560,  10560,  10560,
 -1131,  -1131,  -1131,  -1131,
  -877,   -877,   -877,   -877,
  7754,   7754,   7754,   7754,
 10644,  10644,  10644,  10644,
 -1137,  -1137,  -1137,  -1137,
  -867,   -867,   -867,   -867,
  7665,   7665,   7665,   7665,
 10729,  10729,  10729,  10729,
 -1142,  -1142,  -1142,  -1142,
  -858,   -858,   -858,   -858,
  7576,   7576,   7576,   7576,
 10813,  10813,  10813,  10813,
 -1148,  -1148,  -1148,  -1148,
  -848,   -848,   -848,   -848,
  7487,   7487,   7487,   7487,
 10897,  10897,  10897,  10897,
 -1153,  -1153,  -1153,  -1153,
  -838,   -838,   -838,   -838,
  7398,   7398,   7398,   7398,
 10981,  10981,  10981,  10981,
 -1158,  -1158,  -1158,  -1158,
  -828,   -828,   -828,   -828,
  7310,   7310,   7310,   7310,
 11065,  11065,  11065,  11065,
 -1162,  -1162,  -1162,  -1162,
  -818,   -818,   -818,   -818,
  7221,   7221,   7221,   7221,
 11148,  11148,  11148,  11148,
 -1167,  -1167,  -1167,  -1167,
  -808,   -808,   -808,   -808,
  7132,   7132,   7132,   7132,
 11230,  11230,  11230,  11230,
 -1171,  -1171,  -1171,  -1171,
  -798,   -798,   -798,   -798,
  7044,   7044,   7044,   7044,
 11313,  11313,  11313,  11313,
 -1175,  -1175,  -1175,  -1175,
  -787,   -787,   -787,   -787,
  6956,   6956,   6956,   6956,
 11395,  11395,  11395,  11395,
 -1179,  -1179,  -1179,  -1179,
  -777,   -777,   -777,   -777,
  6867,   6867,   6867,   6867,
 11477,  11477,  11477,  11477,
 -1183,  -1183,  -1183,  -1183,
  -767,   -767,   -767,   -767,
  6779,   6779,   6779,   6779,
 11558,  11558,  11558,  11558,
 -1187,  -1187,  -1187,  -1187,
  -757,   -757,   -757,   -757,
  6691,   6691,   6691,   6691,
 11639,  11639,  11639,  11639,
 -1190,  -1190,  -1190,  -1190,
  -746,   -746,   -746,   -746,
  6603,   6603,   6603,   6603,
 11720,  11720,  11720,  11720,
 -1193,  -1193,  -1193,  -1193,
  -736,   -736,   -736,   -736,
  6515,   6515,   6515,   6515,
 11800,  11800,  11800,  11800,
 -1196,  -1196,  -1196,  -1196,
  -725,   -725,   -725,   -725,
  6428,   6428,   6428,   6428,
 11880,  11880,  11880,  11880,
 -1199,  -1199,  -1199,  -1199,
  -715,   -715,   -715,   -715,
  6340,   6340,   6340,   6340,
 11960,  11960,  11960,  11960,
 -1201,  -1201,  -1201,  -1201,
  -704,   -704,   -704,   -704,
  6253,   6253,   6253,   6253,
 12039,  12039,  12039,  12039,
 -1204,  -1204,  -1204,  -1204,
  -694,   -694,   -694,   -694,
  6166,   6166,   6166,   6166,
 12117,  12117,  12117,  12117,
 -1206,  -1206,  -1206,  -1206,
  -683,   -683,   -683,   -683,
  6079,   6079,   6079,   6079,
 12196,  12196,  12196,  12196,
 -1207,  -1207,  -1207,  -1207,
  -672,   -672,   -672,   -672,
  5992,   5992,   5992,   5992,
 12274,  12274,  12274,  12274,
 -1209,  -1209,  -1209,  -1209,
  -662,   -662,   -662,   -662,
  5905,   5905,   5905,   5905,
 12351,  12351,  12351,  12351,
 -1210,  -1210,  -1210,  -1210,
  -651,   -651,   -651,   -651,
  5819,   5819,   5819,   5819,
 12428,  12428,  12428,  12428,
 -1211,  -1211,  -1211,  -1211,
  -641,   -641,   -641,   -641,
  5733,   5733,   5733,   5733,
 12504,  12504,  12504,  12504,
 -1212,  -1212,  -1212,  -1212,
  -630,   -630,   -630,   -630,
  5647,   5647,   5647,   5647,
 12580,  12580,  12580,  12580,
 -1213,  -1213,  -1213,  -1213,
  -619,   -619,   -619,   -619,
  5561,   5561,   5561,   5561,
 12656,  12656,  12656,  12656,
 -1213,  -1213,  -1213,  -1213,
  -609,   -609,   -609,   -609,
  5476,   5476,   5476,   5476,
 12731,  12731,  12731,  12731,
 -1214,  -1214,  -1214,  -1214,
  -598,   -598,   -598,   -598,
  5390,   5390,   5390,   5390,
 12805,  12805,  12805,  12805,
 -1214,  -1214,  -1214,  -1214,
  -587,   -587,   -587,   -587,
  5305,   5305,   5305,   5305,
 12879,  12879,  12879,  12879,
 -1213,  -1213,  -1213,  -1213,
  -577,   -577,   -577,   -577,
  5221,   5221,   5221,   5221,
 12953,  12953,  12953,  12953,
 -1213,  -1213,  -1213,  -1213,
  -566,   -566,   -566,   -566,
  5136,   5136,   5136,   5136,
 13026,  13026,  13026,  13026,
 -1212,  -1212,  -1212,  -1212,
  -555,   -555,   -555,   -555,
  5052,   5052,   5052,   5052,
 13098,  13098,  13098,  13098,
 -1211,  -1211,  -1211,  -1211,
  -545,   -545,   -545,   -545,
  4968,   4968,   4968,   4968,
 13170,  13170,  13170,  13170,
 -1209,  -1209,  -1209,  -1209,
  -534,   -534,   -534,   -534,
  4885,   4885,   4885,   4885,
 13241,  13241,  13241,  13241,
 -1208,  -1208,  -1208,  -1208,
  -523,   -523,   -523,   -523,
  4801,   4801,   4801,   4801,
 13312,  13312,  13312,  13312,
 -1206,  -1206,  -1206,  -1206,
  -513,   -513,   -513,   -513,
  4718,   4718,   4718,   4718,
 13382,  13382,  13382,  13382,
 -1204,  -1204,  -1204,  -1204,
  -502,   -502,   -502,   -502,
  4636,   4636,   4636,   4636,
 13452,  13452,  13452,  13452,
 -1201,  -1201,  -1201,  -1201,
  -492,   -492,   -492,   -492,
  4553,   4553,   4553,   4553,
 13521,  13521,  13521,  13521,
 -1198,  -1198,  -1198,  -1198,
  -481,   -481,   -481,   -481,
  4471,   4471,   4471,   4471,
 13589,  13589,  13589,  13589,
 -1195,  -1195,  -1195,  -1195,
  -471,   -471,   -471,   -471,
  4390,   4390,   4390,   4390,
 13657,  13657,  13657,  13657,
 -1192,  -1192,  -1192,  -1192,
  -461,   -461,   -461,   -461,
  4309,   4309,   4309,   4309,
 13724,  13724,  13724,  13724,
 -1188,  -1188,  -1188,  -1188,
  -450,   -450,   -450,   -450,
  4228,   4228,   4228,   4228,
 13791,  13791,  13791,  13791,
 -1185,  -1185,  -1185,  -1185,
  -440,   -440,   -440,   -440,
  4147,   4147,   4147,   4147,
 13857,  13857,  13857,  13857,
 -1180,  -1180,  -1180,  -1180,
  -430,   -430,   -430,   -430,
  4067,   4067,   4067,   4067,
 13922,  13922,  13922,  13922,
 -1176,  -1176,  -1176,  -1176,
  -419,   -419,   -419,   -419,
  3988,   3988,   3988,   3988,
 13987,  13987,  13987,  13987,
 -1171,  -1171,  -1171,  -1171,
  -409,   -409,   -409,   -409,
  3908,   3908,   3908,   3908,
 14051,  14051,  14051,  14051,
 -1166,  -1166,  -1166,  -1166,
  -399,   -399,   -399,   -399,
  3829,   3829,   3829,   3829,
 14114,  14114,  14114,  14114,
 -1161,  -1161,  -1161,  -1161,
  -389,   -389,   -389,   -389,
  3751,   3751,   3751,   3751,
 14177,  14177,  14177,  14177,
 -1155,  -1155,  -1155,  -1155,
  -379,   -379,   -379,   -379,
  3673,   3673,   3673,   3673,
 14239,  14239,  14239,  14239,
 -1149,  -1149,  -1149,  -1149,
  -369,   -369,   -369,   -369,
  3595,   3595,   3595,   3595,
 14300,  14300,  14300,  14300,
 -1143,  -1143,  -1143,  -1143,
  -359,   -359,   -359,   -359,
  3518,   3518,   3518,   3518,
 14361,  14361,  14361,  14361,
 -1136,  -1136,  -1136,  -1136,
  -349,   -349,   -349,   -349,
  3442,   3442,   3442,   3442,
 14421,  14421,  14421,  14421,
 -1129,  -1129,  -1129,  -1129,
  -340,   -340,   -340,   -340,
  3366,   3366,   3366,   3366,
 14480,  14480,  14480,  14480,
 -1122,  -1122,  -1122,  -1122,
  -330,   -330,   -330,   -330,
  3290,   3290,   3290,   3290,
 14538,  14538,  14538,  14538,
 -1114,  -1114,  -1114,  -1114,
  -320,   -320,   -320,   -320,
  3215,   3215,   3215,   3215,
 14596,  14596,  14596,  14596,
 -1106,  -1106,  -1106,  -1106,
  -311,   -311,   -311,   -311,
  3140,   3140,   3140,   3140,
 14653,  14653,  14653,  14653,
 -1098,  -1098,  -1098,  -1098,
  -302,   -302,   -302,   -302,
  3066,   3066,   3066,   3066,
 14709,  14709,  14709,  14709,
 -1089,  -1089,  -1089,  -1089,
  -292,   -292,   -292,   -292,
  2992,   2992,   2992,   2992,
 14765,  14765,  14765,  14765,
 -1080,  -1080,  -1080,  -1080,
  -283,   -283,   -283,   -283,
  2919,   2919,   2919,   2919,
 14819,  14819,  14819,  14819,
 -1071,  -1071,  -1071,  -1071,
  -274,   -274,   -274,   -274,
  2846,   2846,   2846,   2846,
 14873,  14873,  14873,  14873,
 -1062,  -1062,  -1062,  -1062,
  -265,   -265,   -265,   -265,
  2774,   2774,   2774,   2774,
 14926,  14926,  14926,  14926,
 -1052,  -1052,  -1052,  -1052,
  -256,   -256,   -256,   -256,
  2702,   2702,   2702,   2702,
 14979,  14979,  14979,  14979,
 -1041,  -1041,  -1041,  -1041,
  -247,   -247,   -247,   -247,
  2631,   2631,   2631,   2631,
 15030,  15030,  15030,  15030,
 -1031,  -1031,  -1031,  -1031,
  -238,   -238,   -238,   -238,
  2561,   2561,   2561,   2561,
 15081,  15081,  15081,  15081,
 -1020,  -1020,  -1020,  -1020,
  -230,   -230,   -230,   -230,
  2491,   2491,   2491,   2491,
 15131,  15131,  15131,  15131,
 -1008,  -1008,  -1008,  -1008,
  -221,   -221,   -221,   -221,
  2422,   2422,   2422,   2422,
 15180,  15180,  15180,  15180,
  -997,   -997,   -997,   -997,
  -213,   -213,   -213,   -213,
  2353,   2353,   2353,   2353,
 15228,  15228,  15228,  15228,
  -984,   -984,   -984,   -984,
  -205,   -205,   -205,   -205,
  2285,   2285,   2285,   2285,
 15275,  15275,  15275,  15275,
  -972,   -972,   -972,   -972,
  -196,   -196,   -196,   -196,
  2218,   2218,   2218,   2218,
 15322,  15322,  15322,  15322,
  -959,   -959,   -959,   -959,
  -188,   -188,   -188,   -188,
  2151,   2151,   2151,   2151,
 15368,  15368,  15368,  15368,
  -946,   -946,   -946,   -946,
  -180,   -180,   -180,   -180,
  2084,   2084,   2084,   2084,
 15412,  15412,  15412,  15412,
  -932,   -932,   -932,   -932,
  -173,   -173,   -173,   -173,
  2019,   2019,   2019,   2019,
 15456,  15456,  15456,  15456,
  -918,   -918,   -918,   -918,
  -165,   -165,   -165,   -165,
  1954,   1954,   1954,   1954,
 15499,  15499,  15499,  15499,
  -904,   -904,   -904,   -904,
  -157,   -157,   -157,   -157,
  1890,   1890,   1890,   1890,
 15541,  15541,  15541,  15541,
  -889,   -889,   -889,   -889,
  -150,   -150,   -150,   -150,
  1826,   1826,   1826,   1826,
 15582,  15582,  15582,  15582,
  -874,   -874,   -874,   -874,
  -143,   -143,   -143,   -143,
  1763,   1763,   1763,   1763,
 15623,  15623,  15623,  15623,
  -859,   -859,   -859,   -859,
  -136,   -136,   -136,   -136,
  1701,   1701,   1701,   1701,
 15662,  15662,  15662,  15662,
  -843,   -843,   -843,   -843,
  -129,   -129,   -129,   -129,
  1639,   1639,   1639,   1639,
 15700,  15700,  15700,  15700,
  -826,   -826,   -826,   -826,
  -122,   -122,   -122,   -122,
  1578,   1578,   1578,   1578,
 15738,  15738,  15738,  15738,
  -810,   -810,   -810,   -810,
  -115,   -115,   -115,   -115,
  1518,   1518,   1518,   1518,
 15774,  15774,  15774,  15774,
  -793,   -793,   -793,   -793,
  -109,   -109,   -109,   -109,
  1458,   1458,   1458,   1458,
 15810,  15810,  15810,  15810,
  -775,   -775,   -775,   -775,
  -102,   -102,   -102,   -102,
  1400,   1400,   1400,   1400,
 15844,  15844,  15844,  15844,
  -757,   -757,   -757,   -757,
   -96,    -96,    -96,    -96,
  1342,   1342,   1342,   1342,
 15878,  15878,  15878,  15878,
  -739,   -739,   -739,   -739,
   -90,    -90,    -90,    -90,
  1284,   1284,   1284,   1284,
 15910,  15910,  15910,  15910,
  -720,   -720,   -720,   -720,
   -84,    -84,    -84,    -84,
  1228,   1228,   1228,   1228,
 15942,  15942,  15942,  15942,
  -701,   -701,   -701,   -701,
   -79,    -79,    -79,    -79,
  1172,   1172,   1172,   1172,
 15972,  15972,  15972,  15972,
  -682,   -682,   -682,   -682,
   -73,    -73,    -73,    -73,
  1117,   1117,   1117,   1117,
 16002,  16002,  16002,  16002,
  -662,   -662,   -662,   -662,
   -68,    -68,    -68,    -68,
  1063,   1063,   1063,   1063,
 16030,  16030,  16030,  16030,
  -641,   -641,   -641,   -641,
   -63,    -63,    -63,    -63,
  1009,   1009,   1009,   1009,
 16058,  16058,  16058,  16058,
  -620,   -620,   -620,   -620,
   -58,    -58,    -58,    -58,
   956,    956,    956,    956,
 16084,  16084,  16084,  16084,
  -599,   -599,   -599,   -599,
   -53,    -53,    -53,    -53,
   905,    905,    905,    905,
 16110,  16110,  16110,  16110,
  -577,   -577,   -577,   -577,
   -48,    -48,    -48,    -48,
   854,    854,    854,    854,
 16134,  16134,  16134,  16134,
  -555,   -555,   -555,   -555,
   -44,    -44,    -44,    -44,
   803,    803,    803,    803,
 16157,  16157,  16157,  16157,
  -533,   -533,   -533,   -533,
   -40,    -40,    -40,    -40,
   754,    754,    754,    754,
 16179,  16179,  16179,  16179,
  -510,   -510,   -510,   -510,
   -36,    -36,    -36,    -36,
   705,    705,    705,    705,
 16200,  16200,  16200,  16200,
  -486,   -486,   -486,   -486,
   -32,    -32,    -32,    -32,
   658,    658,    658,    658,
 16220,  16220,  16220,  16220,
  -462,   -462,   -462,   -462,
   -28,    -28,    -28,    -28,
   611,    611,    611,    611,
 16239,  16239,  16239,  16239,
  -438,   -438,   -438,   -438,
   -25,    -25,    -25,    -25,
   565,    565,    565,    565,
 16257,  16257,  16257,  16257,
  -413,   -413,   -413,   -413,
   -22,    -22,    -22,    -22,
   520,    520,    520,    520,
 16274,  16274,  16274,  16274,
  -388,   -388,   -388,   -388,
   -19,    -19,    -19,    -19,
   475,    475,    475,    475,
 16289,  16289,  16289,  16289,
  -362,   -362,   -362,   -362,
   -16,    -16,    -16,    -16,
   432,    432,    432,    432,
 16304,  16304,  16304,  16304,
  -336,   -336,   -336,   -336,
   -13,    -13,    -13,    -13,
   389,    389,    389,    389,
 16317,  16317,  16317,  16317,
  -309,   -309,   -309,   -309,
   -11,    -11,    -11,    -11,
   348,    348,    348,    348,
 16329,  16329,  16329,  16329,
  -282,   -282,   -282,   -282,
    -9,     -9,     -9,     -9,
   307,    307,    307,    307,
 16340,  16340,  16340,  16340,
  -254,   -254,   -254,   -254,
    -7,     -7,     -7,     -7,
   268,    268,    268,    268,
 16349,  16349,  16349,  16349,
  -226,   -226,   -226,   -226,
    -5,     -5,     -5,     -5,
   229,    229,    229,    229,
 16358,  16358,  16358,  16358,
  -198,   -198,   -198,   -198,
    -4,     -4,     -4,     -4,
   191,    191,    191,    191,
 16365,  16365,  16365,  16365,
  -169,   -169,   -169,   -169,
    -2,     -2,     -2,     -2,
   154,    154,    154,    154,
 16371,  16371,  16371,  16371,
  -139,   -139,   -139,   -139,
    -2,     -2,     -2,     -2,
   118,    118,    118,    118,
 16376,  16376,  16376,  16376,
  -109,   -109,   -109,   -109,
    -1,     -1,     -1,     -1,
    83,     83,     83,     83,
 16380,  16380,  16380,  16380,
   -78,    -78,    -78,    -78,
     0,      0,      0,      0,
    49,     49,     49,     49,
 16383,  16383,  16383,  16383,
   -47,    -47,    -47,    -47,
     0,      0,      0,      0,
    16,     16,     16,     16,
 16384,  16384,  16384,  16384,
   -16,    -16,    -16,    -16,
};

const union table mlib_filters_s16_bc[] = {
   -16,  32767,     16,      0,
   -48,  32767,     49,      0,
   -79,  32766,     82,      0,
  -110,  32764,    115,     -1,
  -141,  32762,    149,     -1,
  -172,  32759,    184,     -2,
  -203,  32755,    218,     -3,
  -233,  32751,    254,     -3,
  -263,  32746,    290,     -4,
  -293,  32740,    326,     -6,
  -322,  32734,    363,     -7,
  -352,  32727,    401,     -8,
  -381,  32720,    438,    -10,
  -410,  32712,    477,    -11,
  -438,  32703,    515,    -13,
  -466,  32694,    555,    -15,
  -495,  32685,    594,    -16,
  -522,  32674,    635,    -18,
  -550,  32663,    675,    -21,
  -577,  32652,    716,    -23,
  -605,  32640,    758,    -25,
  -631,  32627,    800,    -28,
  -658,  32614,    842,    -30,
  -685,  32600,    885,    -33,
  -711,  32586,    929,    -36,
  -737,  32571,    972,    -39,
  -762,  32555,   1017,    -42,
  -788,  32539,   1061,    -45,
  -813,  32523,   1107,    -48,
  -838,  32505,   1152,    -51,
  -863,  32488,   1198,    -55,
  -888,  32469,   1245,    -58,
  -912,  32450,   1291,    -62,
  -936,  32431,   1339,    -66,
  -960,  32411,   1387,    -69,
  -984,  32391,   1435,    -73,
 -1007,  32369,   1483,    -77,
 -1031,  32348,   1532,    -81,
 -1054,  32326,   1582,    -86,
 -1076,  32303,   1631,    -90,
 -1099,  32280,   1682,    -94,
 -1121,  32256,   1732,    -99,
 -1144,  32232,   1783,   -104,
 -1166,  32207,   1835,   -108,
 -1187,  32181,   1887,   -113,
 -1209,  32156,   1939,   -118,
 -1230,  32129,   1992,   -123,
 -1251,  32102,   2045,   -128,
 -1272,  32075,   2098,   -133,
 -1293,  32047,   2152,   -138,
 -1313,  32018,   2206,   -144,
 -1333,  31989,   2261,   -149,
 -1353,  31960,   2316,   -155,
 -1373,  31930,   2371,   -160,
 -1392,  31899,   2427,   -166,
 -1412,  31868,   2483,   -172,
 -1431,  31836,   2540,   -177,
 -1450,  31804,   2597,   -183,
 -1469,  31772,   2654,   -189,
 -1487,  31739,   2712,   -196,
 -1506,  31705,   2770,   -202,
 -1524,  31671,   2828,   -208,
 -1542,  31637,   2887,   -214,
 -1559,  31602,   2946,   -221,
 -1577,  31566,   3006,   -227,
 -1594,  31530,   3066,   -234,
 -1611,  31494,   3126,   -240,
 -1628,  31457,   3186,   -247,
 -1645,  31419,   3247,   -254,
 -1661,  31381,   3309,   -261,
 -1677,  31343,   3370,   -268,
 -1694,  31304,   3432,   -275,
 -1709,  31265,   3495,   -282,
 -1725,  31225,   3557,   -289,
 -1741,  31185,   3620,   -296,
 -1756,  31144,   3683,   -304,
 -1771,  31103,   3747,   -311,
 -1786,  31062,   3811,   -319,
 -1801,  31019,   3875,   -326,
 -1815,  30977,   3940,   -334,
 -1830,  30934,   4005,   -341,
 -1844,  30891,   4070,   -349,
 -1858,  30847,   4136,   -357,
 -1872,  30802,   4202,   -365,
 -1885,  30758,   4268,   -373,
 -1899,  30712,   4335,   -381,
 -1912,  30667,   4402,   -389,
 -1925,  30621,   4469,   -397,
 -1938,  30574,   4536,   -405,
 -1950,  30527,   4604,   -413,
 -1963,  30480,   4672,   -421,
 -1975,  30432,   4741,   -430,
 -1987,  30384,   4809,   -438,
 -1999,  30335,   4878,   -447,
 -2011,  30286,   4948,   -455,
 -2022,  30237,   5017,   -464,
 -2034,  30187,   5087,   -472,
 -2045,  30137,   5157,   -481,
 -2056,  30086,   5228,   -490,
 -2067,  30035,   5298,   -499,
 -2077,  29983,   5369,   -507,
 -2088,  29931,   5441,   -516,
 -2098,  29879,   5512,   -525,
 -2108,  29826,   5584,   -534,
 -2118,  29773,   5656,   -543,
 -2128,  29720,   5729,   -552,
 -2138,  29666,   5801,   -561,
 -2147,  29612,   5874,   -571,
 -2156,  29557,   5947,   -580,
 -2165,  29502,   6021,   -589,
 -2174,  29446,   6094,   -598,
 -2183,  29391,   6168,   -608,
 -2192,  29334,   6243,   -617,
 -2200,  29278,   6317,   -627,
 -2208,  29221,   6392,   -636,
 -2217,  29163,   6467,   -646,
 -2224,  29106,   6542,   -655,
 -2232,  29048,   6617,   -665,
 -2240,  28989,   6693,   -675,
 -2247,  28930,   6769,   -684,
 -2255,  28871,   6845,   -694,
 -2262,  28812,   6922,   -704,
 -2269,  28752,   6998,   -713,
 -2275,  28691,   7075,   -723,
 -2282,  28631,   7152,   -733,
 -2289,  28570,   7230,   -743,
 -2295,  28509,   7307,   -753,
 -2301,  28447,   7385,   -763,
 -2307,  28385,   7463,   -773,
 -2313,  28323,   7541,   -783,
 -2319,  28260,   7620,   -793,
 -2324,  28197,   7698,   -803,
 -2329,  28134,   7777,   -813,
 -2335,  28070,   7856,   -823,
 -2340,  28006,   7936,   -834,
 -2345,  27941,   8015,   -844,
 -2349,  27877,   8095,   -854,
 -2354,  27812,   8175,   -864,
 -2359,  27746,   8255,   -875,
 -2363,  27681,   8335,   -885,
 -2367,  27615,   8415,   -895,
 -2371,  27549,   8496,   -906,
 -2375,  27482,   8577,   -916,
 -2379,  27415,   8658,   -926,
 -2382,  27348,   8739,   -937,
 -2386,  27280,   8821,   -947,
 -2389,  27212,   8902,   -958,
 -2392,  27144,   8984,   -968,
 -2395,  27076,   9066,   -979,
 -2398,  27007,   9148,   -989,
 -2401,  26938,   9230,  -1000,
 -2403,  26869,   9313,  -1010,
 -2406,  26799,   9395,  -1021,
 -2408,  26729,   9478,  -1031,
 -2410,  26659,   9561,  -1042,
 -2412,  26589,   9644,  -1052,
 -2414,  26518,   9727,  -1063,
 -2416,  26447,   9811,  -1073,
 -2418,  26376,   9894,  -1084,
 -2419,  26304,   9978,  -1095,
 -2421,  26232,  10062,  -1105,
 -2422,  26160,  10146,  -1116,
 -2423,  26087,  10230,  -1127,
 -2424,  26015,  10314,  -1137,
 -2425,  25942,  10399,  -1148,
 -2426,  25869,  10483,  -1159,
 -2426,  25795,  10568,  -1169,
 -2427,  25721,  10653,  -1180,
 -2427,  25647,  10738,  -1191,
 -2427,  25573,  10823,  -1201,
 -2427,  25499,  10908,  -1212,
 -2427,  25424,  10994,  -1223,
 -2427,  25349,  11079,  -1233,
 -2427,  25274,  11165,  -1244,
 -2426,  25198,  11251,  -1255,
 -2426,  25122,  11337,  -1265,
 -2425,  25046,  11422,  -1276,
 -2424,  24970,  11509,  -1286,
 -2423,  24894,  11595,  -1297,
 -2422,  24817,  11681,  -1308,
 -2421,  24740,  11767,  -1318,
 -2420,  24663,  11854,  -1329,
 -2419,  24586,  11941,  -1340,
 -2417,  24508,  12027,  -1350,
 -2416,  24430,  12114,  -1361,
 -2414,  24352,  12201,  -1371,
 -2412,  24274,  12288,  -1382,
 -2410,  24196,  12375,  -1393,
 -2408,  24117,  12462,  -1403,
 -2406,  24038,  12549,  -1414,
 -2404,  23959,  12637,  -1424,
 -2401,  23880,  12724,  -1435,
 -2399,  23800,  12812,  -1445,
 -2396,  23721,  12899,  -1456,
 -2393,  23641,  12987,  -1466,
 -2391,  23561,  13075,  -1477,
 -2388,  23480,  13163,  -1487,
 -2385,  23400,  13250,  -1497,
 -2381,  23319,  13338,  -1508,
 -2378,  23238,  13426,  -1518,
 -2375,  23157,  13514,  -1529,
 -2371,  23076,  13602,  -1539,
 -2368,  22994,  13691,  -1549,
 -2364,  22913,  13779,  -1560,
 -2360,  22831,  13867,  -1570,
 -2357,  22749,  13955,  -1580,
 -2353,  22667,  14044,  -1590,
 -2349,  22585,  14132,  -1600,
 -2344,  22502,  14221,  -1611,
 -2340,  22420,  14309,  -1621,
 -2336,  22337,  14398,  -1631,
 -2331,  22254,  14486,  -1641,
 -2327,  22171,  14575,  -1651,
 -2322,  22087,  14664,  -1661,
 -2317,  22004,  14752,  -1671,
 -2313,  21920,  14841,  -1681,
 -2308,  21837,  14930,  -1691,
 -2303,  21753,  15019,  -1701,
 -2298,  21669,  15107,  -1710,
 -2292,  21585,  15196,  -1720,
 -2287,  21500,  15285,  -1730,
 -2282,  21416,  15374,  -1740,
 -2276,  21331,  15463,  -1750,
 -2271,  21246,  15552,  -1759,
 -2265,  21162,  15640,  -1769,
 -2259,  21077,  15729,  -1778,
 -2254,  20991,  15818,  -1788,
 -2248,  20906,  15907,  -1797,
 -2242,  20821,  15996,  -1807,
 -2236,  20735,  16085,  -1816,
 -2230,  20650,  16174,  -1826,
 -2223,  20564,  16263,  -1835,
 -2217,  20478,  16351,  -1844,
 -2211,  20392,  16440,  -1854,
 -2204,  20306,  16529,  -1863,
 -2198,  20220,  16618,  -1872,
 -2191,  20133,  16707,  -1881,
 -2185,  20047,  16796,  -1890,
 -2178,  19960,  16884,  -1899,
 -2171,  19874,  16973,  -1908,
 -2164,  19787,  17062,  -1917,
 -2157,  19700,  17151,  -1926,
 -2150,  19613,  17239,  -1935,
 -2143,  19526,  17328,  -1943,
 -2136,  19439,  17416,  -1952,
 -2128,  19352,  17505,  -1961,
 -2121,  19265,  17593,  -1969,
 -2114,  19178,  17682,  -1978,
 -2106,  19090,  17770,  -1986,
 -2099,  19003,  17859,  -1995,
 -2091,  18915,  17947,  -2003,
 -2083,  18827,  18035,  -2011,
 -2076,  18740,  18124,  -2020,
 -2068,  18652,  18212,  -2028,
 -2060,  18564,  18300,  -2036,
 -2052,  18476,  18388,  -2044,
 -2044,  18388,  18476,  -2052,
 -2036,  18300,  18564,  -2060,
 -2028,  18212,  18652,  -2068,
 -2020,  18124,  18740,  -2076,
 -2011,  18035,  18827,  -2083,
 -2003,  17947,  18915,  -2091,
 -1995,  17859,  19003,  -2099,
 -1986,  17770,  19090,  -2106,
 -1978,  17682,  19178,  -2114,
 -1969,  17593,  19265,  -2121,
 -1961,  17505,  19352,  -2128,
 -1952,  17416,  19439,  -2136,
 -1943,  17328,  19526,  -2143,
 -1935,  17239,  19613,  -2150,
 -1926,  17151,  19700,  -2157,
 -1917,  17062,  19787,  -2164,
 -1908,  16973,  19874,  -2171,
 -1899,  16884,  19960,  -2178,
 -1890,  16796,  20047,  -2185,
 -1881,  16707,  20133,  -2191,
 -1872,  16618,  20220,  -2198,
 -1863,  16529,  20306,  -2204,
 -1854,  16440,  20392,  -2211,
 -1844,  16351,  20478,  -2217,
 -1835,  16263,  20564,  -2223,
 -1826,  16174,  20650,  -2230,
 -1816,  16085,  20735,  -2236,
 -1807,  15996,  20821,  -2242,
 -1797,  15907,  20906,  -2248,
 -1788,  15818,  20991,  -2254,
 -1778,  15729,  21077,  -2259,
 -1769,  15640,  21162,  -2265,
 -1759,  15552,  21246,  -2271,
 -1750,  15463,  21331,  -2276,
 -1740,  15374,  21416,  -2282,
 -1730,  15285,  21500,  -2287,
 -1720,  15196,  21585,  -2292,
 -1710,  15107,  21669,  -2298,
 -1701,  15019,  21753,  -2303,
 -1691,  14930,  21837,  -2308,
 -1681,  14841,  21920,  -2313,
 -1671,  14752,  22004,  -2317,
 -1661,  14664,  22087,  -2322,
 -1651,  14575,  22171,  -2327,
 -1641,  14486,  22254,  -2331,
 -1631,  14398,  22337,  -2336,
 -1621,  14309,  22420,  -2340,
 -1611,  14221,  22502,  -2344,
 -1600,  14132,  22585,  -2349,
 -1590,  14044,  22667,  -2353,
 -1580,  13955,  22749,  -2357,
 -1570,  13867,  22831,  -2360,
 -1560,  13779,  22913,  -2364,
 -1549,  13691,  22994,  -2368,
 -1539,  13602,  23076,  -2371,
 -1529,  13514,  23157,  -2375,
 -1518,  13426,  23238,  -2378,
 -1508,  13338,  23319,  -2381,
 -1497,  13250,  23400,  -2385,
 -1487,  13163,  23480,  -2388,
 -1477,  13075,  23561,  -2391,
 -1466,  12987,  23641,  -2393,
 -1456,  12899,  23721,  -2396,
 -1445,  12812,  23800,  -2399,
 -1435,  12724,  23880,  -2401,
 -1424,  12637,  23959,  -2404,
 -1414,  12549,  24038,  -2406,
 -1403,  12462,  24117,  -2408,
 -1393,  12375,  24196,  -2410,
 -1382,  12288,  24274,  -2412,
 -1371,  12201,  24352,  -2414,
 -1361,  12114,  24430,  -2416,
 -1350,  12027,  24508,  -2417,
 -1340,  11941,  24586,  -2419,
 -1329,  11854,  24663,  -2420,
 -1318,  11767,  24740,  -2421,
 -1308,  11681,  24817,  -2422,
 -1297,  11595,  24894,  -2423,
 -1286,  11509,  24970,  -2424,
 -1276,  11422,  25046,  -2425,
 -1265,  11337,  25122,  -2426,
 -1255,  11251,  25198,  -2426,
 -1244,  11165,  25274,  -2427,
 -1233,  11079,  25349,  -2427,
 -1223,  10994,  25424,  -2427,
 -1212,  10908,  25499,  -2427,
 -1201,  10823,  25573,  -2427,
 -1191,  10738,  25647,  -2427,
 -1180,  10653,  25721,  -2427,
 -1169,  10568,  25795,  -2426,
 -1159,  10483,  25869,  -2426,
 -1148,  10399,  25942,  -2425,
 -1137,  10314,  26015,  -2424,
 -1127,  10230,  26087,  -2423,
 -1116,  10146,  26160,  -2422,
 -1105,  10062,  26232,  -2421,
 -1095,   9978,  26304,  -2419,
 -1084,   9894,  26376,  -2418,
 -1073,   9811,  26447,  -2416,
 -1063,   9727,  26518,  -2414,
 -1052,   9644,  26589,  -2412,
 -1042,   9561,  26659,  -2410,
 -1031,   9478,  26729,  -2408,
 -1021,   9395,  26799,  -2406,
 -1010,   9313,  26869,  -2403,
 -1000,   9230,  26938,  -2401,
  -989,   9148,  27007,  -2398,
  -979,   9066,  27076,  -2395,
  -968,   8984,  27144,  -2392,
  -958,   8902,  27212,  -2389,
  -947,   8821,  27280,  -2386,
  -937,   8739,  27348,  -2382,
  -926,   8658,  27415,  -2379,
  -916,   8577,  27482,  -2375,
  -906,   8496,  27549,  -2371,
  -895,   8415,  27615,  -2367,
  -885,   8335,  27681,  -2363,
  -875,   8255,  27746,  -2359,
  -864,   8175,  27812,  -2354,
  -854,   8095,  27877,  -2349,
  -844,   8015,  27941,  -2345,
  -834,   7936,  28006,  -2340,
  -823,   7856,  28070,  -2335,
  -813,   7777,  28134,  -2329,
  -803,   7698,  28197,  -2324,
  -793,   7620,  28260,  -2319,
  -783,   7541,  28323,  -2313,
  -773,   7463,  28385,  -2307,
  -763,   7385,  28447,  -2301,
  -753,   7307,  28509,  -2295,
  -743,   7230,  28570,  -2289,
  -733,   7152,  28631,  -2282,
  -723,   7075,  28691,  -2275,
  -713,   6998,  28752,  -2269,
  -704,   6922,  28812,  -2262,
  -694,   6845,  28871,  -2255,
  -684,   6769,  28930,  -2247,
  -675,   6693,  28989,  -2240,
  -665,   6617,  29048,  -2232,
  -655,   6542,  29106,  -2224,
  -646,   6467,  29163,  -2217,
  -636,   6392,  29221,  -2208,
  -627,   6317,  29278,  -2200,
  -617,   6243,  29334,  -2192,
  -608,   6168,  29391,  -2183,
  -598,   6094,  29446,  -2174,
  -589,   6021,  29502,  -2165,
  -580,   5947,  29557,  -2156,
  -571,   5874,  29612,  -2147,
  -561,   5801,  29666,  -2138,
  -552,   5729,  29720,  -2128,
  -543,   5656,  29773,  -2118,
  -534,   5584,  29826,  -2108,
  -525,   5512,  29879,  -2098,
  -516,   5441,  29931,  -2088,
  -507,   5369,  29983,  -2077,
  -499,   5298,  30035,  -2067,
  -490,   5228,  30086,  -2056,
  -481,   5157,  30137,  -2045,
  -472,   5087,  30187,  -2034,
  -464,   5017,  30237,  -2022,
  -455,   4948,  30286,  -2011,
  -447,   4878,  30335,  -1999,
  -438,   4809,  30384,  -1987,
  -430,   4741,  30432,  -1975,
  -421,   4672,  30480,  -1963,
  -413,   4604,  30527,  -1950,
  -405,   4536,  30574,  -1938,
  -397,   4469,  30621,  -1925,
  -389,   4402,  30667,  -1912,
  -381,   4335,  30712,  -1899,
  -373,   4268,  30758,  -1885,
  -365,   4202,  30802,  -1872,
  -357,   4136,  30847,  -1858,
  -349,   4070,  30891,  -1844,
  -341,   4005,  30934,  -1830,
  -334,   3940,  30977,  -1815,
  -326,   3875,  31019,  -1801,
  -319,   3811,  31062,  -1786,
  -311,   3747,  31103,  -1771,
  -304,   3683,  31144,  -1756,
  -296,   3620,  31185,  -1741,
  -289,   3557,  31225,  -1725,
  -282,   3495,  31265,  -1709,
  -275,   3432,  31304,  -1694,
  -268,   3370,  31343,  -1677,
  -261,   3309,  31381,  -1661,
  -254,   3247,  31419,  -1645,
  -247,   3186,  31457,  -1628,
  -240,   3126,  31494,  -1611,
  -234,   3066,  31530,  -1594,
  -227,   3006,  31566,  -1577,
  -221,   2946,  31602,  -1559,
  -214,   2887,  31637,  -1542,
  -208,   2828,  31671,  -1524,
  -202,   2770,  31705,  -1506,
  -196,   2712,  31739,  -1487,
  -189,   2654,  31772,  -1469,
  -183,   2597,  31804,  -1450,
  -177,   2540,  31836,  -1431,
  -172,   2483,  31868,  -1412,
  -166,   2427,  31899,  -1392,
  -160,   2371,  31930,  -1373,
  -155,   2316,  31960,  -1353,
  -149,   2261,  31989,  -1333,
  -144,   2206,  32018,  -1313,
  -138,   2152,  32047,  -1293,
  -133,   2098,  32075,  -1272,
  -128,   2045,  32102,  -1251,
  -123,   1992,  32129,  -1230,
  -118,   1939,  32156,  -1209,
  -113,   1887,  32181,  -1187,
  -108,   1835,  32207,  -1166,
  -104,   1783,  32232,  -1144,
   -99,   1732,  32256,  -1121,
   -94,   1682,  32280,  -1099,
   -90,   1631,  32303,  -1076,
   -86,   1582,  32326,  -1054,
   -81,   1532,  32348,  -1031,
   -77,   1483,  32369,  -1007,
   -73,   1435,  32391,   -984,
   -69,   1387,  32411,   -960,
   -66,   1339,  32431,   -936,
   -62,   1291,  32450,   -912,
   -58,   1245,  32469,   -888,
   -55,   1198,  32488,   -863,
   -51,   1152,  32505,   -838,
   -48,   1107,  32523,   -813,
   -45,   1061,  32539,   -788,
   -42,   1017,  32555,   -762,
   -39,    972,  32571,   -737,
   -36,    929,  32586,   -711,
   -33,    885,  32600,   -685,
   -30,    842,  32614,   -658,
   -28,    800,  32627,   -631,
   -25,    758,  32640,   -605,
   -23,    716,  32652,   -577,
   -21,    675,  32663,   -550,
   -18,    635,  32674,   -522,
   -16,    594,  32685,   -495,
   -15,    555,  32694,   -466,
   -13,    515,  32703,   -438,
   -11,    477,  32712,   -410,
   -10,    438,  32720,   -381,
    -8,    401,  32727,   -352,
    -7,    363,  32734,   -322,
    -6,    326,  32740,   -293,
    -4,    290,  32746,   -263,
    -3,    254,  32751,   -233,
    -3,    218,  32755,   -203,
    -2,    184,  32759,   -172,
    -1,    149,  32762,   -141,
    -1,    115,  32764,   -110,
     0,     82,  32766,    -79,
     0,     49,  32767,    -48,
     0,     16,  32767,    -16,
};

const union table mlib_filters_s16_bc_3[] = {
   -16,    -16,    -16,
 32767,  32767,  32767,
    16,     16,     16,
     0,      0,      0,
   -48,    -48,    -48,
 32767,  32767,  32767,
    49,     49,     49,
     0,      0,      0,
   -79,    -79,    -79,
 32766,  32766,  32766,
    82,     82,     82,
     0,      0,      0,
  -110,   -110,   -110,
 32764,  32764,  32764,
   115,    115,    115,
    -1,     -1,     -1,
  -141,   -141,   -141,
 32762,  32762,  32762,
   149,    149,    149,
    -1,     -1,     -1,
  -172,   -172,   -172,
 32759,  32759,  32759,
   184,    184,    184,
    -2,     -2,     -2,
  -203,   -203,   -203,
 32755,  32755,  32755,
   218,    218,    218,
    -3,     -3,     -3,
  -233,   -233,   -233,
 32751,  32751,  32751,
   254,    254,    254,
    -3,     -3,     -3,
  -263,   -263,   -263,
 32746,  32746,  32746,
   290,    290,    290,
    -4,     -4,     -4,
  -293,   -293,   -293,
 32740,  32740,  32740,
   326,    326,    326,
    -6,     -6,     -6,
  -322,   -322,   -322,
 32734,  32734,  32734,
   363,    363,    363,
    -7,     -7,     -7,
  -352,   -352,   -352,
 32727,  32727,  32727,
   401,    401,    401,
    -8,     -8,     -8,
  -381,   -381,   -381,
 32720,  32720,  32720,
   438,    438,    438,
   -10,    -10,    -10,
  -410,   -410,   -410,
 32712,  32712,  32712,
   477,    477,    477,
   -11,    -11,    -11,
  -438,   -438,   -438,
 32703,  32703,  32703,
   515,    515,    515,
   -13,    -13,    -13,
  -466,   -466,   -466,
 32694,  32694,  32694,
   555,    555,    555,
   -15,    -15,    -15,
  -495,   -495,   -495,
 32685,  32685,  32685,
   594,    594,    594,
   -16,    -16,    -16,
  -522,   -522,   -522,
 32674,  32674,  32674,
   635,    635,    635,
   -18,    -18,    -18,
  -550,   -550,   -550,
 32663,  32663,  32663,
   675,    675,    675,
   -21,    -21,    -21,
  -577,   -577,   -577,
 32652,  32652,  32652,
   716,    716,    716,
   -23,    -23,    -23,
  -605,   -605,   -605,
 32640,  32640,  32640,
   758,    758,    758,
   -25,    -25,    -25,
  -631,   -631,   -631,
 32627,  32627,  32627,
   800,    800,    800,
   -28,    -28,    -28,
  -658,   -658,   -658,
 32614,  32614,  32614,
   842,    842,    842,
   -30,    -30,    -30,
  -685,   -685,   -685,
 32600,  32600,  32600,
   885,    885,    885,
   -33,    -33,    -33,
  -711,   -711,   -711,
 32586,  32586,  32586,
   929,    929,    929,
   -36,    -36,    -36,
  -737,   -737,   -737,
 32571,  32571,  32571,
   972,    972,    972,
   -39,    -39,    -39,
  -762,   -762,   -762,
 32555,  32555,  32555,
  1017,   1017,   1017,
   -42,    -42,    -42,
  -788,   -788,   -788,
 32539,  32539,  32539,
  1061,   1061,   1061,
   -45,    -45,    -45,
  -813,   -813,   -813,
 32523,  32523,  32523,
  1107,   1107,   1107,
   -48,    -48,    -48,
  -838,   -838,   -838,
 32505,  32505,  32505,
  1152,   1152,   1152,
   -51,    -51,    -51,
  -863,   -863,   -863,
 32488,  32488,  32488,
  1198,   1198,   1198,
   -55,    -55,    -55,
  -888,   -888,   -888,
 32469,  32469,  32469,
  1245,   1245,   1245,
   -58,    -58,    -58,
  -912,   -912,   -912,
 32450,  32450,  32450,
  1291,   1291,   1291,
   -62,    -62,    -62,
  -936,   -936,   -936,
 32431,  32431,  32431,
  1339,   1339,   1339,
   -66,    -66,    -66,
  -960,   -960,   -960,
 32411,  32411,  32411,
  1387,   1387,   1387,
   -69,    -69,    -69,
  -984,   -984,   -984,
 32391,  32391,  32391,
  1435,   1435,   1435,
   -73,    -73,    -73,
 -1007,  -1007,  -1007,
 32369,  32369,  32369,
  1483,   1483,   1483,
   -77,    -77,    -77,
 -1031,  -1031,  -1031,
 32348,  32348,  32348,
  1532,   1532,   1532,
   -81,    -81,    -81,
 -1054,  -1054,  -1054,
 32326,  32326,  32326,
  1582,   1582,   1582,
   -86,    -86,    -86,
 -1076,  -1076,  -1076,
 32303,  32303,  32303,
  1631,   1631,   1631,
   -90,    -90,    -90,
 -1099,  -1099,  -1099,
 32280,  32280,  32280,
  1682,   1682,   1682,
   -94,    -94,    -94,
 -1121,  -1121,  -1121,
 32256,  32256,  32256,
  1732,   1732,   1732,
   -99,    -99,    -99,
 -1144,  -1144,  -1144,
 32232,  32232,  32232,
  1783,   1783,   1783,
  -104,   -104,   -104,
 -1166,  -1166,  -1166,
 32207,  32207,  32207,
  1835,   1835,   1835,
  -108,   -108,   -108,
 -1187,  -1187,  -1187,
 32181,  32181,  32181,
  1887,   1887,   1887,
  -113,   -113,   -113,
 -1209,  -1209,  -1209,
 32156,  32156,  32156,
  1939,   1939,   1939,
  -118,   -118,   -118,
 -1230,  -1230,  -1230,
 32129,  32129,  32129,
  1992,   1992,   1992,
  -123,   -123,   -123,
 -1251,  -1251,  -1251,
 32102,  32102,  32102,
  2045,   2045,   2045,
  -128,   -128,   -128,
 -1272,  -1272,  -1272,
 32075,  32075,  32075,
  2098,   2098,   2098,
  -133,   -133,   -133,
 -1293,  -1293,  -1293,
 32047,  32047,  32047,
  2152,   2152,   2152,
  -138,   -138,   -138,
 -1313,  -1313,  -1313,
 32018,  32018,  32018,
  2206,   2206,   2206,
  -144,   -144,   -144,
 -1333,  -1333,  -1333,
 31989,  31989,  31989,
  2261,   2261,   2261,
  -149,   -149,   -149,
 -1353,  -1353,  -1353,
 31960,  31960,  31960,
  2316,   2316,   2316,
  -155,   -155,   -155,
 -1373,  -1373,  -1373,
 31930,  31930,  31930,
  2371,   2371,   2371,
  -160,   -160,   -160,
 -1392,  -1392,  -1392,
 31899,  31899,  31899,
  2427,   2427,   2427,
  -166,   -166,   -166,
 -1412,  -1412,  -1412,
 31868,  31868,  31868,
  2483,   2483,   2483,
  -172,   -172,   -172,
 -1431,  -1431,  -1431,
 31836,  31836,  31836,
  2540,   2540,   2540,
  -177,   -177,   -177,
 -1450,  -1450,  -1450,
 31804,  31804,  31804,
  2597,   2597,   2597,
  -183,   -183,   -183,
 -1469,  -1469,  -1469,
 31772,  31772,  31772,
  2654,   2654,   2654,
  -189,   -189,   -189,
 -1487,  -1487,  -1487,
 31739,  31739,  31739,
  2712,   2712,   2712,
  -196,   -196,   -196,
 -1506,  -1506,  -1506,
 31705,  31705,  31705,
  2770,   2770,   2770,
  -202,   -202,   -202,
 -1524,  -1524,  -1524,
 31671,  31671,  31671,
  2828,   2828,   2828,
  -208,   -208,   -208,
 -1542,  -1542,  -1542,
 31637,  31637,  31637,
  2887,   2887,   2887,
  -214,   -214,   -214,
 -1559,  -1559,  -1559,
 31602,  31602,  31602,
  2946,   2946,   2946,
  -221,   -221,   -221,
 -1577,  -1577,  -1577,
 31566,  31566,  31566,
  3006,   3006,   3006,
  -227,   -227,   -227,
 -1594,  -1594,  -1594,
 31530,  31530,  31530,
  3066,   3066,   3066,
  -234,   -234,   -234,
 -1611,  -1611,  -1611,
 31494,  31494,  31494,
  3126,   3126,   3126,
  -240,   -240,   -240,
 -1628,  -1628,  -1628,
 31457,  31457,  31457,
  3186,   3186,   3186,
  -247,   -247,   -247,
 -1645,  -1645,  -1645,
 31419,  31419,  31419,
  3247,   3247,   3247,
  -254,   -254,   -254,
 -1661,  -1661,  -1661,
 31381,  31381,  31381,
  3309,   3309,   3309,
  -261,   -261,   -261,
 -1677,  -1677,  -1677,
 31343,  31343,  31343,
  3370,   3370,   3370,
  -268,   -268,   -268,
 -1694,  -1694,  -1694,
 31304,  31304,  31304,
  3432,   3432,   3432,
  -275,   -275,   -275,
 -1709,  -1709,  -1709,
 31265,  31265,  31265,
  3495,   3495,   3495,
  -282,   -282,   -282,
 -1725,  -1725,  -1725,
 31225,  31225,  31225,
  3557,   3557,   3557,
  -289,   -289,   -289,
 -1741,  -1741,  -1741,
 31185,  31185,  31185,
  3620,   3620,   3620,
  -296,   -296,   -296,
 -1756,  -1756,  -1756,
 31144,  31144,  31144,
  3683,   3683,   3683,
  -304,   -304,   -304,
 -1771,  -1771,  -1771,
 31103,  31103,  31103,
  3747,   3747,   3747,
  -311,   -311,   -311,
 -1786,  -1786,  -1786,
 31062,  31062,  31062,
  3811,   3811,   3811,
  -319,   -319,   -319,
 -1801,  -1801,  -1801,
 31019,  31019,  31019,
  3875,   3875,   3875,
  -326,   -326,   -326,
 -1815,  -1815,  -1815,
 30977,  30977,  30977,
  3940,   3940,   3940,
  -334,   -334,   -334,
 -1830,  -1830,  -1830,
 30934,  30934,  30934,
  4005,   4005,   4005,
  -341,   -341,   -341,
 -1844,  -1844,  -1844,
 30891,  30891,  30891,
  4070,   4070,   4070,
  -349,   -349,   -349,
 -1858,  -1858,  -1858,
 30847,  30847,  30847,
  4136,   4136,   4136,
  -357,   -357,   -357,
 -1872,  -1872,  -1872,
 30802,  30802,  30802,
  4202,   4202,   4202,
  -365,   -365,   -365,
 -1885,  -1885,  -1885,
 30758,  30758,  30758,
  4268,   4268,   4268,
  -373,   -373,   -373,
 -1899,  -1899,  -1899,
 30712,  30712,  30712,
  4335,   4335,   4335,
  -381,   -381,   -381,
 -1912,  -1912,  -1912,
 30667,  30667,  30667,
  4402,   4402,   4402,
  -389,   -389,   -389,
 -1925,  -1925,  -1925,
 30621,  30621,  30621,
  4469,   4469,   4469,
  -397,   -397,   -397,
 -1938,  -1938,  -1938,
 30574,  30574,  30574,
  4536,   4536,   4536,
  -405,   -405,   -405,
 -1950,  -1950,  -1950,
 30527,  30527,  30527,
  4604,   4604,   4604,
  -413,   -413,   -413,
 -1963,  -1963,  -1963,
 30480,  30480,  30480,
  4672,   4672,   4672,
  -421,   -421,   -421,
 -1975,  -1975,  -1975,
 30432,  30432,  30432,
  4741,   4741,   4741,
  -430,   -430,   -430,
 -1987,  -1987,  -1987,
 30384,  30384,  30384,
  4809,   4809,   4809,
  -438,   -438,   -438,
 -1999,  -1999,  -1999,
 30335,  30335,  30335,
  4878,   4878,   4878,
  -447,   -447,   -447,
 -2011,  -2011,  -2011,
 30286,  30286,  30286,
  4948,   4948,   4948,
  -455,   -455,   -455,
 -2022,  -2022,  -2022,
 30237,  30237,  30237,
  5017,   5017,   5017,
  -464,   -464,   -464,
 -2034,  -2034,  -2034,
 30187,  30187,  30187,
  5087,   5087,   5087,
  -472,   -472,   -472,
 -2045,  -2045,  -2045,
 30137,  30137,  30137,
  5157,   5157,   5157,
  -481,   -481,   -481,
 -2056,  -2056,  -2056,
 30086,  30086,  30086,
  5228,   5228,   5228,
  -490,   -490,   -490,
 -2067,  -2067,  -2067,
 30035,  30035,  30035,
  5298,   5298,   5298,
  -499,   -499,   -499,
 -2077,  -2077,  -2077,
 29983,  29983,  29983,
  5369,   5369,   5369,
  -507,   -507,   -507,
 -2088,  -2088,  -2088,
 29931,  29931,  29931,
  5441,   5441,   5441,
  -516,   -516,   -516,
 -2098,  -2098,  -2098,
 29879,  29879,  29879,
  5512,   5512,   5512,
  -525,   -525,   -525,
 -2108,  -2108,  -2108,
 29826,  29826,  29826,
  5584,   5584,   5584,
  -534,   -534,   -534,
 -2118,  -2118,  -2118,
 29773,  29773,  29773,
  5656,   5656,   5656,
  -543,   -543,   -543,
 -2128,  -2128,  -2128,
 29720,  29720,  29720,
  5729,   5729,   5729,
  -552,   -552,   -552,
 -2138,  -2138,  -2138,
 29666,  29666,  29666,
  5801,   5801,   5801,
  -561,   -561,   -561,
 -2147,  -2147,  -2147,
 29612,  29612,  29612,
  5874,   5874,   5874,
  -571,   -571,   -571,
 -2156,  -2156,  -2156,
 29557,  29557,  29557,
  5947,   5947,   5947,
  -580,   -580,   -580,
 -2165,  -2165,  -2165,
 29502,  29502,  29502,
  6021,   6021,   6021,
  -589,   -589,   -589,
 -2174,  -2174,  -2174,
 29446,  29446,  29446,
  6094,   6094,   6094,
  -598,   -598,   -598,
 -2183,  -2183,  -2183,
 29391,  29391,  29391,
  6168,   6168,   6168,
  -608,   -608,   -608,
 -2192,  -2192,  -2192,
 29334,  29334,  29334,
  6243,   6243,   6243,
  -617,   -617,   -617,
 -2200,  -2200,  -2200,
 29278,  29278,  29278,
  6317,   6317,   6317,
  -627,   -627,   -627,
 -2208,  -2208,  -2208,
 29221,  29221,  29221,
  6392,   6392,   6392,
  -636,   -636,   -636,
 -2217,  -2217,  -2217,
 29163,  29163,  29163,
  6467,   6467,   6467,
  -646,   -646,   -646,
 -2224,  -2224,  -2224,
 29106,  29106,  29106,
  6542,   6542,   6542,
  -655,   -655,   -655,
 -2232,  -2232,  -2232,
 29048,  29048,  29048,
  6617,   6617,   6617,
  -665,   -665,   -665,
 -2240,  -2240,  -2240,
 28989,  28989,  28989,
  6693,   6693,   6693,
  -675,   -675,   -675,
 -2247,  -2247,  -2247,
 28930,  28930,  28930,
  6769,   6769,   6769,
  -684,   -684,   -684,
 -2255,  -2255,  -2255,
 28871,  28871,  28871,
  6845,   6845,   6845,
  -694,   -694,   -694,
 -2262,  -2262,  -2262,
 28812,  28812,  28812,
  6922,   6922,   6922,
  -704,   -704,   -704,
 -2269,  -2269,  -2269,
 28752,  28752,  28752,
  6998,   6998,   6998,
  -713,   -713,   -713,
 -2275,  -2275,  -2275,
 28691,  28691,  28691,
  7075,   7075,   7075,
  -723,   -723,   -723,
 -2282,  -2282,  -2282,
 28631,  28631,  28631,
  7152,   7152,   7152,
  -733,   -733,   -733,
 -2289,  -2289,  -2289,
 28570,  28570,  28570,
  7230,   7230,   7230,
  -743,   -743,   -743,
 -2295,  -2295,  -2295,
 28509,  28509,  28509,
  7307,   7307,   7307,
  -753,   -753,   -753,
 -2301,  -2301,  -2301,
 28447,  28447,  28447,
  7385,   7385,   7385,
  -763,   -763,   -763,
 -2307,  -2307,  -2307,
 28385,  28385,  28385,
  7463,   7463,   7463,
  -773,   -773,   -773,
 -2313,  -2313,  -2313,
 28323,  28323,  28323,
  7541,   7541,   7541,
  -783,   -783,   -783,
 -2319,  -2319,  -2319,
 28260,  28260,  28260,
  7620,   7620,   7620,
  -793,   -793,   -793,
 -2324,  -2324,  -2324,
 28197,  28197,  28197,
  7698,   7698,   7698,
  -803,   -803,   -803,
 -2329,  -2329,  -2329,
 28134,  28134,  28134,
  7777,   7777,   7777,
  -813,   -813,   -813,
 -2335,  -2335,  -2335,
 28070,  28070,  28070,
  7856,   7856,   7856,
  -823,   -823,   -823,
 -2340,  -2340,  -2340,
 28006,  28006,  28006,
  7936,   7936,   7936,
  -834,   -834,   -834,
 -2345,  -2345,  -2345,
 27941,  27941,  27941,
  8015,   8015,   8015,
  -844,   -844,   -844,
 -2349,  -2349,  -2349,
 27877,  27877,  27877,
  8095,   8095,   8095,
  -854,   -854,   -854,
 -2354,  -2354,  -2354,
 27812,  27812,  27812,
  8175,   8175,   8175,
  -864,   -864,   -864,
 -2359,  -2359,  -2359,
 27746,  27746,  27746,
  8255,   8255,   8255,
  -875,   -875,   -875,
 -2363,  -2363,  -2363,
 27681,  27681,  27681,
  8335,   8335,   8335,
  -885,   -885,   -885,
 -2367,  -2367,  -2367,
 27615,  27615,  27615,
  8415,   8415,   8415,
  -895,   -895,   -895,
 -2371,  -2371,  -2371,
 27549,  27549,  27549,
  8496,   8496,   8496,
  -906,   -906,   -906,
 -2375,  -2375,  -2375,
 27482,  27482,  27482,
  8577,   8577,   8577,
  -916,   -916,   -916,
 -2379,  -2379,  -2379,
 27415,  27415,  27415,
  8658,   8658,   8658,
  -926,   -926,   -926,
 -2382,  -2382,  -2382,
 27348,  27348,  27348,
  8739,   8739,   8739,
  -937,   -937,   -937,
 -2386,  -2386,  -2386,
 27280,  27280,  27280,
  8821,   8821,   8821,
  -947,   -947,   -947,
 -2389,  -2389,  -2389,
 27212,  27212,  27212,
  8902,   8902,   8902,
  -958,   -958,   -958,
 -2392,  -2392,  -2392,
 27144,  27144,  27144,
  8984,   8984,   8984,
  -968,   -968,   -968,
 -2395,  -2395,  -2395,
 27076,  27076,  27076,
  9066,   9066,   9066,
  -979,   -979,   -979,
 -2398,  -2398,  -2398,
 27007,  27007,  27007,
  9148,   9148,   9148,
  -989,   -989,   -989,
 -2401,  -2401,  -2401,
 26938,  26938,  26938,
  9230,   9230,   9230,
 -1000,  -1000,  -1000,
 -2403,  -2403,  -2403,
 26869,  26869,  26869,
  9313,   9313,   9313,
 -1010,  -1010,  -1010,
 -2406,  -2406,  -2406,
 26799,  26799,  26799,
  9395,   9395,   9395,
 -1021,  -1021,  -1021,
 -2408,  -2408,  -2408,
 26729,  26729,  26729,
  9478,   9478,   9478,
 -1031,  -1031,  -1031,
 -2410,  -2410,  -2410,
 26659,  26659,  26659,
  9561,   9561,   9561,
 -1042,  -1042,  -1042,
 -2412,  -2412,  -2412,
 26589,  26589,  26589,
  9644,   9644,   9644,
 -1052,  -1052,  -1052,
 -2414,  -2414,  -2414,
 26518,  26518,  26518,
  9727,   9727,   9727,
 -1063,  -1063,  -1063,
 -2416,  -2416,  -2416,
 26447,  26447,  26447,
  9811,   9811,   9811,
 -1073,  -1073,  -1073,
 -2418,  -2418,  -2418,
 26376,  26376,  26376,
  9894,   9894,   9894,
 -1084,  -1084,  -1084,
 -2419,  -2419,  -2419,
 26304,  26304,  26304,
  9978,   9978,   9978,
 -1095,  -1095,  -1095,
 -2421,  -2421,  -2421,
 26232,  26232,  26232,
 10062,  10062,  10062,
 -1105,  -1105,  -1105,
 -2422,  -2422,  -2422,
 26160,  26160,  26160,
 10146,  10146,  10146,
 -1116,  -1116,  -1116,
 -2423,  -2423,  -2423,
 26087,  26087,  26087,
 10230,  10230,  10230,
 -1127,  -1127,  -1127,
 -2424,  -2424,  -2424,
 26015,  26015,  26015,
 10314,  10314,  10314,
 -1137,  -1137,  -1137,
 -2425,  -2425,  -2425,
 25942,  25942,  25942,
 10399,  10399,  10399,
 -1148,  -1148,  -1148,
 -2426,  -2426,  -2426,
 25869,  25869,  25869,
 10483,  10483,  10483,
 -1159,  -1159,  -1159,
 -2426,  -2426,  -2426,
 25795,  25795,  25795,
 10568,  10568,  10568,
 -1169,  -1169,  -1169,
 -2427,  -2427,  -2427,
 25721,  25721,  25721,
 10653,  10653,  10653,
 -1180,  -1180,  -1180,
 -2427,  -2427,  -2427,
 25647,  25647,  25647,
 10738,  10738,  10738,
 -1191,  -1191,  -1191,
 -2427,  -2427,  -2427,
 25573,  25573,  25573,
 10823,  10823,  10823,
 -1201,  -1201,  -1201,
 -2427,  -2427,  -2427,
 25499,  25499,  25499,
 10908,  10908,  10908,
 -1212,  -1212,  -1212,
 -2427,  -2427,  -2427,
 25424,  25424,  25424,
 10994,  10994,  10994,
 -1223,  -1223,  -1223,
 -2427,  -2427,  -2427,
 25349,  25349,  25349,
 11079,  11079,  11079,
 -1233,  -1233,  -1233,
 -2427,  -2427,  -2427,
 25274,  25274,  25274,
 11165,  11165,  11165,
 -1244,  -1244,  -1244,
 -2426,  -2426,  -2426,
 25198,  25198,  25198,
 11251,  11251,  11251,
 -1255,  -1255,  -1255,
 -2426,  -2426,  -2426,
 25122,  25122,  25122,
 11337,  11337,  11337,
 -1265,  -1265,  -1265,
 -2425,  -2425,  -2425,
 25046,  25046,  25046,
 11422,  11422,  11422,
 -1276,  -1276,  -1276,
 -2424,  -2424,  -2424,
 24970,  24970,  24970,
 11509,  11509,  11509,
 -1286,  -1286,  -1286,
 -2423,  -2423,  -2423,
 24894,  24894,  24894,
 11595,  11595,  11595,
 -1297,  -1297,  -1297,
 -2422,  -2422,  -2422,
 24817,  24817,  24817,
 11681,  11681,  11681,
 -1308,  -1308,  -1308,
 -2421,  -2421,  -2421,
 24740,  24740,  24740,
 11767,  11767,  11767,
 -1318,  -1318,  -1318,
 -2420,  -2420,  -2420,
 24663,  24663,  24663,
 11854,  11854,  11854,
 -1329,  -1329,  -1329,
 -2419,  -2419,  -2419,
 24586,  24586,  24586,
 11941,  11941,  11941,
 -1340,  -1340,  -1340,
 -2417,  -2417,  -2417,
 24508,  24508,  24508,
 12027,  12027,  12027,
 -1350,  -1350,  -1350,
 -2416,  -2416,  -2416,
 24430,  24430,  24430,
 12114,  12114,  12114,
 -1361,  -1361,  -1361,
 -2414,  -2414,  -2414,
 24352,  24352,  24352,
 12201,  12201,  12201,
 -1371,  -1371,  -1371,
 -2412,  -2412,  -2412,
 24274,  24274,  24274,
 12288,  12288,  12288,
 -1382,  -1382,  -1382,
 -2410,  -2410,  -2410,
 24196,  24196,  24196,
 12375,  12375,  12375,
 -1393,  -1393,  -1393,
 -2408,  -2408,  -2408,
 24117,  24117,  24117,
 12462,  12462,  12462,
 -1403,  -1403,  -1403,
 -2406,  -2406,  -2406,
 24038,  24038,  24038,
 12549,  12549,  12549,
 -1414,  -1414,  -1414,
 -2404,  -2404,  -2404,
 23959,  23959,  23959,
 12637,  12637,  12637,
 -1424,  -1424,  -1424,
 -2401,  -2401,  -2401,
 23880,  23880,  23880,
 12724,  12724,  12724,
 -1435,  -1435,  -1435,
 -2399,  -2399,  -2399,
 23800,  23800,  23800,
 12812,  12812,  12812,
 -1445,  -1445,  -1445,
 -2396,  -2396,  -2396,
 23721,  23721,  23721,
 12899,  12899,  12899,
 -1456,  -1456,  -1456,
 -2393,  -2393,  -2393,
 23641,  23641,  23641,
 12987,  12987,  12987,
 -1466,  -1466,  -1466,
 -2391,  -2391,  -2391,
 23561,  23561,  23561,
 13075,  13075,  13075,
 -1477,  -1477,  -1477,
 -2388,  -2388,  -2388,
 23480,  23480,  23480,
 13163,  13163,  13163,
 -1487,  -1487,  -1487,
 -2385,  -2385,  -2385,
 23400,  23400,  23400,
 13250,  13250,  13250,
 -1497,  -1497,  -1497,
 -2381,  -2381,  -2381,
 23319,  23319,  23319,
 13338,  13338,  13338,
 -1508,  -1508,  -1508,
 -2378,  -2378,  -2378,
 23238,  23238,  23238,
 13426,  13426,  13426,
 -1518,  -1518,  -1518,
 -2375,  -2375,  -2375,
 23157,  23157,  23157,
 13514,  13514,  13514,
 -1529,  -1529,  -1529,
 -2371,  -2371,  -2371,
 23076,  23076,  23076,
 13602,  13602,  13602,
 -1539,  -1539,  -1539,
 -2368,  -2368,  -2368,
 22994,  22994,  22994,
 13691,  13691,  13691,
 -1549,  -1549,  -1549,
 -2364,  -2364,  -2364,
 22913,  22913,  22913,
 13779,  13779,  13779,
 -1560,  -1560,  -1560,
 -2360,  -2360,  -2360,
 22831,  22831,  22831,
 13867,  13867,  13867,
 -1570,  -1570,  -1570,
 -2357,  -2357,  -2357,
 22749,  22749,  22749,
 13955,  13955,  13955,
 -1580,  -1580,  -1580,
 -2353,  -2353,  -2353,
 22667,  22667,  22667,
 14044,  14044,  14044,
 -1590,  -1590,  -1590,
 -2349,  -2349,  -2349,
 22585,  22585,  22585,
 14132,  14132,  14132,
 -1600,  -1600,  -1600,
 -2344,  -2344,  -2344,
 22502,  22502,  22502,
 14221,  14221,  14221,
 -1611,  -1611,  -1611,
 -2340,  -2340,  -2340,
 22420,  22420,  22420,
 14309,  14309,  14309,
 -1621,  -1621,  -1621,
 -2336,  -2336,  -2336,
 22337,  22337,  22337,
 14398,  14398,  14398,
 -1631,  -1631,  -1631,
 -2331,  -2331,  -2331,
 22254,  22254,  22254,
 14486,  14486,  14486,
 -1641,  -1641,  -1641,
 -2327,  -2327,  -2327,
 22171,  22171,  22171,
 14575,  14575,  14575,
 -1651,  -1651,  -1651,
 -2322,  -2322,  -2322,
 22087,  22087,  22087,
 14664,  14664,  14664,
 -1661,  -1661,  -1661,
 -2317,  -2317,  -2317,
 22004,  22004,  22004,
 14752,  14752,  14752,
 -1671,  -1671,  -1671,
 -2313,  -2313,  -2313,
 21920,  21920,  21920,
 14841,  14841,  14841,
 -1681,  -1681,  -1681,
 -2308,  -2308,  -2308,
 21837,  21837,  21837,
 14930,  14930,  14930,
 -1691,  -1691,  -1691,
 -2303,  -2303,  -2303,
 21753,  21753,  21753,
 15019,  15019,  15019,
 -1701,  -1701,  -1701,
 -2298,  -2298,  -2298,
 21669,  21669,  21669,
 15107,  15107,  15107,
 -1710,  -1710,  -1710,
 -2292,  -2292,  -2292,
 21585,  21585,  21585,
 15196,  15196,  15196,
 -1720,  -1720,  -1720,
 -2287,  -2287,  -2287,
 21500,  21500,  21500,
 15285,  15285,  15285,
 -1730,  -1730,  -1730,
 -2282,  -2282,  -2282,
 21416,  21416,  21416,
 15374,  15374,  15374,
 -1740,  -1740,  -1740,
 -2276,  -2276,  -2276,
 21331,  21331,  21331,
 15463,  15463,  15463,
 -1750,  -1750,  -1750,
 -2271,  -2271,  -2271,
 21246,  21246,  21246,
 15552,  15552,  15552,
 -1759,  -1759,  -1759,
 -2265,  -2265,  -2265,
 21162,  21162,  21162,
 15640,  15640,  15640,
 -1769,  -1769,  -1769,
 -2259,  -2259,  -2259,
 21077,  21077,  21077,
 15729,  15729,  15729,
 -1778,  -1778,  -1778,
 -2254,  -2254,  -2254,
 20991,  20991,  20991,
 15818,  15818,  15818,
 -1788,  -1788,  -1788,
 -2248,  -2248,  -2248,
 20906,  20906,  20906,
 15907,  15907,  15907,
 -1797,  -1797,  -1797,
 -2242,  -2242,  -2242,
 20821,  20821,  20821,
 15996,  15996,  15996,
 -1807,  -1807,  -1807,
 -2236,  -2236,  -2236,
 20735,  20735,  20735,
 16085,  16085,  16085,
 -1816,  -1816,  -1816,
 -2230,  -2230,  -2230,
 20650,  20650,  20650,
 16174,  16174,  16174,
 -1826,  -1826,  -1826,
 -2223,  -2223,  -2223,
 20564,  20564,  20564,
 16263,  16263,  16263,
 -1835,  -1835,  -1835,
 -2217,  -2217,  -2217,
 20478,  20478,  20478,
 16351,  16351,  16351,
 -1844,  -1844,  -1844,
 -2211,  -2211,  -2211,
 20392,  20392,  20392,
 16440,  16440,  16440,
 -1854,  -1854,  -1854,
 -2204,  -2204,  -2204,
 20306,  20306,  20306,
 16529,  16529,  16529,
 -1863,  -1863,  -1863,
 -2198,  -2198,  -2198,
 20220,  20220,  20220,
 16618,  16618,  16618,
 -1872,  -1872,  -1872,
 -2191,  -2191,  -2191,
 20133,  20133,  20133,
 16707,  16707,  16707,
 -1881,  -1881,  -1881,
 -2185,  -2185,  -2185,
 20047,  20047,  20047,
 16796,  16796,  16796,
 -1890,  -1890,  -1890,
 -2178,  -2178,  -2178,
 19960,  19960,  19960,
 16884,  16884,  16884,
 -1899,  -1899,  -1899,
 -2171,  -2171,  -2171,
 19874,  19874,  19874,
 16973,  16973,  16973,
 -1908,  -1908,  -1908,
 -2164,  -2164,  -2164,
 19787,  19787,  19787,
 17062,  17062,  17062,
 -1917,  -1917,  -1917,
 -2157,  -2157,  -2157,
 19700,  19700,  19700,
 17151,  17151,  17151,
 -1926,  -1926,  -1926,
 -2150,  -2150,  -2150,
 19613,  19613,  19613,
 17239,  17239,  17239,
 -1935,  -1935,  -1935,
 -2143,  -2143,  -2143,
 19526,  19526,  19526,
 17328,  17328,  17328,
 -1943,  -1943,  -1943,
 -2136,  -2136,  -2136,
 19439,  19439,  19439,
 17416,  17416,  17416,
 -1952,  -1952,  -1952,
 -2128,  -2128,  -2128,
 19352,  19352,  19352,
 17505,  17505,  17505,
 -1961,  -1961,  -1961,
 -2121,  -2121,  -2121,
 19265,  19265,  19265,
 17593,  17593,  17593,
 -1969,  -1969,  -1969,
 -2114,  -2114,  -2114,
 19178,  19178,  19178,
 17682,  17682,  17682,
 -1978,  -1978,  -1978,
 -2106,  -2106,  -2106,
 19090,  19090,  19090,
 17770,  17770,  17770,
 -1986,  -1986,  -1986,
 -2099,  -2099,  -2099,
 19003,  19003,  19003,
 17859,  17859,  17859,
 -1995,  -1995,  -1995,
 -2091,  -2091,  -2091,
 18915,  18915,  18915,
 17947,  17947,  17947,
 -2003,  -2003,  -2003,
 -2083,  -2083,  -2083,
 18827,  18827,  18827,
 18035,  18035,  18035,
 -2011,  -2011,  -2011,
 -2076,  -2076,  -2076,
 18740,  18740,  18740,
 18124,  18124,  18124,
 -2020,  -2020,  -2020,
 -2068,  -2068,  -2068,
 18652,  18652,  18652,
 18212,  18212,  18212,
 -2028,  -2028,  -2028,
 -2060,  -2060,  -2060,
 18564,  18564,  18564,
 18300,  18300,  18300,
 -2036,  -2036,  -2036,
 -2052,  -2052,  -2052,
 18476,  18476,  18476,
 18388,  18388,  18388,
 -2044,  -2044,  -2044,
 -2044,  -2044,  -2044,
 18388,  18388,  18388,
 18476,  18476,  18476,
 -2052,  -2052,  -2052,
 -2036,  -2036,  -2036,
 18300,  18300,  18300,
 18564,  18564,  18564,
 -2060,  -2060,  -2060,
 -2028,  -2028,  -2028,
 18212,  18212,  18212,
 18652,  18652,  18652,
 -2068,  -2068,  -2068,
 -2020,  -2020,  -2020,
 18124,  18124,  18124,
 18740,  18740,  18740,
 -2076,  -2076,  -2076,
 -2011,  -2011,  -2011,
 18035,  18035,  18035,
 18827,  18827,  18827,
 -2083,  -2083,  -2083,
 -2003,  -2003,  -2003,
 17947,  17947,  17947,
 18915,  18915,  18915,
 -2091,  -2091,  -2091,
 -1995,  -1995,  -1995,
 17859,  17859,  17859,
 19003,  19003,  19003,
 -2099,  -2099,  -2099,
 -1986,  -1986,  -1986,
 17770,  17770,  17770,
 19090,  19090,  19090,
 -2106,  -2106,  -2106,
 -1978,  -1978,  -1978,
 17682,  17682,  17682,
 19178,  19178,  19178,
 -2114,  -2114,  -2114,
 -1969,  -1969,  -1969,
 17593,  17593,  17593,
 19265,  19265,  19265,
 -2121,  -2121,  -2121,
 -1961,  -1961,  -1961,
 17505,  17505,  17505,
 19352,  19352,  19352,
 -2128,  -2128,  -2128,
 -1952,  -1952,  -1952,
 17416,  17416,  17416,
 19439,  19439,  19439,
 -2136,  -2136,  -2136,
 -1943,  -1943,  -1943,
 17328,  17328,  17328,
 19526,  19526,  19526,
 -2143,  -2143,  -2143,
 -1935,  -1935,  -1935,
 17239,  17239,  17239,
 19613,  19613,  19613,
 -2150,  -2150,  -2150,
 -1926,  -1926,  -1926,
 17151,  17151,  17151,
 19700,  19700,  19700,
 -2157,  -2157,  -2157,
 -1917,  -1917,  -1917,
 17062,  17062,  17062,
 19787,  19787,  19787,
 -2164,  -2164,  -2164,
 -1908,  -1908,  -1908,
 16973,  16973,  16973,
 19874,  19874,  19874,
 -2171,  -2171,  -2171,
 -1899,  -1899,  -1899,
 16884,  16884,  16884,
 19960,  19960,  19960,
 -2178,  -2178,  -2178,
 -1890,  -1890,  -1890,
 16796,  16796,  16796,
 20047,  20047,  20047,
 -2185,  -2185,  -2185,
 -1881,  -1881,  -1881,
 16707,  16707,  16707,
 20133,  20133,  20133,
 -2191,  -2191,  -2191,
 -1872,  -1872,  -1872,
 16618,  16618,  16618,
 20220,  20220,  20220,
 -2198,  -2198,  -2198,
 -1863,  -1863,  -1863,
 16529,  16529,  16529,
 20306,  20306,  20306,
 -2204,  -2204,  -2204,
 -1854,  -1854,  -1854,
 16440,  16440,  16440,
 20392,  20392,  20392,
 -2211,  -2211,  -2211,
 -1844,  -1844,  -1844,
 16351,  16351,  16351,
 20478,  20478,  20478,
 -2217,  -2217,  -2217,
 -1835,  -1835,  -1835,
 16263,  16263,  16263,
 20564,  20564,  20564,
 -2223,  -2223,  -2223,
 -1826,  -1826,  -1826,
 16174,  16174,  16174,
 20650,  20650,  20650,
 -2230,  -2230,  -2230,
 -1816,  -1816,  -1816,
 16085,  16085,  16085,
 20735,  20735,  20735,
 -2236,  -2236,  -2236,
 -1807,  -1807,  -1807,
 15996,  15996,  15996,
 20821,  20821,  20821,
 -2242,  -2242,  -2242,
 -1797,  -1797,  -1797,
 15907,  15907,  15907,
 20906,  20906,  20906,
 -2248,  -2248,  -2248,
 -1788,  -1788,  -1788,
 15818,  15818,  15818,
 20991,  20991,  20991,
 -2254,  -2254,  -2254,
 -1778,  -1778,  -1778,
 15729,  15729,  15729,
 21077,  21077,  21077,
 -2259,  -2259,  -2259,
 -1769,  -1769,  -1769,
 15640,  15640,  15640,
 21162,  21162,  21162,
 -2265,  -2265,  -2265,
 -1759,  -1759,  -1759,
 15552,  15552,  15552,
 21246,  21246,  21246,
 -2271,  -2271,  -2271,
 -1750,  -1750,  -1750,
 15463,  15463,  15463,
 21331,  21331,  21331,
 -2276,  -2276,  -2276,
 -1740,  -1740,  -1740,
 15374,  15374,  15374,
 21416,  21416,  21416,
 -2282,  -2282,  -2282,
 -1730,  -1730,  -1730,
 15285,  15285,  15285,
 21500,  21500,  21500,
 -2287,  -2287,  -2287,
 -1720,  -1720,  -1720,
 15196,  15196,  15196,
 21585,  21585,  21585,
 -2292,  -2292,  -2292,
 -1710,  -1710,  -1710,
 15107,  15107,  15107,
 21669,  21669,  21669,
 -2298,  -2298,  -2298,
 -1701,  -1701,  -1701,
 15019,  15019,  15019,
 21753,  21753,  21753,
 -2303,  -2303,  -2303,
 -1691,  -1691,  -1691,
 14930,  14930,  14930,
 21837,  21837,  21837,
 -2308,  -2308,  -2308,
 -1681,  -1681,  -1681,
 14841,  14841,  14841,
 21920,  21920,  21920,
 -2313,  -2313,  -2313,
 -1671,  -1671,  -1671,
 14752,  14752,  14752,
 22004,  22004,  22004,
 -2317,  -2317,  -2317,
 -1661,  -1661,  -1661,
 14664,  14664,  14664,
 22087,  22087,  22087,
 -2322,  -2322,  -2322,
 -1651,  -1651,  -1651,
 14575,  14575,  14575,
 22171,  22171,  22171,
 -2327,  -2327,  -2327,
 -1641,  -1641,  -1641,
 14486,  14486,  14486,
 22254,  22254,  22254,
 -2331,  -2331,  -2331,
 -1631,  -1631,  -1631,
 14398,  14398,  14398,
 22337,  22337,  22337,
 -2336,  -2336,  -2336,
 -1621,  -1621,  -1621,
 14309,  14309,  14309,
 22420,  22420,  22420,
 -2340,  -2340,  -2340,
 -1611,  -1611,  -1611,
 14221,  14221,  14221,
 22502,  22502,  22502,
 -2344,  -2344,  -2344,
 -1600,  -1600,  -1600,
 14132,  14132,  14132,
 22585,  22585,  22585,
 -2349,  -2349,  -2349,
 -1590,  -1590,  -1590,
 14044,  14044,  14044,
 22667,  22667,  22667,
 -2353,  -2353,  -2353,
 -1580,  -1580,  -1580,
 13955,  13955,  13955,
 22749,  22749,  22749,
 -2357,  -2357,  -2357,
 -1570,  -1570,  -1570,
 13867,  13867,  13867,
 22831,  22831,  22831,
 -2360,  -2360,  -2360,
 -1560,  -1560,  -1560,
 13779,  13779,  13779,
 22913,  22913,  22913,
 -2364,  -2364,  -2364,
 -1549,  -1549,  -1549,
 13691,  13691,  13691,
 22994,  22994,  22994,
 -2368,  -2368,  -2368,
 -1539,  -1539,  -1539,
 13602,  13602,  13602,
 23076,  23076,  23076,
 -2371,  -2371,  -2371,
 -1529,  -1529,  -1529,
 13514,  13514,  13514,
 23157,  23157,  23157,
 -2375,  -2375,  -2375,
 -1518,  -1518,  -1518,
 13426,  13426,  13426,
 23238,  23238,  23238,
 -2378,  -2378,  -2378,
 -1508,  -1508,  -1508,
 13338,  13338,  13338,
 23319,  23319,  23319,
 -2381,  -2381,  -2381,
 -1497,  -1497,  -1497,
 13250,  13250,  13250,
 23400,  23400,  23400,
 -2385,  -2385,  -2385,
 -1487,  -1487,  -1487,
 13163,  13163,  13163,
 23480,  23480,  23480,
 -2388,  -2388,  -2388,
 -1477,  -1477,  -1477,
 13075,  13075,  13075,
 23561,  23561,  23561,
 -2391,  -2391,  -2391,
 -1466,  -1466,  -1466,
 12987,  12987,  12987,
 23641,  23641,  23641,
 -2393,  -2393,  -2393,
 -1456,  -1456,  -1456,
 12899,  12899,  12899,
 23721,  23721,  23721,
 -2396,  -2396,  -2396,
 -1445,  -1445,  -1445,
 12812,  12812,  12812,
 23800,  23800,  23800,
 -2399,  -2399,  -2399,
 -1435,  -1435,  -1435,
 12724,  12724,  12724,
 23880,  23880,  23880,
 -2401,  -2401,  -2401,
 -1424,  -1424,  -1424,
 12637,  12637,  12637,
 23959,  23959,  23959,
 -2404,  -2404,  -2404,
 -1414,  -1414,  -1414,
 12549,  12549,  12549,
 24038,  24038,  24038,
 -2406,  -2406,  -2406,
 -1403,  -1403,  -1403,
 12462,  12462,  12462,
 24117,  24117,  24117,
 -2408,  -2408,  -2408,
 -1393,  -1393,  -1393,
 12375,  12375,  12375,
 24196,  24196,  24196,
 -2410,  -2410,  -2410,
 -1382,  -1382,  -1382,
 12288,  12288,  12288,
 24274,  24274,  24274,
 -2412,  -2412,  -2412,
 -1371,  -1371,  -1371,
 12201,  12201,  12201,
 24352,  24352,  24352,
 -2414,  -2414,  -2414,
 -1361,  -1361,  -1361,
 12114,  12114,  12114,
 24430,  24430,  24430,
 -2416,  -2416,  -2416,
 -1350,  -1350,  -1350,
 12027,  12027,  12027,
 24508,  24508,  24508,
 -2417,  -2417,  -2417,
 -1340,  -1340,  -1340,
 11941,  11941,  11941,
 24586,  24586,  24586,
 -2419,  -2419,  -2419,
 -1329,  -1329,  -1329,
 11854,  11854,  11854,
 24663,  24663,  24663,
 -2420,  -2420,  -2420,
 -1318,  -1318,  -1318,
 11767,  11767,  11767,
 24740,  24740,  24740,
 -2421,  -2421,  -2421,
 -1308,  -1308,  -1308,
 11681,  11681,  11681,
 24817,  24817,  24817,
 -2422,  -2422,  -2422,
 -1297,  -1297,  -1297,
 11595,  11595,  11595,
 24894,  24894,  24894,
 -2423,  -2423,  -2423,
 -1286,  -1286,  -1286,
 11509,  11509,  11509,
 24970,  24970,  24970,
 -2424,  -2424,  -2424,
 -1276,  -1276,  -1276,
 11422,  11422,  11422,
 25046,  25046,  25046,
 -2425,  -2425,  -2425,
 -1265,  -1265,  -1265,
 11337,  11337,  11337,
 25122,  25122,  25122,
 -2426,  -2426,  -2426,
 -1255,  -1255,  -1255,
 11251,  11251,  11251,
 25198,  25198,  25198,
 -2426,  -2426,  -2426,
 -1244,  -1244,  -1244,
 11165,  11165,  11165,
 25274,  25274,  25274,
 -2427,  -2427,  -2427,
 -1233,  -1233,  -1233,
 11079,  11079,  11079,
 25349,  25349,  25349,
 -2427,  -2427,  -2427,
 -1223,  -1223,  -1223,
 10994,  10994,  10994,
 25424,  25424,  25424,
 -2427,  -2427,  -2427,
 -1212,  -1212,  -1212,
 10908,  10908,  10908,
 25499,  25499,  25499,
 -2427,  -2427,  -2427,
 -1201,  -1201,  -1201,
 10823,  10823,  10823,
 25573,  25573,  25573,
 -2427,  -2427,  -2427,
 -1191,  -1191,  -1191,
 10738,  10738,  10738,
 25647,  25647,  25647,
 -2427,  -2427,  -2427,
 -1180,  -1180,  -1180,
 10653,  10653,  10653,
 25721,  25721,  25721,
 -2427,  -2427,  -2427,
 -1169,  -1169,  -1169,
 10568,  10568,  10568,
 25795,  25795,  25795,
 -2426,  -2426,  -2426,
 -1159,  -1159,  -1159,
 10483,  10483,  10483,
 25869,  25869,  25869,
 -2426,  -2426,  -2426,
 -1148,  -1148,  -1148,
 10399,  10399,  10399,
 25942,  25942,  25942,
 -2425,  -2425,  -2425,
 -1137,  -1137,  -1137,
 10314,  10314,  10314,
 26015,  26015,  26015,
 -2424,  -2424,  -2424,
 -1127,  -1127,  -1127,
 10230,  10230,  10230,
 26087,  26087,  26087,
 -2423,  -2423,  -2423,
 -1116,  -1116,  -1116,
 10146,  10146,  10146,
 26160,  26160,  26160,
 -2422,  -2422,  -2422,
 -1105,  -1105,  -1105,
 10062,  10062,  10062,
 26232,  26232,  26232,
 -2421,  -2421,  -2421,
 -1095,  -1095,  -1095,
  9978,   9978,   9978,
 26304,  26304,  26304,
 -2419,  -2419,  -2419,
 -1084,  -1084,  -1084,
  9894,   9894,   9894,
 26376,  26376,  26376,
 -2418,  -2418,  -2418,
 -1073,  -1073,  -1073,
  9811,   9811,   9811,
 26447,  26447,  26447,
 -2416,  -2416,  -2416,
 -1063,  -1063,  -1063,
  9727,   9727,   9727,
 26518,  26518,  26518,
 -2414,  -2414,  -2414,
 -1052,  -1052,  -1052,
  9644,   9644,   9644,
 26589,  26589,  26589,
 -2412,  -2412,  -2412,
 -1042,  -1042,  -1042,
  9561,   9561,   9561,
 26659,  26659,  26659,
 -2410,  -2410,  -2410,
 -1031,  -1031,  -1031,
  9478,   9478,   9478,
 26729,  26729,  26729,
 -2408,  -2408,  -2408,
 -1021,  -1021,  -1021,
  9395,   9395,   9395,
 26799,  26799,  26799,
 -2406,  -2406,  -2406,
 -1010,  -1010,  -1010,
  9313,   9313,   9313,
 26869,  26869,  26869,
 -2403,  -2403,  -2403,
 -1000,  -1000,  -1000,
  9230,   9230,   9230,
 26938,  26938,  26938,
 -2401,  -2401,  -2401,
  -989,   -989,   -989,
  9148,   9148,   9148,
 27007,  27007,  27007,
 -2398,  -2398,  -2398,
  -979,   -979,   -979,
  9066,   9066,   9066,
 27076,  27076,  27076,
 -2395,  -2395,  -2395,
  -968,   -968,   -968,
  8984,   8984,   8984,
 27144,  27144,  27144,
 -2392,  -2392,  -2392,
  -958,   -958,   -958,
  8902,   8902,   8902,
 27212,  27212,  27212,
 -2389,  -2389,  -2389,
  -947,   -947,   -947,
  8821,   8821,   8821,
 27280,  27280,  27280,
 -2386,  -2386,  -2386,
  -937,   -937,   -937,
  8739,   8739,   8739,
 27348,  27348,  27348,
 -2382,  -2382,  -2382,
  -926,   -926,   -926,
  8658,   8658,   8658,
 27415,  27415,  27415,
 -2379,  -2379,  -2379,
  -916,   -916,   -916,
  8577,   8577,   8577,
 27482,  27482,  27482,
 -2375,  -2375,  -2375,
  -906,   -906,   -906,
  8496,   8496,   8496,
 27549,  27549,  27549,
 -2371,  -2371,  -2371,
  -895,   -895,   -895,
  8415,   8415,   8415,
 27615,  27615,  27615,
 -2367,  -2367,  -2367,
  -885,   -885,   -885,
  8335,   8335,   8335,
 27681,  27681,  27681,
 -2363,  -2363,  -2363,
  -875,   -875,   -875,
  8255,   8255,   8255,
 27746,  27746,  27746,
 -2359,  -2359,  -2359,
  -864,   -864,   -864,
  8175,   8175,   8175,
 27812,  27812,  27812,
 -2354,  -2354,  -2354,
  -854,   -854,   -854,
  8095,   8095,   8095,
 27877,  27877,  27877,
 -2349,  -2349,  -2349,
  -844,   -844,   -844,
  8015,   8015,   8015,
 27941,  27941,  27941,
 -2345,  -2345,  -2345,
  -834,   -834,   -834,
  7936,   7936,   7936,
 28006,  28006,  28006,
 -2340,  -2340,  -2340,
  -823,   -823,   -823,
  7856,   7856,   7856,
 28070,  28070,  28070,
 -2335,  -2335,  -2335,
  -813,   -813,   -813,
  7777,   7777,   7777,
 28134,  28134,  28134,
 -2329,  -2329,  -2329,
  -803,   -803,   -803,
  7698,   7698,   7698,
 28197,  28197,  28197,
 -2324,  -2324,  -2324,
  -793,   -793,   -793,
  7620,   7620,   7620,
 28260,  28260,  28260,
 -2319,  -2319,  -2319,
  -783,   -783,   -783,
  7541,   7541,   7541,
 28323,  28323,  28323,
 -2313,  -2313,  -2313,
  -773,   -773,   -773,
  7463,   7463,   7463,
 28385,  28385,  28385,
 -2307,  -2307,  -2307,
  -763,   -763,   -763,
  7385,   7385,   7385,
 28447,  28447,  28447,
 -2301,  -2301,  -2301,
  -753,   -753,   -753,
  7307,   7307,   7307,
 28509,  28509,  28509,
 -2295,  -2295,  -2295,
  -743,   -743,   -743,
  7230,   7230,   7230,
 28570,  28570,  28570,
 -2289,  -2289,  -2289,
  -733,   -733,   -733,
  7152,   7152,   7152,
 28631,  28631,  28631,
 -2282,  -2282,  -2282,
  -723,   -723,   -723,
  7075,   7075,   7075,
 28691,  28691,  28691,
 -2275,  -2275,  -2275,
  -713,   -713,   -713,
  6998,   6998,   6998,
 28752,  28752,  28752,
 -2269,  -2269,  -2269,
  -704,   -704,   -704,
  6922,   6922,   6922,
 28812,  28812,  28812,
 -2262,  -2262,  -2262,
  -694,   -694,   -694,
  6845,   6845,   6845,
 28871,  28871,  28871,
 -2255,  -2255,  -2255,
  -684,   -684,   -684,
  6769,   6769,   6769,
 28930,  28930,  28930,
 -2247,  -2247,  -2247,
  -675,   -675,   -675,
  6693,   6693,   6693,
 28989,  28989,  28989,
 -2240,  -2240,  -2240,
  -665,   -665,   -665,
  6617,   6617,   6617,
 29048,  29048,  29048,
 -2232,  -2232,  -2232,
  -655,   -655,   -655,
  6542,   6542,   6542,
 29106,  29106,  29106,
 -2224,  -2224,  -2224,
  -646,   -646,   -646,
  6467,   6467,   6467,
 29163,  29163,  29163,
 -2217,  -2217,  -2217,
  -636,   -636,   -636,
  6392,   6392,   6392,
 29221,  29221,  29221,
 -2208,  -2208,  -2208,
  -627,   -627,   -627,
  6317,   6317,   6317,
 29278,  29278,  29278,
 -2200,  -2200,  -2200,
  -617,   -617,   -617,
  6243,   6243,   6243,
 29334,  29334,  29334,
 -2192,  -2192,  -2192,
  -608,   -608,   -608,
  6168,   6168,   6168,
 29391,  29391,  29391,
 -2183,  -2183,  -2183,
  -598,   -598,   -598,
  6094,   6094,   6094,
 29446,  29446,  29446,
 -2174,  -2174,  -2174,
  -589,   -589,   -589,
  6021,   6021,   6021,
 29502,  29502,  29502,
 -2165,  -2165,  -2165,
  -580,   -580,   -580,
  5947,   5947,   5947,
 29557,  29557,  29557,
 -2156,  -2156,  -2156,
  -571,   -571,   -571,
  5874,   5874,   5874,
 29612,  29612,  29612,
 -2147,  -2147,  -2147,
  -561,   -561,   -561,
  5801,   5801,   5801,
 29666,  29666,  29666,
 -2138,  -2138,  -2138,
  -552,   -552,   -552,
  5729,   5729,   5729,
 29720,  29720,  29720,
 -2128,  -2128,  -2128,
  -543,   -543,   -543,
  5656,   5656,   5656,
 29773,  29773,  29773,
 -2118,  -2118,  -2118,
  -534,   -534,   -534,
  5584,   5584,   5584,
 29826,  29826,  29826,
 -2108,  -2108,  -2108,
  -525,   -525,   -525,
  5512,   5512,   5512,
 29879,  29879,  29879,
 -2098,  -2098,  -2098,
  -516,   -516,   -516,
  5441,   5441,   5441,
 29931,  29931,  29931,
 -2088,  -2088,  -2088,
  -507,   -507,   -507,
  5369,   5369,   5369,
 29983,  29983,  29983,
 -2077,  -2077,  -2077,
  -499,   -499,   -499,
  5298,   5298,   5298,
 30035,  30035,  30035,
 -2067,  -2067,  -2067,
  -490,   -490,   -490,
  5228,   5228,   5228,
 30086,  30086,  30086,
 -2056,  -2056,  -2056,
  -481,   -481,   -481,
  5157,   5157,   5157,
 30137,  30137,  30137,
 -2045,  -2045,  -2045,
  -472,   -472,   -472,
  5087,   5087,   5087,
 30187,  30187,  30187,
 -2034,  -2034,  -2034,
  -464,   -464,   -464,
  5017,   5017,   5017,
 30237,  30237,  30237,
 -2022,  -2022,  -2022,
  -455,   -455,   -455,
  4948,   4948,   4948,
 30286,  30286,  30286,
 -2011,  -2011,  -2011,
  -447,   -447,   -447,
  4878,   4878,   4878,
 30335,  30335,  30335,
 -1999,  -1999,  -1999,
  -438,   -438,   -438,
  4809,   4809,   4809,
 30384,  30384,  30384,
 -1987,  -1987,  -1987,
  -430,   -430,   -430,
  4741,   4741,   4741,
 30432,  30432,  30432,
 -1975,  -1975,  -1975,
  -421,   -421,   -421,
  4672,   4672,   4672,
 30480,  30480,  30480,
 -1963,  -1963,  -1963,
  -413,   -413,   -413,
  4604,   4604,   4604,
 30527,  30527,  30527,
 -1950,  -1950,  -1950,
  -405,   -405,   -405,
  4536,   4536,   4536,
 30574,  30574,  30574,
 -1938,  -1938,  -1938,
  -397,   -397,   -397,
  4469,   4469,   4469,
 30621,  30621,  30621,
 -1925,  -1925,  -1925,
  -389,   -389,   -389,
  4402,   4402,   4402,
 30667,  30667,  30667,
 -1912,  -1912,  -1912,
  -381,   -381,   -381,
  4335,   4335,   4335,
 30712,  30712,  30712,
 -1899,  -1899,  -1899,
  -373,   -373,   -373,
  4268,   4268,   4268,
 30758,  30758,  30758,
 -1885,  -1885,  -1885,
  -365,   -365,   -365,
  4202,   4202,   4202,
 30802,  30802,  30802,
 -1872,  -1872,  -1872,
  -357,   -357,   -357,
  4136,   4136,   4136,
 30847,  30847,  30847,
 -1858,  -1858,  -1858,
  -349,   -349,   -349,
  4070,   4070,   4070,
 30891,  30891,  30891,
 -1844,  -1844,  -1844,
  -341,   -341,   -341,
  4005,   4005,   4005,
 30934,  30934,  30934,
 -1830,  -1830,  -1830,
  -334,   -334,   -334,
  3940,   3940,   3940,
 30977,  30977,  30977,
 -1815,  -1815,  -1815,
  -326,   -326,   -326,
  3875,   3875,   3875,
 31019,  31019,  31019,
 -1801,  -1801,  -1801,
  -319,   -319,   -319,
  3811,   3811,   3811,
 31062,  31062,  31062,
 -1786,  -1786,  -1786,
  -311,   -311,   -311,
  3747,   3747,   3747,
 31103,  31103,  31103,
 -1771,  -1771,  -1771,
  -304,   -304,   -304,
  3683,   3683,   3683,
 31144,  31144,  31144,
 -1756,  -1756,  -1756,
  -296,   -296,   -296,
  3620,   3620,   3620,
 31185,  31185,  31185,
 -1741,  -1741,  -1741,
  -289,   -289,   -289,
  3557,   3557,   3557,
 31225,  31225,  31225,
 -1725,  -1725,  -1725,
  -282,   -282,   -282,
  3495,   3495,   3495,
 31265,  31265,  31265,
 -1709,  -1709,  -1709,
  -275,   -275,   -275,
  3432,   3432,   3432,
 31304,  31304,  31304,
 -1694,  -1694,  -1694,
  -268,   -268,   -268,
  3370,   3370,   3370,
 31343,  31343,  31343,
 -1677,  -1677,  -1677,
  -261,   -261,   -261,
  3309,   3309,   3309,
 31381,  31381,  31381,
 -1661,  -1661,  -1661,
  -254,   -254,   -254,
  3247,   3247,   3247,
 31419,  31419,  31419,
 -1645,  -1645,  -1645,
  -247,   -247,   -247,
  3186,   3186,   3186,
 31457,  31457,  31457,
 -1628,  -1628,  -1628,
  -240,   -240,   -240,
  3126,   3126,   3126,
 31494,  31494,  31494,
 -1611,  -1611,  -1611,
  -234,   -234,   -234,
  3066,   3066,   3066,
 31530,  31530,  31530,
 -1594,  -1594,  -1594,
  -227,   -227,   -227,
  3006,   3006,   3006,
 31566,  31566,  31566,
 -1577,  -1577,  -1577,
  -221,   -221,   -221,
  2946,   2946,   2946,
 31602,  31602,  31602,
 -1559,  -1559,  -1559,
  -214,   -214,   -214,
  2887,   2887,   2887,
 31637,  31637,  31637,
 -1542,  -1542,  -1542,
  -208,   -208,   -208,
  2828,   2828,   2828,
 31671,  31671,  31671,
 -1524,  -1524,  -1524,
  -202,   -202,   -202,
  2770,   2770,   2770,
 31705,  31705,  31705,
 -1506,  -1506,  -1506,
  -196,   -196,   -196,
  2712,   2712,   2712,
 31739,  31739,  31739,
 -1487,  -1487,  -1487,
  -189,   -189,   -189,
  2654,   2654,   2654,
 31772,  31772,  31772,
 -1469,  -1469,  -1469,
  -183,   -183,   -183,
  2597,   2597,   2597,
 31804,  31804,  31804,
 -1450,  -1450,  -1450,
  -177,   -177,   -177,
  2540,   2540,   2540,
 31836,  31836,  31836,
 -1431,  -1431,  -1431,
  -172,   -172,   -172,
  2483,   2483,   2483,
 31868,  31868,  31868,
 -1412,  -1412,  -1412,
  -166,   -166,   -166,
  2427,   2427,   2427,
 31899,  31899,  31899,
 -1392,  -1392,  -1392,
  -160,   -160,   -160,
  2371,   2371,   2371,
 31930,  31930,  31930,
 -1373,  -1373,  -1373,
  -155,   -155,   -155,
  2316,   2316,   2316,
 31960,  31960,  31960,
 -1353,  -1353,  -1353,
  -149,   -149,   -149,
  2261,   2261,   2261,
 31989,  31989,  31989,
 -1333,  -1333,  -1333,
  -144,   -144,   -144,
  2206,   2206,   2206,
 32018,  32018,  32018,
 -1313,  -1313,  -1313,
  -138,   -138,   -138,
  2152,   2152,   2152,
 32047,  32047,  32047,
 -1293,  -1293,  -1293,
  -133,   -133,   -133,
  2098,   2098,   2098,
 32075,  32075,  32075,
 -1272,  -1272,  -1272,
  -128,   -128,   -128,
  2045,   2045,   2045,
 32102,  32102,  32102,
 -1251,  -1251,  -1251,
  -123,   -123,   -123,
  1992,   1992,   1992,
 32129,  32129,  32129,
 -1230,  -1230,  -1230,
  -118,   -118,   -118,
  1939,   1939,   1939,
 32156,  32156,  32156,
 -1209,  -1209,  -1209,
  -113,   -113,   -113,
  1887,   1887,   1887,
 32181,  32181,  32181,
 -1187,  -1187,  -1187,
  -108,   -108,   -108,
  1835,   1835,   1835,
 32207,  32207,  32207,
 -1166,  -1166,  -1166,
  -104,   -104,   -104,
  1783,   1783,   1783,
 32232,  32232,  32232,
 -1144,  -1144,  -1144,
   -99,    -99,    -99,
  1732,   1732,   1732,
 32256,  32256,  32256,
 -1121,  -1121,  -1121,
   -94,    -94,    -94,
  1682,   1682,   1682,
 32280,  32280,  32280,
 -1099,  -1099,  -1099,
   -90,    -90,    -90,
  1631,   1631,   1631,
 32303,  32303,  32303,
 -1076,  -1076,  -1076,
   -86,    -86,    -86,
  1582,   1582,   1582,
 32326,  32326,  32326,
 -1054,  -1054,  -1054,
   -81,    -81,    -81,
  1532,   1532,   1532,
 32348,  32348,  32348,
 -1031,  -1031,  -1031,
   -77,    -77,    -77,
  1483,   1483,   1483,
 32369,  32369,  32369,
 -1007,  -1007,  -1007,
   -73,    -73,    -73,
  1435,   1435,   1435,
 32391,  32391,  32391,
  -984,   -984,   -984,
   -69,    -69,    -69,
  1387,   1387,   1387,
 32411,  32411,  32411,
  -960,   -960,   -960,
   -66,    -66,    -66,
  1339,   1339,   1339,
 32431,  32431,  32431,
  -936,   -936,   -936,
   -62,    -62,    -62,
  1291,   1291,   1291,
 32450,  32450,  32450,
  -912,   -912,   -912,
   -58,    -58,    -58,
  1245,   1245,   1245,
 32469,  32469,  32469,
  -888,   -888,   -888,
   -55,    -55,    -55,
  1198,   1198,   1198,
 32488,  32488,  32488,
  -863,   -863,   -863,
   -51,    -51,    -51,
  1152,   1152,   1152,
 32505,  32505,  32505,
  -838,   -838,   -838,
   -48,    -48,    -48,
  1107,   1107,   1107,
 32523,  32523,  32523,
  -813,   -813,   -813,
   -45,    -45,    -45,
  1061,   1061,   1061,
 32539,  32539,  32539,
  -788,   -788,   -788,
   -42,    -42,    -42,
  1017,   1017,   1017,
 32555,  32555,  32555,
  -762,   -762,   -762,
   -39,    -39,    -39,
   972,    972,    972,
 32571,  32571,  32571,
  -737,   -737,   -737,
   -36,    -36,    -36,
   929,    929,    929,
 32586,  32586,  32586,
  -711,   -711,   -711,
   -33,    -33,    -33,
   885,    885,    885,
 32600,  32600,  32600,
  -685,   -685,   -685,
   -30,    -30,    -30,
   842,    842,    842,
 32614,  32614,  32614,
  -658,   -658,   -658,
   -28,    -28,    -28,
   800,    800,    800,
 32627,  32627,  32627,
  -631,   -631,   -631,
   -25,    -25,    -25,
   758,    758,    758,
 32640,  32640,  32640,
  -605,   -605,   -605,
   -23,    -23,    -23,
   716,    716,    716,
 32652,  32652,  32652,
  -577,   -577,   -577,
   -21,    -21,    -21,
   675,    675,    675,
 32663,  32663,  32663,
  -550,   -550,   -550,
   -18,    -18,    -18,
   635,    635,    635,
 32674,  32674,  32674,
  -522,   -522,   -522,
   -16,    -16,    -16,
   594,    594,    594,
 32685,  32685,  32685,
  -495,   -495,   -495,
   -15,    -15,    -15,
   555,    555,    555,
 32694,  32694,  32694,
  -466,   -466,   -466,
   -13,    -13,    -13,
   515,    515,    515,
 32703,  32703,  32703,
  -438,   -438,   -438,
   -11,    -11,    -11,
   477,    477,    477,
 32712,  32712,  32712,
  -410,   -410,   -410,
   -10,    -10,    -10,
   438,    438,    438,
 32720,  32720,  32720,
  -381,   -381,   -381,
    -8,     -8,     -8,
   401,    401,    401,
 32727,  32727,  32727,
  -352,   -352,   -352,
    -7,     -7,     -7,
   363,    363,    363,
 32734,  32734,  32734,
  -322,   -322,   -322,
    -6,     -6,     -6,
   326,    326,    326,
 32740,  32740,  32740,
  -293,   -293,   -293,
    -4,     -4,     -4,
   290,    290,    290,
 32746,  32746,  32746,
  -263,   -263,   -263,
    -3,     -3,     -3,
   254,    254,    254,
 32751,  32751,  32751,
  -233,   -233,   -233,
    -3,     -3,     -3,
   218,    218,    218,
 32755,  32755,  32755,
  -203,   -203,   -203,
    -2,     -2,     -2,
   184,    184,    184,
 32759,  32759,  32759,
  -172,   -172,   -172,
    -1,     -1,     -1,
   149,    149,    149,
 32762,  32762,  32762,
  -141,   -141,   -141,
    -1,     -1,     -1,
   115,    115,    115,
 32764,  32764,  32764,
  -110,   -110,   -110,
     0,      0,      0,
    82,     82,     82,
 32766,  32766,  32766,
   -79,    -79,    -79,
     0,      0,      0,
    49,     49,     49,
 32767,  32767,  32767,
   -48,    -48,    -48,
     0,      0,      0,
    16,     16,     16,
 32767,  32767,  32767,
   -16,    -16,    -16,
};

const union table mlib_filters_s16_bc_4[] = {
   -16,    -16,    -16,    -16,
 32767,  32767,  32767,  32767,
    16,     16,     16,     16,
     0,      0,      0,      0,
   -48,    -48,    -48,    -48,
 32767,  32767,  32767,  32767,
    49,     49,     49,     49,
     0,      0,      0,      0,
   -79,    -79,    -79,    -79,
 32766,  32766,  32766,  32766,
    82,     82,     82,     82,
     0,      0,      0,      0,
  -110,   -110,   -110,   -110,
 32764,  32764,  32764,  32764,
   115,    115,    115,    115,
    -1,     -1,     -1,     -1,
  -141,   -141,   -141,   -141,
 32762,  32762,  32762,  32762,
   149,    149,    149,    149,
    -1,     -1,     -1,     -1,
  -172,   -172,   -172,   -172,
 32759,  32759,  32759,  32759,
   184,    184,    184,    184,
    -2,     -2,     -2,     -2,
  -203,   -203,   -203,   -203,
 32755,  32755,  32755,  32755,
   218,    218,    218,    218,
    -3,     -3,     -3,     -3,
  -233,   -233,   -233,   -233,
 32751,  32751,  32751,  32751,
   254,    254,    254,    254,
    -3,     -3,     -3,     -3,
  -263,   -263,   -263,   -263,
 32746,  32746,  32746,  32746,
   290,    290,    290,    290,
    -4,     -4,     -4,     -4,
  -293,   -293,   -293,   -293,
 32740,  32740,  32740,  32740,
   326,    326,    326,    326,
    -6,     -6,     -6,     -6,
  -322,   -322,   -322,   -322,
 32734,  32734,  32734,  32734,
   363,    363,    363,    363,
    -7,     -7,     -7,     -7,
  -352,   -352,   -352,   -352,
 32727,  32727,  32727,  32727,
   401,    401,    401,    401,
    -8,     -8,     -8,     -8,
  -381,   -381,   -381,   -381,
 32720,  32720,  32720,  32720,
   438,    438,    438,    438,
   -10,    -10,    -10,    -10,
  -410,   -410,   -410,   -410,
 32712,  32712,  32712,  32712,
   477,    477,    477,    477,
   -11,    -11,    -11,    -11,
  -438,   -438,   -438,   -438,
 32703,  32703,  32703,  32703,
   515,    515,    515,    515,
   -13,    -13,    -13,    -13,
  -466,   -466,   -466,   -466,
 32694,  32694,  32694,  32694,
   555,    555,    555,    555,
   -15,    -15,    -15,    -15,
  -495,   -495,   -495,   -495,
 32685,  32685,  32685,  32685,
   594,    594,    594,    594,
   -16,    -16,    -16,    -16,
  -522,   -522,   -522,   -522,
 32674,  32674,  32674,  32674,
   635,    635,    635,    635,
   -18,    -18,    -18,    -18,
  -550,   -550,   -550,   -550,
 32663,  32663,  32663,  32663,
   675,    675,    675,    675,
   -21,    -21,    -21,    -21,
  -577,   -577,   -577,   -577,
 32652,  32652,  32652,  32652,
   716,    716,    716,    716,
   -23,    -23,    -23,    -23,
  -605,   -605,   -605,   -605,
 32640,  32640,  32640,  32640,
   758,    758,    758,    758,
   -25,    -25,    -25,    -25,
  -631,   -631,   -631,   -631,
 32627,  32627,  32627,  32627,
   800,    800,    800,    800,
   -28,    -28,    -28,    -28,
  -658,   -658,   -658,   -658,
 32614,  32614,  32614,  32614,
   842,    842,    842,    842,
   -30,    -30,    -30,    -30,
  -685,   -685,   -685,   -685,
 32600,  32600,  32600,  32600,
   885,    885,    885,    885,
   -33,    -33,    -33,    -33,
  -711,   -711,   -711,   -711,
 32586,  32586,  32586,  32586,
   929,    929,    929,    929,
   -36,    -36,    -36,    -36,
  -737,   -737,   -737,   -737,
 32571,  32571,  32571,  32571,
   972,    972,    972,    972,
   -39,    -39,    -39,    -39,
  -762,   -762,   -762,   -762,
 32555,  32555,  32555,  32555,
  1017,   1017,   1017,   1017,
   -42,    -42,    -42,    -42,
  -788,   -788,   -788,   -788,
 32539,  32539,  32539,  32539,
  1061,   1061,   1061,   1061,
   -45,    -45,    -45,    -45,
  -813,   -813,   -813,   -813,
 32523,  32523,  32523,  32523,
  1107,   1107,   1107,   1107,
   -48,    -48,    -48,    -48,
  -838,   -838,   -838,   -838,
 32505,  32505,  32505,  32505,
  1152,   1152,   1152,   1152,
   -51,    -51,    -51,    -51,
  -863,   -863,   -863,   -863,
 32488,  32488,  32488,  32488,
  1198,   1198,   1198,   1198,
   -55,    -55,    -55,    -55,
  -888,   -888,   -888,   -888,
 32469,  32469,  32469,  32469,
  1245,   1245,   1245,   1245,
   -58,    -58,    -58,    -58,
  -912,   -912,   -912,   -912,
 32450,  32450,  32450,  32450,
  1291,   1291,   1291,   1291,
   -62,    -62,    -62,    -62,
  -936,   -936,   -936,   -936,
 32431,  32431,  32431,  32431,
  1339,   1339,   1339,   1339,
   -66,    -66,    -66,    -66,
  -960,   -960,   -960,   -960,
 32411,  32411,  32411,  32411,
  1387,   1387,   1387,   1387,
   -69,    -69,    -69,    -69,
  -984,   -984,   -984,   -984,
 32391,  32391,  32391,  32391,
  1435,   1435,   1435,   1435,
   -73,    -73,    -73,    -73,
 -1007,  -1007,  -1007,  -1007,
 32369,  32369,  32369,  32369,
  1483,   1483,   1483,   1483,
   -77,    -77,    -77,    -77,
 -1031,  -1031,  -1031,  -1031,
 32348,  32348,  32348,  32348,
  1532,   1532,   1532,   1532,
   -81,    -81,    -81,    -81,
 -1054,  -1054,  -1054,  -1054,
 32326,  32326,  32326,  32326,
  1582,   1582,   1582,   1582,
   -86,    -86,    -86,    -86,
 -1076,  -1076,  -1076,  -1076,
 32303,  32303,  32303,  32303,
  1631,   1631,   1631,   1631,
   -90,    -90,    -90,    -90,
 -1099,  -1099,  -1099,  -1099,
 32280,  32280,  32280,  32280,
  1682,   1682,   1682,   1682,
   -94,    -94,    -94,    -94,
 -1121,  -1121,  -1121,  -1121,
 32256,  32256,  32256,  32256,
  1732,   1732,   1732,   1732,
   -99,    -99,    -99,    -99,
 -1144,  -1144,  -1144,  -1144,
 32232,  32232,  32232,  32232,
  1783,   1783,   1783,   1783,
  -104,   -104,   -104,   -104,
 -1166,  -1166,  -1166,  -1166,
 32207,  32207,  32207,  32207,
  1835,   1835,   1835,   1835,
  -108,   -108,   -108,   -108,
 -1187,  -1187,  -1187,  -1187,
 32181,  32181,  32181,  32181,
  1887,   1887,   1887,   1887,
  -113,   -113,   -113,   -113,
 -1209,  -1209,  -1209,  -1209,
 32156,  32156,  32156,  32156,
  1939,   1939,   1939,   1939,
  -118,   -118,   -118,   -118,
 -1230,  -1230,  -1230,  -1230,
 32129,  32129,  32129,  32129,
  1992,   1992,   1992,   1992,
  -123,   -123,   -123,   -123,
 -1251,  -1251,  -1251,  -1251,
 32102,  32102,  32102,  32102,
  2045,   2045,   2045,   2045,
  -128,   -128,   -128,   -128,
 -1272,  -1272,  -1272,  -1272,
 32075,  32075,  32075,  32075,
  2098,   2098,   2098,   2098,
  -133,   -133,   -133,   -133,
 -1293,  -1293,  -1293,  -1293,
 32047,  32047,  32047,  32047,
  2152,   2152,   2152,   2152,
  -138,   -138,   -138,   -138,
 -1313,  -1313,  -1313,  -1313,
 32018,  32018,  32018,  32018,
  2206,   2206,   2206,   2206,
  -144,   -144,   -144,   -144,
 -1333,  -1333,  -1333,  -1333,
 31989,  31989,  31989,  31989,
  2261,   2261,   2261,   2261,
  -149,   -149,   -149,   -149,
 -1353,  -1353,  -1353,  -1353,
 31960,  31960,  31960,  31960,
  2316,   2316,   2316,   2316,
  -155,   -155,   -155,   -155,
 -1373,  -1373,  -1373,  -1373,
 31930,  31930,  31930,  31930,
  2371,   2371,   2371,   2371,
  -160,   -160,   -160,   -160,
 -1392,  -1392,  -1392,  -1392,
 31899,  31899,  31899,  31899,
  2427,   2427,   2427,   2427,
  -166,   -166,   -166,   -166,
 -1412,  -1412,  -1412,  -1412,
 31868,  31868,  31868,  31868,
  2483,   2483,   2483,   2483,
  -172,   -172,   -172,   -172,
 -1431,  -1431,  -1431,  -1431,
 31836,  31836,  31836,  31836,
  2540,   2540,   2540,   2540,
  -177,   -177,   -177,   -177,
 -1450,  -1450,  -1450,  -1450,
 31804,  31804,  31804,  31804,
  2597,   2597,   2597,   2597,
  -183,   -183,   -183,   -183,
 -1469,  -1469,  -1469,  -1469,
 31772,  31772,  31772,  31772,
  2654,   2654,   2654,   2654,
  -189,   -189,   -189,   -189,
 -1487,  -1487,  -1487,  -1487,
 31739,  31739,  31739,  31739,
  2712,   2712,   2712,   2712,
  -196,   -196,   -196,   -196,
 -1506,  -1506,  -1506,  -1506,
 31705,  31705,  31705,  31705,
  2770,   2770,   2770,   2770,
  -202,   -202,   -202,   -202,
 -1524,  -1524,  -1524,  -1524,
 31671,  31671,  31671,  31671,
  2828,   2828,   2828,   2828,
  -208,   -208,   -208,   -208,
 -1542,  -1542,  -1542,  -1542,
 31637,  31637,  31637,  31637,
  2887,   2887,   2887,   2887,
  -214,   -214,   -214,   -214,
 -1559,  -1559,  -1559,  -1559,
 31602,  31602,  31602,  31602,
  2946,   2946,   2946,   2946,
  -221,   -221,   -221,   -221,
 -1577,  -1577,  -1577,  -1577,
 31566,  31566,  31566,  31566,
  3006,   3006,   3006,   3006,
  -227,   -227,   -227,   -227,
 -1594,  -1594,  -1594,  -1594,
 31530,  31530,  31530,  31530,
  3066,   3066,   3066,   3066,
  -234,   -234,   -234,   -234,
 -1611,  -1611,  -1611,  -1611,
 31494,  31494,  31494,  31494,
  3126,   3126,   3126,   3126,
  -240,   -240,   -240,   -240,
 -1628,  -1628,  -1628,  -1628,
 31457,  31457,  31457,  31457,
  3186,   3186,   3186,   3186,
  -247,   -247,   -247,   -247,
 -1645,  -1645,  -1645,  -1645,
 31419,  31419,  31419,  31419,
  3247,   3247,   3247,   3247,
  -254,   -254,   -254,   -254,
 -1661,  -1661,  -1661,  -1661,
 31381,  31381,  31381,  31381,
  3309,   3309,   3309,   3309,
  -261,   -261,   -261,   -261,
 -1677,  -1677,  -1677,  -1677,
 31343,  31343,  31343,  31343,
  3370,   3370,   3370,   3370,
  -268,   -268,   -268,   -268,
 -1694,  -1694,  -1694,  -1694,
 31304,  31304,  31304,  31304,
  3432,   3432,   3432,   3432,
  -275,   -275,   -275,   -275,
 -1709,  -1709,  -1709,  -1709,
 31265,  31265,  31265,  31265,
  3495,   3495,   3495,   3495,
  -282,   -282,   -282,   -282,
 -1725,  -1725,  -1725,  -1725,
 31225,  31225,  31225,  31225,
  3557,   3557,   3557,   3557,
  -289,   -289,   -289,   -289,
 -1741,  -1741,  -1741,  -1741,
 31185,  31185,  31185,  31185,
  3620,   3620,   3620,   3620,
  -296,   -296,   -296,   -296,
 -1756,  -1756,  -1756,  -1756,
 31144,  31144,  31144,  31144,
  3683,   3683,   3683,   3683,
  -304,   -304,   -304,   -304,
 -1771,  -1771,  -1771,  -1771,
 31103,  31103,  31103,  31103,
  3747,   3747,   3747,   3747,
  -311,   -311,   -311,   -311,
 -1786,  -1786,  -1786,  -1786,
 31062,  31062,  31062,  31062,
  3811,   3811,   3811,   3811,
  -319,   -319,   -319,   -319,
 -1801,  -1801,  -1801,  -1801,
 31019,  31019,  31019,  31019,
  3875,   3875,   3875,   3875,
  -326,   -326,   -326,   -326,
 -1815,  -1815,  -1815,  -1815,
 30977,  30977,  30977,  30977,
  3940,   3940,   3940,   3940,
  -334,   -334,   -334,   -334,
 -1830,  -1830,  -1830,  -1830,
 30934,  30934,  30934,  30934,
  4005,   4005,   4005,   4005,
  -341,   -341,   -341,   -341,
 -1844,  -1844,  -1844,  -1844,
 30891,  30891,  30891,  30891,
  4070,   4070,   4070,   4070,
  -349,   -349,   -349,   -349,
 -1858,  -1858,  -1858,  -1858,
 30847,  30847,  30847,  30847,
  4136,   4136,   4136,   4136,
  -357,   -357,   -357,   -357,
 -1872,  -1872,  -1872,  -1872,
 30802,  30802,  30802,  30802,
  4202,   4202,   4202,   4202,
  -365,   -365,   -365,   -365,
 -1885,  -1885,  -1885,  -1885,
 30758,  30758,  30758,  30758,
  4268,   4268,   4268,   4268,
  -373,   -373,   -373,   -373,
 -1899,  -1899,  -1899,  -1899,
 30712,  30712,  30712,  30712,
  4335,   4335,   4335,   4335,
  -381,   -381,   -381,   -381,
 -1912,  -1912,  -1912,  -1912,
 30667,  30667,  30667,  30667,
  4402,   4402,   4402,   4402,
  -389,   -389,   -389,   -389,
 -1925,  -1925,  -1925,  -1925,
 30621,  30621,  30621,  30621,
  4469,   4469,   4469,   4469,
  -397,   -397,   -397,   -397,
 -1938,  -1938,  -1938,  -1938,
 30574,  30574,  30574,  30574,
  4536,   4536,   4536,   4536,
  -405,   -405,   -405,   -405,
 -1950,  -1950,  -1950,  -1950,
 30527,  30527,  30527,  30527,
  4604,   4604,   4604,   4604,
  -413,   -413,   -413,   -413,
 -1963,  -1963,  -1963,  -1963,
 30480,  30480,  30480,  30480,
  4672,   4672,   4672,   4672,
  -421,   -421,   -421,   -421,
 -1975,  -1975,  -1975,  -1975,
 30432,  30432,  30432,  30432,
  4741,   4741,   4741,   4741,
  -430,   -430,   -430,   -430,
 -1987,  -1987,  -1987,  -1987,
 30384,  30384,  30384,  30384,
  4809,   4809,   4809,   4809,
  -438,   -438,   -438,   -438,
 -1999,  -1999,  -1999,  -1999,
 30335,  30335,  30335,  30335,
  4878,   4878,   4878,   4878,
  -447,   -447,   -447,   -447,
 -2011,  -2011,  -2011,  -2011,
 30286,  30286,  30286,  30286,
  4948,   4948,   4948,   4948,
  -455,   -455,   -455,   -455,
 -2022,  -2022,  -2022,  -2022,
 30237,  30237,  30237,  30237,
  5017,   5017,   5017,   5017,
  -464,   -464,   -464,   -464,
 -2034,  -2034,  -2034,  -2034,
 30187,  30187,  30187,  30187,
  5087,   5087,   5087,   5087,
  -472,   -472,   -472,   -472,
 -2045,  -2045,  -2045,  -2045,
 30137,  30137,  30137,  30137,
  5157,   5157,   5157,   5157,
  -481,   -481,   -481,   -481,
 -2056,  -2056,  -2056,  -2056,
 30086,  30086,  30086,  30086,
  5228,   5228,   5228,   5228,
  -490,   -490,   -490,   -490,
 -2067,  -2067,  -2067,  -2067,
 30035,  30035,  30035,  30035,
  5298,   5298,   5298,   5298,
  -499,   -499,   -499,   -499,
 -2077,  -2077,  -2077,  -2077,
 29983,  29983,  29983,  29983,
  5369,   5369,   5369,   5369,
  -507,   -507,   -507,   -507,
 -2088,  -2088,  -2088,  -2088,
 29931,  29931,  29931,  29931,
  5441,   5441,   5441,   5441,
  -516,   -516,   -516,   -516,
 -2098,  -2098,  -2098,  -2098,
 29879,  29879,  29879,  29879,
  5512,   5512,   5512,   5512,
  -525,   -525,   -525,   -525,
 -2108,  -2108,  -2108,  -2108,
 29826,  29826,  29826,  29826,
  5584,   5584,   5584,   5584,
  -534,   -534,   -534,   -534,
 -2118,  -2118,  -2118,  -2118,
 29773,  29773,  29773,  29773,
  5656,   5656,   5656,   5656,
  -543,   -543,   -543,   -543,
 -2128,  -2128,  -2128,  -2128,
 29720,  29720,  29720,  29720,
  5729,   5729,   5729,   5729,
  -552,   -552,   -552,   -552,
 -2138,  -2138,  -2138,  -2138,
 29666,  29666,  29666,  29666,
  5801,   5801,   5801,   5801,
  -561,   -561,   -561,   -561,
 -2147,  -2147,  -2147,  -2147,
 29612,  29612,  29612,  29612,
  5874,   5874,   5874,   5874,
  -571,   -571,   -571,   -571,
 -2156,  -2156,  -2156,  -2156,
 29557,  29557,  29557,  29557,
  5947,   5947,   5947,   5947,
  -580,   -580,   -580,   -580,
 -2165,  -2165,  -2165,  -2165,
 29502,  29502,  29502,  29502,
  6021,   6021,   6021,   6021,
  -589,   -589,   -589,   -589,
 -2174,  -2174,  -2174,  -2174,
 29446,  29446,  29446,  29446,
  6094,   6094,   6094,   6094,
  -598,   -598,   -598,   -598,
 -2183,  -2183,  -2183,  -2183,
 29391,  29391,  29391,  29391,
  6168,   6168,   6168,   6168,
  -608,   -608,   -608,   -608,
 -2192,  -2192,  -2192,  -2192,
 29334,  29334,  29334,  29334,
  6243,   6243,   6243,   6243,
  -617,   -617,   -617,   -617,
 -2200,  -2200,  -2200,  -2200,
 29278,  29278,  29278,  29278,
  6317,   6317,   6317,   6317,
  -627,   -627,   -627,   -627,
 -2208,  -2208,  -2208,  -2208,
 29221,  29221,  29221,  29221,
  6392,   6392,   6392,   6392,
  -636,   -636,   -636,   -636,
 -2217,  -2217,  -2217,  -2217,
 29163,  29163,  29163,  29163,
  6467,   6467,   6467,   6467,
  -646,   -646,   -646,   -646,
 -2224,  -2224,  -2224,  -2224,
 29106,  29106,  29106,  29106,
  6542,   6542,   6542,   6542,
  -655,   -655,   -655,   -655,
 -2232,  -2232,  -2232,  -2232,
 29048,  29048,  29048,  29048,
  6617,   6617,   6617,   6617,
  -665,   -665,   -665,   -665,
 -2240,  -2240,  -2240,  -2240,
 28989,  28989,  28989,  28989,
  6693,   6693,   6693,   6693,
  -675,   -675,   -675,   -675,
 -2247,  -2247,  -2247,  -2247,
 28930,  28930,  28930,  28930,
  6769,   6769,   6769,   6769,
  -684,   -684,   -684,   -684,
 -2255,  -2255,  -2255,  -2255,
 28871,  28871,  28871,  28871,
  6845,   6845,   6845,   6845,
  -694,   -694,   -694,   -694,
 -2262,  -2262,  -2262,  -2262,
 28812,  28812,  28812,  28812,
  6922,   6922,   6922,   6922,
  -704,   -704,   -704,   -704,
 -2269,  -2269,  -2269,  -2269,
 28752,  28752,  28752,  28752,
  6998,   6998,   6998,   6998,
  -713,   -713,   -713,   -713,
 -2275,  -2275,  -2275,  -2275,
 28691,  28691,  28691,  28691,
  7075,   7075,   7075,   7075,
  -723,   -723,   -723,   -723,
 -2282,  -2282,  -2282,  -2282,
 28631,  28631,  28631,  28631,
  7152,   7152,   7152,   7152,
  -733,   -733,   -733,   -733,
 -2289,  -2289,  -2289,  -2289,
 28570,  28570,  28570,  28570,
  7230,   7230,   7230,   7230,
  -743,   -743,   -743,   -743,
 -2295,  -2295,  -2295,  -2295,
 28509,  28509,  28509,  28509,
  7307,   7307,   7307,   7307,
  -753,   -753,   -753,   -753,
 -2301,  -2301,  -2301,  -2301,
 28447,  28447,  28447,  28447,
  7385,   7385,   7385,   7385,
  -763,   -763,   -763,   -763,
 -2307,  -2307,  -2307,  -2307,
 28385,  28385,  28385,  28385,
  7463,   7463,   7463,   7463,
  -773,   -773,   -773,   -773,
 -2313,  -2313,  -2313,  -2313,
 28323,  28323,  28323,  28323,
  7541,   7541,   7541,   7541,
  -783,   -783,   -783,   -783,
 -2319,  -2319,  -2319,  -2319,
 28260,  28260,  28260,  28260,
  7620,   7620,   7620,   7620,
  -793,   -793,   -793,   -793,
 -2324,  -2324,  -2324,  -2324,
 28197,  28197,  28197,  28197,
  7698,   7698,   7698,   7698,
  -803,   -803,   -803,   -803,
 -2329,  -2329,  -2329,  -2329,
 28134,  28134,  28134,  28134,
  7777,   7777,   7777,   7777,
  -813,   -813,   -813,   -813,
 -2335,  -2335,  -2335,  -2335,
 28070,  28070,  28070,  28070,
  7856,   7856,   7856,   7856,
  -823,   -823,   -823,   -823,
 -2340,  -2340,  -2340,  -2340,
 28006,  28006,  28006,  28006,
  7936,   7936,   7936,   7936,
  -834,   -834,   -834,   -834,
 -2345,  -2345,  -2345,  -2345,
 27941,  27941,  27941,  27941,
  8015,   8015,   8015,   8015,
  -844,   -844,   -844,   -844,
 -2349,  -2349,  -2349,  -2349,
 27877,  27877,  27877,  27877,
  8095,   8095,   8095,   8095,
  -854,   -854,   -854,   -854,
 -2354,  -2354,  -2354,  -2354,
 27812,  27812,  27812,  27812,
  8175,   8175,   8175,   8175,
  -864,   -864,   -864,   -864,
 -2359,  -2359,  -2359,  -2359,
 27746,  27746,  27746,  27746,
  8255,   8255,   8255,   8255,
  -875,   -875,   -875,   -875,
 -2363,  -2363,  -2363,  -2363,
 27681,  27681,  27681,  27681,
  8335,   8335,   8335,   8335,
  -885,   -885,   -885,   -885,
 -2367,  -2367,  -2367,  -2367,
 27615,  27615,  27615,  27615,
  8415,   8415,   8415,   8415,
  -895,   -895,   -895,   -895,
 -2371,  -2371,  -2371,  -2371,
 27549,  27549,  27549,  27549,
  8496,   8496,   8496,   8496,
  -906,   -906,   -906,   -906,
 -2375,  -2375,  -2375,  -2375,
 27482,  27482,  27482,  27482,
  8577,   8577,   8577,   8577,
  -916,   -916,   -916,   -916,
 -2379,  -2379,  -2379,  -2379,
 27415,  27415,  27415,  27415,
  8658,   8658,   8658,   8658,
  -926,   -926,   -926,   -926,
 -2382,  -2382,  -2382,  -2382,
 27348,  27348,  27348,  27348,
  8739,   8739,   8739,   8739,
  -937,   -937,   -937,   -937,
 -2386,  -2386,  -2386,  -2386,
 27280,  27280,  27280,  27280,
  8821,   8821,   8821,   8821,
  -947,   -947,   -947,   -947,
 -2389,  -2389,  -2389,  -2389,
 27212,  27212,  27212,  27212,
  8902,   8902,   8902,   8902,
  -958,   -958,   -958,   -958,
 -2392,  -2392,  -2392,  -2392,
 27144,  27144,  27144,  27144,
  8984,   8984,   8984,   8984,
  -968,   -968,   -968,   -968,
 -2395,  -2395,  -2395,  -2395,
 27076,  27076,  27076,  27076,
  9066,   9066,   9066,   9066,
  -979,   -979,   -979,   -979,
 -2398,  -2398,  -2398,  -2398,
 27007,  27007,  27007,  27007,
  9148,   9148,   9148,   9148,
  -989,   -989,   -989,   -989,
 -2401,  -2401,  -2401,  -2401,
 26938,  26938,  26938,  26938,
  9230,   9230,   9230,   9230,
 -1000,  -1000,  -1000,  -1000,
 -2403,  -2403,  -2403,  -2403,
 26869,  26869,  26869,  26869,
  9313,   9313,   9313,   9313,
 -1010,  -1010,  -1010,  -1010,
 -2406,  -2406,  -2406,  -2406,
 26799,  26799,  26799,  26799,
  9395,   9395,   9395,   9395,
 -1021,  -1021,  -1021,  -1021,
 -2408,  -2408,  -2408,  -2408,
 26729,  26729,  26729,  26729,
  9478,   9478,   9478,   9478,
 -1031,  -1031,  -1031,  -1031,
 -2410,  -2410,  -2410,  -2410,
 26659,  26659,  26659,  26659,
  9561,   9561,   9561,   9561,
 -1042,  -1042,  -1042,  -1042,
 -2412,  -2412,  -2412,  -2412,
 26589,  26589,  26589,  26589,
  9644,   9644,   9644,   9644,
 -1052,  -1052,  -1052,  -1052,
 -2414,  -2414,  -2414,  -2414,
 26518,  26518,  26518,  26518,
  9727,   9727,   9727,   9727,
 -1063,  -1063,  -1063,  -1063,
 -2416,  -2416,  -2416,  -2416,
 26447,  26447,  26447,  26447,
  9811,   9811,   9811,   9811,
 -1073,  -1073,  -1073,  -1073,
 -2418,  -2418,  -2418,  -2418,
 26376,  26376,  26376,  26376,
  9894,   9894,   9894,   9894,
 -1084,  -1084,  -1084,  -1084,
 -2419,  -2419,  -2419,  -2419,
 26304,  26304,  26304,  26304,
  9978,   9978,   9978,   9978,
 -1095,  -1095,  -1095,  -1095,
 -2421,  -2421,  -2421,  -2421,
 26232,  26232,  26232,  26232,
 10062,  10062,  10062,  10062,
 -1105,  -1105,  -1105,  -1105,
 -2422,  -2422,  -2422,  -2422,
 26160,  26160,  26160,  26160,
 10146,  10146,  10146,  10146,
 -1116,  -1116,  -1116,  -1116,
 -2423,  -2423,  -2423,  -2423,
 26087,  26087,  26087,  26087,
 10230,  10230,  10230,  10230,
 -1127,  -1127,  -1127,  -1127,
 -2424,  -2424,  -2424,  -2424,
 26015,  26015,  26015,  26015,
 10314,  10314,  10314,  10314,
 -1137,  -1137,  -1137,  -1137,
 -2425,  -2425,  -2425,  -2425,
 25942,  25942,  25942,  25942,
 10399,  10399,  10399,  10399,
 -1148,  -1148,  -1148,  -1148,
 -2426,  -2426,  -2426,  -2426,
 25869,  25869,  25869,  25869,
 10483,  10483,  10483,  10483,
 -1159,  -1159,  -1159,  -1159,
 -2426,  -2426,  -2426,  -2426,
 25795,  25795,  25795,  25795,
 10568,  10568,  10568,  10568,
 -1169,  -1169,  -1169,  -1169,
 -2427,  -2427,  -2427,  -2427,
 25721,  25721,  25721,  25721,
 10653,  10653,  10653,  10653,
 -1180,  -1180,  -1180,  -1180,
 -2427,  -2427,  -2427,  -2427,
 25647,  25647,  25647,  25647,
 10738,  10738,  10738,  10738,
 -1191,  -1191,  -1191,  -1191,
 -2427,  -2427,  -2427,  -2427,
 25573,  25573,  25573,  25573,
 10823,  10823,  10823,  10823,
 -1201,  -1201,  -1201,  -1201,
 -2427,  -2427,  -2427,  -2427,
 25499,  25499,  25499,  25499,
 10908,  10908,  10908,  10908,
 -1212,  -1212,  -1212,  -1212,
 -2427,  -2427,  -2427,  -2427,
 25424,  25424,  25424,  25424,
 10994,  10994,  10994,  10994,
 -1223,  -1223,  -1223,  -1223,
 -2427,  -2427,  -2427,  -2427,
 25349,  25349,  25349,  25349,
 11079,  11079,  11079,  11079,
 -1233,  -1233,  -1233,  -1233,
 -2427,  -2427,  -2427,  -2427,
 25274,  25274,  25274,  25274,
 11165,  11165,  11165,  11165,
 -1244,  -1244,  -1244,  -1244,
 -2426,  -2426,  -2426,  -2426,
 25198,  25198,  25198,  25198,
 11251,  11251,  11251,  11251,
 -1255,  -1255,  -1255,  -1255,
 -2426,  -2426,  -2426,  -2426,
 25122,  25122,  25122,  25122,
 11337,  11337,  11337,  11337,
 -1265,  -1265,  -1265,  -1265,
 -2425,  -2425,  -2425,  -2425,
 25046,  25046,  25046,  25046,
 11422,  11422,  11422,  11422,
 -1276,  -1276,  -1276,  -1276,
 -2424,  -2424,  -2424,  -2424,
 24970,  24970,  24970,  24970,
 11509,  11509,  11509,  11509,
 -1286,  -1286,  -1286,  -1286,
 -2423,  -2423,  -2423,  -2423,
 24894,  24894,  24894,  24894,
 11595,  11595,  11595,  11595,
 -1297,  -1297,  -1297,  -1297,
 -2422,  -2422,  -2422,  -2422,
 24817,  24817,  24817,  24817,
 11681,  11681,  11681,  11681,
 -1308,  -1308,  -1308,  -1308,
 -2421,  -2421,  -2421,  -2421,
 24740,  24740,  24740,  24740,
 11767,  11767,  11767,  11767,
 -1318,  -1318,  -1318,  -1318,
 -2420,  -2420,  -2420,  -2420,
 24663,  24663,  24663,  24663,
 11854,  11854,  11854,  11854,
 -1329,  -1329,  -1329,  -1329,
 -2419,  -2419,  -2419,  -2419,
 24586,  24586,  24586,  24586,
 11941,  11941,  11941,  11941,
 -1340,  -1340,  -1340,  -1340,
 -2417,  -2417,  -2417,  -2417,
 24508,  24508,  24508,  24508,
 12027,  12027,  12027,  12027,
 -1350,  -1350,  -1350,  -1350,
 -2416,  -2416,  -2416,  -2416,
 24430,  24430,  24430,  24430,
 12114,  12114,  12114,  12114,
 -1361,  -1361,  -1361,  -1361,
 -2414,  -2414,  -2414,  -2414,
 24352,  24352,  24352,  24352,
 12201,  12201,  12201,  12201,
 -1371,  -1371,  -1371,  -1371,
 -2412,  -2412,  -2412,  -2412,
 24274,  24274,  24274,  24274,
 12288,  12288,  12288,  12288,
 -1382,  -1382,  -1382,  -1382,
 -2410,  -2410,  -2410,  -2410,
 24196,  24196,  24196,  24196,
 12375,  12375,  12375,  12375,
 -1393,  -1393,  -1393,  -1393,
 -2408,  -2408,  -2408,  -2408,
 24117,  24117,  24117,  24117,
 12462,  12462,  12462,  12462,
 -1403,  -1403,  -1403,  -1403,
 -2406,  -2406,  -2406,  -2406,
 24038,  24038,  24038,  24038,
 12549,  12549,  12549,  12549,
 -1414,  -1414,  -1414,  -1414,
 -2404,  -2404,  -2404,  -2404,
 23959,  23959,  23959,  23959,
 12637,  12637,  12637,  12637,
 -1424,  -1424,  -1424,  -1424,
 -2401,  -2401,  -2401,  -2401,
 23880,  23880,  23880,  23880,
 12724,  12724,  12724,  12724,
 -1435,  -1435,  -1435,  -1435,
 -2399,  -2399,  -2399,  -2399,
 23800,  23800,  23800,  23800,
 12812,  12812,  12812,  12812,
 -1445,  -1445,  -1445,  -1445,
 -2396,  -2396,  -2396,  -2396,
 23721,  23721,  23721,  23721,
 12899,  12899,  12899,  12899,
 -1456,  -1456,  -1456,  -1456,
 -2393,  -2393,  -2393,  -2393,
 23641,  23641,  23641,  23641,
 12987,  12987,  12987,  12987,
 -1466,  -1466,  -1466,  -1466,
 -2391,  -2391,  -2391,  -2391,
 23561,  23561,  23561,  23561,
 13075,  13075,  13075,  13075,
 -1477,  -1477,  -1477,  -1477,
 -2388,  -2388,  -2388,  -2388,
 23480,  23480,  23480,  23480,
 13163,  13163,  13163,  13163,
 -1487,  -1487,  -1487,  -1487,
 -2385,  -2385,  -2385,  -2385,
 23400,  23400,  23400,  23400,
 13250,  13250,  13250,  13250,
 -1497,  -1497,  -1497,  -1497,
 -2381,  -2381,  -2381,  -2381,
 23319,  23319,  23319,  23319,
 13338,  13338,  13338,  13338,
 -1508,  -1508,  -1508,  -1508,
 -2378,  -2378,  -2378,  -2378,
 23238,  23238,  23238,  23238,
 13426,  13426,  13426,  13426,
 -1518,  -1518,  -1518,  -1518,
 -2375,  -2375,  -2375,  -2375,
 23157,  23157,  23157,  23157,
 13514,  13514,  13514,  13514,
 -1529,  -1529,  -1529,  -1529,
 -2371,  -2371,  -2371,  -2371,
 23076,  23076,  23076,  23076,
 13602,  13602,  13602,  13602,
 -1539,  -1539,  -1539,  -1539,
 -2368,  -2368,  -2368,  -2368,
 22994,  22994,  22994,  22994,
 13691,  13691,  13691,  13691,
 -1549,  -1549,  -1549,  -1549,
 -2364,  -2364,  -2364,  -2364,
 22913,  22913,  22913,  22913,
 13779,  13779,  13779,  13779,
 -1560,  -1560,  -1560,  -1560,
 -2360,  -2360,  -2360,  -2360,
 22831,  22831,  22831,  22831,
 13867,  13867,  13867,  13867,
 -1570,  -1570,  -1570,  -1570,
 -2357,  -2357,  -2357,  -2357,
 22749,  22749,  22749,  22749,
 13955,  13955,  13955,  13955,
 -1580,  -1580,  -1580,  -1580,
 -2353,  -2353,  -2353,  -2353,
 22667,  22667,  22667,  22667,
 14044,  14044,  14044,  14044,
 -1590,  -1590,  -1590,  -1590,
 -2349,  -2349,  -2349,  -2349,
 22585,  22585,  22585,  22585,
 14132,  14132,  14132,  14132,
 -1600,  -1600,  -1600,  -1600,
 -2344,  -2344,  -2344,  -2344,
 22502,  22502,  22502,  22502,
 14221,  14221,  14221,  14221,
 -1611,  -1611,  -1611,  -1611,
 -2340,  -2340,  -2340,  -2340,
 22420,  22420,  22420,  22420,
 14309,  14309,  14309,  14309,
 -1621,  -1621,  -1621,  -1621,
 -2336,  -2336,  -2336,  -2336,
 22337,  22337,  22337,  22337,
 14398,  14398,  14398,  14398,
 -1631,  -1631,  -1631,  -1631,
 -2331,  -2331,  -2331,  -2331,
 22254,  22254,  22254,  22254,
 14486,  14486,  14486,  14486,
 -1641,  -1641,  -1641,  -1641,
 -2327,  -2327,  -2327,  -2327,
 22171,  22171,  22171,  22171,
 14575,  14575,  14575,  14575,
 -1651,  -1651,  -1651,  -1651,
 -2322,  -2322,  -2322,  -2322,
 22087,  22087,  22087,  22087,
 14664,  14664,  14664,  14664,
 -1661,  -1661,  -1661,  -1661,
 -2317,  -2317,  -2317,  -2317,
 22004,  22004,  22004,  22004,
 14752,  14752,  14752,  14752,
 -1671,  -1671,  -1671,  -1671,
 -2313,  -2313,  -2313,  -2313,
 21920,  21920,  21920,  21920,
 14841,  14841,  14841,  14841,
 -1681,  -1681,  -1681,  -1681,
 -2308,  -2308,  -2308,  -2308,
 21837,  21837,  21837,  21837,
 14930,  14930,  14930,  14930,
 -1691,  -1691,  -1691,  -1691,
 -2303,  -2303,  -2303,  -2303,
 21753,  21753,  21753,  21753,
 15019,  15019,  15019,  15019,
 -1701,  -1701,  -1701,  -1701,
 -2298,  -2298,  -2298,  -2298,
 21669,  21669,  21669,  21669,
 15107,  15107,  15107,  15107,
 -1710,  -1710,  -1710,  -1710,
 -2292,  -2292,  -2292,  -2292,
 21585,  21585,  21585,  21585,
 15196,  15196,  15196,  15196,
 -1720,  -1720,  -1720,  -1720,
 -2287,  -2287,  -2287,  -2287,
 21500,  21500,  21500,  21500,
 15285,  15285,  15285,  15285,
 -1730,  -1730,  -1730,  -1730,
 -2282,  -2282,  -2282,  -2282,
 21416,  21416,  21416,  21416,
 15374,  15374,  15374,  15374,
 -1740,  -1740,  -1740,  -1740,
 -2276,  -2276,  -2276,  -2276,
 21331,  21331,  21331,  21331,
 15463,  15463,  15463,  15463,
 -1750,  -1750,  -1750,  -1750,
 -2271,  -2271,  -2271,  -2271,
 21246,  21246,  21246,  21246,
 15552,  15552,  15552,  15552,
 -1759,  -1759,  -1759,  -1759,
 -2265,  -2265,  -2265,  -2265,
 21162,  21162,  21162,  21162,
 15640,  15640,  15640,  15640,
 -1769,  -1769,  -1769,  -1769,
 -2259,  -2259,  -2259,  -2259,
 21077,  21077,  21077,  21077,
 15729,  15729,  15729,  15729,
 -1778,  -1778,  -1778,  -1778,
 -2254,  -2254,  -2254,  -2254,
 20991,  20991,  20991,  20991,
 15818,  15818,  15818,  15818,
 -1788,  -1788,  -1788,  -1788,
 -2248,  -2248,  -2248,  -2248,
 20906,  20906,  20906,  20906,
 15907,  15907,  15907,  15907,
 -1797,  -1797,  -1797,  -1797,
 -2242,  -2242,  -2242,  -2242,
 20821,  20821,  20821,  20821,
 15996,  15996,  15996,  15996,
 -1807,  -1807,  -1807,  -1807,
 -2236,  -2236,  -2236,  -2236,
 20735,  20735,  20735,  20735,
 16085,  16085,  16085,  16085,
 -1816,  -1816,  -1816,  -1816,
 -2230,  -2230,  -2230,  -2230,
 20650,  20650,  20650,  20650,
 16174,  16174,  16174,  16174,
 -1826,  -1826,  -1826,  -1826,
 -2223,  -2223,  -2223,  -2223,
 20564,  20564,  20564,  20564,
 16263,  16263,  16263,  16263,
 -1835,  -1835,  -1835,  -1835,
 -2217,  -2217,  -2217,  -2217,
 20478,  20478,  20478,  20478,
 16351,  16351,  16351,  16351,
 -1844,  -1844,  -1844,  -1844,
 -2211,  -2211,  -2211,  -2211,
 20392,  20392,  20392,  20392,
 16440,  16440,  16440,  16440,
 -1854,  -1854,  -1854,  -1854,
 -2204,  -2204,  -2204,  -2204,
 20306,  20306,  20306,  20306,
 16529,  16529,  16529,  16529,
 -1863,  -1863,  -1863,  -1863,
 -2198,  -2198,  -2198,  -2198,
 20220,  20220,  20220,  20220,
 16618,  16618,  16618,  16618,
 -1872,  -1872,  -1872,  -1872,
 -2191,  -2191,  -2191,  -2191,
 20133,  20133,  20133,  20133,
 16707,  16707,  16707,  16707,
 -1881,  -1881,  -1881,  -1881,
 -2185,  -2185,  -2185,  -2185,
 20047,  20047,  20047,  20047,
 16796,  16796,  16796,  16796,
 -1890,  -1890,  -1890,  -1890,
 -2178,  -2178,  -2178,  -2178,
 19960,  19960,  19960,  19960,
 16884,  16884,  16884,  16884,
 -1899,  -1899,  -1899,  -1899,
 -2171,  -2171,  -2171,  -2171,
 19874,  19874,  19874,  19874,
 16973,  16973,  16973,  16973,
 -1908,  -1908,  -1908,  -1908,
 -2164,  -2164,  -2164,  -2164,
 19787,  19787,  19787,  19787,
 17062,  17062,  17062,  17062,
 -1917,  -1917,  -1917,  -1917,
 -2157,  -2157,  -2157,  -2157,
 19700,  19700,  19700,  19700,
 17151,  17151,  17151,  17151,
 -1926,  -1926,  -1926,  -1926,
 -2150,  -2150,  -2150,  -2150,
 19613,  19613,  19613,  19613,
 17239,  17239,  17239,  17239,
 -1935,  -1935,  -1935,  -1935,
 -2143,  -2143,  -2143,  -2143,
 19526,  19526,  19526,  19526,
 17328,  17328,  17328,  17328,
 -1943,  -1943,  -1943,  -1943,
 -2136,  -2136,  -2136,  -2136,
 19439,  19439,  19439,  19439,
 17416,  17416,  17416,  17416,
 -1952,  -1952,  -1952,  -1952,
 -2128,  -2128,  -2128,  -2128,
 19352,  19352,  19352,  19352,
 17505,  17505,  17505,  17505,
 -1961,  -1961,  -1961,  -1961,
 -2121,  -2121,  -2121,  -2121,
 19265,  19265,  19265,  19265,
 17593,  17593,  17593,  17593,
 -1969,  -1969,  -1969,  -1969,
 -2114,  -2114,  -2114,  -2114,
 19178,  19178,  19178,  19178,
 17682,  17682,  17682,  17682,
 -1978,  -1978,  -1978,  -1978,
 -2106,  -2106,  -2106,  -2106,
 19090,  19090,  19090,  19090,
 17770,  17770,  17770,  17770,
 -1986,  -1986,  -1986,  -1986,
 -2099,  -2099,  -2099,  -2099,
 19003,  19003,  19003,  19003,
 17859,  17859,  17859,  17859,
 -1995,  -1995,  -1995,  -1995,
 -2091,  -2091,  -2091,  -2091,
 18915,  18915,  18915,  18915,
 17947,  17947,  17947,  17947,
 -2003,  -2003,  -2003,  -2003,
 -2083,  -2083,  -2083,  -2083,
 18827,  18827,  18827,  18827,
 18035,  18035,  18035,  18035,
 -2011,  -2011,  -2011,  -2011,
 -2076,  -2076,  -2076,  -2076,
 18740,  18740,  18740,  18740,
 18124,  18124,  18124,  18124,
 -2020,  -2020,  -2020,  -2020,
 -2068,  -2068,  -2068,  -2068,
 18652,  18652,  18652,  18652,
 18212,  18212,  18212,  18212,
 -2028,  -2028,  -2028,  -2028,
 -2060,  -2060,  -2060,  -2060,
 18564,  18564,  18564,  18564,
 18300,  18300,  18300,  18300,
 -2036,  -2036,  -2036,  -2036,
 -2052,  -2052,  -2052,  -2052,
 18476,  18476,  18476,  18476,
 18388,  18388,  18388,  18388,
 -2044,  -2044,  -2044,  -2044,
 -2044,  -2044,  -2044,  -2044,
 18388,  18388,  18388,  18388,
 18476,  18476,  18476,  18476,
 -2052,  -2052,  -2052,  -2052,
 -2036,  -2036,  -2036,  -2036,
 18300,  18300,  18300,  18300,
 18564,  18564,  18564,  18564,
 -2060,  -2060,  -2060,  -2060,
 -2028,  -2028,  -2028,  -2028,
 18212,  18212,  18212,  18212,
 18652,  18652,  18652,  18652,
 -2068,  -2068,  -2068,  -2068,
 -2020,  -2020,  -2020,  -2020,
 18124,  18124,  18124,  18124,
 18740,  18740,  18740,  18740,
 -2076,  -2076,  -2076,  -2076,
 -2011,  -2011,  -2011,  -2011,
 18035,  18035,  18035,  18035,
 18827,  18827,  18827,  18827,
 -2083,  -2083,  -2083,  -2083,
 -2003,  -2003,  -2003,  -2003,
 17947,  17947,  17947,  17947,
 18915,  18915,  18915,  18915,
 -2091,  -2091,  -2091,  -2091,
 -1995,  -1995,  -1995,  -1995,
 17859,  17859,  17859,  17859,
 19003,  19003,  19003,  19003,
 -2099,  -2099,  -2099,  -2099,
 -1986,  -1986,  -1986,  -1986,
 17770,  17770,  17770,  17770,
 19090,  19090,  19090,  19090,
 -2106,  -2106,  -2106,  -2106,
 -1978,  -1978,  -1978,  -1978,
 17682,  17682,  17682,  17682,
 19178,  19178,  19178,  19178,
 -2114,  -2114,  -2114,  -2114,
 -1969,  -1969,  -1969,  -1969,
 17593,  17593,  17593,  17593,
 19265,  19265,  19265,  19265,
 -2121,  -2121,  -2121,  -2121,
 -1961,  -1961,  -1961,  -1961,
 17505,  17505,  17505,  17505,
 19352,  19352,  19352,  19352,
 -2128,  -2128,  -2128,  -2128,
 -1952,  -1952,  -1952,  -1952,
 17416,  17416,  17416,  17416,
 19439,  19439,  19439,  19439,
 -2136,  -2136,  -2136,  -2136,
 -1943,  -1943,  -1943,  -1943,
 17328,  17328,  17328,  17328,
 19526,  19526,  19526,  19526,
 -2143,  -2143,  -2143,  -2143,
 -1935,  -1935,  -1935,  -1935,
 17239,  17239,  17239,  17239,
 19613,  19613,  19613,  19613,
 -2150,  -2150,  -2150,  -2150,
 -1926,  -1926,  -1926,  -1926,
 17151,  17151,  17151,  17151,
 19700,  19700,  19700,  19700,
 -2157,  -2157,  -2157,  -2157,
 -1917,  -1917,  -1917,  -1917,
 17062,  17062,  17062,  17062,
 19787,  19787,  19787,  19787,
 -2164,  -2164,  -2164,  -2164,
 -1908,  -1908,  -1908,  -1908,
 16973,  16973,  16973,  16973,
 19874,  19874,  19874,  19874,
 -2171,  -2171,  -2171,  -2171,
 -1899,  -1899,  -1899,  -1899,
 16884,  16884,  16884,  16884,
 19960,  19960,  19960,  19960,
 -2178,  -2178,  -2178,  -2178,
 -1890,  -1890,  -1890,  -1890,
 16796,  16796,  16796,  16796,
 20047,  20047,  20047,  20047,
 -2185,  -2185,  -2185,  -2185,
 -1881,  -1881,  -1881,  -1881,
 16707,  16707,  16707,  16707,
 20133,  20133,  20133,  20133,
 -2191,  -2191,  -2191,  -2191,
 -1872,  -1872,  -1872,  -1872,
 16618,  16618,  16618,  16618,
 20220,  20220,  20220,  20220,
 -2198,  -2198,  -2198,  -2198,
 -1863,  -1863,  -1863,  -1863,
 16529,  16529,  16529,  16529,
 20306,  20306,  20306,  20306,
 -2204,  -2204,  -2204,  -2204,
 -1854,  -1854,  -1854,  -1854,
 16440,  16440,  16440,  16440,
 20392,  20392,  20392,  20392,
 -2211,  -2211,  -2211,  -2211,
 -1844,  -1844,  -1844,  -1844,
 16351,  16351,  16351,  16351,
 20478,  20478,  20478,  20478,
 -2217,  -2217,  -2217,  -2217,
 -1835,  -1835,  -1835,  -1835,
 16263,  16263,  16263,  16263,
 20564,  20564,  20564,  20564,
 -2223,  -2223,  -2223,  -2223,
 -1826,  -1826,  -1826,  -1826,
 16174,  16174,  16174,  16174,
 20650,  20650,  20650,  20650,
 -2230,  -2230,  -2230,  -2230,
 -1816,  -1816,  -1816,  -1816,
 16085,  16085,  16085,  16085,
 20735,  20735,  20735,  20735,
 -2236,  -2236,  -2236,  -2236,
 -1807,  -1807,  -1807,  -1807,
 15996,  15996,  15996,  15996,
 20821,  20821,  20821,  20821,
 -2242,  -2242,  -2242,  -2242,
 -1797,  -1797,  -1797,  -1797,
 15907,  15907,  15907,  15907,
 20906,  20906,  20906,  20906,
 -2248,  -2248,  -2248,  -2248,
 -1788,  -1788,  -1788,  -1788,
 15818,  15818,  15818,  15818,
 20991,  20991,  20991,  20991,
 -2254,  -2254,  -2254,  -2254,
 -1778,  -1778,  -1778,  -1778,
 15729,  15729,  15729,  15729,
 21077,  21077,  21077,  21077,
 -2259,  -2259,  -2259,  -2259,
 -1769,  -1769,  -1769,  -1769,
 15640,  15640,  15640,  15640,
 21162,  21162,  21162,  21162,
 -2265,  -2265,  -2265,  -2265,
 -1759,  -1759,  -1759,  -1759,
 15552,  15552,  15552,  15552,
 21246,  21246,  21246,  21246,
 -2271,  -2271,  -2271,  -2271,
 -1750,  -1750,  -1750,  -1750,
 15463,  15463,  15463,  15463,
 21331,  21331,  21331,  21331,
 -2276,  -2276,  -2276,  -2276,
 -1740,  -1740,  -1740,  -1740,
 15374,  15374,  15374,  15374,
 21416,  21416,  21416,  21416,
 -2282,  -2282,  -2282,  -2282,
 -1730,  -1730,  -1730,  -1730,
 15285,  15285,  15285,  15285,
 21500,  21500,  21500,  21500,
 -2287,  -2287,  -2287,  -2287,
 -1720,  -1720,  -1720,  -1720,
 15196,  15196,  15196,  15196,
 21585,  21585,  21585,  21585,
 -2292,  -2292,  -2292,  -2292,
 -1710,  -1710,  -1710,  -1710,
 15107,  15107,  15107,  15107,
 21669,  21669,  21669,  21669,
 -2298,  -2298,  -2298,  -2298,
 -1701,  -1701,  -1701,  -1701,
 15019,  15019,  15019,  15019,
 21753,  21753,  21753,  21753,
 -2303,  -2303,  -2303,  -2303,
 -1691,  -1691,  -1691,  -1691,
 14930,  14930,  14930,  14930,
 21837,  21837,  21837,  21837,
 -2308,  -2308,  -2308,  -2308,
 -1681,  -1681,  -1681,  -1681,
 14841,  14841,  14841,  14841,
 21920,  21920,  21920,  21920,
 -2313,  -2313,  -2313,  -2313,
 -1671,  -1671,  -1671,  -1671,
 14752,  14752,  14752,  14752,
 22004,  22004,  22004,  22004,
 -2317,  -2317,  -2317,  -2317,
 -1661,  -1661,  -1661,  -1661,
 14664,  14664,  14664,  14664,
 22087,  22087,  22087,  22087,
 -2322,  -2322,  -2322,  -2322,
 -1651,  -1651,  -1651,  -1651,
 14575,  14575,  14575,  14575,
 22171,  22171,  22171,  22171,
 -2327,  -2327,  -2327,  -2327,
 -1641,  -1641,  -1641,  -1641,
 14486,  14486,  14486,  14486,
 22254,  22254,  22254,  22254,
 -2331,  -2331,  -2331,  -2331,
 -1631,  -1631,  -1631,  -1631,
 14398,  14398,  14398,  14398,
 22337,  22337,  22337,  22337,
 -2336,  -2336,  -2336,  -2336,
 -1621,  -1621,  -1621,  -1621,
 14309,  14309,  14309,  14309,
 22420,  22420,  22420,  22420,
 -2340,  -2340,  -2340,  -2340,
 -1611,  -1611,  -1611,  -1611,
 14221,  14221,  14221,  14221,
 22502,  22502,  22502,  22502,
 -2344,  -2344,  -2344,  -2344,
 -1600,  -1600,  -1600,  -1600,
 14132,  14132,  14132,  14132,
 22585,  22585,  22585,  22585,
 -2349,  -2349,  -2349,  -2349,
 -1590,  -1590,  -1590,  -1590,
 14044,  14044,  14044,  14044,
 22667,  22667,  22667,  22667,
 -2353,  -2353,  -2353,  -2353,
 -1580,  -1580,  -1580,  -1580,
 13955,  13955,  13955,  13955,
 22749,  22749,  22749,  22749,
 -2357,  -2357,  -2357,  -2357,
 -1570,  -1570,  -1570,  -1570,
 13867,  13867,  13867,  13867,
 22831,  22831,  22831,  22831,
 -2360,  -2360,  -2360,  -2360,
 -1560,  -1560,  -1560,  -1560,
 13779,  13779,  13779,  13779,
 22913,  22913,  22913,  22913,
 -2364,  -2364,  -2364,  -2364,
 -1549,  -1549,  -1549,  -1549,
 13691,  13691,  13691,  13691,
 22994,  22994,  22994,  22994,
 -2368,  -2368,  -2368,  -2368,
 -1539,  -1539,  -1539,  -1539,
 13602,  13602,  13602,  13602,
 23076,  23076,  23076,  23076,
 -2371,  -2371,  -2371,  -2371,
 -1529,  -1529,  -1529,  -1529,
 13514,  13514,  13514,  13514,
 23157,  23157,  23157,  23157,
 -2375,  -2375,  -2375,  -2375,
 -1518,  -1518,  -1518,  -1518,
 13426,  13426,  13426,  13426,
 23238,  23238,  23238,  23238,
 -2378,  -2378,  -2378,  -2378,
 -1508,  -1508,  -1508,  -1508,
 13338,  13338,  13338,  13338,
 23319,  23319,  23319,  23319,
 -2381,  -2381,  -2381,  -2381,
 -1497,  -1497,  -1497,  -1497,
 13250,  13250,  13250,  13250,
 23400,  23400,  23400,  23400,
 -2385,  -2385,  -2385,  -2385,
 -1487,  -1487,  -1487,  -1487,
 13163,  13163,  13163,  13163,
 23480,  23480,  23480,  23480,
 -2388,  -2388,  -2388,  -2388,
 -1477,  -1477,  -1477,  -1477,
 13075,  13075,  13075,  13075,
 23561,  23561,  23561,  23561,
 -2391,  -2391,  -2391,  -2391,
 -1466,  -1466,  -1466,  -1466,
 12987,  12987,  12987,  12987,
 23641,  23641,  23641,  23641,
 -2393,  -2393,  -2393,  -2393,
 -1456,  -1456,  -1456,  -1456,
 12899,  12899,  12899,  12899,
 23721,  23721,  23721,  23721,
 -2396,  -2396,  -2396,  -2396,
 -1445,  -1445,  -1445,  -1445,
 12812,  12812,  12812,  12812,
 23800,  23800,  23800,  23800,
 -2399,  -2399,  -2399,  -2399,
 -1435,  -1435,  -1435,  -1435,
 12724,  12724,  12724,  12724,
 23880,  23880,  23880,  23880,
 -2401,  -2401,  -2401,  -2401,
 -1424,  -1424,  -1424,  -1424,
 12637,  12637,  12637,  12637,
 23959,  23959,  23959,  23959,
 -2404,  -2404,  -2404,  -2404,
 -1414,  -1414,  -1414,  -1414,
 12549,  12549,  12549,  12549,
 24038,  24038,  24038,  24038,
 -2406,  -2406,  -2406,  -2406,
 -1403,  -1403,  -1403,  -1403,
 12462,  12462,  12462,  12462,
 24117,  24117,  24117,  24117,
 -2408,  -2408,  -2408,  -2408,
 -1393,  -1393,  -1393,  -1393,
 12375,  12375,  12375,  12375,
 24196,  24196,  24196,  24196,
 -2410,  -2410,  -2410,  -2410,
 -1382,  -1382,  -1382,  -1382,
 12288,  12288,  12288,  12288,
 24274,  24274,  24274,  24274,
 -2412,  -2412,  -2412,  -2412,
 -1371,  -1371,  -1371,  -1371,
 12201,  12201,  12201,  12201,
 24352,  24352,  24352,  24352,
 -2414,  -2414,  -2414,  -2414,
 -1361,  -1361,  -1361,  -1361,
 12114,  12114,  12114,  12114,
 24430,  24430,  24430,  24430,
 -2416,  -2416,  -2416,  -2416,
 -1350,  -1350,  -1350,  -1350,
 12027,  12027,  12027,  12027,
 24508,  24508,  24508,  24508,
 -2417,  -2417,  -2417,  -2417,
 -1340,  -1340,  -1340,  -1340,
 11941,  11941,  11941,  11941,
 24586,  24586,  24586,  24586,
 -2419,  -2419,  -2419,  -2419,
 -1329,  -1329,  -1329,  -1329,
 11854,  11854,  11854,  11854,
 24663,  24663,  24663,  24663,
 -2420,  -2420,  -2420,  -2420,
 -1318,  -1318,  -1318,  -1318,
 11767,  11767,  11767,  11767,
 24740,  24740,  24740,  24740,
 -2421,  -2421,  -2421,  -2421,
 -1308,  -1308,  -1308,  -1308,
 11681,  11681,  11681,  11681,
 24817,  24817,  24817,  24817,
 -2422,  -2422,  -2422,  -2422,
 -1297,  -1297,  -1297,  -1297,
 11595,  11595,  11595,  11595,
 24894,  24894,  24894,  24894,
 -2423,  -2423,  -2423,  -2423,
 -1286,  -1286,  -1286,  -1286,
 11509,  11509,  11509,  11509,
 24970,  24970,  24970,  24970,
 -2424,  -2424,  -2424,  -2424,
 -1276,  -1276,  -1276,  -1276,
 11422,  11422,  11422,  11422,
 25046,  25046,  25046,  25046,
 -2425,  -2425,  -2425,  -2425,
 -1265,  -1265,  -1265,  -1265,
 11337,  11337,  11337,  11337,
 25122,  25122,  25122,  25122,
 -2426,  -2426,  -2426,  -2426,
 -1255,  -1255,  -1255,  -1255,
 11251,  11251,  11251,  11251,
 25198,  25198,  25198,  25198,
 -2426,  -2426,  -2426,  -2426,
 -1244,  -1244,  -1244,  -1244,
 11165,  11165,  11165,  11165,
 25274,  25274,  25274,  25274,
 -2427,  -2427,  -2427,  -2427,
 -1233,  -1233,  -1233,  -1233,
 11079,  11079,  11079,  11079,
 25349,  25349,  25349,  25349,
 -2427,  -2427,  -2427,  -2427,
 -1223,  -1223,  -1223,  -1223,
 10994,  10994,  10994,  10994,
 25424,  25424,  25424,  25424,
 -2427,  -2427,  -2427,  -2427,
 -1212,  -1212,  -1212,  -1212,
 10908,  10908,  10908,  10908,
 25499,  25499,  25499,  25499,
 -2427,  -2427,  -2427,  -2427,
 -1201,  -1201,  -1201,  -1201,
 10823,  10823,  10823,  10823,
 25573,  25573,  25573,  25573,
 -2427,  -2427,  -2427,  -2427,
 -1191,  -1191,  -1191,  -1191,
 10738,  10738,  10738,  10738,
 25647,  25647,  25647,  25647,
 -2427,  -2427,  -2427,  -2427,
 -1180,  -1180,  -1180,  -1180,
 10653,  10653,  10653,  10653,
 25721,  25721,  25721,  25721,
 -2427,  -2427,  -2427,  -2427,
 -1169,  -1169,  -1169,  -1169,
 10568,  10568,  10568,  10568,
 25795,  25795,  25795,  25795,
 -2426,  -2426,  -2426,  -2426,
 -1159,  -1159,  -1159,  -1159,
 10483,  10483,  10483,  10483,
 25869,  25869,  25869,  25869,
 -2426,  -2426,  -2426,  -2426,
 -1148,  -1148,  -1148,  -1148,
 10399,  10399,  10399,  10399,
 25942,  25942,  25942,  25942,
 -2425,  -2425,  -2425,  -2425,
 -1137,  -1137,  -1137,  -1137,
 10314,  10314,  10314,  10314,
 26015,  26015,  26015,  26015,
 -2424,  -2424,  -2424,  -2424,
 -1127,  -1127,  -1127,  -1127,
 10230,  10230,  10230,  10230,
 26087,  26087,  26087,  26087,
 -2423,  -2423,  -2423,  -2423,
 -1116,  -1116,  -1116,  -1116,
 10146,  10146,  10146,  10146,
 26160,  26160,  26160,  26160,
 -2422,  -2422,  -2422,  -2422,
 -1105,  -1105,  -1105,  -1105,
 10062,  10062,  10062,  10062,
 26232,  26232,  26232,  26232,
 -2421,  -2421,  -2421,  -2421,
 -1095,  -1095,  -1095,  -1095,
  9978,   9978,   9978,   9978,
 26304,  26304,  26304,  26304,
 -2419,  -2419,  -2419,  -2419,
 -1084,  -1084,  -1084,  -1084,
  9894,   9894,   9894,   9894,
 26376,  26376,  26376,  26376,
 -2418,  -2418,  -2418,  -2418,
 -1073,  -1073,  -1073,  -1073,
  9811,   9811,   9811,   9811,
 26447,  26447,  26447,  26447,
 -2416,  -2416,  -2416,  -2416,
 -1063,  -1063,  -1063,  -1063,
  9727,   9727,   9727,   9727,
 26518,  26518,  26518,  26518,
 -2414,  -2414,  -2414,  -2414,
 -1052,  -1052,  -1052,  -1052,
  9644,   9644,   9644,   9644,
 26589,  26589,  26589,  26589,
 -2412,  -2412,  -2412,  -2412,
 -1042,  -1042,  -1042,  -1042,
  9561,   9561,   9561,   9561,
 26659,  26659,  26659,  26659,
 -2410,  -2410,  -2410,  -2410,
 -1031,  -1031,  -1031,  -1031,
  9478,   9478,   9478,   9478,
 26729,  26729,  26729,  26729,
 -2408,  -2408,  -2408,  -2408,
 -1021,  -1021,  -1021,  -1021,
  9395,   9395,   9395,   9395,
 26799,  26799,  26799,  26799,
 -2406,  -2406,  -2406,  -2406,
 -1010,  -1010,  -1010,  -1010,
  9313,   9313,   9313,   9313,
 26869,  26869,  26869,  26869,
 -2403,  -2403,  -2403,  -2403,
 -1000,  -1000,  -1000,  -1000,
  9230,   9230,   9230,   9230,
 26938,  26938,  26938,  26938,
 -2401,  -2401,  -2401,  -2401,
  -989,   -989,   -989,   -989,
  9148,   9148,   9148,   9148,
 27007,  27007,  27007,  27007,
 -2398,  -2398,  -2398,  -2398,
  -979,   -979,   -979,   -979,
  9066,   9066,   9066,   9066,
 27076,  27076,  27076,  27076,
 -2395,  -2395,  -2395,  -2395,
  -968,   -968,   -968,   -968,
  8984,   8984,   8984,   8984,
 27144,  27144,  27144,  27144,
 -2392,  -2392,  -2392,  -2392,
  -958,   -958,   -958,   -958,
  8902,   8902,   8902,   8902,
 27212,  27212,  27212,  27212,
 -2389,  -2389,  -2389,  -2389,
  -947,   -947,   -947,   -947,
  8821,   8821,   8821,   8821,
 27280,  27280,  27280,  27280,
 -2386,  -2386,  -2386,  -2386,
  -937,   -937,   -937,   -937,
  8739,   8739,   8739,   8739,
 27348,  27348,  27348,  27348,
 -2382,  -2382,  -2382,  -2382,
  -926,   -926,   -926,   -926,
  8658,   8658,   8658,   8658,
 27415,  27415,  27415,  27415,
 -2379,  -2379,  -2379,  -2379,
  -916,   -916,   -916,   -916,
  8577,   8577,   8577,   8577,
 27482,  27482,  27482,  27482,
 -2375,  -2375,  -2375,  -2375,
  -906,   -906,   -906,   -906,
  8496,   8496,   8496,   8496,
 27549,  27549,  27549,  27549,
 -2371,  -2371,  -2371,  -2371,
  -895,   -895,   -895,   -895,
  8415,   8415,   8415,   8415,
 27615,  27615,  27615,  27615,
 -2367,  -2367,  -2367,  -2367,
  -885,   -885,   -885,   -885,
  8335,   8335,   8335,   8335,
 27681,  27681,  27681,  27681,
 -2363,  -2363,  -2363,  -2363,
  -875,   -875,   -875,   -875,
  8255,   8255,   8255,   8255,
 27746,  27746,  27746,  27746,
 -2359,  -2359,  -2359,  -2359,
  -864,   -864,   -864,   -864,
  8175,   8175,   8175,   8175,
 27812,  27812,  27812,  27812,
 -2354,  -2354,  -2354,  -2354,
  -854,   -854,   -854,   -854,
  8095,   8095,   8095,   8095,
 27877,  27877,  27877,  27877,
 -2349,  -2349,  -2349,  -2349,
  -844,   -844,   -844,   -844,
  8015,   8015,   8015,   8015,
 27941,  27941,  27941,  27941,
 -2345,  -2345,  -2345,  -2345,
  -834,   -834,   -834,   -834,
  7936,   7936,   7936,   7936,
 28006,  28006,  28006,  28006,
 -2340,  -2340,  -2340,  -2340,
  -823,   -823,   -823,   -823,
  7856,   7856,   7856,   7856,
 28070,  28070,  28070,  28070,
 -2335,  -2335,  -2335,  -2335,
  -813,   -813,   -813,   -813,
  7777,   7777,   7777,   7777,
 28134,  28134,  28134,  28134,
 -2329,  -2329,  -2329,  -2329,
  -803,   -803,   -803,   -803,
  7698,   7698,   7698,   7698,
 28197,  28197,  28197,  28197,
 -2324,  -2324,  -2324,  -2324,
  -793,   -793,   -793,   -793,
  7620,   7620,   7620,   7620,
 28260,  28260,  28260,  28260,
 -2319,  -2319,  -2319,  -2319,
  -783,   -783,   -783,   -783,
  7541,   7541,   7541,   7541,
 28323,  28323,  28323,  28323,
 -2313,  -2313,  -2313,  -2313,
  -773,   -773,   -773,   -773,
  7463,   7463,   7463,   7463,
 28385,  28385,  28385,  28385,
 -2307,  -2307,  -2307,  -2307,
  -763,   -763,   -763,   -763,
  7385,   7385,   7385,   7385,
 28447,  28447,  28447,  28447,
 -2301,  -2301,  -2301,  -2301,
  -753,   -753,   -753,   -753,
  7307,   7307,   7307,   7307,
 28509,  28509,  28509,  28509,
 -2295,  -2295,  -2295,  -2295,
  -743,   -743,   -743,   -743,
  7230,   7230,   7230,   7230,
 28570,  28570,  28570,  28570,
 -2289,  -2289,  -2289,  -2289,
  -733,   -733,   -733,   -733,
  7152,   7152,   7152,   7152,
 28631,  28631,  28631,  28631,
 -2282,  -2282,  -2282,  -2282,
  -723,   -723,   -723,   -723,
  7075,   7075,   7075,   7075,
 28691,  28691,  28691,  28691,
 -2275,  -2275,  -2275,  -2275,
  -713,   -713,   -713,   -713,
  6998,   6998,   6998,   6998,
 28752,  28752,  28752,  28752,
 -2269,  -2269,  -2269,  -2269,
  -704,   -704,   -704,   -704,
  6922,   6922,   6922,   6922,
 28812,  28812,  28812,  28812,
 -2262,  -2262,  -2262,  -2262,
  -694,   -694,   -694,   -694,
  6845,   6845,   6845,   6845,
 28871,  28871,  28871,  28871,
 -2255,  -2255,  -2255,  -2255,
  -684,   -684,   -684,   -684,
  6769,   6769,   6769,   6769,
 28930,  28930,  28930,  28930,
 -2247,  -2247,  -2247,  -2247,
  -675,   -675,   -675,   -675,
  6693,   6693,   6693,   6693,
 28989,  28989,  28989,  28989,
 -2240,  -2240,  -2240,  -2240,
  -665,   -665,   -665,   -665,
  6617,   6617,   6617,   6617,
 29048,  29048,  29048,  29048,
 -2232,  -2232,  -2232,  -2232,
  -655,   -655,   -655,   -655,
  6542,   6542,   6542,   6542,
 29106,  29106,  29106,  29106,
 -2224,  -2224,  -2224,  -2224,
  -646,   -646,   -646,   -646,
  6467,   6467,   6467,   6467,
 29163,  29163,  29163,  29163,
 -2217,  -2217,  -2217,  -2217,
  -636,   -636,   -636,   -636,
  6392,   6392,   6392,   6392,
 29221,  29221,  29221,  29221,
 -2208,  -2208,  -2208,  -2208,
  -627,   -627,   -627,   -627,
  6317,   6317,   6317,   6317,
 29278,  29278,  29278,  29278,
 -2200,  -2200,  -2200,  -2200,
  -617,   -617,   -617,   -617,
  6243,   6243,   6243,   6243,
 29334,  29334,  29334,  29334,
 -2192,  -2192,  -2192,  -2192,
  -608,   -608,   -608,   -608,
  6168,   6168,   6168,   6168,
 29391,  29391,  29391,  29391,
 -2183,  -2183,  -2183,  -2183,
  -598,   -598,   -598,   -598,
  6094,   6094,   6094,   6094,
 29446,  29446,  29446,  29446,
 -2174,  -2174,  -2174,  -2174,
  -589,   -589,   -589,   -589,
  6021,   6021,   6021,   6021,
 29502,  29502,  29502,  29502,
 -2165,  -2165,  -2165,  -2165,
  -580,   -580,   -580,   -580,
  5947,   5947,   5947,   5947,
 29557,  29557,  29557,  29557,
 -2156,  -2156,  -2156,  -2156,
  -571,   -571,   -571,   -571,
  5874,   5874,   5874,   5874,
 29612,  29612,  29612,  29612,
 -2147,  -2147,  -2147,  -2147,
  -561,   -561,   -561,   -561,
  5801,   5801,   5801,   5801,
 29666,  29666,  29666,  29666,
 -2138,  -2138,  -2138,  -2138,
  -552,   -552,   -552,   -552,
  5729,   5729,   5729,   5729,
 29720,  29720,  29720,  29720,
 -2128,  -2128,  -2128,  -2128,
  -543,   -543,   -543,   -543,
  5656,   5656,   5656,   5656,
 29773,  29773,  29773,  29773,
 -2118,  -2118,  -2118,  -2118,
  -534,   -534,   -534,   -534,
  5584,   5584,   5584,   5584,
 29826,  29826,  29826,  29826,
 -2108,  -2108,  -2108,  -2108,
  -525,   -525,   -525,   -525,
  5512,   5512,   5512,   5512,
 29879,  29879,  29879,  29879,
 -2098,  -2098,  -2098,  -2098,
  -516,   -516,   -516,   -516,
  5441,   5441,   5441,   5441,
 29931,  29931,  29931,  29931,
 -2088,  -2088,  -2088,  -2088,
  -507,   -507,   -507,   -507,
  5369,   5369,   5369,   5369,
 29983,  29983,  29983,  29983,
 -2077,  -2077,  -2077,  -2077,
  -499,   -499,   -499,   -499,
  5298,   5298,   5298,   5298,
 30035,  30035,  30035,  30035,
 -2067,  -2067,  -2067,  -2067,
  -490,   -490,   -490,   -490,
  5228,   5228,   5228,   5228,
 30086,  30086,  30086,  30086,
 -2056,  -2056,  -2056,  -2056,
  -481,   -481,   -481,   -481,
  5157,   5157,   5157,   5157,
 30137,  30137,  30137,  30137,
 -2045,  -2045,  -2045,  -2045,
  -472,   -472,   -472,   -472,
  5087,   5087,   5087,   5087,
 30187,  30187,  30187,  30187,
 -2034,  -2034,  -2034,  -2034,
  -464,   -464,   -464,   -464,
  5017,   5017,   5017,   5017,
 30237,  30237,  30237,  30237,
 -2022,  -2022,  -2022,  -2022,
  -455,   -455,   -455,   -455,
  4948,   4948,   4948,   4948,
 30286,  30286,  30286,  30286,
 -2011,  -2011,  -2011,  -2011,
  -447,   -447,   -447,   -447,
  4878,   4878,   4878,   4878,
 30335,  30335,  30335,  30335,
 -1999,  -1999,  -1999,  -1999,
  -438,   -438,   -438,   -438,
  4809,   4809,   4809,   4809,
 30384,  30384,  30384,  30384,
 -1987,  -1987,  -1987,  -1987,
  -430,   -430,   -430,   -430,
  4741,   4741,   4741,   4741,
 30432,  30432,  30432,  30432,
 -1975,  -1975,  -1975,  -1975,
  -421,   -421,   -421,   -421,
  4672,   4672,   4672,   4672,
 30480,  30480,  30480,  30480,
 -1963,  -1963,  -1963,  -1963,
  -413,   -413,   -413,   -413,
  4604,   4604,   4604,   4604,
 30527,  30527,  30527,  30527,
 -1950,  -1950,  -1950,  -1950,
  -405,   -405,   -405,   -405,
  4536,   4536,   4536,   4536,
 30574,  30574,  30574,  30574,
 -1938,  -1938,  -1938,  -1938,
  -397,   -397,   -397,   -397,
  4469,   4469,   4469,   4469,
 30621,  30621,  30621,  30621,
 -1925,  -1925,  -1925,  -1925,
  -389,   -389,   -389,   -389,
  4402,   4402,   4402,   4402,
 30667,  30667,  30667,  30667,
 -1912,  -1912,  -1912,  -1912,
  -381,   -381,   -381,   -381,
  4335,   4335,   4335,   4335,
 30712,  30712,  30712,  30712,
 -1899,  -1899,  -1899,  -1899,
  -373,   -373,   -373,   -373,
  4268,   4268,   4268,   4268,
 30758,  30758,  30758,  30758,
 -1885,  -1885,  -1885,  -1885,
  -365,   -365,   -365,   -365,
  4202,   4202,   4202,   4202,
 30802,  30802,  30802,  30802,
 -1872,  -1872,  -1872,  -1872,
  -357,   -357,   -357,   -357,
  4136,   4136,   4136,   4136,
 30847,  30847,  30847,  30847,
 -1858,  -1858,  -1858,  -1858,
  -349,   -349,   -349,   -349,
  4070,   4070,   4070,   4070,
 30891,  30891,  30891,  30891,
 -1844,  -1844,  -1844,  -1844,
  -341,   -341,   -341,   -341,
  4005,   4005,   4005,   4005,
 30934,  30934,  30934,  30934,
 -1830,  -1830,  -1830,  -1830,
  -334,   -334,   -334,   -334,
  3940,   3940,   3940,   3940,
 30977,  30977,  30977,  30977,
 -1815,  -1815,  -1815,  -1815,
  -326,   -326,   -326,   -326,
  3875,   3875,   3875,   3875,
 31019,  31019,  31019,  31019,
 -1801,  -1801,  -1801,  -1801,
  -319,   -319,   -319,   -319,
  3811,   3811,   3811,   3811,
 31062,  31062,  31062,  31062,
 -1786,  -1786,  -1786,  -1786,
  -311,   -311,   -311,   -311,
  3747,   3747,   3747,   3747,
 31103,  31103,  31103,  31103,
 -1771,  -1771,  -1771,  -1771,
  -304,   -304,   -304,   -304,
  3683,   3683,   3683,   3683,
 31144,  31144,  31144,  31144,
 -1756,  -1756,  -1756,  -1756,
  -296,   -296,   -296,   -296,
  3620,   3620,   3620,   3620,
 31185,  31185,  31185,  31185,
 -1741,  -1741,  -1741,  -1741,
  -289,   -289,   -289,   -289,
  3557,   3557,   3557,   3557,
 31225,  31225,  31225,  31225,
 -1725,  -1725,  -1725,  -1725,
  -282,   -282,   -282,   -282,
  3495,   3495,   3495,   3495,
 31265,  31265,  31265,  31265,
 -1709,  -1709,  -1709,  -1709,
  -275,   -275,   -275,   -275,
  3432,   3432,   3432,   3432,
 31304,  31304,  31304,  31304,
 -1694,  -1694,  -1694,  -1694,
  -268,   -268,   -268,   -268,
  3370,   3370,   3370,   3370,
 31343,  31343,  31343,  31343,
 -1677,  -1677,  -1677,  -1677,
  -261,   -261,   -261,   -261,
  3309,   3309,   3309,   3309,
 31381,  31381,  31381,  31381,
 -1661,  -1661,  -1661,  -1661,
  -254,   -254,   -254,   -254,
  3247,   3247,   3247,   3247,
 31419,  31419,  31419,  31419,
 -1645,  -1645,  -1645,  -1645,
  -247,   -247,   -247,   -247,
  3186,   3186,   3186,   3186,
 31457,  31457,  31457,  31457,
 -1628,  -1628,  -1628,  -1628,
  -240,   -240,   -240,   -240,
  3126,   3126,   3126,   3126,
 31494,  31494,  31494,  31494,
 -1611,  -1611,  -1611,  -1611,
  -234,   -234,   -234,   -234,
  3066,   3066,   3066,   3066,
 31530,  31530,  31530,  31530,
 -1594,  -1594,  -1594,  -1594,
  -227,   -227,   -227,   -227,
  3006,   3006,   3006,   3006,
 31566,  31566,  31566,  31566,
 -1577,  -1577,  -1577,  -1577,
  -221,   -221,   -221,   -221,
  2946,   2946,   2946,   2946,
 31602,  31602,  31602,  31602,
 -1559,  -1559,  -1559,  -1559,
  -214,   -214,   -214,   -214,
  2887,   2887,   2887,   2887,
 31637,  31637,  31637,  31637,
 -1542,  -1542,  -1542,  -1542,
  -208,   -208,   -208,   -208,
  2828,   2828,   2828,   2828,
 31671,  31671,  31671,  31671,
 -1524,  -1524,  -1524,  -1524,
  -202,   -202,   -202,   -202,
  2770,   2770,   2770,   2770,
 31705,  31705,  31705,  31705,
 -1506,  -1506,  -1506,  -1506,
  -196,   -196,   -196,   -196,
  2712,   2712,   2712,   2712,
 31739,  31739,  31739,  31739,
 -1487,  -1487,  -1487,  -1487,
  -189,   -189,   -189,   -189,
  2654,   2654,   2654,   2654,
 31772,  31772,  31772,  31772,
 -1469,  -1469,  -1469,  -1469,
  -183,   -183,   -183,   -183,
  2597,   2597,   2597,   2597,
 31804,  31804,  31804,  31804,
 -1450,  -1450,  -1450,  -1450,
  -177,   -177,   -177,   -177,
  2540,   2540,   2540,   2540,
 31836,  31836,  31836,  31836,
 -1431,  -1431,  -1431,  -1431,
  -172,   -172,   -172,   -172,
  2483,   2483,   2483,   2483,
 31868,  31868,  31868,  31868,
 -1412,  -1412,  -1412,  -1412,
  -166,   -166,   -166,   -166,
  2427,   2427,   2427,   2427,
 31899,  31899,  31899,  31899,
 -1392,  -1392,  -1392,  -1392,
  -160,   -160,   -160,   -160,
  2371,   2371,   2371,   2371,
 31930,  31930,  31930,  31930,
 -1373,  -1373,  -1373,  -1373,
  -155,   -155,   -155,   -155,
  2316,   2316,   2316,   2316,
 31960,  31960,  31960,  31960,
 -1353,  -1353,  -1353,  -1353,
  -149,   -149,   -149,   -149,
  2261,   2261,   2261,   2261,
 31989,  31989,  31989,  31989,
 -1333,  -1333,  -1333,  -1333,
  -144,   -144,   -144,   -144,
  2206,   2206,   2206,   2206,
 32018,  32018,  32018,  32018,
 -1313,  -1313,  -1313,  -1313,
  -138,   -138,   -138,   -138,
  2152,   2152,   2152,   2152,
 32047,  32047,  32047,  32047,
 -1293,  -1293,  -1293,  -1293,
  -133,   -133,   -133,   -133,
  2098,   2098,   2098,   2098,
 32075,  32075,  32075,  32075,
 -1272,  -1272,  -1272,  -1272,
  -128,   -128,   -128,   -128,
  2045,   2045,   2045,   2045,
 32102,  32102,  32102,  32102,
 -1251,  -1251,  -1251,  -1251,
  -123,   -123,   -123,   -123,
  1992,   1992,   1992,   1992,
 32129,  32129,  32129,  32129,
 -1230,  -1230,  -1230,  -1230,
  -118,   -118,   -118,   -118,
  1939,   1939,   1939,   1939,
 32156,  32156,  32156,  32156,
 -1209,  -1209,  -1209,  -1209,
  -113,   -113,   -113,   -113,
  1887,   1887,   1887,   1887,
 32181,  32181,  32181,  32181,
 -1187,  -1187,  -1187,  -1187,
  -108,   -108,   -108,   -108,
  1835,   1835,   1835,   1835,
 32207,  32207,  32207,  32207,
 -1166,  -1166,  -1166,  -1166,
  -104,   -104,   -104,   -104,
  1783,   1783,   1783,   1783,
 32232,  32232,  32232,  32232,
 -1144,  -1144,  -1144,  -1144,
   -99,    -99,    -99,    -99,
  1732,   1732,   1732,   1732,
 32256,  32256,  32256,  32256,
 -1121,  -1121,  -1121,  -1121,
   -94,    -94,    -94,    -94,
  1682,   1682,   1682,   1682,
 32280,  32280,  32280,  32280,
 -1099,  -1099,  -1099,  -1099,
   -90,    -90,    -90,    -90,
  1631,   1631,   1631,   1631,
 32303,  32303,  32303,  32303,
 -1076,  -1076,  -1076,  -1076,
   -86,    -86,    -86,    -86,
  1582,   1582,   1582,   1582,
 32326,  32326,  32326,  32326,
 -1054,  -1054,  -1054,  -1054,
   -81,    -81,    -81,    -81,
  1532,   1532,   1532,   1532,
 32348,  32348,  32348,  32348,
 -1031,  -1031,  -1031,  -1031,
   -77,    -77,    -77,    -77,
  1483,   1483,   1483,   1483,
 32369,  32369,  32369,  32369,
 -1007,  -1007,  -1007,  -1007,
   -73,    -73,    -73,    -73,
  1435,   1435,   1435,   1435,
 32391,  32391,  32391,  32391,
  -984,   -984,   -984,   -984,
   -69,    -69,    -69,    -69,
  1387,   1387,   1387,   1387,
 32411,  32411,  32411,  32411,
  -960,   -960,   -960,   -960,
   -66,    -66,    -66,    -66,
  1339,   1339,   1339,   1339,
 32431,  32431,  32431,  32431,
  -936,   -936,   -936,   -936,
   -62,    -62,    -62,    -62,
  1291,   1291,   1291,   1291,
 32450,  32450,  32450,  32450,
  -912,   -912,   -912,   -912,
   -58,    -58,    -58,    -58,
  1245,   1245,   1245,   1245,
 32469,  32469,  32469,  32469,
  -888,   -888,   -888,   -888,
   -55,    -55,    -55,    -55,
  1198,   1198,   1198,   1198,
 32488,  32488,  32488,  32488,
  -863,   -863,   -863,   -863,
   -51,    -51,    -51,    -51,
  1152,   1152,   1152,   1152,
 32505,  32505,  32505,  32505,
  -838,   -838,   -838,   -838,
   -48,    -48,    -48,    -48,
  1107,   1107,   1107,   1107,
 32523,  32523,  32523,  32523,
  -813,   -813,   -813,   -813,
   -45,    -45,    -45,    -45,
  1061,   1061,   1061,   1061,
 32539,  32539,  32539,  32539,
  -788,   -788,   -788,   -788,
   -42,    -42,    -42,    -42,
  1017,   1017,   1017,   1017,
 32555,  32555,  32555,  32555,
  -762,   -762,   -762,   -762,
   -39,    -39,    -39,    -39,
   972,    972,    972,    972,
 32571,  32571,  32571,  32571,
  -737,   -737,   -737,   -737,
   -36,    -36,    -36,    -36,
   929,    929,    929,    929,
 32586,  32586,  32586,  32586,
  -711,   -711,   -711,   -711,
   -33,    -33,    -33,    -33,
   885,    885,    885,    885,
 32600,  32600,  32600,  32600,
  -685,   -685,   -685,   -685,
   -30,    -30,    -30,    -30,
   842,    842,    842,    842,
 32614,  32614,  32614,  32614,
  -658,   -658,   -658,   -658,
   -28,    -28,    -28,    -28,
   800,    800,    800,    800,
 32627,  32627,  32627,  32627,
  -631,   -631,   -631,   -631,
   -25,    -25,    -25,    -25,
   758,    758,    758,    758,
 32640,  32640,  32640,  32640,
  -605,   -605,   -605,   -605,
   -23,    -23,    -23,    -23,
   716,    716,    716,    716,
 32652,  32652,  32652,  32652,
  -577,   -577,   -577,   -577,
   -21,    -21,    -21,    -21,
   675,    675,    675,    675,
 32663,  32663,  32663,  32663,
  -550,   -550,   -550,   -550,
   -18,    -18,    -18,    -18,
   635,    635,    635,    635,
 32674,  32674,  32674,  32674,
  -522,   -522,   -522,   -522,
   -16,    -16,    -16,    -16,
   594,    594,    594,    594,
 32685,  32685,  32685,  32685,
  -495,   -495,   -495,   -495,
   -15,    -15,    -15,    -15,
   555,    555,    555,    555,
 32694,  32694,  32694,  32694,
  -466,   -466,   -466,   -466,
   -13,    -13,    -13,    -13,
   515,    515,    515,    515,
 32703,  32703,  32703,  32703,
  -438,   -438,   -438,   -438,
   -11,    -11,    -11,    -11,
   477,    477,    477,    477,
 32712,  32712,  32712,  32712,
  -410,   -410,   -410,   -410,
   -10,    -10,    -10,    -10,
   438,    438,    438,    438,
 32720,  32720,  32720,  32720,
  -381,   -381,   -381,   -381,
    -8,     -8,     -8,     -8,
   401,    401,    401,    401,
 32727,  32727,  32727,  32727,
  -352,   -352,   -352,   -352,
    -7,     -7,     -7,     -7,
   363,    363,    363,    363,
 32734,  32734,  32734,  32734,
  -322,   -322,   -322,   -322,
    -6,     -6,     -6,     -6,
   326,    326,    326,    326,
 32740,  32740,  32740,  32740,
  -293,   -293,   -293,   -293,
    -4,     -4,     -4,     -4,
   290,    290,    290,    290,
 32746,  32746,  32746,  32746,
  -263,   -263,   -263,   -263,
    -3,     -3,     -3,     -3,
   254,    254,    254,    254,
 32751,  32751,  32751,  32751,
  -233,   -233,   -233,   -233,
    -3,     -3,     -3,     -3,
   218,    218,    218,    218,
 32755,  32755,  32755,  32755,
  -203,   -203,   -203,   -203,
    -2,     -2,     -2,     -2,
   184,    184,    184,    184,
 32759,  32759,  32759,  32759,
  -172,   -172,   -172,   -172,
    -1,     -1,     -1,     -1,
   149,    149,    149,    149,
 32762,  32762,  32762,  32762,
  -141,   -141,   -141,   -141,
    -1,     -1,     -1,     -1,
   115,    115,    115,    115,
 32764,  32764,  32764,  32764,
  -110,   -110,   -110,   -110,
     0,      0,      0,      0,
    82,     82,     82,     82,
 32766,  32766,  32766,  32766,
   -79,    -79,    -79,    -79,
     0,      0,      0,      0,
    49,     49,     49,     49,
 32767,  32767,  32767,  32767,
   -48,    -48,    -48,    -48,
     0,      0,      0,      0,
    16,     16,     16,     16,
 32767,  32767,  32767,  32767,
   -16,    -16,    -16,    -16,
};

const mlib_f32 mlib_filters_u8f_bc[] = {
    -3.9843902588f,   4095.9609832764f,      4.0312042236f,     -0.0077972412f,
   -11.8597869873f,   4095.6496734619f,     12.2800140381f,     -0.0699005127f,
   -19.6112823486f,   4095.0291595459f,     20.7755279541f,     -0.1934051514f,
   -27.2396087646f,   4094.1016387939f,     29.5155487061f,     -0.3775787354f,
   -34.7454986572f,   4092.8693084717f,     38.4978790283f,     -0.6216888428f,
   -42.1296844482f,   4091.3343658447f,     47.7203216553f,     -0.9250030518f,
   -49.3928985596f,   4089.4990081787f,     57.1806793213f,     -1.2867889404f,
   -56.5358734131f,   4087.3654327393f,     66.8767547607f,     -1.7063140869f,
   -63.5593414307f,   4084.9358367920f,     76.8063507080f,     -2.1828460693f,
   -70.4640350342f,   4082.2124176025f,     86.9672698975f,     -2.7156524658f,
   -77.2506866455f,   4079.1973724365f,     97.3573150635f,     -3.3040008545f,
   -83.9200286865f,   4075.8928985596f,    107.9742889404f,     -3.9471588135f,
   -90.4727935791f,   4072.3011932373f,    118.8159942627f,     -4.6443939209f,
   -96.9097137451f,   4068.4244537354f,    129.8802337646f,     -5.3949737549f,
  -103.2315216064f,   4064.2648773193f,    141.1648101807f,     -6.1981658936f,
  -109.4389495850f,   4059.8246612549f,    152.6675262451f,     -7.0532379150f,
  -115.5327301025f,   4055.1060028076f,    164.3861846924f,     -7.9594573975f,
  -121.5135955811f,   4050.1110992432f,    176.3185882568f,     -8.9160919189f,
  -127.3822784424f,   4044.8421478271f,    188.4625396729f,     -9.9224090576f,
  -133.1395111084f,   4039.3013458252f,    200.8158416748f,    -10.9776763916f,
  -138.7860260010f,   4033.4908905029f,    213.3762969971f,    -12.0811614990f,
  -144.3225555420f,   4027.4129791260f,    226.1417083740f,    -13.2321319580f,
  -149.7498321533f,   4021.0698089600f,    239.1098785400f,    -14.4298553467f,
  -155.0685882568f,   4014.4635772705f,    252.2786102295f,    -15.6735992432f,
  -160.2795562744f,   4007.5964813232f,    265.6457061768f,    -16.9626312256f,
  -165.3834686279f,   4000.4707183838f,    279.2089691162f,    -18.2962188721f,
  -170.3810577393f,   3993.0884857178f,    292.9662017822f,    -19.6736297607f,
  -175.2730560303f,   3985.4519805908f,    306.9152069092f,    -21.0941314697f,
  -180.0601959229f,   3977.5634002686f,    321.0537872314f,    -22.5569915771f,
  -184.7432098389f,   3969.4249420166f,    335.3797454834f,    -24.0614776611f,
  -189.3228302002f,   3961.0388031006f,    349.8908843994f,    -25.6068572998f,
  -193.7997894287f,   3952.4071807861f,    364.5850067139f,    -27.1923980713f,
  -198.1748199463f,   3943.5322723389f,    379.4599151611f,    -28.8173675537f,
  -202.4486541748f,   3934.4162750244f,    394.5134124756f,    -30.4810333252f,
  -206.6220245361f,   3925.0613861084f,    409.7433013916f,    -32.1826629639f,
  -210.6956634521f,   3915.4698028564f,    425.1473846436f,    -33.9215240479f,
  -214.6703033447f,   3905.6437225342f,    440.7234649658f,    -35.6968841553f,
  -218.5466766357f,   3895.5853424072f,    456.4693450928f,    -37.5080108643f,
  -222.3255157471f,   3885.2968597412f,    472.3828277588f,    -39.3541717529f,
  -226.0075531006f,   3874.7804718018f,    488.4617156982f,    -41.2346343994f,
  -229.5935211182f,   3864.0383758545f,    504.7038116455f,    -43.1486663818f,
  -233.0841522217f,   3853.0727691650f,    521.1069183350f,    -45.0955352783f,
  -236.4801788330f,   3841.8858489990f,    537.6688385010f,    -47.0745086670f,
  -239.7823333740f,   3830.4798126221f,    554.3873748779f,    -49.0848541260f,
  -242.9913482666f,   3818.8568572998f,    571.2603302002f,    -51.1258392334f,
  -246.1079559326f,   3807.0191802979f,    588.2855072021f,    -53.1967315674f,
  -249.1328887939f,   3794.9689788818f,    605.4607086182f,    -55.2967987061f,
  -252.0668792725f,   3782.7084503174f,    622.7837371826f,    -57.4253082275f,
  -254.9106597900f,   3770.2397918701f,    640.2523956299f,    -59.5815277100f,
  -257.6649627686f,   3757.5652008057f,    657.8644866943f,    -61.7647247314f,
  -260.3305206299f,   3744.6868743896f,    675.6178131104f,    -63.9741668701f,
  -262.9080657959f,   3731.6070098877f,    693.5101776123f,    -66.2091217041f,
  -265.3983306885f,   3718.3278045654f,    711.5393829346f,    -68.4688568115f,
  -267.8020477295f,   3704.8514556885f,    729.7032318115f,    -70.7526397705f,
  -270.1199493408f,   3691.1801605225f,    747.9995269775f,    -73.0597381592f,
  -272.3527679443f,   3677.3161163330f,    766.4260711670f,    -75.3894195557f,
  -274.5012359619f,   3663.2615203857f,    784.9806671143f,    -77.7409515381f,
  -276.5660858154f,   3649.0185699463f,    803.6611175537f,    -80.1136016846f,
  -278.5480499268f,   3634.5894622803f,    822.4652252197f,    -82.5066375732f,
  -280.4478607178f,   3619.9763946533f,    841.3907928467f,    -84.9193267822f,
  -282.2662506104f,   3605.1815643311f,    860.4356231689f,    -87.3509368896f,
  -284.0039520264f,   3590.2071685791f,    879.5975189209f,    -89.8007354736f,
  -285.6616973877f,   3575.0554046631f,    898.8742828369f,    -92.2679901123f,
  -287.2402191162f,   3559.7284698486f,    918.2637176514f,    -94.7519683838f,
  -288.7402496338f,   3544.2285614014f,    937.7636260986f,    -97.2519378662f,
  -290.1625213623f,   3528.5578765869f,    957.3718109131f,    -99.7671661377f,
  -291.5077667236f,   3512.7186126709f,    977.0860748291f,   -102.2969207764f,
  -292.7767181396f,   3496.7129669189f,    996.9042205811f,   -104.8404693604f,
  -293.9701080322f,   3480.5431365967f,   1016.8240509033f,   -107.3970794678f,
  -295.0886688232f,   3464.2113189697f,   1036.8433685303f,   -109.9660186768f,
  -296.1331329346f,   3447.7197113037f,   1056.9599761963f,   -112.5465545654f,
  -297.1042327881f,   3431.0705108643f,   1077.1716766357f,   -115.1379547119f,
  -298.0027008057f,   3414.2659149170f,   1097.4762725830f,   -117.7394866943f,
  -298.8292694092f,   3397.3081207275f,   1117.8715667725f,   -120.3504180908f,
  -299.5846710205f,   3380.1993255615f,   1138.3553619385f,   -122.9700164795f,
  -300.2696380615f,   3362.9417266846f,   1158.9254608154f,   -125.5975494385f,
  -300.8849029541f,   3345.5375213623f,   1179.5796661377f,   -128.2322845459f,
  -301.4311981201f,   3327.9889068604f,   1200.3157806396f,   -130.8734893799f,
  -301.9092559814f,   3310.2980804443f,   1221.1316070557f,   -133.5204315186f,
  -302.3198089600f,   3292.4672393799f,   1242.0249481201f,   -136.1723785400f,
  -302.6635894775f,   3274.4985809326f,   1262.9936065674f,   -138.8285980225f,
  -302.9413299561f,   3256.3943023682f,   1284.0353851318f,   -141.4883575439f,
  -303.1537628174f,   3238.1566009521f,   1305.1480865479f,   -144.1509246826f,
  -303.3016204834f,   3219.7876739502f,   1326.3295135498f,   -146.8155670166f,
  -303.3856353760f,   3201.2897186279f,   1347.5774688721f,   -149.4815521240f,
  -303.4065399170f,   3182.6649322510f,   1368.8897552490f,   -152.1481475830f,
  -303.3650665283f,   3163.9155120850f,   1390.2641754150f,   -154.8146209717f,
  -303.2619476318f,   3145.0436553955f,   1411.6985321045f,   -157.4802398682f,
  -303.0979156494f,   3126.0515594482f,   1433.1906280518f,   -160.1442718506f,
  -302.8737030029f,   3106.9414215088f,   1454.7382659912f,   -162.8059844971f,
  -302.5900421143f,   3087.7154388428f,   1476.3392486572f,   -165.4646453857f,
  -302.2476654053f,   3068.3758087158f,   1497.9913787842f,   -168.1195220947f,
  -301.8473052979f,   3048.9247283936f,   1519.6924591064f,   -170.7698822021f,
  -301.3896942139f,   3029.3643951416f,   1541.4402923584f,   -173.4149932861f,
  -300.8755645752f,   3009.6970062256f,   1563.2326812744f,   -176.0541229248f,
  -300.3056488037f,   2989.9247589111f,   1585.0674285889f,   -178.6865386963f,
  -299.6806793213f,   2970.0498504639f,   1606.9423370361f,   -181.3115081787f,
  -299.0013885498f,   2950.0744781494f,   1628.8552093506f,   -183.9282989502f,
  -298.2685089111f,   2930.0008392334f,   1650.8038482666f,   -186.5361785889f,
  -297.4827728271f,   2909.8311309814f,   1672.7860565186f,   -189.1344146729f,
  -296.6449127197f,   2889.5675506592f,   1694.7996368408f,   -191.7222747803f,
  -295.7556610107f,   2869.2122955322f,   1716.8423919678f,   -194.2990264893f,
  -294.8157501221f,   2848.7675628662f,   1738.9121246338f,   -196.8639373779f,
  -293.8259124756f,   2828.2355499268f,   1761.0066375732f,   -199.4162750244f,
  -292.7868804932f,   2807.6184539795f,   1783.1237335205f,   -201.9553070068f,
  -291.6993865967f,   2786.9184722900f,   1805.2612152100f,   -204.4803009033f,
  -290.5641632080f,   2766.1378021240f,   1827.4168853760f,   -206.9905242920f,
  -289.3819427490f,   2745.2786407471f,   1849.5885467529f,   -209.4852447510f,
  -288.1534576416f,   2724.3431854248f,   1871.7740020752f,   -211.9637298584f,
  -286.8794403076f,   2703.3336334229f,   1893.9710540771f,   -214.4252471924f,
  -285.5606231689f,   2682.2521820068f,   1916.1775054932f,   -216.8690643311f,
  -284.1977386475f,   2661.1010284424f,   1938.3911590576f,   -219.2944488525f,
  -282.7915191650f,   2639.8823699951f,   1960.6098175049f,   -221.7006683350f,
  -281.3426971436f,   2618.5984039307f,   1982.8312835693f,   -224.0869903564f,
  -279.8520050049f,   2597.2513275146f,   2005.0533599854f,   -226.4526824951f,
  -278.3201751709f,   2575.8433380127f,   2027.2738494873f,   -228.7970123291f,
  -276.7479400635f,   2554.3766326904f,   2049.4905548096f,   -231.1192474365f,
  -275.1360321045f,   2532.8534088135f,   2071.7012786865f,   -233.4186553955f,
  -273.4851837158f,   2511.2758636475f,   2093.9038238525f,   -235.6945037842f,
  -271.7961273193f,   2489.6461944580f,   2116.0959930420f,   -237.9460601807f,
  -270.0695953369f,   2467.9665985107f,   2138.2755889893f,   -240.1725921631f,
  -268.3063201904f,   2446.2392730713f,   2160.4404144287f,   -242.3733673096f,
  -266.5070343018f,   2424.4664154053f,   2182.5882720947f,   -244.5476531982f,
  -264.6724700928f,   2402.6502227783f,   2204.7169647217f,   -246.6947174072f,
  -262.8033599854f,   2380.7928924561f,   2226.8242950439f,   -248.8138275146f,
  -260.9004364014f,   2358.8966217041f,   2248.9080657959f,   -250.9042510986f,
  -258.9644317627f,   2336.9636077881f,   2270.9660797119f,   -252.9652557373f,
  -256.9960784912f,   2314.9960479736f,   2292.9961395264f,   -254.9961090088f,
  -254.9961090088f,   2292.9961395264f,   2314.9960479736f,   -256.9960784912f,
  -252.9652557373f,   2270.9660797119f,   2336.9636077881f,   -258.9644317627f,
  -250.9042510986f,   2248.9080657959f,   2358.8966217041f,   -260.9004364014f,
  -248.8138275146f,   2226.8242950439f,   2380.7928924561f,   -262.8033599854f,
  -246.6947174072f,   2204.7169647217f,   2402.6502227783f,   -264.6724700928f,
  -244.5476531982f,   2182.5882720947f,   2424.4664154053f,   -266.5070343018f,
  -242.3733673096f,   2160.4404144287f,   2446.2392730713f,   -268.3063201904f,
  -240.1725921631f,   2138.2755889893f,   2467.9665985107f,   -270.0695953369f,
  -237.9460601807f,   2116.0959930420f,   2489.6461944580f,   -271.7961273193f,
  -235.6945037842f,   2093.9038238525f,   2511.2758636475f,   -273.4851837158f,
  -233.4186553955f,   2071.7012786865f,   2532.8534088135f,   -275.1360321045f,
  -231.1192474365f,   2049.4905548096f,   2554.3766326904f,   -276.7479400635f,
  -228.7970123291f,   2027.2738494873f,   2575.8433380127f,   -278.3201751709f,
  -226.4526824951f,   2005.0533599854f,   2597.2513275146f,   -279.8520050049f,
  -224.0869903564f,   1982.8312835693f,   2618.5984039307f,   -281.3426971436f,
  -221.7006683350f,   1960.6098175049f,   2639.8823699951f,   -282.7915191650f,
  -219.2944488525f,   1938.3911590576f,   2661.1010284424f,   -284.1977386475f,
  -216.8690643311f,   1916.1775054932f,   2682.2521820068f,   -285.5606231689f,
  -214.4252471924f,   1893.9710540771f,   2703.3336334229f,   -286.8794403076f,
  -211.9637298584f,   1871.7740020752f,   2724.3431854248f,   -288.1534576416f,
  -209.4852447510f,   1849.5885467529f,   2745.2786407471f,   -289.3819427490f,
  -206.9905242920f,   1827.4168853760f,   2766.1378021240f,   -290.5641632080f,
  -204.4803009033f,   1805.2612152100f,   2786.9184722900f,   -291.6993865967f,
  -201.9553070068f,   1783.1237335205f,   2807.6184539795f,   -292.7868804932f,
  -199.4162750244f,   1761.0066375732f,   2828.2355499268f,   -293.8259124756f,
  -196.8639373779f,   1738.9121246338f,   2848.7675628662f,   -294.8157501221f,
  -194.2990264893f,   1716.8423919678f,   2869.2122955322f,   -295.7556610107f,
  -191.7222747803f,   1694.7996368408f,   2889.5675506592f,   -296.6449127197f,
  -189.1344146729f,   1672.7860565186f,   2909.8311309814f,   -297.4827728271f,
  -186.5361785889f,   1650.8038482666f,   2930.0008392334f,   -298.2685089111f,
  -183.9282989502f,   1628.8552093506f,   2950.0744781494f,   -299.0013885498f,
  -181.3115081787f,   1606.9423370361f,   2970.0498504639f,   -299.6806793213f,
  -178.6865386963f,   1585.0674285889f,   2989.9247589111f,   -300.3056488037f,
  -176.0541229248f,   1563.2326812744f,   3009.6970062256f,   -300.8755645752f,
  -173.4149932861f,   1541.4402923584f,   3029.3643951416f,   -301.3896942139f,
  -170.7698822021f,   1519.6924591064f,   3048.9247283936f,   -301.8473052979f,
  -168.1195220947f,   1497.9913787842f,   3068.3758087158f,   -302.2476654053f,
  -165.4646453857f,   1476.3392486572f,   3087.7154388428f,   -302.5900421143f,
  -162.8059844971f,   1454.7382659912f,   3106.9414215088f,   -302.8737030029f,
  -160.1442718506f,   1433.1906280518f,   3126.0515594482f,   -303.0979156494f,
  -157.4802398682f,   1411.6985321045f,   3145.0436553955f,   -303.2619476318f,
  -154.8146209717f,   1390.2641754150f,   3163.9155120850f,   -303.3650665283f,
  -152.1481475830f,   1368.8897552490f,   3182.6649322510f,   -303.4065399170f,
  -149.4815521240f,   1347.5774688721f,   3201.2897186279f,   -303.3856353760f,
  -146.8155670166f,   1326.3295135498f,   3219.7876739502f,   -303.3016204834f,
  -144.1509246826f,   1305.1480865479f,   3238.1566009521f,   -303.1537628174f,
  -141.4883575439f,   1284.0353851318f,   3256.3943023682f,   -302.9413299561f,
  -138.8285980225f,   1262.9936065674f,   3274.4985809326f,   -302.6635894775f,
  -136.1723785400f,   1242.0249481201f,   3292.4672393799f,   -302.3198089600f,
  -133.5204315186f,   1221.1316070557f,   3310.2980804443f,   -301.9092559814f,
  -130.8734893799f,   1200.3157806396f,   3327.9889068604f,   -301.4311981201f,
  -128.2322845459f,   1179.5796661377f,   3345.5375213623f,   -300.8849029541f,
  -125.5975494385f,   1158.9254608154f,   3362.9417266846f,   -300.2696380615f,
  -122.9700164795f,   1138.3553619385f,   3380.1993255615f,   -299.5846710205f,
  -120.3504180908f,   1117.8715667725f,   3397.3081207275f,   -298.8292694092f,
  -117.7394866943f,   1097.4762725830f,   3414.2659149170f,   -298.0027008057f,
  -115.1379547119f,   1077.1716766357f,   3431.0705108643f,   -297.1042327881f,
  -112.5465545654f,   1056.9599761963f,   3447.7197113037f,   -296.1331329346f,
  -109.9660186768f,   1036.8433685303f,   3464.2113189697f,   -295.0886688232f,
  -107.3970794678f,   1016.8240509033f,   3480.5431365967f,   -293.9701080322f,
  -104.8404693604f,    996.9042205811f,   3496.7129669189f,   -292.7767181396f,
  -102.2969207764f,    977.0860748291f,   3512.7186126709f,   -291.5077667236f,
   -99.7671661377f,    957.3718109131f,   3528.5578765869f,   -290.1625213623f,
   -97.2519378662f,    937.7636260986f,   3544.2285614014f,   -288.7402496338f,
   -94.7519683838f,    918.2637176514f,   3559.7284698486f,   -287.2402191162f,
   -92.2679901123f,    898.8742828369f,   3575.0554046631f,   -285.6616973877f,
   -89.8007354736f,    879.5975189209f,   3590.2071685791f,   -284.0039520264f,
   -87.3509368896f,    860.4356231689f,   3605.1815643311f,   -282.2662506104f,
   -84.9193267822f,    841.3907928467f,   3619.9763946533f,   -280.4478607178f,
   -82.5066375732f,    822.4652252197f,   3634.5894622803f,   -278.5480499268f,
   -80.1136016846f,    803.6611175537f,   3649.0185699463f,   -276.5660858154f,
   -77.7409515381f,    784.9806671143f,   3663.2615203857f,   -274.5012359619f,
   -75.3894195557f,    766.4260711670f,   3677.3161163330f,   -272.3527679443f,
   -73.0597381592f,    747.9995269775f,   3691.1801605225f,   -270.1199493408f,
   -70.7526397705f,    729.7032318115f,   3704.8514556885f,   -267.8020477295f,
   -68.4688568115f,    711.5393829346f,   3718.3278045654f,   -265.3983306885f,
   -66.2091217041f,    693.5101776123f,   3731.6070098877f,   -262.9080657959f,
   -63.9741668701f,    675.6178131104f,   3744.6868743896f,   -260.3305206299f,
   -61.7647247314f,    657.8644866943f,   3757.5652008057f,   -257.6649627686f,
   -59.5815277100f,    640.2523956299f,   3770.2397918701f,   -254.9106597900f,
   -57.4253082275f,    622.7837371826f,   3782.7084503174f,   -252.0668792725f,
   -55.2967987061f,    605.4607086182f,   3794.9689788818f,   -249.1328887939f,
   -53.1967315674f,    588.2855072021f,   3807.0191802979f,   -246.1079559326f,
   -51.1258392334f,    571.2603302002f,   3818.8568572998f,   -242.9913482666f,
   -49.0848541260f,    554.3873748779f,   3830.4798126221f,   -239.7823333740f,
   -47.0745086670f,    537.6688385010f,   3841.8858489990f,   -236.4801788330f,
   -45.0955352783f,    521.1069183350f,   3853.0727691650f,   -233.0841522217f,
   -43.1486663818f,    504.7038116455f,   3864.0383758545f,   -229.5935211182f,
   -41.2346343994f,    488.4617156982f,   3874.7804718018f,   -226.0075531006f,
   -39.3541717529f,    472.3828277588f,   3885.2968597412f,   -222.3255157471f,
   -37.5080108643f,    456.4693450928f,   3895.5853424072f,   -218.5466766357f,
   -35.6968841553f,    440.7234649658f,   3905.6437225342f,   -214.6703033447f,
   -33.9215240479f,    425.1473846436f,   3915.4698028564f,   -210.6956634521f,
   -32.1826629639f,    409.7433013916f,   3925.0613861084f,   -206.6220245361f,
   -30.4810333252f,    394.5134124756f,   3934.4162750244f,   -202.4486541748f,
   -28.8173675537f,    379.4599151611f,   3943.5322723389f,   -198.1748199463f,
   -27.1923980713f,    364.5850067139f,   3952.4071807861f,   -193.7997894287f,
   -25.6068572998f,    349.8908843994f,   3961.0388031006f,   -189.3228302002f,
   -24.0614776611f,    335.3797454834f,   3969.4249420166f,   -184.7432098389f,
   -22.5569915771f,    321.0537872314f,   3977.5634002686f,   -180.0601959229f,
   -21.0941314697f,    306.9152069092f,   3985.4519805908f,   -175.2730560303f,
   -19.6736297607f,    292.9662017822f,   3993.0884857178f,   -170.3810577393f,
   -18.2962188721f,    279.2089691162f,   4000.4707183838f,   -165.3834686279f,
   -16.9626312256f,    265.6457061768f,   4007.5964813232f,   -160.2795562744f,
   -15.6735992432f,    252.2786102295f,   4014.4635772705f,   -155.0685882568f,
   -14.4298553467f,    239.1098785400f,   4021.0698089600f,   -149.7498321533f,
   -13.2321319580f,    226.1417083740f,   4027.4129791260f,   -144.3225555420f,
   -12.0811614990f,    213.3762969971f,   4033.4908905029f,   -138.7860260010f,
   -10.9776763916f,    200.8158416748f,   4039.3013458252f,   -133.1395111084f,
    -9.9224090576f,    188.4625396729f,   4044.8421478271f,   -127.3822784424f,
    -8.9160919189f,    176.3185882568f,   4050.1110992432f,   -121.5135955811f,
    -7.9594573975f,    164.3861846924f,   4055.1060028076f,   -115.5327301025f,
    -7.0532379150f,    152.6675262451f,   4059.8246612549f,   -109.4389495850f,
    -6.1981658936f,    141.1648101807f,   4064.2648773193f,   -103.2315216064f,
    -5.3949737549f,    129.8802337646f,   4068.4244537354f,    -96.9097137451f,
    -4.6443939209f,    118.8159942627f,   4072.3011932373f,    -90.4727935791f,
    -3.9471588135f,    107.9742889404f,   4075.8928985596f,    -83.9200286865f,
    -3.3040008545f,     97.3573150635f,   4079.1973724365f,    -77.2506866455f,
    -2.7156524658f,     86.9672698975f,   4082.2124176025f,    -70.4640350342f,
    -2.1828460693f,     76.8063507080f,   4084.9358367920f,    -63.5593414307f,
    -1.7063140869f,     66.8767547607f,   4087.3654327393f,    -56.5358734131f,
    -1.2867889404f,     57.1806793213f,   4089.4990081787f,    -49.3928985596f,
    -0.9250030518f,     47.7203216553f,   4091.3343658447f,    -42.1296844482f,
    -0.6216888428f,     38.4978790283f,   4092.8693084717f,    -34.7454986572f,
    -0.3775787354f,     29.5155487061f,   4094.1016387939f,    -27.2396087646f,
    -0.1934051514f,     20.7755279541f,   4095.0291595459f,    -19.6112823486f,
    -0.0699005127f,     12.2800140381f,   4095.6496734619f,    -11.8597869873f,
    -0.0077972412f,      4.0312042236f,   4095.9609832764f,     -3.9843902588f,
};

const mlib_f32 mlib_filters_s16f_bc[] = {
  -0.1247559786f,  255.9993900061f,    0.1254879236f,   -0.0001219511f,
  -0.3728059530f,  255.9945164919f,    0.3793848753f,   -0.0010954142f,
  -0.6189113855f,  255.9847859144f,    0.6371623278f,   -0.0030368567f,
  -0.8630779982f,  255.9702154398f,    0.8988031149f,   -0.0059405565f,
  -1.1053115129f,  255.9508222342f,    1.1642900705f,   -0.0098007917f,
  -1.3456176519f,  255.9266234636f,    1.4336060286f,   -0.0146118402f,
  -1.5840021372f,  255.8976362944f,    1.7067338228f,   -0.0203679800f,
  -1.8204706907f,  255.8638778925f,    1.9836562872f,   -0.0270634890f,
  -2.0550290346f,  255.8253654242f,    2.2643562555f,   -0.0346926451f,
  -2.2876828909f,  255.7821160555f,    2.5488165617f,   -0.0432497263f,
  -2.5184379816f,  255.7341469526f,    2.8370200396f,   -0.0527290106f,
  -2.7473000288f,  255.6814752817f,    3.1289495230f,   -0.0631247759f,
  -2.9742747545f,  255.6241182089f,    3.4245878458f,   -0.0744313002f,
  -3.1993678808f,  255.5620929003f,    3.7239178419f,   -0.0866428614f,
  -3.4225851297f,  255.4954165220f,    4.0269223452f,   -0.0997537374f,
  -3.6439322233f,  255.4241062403f,    4.3335841894f,   -0.1137582064f,
  -3.8634148836f,  255.3481792212f,    4.6438862085f,   -0.1286505461f,
  -4.0810388327f,  255.2676526308f,    4.9578112364f,   -0.1444250345f,
  -4.2968097925f,  255.1825436354f,    5.2753421068f,   -0.1610759497f,
  -4.5107334852f,  255.0928694010f,    5.5964616537f,   -0.1785975695f,
  -4.7228156328f,  254.9986470938f,    5.9211527109f,   -0.1969841719f,
  -4.9330619574f,  254.8998938799f,    6.2493981123f,   -0.2162300348f,
  -5.1414781809f,  254.7966269255f,    6.5811806917f,   -0.2363294363f,
  -5.3480700254f,  254.6888633966f,    6.9164832830f,   -0.2572766542f,
  -5.5528432131f,  254.5766204596f,    7.2552887201f,   -0.2790659666f,
  -5.7558034658f,  254.4599152803f,    7.5975798368f,   -0.3016916513f,
  -5.9569565058f,  254.3387650251f,    7.9433394670f,   -0.3251479864f,
  -6.1563080549f,  254.2131868601f,    8.2925504446f,   -0.3494292498f,
  -6.3538638353f,  254.0831979513f,    8.6451956034f,   -0.3745297194f,
  -6.5496295691f,  253.9488154650f,    9.0012577772f,   -0.4004436731f,
  -6.7436109781f,  253.8100565672f,    9.3607198000f,   -0.4271653891f,
  -6.9358137846f,  253.6669384241f,    9.7235645056f,   -0.4546891451f,
  -7.1262437105f,  253.5194782019f,   10.0897747278f,   -0.4830092192f,
  -7.3149064779f,  253.3676930666f,   10.4593333006f,   -0.5121198893f,
  -7.5018078089f,  253.2116001844f,   10.8322230577f,   -0.5420154333f,
  -7.6869534254f,  253.0512167215f,   11.2084268332f,   -0.5726901293f,
  -7.8703490496f,  252.8865598440f,   11.5879274607f,   -0.6041382551f,
  -8.0520004034f,  252.7176467180f,   11.9707077742f,   -0.6363540888f,
  -8.2319132090f,  252.5444945097f,   12.3567506075f,   -0.6693319082f,
  -8.4100931883f,  252.3671203852f,   12.7460387945f,   -0.7030659914f,
  -8.5865460634f,  252.1855415106f,   13.1385551691f,   -0.7375506163f,
  -8.7612775564f,  251.9997750521f,   13.5342825651f,   -0.7727800608f,
  -8.9342933893f,  251.8098381758f,   13.9332038164f,   -0.8087486029f,
  -9.1055992842f,  251.6157480478f,   14.3353017569f,   -0.8454505205f,
  -9.2752009630f,  251.4175218344f,   14.7405592203f,   -0.8828800917f,
  -9.4431041479f,  251.2151767015f,   15.1489590406f,   -0.9210315943f,
  -9.6093145609f,  251.0087298155f,   15.5604840517f,   -0.9598993063f,
  -9.7738379240f,  250.7981983423f,   15.9751170874f,   -0.9994775057f,
  -9.9366799593f,  250.5835994482f,   16.3928409815f,   -1.0397604704f,
 -10.0978463888f,  250.3649502993f,   16.8136385679f,   -1.0807424784f,
 -10.2573429346f,  250.1422680616f,   17.2374926805f,   -1.1224178076f,
 -10.4151753187f,  249.9155699015f,   17.6643861532f,   -1.1647807360f,
 -10.5713492632f,  249.6848729849f,   18.0943018198f,   -1.2078255415f,
 -10.7258704901f,  249.4501944780f,   18.5272225142f,   -1.2515465021f,
 -10.8787447214f,  249.2115515471f,   18.9631310701f,   -1.2959378958f,
 -11.0299776793f,  248.9689613581f,   19.4020103216f,   -1.3409940004f,
 -11.1795750856f,  248.7224410772f,   19.8438431025f,   -1.3867090940f,
 -11.3275426626f,  248.4720078707f,   20.2886122465f,   -1.4330774546f,
 -11.4738861322f,  248.2176789045f,   20.7363005877f,   -1.4800933599f,
 -11.6186112165f,  247.9594713449f,   21.1868909597f,   -1.5277510881f,
 -11.7617236376f,  247.6974023581f,   21.6403661966f,   -1.5760449171f,
 -11.9032291174f,  247.4314891100f,   22.0967091322f,   -1.6249691248f,
 -12.0431333780f,  247.1617487669f,   22.5559026003f,   -1.6745179892f,
 -12.1814421415f,  246.8881984949f,   23.0179294348f,   -1.7246857882f,
 -12.3181611300f,  246.6108554602f,   23.4827724695f,   -1.7754667997f,
 -12.4532960653f,  246.3297368288f,   23.9504145384f,   -1.8268553019f,
 -12.5868526697f,  246.0448597670f,   24.4208384752f,   -1.8788455725f,
 -12.7188366652f,  245.7562414408f,   24.8940271139f,   -1.9314318895f,
 -12.8492537737f,  245.4638990164f,   25.3699632883f,   -1.9846085310f,
 -12.9781097174f,  245.1678496599f,   25.8486298323f,   -2.0383697748f,
 -13.1054102182f,  244.8681105375f,   26.3300095797f,   -2.0927098989f,
 -13.2311609983f,  244.5646988153f,   26.8140853643f,   -2.1476231813f,
 -13.3553677797f,  244.2576316595f,   27.3008400202f,   -2.2031039000f,
 -13.4780362844f,  243.9469262362f,   27.7902563810f,   -2.2591463327f,
 -13.5991722345f,  243.6325997114f,   28.2823172808f,   -2.3157447577f,
 -13.7187813520f,  243.3146692514f,   28.7770055532f,   -2.3728934526f,
 -13.8368693590f,  242.9931520224f,   29.2743040323f,   -2.4305866957f,
 -13.9534419775f,  242.6680651903f,   29.7741955519f,   -2.4888187647f,
 -14.0685049295f,  242.3394259214f,   30.2766629457f,   -2.5475839376f,
 -14.1820639372f,  242.0072513819f,   30.7816890478f,   -2.6068764925f,
 -14.2941247225f,  241.6715587378f,   31.2892566919f,   -2.6666907072f,
 -14.4046930075f,  241.3323651552f,   31.7993487120f,   -2.7270208597f,
 -14.5137745142f,  240.9896878004f,   32.3119479418f,   -2.7878612280f,
 -14.6213749647f,  240.6435438395f,   32.8270372152f,   -2.8492060900f,
 -14.7275000811f,  240.2939504385f,   33.3445993662f,   -2.9110497236f,
 -14.8321555853f,  239.9409247637f,   33.8646172285f,   -2.9733864069f,
 -14.9353471994f,  239.5844839811f,   34.3870736361f,   -3.0362104177f,
 -15.0370806456f,  239.2246452570f,   34.9119514227f,   -3.0995160341f,
 -15.1373616457f,  238.8614257574f,   35.4392334223f,   -3.1632975340f,
 -15.2361959219f,  238.4948426485f,   35.9689024687f,   -3.2275491953f,
 -15.3335891962f,  238.1249130964f,   36.5009413958f,   -3.2922652960f,
 -15.4295471907f,  237.7516542673f,   37.0353330374f,   -3.3574401140f,
 -15.5240756273f,  237.3750833273f,   37.5720602274f,   -3.4230679274f,
 -15.6171802282f,  236.9952174425f,   38.1111057997f,   -3.4891430140f,
 -15.7088667154f,  236.6120737791f,   38.6524525881f,   -3.5556596518f,
 -15.7991408110f,  236.2256695032f,   39.1960834265f,   -3.6226121187f,
 -15.8880082369f,  235.8360217810f,   39.7419811487f,   -3.6899946928f,
 -15.9754747152f,  235.4431477785f,   40.2901285887f,   -3.7578016520f,
 -16.0615459681f,  235.0470646620f,   40.8405085802f,   -3.8260272741f,
 -16.1462277174f,  234.6477895975f,   41.3931039572f,   -3.8946658373f,
 -16.2295256853f,  234.2453397512f,   41.9478975534f,   -3.9637116194f,
 -16.3114455938f,  233.8397322893f,   42.5048722029f,   -4.0331588984f,
 -16.3919931650f,  233.4309843779f,   43.0640107393f,   -4.1030019522f,
 -16.4711741209f,  233.0191131830f,   43.6252959967f,   -4.1732350588f,
 -16.5489941835f,  232.6041358709f,   44.1887108088f,   -4.2438524961f,
 -16.6254590750f,  232.1860696077f,   44.7542380095f,   -4.3148485422f,
 -16.7005745173f,  231.7649315596f,   45.3218604326f,   -4.3862174749f,
 -16.7743462324f,  231.3407388926f,   45.8915609121f,   -4.4579535723f,
 -16.8467799425f,  230.9135087729f,   46.4633222818f,   -4.5300511122f,
 -16.9178813696f,  230.4832583666f,   47.0371273756f,   -4.6025043726f,
 -16.9876562357f,  230.0500048399f,   47.6129590273f,   -4.6753076315f,
 -17.0561102629f,  229.6137653589f,   48.1908000708f,   -4.7484551668f,
 -17.1232491732f,  229.1745570898f,   48.7706333399f,   -4.8219412565f,
 -17.1890786886f,  228.7323971987f,   49.3524416685f,   -4.8957601786f,
 -17.2536045313f,  228.2873028517f,   49.9362078905f,   -4.9699062109f,
 -17.3168324232f,  227.8392912149f,   50.5219148397f,   -5.0443736315f,
 -17.3787680864f,  227.3883794546f,   51.1095453501f,   -5.1191567183f,
 -17.4394172430f,  226.9345847368f,   51.6990822554f,   -5.1942497492f,
 -17.4987856150f,  226.4779242277f,   52.2905083895f,   -5.2696470022f,
 -17.5568789244f,  226.0184150934f,   52.8838065863f,   -5.3453427553f,
 -17.6137028933f,  225.5560745001f,   53.4789596796f,   -5.4213312864f,
 -17.6692632437f,  225.0909196138f,   54.0759505033f,   -5.4976068735f,
 -17.7235656977f,  224.6229676008f,   54.6747618914f,   -5.5741637945f,
 -17.7766159773f,  224.1522356272f,   55.2753766775f,   -5.6509963274f,
 -17.8284198046f,  223.6787408590f,   55.8777776957f,   -5.7280987501f,
 -17.8789829016f,  223.2025004625f,   56.4819477797f,   -5.8054653406f,
 -17.9283109903f,  222.7235316038f,   57.0878697634f,   -5.8830903769f,
 -17.9764097929f,  222.2418514490f,   57.6955264807f,   -5.9609681368f,
 -18.0232850313f,  221.7574771643f,   58.3049007654f,   -6.0390928984f,
 -18.0689424276f,  221.2704259157f,   58.9159754515f,   -6.1174589396f,
 -18.1133877039f,  220.7807148695f,   59.5287333727f,   -6.1960605383f,
 -18.1566265821f,  220.2883611917f,   60.1431573629f,   -6.2748919725f,
 -18.1986647844f,  219.7933820486f,   60.7592302561f,   -6.3539475203f,
 -18.2395080328f,  219.2957946062f,   61.3769348860f,   -6.4332214594f,
 -18.2791620493f,  218.7956160307f,   61.9962540865f,   -6.5127080679f,
 -18.3176325560f,  218.2928634882f,   62.6171706915f,   -6.5924016237f,
 -18.3549252748f,  217.7875541449f,   63.2396675348f,   -6.6722964048f,
 -18.3910459280f,  217.2797051668f,   63.8637274504f,   -6.7523866892f,
 -18.4260002375f,  216.7693337202f,   64.4893332720f,   -6.8326667547f,
 -18.4597939253f,  216.2564569712f,   65.1164678335f,   -6.9131308794f,
 -18.4924327135f,  215.7410920858f,   65.7451139688f,   -6.9937733412f,
 -18.5239223242f,  215.2232562304f,   66.3752545118f,   -7.0745884180f,
 -18.5542684793f,  214.7029665709f,   67.0068722963f,   -7.1555703878f,
 -18.5834769011f,  214.1802402735f,   67.6399501562f,   -7.2367135286f,
 -18.6115533113f,  213.6550945044f,   68.2744709253f,   -7.3180121183f,
 -18.6385034323f,  213.1275464296f,   68.9104174376f,   -7.3994604349f,
 -18.6643329859f,  212.5976132154f,   69.5477725267f,   -7.4810527563f,
 -18.6890476942f,  212.0653120279f,   70.1865190268f,   -7.5627833605f,
 -18.7126532793f,  211.5306600332f,   70.8266397715f,   -7.6446465254f,
 -18.7351554632f,  210.9936743975f,   71.4681175947f,   -7.7266365290f,
 -18.7565599680f,  210.4543722868f,   72.1109353304f,   -7.8087476492f,
 -18.7768725157f,  209.9127708673f,   72.7550758123f,   -7.8909741640f,
 -18.7960988283f,  209.3688873053f,   73.4005218744f,   -7.9733103514f,
 -18.8142446280f,  208.8227387667f,   74.0472563505f,   -8.0557504892f,
 -18.8313156366f,  208.2743424177f,   74.6952620745f,   -8.1382888556f,
 -18.8473175764f,  207.7237154245f,   75.3445218801f,   -8.2209197283f,
 -18.8622561693f,  207.1708749533f,   75.9950186014f,   -8.3036373854f,
 -18.8761371374f,  206.6158381701f,   76.6467350721f,   -8.3864361048f,
 -18.8889662027f,  206.0586222410f,   77.2996541262f,   -8.4693101645f,
 -18.9007490873f,  205.4992443323f,   77.9537585974f,   -8.5522538424f,
 -18.9114915133f,  204.9377216101f,   78.6090313196f,   -8.6352614164f,
 -18.9211992025f,  204.3740712404f,   79.2654551268f,   -8.7183271646f,
 -18.9298778772f,  203.8083103895f,   79.9230128527f,   -8.8014453650f,
 -18.9375332594f,  203.2404562235f,   80.5816873312f,   -8.8846102953f,
 -18.9441710711f,  202.6705259085f,   81.2414613962f,   -8.9678162336f,
 -18.9497970343f,  202.0985366106f,   81.9023178816f,   -9.0510574579f,
 -18.9544168711f,  201.5245054960f,   82.5642396212f,   -9.1343282461f,
 -18.9580363035f,  200.9484497309f,   83.2272094488f,   -9.2176228762f,
 -18.9606610537f,  200.3703864813f,   83.8912101984f,   -9.3009356260f,
 -18.9622968435f,  199.7903329134f,   84.5562247038f,   -9.3842607737f,
 -18.9629493952f,  199.2083061934f,   85.2222357988f,   -9.4675925970f,
 -18.9626244307f,  198.6243234873f,   85.8892263174f,   -9.5509253740f,
 -18.9613276720f,  198.0384019613f,   86.5571790934f,   -9.6342533827f,
 -18.9590648413f,  197.4505587816f,   87.2260769606f,   -9.7175709009f,
 -18.9558416605f,  196.8608111143f,   87.8959027529f,   -9.8008722067f,
 -18.9516638517f,  196.2691761255f,   88.5666393042f,   -9.8841515779f,
 -18.9465371370f,  195.6756709814f,   89.2382694483f,   -9.9674032927f,
 -18.9404672384f,  195.0803128481f,   89.9107760191f,  -10.0506216288f,
 -18.9334598780f,  194.4831188917f,   90.5841418505f,  -10.1338008642f,
 -18.9255207777f,  193.8841062784f,   91.2583497763f,  -10.2169352770f,
 -18.9166556597f,  193.2832921743f,   91.9333826303f,  -10.3000191450f,
 -18.9068702459f,  192.6806937456f,   92.6092232466f,  -10.3830467463f,
 -18.8961702585f,  192.0763281584f,   93.2858544588f,  -10.4660123587f,
 -18.8845614195f,  191.4702125788f,   93.9632591009f,  -10.5489102602f,
 -18.8720494509f,  190.8623641729f,   94.6414200068f,  -10.6317347288f,
 -18.8586400747f,  190.2528001070f,   95.3203200102f,  -10.7144800425f,
 -18.8443390131f,  189.6415375471f,   95.9999419451f,  -10.7971404791f,
 -18.8291519880f,  189.0285936594f,   96.6802686453f,  -10.8797103167f,
 -18.8130847216f,  188.4139856100f,   97.3612829447f,  -10.9621838331f,
 -18.7961429358f,  187.7977305651f,   98.0429676771f,  -11.0445553064f,
 -18.7783323526f,  187.1798456907f,   98.7253056765f,  -11.1268190145f,
 -18.7596586943f,  186.5603481531f,   99.4082797766f,  -11.2089692354f,
 -18.7401276827f,  185.9392551184f,  100.0918728113f,  -11.2910002470f,
 -18.7197450399f,  185.3165837526f,  100.7760676146f,  -11.3729063272f,
 -18.6985164881f,  184.6923512220f,  101.4608470201f,  -11.4546817541f,
 -18.6764477491f,  184.0665746927f,  102.1461938620f,  -11.5363208055f,
 -18.6535445452f,  183.4392713308f,  102.8320909739f,  -11.6178177595f,
 -18.6298125982f,  182.8104583025f,  103.5185211897f,  -11.6991668940f,
 -18.6052576303f,  182.1801527739f,  104.2054673433f,  -11.7803624868f,
 -18.5798853636f,  181.5483719110f,  104.8929122686f,  -11.8613988161f,
 -18.5537015200f,  180.9151328802f,  105.5808387995f,  -11.9422701597f,
 -18.5267118216f,  180.2804528475f,  106.2692297697f,  -12.0229707956f,
 -18.4989219904f,  179.6443489790f,  106.9580680132f,  -12.1034950018f,
 -18.4703377485f,  179.0068384409f,  107.6473363638f,  -12.1838370562f,
 -18.4409648180f,  178.3679383993f,  108.3370176554f,  -12.2639912367f,
 -18.4108089209f,  177.7276660204f,  109.0270947218f,  -12.3439518213f,
 -18.3798757792f,  177.0860384703f,  109.7175503969f,  -12.4237130880f,
 -18.3481711149f,  176.4430729151f,  110.4083675146f,  -12.5032693148f,
 -18.3157006502f,  175.7987865210f,  111.0995289087f,  -12.5826147795f,
 -18.2824701071f,  175.1531964540f,  111.7910174131f,  -12.6617437601f,
 -18.2484852076f,  174.5063198805f,  112.4828158617f,  -12.7406505346f,
 -18.2137516737f,  173.8581739664f,  113.1749070883f,  -12.8193293810f,
 -18.1782752275f,  173.2087758780f,  113.8672739267f,  -12.8977745771f,
 -18.1420615911f,  172.5581427813f,  114.5598992109f,  -12.9759804010f,
 -18.1051164865f,  171.9062918425f,  115.2527657747f,  -13.0539411306f,
 -18.0674456358f,  171.2532402277f,  115.9458564520f,  -13.1316510439f,
 -18.0290547609f,  170.5990051031f,  116.6391540766f,  -13.2091044188f,
 -17.9899495840f,  169.9436036348f,  117.3326414824f,  -13.2862955332f,
 -17.9501358271f,  169.2870529890f,  118.0263015032f,  -13.3632186651f,
 -17.9096192122f,  168.6293703318f,  118.7201169729f,  -13.4398680925f,
 -17.8684054613f,  167.9705728292f,  119.4140707254f,  -13.5162380934f,
 -17.8265002966f,  167.3106776476f,  120.1081455946f,  -13.5923229456f,
 -17.7839094400f,  166.6497019529f,  120.8023244143f,  -13.6681169271f,
 -17.7406386137f,  165.9876629114f,  121.4965900183f,  -13.7436143160f,
 -17.6966935396f,  165.3245776892f,  122.1909252405f,  -13.8188093901f,
 -17.6520799398f,  164.6604634523f,  122.8853129148f,  -13.8936964273f,
 -17.6068035364f,  163.9953373671f,  123.5797358751f,  -13.9682697058f,
 -17.5608700514f,  163.3292165995f,  124.2741769552f,  -14.0425235033f,
 -17.5142852068f,  162.6621183157f,  124.9686189890f,  -14.1164520979f,
 -17.4670547247f,  161.9940596819f,  125.6630448103f,  -14.1900497675f,
 -17.4191843271f,  161.3250578642f,  126.3574372530f,  -14.2633107901f,
 -17.3706797361f,  160.6551300287f,  127.0517791510f,  -14.3362294436f,
 -17.3215466738f,  159.9842933416f,  127.7460533381f,  -14.4088000059f,
 -17.2717908621f,  159.3125649691f,  128.4402426481f,  -14.4810167551f,
 -17.2214180231f,  158.6399620771f,  129.1343299150f,  -14.5528739691f,
 -17.1704338789f,  157.9665018320f,  129.8282979727f,  -14.6243659258f,
 -17.1188441515f,  157.2922013998f,  130.5221296549f,  -14.6954869032f,
 -17.0666545630f,  156.6170779467f,  131.2158077955f,  -14.7662311792f,
 -17.0138708353f,  155.9411486387f,  131.9093152285f,  -14.8365930319f,
 -16.9604986906f,  155.2644306421f,  132.6026347876f,  -14.9065667391f,
 -16.9065438509f,  154.5869411230f,  133.2957493067f,  -14.9761465788f,
 -16.8520120382f,  153.9086972475f,  133.9886416197f,  -15.0453268290f,
 -16.7969089746f,  153.2297161818f,  134.6812945604f,  -15.1141017675f,
 -16.7412403822f,  152.5500150919f,  135.3736909628f,  -15.1824656725f,
 -16.6850119829f,  151.8696111441f,  136.0658136606f,  -15.2504128218f,
 -16.6282294989f,  151.1885215044f,  136.7576454878f,  -15.3179374933f,
 -16.5708986521f,  150.5067633390f,  137.4491692781f,  -15.3850339651f,
 -16.5130251646f,  149.8243538141f,  138.1403678656f,  -15.4516965151f,
 -16.4546147585f,  149.1413100958f,  138.8312240839f,  -15.5179194212f,
 -16.3956731558f,  148.4576493502f,  139.5217207670f,  -15.5836969614f,
 -16.3362060785f,  147.7733887434f,  140.2118407488f,  -15.6490234137f,
 -16.2762192488f,  147.0885454416f,  140.9015668631f,  -15.7138930559f,
 -16.2157183886f,  146.4031366110f,  141.5908819437f,  -15.7783001661f,
 -16.1547092199f,  145.7171794176f,  142.2797688246f,  -15.8422390223f,
 -16.0931974649f,  145.0306910276f,  142.9682103395f,  -15.9057039022f,
 -16.0311888456f,  144.3436886072f,  143.6561893225f,  -15.9686890841f,
 -15.9686890841f,  143.6561893225f,  144.3436886072f,  -16.0311888456f,
 -15.9057039022f,  142.9682103395f,  145.0306910276f,  -16.0931974649f,
 -15.8422390223f,  142.2797688246f,  145.7171794176f,  -16.1547092199f,
 -15.7783001661f,  141.5908819437f,  146.4031366110f,  -16.2157183886f,
 -15.7138930559f,  140.9015668631f,  147.0885454416f,  -16.2762192488f,
 -15.6490234137f,  140.2118407488f,  147.7733887434f,  -16.3362060785f,
 -15.5836969614f,  139.5217207670f,  148.4576493502f,  -16.3956731558f,
 -15.5179194212f,  138.8312240839f,  149.1413100958f,  -16.4546147585f,
 -15.4516965151f,  138.1403678656f,  149.8243538141f,  -16.5130251646f,
 -15.3850339651f,  137.4491692781f,  150.5067633390f,  -16.5708986521f,
 -15.3179374933f,  136.7576454878f,  151.1885215044f,  -16.6282294989f,
 -15.2504128218f,  136.0658136606f,  151.8696111441f,  -16.6850119829f,
 -15.1824656725f,  135.3736909628f,  152.5500150919f,  -16.7412403822f,
 -15.1141017675f,  134.6812945604f,  153.2297161818f,  -16.7969089746f,
 -15.0453268290f,  133.9886416197f,  153.9086972475f,  -16.8520120382f,
 -14.9761465788f,  133.2957493067f,  154.5869411230f,  -16.9065438509f,
 -14.9065667391f,  132.6026347876f,  155.2644306421f,  -16.9604986906f,
 -14.8365930319f,  131.9093152285f,  155.9411486387f,  -17.0138708353f,
 -14.7662311792f,  131.2158077955f,  156.6170779467f,  -17.0666545630f,
 -14.6954869032f,  130.5221296549f,  157.2922013998f,  -17.1188441515f,
 -14.6243659258f,  129.8282979727f,  157.9665018320f,  -17.1704338789f,
 -14.5528739691f,  129.1343299150f,  158.6399620771f,  -17.2214180231f,
 -14.4810167551f,  128.4402426481f,  159.3125649691f,  -17.2717908621f,
 -14.4088000059f,  127.7460533381f,  159.9842933416f,  -17.3215466738f,
 -14.3362294436f,  127.0517791510f,  160.6551300287f,  -17.3706797361f,
 -14.2633107901f,  126.3574372530f,  161.3250578642f,  -17.4191843271f,
 -14.1900497675f,  125.6630448103f,  161.9940596819f,  -17.4670547247f,
 -14.1164520979f,  124.9686189890f,  162.6621183157f,  -17.5142852068f,
 -14.0425235033f,  124.2741769552f,  163.3292165995f,  -17.5608700514f,
 -13.9682697058f,  123.5797358751f,  163.9953373671f,  -17.6068035364f,
 -13.8936964273f,  122.8853129148f,  164.6604634523f,  -17.6520799398f,
 -13.8188093901f,  122.1909252405f,  165.3245776892f,  -17.6966935396f,
 -13.7436143160f,  121.4965900183f,  165.9876629114f,  -17.7406386137f,
 -13.6681169271f,  120.8023244143f,  166.6497019529f,  -17.7839094400f,
 -13.5923229456f,  120.1081455946f,  167.3106776476f,  -17.8265002966f,
 -13.5162380934f,  119.4140707254f,  167.9705728292f,  -17.8684054613f,
 -13.4398680925f,  118.7201169729f,  168.6293703318f,  -17.9096192122f,
 -13.3632186651f,  118.0263015032f,  169.2870529890f,  -17.9501358271f,
 -13.2862955332f,  117.3326414824f,  169.9436036348f,  -17.9899495840f,
 -13.2091044188f,  116.6391540766f,  170.5990051031f,  -18.0290547609f,
 -13.1316510439f,  115.9458564520f,  171.2532402277f,  -18.0674456358f,
 -13.0539411306f,  115.2527657747f,  171.9062918425f,  -18.1051164865f,
 -12.9759804010f,  114.5598992109f,  172.5581427813f,  -18.1420615911f,
 -12.8977745771f,  113.8672739267f,  173.2087758780f,  -18.1782752275f,
 -12.8193293810f,  113.1749070883f,  173.8581739664f,  -18.2137516737f,
 -12.7406505346f,  112.4828158617f,  174.5063198805f,  -18.2484852076f,
 -12.6617437601f,  111.7910174131f,  175.1531964540f,  -18.2824701071f,
 -12.5826147795f,  111.0995289087f,  175.7987865210f,  -18.3157006502f,
 -12.5032693148f,  110.4083675146f,  176.4430729151f,  -18.3481711149f,
 -12.4237130880f,  109.7175503969f,  177.0860384703f,  -18.3798757792f,
 -12.3439518213f,  109.0270947218f,  177.7276660204f,  -18.4108089209f,
 -12.2639912367f,  108.3370176554f,  178.3679383993f,  -18.4409648180f,
 -12.1838370562f,  107.6473363638f,  179.0068384409f,  -18.4703377485f,
 -12.1034950018f,  106.9580680132f,  179.6443489790f,  -18.4989219904f,
 -12.0229707956f,  106.2692297697f,  180.2804528475f,  -18.5267118216f,
 -11.9422701597f,  105.5808387995f,  180.9151328802f,  -18.5537015200f,
 -11.8613988161f,  104.8929122686f,  181.5483719110f,  -18.5798853636f,
 -11.7803624868f,  104.2054673433f,  182.1801527739f,  -18.6052576303f,
 -11.6991668940f,  103.5185211897f,  182.8104583025f,  -18.6298125982f,
 -11.6178177595f,  102.8320909739f,  183.4392713308f,  -18.6535445452f,
 -11.5363208055f,  102.1461938620f,  184.0665746927f,  -18.6764477491f,
 -11.4546817541f,  101.4608470201f,  184.6923512220f,  -18.6985164881f,
 -11.3729063272f,  100.7760676146f,  185.3165837526f,  -18.7197450399f,
 -11.2910002470f,  100.0918728113f,  185.9392551184f,  -18.7401276827f,
 -11.2089692354f,   99.4082797766f,  186.5603481531f,  -18.7596586943f,
 -11.1268190145f,   98.7253056765f,  187.1798456907f,  -18.7783323526f,
 -11.0445553064f,   98.0429676771f,  187.7977305651f,  -18.7961429358f,
 -10.9621838331f,   97.3612829447f,  188.4139856100f,  -18.8130847216f,
 -10.8797103167f,   96.6802686453f,  189.0285936594f,  -18.8291519880f,
 -10.7971404791f,   95.9999419451f,  189.6415375471f,  -18.8443390131f,
 -10.7144800425f,   95.3203200102f,  190.2528001070f,  -18.8586400747f,
 -10.6317347288f,   94.6414200068f,  190.8623641729f,  -18.8720494509f,
 -10.5489102602f,   93.9632591009f,  191.4702125788f,  -18.8845614195f,
 -10.4660123587f,   93.2858544588f,  192.0763281584f,  -18.8961702585f,
 -10.3830467463f,   92.6092232466f,  192.6806937456f,  -18.9068702459f,
 -10.3000191450f,   91.9333826303f,  193.2832921743f,  -18.9166556597f,
 -10.2169352770f,   91.2583497763f,  193.8841062784f,  -18.9255207777f,
 -10.1338008642f,   90.5841418505f,  194.4831188917f,  -18.9334598780f,
 -10.0506216288f,   89.9107760191f,  195.0803128481f,  -18.9404672384f,
  -9.9674032927f,   89.2382694483f,  195.6756709814f,  -18.9465371370f,
  -9.8841515779f,   88.5666393042f,  196.2691761255f,  -18.9516638517f,
  -9.8008722067f,   87.8959027529f,  196.8608111143f,  -18.9558416605f,
  -9.7175709009f,   87.2260769606f,  197.4505587816f,  -18.9590648413f,
  -9.6342533827f,   86.5571790934f,  198.0384019613f,  -18.9613276720f,
  -9.5509253740f,   85.8892263174f,  198.6243234873f,  -18.9626244307f,
  -9.4675925970f,   85.2222357988f,  199.2083061934f,  -18.9629493952f,
  -9.3842607737f,   84.5562247038f,  199.7903329134f,  -18.9622968435f,
  -9.3009356260f,   83.8912101984f,  200.3703864813f,  -18.9606610537f,
  -9.2176228762f,   83.2272094488f,  200.9484497309f,  -18.9580363035f,
  -9.1343282461f,   82.5642396212f,  201.5245054960f,  -18.9544168711f,
  -9.0510574579f,   81.9023178816f,  202.0985366106f,  -18.9497970343f,
  -8.9678162336f,   81.2414613962f,  202.6705259085f,  -18.9441710711f,
  -8.8846102953f,   80.5816873312f,  203.2404562235f,  -18.9375332594f,
  -8.8014453650f,   79.9230128527f,  203.8083103895f,  -18.9298778772f,
  -8.7183271646f,   79.2654551268f,  204.3740712404f,  -18.9211992025f,
  -8.6352614164f,   78.6090313196f,  204.9377216101f,  -18.9114915133f,
  -8.5522538424f,   77.9537585974f,  205.4992443323f,  -18.9007490873f,
  -8.4693101645f,   77.2996541262f,  206.0586222410f,  -18.8889662027f,
  -8.3864361048f,   76.6467350721f,  206.6158381701f,  -18.8761371374f,
  -8.3036373854f,   75.9950186014f,  207.1708749533f,  -18.8622561693f,
  -8.2209197283f,   75.3445218801f,  207.7237154245f,  -18.8473175764f,
  -8.1382888556f,   74.6952620745f,  208.2743424177f,  -18.8313156366f,
  -8.0557504892f,   74.0472563505f,  208.8227387667f,  -18.8142446280f,
  -7.9733103514f,   73.4005218744f,  209.3688873053f,  -18.7960988283f,
  -7.8909741640f,   72.7550758123f,  209.9127708673f,  -18.7768725157f,
  -7.8087476492f,   72.1109353304f,  210.4543722868f,  -18.7565599680f,
  -7.7266365290f,   71.4681175947f,  210.9936743975f,  -18.7351554632f,
  -7.6446465254f,   70.8266397715f,  211.5306600332f,  -18.7126532793f,
  -7.5627833605f,   70.1865190268f,  212.0653120279f,  -18.6890476942f,
  -7.4810527563f,   69.5477725267f,  212.5976132154f,  -18.6643329859f,
  -7.3994604349f,   68.9104174376f,  213.1275464296f,  -18.6385034323f,
  -7.3180121183f,   68.2744709253f,  213.6550945044f,  -18.6115533113f,
  -7.2367135286f,   67.6399501562f,  214.1802402735f,  -18.5834769011f,
  -7.1555703878f,   67.0068722963f,  214.7029665709f,  -18.5542684793f,
  -7.0745884180f,   66.3752545118f,  215.2232562304f,  -18.5239223242f,
  -6.9937733412f,   65.7451139688f,  215.7410920858f,  -18.4924327135f,
  -6.9131308794f,   65.1164678335f,  216.2564569712f,  -18.4597939253f,
  -6.8326667547f,   64.4893332720f,  216.7693337202f,  -18.4260002375f,
  -6.7523866892f,   63.8637274504f,  217.2797051668f,  -18.3910459280f,
  -6.6722964048f,   63.2396675348f,  217.7875541449f,  -18.3549252748f,
  -6.5924016237f,   62.6171706915f,  218.2928634882f,  -18.3176325560f,
  -6.5127080679f,   61.9962540865f,  218.7956160307f,  -18.2791620493f,
  -6.4332214594f,   61.3769348860f,  219.2957946062f,  -18.2395080328f,
  -6.3539475203f,   60.7592302561f,  219.7933820486f,  -18.1986647844f,
  -6.2748919725f,   60.1431573629f,  220.2883611917f,  -18.1566265821f,
  -6.1960605383f,   59.5287333727f,  220.7807148695f,  -18.1133877039f,
  -6.1174589396f,   58.9159754515f,  221.2704259157f,  -18.0689424276f,
  -6.0390928984f,   58.3049007654f,  221.7574771643f,  -18.0232850313f,
  -5.9609681368f,   57.6955264807f,  222.2418514490f,  -17.9764097929f,
  -5.8830903769f,   57.0878697634f,  222.7235316038f,  -17.9283109903f,
  -5.8054653406f,   56.4819477797f,  223.2025004625f,  -17.8789829016f,
  -5.7280987501f,   55.8777776957f,  223.6787408590f,  -17.8284198046f,
  -5.6509963274f,   55.2753766775f,  224.1522356272f,  -17.7766159773f,
  -5.5741637945f,   54.6747618914f,  224.6229676008f,  -17.7235656977f,
  -5.4976068735f,   54.0759505033f,  225.0909196138f,  -17.6692632437f,
  -5.4213312864f,   53.4789596796f,  225.5560745001f,  -17.6137028933f,
  -5.3453427553f,   52.8838065863f,  226.0184150934f,  -17.5568789244f,
  -5.2696470022f,   52.2905083895f,  226.4779242277f,  -17.4987856150f,
  -5.1942497492f,   51.6990822554f,  226.9345847368f,  -17.4394172430f,
  -5.1191567183f,   51.1095453501f,  227.3883794546f,  -17.3787680864f,
  -5.0443736315f,   50.5219148397f,  227.8392912149f,  -17.3168324232f,
  -4.9699062109f,   49.9362078905f,  228.2873028517f,  -17.2536045313f,
  -4.8957601786f,   49.3524416685f,  228.7323971987f,  -17.1890786886f,
  -4.8219412565f,   48.7706333399f,  229.1745570898f,  -17.1232491732f,
  -4.7484551668f,   48.1908000708f,  229.6137653589f,  -17.0561102629f,
  -4.6753076315f,   47.6129590273f,  230.0500048399f,  -16.9876562357f,
  -4.6025043726f,   47.0371273756f,  230.4832583666f,  -16.9178813696f,
  -4.5300511122f,   46.4633222818f,  230.9135087729f,  -16.8467799425f,
  -4.4579535723f,   45.8915609121f,  231.3407388926f,  -16.7743462324f,
  -4.3862174749f,   45.3218604326f,  231.7649315596f,  -16.7005745173f,
  -4.3148485422f,   44.7542380095f,  232.1860696077f,  -16.6254590750f,
  -4.2438524961f,   44.1887108088f,  232.6041358709f,  -16.5489941835f,
  -4.1732350588f,   43.6252959967f,  233.0191131830f,  -16.4711741209f,
  -4.1030019522f,   43.0640107393f,  233.4309843779f,  -16.3919931650f,
  -4.0331588984f,   42.5048722029f,  233.8397322893f,  -16.3114455938f,
  -3.9637116194f,   41.9478975534f,  234.2453397512f,  -16.2295256853f,
  -3.8946658373f,   41.3931039572f,  234.6477895975f,  -16.1462277174f,
  -3.8260272741f,   40.8405085802f,  235.0470646620f,  -16.0615459681f,
  -3.7578016520f,   40.2901285887f,  235.4431477785f,  -15.9754747152f,
  -3.6899946928f,   39.7419811487f,  235.8360217810f,  -15.8880082369f,
  -3.6226121187f,   39.1960834265f,  236.2256695032f,  -15.7991408110f,
  -3.5556596518f,   38.6524525881f,  236.6120737791f,  -15.7088667154f,
  -3.4891430140f,   38.1111057997f,  236.9952174425f,  -15.6171802282f,
  -3.4230679274f,   37.5720602274f,  237.3750833273f,  -15.5240756273f,
  -3.3574401140f,   37.0353330374f,  237.7516542673f,  -15.4295471907f,
  -3.2922652960f,   36.5009413958f,  238.1249130964f,  -15.3335891962f,
  -3.2275491953f,   35.9689024687f,  238.4948426485f,  -15.2361959219f,
  -3.1632975340f,   35.4392334223f,  238.8614257574f,  -15.1373616457f,
  -3.0995160341f,   34.9119514227f,  239.2246452570f,  -15.0370806456f,
  -3.0362104177f,   34.3870736361f,  239.5844839811f,  -14.9353471994f,
  -2.9733864069f,   33.8646172285f,  239.9409247637f,  -14.8321555853f,
  -2.9110497236f,   33.3445993662f,  240.2939504385f,  -14.7275000811f,
  -2.8492060900f,   32.8270372152f,  240.6435438395f,  -14.6213749647f,
  -2.7878612280f,   32.3119479418f,  240.9896878004f,  -14.5137745142f,
  -2.7270208597f,   31.7993487120f,  241.3323651552f,  -14.4046930075f,
  -2.6666907072f,   31.2892566919f,  241.6715587378f,  -14.2941247225f,
  -2.6068764925f,   30.7816890478f,  242.0072513819f,  -14.1820639372f,
  -2.5475839376f,   30.2766629457f,  242.3394259214f,  -14.0685049295f,
  -2.4888187647f,   29.7741955519f,  242.6680651903f,  -13.9534419775f,
  -2.4305866957f,   29.2743040323f,  242.9931520224f,  -13.8368693590f,
  -2.3728934526f,   28.7770055532f,  243.3146692514f,  -13.7187813520f,
  -2.3157447577f,   28.2823172808f,  243.6325997114f,  -13.5991722345f,
  -2.2591463327f,   27.7902563810f,  243.9469262362f,  -13.4780362844f,
  -2.2031039000f,   27.3008400202f,  244.2576316595f,  -13.3553677797f,
  -2.1476231813f,   26.8140853643f,  244.5646988153f,  -13.2311609983f,
  -2.0927098989f,   26.3300095797f,  244.8681105375f,  -13.1054102182f,
  -2.0383697748f,   25.8486298323f,  245.1678496599f,  -12.9781097174f,
  -1.9846085310f,   25.3699632883f,  245.4638990164f,  -12.8492537737f,
  -1.9314318895f,   24.8940271139f,  245.7562414408f,  -12.7188366652f,
  -1.8788455725f,   24.4208384752f,  246.0448597670f,  -12.5868526697f,
  -1.8268553019f,   23.9504145384f,  246.3297368288f,  -12.4532960653f,
  -1.7754667997f,   23.4827724695f,  246.6108554602f,  -12.3181611300f,
  -1.7246857882f,   23.0179294348f,  246.8881984949f,  -12.1814421415f,
  -1.6745179892f,   22.5559026003f,  247.1617487669f,  -12.0431333780f,
  -1.6249691248f,   22.0967091322f,  247.4314891100f,  -11.9032291174f,
  -1.5760449171f,   21.6403661966f,  247.6974023581f,  -11.7617236376f,
  -1.5277510881f,   21.1868909597f,  247.9594713449f,  -11.6186112165f,
  -1.4800933599f,   20.7363005877f,  248.2176789045f,  -11.4738861322f,
  -1.4330774546f,   20.2886122465f,  248.4720078707f,  -11.3275426626f,
  -1.3867090940f,   19.8438431025f,  248.7224410772f,  -11.1795750856f,
  -1.3409940004f,   19.4020103216f,  248.9689613581f,  -11.0299776793f,
  -1.2959378958f,   18.9631310701f,  249.2115515471f,  -10.8787447214f,
  -1.2515465021f,   18.5272225142f,  249.4501944780f,  -10.7258704901f,
  -1.2078255415f,   18.0943018198f,  249.6848729849f,  -10.5713492632f,
  -1.1647807360f,   17.6643861532f,  249.9155699015f,  -10.4151753187f,
  -1.1224178076f,   17.2374926805f,  250.1422680616f,  -10.2573429346f,
  -1.0807424784f,   16.8136385679f,  250.3649502993f,  -10.0978463888f,
  -1.0397604704f,   16.3928409815f,  250.5835994482f,   -9.9366799593f,
  -0.9994775057f,   15.9751170874f,  250.7981983423f,   -9.7738379240f,
  -0.9598993063f,   15.5604840517f,  251.0087298155f,   -9.6093145609f,
  -0.9210315943f,   15.1489590406f,  251.2151767015f,   -9.4431041479f,
  -0.8828800917f,   14.7405592203f,  251.4175218344f,   -9.2752009630f,
  -0.8454505205f,   14.3353017569f,  251.6157480478f,   -9.1055992842f,
  -0.8087486029f,   13.9332038164f,  251.8098381758f,   -8.9342933893f,
  -0.7727800608f,   13.5342825651f,  251.9997750521f,   -8.7612775564f,
  -0.7375506163f,   13.1385551691f,  252.1855415106f,   -8.5865460634f,
  -0.7030659914f,   12.7460387945f,  252.3671203852f,   -8.4100931883f,
  -0.6693319082f,   12.3567506075f,  252.5444945097f,   -8.2319132090f,
  -0.6363540888f,   11.9707077742f,  252.7176467180f,   -8.0520004034f,
  -0.6041382551f,   11.5879274607f,  252.8865598440f,   -7.8703490496f,
  -0.5726901293f,   11.2084268332f,  253.0512167215f,   -7.6869534254f,
  -0.5420154333f,   10.8322230577f,  253.2116001844f,   -7.5018078089f,
  -0.5121198893f,   10.4593333006f,  253.3676930666f,   -7.3149064779f,
  -0.4830092192f,   10.0897747278f,  253.5194782019f,   -7.1262437105f,
  -0.4546891451f,    9.7235645056f,  253.6669384241f,   -6.9358137846f,
  -0.4271653891f,    9.3607198000f,  253.8100565672f,   -6.7436109781f,
  -0.4004436731f,    9.0012577772f,  253.9488154650f,   -6.5496295691f,
  -0.3745297194f,    8.6451956034f,  254.0831979513f,   -6.3538638353f,
  -0.3494292498f,    8.2925504446f,  254.2131868601f,   -6.1563080549f,
  -0.3251479864f,    7.9433394670f,  254.3387650251f,   -5.9569565058f,
  -0.3016916513f,    7.5975798368f,  254.4599152803f,   -5.7558034658f,
  -0.2790659666f,    7.2552887201f,  254.5766204596f,   -5.5528432131f,
  -0.2572766542f,    6.9164832830f,  254.6888633966f,   -5.3480700254f,
  -0.2363294363f,    6.5811806917f,  254.7966269255f,   -5.1414781809f,
  -0.2162300348f,    6.2493981123f,  254.8998938799f,   -4.9330619574f,
  -0.1969841719f,    5.9211527109f,  254.9986470938f,   -4.7228156328f,
  -0.1785975695f,    5.5964616537f,  255.0928694010f,   -4.5107334852f,
  -0.1610759497f,    5.2753421068f,  255.1825436354f,   -4.2968097925f,
  -0.1444250345f,    4.9578112364f,  255.2676526308f,   -4.0810388327f,
  -0.1286505461f,    4.6438862085f,  255.3481792212f,   -3.8634148836f,
  -0.1137582064f,    4.3335841894f,  255.4241062403f,   -3.6439322233f,
  -0.0997537374f,    4.0269223452f,  255.4954165220f,   -3.4225851297f,
  -0.0866428614f,    3.7239178419f,  255.5620929003f,   -3.1993678808f,
  -0.0744313002f,    3.4245878458f,  255.6241182089f,   -2.9742747545f,
  -0.0631247759f,    3.1289495230f,  255.6814752817f,   -2.7473000288f,
  -0.0527290106f,    2.8370200396f,  255.7341469526f,   -2.5184379816f,
  -0.0432497263f,    2.5488165617f,  255.7821160555f,   -2.2876828909f,
  -0.0346926451f,    2.2643562555f,  255.8253654242f,   -2.0550290346f,
  -0.0270634890f,    1.9836562872f,  255.8638778925f,   -1.8204706907f,
  -0.0203679800f,    1.7067338228f,  255.8976362944f,   -1.5840021372f,
  -0.0146118402f,    1.4336060286f,  255.9266234636f,   -1.3456176519f,
  -0.0098007917f,    1.1642900705f,  255.9508222342f,   -1.1053115129f,
  -0.0059405565f,    0.8988031149f,  255.9702154398f,   -0.8630779982f,
  -0.0030368567f,    0.6371623278f,  255.9847859144f,   -0.6189113855f,
  -0.0010954142f,    0.3793848753f,  255.9945164919f,   -0.3728059530f,
  -0.0001219511f,    0.1254879236f,  255.9993900061f,   -0.1247559786f,
};
